/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !csr_operand (operands[2], i3))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return pattern153 (x1); /* [-1, 47] */

    case ZERO_EXTEND:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern154 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_HImode) != 0)
            return -1;
          return 96;

        case E_RVVM2QImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_HImode) != 0)
            return -1;
          return 97;

        case E_RVVM1QImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_HImode) != 0)
            return -1;
          return 98;

        case E_RVVMF2QImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF4QImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF8QImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_HImode) != 0)
            return -1;
          return 101;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_SImode) != 0)
            return -1;
          return 102;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_SImode) != 0)
            return -1;
          return 103;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_SImode) != 0)
            return -1;
          return 104;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_SImode) != 0)
            return -1;
          return 106;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_DImode) != 0)
            return -1;
          return 107;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_DImode) != 0)
            return -1;
          return 108;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_DImode) != 0)
            return -1;
          return 109;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_DImode) != 0)
            return -1;
          return 110;

        case E_V1QImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1QImode, 
E_HImode) != 0)
            return -1;
          return 111;

        case E_V2QImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2QImode, 
E_HImode) != 0)
            return -1;
          return 112;

        case E_V4QImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4QImode, 
E_HImode) != 0)
            return -1;
          return 113;

        case E_V8QImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8QImode, 
E_HImode) != 0)
            return -1;
          return 114;

        case E_V16QImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 115;

        case E_V32QImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32QImode, 
E_HImode) != 0)
            return -1;
          return 116;

        case E_V64QImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64QImode, 
E_HImode) != 0)
            return -1;
          return 117;

        case E_V128QImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128QImode, 
E_HImode) != 0)
            return -1;
          return 118;

        case E_V256QImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256QImode, 
E_HImode) != 0)
            return -1;
          return 119;

        case E_V512QImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512QImode, 
E_HImode) != 0)
            return -1;
          return 120;

        case E_V1024QImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_HImode) != 0)
            return -1;
          return 121;

        case E_V2048QImode:
          if (pattern154 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_HImode) != 0)
            return -1;
          return 122;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1HImode, 
E_SImode) != 0)
            return -1;
          return 123;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2HImode, 
E_SImode) != 0)
            return -1;
          return 124;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4HImode, 
E_SImode) != 0)
            return -1;
          return 125;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8HImode, 
E_SImode) != 0)
            return -1;
          return 126;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16HImode, 
E_SImode) != 0)
            return -1;
          return 127;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 128;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64HImode, 
E_SImode) != 0)
            return -1;
          return 129;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128HImode, 
E_SImode) != 0)
            return -1;
          return 130;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256HImode, 
E_SImode) != 0)
            return -1;
          return 131;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512HImode, 
E_SImode) != 0)
            return -1;
          return 132;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_SImode) != 0)
            return -1;
          return 133;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1DImode, 
E_V1SImode, 
E_DImode) != 0)
            return -1;
          return 134;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2DImode, 
E_V2SImode, 
E_DImode) != 0)
            return -1;
          return 135;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4DImode, 
E_V4SImode, 
E_DImode) != 0)
            return -1;
          return 136;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8DImode, 
E_V8SImode, 
E_DImode) != 0)
            return -1;
          return 137;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16DImode, 
E_V16SImode, 
E_DImode) != 0)
            return -1;
          return 138;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32DImode, 
E_V32SImode, 
E_DImode) != 0)
            return -1;
          return 139;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64DImode, 
E_V64SImode, 
E_DImode) != 0)
            return -1;
          return 140;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128DImode, 
E_V128SImode, 
E_DImode) != 0)
            return -1;
          return 141;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256DImode, 
E_V256SImode, 
E_DImode) != 0)
            return -1;
          return 142;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512DImode, 
E_V512SImode, 
E_DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern184 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      return 2;

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM8SFmode:
      if (!register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 5;

    case E_RVVM2x2QImode:
      if (!register_operand (operands[3], E_RVVM2x2QImode))
        return -1;
      return 6;

    case E_RVVM2x3QImode:
      if (!register_operand (operands[3], E_RVVM2x3QImode))
        return -1;
      return 7;

    case E_RVVM2x4QImode:
      if (!register_operand (operands[3], E_RVVM2x4QImode))
        return -1;
      return 8;

    case E_RVVM4x2HImode:
      if (!register_operand (operands[3], E_RVVM4x2HImode))
        return -1;
      return 9;

    case E_RVVM4x2BFmode:
      if (!register_operand (operands[3], E_RVVM4x2BFmode))
        return -1;
      return 10;

    case E_RVVM4x2HFmode:
      if (!register_operand (operands[3], E_RVVM4x2HFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern191 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern191 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern191 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern191 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern191 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern191 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern191 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern191 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern191 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern191 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern191 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern191 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern191 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern191 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern191 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern191 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern191 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern191 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern191 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern191 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern191 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern191 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern191 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern191 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern191 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern191 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern191 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern191 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern191 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern191 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern191 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern191 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern191 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern191 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern191 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern191 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern191 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern191 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern191 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern191 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern191 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern191 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern191 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern191 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern191 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern191 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern191 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern191 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern201 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern201 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern201 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern201 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern201 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern201 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern201 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern201 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern201 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern201 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern201 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern201 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern201 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern201 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern201 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern201 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern201 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern201 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern201 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern201 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern201 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern201 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern201 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern201 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern201 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern201 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern201 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern201 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern201 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern201 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern201 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern201 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern201 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern201 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern201 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern201 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern201 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern201 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern201 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern201 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern201 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern201 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern201 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern201 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern201 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern201 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern201 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern201 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern201 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern201 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern201 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern201 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern201 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern201 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern201 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern201 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern201 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern201 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern201 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern201 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern201 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern201 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern201 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern201 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern201 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern201 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern201 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern201 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern201 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern201 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern201 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern201 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern201 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern201 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern201 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern201 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern201 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern201 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern201 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern201 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern201 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern201 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern201 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern201 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern201 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern201 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern201 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern201 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern201 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern201 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern201 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern201 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern201 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern201 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern201 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern201 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern201 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern201 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern201 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern201 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern201 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern201 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern201 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern201 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern201 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern201 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern201 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern201 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern201 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern201 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern201 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern201 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern201 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern201 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern201 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern201 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern201 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern201 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern201 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern201 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern201 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern201 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern202 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern202 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern202 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern202 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern202 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern202 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern202 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern202 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern202 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern202 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern202 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern202 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern202 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern202 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern202 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern202 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern202 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern202 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern202 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern202 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern202 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern202 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern202 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern202 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern202 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern202 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern202 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern202 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern202 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern202 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern202 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern202 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern202 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern202 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern202 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern202 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern202 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern202 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern202 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern202 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern202 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern202 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern202 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern202 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern202 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern202 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern202 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern202 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern203 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern203 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern203 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern203 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern203 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern203 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern203 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern203 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern203 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern203 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern203 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern203 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern203 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern203 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern203 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern203 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern203 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern203 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern203 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern203 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern203 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern203 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern203 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern203 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern203 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern203 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern203 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern203 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern203 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern203 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern203 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern203 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern203 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern203 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern203 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern203 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern203 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern203 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern203 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern203 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern203 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern203 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern203 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern203 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern203 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern203 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern203 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern203 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern204 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern204 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern204 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern204 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern204 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern204 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern204 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern204 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern204 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern204 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern204 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern204 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern204 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern204 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern204 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern204 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern204 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern204 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern204 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern204 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern204 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern204 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern204 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern204 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern204 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern204 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern204 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern204 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern204 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern204 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern204 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern204 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern204 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern204 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern204 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern204 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern204 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern204 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern204 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern204 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern204 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern204 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern204 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern204 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern204 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern204 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern204 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern204 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern204 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern204 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern204 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern204 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern204 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern204 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern204 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern204 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern204 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern204 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern204 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern204 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern204 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern204 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern204 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern204 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern204 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern204 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern204 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern204 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern204 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern204 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern204 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern204 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[1], E_RVVM8QImode))
        return -1;
      return 0;

    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 6;

    case E_V1QImode:
      if (!register_operand (operands[1], E_V1QImode))
        return -1;
      return 7;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 8;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 9;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 10;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 13;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 14;

    case E_V256QImode:
      if (!register_operand (operands[1], E_V256QImode))
        return -1;
      return 15;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 16;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 17;

    case E_V2048QImode:
      if (!register_operand (operands[1], E_V2048QImode))
        return -1;
      return 18;

    case E_V4096QImode:
      if (!register_operand (operands[1], E_V4096QImode))
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern455 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern453 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern453 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern460 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern472 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern471 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern471 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern471 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern471 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern471 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern471 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern471 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern471 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern471 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern471 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern471 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern471 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern471 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern471 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern471 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern471 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern471 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern471 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern471 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern484 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern484 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern484 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern484 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern484 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern484 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern484 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern484 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern484 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern484 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern484 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern484 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern484 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern484 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern484 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern484 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern484 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern484 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern484 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern484 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern484 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern484 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern484 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern484 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern484 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern484 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern484 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern484 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern484 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern484 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern484 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern484 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern484 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern484 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern484 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern484 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern484 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern484 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern484 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern484 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern484 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern484 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern484 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern484 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern484 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern484 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern484 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern484 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern484 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern484 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern484 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern484 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern484 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern484 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern484 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern484 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern484 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern484 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern484 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern484 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern484 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern484 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern484 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern484 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern484 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern484 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern484 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern484 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern500 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern501 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern500 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern500 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern500 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern500 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern500 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern500 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern500 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern500 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern500 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern500 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern500 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern500 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern500 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern500 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern500 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern500 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern500 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern500 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern566 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern574 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern492 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern492 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern492 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern492 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern492 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern492 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern492 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern492 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern492 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern492 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern492 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern492 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern492 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern492 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern492 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern582 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_neg_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern595 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[4], E_RVVM2HFmode)
          || !register_operand (operands[5], E_RVVM2HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[4], E_RVVM4SFmode)
          || !register_operand (operands[5], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVM8DFmode:
      if (!register_operand (operands[4], E_RVVM8DFmode)
          || !register_operand (operands[5], E_RVVM8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern608 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[4], E_RVVMF2HFmode)
          || !register_operand (operands[5], E_RVVMF2HFmode))
        return -1;
      return 0;

    case E_RVVM1SFmode:
      if (!register_operand (operands[4], E_RVVM1SFmode)
          || !register_operand (operands[5], E_RVVM1SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[4], E_RVVM2DFmode)
          || !register_operand (operands[5], E_RVVM2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[4], E_V2HFmode)
          || !register_operand (operands[5], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[4], E_V2SFmode)
          || !register_operand (operands[5], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[4], E_V2DFmode)
          || !register_operand (operands[5], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || !register_operand (operands[5], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || !register_operand (operands[5], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || !register_operand (operands[5], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || !register_operand (operands[5], E_V128HFmode))
        return -1;
      return 0;

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || !register_operand (operands[5], E_V128SFmode))
        return -1;
      return 1;

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || !register_operand (operands[5], E_V128DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern621 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i3))
    return -1;
  x10 = XEXP (x1, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  return 0;
}

int
pattern625 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode)
          || !vector_arith_operand (operands[2], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode)
          || !vector_arith_operand (operands[2], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !vector_arith_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !vector_arith_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !vector_arith_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !vector_arith_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode)
          || !register_operand (operands[2], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode)
          || !register_operand (operands[2], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[2], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern638 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew16_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 0;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern653 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern671 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern677 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern686 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i4
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern694 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], E_DImode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern698 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern698 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern698 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern698 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern698 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern698 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVM8SImode
          || GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM8SImode
          || GET_MODE (x4) != E_RVVM8SImode
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode)
              || !register_operand (operands[4], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 7;

            case E_RVVM8QImode:
              if (!register_operand (operands[4], E_RVVM8QImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVM4SImode
          || GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM4SImode
          || GET_MODE (x4) != E_RVVM4SImode
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode)
              || !register_operand (operands[4], E_RVVM2HImode))
            return -1;
          return 9;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 10;

            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVM2SImode
          || GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM2SImode
          || GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode)
              || !register_operand (operands[4], E_RVVM1HImode))
            return -1;
          return 12;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 13;

            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVM1SImode
          || GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM1SImode
          || GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode)
              || !register_operand (operands[4], E_RVVMF2HImode))
            return -1;
          return 15;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVMF2QImode:
              if (!register_operand (operands[4], E_RVVMF2QImode))
                return -1;
              return 16;

            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern698 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVM8DImode:
      if (pattern698 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 19;

    case E_RVVM4DImode:
      if (pattern698 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 20;

    case E_RVVM2DImode:
      if (pattern698 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1DImode:
      if (pattern698 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_V1HImode:
      if (pattern698 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 23;

    case E_V2HImode:
      if (pattern698 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 24;

    case E_V4HImode:
      if (pattern698 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 25;

    case E_V8HImode:
      if (pattern698 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 26;

    case E_V16HImode:
      if (pattern698 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 27;

    case E_V32HImode:
      if (pattern698 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 28;

    case E_V64HImode:
      if (pattern698 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 29;

    case E_V128HImode:
      if (pattern698 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 30;

    case E_V256HImode:
      if (pattern698 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 31;

    case E_V512HImode:
      if (pattern698 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 32;

    case E_V1024HImode:
      if (pattern698 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 33;

    case E_V2048HImode:
      if (pattern698 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 34;

    case E_V1SImode:
      if (pattern698 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2SImode:
      if (pattern698 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4SImode:
      if (pattern698 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8SImode:
      if (pattern698 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16SImode:
      if (pattern698 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32SImode:
      if (pattern698 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64SImode:
      if (pattern698 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128SImode:
      if (pattern698 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256SImode:
      if (pattern698 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512SImode:
      if (pattern698 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024SImode:
      if (pattern698 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V1DImode:
      if (pattern698 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 46;

    case E_V2DImode:
      if (pattern698 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 47;

    case E_V4DImode:
      if (pattern698 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 48;

    case E_V8DImode:
      if (pattern698 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 49;

    case E_V16DImode:
      if (pattern698 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 50;

    case E_V32DImode:
      if (pattern698 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 51;

    case E_V64DImode:
      if (pattern698 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 52;

    case E_V128DImode:
      if (pattern698 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 53;

    case E_V256DImode:
      if (pattern698 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 54;

    case E_V512DImode:
      if (pattern698 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 55;

    default:
      return -1;
    }
}

int
pattern737 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern740 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  return 0;
}

int
pattern745 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x27, 1);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  return 0;
}

int
pattern752 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -24L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -28L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -48L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -56L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern760 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23)
        return -1;
      return 0;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21)
        return -1;
      return 1;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9
          || REGNO (x32) != 8
          || REGNO (x37) != 1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x42) != 10)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 10
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x46) != RETURN)
        return -1;
      x47 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x47) != USE)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 1
          || GET_MODE (x48) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern773 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x52, 1);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  return 0;
}

int
pattern786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern790 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -44])
    return -1;
  return 0;
}

int
pattern794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  x63 = XEXP (x61, 1);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XVECEXP (x1, 0, 13);
  x67 = XEXP (x66, 0);
  if (GET_MODE (x67) != i1)
    return -1;
  x68 = XEXP (x66, 1);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x68, 0);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  x71 = XVECEXP (x1, 0, 14);
  x72 = XEXP (x71, 0);
  if (GET_MODE (x72) != i1)
    return -1;
  x73 = XVECEXP (x1, 0, 15);
  x74 = XEXP (x73, 0);
  if (GET_MODE (x74) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 856 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 9; /* *addsi3_extended2 */

    case MINUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1037 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 18; /* *subsi3_extended2 */

    case NEG:
      operands[2] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1089 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 22; /* *negsi2_extended2 */

    case MULT:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1254 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 29; /* *mulsi3_extended2 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 1954 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_XTHEADMEMIDX))
            return -1;
          return 127; /* *extendsidi2_internal */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 130; /* *extendqidi2 */
          if (!(
#line 321 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 528; /* *extendqidi2_bitmanip */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 133; /* *extendhidi2 */
          if (!(
#line 321 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 531; /* *extendhidi2_bitmanip */

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern280 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 128; /* *extendqihi2 */
          if (!
#line 321 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 526; /* *extendqihi2_bitmanip */

        case 1:
          if (
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 131; /* *extendhihi2 */
          if (!
#line 321 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 529; /* *extendhihi2_bitmanip */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern280 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 129; /* *extendqisi2 */
          if (!
#line 321 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 527; /* *extendqisi2_bitmanip */

        case 1:
          if (
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 132; /* *extendhisi2 */
          if (!
#line 321 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 530; /* *extendhisi2_bitmanip */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern281 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 65 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 858; /* *extendhihi2_th_ext */
          if (!
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return -1;
          return 914; /* *th_memidx_extendhihi2 */

        case 1:
          if (
#line 76 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 861; /* *extendqihi2_th_ext */
          if (
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 911; /* *th_memidx_extendqihi2 */
          if (!
#line 628 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 922; /* *th_memidx_bb_extendqihi2 */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern281 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 65 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 859; /* *extendhisi2_th_ext */
          if (
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 915; /* *th_memidx_extendhisi2 */
          if (!
#line 612 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 920; /* *th_memidx_bb_extendhisi2 */

        case 1:
          if (
#line 76 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 862; /* *extendqisi2_th_ext */
          if (
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 912; /* *th_memidx_extendqisi2 */
          if (!
#line 628 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 923; /* *th_memidx_bb_extendqisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 65 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 860; /* *extendhidi2_th_ext */
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 916; /* *th_memidx_extendhidi2 */
          if (!(
#line 612 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 921; /* *th_memidx_bb_extendhidi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 76 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 863; /* *extendqidi2_th_ext */
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 913; /* *th_memidx_extendqidi2 */
          if (!(
#line 628 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 924; /* *th_memidx_bb_extendqidi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 482 "../../gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX))
            return -1;
          return 907; /* *th_memidx_extendsidi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || pattern327 (x3) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27334; /* *pred_extract_first_sextdirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27335; /* *pred_extract_first_sextdirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27336; /* *pred_extract_first_sextdirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27337; /* *pred_extract_first_sextdirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27338; /* *pred_extract_first_sextdirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27339; /* *pred_extract_first_sextdirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27340; /* *pred_extract_first_sextdirvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 557 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 27352; /* *pred_extract_first_sextdiv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 558 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 27353; /* *pred_extract_first_sextdiv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 559 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 27354; /* *pred_extract_first_sextdiv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 560 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 27355; /* *pred_extract_first_sextdiv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 561 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 27356; /* *pred_extract_first_sextdiv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 562 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 27357; /* *pred_extract_first_sextdiv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 563 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 27358; /* *pred_extract_first_sextdiv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 564 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 27359; /* *pred_extract_first_sextdiv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 27360; /* *pred_extract_first_sextdiv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 566 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 27361; /* *pred_extract_first_sextdiv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 27362; /* *pred_extract_first_sextdiv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 568 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 27363; /* *pred_extract_first_sextdiv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 27364; /* *pred_extract_first_sextdiv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27341; /* *pred_extract_first_sextdirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27342; /* *pred_extract_first_sextdirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27343; /* *pred_extract_first_sextdirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27344; /* *pred_extract_first_sextdirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27345; /* *pred_extract_first_sextdirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27346; /* *pred_extract_first_sextdirvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 570 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 27365; /* *pred_extract_first_sextdiv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 27366; /* *pred_extract_first_sextdiv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 27367; /* *pred_extract_first_sextdiv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 27368; /* *pred_extract_first_sextdiv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 27369; /* *pred_extract_first_sextdiv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 27370; /* *pred_extract_first_sextdiv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 27371; /* *pred_extract_first_sextdiv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 27372; /* *pred_extract_first_sextdiv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 27373; /* *pred_extract_first_sextdiv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 27374; /* *pred_extract_first_sextdiv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 27375; /* *pred_extract_first_sextdiv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 27376; /* *pred_extract_first_sextdiv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8SImode:
              if (!register_operand (operands[1], E_RVVM8SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27347; /* *pred_extract_first_sextdirvvm8si */

            case E_RVVM4SImode:
              if (!register_operand (operands[1], E_RVVM4SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27348; /* *pred_extract_first_sextdirvvm4si */

            case E_RVVM2SImode:
              if (!register_operand (operands[1], E_RVVM2SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27349; /* *pred_extract_first_sextdirvvm2si */

            case E_RVVM1SImode:
              if (!register_operand (operands[1], E_RVVM1SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27350; /* *pred_extract_first_sextdirvvm1si */

            case E_RVVMF2SImode:
              if (!register_operand (operands[1], E_RVVMF2SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27351; /* *pred_extract_first_sextdirvvmf2si */

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 27377; /* *pred_extract_first_sextdiv1si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 27378; /* *pred_extract_first_sextdiv2si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 27379; /* *pred_extract_first_sextdiv4si */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 27380; /* *pred_extract_first_sextdiv8si */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 27381; /* *pred_extract_first_sextdiv16si */

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 27382; /* *pred_extract_first_sextdiv32si */

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 27383; /* *pred_extract_first_sextdiv64si */

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 27384; /* *pred_extract_first_sextdiv128si */

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 27385; /* *pred_extract_first_sextdiv256si */

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 27386; /* *pred_extract_first_sextdiv512si */

            case E_V1024SImode:
              if (!register_operand (operands[1], E_V1024SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 27387; /* *pred_extract_first_sextdiv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27388; /* *pred_extract_first_sextsirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27389; /* *pred_extract_first_sextsirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27390; /* *pred_extract_first_sextsirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27391; /* *pred_extract_first_sextsirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27392; /* *pred_extract_first_sextsirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27393; /* *pred_extract_first_sextsirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 545 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27394; /* *pred_extract_first_sextsirvvmf8qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27395; /* *pred_extract_first_sextsirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27396; /* *pred_extract_first_sextsirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27397; /* *pred_extract_first_sextsirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27398; /* *pred_extract_first_sextsirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27399; /* *pred_extract_first_sextsirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 547 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27400; /* *pred_extract_first_sextsirvvmf4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 1045 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 19; /* negdi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 20; /* *negsi2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 1615 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 84; /* negsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 1615 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 85; /* negdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 1615 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 86; /* neghf2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25972; /* negrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25974; /* negrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25976; /* negrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25978; /* negrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25980; /* negrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25982; /* negrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25984; /* negrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25986; /* negrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25988; /* negrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25990; /* negrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25992; /* negrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25994; /* negrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25996; /* negrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25998; /* negrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26000; /* negrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26002; /* negrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26004; /* negrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26006; /* negrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26008; /* negrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26010; /* negrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26012; /* negrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26014; /* negrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26016; /* negv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26018; /* negv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26020; /* negv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26022; /* negv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26024; /* negv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26026; /* negv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26028; /* negv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26030; /* negv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26032; /* negv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26034; /* negv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26036; /* negv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26038; /* negv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26040; /* negv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26042; /* negv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26044; /* negv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26046; /* negv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26048; /* negv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26050; /* negv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26052; /* negv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26054; /* negv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26056; /* negv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26058; /* negv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26060; /* negv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26062; /* negv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26064; /* negv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26066; /* negv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26068; /* negv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26070; /* negv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 26072; /* negv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26074; /* negv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26076; /* negv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26078; /* negv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26080; /* negv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26082; /* negv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26084; /* negv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26086; /* negv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26088; /* negv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26090; /* negv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26092; /* negv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26094; /* negv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26096; /* negv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26098; /* negv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26100; /* negv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26102; /* negv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26104; /* negv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26106; /* negv512di2 */

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26108; /* negrvvm8hf2 */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26110; /* negrvvm4hf2 */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26112; /* negrvvm2hf2 */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26114; /* negrvvm1hf2 */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26116; /* negrvvmf2hf2 */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26118; /* negrvvmf4hf2 */

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26120; /* negrvvm8sf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26122; /* negrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26124; /* negrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26126; /* negrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26128; /* negrvvmf2sf2 */

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26130; /* negrvvm8df2 */

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26132; /* negrvvm4df2 */

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26134; /* negrvvm2df2 */

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26136; /* negrvvm1df2 */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26138; /* negv1hf2 */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26140; /* negv2hf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26142; /* negv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26144; /* negv8hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26146; /* negv16hf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26148; /* negv32hf2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26150; /* negv64hf2 */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26152; /* negv128hf2 */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26154; /* negv256hf2 */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26156; /* negv512hf2 */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26158; /* negv1024hf2 */

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26160; /* negv2048hf2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26162; /* negv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26164; /* negv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26166; /* negv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26168; /* negv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26170; /* negv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26172; /* negv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26174; /* negv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26176; /* negv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26178; /* negv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26180; /* negv512sf2 */

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26182; /* negv1024sf2 */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26184; /* negv1df2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26186; /* negv2df2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26188; /* negv4df2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26190; /* negv8df2 */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26192; /* negv16df2 */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26194; /* negv32df2 */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26196; /* negv64df2 */

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26198; /* negv128df2 */

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26200; /* negv256df2 */

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 1109 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26202; /* negv512df2 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern236 (x3))
    {
    case 0:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26868; /* fmaxrvvm8hf3 */

    case 1:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26870; /* fmaxrvvm4hf3 */

    case 2:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26872; /* fmaxrvvm2hf3 */

    case 3:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26874; /* fmaxrvvm1hf3 */

    case 4:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26876; /* fmaxrvvmf2hf3 */

    case 5:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26878; /* fmaxrvvmf4hf3 */

    case 6:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26880; /* fmaxrvvm8sf3 */

    case 7:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26882; /* fmaxrvvm4sf3 */

    case 8:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26884; /* fmaxrvvm2sf3 */

    case 9:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26886; /* fmaxrvvm1sf3 */

    case 10:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26888; /* fmaxrvvmf2sf3 */

    case 11:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26890; /* fmaxrvvm8df3 */

    case 12:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26892; /* fmaxrvvm4df3 */

    case 13:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26894; /* fmaxrvvm2df3 */

    case 14:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26896; /* fmaxrvvm1df3 */

    case 15:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26898; /* fmaxv1hf3 */

    case 16:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26900; /* fmaxv2hf3 */

    case 17:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26902; /* fmaxv4hf3 */

    case 18:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26904; /* fmaxv8hf3 */

    case 19:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26906; /* fmaxv16hf3 */

    case 20:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26908; /* fmaxv32hf3 */

    case 21:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26910; /* fmaxv64hf3 */

    case 22:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26912; /* fmaxv128hf3 */

    case 23:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26914; /* fmaxv256hf3 */

    case 24:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26916; /* fmaxv512hf3 */

    case 25:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26918; /* fmaxv1024hf3 */

    case 26:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26920; /* fmaxv2048hf3 */

    case 27:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26922; /* fmaxv1sf3 */

    case 28:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26924; /* fmaxv2sf3 */

    case 29:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26926; /* fmaxv4sf3 */

    case 30:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26928; /* fmaxv8sf3 */

    case 31:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26930; /* fmaxv16sf3 */

    case 32:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26932; /* fmaxv32sf3 */

    case 33:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26934; /* fmaxv64sf3 */

    case 34:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26936; /* fmaxv128sf3 */

    case 35:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26938; /* fmaxv256sf3 */

    case 36:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26940; /* fmaxv512sf3 */

    case 37:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26942; /* fmaxv1024sf3 */

    case 38:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26944; /* fmaxv1df3 */

    case 39:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26946; /* fmaxv2df3 */

    case 40:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26948; /* fmaxv4df3 */

    case 41:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26950; /* fmaxv8df3 */

    case 42:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26952; /* fmaxv16df3 */

    case 43:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26954; /* fmaxv32df3 */

    case 44:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26956; /* fmaxv64df3 */

    case 45:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26958; /* fmaxv128df3 */

    case 46:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26960; /* fmaxv256df3 */

    case 47:
      if (!(
#line 1577 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26962; /* fmaxv512df3 */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18117; /* pred_redxorrvvm8qi */

        case 1:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18125; /* pred_redxorrvvm4qi */

        case 2:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18133; /* pred_redxorrvvm2qi */

        case 3:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18141; /* pred_redxorrvvm1qi */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18245; /* pred_redxorrvvmf2qi */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18253; /* pred_redxorrvvmf4qi */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18261; /* pred_redxorrvvmf8qi */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18293; /* pred_redxorv1qi */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18301; /* pred_redxorv2qi */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18309; /* pred_redxorv4qi */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18317; /* pred_redxorv8qi */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18325; /* pred_redxorv16qi */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18333; /* pred_redxorv32qi */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18341; /* pred_redxorv64qi */

        case 14:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18349; /* pred_redxorv128qi */

        case 15:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18357; /* pred_redxorv256qi */

        case 16:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18365; /* pred_redxorv512qi */

        case 17:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18373; /* pred_redxorv1024qi */

        case 18:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18381; /* pred_redxorv2048qi */

        case 19:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18389; /* pred_redxorv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18149; /* pred_redxorrvvm8hi */

        case 1:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18157; /* pred_redxorrvvm4hi */

        case 2:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18165; /* pred_redxorrvvm2hi */

        case 3:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18173; /* pred_redxorrvvm1hi */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18269; /* pred_redxorrvvmf2hi */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18277; /* pred_redxorrvvmf4hi */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18397; /* pred_redxorv1hi */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18405; /* pred_redxorv2hi */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18413; /* pred_redxorv4hi */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18421; /* pred_redxorv8hi */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18429; /* pred_redxorv16hi */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18437; /* pred_redxorv32hi */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18445; /* pred_redxorv64hi */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18453; /* pred_redxorv128hi */

        case 14:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18461; /* pred_redxorv256hi */

        case 15:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18469; /* pred_redxorv512hi */

        case 16:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18477; /* pred_redxorv1024hi */

        case 17:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18485; /* pred_redxorv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18181; /* pred_redxorrvvm8si */

        case 1:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18189; /* pred_redxorrvvm4si */

        case 2:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18197; /* pred_redxorrvvm2si */

        case 3:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18205; /* pred_redxorrvvm1si */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18285; /* pred_redxorrvvmf2si */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18493; /* pred_redxorv1si */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18501; /* pred_redxorv2si */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18509; /* pred_redxorv4si */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18517; /* pred_redxorv8si */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18525; /* pred_redxorv16si */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18533; /* pred_redxorv32si */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18541; /* pred_redxorv64si */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18549; /* pred_redxorv128si */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18557; /* pred_redxorv256si */

        case 14:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18565; /* pred_redxorv512si */

        case 15:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18573; /* pred_redxorv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2))
        {
        case 0:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18213; /* pred_redxorrvvm8di */

        case 1:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18221; /* pred_redxorrvvm4di */

        case 2:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18229; /* pred_redxorrvvm2di */

        case 3:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18237; /* pred_redxorrvvm1di */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18581; /* pred_redxorv1di */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18589; /* pred_redxorv2di */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18597; /* pred_redxorv4di */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18605; /* pred_redxorv8di */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18613; /* pred_redxorv16di */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18621; /* pred_redxorv32di */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18629; /* pred_redxorv64di */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18637; /* pred_redxorv128di */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18645; /* pred_redxorv256di */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18653; /* pred_redxorv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (pattern355 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[7] = x7;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  switch (XINT (x8, 1))
    {
    case 141:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1QImode:
          switch (pattern673 (x2, 
E_RVVM1QImode))
            {
            case 0:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18110; /* pred_redsumrvvm8qi */

            case 1:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18118; /* pred_redsumrvvm4qi */

            case 2:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18126; /* pred_redsumrvvm2qi */

            case 3:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18134; /* pred_redsumrvvm1qi */

            case 4:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 18238; /* pred_redsumrvvmf2qi */

            case 5:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 18246; /* pred_redsumrvvmf4qi */

            case 6:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 18254; /* pred_redsumrvvmf8qi */

            case 7:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 18286; /* pred_redsumv1qi */

            case 8:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 18294; /* pred_redsumv2qi */

            case 9:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 18302; /* pred_redsumv4qi */

            case 10:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 18310; /* pred_redsumv8qi */

            case 11:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 18318; /* pred_redsumv16qi */

            case 12:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 18326; /* pred_redsumv32qi */

            case 13:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18334; /* pred_redsumv64qi */

            case 14:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18342; /* pred_redsumv128qi */

            case 15:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18350; /* pred_redsumv256qi */

            case 16:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18358; /* pred_redsumv512qi */

            case 17:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18366; /* pred_redsumv1024qi */

            case 18:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18374; /* pred_redsumv2048qi */

            case 19:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18382; /* pred_redsumv4096qi */

            default:
              return -1;
            }

        case E_RVVM1HImode:
          switch (pattern674 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18142; /* pred_redsumrvvm8hi */

            case 1:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18150; /* pred_redsumrvvm4hi */

            case 2:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18158; /* pred_redsumrvvm2hi */

            case 3:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18166; /* pred_redsumrvvm1hi */

            case 4:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 18262; /* pred_redsumrvvmf2hi */

            case 5:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 18270; /* pred_redsumrvvmf4hi */

            case 6:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 18390; /* pred_redsumv1hi */

            case 7:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 18398; /* pred_redsumv2hi */

            case 8:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 18406; /* pred_redsumv4hi */

            case 9:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 18414; /* pred_redsumv8hi */

            case 10:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 18422; /* pred_redsumv16hi */

            case 11:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18430; /* pred_redsumv32hi */

            case 12:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18438; /* pred_redsumv64hi */

            case 13:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18446; /* pred_redsumv128hi */

            case 14:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18454; /* pred_redsumv256hi */

            case 15:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18462; /* pred_redsumv512hi */

            case 16:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18470; /* pred_redsumv1024hi */

            case 17:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18478; /* pred_redsumv2048hi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern675 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18174; /* pred_redsumrvvm8si */

            case 1:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18182; /* pred_redsumrvvm4si */

            case 2:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18190; /* pred_redsumrvvm2si */

            case 3:
              if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18198; /* pred_redsumrvvm1si */

            case 4:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 18278; /* pred_redsumrvvmf2si */

            case 5:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 18486; /* pred_redsumv1si */

            case 6:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 18494; /* pred_redsumv2si */

            case 7:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 18502; /* pred_redsumv4si */

            case 8:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 18510; /* pred_redsumv8si */

            case 9:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18518; /* pred_redsumv16si */

            case 10:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18526; /* pred_redsumv32si */

            case 11:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18534; /* pred_redsumv64si */

            case 12:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18542; /* pred_redsumv128si */

            case 13:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18550; /* pred_redsumv256si */

            case 14:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18558; /* pred_redsumv512si */

            case 15:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18566; /* pred_redsumv1024si */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern676 (x2))
            {
            case 0:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18206; /* pred_redsumrvvm8di */

            case 1:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18214; /* pred_redsumrvvm4di */

            case 2:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18222; /* pred_redsumrvvm2di */

            case 3:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18230; /* pred_redsumrvvm1di */

            case 4:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18574; /* pred_redsumv1di */

            case 5:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18582; /* pred_redsumv2di */

            case 6:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 18590; /* pred_redsumv4di */

            case 7:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18598; /* pred_redsumv8di */

            case 8:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18606; /* pred_redsumv16di */

            case 9:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18614; /* pred_redsumv32di */

            case 10:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18622; /* pred_redsumv64di */

            case 11:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18630; /* pred_redsumv128di */

            case 12:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18638; /* pred_redsumv256di */

            case 13:
              if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18646; /* pred_redsumv512di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 144:
      return recog_67 (x1, insn, pnum_clobbers);

    case 145:
      return recog_62 (x1, insn, pnum_clobbers);

    case 146:
      return recog_66 (x1, insn, pnum_clobbers);

    case 147:
      return recog_61 (x1, insn, pnum_clobbers);

    case 148:
      return recog_64 (x1, insn, pnum_clobbers);

    case 149:
      return recog_65 (x1, insn, pnum_clobbers);

    case 150:
      return recog_63 (x1, insn, pnum_clobbers);

    case 151:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern673 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18654; /* pred_wredsumrvvm8qi */

            case 1:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18656; /* pred_wredsumrvvm4qi */

            case 2:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18658; /* pred_wredsumrvvm2qi */

            case 3:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18660; /* pred_wredsumrvvm1qi */

            case 4:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18662; /* pred_wredsumrvvmf2qi */

            case 5:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18664; /* pred_wredsumrvvmf4qi */

            case 6:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 18666; /* pred_wredsumrvvmf8qi */

            case 7:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 557 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 18690; /* pred_wredsumv1qi */

            case 8:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 558 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 18692; /* pred_wredsumv2qi */

            case 9:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 559 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 18694; /* pred_wredsumv4qi */

            case 10:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 560 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 18696; /* pred_wredsumv8qi */

            case 11:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 561 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 18698; /* pred_wredsumv16qi */

            case 12:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 562 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 18700; /* pred_wredsumv32qi */

            case 13:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 563 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18702; /* pred_wredsumv64qi */

            case 14:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 564 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18704; /* pred_wredsumv128qi */

            case 15:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18706; /* pred_wredsumv256qi */

            case 16:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 566 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18708; /* pred_wredsumv512qi */

            case 17:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18710; /* pred_wredsumv1024qi */

            case 18:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 568 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18712; /* pred_wredsumv2048qi */

            case 19:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18714; /* pred_wredsumv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern674 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18668; /* pred_wredsumrvvm8hi */

            case 1:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18670; /* pred_wredsumrvvm4hi */

            case 2:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18672; /* pred_wredsumrvvm2hi */

            case 3:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18674; /* pred_wredsumrvvm1hi */

            case 4:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18676; /* pred_wredsumrvvmf2hi */

            case 5:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 18678; /* pred_wredsumrvvmf4hi */

            case 6:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 570 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 18716; /* pred_wredsumv1hi */

            case 7:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 18718; /* pred_wredsumv2hi */

            case 8:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 18720; /* pred_wredsumv4hi */

            case 9:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 18722; /* pred_wredsumv8hi */

            case 10:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 18724; /* pred_wredsumv16hi */

            case 11:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18726; /* pred_wredsumv32hi */

            case 12:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18728; /* pred_wredsumv64hi */

            case 13:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18730; /* pred_wredsumv128hi */

            case 14:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18732; /* pred_wredsumv256hi */

            case 15:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18734; /* pred_wredsumv512hi */

            case 16:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18736; /* pred_wredsumv1024hi */

            case 17:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18738; /* pred_wredsumv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern675 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18680; /* pred_wredsumrvvm8si */

            case 1:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18682; /* pred_wredsumrvvm4si */

            case 2:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18684; /* pred_wredsumrvvm2si */

            case 3:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18686; /* pred_wredsumrvvm1si */

            case 4:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 18688; /* pred_wredsumrvvmf2si */

            case 5:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 18740; /* pred_wredsumv1si */

            case 6:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 18742; /* pred_wredsumv2si */

            case 7:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 18744; /* pred_wredsumv4si */

            case 8:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 18746; /* pred_wredsumv8si */

            case 9:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18748; /* pred_wredsumv16si */

            case 10:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18750; /* pred_wredsumv32si */

            case 11:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18752; /* pred_wredsumv64si */

            case 12:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18754; /* pred_wredsumv128si */

            case 13:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18756; /* pred_wredsumv256si */

            case 14:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18758; /* pred_wredsumv512si */

            case 15:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18760; /* pred_wredsumv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 152:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern673 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18655; /* pred_wredsumurvvm8qi */

            case 1:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18657; /* pred_wredsumurvvm4qi */

            case 2:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18659; /* pred_wredsumurvvm2qi */

            case 3:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18661; /* pred_wredsumurvvm1qi */

            case 4:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18663; /* pred_wredsumurvvmf2qi */

            case 5:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18665; /* pred_wredsumurvvmf4qi */

            case 6:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 18667; /* pred_wredsumurvvmf8qi */

            case 7:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 557 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 18691; /* pred_wredsumuv1qi */

            case 8:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 558 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 18693; /* pred_wredsumuv2qi */

            case 9:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 559 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 18695; /* pred_wredsumuv4qi */

            case 10:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 560 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 18697; /* pred_wredsumuv8qi */

            case 11:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 561 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 18699; /* pred_wredsumuv16qi */

            case 12:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 562 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 18701; /* pred_wredsumuv32qi */

            case 13:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 563 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18703; /* pred_wredsumuv64qi */

            case 14:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 564 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18705; /* pred_wredsumuv128qi */

            case 15:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18707; /* pred_wredsumuv256qi */

            case 16:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 566 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18709; /* pred_wredsumuv512qi */

            case 17:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18711; /* pred_wredsumuv1024qi */

            case 18:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 568 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18713; /* pred_wredsumuv2048qi */

            case 19:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18715; /* pred_wredsumuv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern674 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18669; /* pred_wredsumurvvm8hi */

            case 1:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18671; /* pred_wredsumurvvm4hi */

            case 2:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18673; /* pred_wredsumurvvm2hi */

            case 3:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18675; /* pred_wredsumurvvm1hi */

            case 4:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18677; /* pred_wredsumurvvmf2hi */

            case 5:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 18679; /* pred_wredsumurvvmf4hi */

            case 6:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 570 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 18717; /* pred_wredsumuv1hi */

            case 7:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 18719; /* pred_wredsumuv2hi */

            case 8:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 18721; /* pred_wredsumuv4hi */

            case 9:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 18723; /* pred_wredsumuv8hi */

            case 10:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 18725; /* pred_wredsumuv16hi */

            case 11:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18727; /* pred_wredsumuv32hi */

            case 12:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18729; /* pred_wredsumuv64hi */

            case 13:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18731; /* pred_wredsumuv128hi */

            case 14:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18733; /* pred_wredsumuv256hi */

            case 15:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18735; /* pred_wredsumuv512hi */

            case 16:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18737; /* pred_wredsumuv1024hi */

            case 17:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18739; /* pred_wredsumuv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern675 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18681; /* pred_wredsumurvvm8si */

            case 1:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18683; /* pred_wredsumurvvm4si */

            case 2:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18685; /* pred_wredsumurvvm2si */

            case 3:
              if (!
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 18687; /* pred_wredsumurvvm1si */

            case 4:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 18689; /* pred_wredsumurvvmf2si */

            case 5:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 18741; /* pred_wredsumuv1si */

            case 6:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 18743; /* pred_wredsumuv2si */

            case 7:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 18745; /* pred_wredsumuv4si */

            case 8:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 18747; /* pred_wredsumuv8si */

            case 9:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 18749; /* pred_wredsumuv16si */

            case 10:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 18751; /* pred_wredsumuv32si */

            case 11:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 18753; /* pred_wredsumuv64si */

            case 12:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 18755; /* pred_wredsumuv128si */

            case 13:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 18757; /* pred_wredsumuv256si */

            case 14:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 18759; /* pred_wredsumuv512si */

            case 15:
              if (!(
#line 7786 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 18761; /* pred_wredsumuv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern188 (x1))
    {
    case 0:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19153; /* pred_slidedownrvvm8qi */

    case 1:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19155; /* pred_slidedownrvvm4qi */

    case 2:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19157; /* pred_slidedownrvvm2qi */

    case 3:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19159; /* pred_slidedownrvvm1qi */

    case 4:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19161; /* pred_slidedownrvvm8hi */

    case 5:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19163; /* pred_slidedownrvvm4hi */

    case 6:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19165; /* pred_slidedownrvvm2hi */

    case 7:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19167; /* pred_slidedownrvvm1hi */

    case 8:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19169; /* pred_slidedownrvvm8si */

    case 9:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19171; /* pred_slidedownrvvm4si */

    case 10:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19173; /* pred_slidedownrvvm2si */

    case 11:
      if (!
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19175; /* pred_slidedownrvvm1si */

    case 12:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19177; /* pred_slidedownrvvm8di */

    case 13:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19179; /* pred_slidedownrvvm4di */

    case 14:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19181; /* pred_slidedownrvvm2di */

    case 15:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19183; /* pred_slidedownrvvm1di */

    case 16:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19185; /* pred_slidedownrvvmf2qi */

    case 17:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19187; /* pred_slidedownrvvmf4qi */

    case 18:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19189; /* pred_slidedownrvvmf8qi */

    case 19:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19191; /* pred_slidedownrvvmf2hi */

    case 20:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19193; /* pred_slidedownrvvmf4hi */

    case 21:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19195; /* pred_slidedownrvvmf2si */

    case 22:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19197; /* pred_slidedownrvvm8bf */

    case 23:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19199; /* pred_slidedownrvvm4bf */

    case 24:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19201; /* pred_slidedownrvvm2bf */

    case 25:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19203; /* pred_slidedownrvvm1bf */

    case 26:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19205; /* pred_slidedownrvvmf2bf */

    case 27:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19207; /* pred_slidedownrvvmf4bf */

    case 28:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19209; /* pred_slidedownrvvm8hf */

    case 29:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19211; /* pred_slidedownrvvm4hf */

    case 30:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19213; /* pred_slidedownrvvm2hf */

    case 31:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19215; /* pred_slidedownrvvm1hf */

    case 32:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19217; /* pred_slidedownrvvmf2hf */

    case 33:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19219; /* pred_slidedownrvvmf4hf */

    case 34:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19221; /* pred_slidedownrvvm8sf */

    case 35:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19223; /* pred_slidedownrvvm4sf */

    case 36:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19225; /* pred_slidedownrvvm2sf */

    case 37:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19227; /* pred_slidedownrvvm1sf */

    case 38:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19229; /* pred_slidedownrvvmf2sf */

    case 39:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19231; /* pred_slidedownrvvm8df */

    case 40:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19233; /* pred_slidedownrvvm4df */

    case 41:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19235; /* pred_slidedownrvvm2df */

    case 42:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19237; /* pred_slidedownrvvm1df */

    case 43:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 19239; /* pred_slidedownv1qi */

    case 44:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 19241; /* pred_slidedownv2qi */

    case 45:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 19243; /* pred_slidedownv4qi */

    case 46:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 19245; /* pred_slidedownv8qi */

    case 47:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 19247; /* pred_slidedownv16qi */

    case 48:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 19249; /* pred_slidedownv32qi */

    case 49:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19251; /* pred_slidedownv64qi */

    case 50:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19253; /* pred_slidedownv128qi */

    case 51:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19255; /* pred_slidedownv256qi */

    case 52:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19257; /* pred_slidedownv512qi */

    case 53:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19259; /* pred_slidedownv1024qi */

    case 54:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19261; /* pred_slidedownv2048qi */

    case 55:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19263; /* pred_slidedownv4096qi */

    case 56:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 19265; /* pred_slidedownv1hi */

    case 57:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 19267; /* pred_slidedownv2hi */

    case 58:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 19269; /* pred_slidedownv4hi */

    case 59:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 19271; /* pred_slidedownv8hi */

    case 60:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 19273; /* pred_slidedownv16hi */

    case 61:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19275; /* pred_slidedownv32hi */

    case 62:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19277; /* pred_slidedownv64hi */

    case 63:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19279; /* pred_slidedownv128hi */

    case 64:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19281; /* pred_slidedownv256hi */

    case 65:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19283; /* pred_slidedownv512hi */

    case 66:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19285; /* pred_slidedownv1024hi */

    case 67:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19287; /* pred_slidedownv2048hi */

    case 68:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 19289; /* pred_slidedownv1si */

    case 69:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 19291; /* pred_slidedownv2si */

    case 70:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 19293; /* pred_slidedownv4si */

    case 71:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 19295; /* pred_slidedownv8si */

    case 72:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19297; /* pred_slidedownv16si */

    case 73:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19299; /* pred_slidedownv32si */

    case 74:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19301; /* pred_slidedownv64si */

    case 75:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19303; /* pred_slidedownv128si */

    case 76:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19305; /* pred_slidedownv256si */

    case 77:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19307; /* pred_slidedownv512si */

    case 78:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19309; /* pred_slidedownv1024si */

    case 79:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19311; /* pred_slidedownv1di */

    case 80:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19313; /* pred_slidedownv2di */

    case 81:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19315; /* pred_slidedownv4di */

    case 82:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19317; /* pred_slidedownv8di */

    case 83:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19319; /* pred_slidedownv16di */

    case 84:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19321; /* pred_slidedownv32di */

    case 85:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19323; /* pred_slidedownv64di */

    case 86:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19325; /* pred_slidedownv128di */

    case 87:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19327; /* pred_slidedownv256di */

    case 88:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19329; /* pred_slidedownv512di */

    case 89:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19331; /* pred_slidedownv1hf */

    case 90:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19333; /* pred_slidedownv2hf */

    case 91:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19335; /* pred_slidedownv4hf */

    case 92:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19337; /* pred_slidedownv8hf */

    case 93:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19339; /* pred_slidedownv16hf */

    case 94:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19341; /* pred_slidedownv32hf */

    case 95:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19343; /* pred_slidedownv64hf */

    case 96:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19345; /* pred_slidedownv128hf */

    case 97:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19347; /* pred_slidedownv256hf */

    case 98:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19349; /* pred_slidedownv512hf */

    case 99:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19351; /* pred_slidedownv1024hf */

    case 100:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19353; /* pred_slidedownv2048hf */

    case 101:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19355; /* pred_slidedownv1sf */

    case 102:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19357; /* pred_slidedownv2sf */

    case 103:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19359; /* pred_slidedownv4sf */

    case 104:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19361; /* pred_slidedownv8sf */

    case 105:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19363; /* pred_slidedownv16sf */

    case 106:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19365; /* pred_slidedownv32sf */

    case 107:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19367; /* pred_slidedownv64sf */

    case 108:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19369; /* pred_slidedownv128sf */

    case 109:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19371; /* pred_slidedownv256sf */

    case 110:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19373; /* pred_slidedownv512sf */

    case 111:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19375; /* pred_slidedownv1024sf */

    case 112:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19377; /* pred_slidedownv1df */

    case 113:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19379; /* pred_slidedownv2df */

    case 114:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19381; /* pred_slidedownv4df */

    case 115:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19383; /* pred_slidedownv8df */

    case 116:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19385; /* pred_slidedownv16df */

    case 117:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19387; /* pred_slidedownv32df */

    case 118:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19389; /* pred_slidedownv64df */

    case 119:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19391; /* pred_slidedownv128df */

    case 120:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19393; /* pred_slidedownv256df */

    case 121:
      if (!(
#line 7980 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19395; /* pred_slidedownv512df */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 107; /* *iorsi3 */
          if (
#line 1758 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 112; /* *iorsi3_internal */
        }
      if (single_bit_mask_operand (operands[2], E_SImode)
          && (
#line 789 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 605; /* *bsetisi */
      if (!uimm_extra_bit_or_twobits (operands[2], E_SImode)
          || !(
#line 1020 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 628; /* *iorisi_extrabit */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (arith_operand (operands[2], E_DImode)
          && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return 109; /* *iordi3 */
      if (single_bit_mask_operand (operands[2], E_DImode)
          && (
#line 789 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return 607; /* *bsetidi */
      if (!uimm_extra_bit_or_twobits (operands[2], E_DImode)
          || !(
#line 1020 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 630; /* *ioridi_extrabit */

    case E_RVVM8QImode:
      if (pattern228 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23617; /* iorrvvm8qi3 */

    case E_RVVM4QImode:
      if (pattern228 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23631; /* iorrvvm4qi3 */

    case E_RVVM2QImode:
      if (pattern228 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23645; /* iorrvvm2qi3 */

    case E_RVVM1QImode:
      if (pattern228 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23659; /* iorrvvm1qi3 */

    case E_RVVM8HImode:
      if (pattern228 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23673; /* iorrvvm8hi3 */

    case E_RVVM4HImode:
      if (pattern228 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23687; /* iorrvvm4hi3 */

    case E_RVVM2HImode:
      if (pattern228 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23701; /* iorrvvm2hi3 */

    case E_RVVM1HImode:
      if (pattern228 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23715; /* iorrvvm1hi3 */

    case E_RVVM8SImode:
      if (pattern228 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23729; /* iorrvvm8si3 */

    case E_RVVM4SImode:
      if (pattern228 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23743; /* iorrvvm4si3 */

    case E_RVVM2SImode:
      if (pattern228 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23757; /* iorrvvm2si3 */

    case E_RVVM1SImode:
      if (pattern228 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23771; /* iorrvvm1si3 */

    case E_RVVM8DImode:
      if (pattern228 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23785; /* iorrvvm8di3 */

    case E_RVVM4DImode:
      if (pattern228 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23799; /* iorrvvm4di3 */

    case E_RVVM2DImode:
      if (pattern228 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23813; /* iorrvvm2di3 */

    case E_RVVM1DImode:
      if (pattern228 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23827; /* iorrvvm1di3 */

    case E_RVVMF2QImode:
      if (pattern228 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23841; /* iorrvvmf2qi3 */

    case E_RVVMF4QImode:
      if (pattern228 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23855; /* iorrvvmf4qi3 */

    case E_RVVMF8QImode:
      if (pattern228 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23869; /* iorrvvmf8qi3 */

    case E_RVVMF2HImode:
      if (pattern228 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23883; /* iorrvvmf2hi3 */

    case E_RVVMF4HImode:
      if (pattern228 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23897; /* iorrvvmf4hi3 */

    case E_RVVMF2SImode:
      if (pattern228 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23911; /* iorrvvmf2si3 */

    case E_V1QImode:
      if (pattern228 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23925; /* iorv1qi3 */

    case E_V2QImode:
      if (pattern228 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23939; /* iorv2qi3 */

    case E_V4QImode:
      if (pattern228 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23953; /* iorv4qi3 */

    case E_V8QImode:
      if (pattern228 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23967; /* iorv8qi3 */

    case E_V16QImode:
      if (pattern228 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23981; /* iorv16qi3 */

    case E_V32QImode:
      if (pattern228 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 23995; /* iorv32qi3 */

    case E_V64QImode:
      if (pattern228 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24009; /* iorv64qi3 */

    case E_V128QImode:
      if (pattern228 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24023; /* iorv128qi3 */

    case E_V256QImode:
      if (pattern228 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24037; /* iorv256qi3 */

    case E_V512QImode:
      if (pattern228 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24051; /* iorv512qi3 */

    case E_V1024QImode:
      if (pattern228 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24065; /* iorv1024qi3 */

    case E_V2048QImode:
      if (pattern228 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24079; /* iorv2048qi3 */

    case E_V4096QImode:
      if (pattern228 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24093; /* iorv4096qi3 */

    case E_V1HImode:
      if (pattern228 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24107; /* iorv1hi3 */

    case E_V2HImode:
      if (pattern228 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24121; /* iorv2hi3 */

    case E_V4HImode:
      if (pattern228 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24135; /* iorv4hi3 */

    case E_V8HImode:
      if (pattern228 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24149; /* iorv8hi3 */

    case E_V16HImode:
      if (pattern228 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24163; /* iorv16hi3 */

    case E_V32HImode:
      if (pattern228 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24177; /* iorv32hi3 */

    case E_V64HImode:
      if (pattern228 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24191; /* iorv64hi3 */

    case E_V128HImode:
      if (pattern228 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24205; /* iorv128hi3 */

    case E_V256HImode:
      if (pattern228 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24219; /* iorv256hi3 */

    case E_V512HImode:
      if (pattern228 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24233; /* iorv512hi3 */

    case E_V1024HImode:
      if (pattern228 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24247; /* iorv1024hi3 */

    case E_V2048HImode:
      if (pattern228 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24261; /* iorv2048hi3 */

    case E_V1SImode:
      if (pattern228 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24275; /* iorv1si3 */

    case E_V2SImode:
      if (pattern228 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24289; /* iorv2si3 */

    case E_V4SImode:
      if (pattern228 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24303; /* iorv4si3 */

    case E_V8SImode:
      if (pattern228 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24317; /* iorv8si3 */

    case E_V16SImode:
      if (pattern228 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24331; /* iorv16si3 */

    case E_V32SImode:
      if (pattern228 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24345; /* iorv32si3 */

    case E_V64SImode:
      if (pattern228 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24359; /* iorv64si3 */

    case E_V128SImode:
      if (pattern228 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24373; /* iorv128si3 */

    case E_V256SImode:
      if (pattern228 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24387; /* iorv256si3 */

    case E_V512SImode:
      if (pattern228 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24401; /* iorv512si3 */

    case E_V1024SImode:
      if (pattern228 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24415; /* iorv1024si3 */

    case E_V1DImode:
      if (pattern228 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24429; /* iorv1di3 */

    case E_V2DImode:
      if (pattern228 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24443; /* iorv2di3 */

    case E_V4DImode:
      if (pattern228 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24457; /* iorv4di3 */

    case E_V8DImode:
      if (pattern228 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24471; /* iorv8di3 */

    case E_V16DImode:
      if (pattern228 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24485; /* iorv16di3 */

    case E_V32DImode:
      if (pattern228 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24499; /* iorv32di3 */

    case E_V64DImode:
      if (pattern228 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24513; /* iorv64di3 */

    case E_V128DImode:
      if (pattern228 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24527; /* iorv128di3 */

    case E_V256DImode:
      if (pattern228 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24541; /* iorv256di3 */

    case E_V512DImode:
      if (pattern228 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24555; /* iorv512di3 */

    case E_RVVMF64BImode:
      if (pattern0 (x2, 
E_RVVMF64BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 24975; /* iorrvvmf64bi3 */

    case E_RVVMF32BImode:
      if (pattern0 (x2, 
E_RVVMF32BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24978; /* iorrvvmf32bi3 */

    case E_RVVMF16BImode:
      if (pattern0 (x2, 
E_RVVMF16BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24981; /* iorrvvmf16bi3 */

    case E_RVVMF8BImode:
      if (pattern0 (x2, 
E_RVVMF8BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24984; /* iorrvvmf8bi3 */

    case E_RVVMF4BImode:
      if (pattern0 (x2, 
E_RVVMF4BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24987; /* iorrvvmf4bi3 */

    case E_RVVMF2BImode:
      if (pattern0 (x2, 
E_RVVMF2BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24990; /* iorrvvmf2bi3 */

    case E_RVVM1BImode:
      if (pattern0 (x2, 
E_RVVM1BImode) != 0
          || !
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24993; /* iorrvvm1bi3 */

    case E_V1BImode:
      if (pattern0 (x2, 
E_V1BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 24996; /* iorv1bi3 */

    case E_V2BImode:
      if (pattern0 (x2, 
E_V2BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 24999; /* iorv2bi3 */

    case E_V4BImode:
      if (pattern0 (x2, 
E_V4BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25002; /* iorv4bi3 */

    case E_V8BImode:
      if (pattern0 (x2, 
E_V8BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25005; /* iorv8bi3 */

    case E_V16BImode:
      if (pattern0 (x2, 
E_V16BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25008; /* iorv16bi3 */

    case E_V32BImode:
      if (pattern0 (x2, 
E_V32BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25011; /* iorv32bi3 */

    case E_V64BImode:
      if (pattern0 (x2, 
E_V64BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25014; /* iorv64bi3 */

    case E_V128BImode:
      if (pattern0 (x2, 
E_V128BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25017; /* iorv128bi3 */

    case E_V256BImode:
      if (pattern0 (x2, 
E_V256BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25020; /* iorv256bi3 */

    case E_V512BImode:
      if (pattern0 (x2, 
E_V512BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25023; /* iorv512bi3 */

    case E_V1024BImode:
      if (pattern0 (x2, 
E_V1024BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25026; /* iorv1024bi3 */

    case E_V2048BImode:
      if (pattern0 (x2, 
E_V2048BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25029; /* iorv2048bi3 */

    case E_V4096BImode:
      if (pattern0 (x2, 
E_V4096BImode) != 0
          || !(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25032; /* iorv4096bi3 */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256BImode)
      && reg_or_mem_operand (operands[1], E_V256BImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4337 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3311; /* *movv256bisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4337 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3312; /* *movv256bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256BImode)
      || !register_operand (operands[1], E_V256BImode)
      || !(
#line 1529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3487; /* *movv256bi_vls */
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4331 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3301; /* *movv256dfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4331 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3302; /* *movv256dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3398; /* *movv256df_vls */
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SFmode)
      && reg_or_mem_operand (operands[1], E_V512SFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4326 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3291; /* *movv512sfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4326 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3292; /* *movv512sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SFmode)
      || !register_operand (operands[1], E_V512SFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3388; /* *movv512sf_vls */
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048HFmode)
      && reg_or_mem_operand (operands[1], E_V2048HFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4321 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3281; /* *movv2048hfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4321 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3282; /* *movv2048hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048HFmode)
      || !register_operand (operands[1], E_V2048HFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3378; /* *movv2048hf_vls */
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32HFmode)
      && reg_or_mem_operand (operands[1], E_V32HFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4315 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3269; /* *movv32hfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4315 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3270; /* *movv32hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32HFmode)
      || !register_operand (operands[1], E_V32HFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3372; /* *movv32hf_vls */
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024SImode)
      && reg_or_mem_operand (operands[1], E_V1024SImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4309 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3257; /* *movv1024sisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4309 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3258; /* *movv1024sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024SImode)
      || !register_operand (operands[1], E_V1024SImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3356; /* *movv1024si_vls */
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048HImode)
      && reg_or_mem_operand (operands[1], E_V2048HImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3245; /* *movv2048hisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv2048hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048HImode)
      || !register_operand (operands[1], E_V2048HImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3345; /* *movv2048hi_vls */
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32HImode)
      && reg_or_mem_operand (operands[1], E_V32HImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3233; /* *movv32hisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv32hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32HImode)
      || !register_operand (operands[1], E_V32HImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3339; /* *movv32hi_vls */
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128QImode)
      && reg_or_mem_operand (operands[1], E_V128QImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3221; /* *movv128qisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3222; /* *movv128qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128QImode)
      || !register_operand (operands[1], E_V128QImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3328; /* *movv128qi_vls */
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF16BImode)
      && register_operand (operands[1], E_RVVMF16BImode)
      && 
#line 1293 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2799; /* *movrvvmf16bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF16BImode))
    return -1;
  if ((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2837; /* *movrvvmf16bisi_lra */
    }
  if (!(
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2838; /* *movrvvmf16bidi_lra */
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4BFmode)
      && register_operand (operands[1], E_RVVMF4BFmode)
      && (
#line 1256 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
    return 2781; /* *movrvvmf4bf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4BFmode))
    return -1;
  if ((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2817; /* *movrvvmf4bfsi_lra */
    }
  if (!(
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2828; /* *movrvvmf4bfdi_lra */
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_DImode)
      && splittable_const_int_operand (operands[1], E_DImode)
      && (
#line 2458 "../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], DImode)
        || high_mask_shift_operand (operands[1], DImode))) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
    return 275; /* *mvconst_internal */
  if (!nonimmediate_operand (operands[0], E_DImode)
      || !move_operand (operands[1], E_DImode))
    return -1;
  if (
#line 2485 "../../gcc/config/riscv/riscv.md"
(!TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
    return 276; /* *movdi_32bit */
  if (!
#line 2497 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
    return -1;
  return 277; /* *movdi_64bit */
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3209; /* *movv4df */
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3392; /* *movv4df_vls */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3203; /* *movv2sf */
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3380; /* *movv2sf_vls */
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DImode)
      && reg_or_mem_operand (operands[1], E_V16DImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DImode)
       || register_operand (operands[1], V16DImode))) && 
#line 4264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 3196; /* *movv16di */
  if (!register_operand (operands[0], E_V16DImode)
      || !register_operand (operands[1], E_V16DImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3361; /* *movv16di_vls */
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 3189; /* *movv4si */
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 3348; /* *movv4si_vls */
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 3182; /* *movv1hi */
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 3334; /* *movv1hi_vls */
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3175; /* *movrvvm4x2qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3176; /* *movrvvm4x2qi_di */
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3165; /* *movrvvm2x3qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3166; /* *movrvvm2x3qi_di */
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3153; /* *movrvvm2x4bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3154; /* *movrvvm2x4bf_di */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3139; /* *movrvvm1x8qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3140; /* *movrvvm1x8qi_di */
}

 int
recog_236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2DFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3125; /* *movrvvm4x2df_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3126; /* *movrvvm4x2df_di */
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3111; /* *movrvvm1x5hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3112; /* *movrvvm1x5hf_di */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3097; /* *movrvvm1x5bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3098; /* *movrvvm1x5bf_di */
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3083; /* *movrvvm2x2si_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3084; /* *movrvvm2x2si_di */
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3069; /* *movrvvm1x2hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3070; /* *movrvvm1x2hi_di */
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4DFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3053; /* *movrvvm2x4df_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3054; /* *movrvvm2x4df_di */
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3SFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3037; /* *movrvvm1x3sf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3038; /* *movrvvm1x3sf_di */
}

 int
recog_288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3021; /* *movrvvmf2x2hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3022; /* *movrvvmf2x2hf_di */
}

 int
recog_296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4DImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3005; /* *movrvvm2x4di_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3006; /* *movrvvm2x4di_di */
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2983; /* *movrvvmf2x7hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2984; /* *movrvvmf2x7hi_di */
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x6QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2967; /* *movrvvmf4x6qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2968; /* *movrvvmf4x6qi_di */
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5DFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2951; /* *movrvvm1x5df_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2952; /* *movrvvm1x5df_di */
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4SFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2935; /* *movrvvmf2x4sf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2936; /* *movrvvmf2x4sf_di */
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2919; /* *movrvvmf4x3hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2920; /* *movrvvmf4x3hf_di */
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2903; /* *movrvvmf4x2bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2904; /* *movrvvmf4x2bf_di */
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5SImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2881; /* *movrvvmf2x5si_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2882; /* *movrvvmf2x5si_di */
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern323 (x2))
    {
    case 0:
      return 298; /* *lshrsi3 */

    case 1:
      if (!
#line 2900 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 301; /* lshrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24568; /* lshrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24772; /* vlshrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24571; /* lshrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24775; /* vlshrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24574; /* lshrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24778; /* vlshrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24577; /* lshrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24781; /* vlshrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24580; /* lshrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24784; /* vlshrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24583; /* lshrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24787; /* vlshrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24586; /* lshrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24790; /* vlshrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24589; /* lshrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24793; /* vlshrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24592; /* lshrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24796; /* vlshrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24595; /* lshrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24799; /* vlshrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24598; /* lshrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24802; /* vlshrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24601; /* lshrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24805; /* vlshrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24604; /* lshrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24808; /* vlshrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24607; /* lshrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24811; /* vlshrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24610; /* lshrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24814; /* vlshrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24613; /* lshrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24817; /* vlshrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24616; /* lshrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24820; /* vlshrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24619; /* lshrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24823; /* vlshrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24622; /* lshrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24826; /* vlshrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24625; /* lshrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24829; /* vlshrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24628; /* lshrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24832; /* vlshrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24631; /* lshrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24835; /* vlshrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 24634; /* lshrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24838; /* vlshrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 24637; /* lshrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24841; /* vlshrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 24640; /* lshrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24844; /* vlshrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 24643; /* lshrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24847; /* vlshrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 24646; /* lshrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24850; /* vlshrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 24649; /* lshrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24853; /* vlshrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 24652; /* lshrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24856; /* vlshrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 24655; /* lshrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24859; /* vlshrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 24658; /* lshrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24862; /* vlshrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 24661; /* lshrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24865; /* vlshrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 24664; /* lshrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24868; /* vlshrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 24667; /* lshrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24871; /* vlshrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 24670; /* lshrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24874; /* vlshrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 24673; /* lshrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24877; /* vlshrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 24676; /* lshrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24880; /* vlshrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 24679; /* lshrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24883; /* vlshrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 24682; /* lshrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24886; /* vlshrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 24685; /* lshrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24889; /* vlshrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 24688; /* lshrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24892; /* vlshrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 24691; /* lshrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24895; /* vlshrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 24694; /* lshrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24898; /* vlshrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 24697; /* lshrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24901; /* vlshrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 24700; /* lshrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24904; /* vlshrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 24703; /* lshrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24907; /* vlshrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 24706; /* lshrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24910; /* vlshrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 24709; /* lshrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24913; /* vlshrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 24712; /* lshrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24916; /* vlshrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 24715; /* lshrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24919; /* vlshrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 24718; /* lshrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24922; /* vlshrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 24721; /* lshrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24925; /* vlshrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 24724; /* lshrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24928; /* vlshrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 24727; /* lshrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24931; /* vlshrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 24730; /* lshrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24934; /* vlshrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 24733; /* lshrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24937; /* vlshrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 24736; /* lshrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24940; /* vlshrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 24739; /* lshrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24943; /* vlshrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 24742; /* lshrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24946; /* vlshrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 24745; /* lshrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24949; /* vlshrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 24748; /* lshrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24952; /* vlshrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 24751; /* lshrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24955; /* vlshrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 24754; /* lshrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24958; /* vlshrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 24757; /* lshrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24961; /* vlshrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 24760; /* lshrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24964; /* vlshrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 24763; /* lshrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24967; /* vlshrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 24766; /* lshrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24970; /* vlshrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 24769; /* lshrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24973; /* vlshrv512di3 */

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32454; /* pred_crypto_vvsm4rvvrvvm8si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32514; /* pred_crypto_vvsm4rvvx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32574; /* pred_crypto_vvsm4rvvx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32622; /* pred_crypto_vvsm4rvvx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32658; /* pred_crypto_vvsm4rvvx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32682; /* pred_crypto_vvsm4rvvx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32466; /* pred_crypto_vvsm4rvvrvvm4si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32526; /* pred_crypto_vvsm4rvvx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32586; /* pred_crypto_vvsm4rvvx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32634; /* pred_crypto_vvsm4rvvx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32670; /* pred_crypto_vvsm4rvvx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32478; /* pred_crypto_vvsm4rvvrvvm2si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32538; /* pred_crypto_vvsm4rvvx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32598; /* pred_crypto_vvsm4rvvx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32646; /* pred_crypto_vvsm4rvvx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32490; /* pred_crypto_vvsm4rvvrvvm1si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32550; /* pred_crypto_vvsm4rvvx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32610; /* pred_crypto_vvsm4rvvx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32502; /* pred_crypto_vvsm4rvvrvvmf2si */
      if (!(
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32562; /* pred_crypto_vvsm4rvvx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 32327; /* pred_vsha2clrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 32331; /* pred_vsha2clrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 32335; /* pred_vsha2clrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 32339; /* pred_vsha2clrvvm1si */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32343; /* pred_vsha2clrvvmf2si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32347; /* pred_vsha2clrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32351; /* pred_vsha2clrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32355; /* pred_vsha2clrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32359; /* pred_vsha2clrvvm1di */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32363; /* pred_vsha2clv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32367; /* pred_vsha2clv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32371; /* pred_vsha2clv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32375; /* pred_vsha2clv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32379; /* pred_vsha2clv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32383; /* pred_vsha2clv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32387; /* pred_vsha2clv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32391; /* pred_vsha2clv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32395; /* pred_vsha2clv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32399; /* pred_vsha2clv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32403; /* pred_vsha2clv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32407; /* pred_vsha2clv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32411; /* pred_vsha2clv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32415; /* pred_vsha2clv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32419; /* pred_vsha2clv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32423; /* pred_vsha2clv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32427; /* pred_vsha2clv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32431; /* pred_vsha2clv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32435; /* pred_vsha2clv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32439; /* pred_vsha2clv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern642 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32443; /* pred_vsha2clv512di */

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  if (!vector_length_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern481 (x2))
        {
        case 0:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14198; /* pred_nandrvvmf64bi */

        case 1:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14201; /* pred_nandrvvmf32bi */

        case 2:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14204; /* pred_nandrvvmf16bi */

        case 3:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14207; /* pred_nandrvvmf8bi */

        case 4:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14210; /* pred_nandrvvmf4bi */

        case 5:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14213; /* pred_nandrvvmf2bi */

        case 6:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14216; /* pred_nandrvvm1bi */

        case 7:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14219; /* pred_nandv1bi */

        case 8:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14222; /* pred_nandv2bi */

        case 9:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14225; /* pred_nandv4bi */

        case 10:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14228; /* pred_nandv8bi */

        case 11:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14231; /* pred_nandv16bi */

        case 12:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14234; /* pred_nandv32bi */

        case 13:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14237; /* pred_nandv64bi */

        case 14:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14240; /* pred_nandv128bi */

        case 15:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14243; /* pred_nandv256bi */

        case 16:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14246; /* pred_nandv512bi */

        case 17:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14249; /* pred_nandv1024bi */

        case 18:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14252; /* pred_nandv2048bi */

        case 19:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14255; /* pred_nandv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern481 (x2))
        {
        case 0:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14199; /* pred_niorrvvmf64bi */

        case 1:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14202; /* pred_niorrvvmf32bi */

        case 2:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14205; /* pred_niorrvvmf16bi */

        case 3:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14208; /* pred_niorrvvmf8bi */

        case 4:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14211; /* pred_niorrvvmf4bi */

        case 5:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14214; /* pred_niorrvvmf2bi */

        case 6:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14217; /* pred_niorrvvm1bi */

        case 7:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14220; /* pred_niorv1bi */

        case 8:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14223; /* pred_niorv2bi */

        case 9:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14226; /* pred_niorv4bi */

        case 10:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14229; /* pred_niorv8bi */

        case 11:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14232; /* pred_niorv16bi */

        case 12:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14235; /* pred_niorv32bi */

        case 13:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14238; /* pred_niorv64bi */

        case 14:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14241; /* pred_niorv128bi */

        case 15:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14244; /* pred_niorv256bi */

        case 16:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14247; /* pred_niorv512bi */

        case 17:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14250; /* pred_niorv1024bi */

        case 18:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14253; /* pred_niorv2048bi */

        case 19:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14256; /* pred_niorv4096bi */

        default:
          return -1;
        }

    case XOR:
      switch (pattern481 (x2))
        {
        case 0:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14200; /* pred_nxorrvvmf64bi */

        case 1:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14203; /* pred_nxorrvvmf32bi */

        case 2:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14206; /* pred_nxorrvvmf16bi */

        case 3:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14209; /* pred_nxorrvvmf8bi */

        case 4:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14212; /* pred_nxorrvvmf4bi */

        case 5:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14215; /* pred_nxorrvvmf2bi */

        case 6:
          if (!
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14218; /* pred_nxorrvvm1bi */

        case 7:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14221; /* pred_nxorv1bi */

        case 8:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14224; /* pred_nxorv2bi */

        case 9:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14227; /* pred_nxorv4bi */

        case 10:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14230; /* pred_nxorv8bi */

        case 11:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14233; /* pred_nxorv16bi */

        case 12:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14236; /* pred_nxorv32bi */

        case 13:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14239; /* pred_nxorv64bi */

        case 14:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14242; /* pred_nxorv128bi */

        case 15:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14245; /* pred_nxorv256bi */

        case 16:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14248; /* pred_nxorv512bi */

        case 17:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14251; /* pred_nxorv1024bi */

        case 18:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14254; /* pred_nxorv2048bi */

        case 19:
          if (!(
#line 6028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14257; /* pred_nxorv4096bi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x8;
      operands[4] = x5;
      x9 = XVECEXP (x3, 0, 2);
      operands[5] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern569 (x2, 
E_RVVMF64BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14298; /* pred_notrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern569 (x2, 
E_RVVMF32BImode) != 0
              || !
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14299; /* pred_notrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern569 (x2, 
E_RVVMF16BImode) != 0
              || !
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14300; /* pred_notrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern569 (x2, 
E_RVVMF8BImode) != 0
              || !
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14301; /* pred_notrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern569 (x2, 
E_RVVMF4BImode) != 0
              || !
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14302; /* pred_notrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern569 (x2, 
E_RVVMF2BImode) != 0
              || !
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14303; /* pred_notrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern569 (x2, 
E_RVVM1BImode) != 0
              || !
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14304; /* pred_notrvvm1bi */

        case E_V1BImode:
          if (pattern569 (x2, 
E_V1BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14305; /* pred_notv1bi */

        case E_V2BImode:
          if (pattern569 (x2, 
E_V2BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14306; /* pred_notv2bi */

        case E_V4BImode:
          if (pattern569 (x2, 
E_V4BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14307; /* pred_notv4bi */

        case E_V8BImode:
          if (pattern569 (x2, 
E_V8BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14308; /* pred_notv8bi */

        case E_V16BImode:
          if (pattern569 (x2, 
E_V16BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14309; /* pred_notv16bi */

        case E_V32BImode:
          if (pattern569 (x2, 
E_V32BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14310; /* pred_notv32bi */

        case E_V64BImode:
          if (pattern569 (x2, 
E_V64BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14311; /* pred_notv64bi */

        case E_V128BImode:
          if (pattern569 (x2, 
E_V128BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14312; /* pred_notv128bi */

        case E_V256BImode:
          if (pattern569 (x2, 
E_V256BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14313; /* pred_notv256bi */

        case E_V512BImode:
          if (pattern569 (x2, 
E_V512BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14314; /* pred_notv512bi */

        case E_V1024BImode:
          if (pattern569 (x2, 
E_V1024BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14315; /* pred_notv1024bi */

        case E_V2048BImode:
          if (pattern569 (x2, 
E_V2048BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14316; /* pred_notv2048bi */

        case E_V4096BImode:
          if (pattern569 (x2, 
E_V4096BImode) != 0
              || !(
#line 6068 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14317; /* pred_notv4096bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 4337; /* *pred_broadcastv512df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4459; /* *pred_broadcastv512df_imm */
}

 int
recog_400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 4336; /* *pred_broadcastv256df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4458; /* *pred_broadcastv256df_imm */
}

 int
recog_401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 4335; /* *pred_broadcastv128df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4457; /* *pred_broadcastv128df_imm */
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 4334; /* *pred_broadcastv64df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4456; /* *pred_broadcastv64df_imm */
}

 int
recog_403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 4333; /* *pred_broadcastv32df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4455; /* *pred_broadcastv32df_imm */
}

 int
recog_406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4330; /* *pred_broadcastv4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4452; /* *pred_broadcastv4df_imm */
}

 int
recog_410 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 4326; /* *pred_broadcastv512sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4448; /* *pred_broadcastv512sf_imm */
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 4322; /* *pred_broadcastv32sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4444; /* *pred_broadcastv32sf_imm */
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4318; /* *pred_broadcastv2sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4440; /* *pred_broadcastv2sf_imm */
}

 int
recog_422 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return 4314; /* *pred_broadcastv512hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4436; /* *pred_broadcastv512hf_imm */
}

 int
recog_426 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return 4310; /* *pred_broadcastv32hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4432; /* *pred_broadcastv32hf_imm */
}

 int
recog_431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4305; /* *pred_broadcastv1hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4427; /* *pred_broadcastv1hf_imm */
}

 int
recog_435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64DImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 4301; /* *pred_broadcastv64di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64DImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4423; /* *pred_broadcastv64di_imm */
}

 int
recog_439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4DImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 4297; /* *pred_broadcastv4di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4DImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4419; /* *pred_broadcastv4di_imm */
}

 int
recog_443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 4293; /* *pred_broadcastv512si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4415; /* *pred_broadcastv512si_imm */
}

 int
recog_449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8SImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 4287; /* *pred_broadcastv8si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8SImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 4409; /* *pred_broadcastv8si_imm */
}

 int
recog_456 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256HImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 4280; /* *pred_broadcastv256hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256HImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4402; /* *pred_broadcastv256hi_imm */
}

 int
recog_464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 4272; /* *pred_broadcastv1hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 4394; /* *pred_broadcastv1hi_imm */
}

 int
recog_472 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32QImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 4264; /* *pred_broadcastv32qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32QImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 4386; /* *pred_broadcastv32qi_imm */
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM4DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4256; /* *pred_broadcastrvvm4df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4378; /* *pred_broadcastrvvm4df_imm */
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVMF2HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4248; /* *pred_broadcastrvvmf2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4370; /* *pred_broadcastrvvmf2hf_imm */
}

 int
recog_496 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512DImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 19777; /* pred_gatherv512df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 19899; /* pred_gatherv512df_scalar */
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16DImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 19772; /* pred_gatherv16df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 19894; /* pred_gatherv16df_scalar */
}

 int
recog_506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024SImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 19767; /* pred_gatherv1024sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 19889; /* pred_gatherv1024sf_scalar */
}

 int
recog_511 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32SImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 19762; /* pred_gatherv32sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 19884; /* pred_gatherv32sf_scalar */
}

 int
recog_516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1SImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 19757; /* pred_gatherv1sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 19879; /* pred_gatherv1sf_scalar */
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128HImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return 19752; /* pred_gatherv128hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 19874; /* pred_gatherv128hf_scalar */
}

 int
recog_526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4HImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 19747; /* pred_gatherv4hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 19869; /* pred_gatherv4hf_scalar */
}

 int
recog_531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V128DImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 19742; /* pred_gatherv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 19864; /* pred_gatherv128di_scalar */
}

 int
recog_536 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 19737; /* pred_gatherv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 19859; /* pred_gatherv4di_scalar */
}

 int
recog_541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256SImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 19732; /* pred_gatherv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 19854; /* pred_gatherv256si_scalar */
}

 int
recog_546 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8SImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 19727; /* pred_gatherv8si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 19849; /* pred_gatherv8si_scalar */
}

 int
recog_551 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1024HImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 19722; /* pred_gatherv1024hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 19844; /* pred_gatherv1024hi_scalar */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32HImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 19717; /* pred_gatherv32hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 19839; /* pred_gatherv32hi_scalar */
}

 int
recog_561 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 19712; /* pred_gatherv1hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 19834; /* pred_gatherv1hi_scalar */
}

 int
recog_566 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256QImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 19707; /* pred_gatherv256qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 19829; /* pred_gatherv256qi_scalar */
}

 int
recog_571 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8QImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 19702; /* pred_gatherv8qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 19824; /* pred_gatherv8qi_scalar */
}

 int
recog_576 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM2DImode)
      && (
#line 8105 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 19697; /* pred_gatherrvvm2df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 19819; /* pred_gatherrvvm2df_scalar */
}

 int
recog_581 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[4] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 0);
  operands[3] = x11;
  switch (pattern696 (x2))
    {
    case 0:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20181; /* pred_unit_strided_loadrvvmf8x2qi */

    case 1:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20182; /* pred_unit_strided_loadrvvmf8x3qi */

    case 2:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20183; /* pred_unit_strided_loadrvvmf8x4qi */

    case 3:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20184; /* pred_unit_strided_loadrvvmf8x5qi */

    case 4:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20185; /* pred_unit_strided_loadrvvmf8x6qi */

    case 5:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20186; /* pred_unit_strided_loadrvvmf8x7qi */

    case 6:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20187; /* pred_unit_strided_loadrvvmf8x8qi */

    case 7:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20188; /* pred_unit_strided_loadrvvmf4x2hi */

    case 8:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20189; /* pred_unit_strided_loadrvvmf4x3hi */

    case 9:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20190; /* pred_unit_strided_loadrvvmf4x4hi */

    case 10:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20191; /* pred_unit_strided_loadrvvmf4x5hi */

    case 11:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20192; /* pred_unit_strided_loadrvvmf4x6hi */

    case 12:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20193; /* pred_unit_strided_loadrvvmf4x7hi */

    case 13:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20194; /* pred_unit_strided_loadrvvmf4x8hi */

    case 14:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20195; /* pred_unit_strided_loadrvvmf2x2si */

    case 15:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20196; /* pred_unit_strided_loadrvvmf2x3si */

    case 16:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20197; /* pred_unit_strided_loadrvvmf2x4si */

    case 17:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20198; /* pred_unit_strided_loadrvvmf2x5si */

    case 18:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20199; /* pred_unit_strided_loadrvvmf2x6si */

    case 19:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20200; /* pred_unit_strided_loadrvvmf2x7si */

    case 20:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20201; /* pred_unit_strided_loadrvvmf2x8si */

    case 21:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20202; /* pred_unit_strided_loadrvvm1x2di */

    case 22:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20203; /* pred_unit_strided_loadrvvm1x3di */

    case 23:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20204; /* pred_unit_strided_loadrvvm1x4di */

    case 24:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20205; /* pred_unit_strided_loadrvvm1x5di */

    case 25:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20206; /* pred_unit_strided_loadrvvm1x6di */

    case 26:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20207; /* pred_unit_strided_loadrvvm1x7di */

    case 27:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20208; /* pred_unit_strided_loadrvvm1x8di */

    case 28:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20209; /* pred_unit_strided_loadrvvmf4x2bf */

    case 29:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20210; /* pred_unit_strided_loadrvvmf4x3bf */

    case 30:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20211; /* pred_unit_strided_loadrvvmf4x4bf */

    case 31:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20212; /* pred_unit_strided_loadrvvmf4x5bf */

    case 32:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20213; /* pred_unit_strided_loadrvvmf4x6bf */

    case 33:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20214; /* pred_unit_strided_loadrvvmf4x7bf */

    case 34:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20215; /* pred_unit_strided_loadrvvmf4x8bf */

    case 35:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20216; /* pred_unit_strided_loadrvvmf4x2hf */

    case 36:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20217; /* pred_unit_strided_loadrvvmf4x3hf */

    case 37:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20218; /* pred_unit_strided_loadrvvmf4x4hf */

    case 38:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20219; /* pred_unit_strided_loadrvvmf4x5hf */

    case 39:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20220; /* pred_unit_strided_loadrvvmf4x6hf */

    case 40:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20221; /* pred_unit_strided_loadrvvmf4x7hf */

    case 41:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20222; /* pred_unit_strided_loadrvvmf4x8hf */

    case 42:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20223; /* pred_unit_strided_loadrvvmf2x2sf */

    case 43:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20224; /* pred_unit_strided_loadrvvmf2x3sf */

    case 44:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20225; /* pred_unit_strided_loadrvvmf2x4sf */

    case 45:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20226; /* pred_unit_strided_loadrvvmf2x5sf */

    case 46:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20227; /* pred_unit_strided_loadrvvmf2x6sf */

    case 47:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20228; /* pred_unit_strided_loadrvvmf2x7sf */

    case 48:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20229; /* pred_unit_strided_loadrvvmf2x8sf */

    case 49:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20230; /* pred_unit_strided_loadrvvm1x2df */

    case 50:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20231; /* pred_unit_strided_loadrvvm1x3df */

    case 51:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20232; /* pred_unit_strided_loadrvvm1x4df */

    case 52:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20233; /* pred_unit_strided_loadrvvm1x5df */

    case 53:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20234; /* pred_unit_strided_loadrvvm1x6df */

    case 54:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20235; /* pred_unit_strided_loadrvvm1x7df */

    case 55:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20236; /* pred_unit_strided_loadrvvm1x8df */

    case 56:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20237; /* pred_unit_strided_loadrvvmf4x2qi */

    case 57:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20238; /* pred_unit_strided_loadrvvmf4x3qi */

    case 58:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20239; /* pred_unit_strided_loadrvvmf4x4qi */

    case 59:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20240; /* pred_unit_strided_loadrvvmf4x5qi */

    case 60:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20241; /* pred_unit_strided_loadrvvmf4x6qi */

    case 61:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20242; /* pred_unit_strided_loadrvvmf4x7qi */

    case 62:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20243; /* pred_unit_strided_loadrvvmf4x8qi */

    case 63:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20244; /* pred_unit_strided_loadrvvmf2x2hi */

    case 64:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20245; /* pred_unit_strided_loadrvvmf2x3hi */

    case 65:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20246; /* pred_unit_strided_loadrvvmf2x4hi */

    case 66:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20247; /* pred_unit_strided_loadrvvmf2x5hi */

    case 67:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20248; /* pred_unit_strided_loadrvvmf2x6hi */

    case 68:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20249; /* pred_unit_strided_loadrvvmf2x7hi */

    case 69:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20250; /* pred_unit_strided_loadrvvmf2x8hi */

    case 70:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20251; /* pred_unit_strided_loadrvvm1x2si */

    case 71:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20252; /* pred_unit_strided_loadrvvm1x3si */

    case 72:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20253; /* pred_unit_strided_loadrvvm1x4si */

    case 73:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20254; /* pred_unit_strided_loadrvvm1x5si */

    case 74:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20255; /* pred_unit_strided_loadrvvm1x6si */

    case 75:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20256; /* pred_unit_strided_loadrvvm1x7si */

    case 76:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20257; /* pred_unit_strided_loadrvvm1x8si */

    case 77:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20258; /* pred_unit_strided_loadrvvm2x2di */

    case 78:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20259; /* pred_unit_strided_loadrvvm2x3di */

    case 79:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20260; /* pred_unit_strided_loadrvvm2x4di */

    case 80:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20261; /* pred_unit_strided_loadrvvmf2x2bf */

    case 81:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20262; /* pred_unit_strided_loadrvvmf2x3bf */

    case 82:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20263; /* pred_unit_strided_loadrvvmf2x4bf */

    case 83:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20264; /* pred_unit_strided_loadrvvmf2x5bf */

    case 84:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20265; /* pred_unit_strided_loadrvvmf2x6bf */

    case 85:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20266; /* pred_unit_strided_loadrvvmf2x7bf */

    case 86:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20267; /* pred_unit_strided_loadrvvmf2x8bf */

    case 87:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20268; /* pred_unit_strided_loadrvvmf2x2hf */

    case 88:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20269; /* pred_unit_strided_loadrvvmf2x3hf */

    case 89:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20270; /* pred_unit_strided_loadrvvmf2x4hf */

    case 90:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20271; /* pred_unit_strided_loadrvvmf2x5hf */

    case 91:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20272; /* pred_unit_strided_loadrvvmf2x6hf */

    case 92:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20273; /* pred_unit_strided_loadrvvmf2x7hf */

    case 93:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20274; /* pred_unit_strided_loadrvvmf2x8hf */

    case 94:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20275; /* pred_unit_strided_loadrvvm1x2sf */

    case 95:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20276; /* pred_unit_strided_loadrvvm1x3sf */

    case 96:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20277; /* pred_unit_strided_loadrvvm1x4sf */

    case 97:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20278; /* pred_unit_strided_loadrvvm1x5sf */

    case 98:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20279; /* pred_unit_strided_loadrvvm1x6sf */

    case 99:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20280; /* pred_unit_strided_loadrvvm1x7sf */

    case 100:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20281; /* pred_unit_strided_loadrvvm1x8sf */

    case 101:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20282; /* pred_unit_strided_loadrvvm2x2df */

    case 102:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20283; /* pred_unit_strided_loadrvvm2x3df */

    case 103:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20284; /* pred_unit_strided_loadrvvm2x4df */

    case 104:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20285; /* pred_unit_strided_loadrvvmf2x2qi */

    case 105:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20286; /* pred_unit_strided_loadrvvmf2x3qi */

    case 106:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20287; /* pred_unit_strided_loadrvvmf2x4qi */

    case 107:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20288; /* pred_unit_strided_loadrvvmf2x5qi */

    case 108:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20289; /* pred_unit_strided_loadrvvmf2x6qi */

    case 109:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20290; /* pred_unit_strided_loadrvvmf2x7qi */

    case 110:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20291; /* pred_unit_strided_loadrvvmf2x8qi */

    case 111:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20292; /* pred_unit_strided_loadrvvm1x2hi */

    case 112:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20293; /* pred_unit_strided_loadrvvm1x3hi */

    case 113:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20294; /* pred_unit_strided_loadrvvm1x4hi */

    case 114:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20295; /* pred_unit_strided_loadrvvm1x5hi */

    case 115:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20296; /* pred_unit_strided_loadrvvm1x6hi */

    case 116:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20297; /* pred_unit_strided_loadrvvm1x7hi */

    case 117:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20298; /* pred_unit_strided_loadrvvm1x8hi */

    case 118:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20299; /* pred_unit_strided_loadrvvm2x2si */

    case 119:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20300; /* pred_unit_strided_loadrvvm2x3si */

    case 120:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20301; /* pred_unit_strided_loadrvvm2x4si */

    case 121:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20302; /* pred_unit_strided_loadrvvm4x2di */

    case 122:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20303; /* pred_unit_strided_loadrvvm1x2bf */

    case 123:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20304; /* pred_unit_strided_loadrvvm1x3bf */

    case 124:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20305; /* pred_unit_strided_loadrvvm1x4bf */

    case 125:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20306; /* pred_unit_strided_loadrvvm1x5bf */

    case 126:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20307; /* pred_unit_strided_loadrvvm1x6bf */

    case 127:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20308; /* pred_unit_strided_loadrvvm1x7bf */

    case 128:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20309; /* pred_unit_strided_loadrvvm1x8bf */

    case 129:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20310; /* pred_unit_strided_loadrvvm1x2hf */

    case 130:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20311; /* pred_unit_strided_loadrvvm1x3hf */

    case 131:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20312; /* pred_unit_strided_loadrvvm1x4hf */

    case 132:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20313; /* pred_unit_strided_loadrvvm1x5hf */

    case 133:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20314; /* pred_unit_strided_loadrvvm1x6hf */

    case 134:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20315; /* pred_unit_strided_loadrvvm1x7hf */

    case 135:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20316; /* pred_unit_strided_loadrvvm1x8hf */

    case 136:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20317; /* pred_unit_strided_loadrvvm2x2sf */

    case 137:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20318; /* pred_unit_strided_loadrvvm2x3sf */

    case 138:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20319; /* pred_unit_strided_loadrvvm2x4sf */

    case 139:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20320; /* pred_unit_strided_loadrvvm4x2df */

    case 140:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20321; /* pred_unit_strided_loadrvvm1x2qi */

    case 141:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20322; /* pred_unit_strided_loadrvvm1x3qi */

    case 142:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20323; /* pred_unit_strided_loadrvvm1x4qi */

    case 143:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20324; /* pred_unit_strided_loadrvvm1x5qi */

    case 144:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20325; /* pred_unit_strided_loadrvvm1x6qi */

    case 145:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20326; /* pred_unit_strided_loadrvvm1x7qi */

    case 146:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20327; /* pred_unit_strided_loadrvvm1x8qi */

    case 147:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20328; /* pred_unit_strided_loadrvvm2x2hi */

    case 148:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20329; /* pred_unit_strided_loadrvvm2x3hi */

    case 149:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20330; /* pred_unit_strided_loadrvvm2x4hi */

    case 150:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20331; /* pred_unit_strided_loadrvvm4x2si */

    case 151:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20332; /* pred_unit_strided_loadrvvm2x2bf */

    case 152:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20333; /* pred_unit_strided_loadrvvm2x3bf */

    case 153:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20334; /* pred_unit_strided_loadrvvm2x4bf */

    case 154:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20335; /* pred_unit_strided_loadrvvm2x2hf */

    case 155:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20336; /* pred_unit_strided_loadrvvm2x3hf */

    case 156:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20337; /* pred_unit_strided_loadrvvm2x4hf */

    case 157:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20338; /* pred_unit_strided_loadrvvm4x2sf */

    case 158:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20339; /* pred_unit_strided_loadrvvm2x2qi */

    case 159:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20340; /* pred_unit_strided_loadrvvm2x3qi */

    case 160:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20341; /* pred_unit_strided_loadrvvm2x4qi */

    case 161:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20342; /* pred_unit_strided_loadrvvm4x2hi */

    case 162:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20343; /* pred_unit_strided_loadrvvm4x2bf */

    case 163:
      if (!(
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20344; /* pred_unit_strided_loadrvvm4x2hf */

    case 164:
      if (!
#line 8245 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20345; /* pred_unit_strided_loadrvvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_592 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8DImode:
      if (pattern686 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7778; /* *pred_addrvvm8di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10268; /* pred_single_widen_addsrvvm8di_extended_scalar */

    case E_RVVM4DImode:
      if (pattern686 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7787; /* *pred_addrvvm4di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10270; /* pred_single_widen_addsrvvm4di_extended_scalar */

    case E_RVVM2DImode:
      if (pattern686 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7796; /* *pred_addrvvm2di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10272; /* pred_single_widen_addsrvvm2di_extended_scalar */

    case E_RVVM1DImode:
      if (pattern686 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 7805; /* *pred_addrvvm1di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10274; /* pred_single_widen_addsrvvm1di_extended_scalar */

    case E_V1DImode:
      if (pattern686 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 7814; /* *pred_addv1di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10322; /* pred_single_widen_addsv1di_extended_scalar */

    case E_V2DImode:
      if (pattern686 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 7823; /* *pred_addv2di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10324; /* pred_single_widen_addsv2di_extended_scalar */

    case E_V4DImode:
      if (pattern686 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 7832; /* *pred_addv4di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10326; /* pred_single_widen_addsv4di_extended_scalar */

    case E_V8DImode:
      if (pattern686 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 7841; /* *pred_addv8di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10328; /* pred_single_widen_addsv8di_extended_scalar */

    case E_V16DImode:
      if (pattern686 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 7850; /* *pred_addv16di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10330; /* pred_single_widen_addsv16di_extended_scalar */

    case E_V32DImode:
      if (pattern686 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 7859; /* *pred_addv32di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10332; /* pred_single_widen_addsv32di_extended_scalar */

    case E_V64DImode:
      if (pattern686 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 7868; /* *pred_addv64di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10334; /* pred_single_widen_addsv64di_extended_scalar */

    case E_V128DImode:
      if (pattern686 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 7877; /* *pred_addv128di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10336; /* pred_single_widen_addsv128di_extended_scalar */

    case E_V256DImode:
      if (pattern686 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 7886; /* *pred_addv256di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10338; /* pred_single_widen_addsv256di_extended_scalar */

    case E_V512DImode:
      if (pattern686 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      if ((
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 7895; /* *pred_addv512di_extended_scalar */
      if (!(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10340; /* pred_single_widen_addsv512di_extended_scalar */

    case E_RVVM8HImode:
      if (pattern686 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10246; /* pred_single_widen_addsrvvm8hi_extended_scalar */

    case E_RVVM4HImode:
      if (pattern686 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10248; /* pred_single_widen_addsrvvm4hi_extended_scalar */

    case E_RVVM2HImode:
      if (pattern686 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10250; /* pred_single_widen_addsrvvm2hi_extended_scalar */

    case E_RVVM1HImode:
      if (pattern686 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10252; /* pred_single_widen_addsrvvm1hi_extended_scalar */

    case E_RVVMF2HImode:
      if (pattern686 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10254; /* pred_single_widen_addsrvvmf2hi_extended_scalar */

    case E_RVVMF4HImode:
      if (pattern686 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10256; /* pred_single_widen_addsrvvmf4hi_extended_scalar */

    case E_RVVM8SImode:
      if (pattern686 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10258; /* pred_single_widen_addsrvvm8si_extended_scalar */

    case E_RVVM4SImode:
      if (pattern686 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10260; /* pred_single_widen_addsrvvm4si_extended_scalar */

    case E_RVVM2SImode:
      if (pattern686 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10262; /* pred_single_widen_addsrvvm2si_extended_scalar */

    case E_RVVM1SImode:
      if (pattern686 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
          || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10264; /* pred_single_widen_addsrvvm1si_extended_scalar */

    case E_RVVMF2SImode:
      if (pattern686 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 10266; /* pred_single_widen_addsrvvmf2si_extended_scalar */

    case E_V1HImode:
      if (pattern686 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 10276; /* pred_single_widen_addsv1hi_extended_scalar */

    case E_V2HImode:
      if (pattern686 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 10278; /* pred_single_widen_addsv2hi_extended_scalar */

    case E_V4HImode:
      if (pattern686 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 10280; /* pred_single_widen_addsv4hi_extended_scalar */

    case E_V8HImode:
      if (pattern686 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 10282; /* pred_single_widen_addsv8hi_extended_scalar */

    case E_V16HImode:
      if (pattern686 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 10284; /* pred_single_widen_addsv16hi_extended_scalar */

    case E_V32HImode:
      if (pattern686 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10286; /* pred_single_widen_addsv32hi_extended_scalar */

    case E_V64HImode:
      if (pattern686 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10288; /* pred_single_widen_addsv64hi_extended_scalar */

    case E_V128HImode:
      if (pattern686 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10290; /* pred_single_widen_addsv128hi_extended_scalar */

    case E_V256HImode:
      if (pattern686 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10292; /* pred_single_widen_addsv256hi_extended_scalar */

    case E_V512HImode:
      if (pattern686 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10294; /* pred_single_widen_addsv512hi_extended_scalar */

    case E_V1024HImode:
      if (pattern686 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10296; /* pred_single_widen_addsv1024hi_extended_scalar */

    case E_V2048HImode:
      if (pattern686 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10298; /* pred_single_widen_addsv2048hi_extended_scalar */

    case E_V1SImode:
      if (pattern686 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 10300; /* pred_single_widen_addsv1si_extended_scalar */

    case E_V2SImode:
      if (pattern686 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 10302; /* pred_single_widen_addsv2si_extended_scalar */

    case E_V4SImode:
      if (pattern686 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 10304; /* pred_single_widen_addsv4si_extended_scalar */

    case E_V8SImode:
      if (pattern686 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 10306; /* pred_single_widen_addsv8si_extended_scalar */

    case E_V16SImode:
      if (pattern686 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10308; /* pred_single_widen_addsv16si_extended_scalar */

    case E_V32SImode:
      if (pattern686 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10310; /* pred_single_widen_addsv32si_extended_scalar */

    case E_V64SImode:
      if (pattern686 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10312; /* pred_single_widen_addsv64si_extended_scalar */

    case E_V128SImode:
      if (pattern686 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10314; /* pred_single_widen_addsv128si_extended_scalar */

    case E_V256SImode:
      if (pattern686 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10316; /* pred_single_widen_addsv256si_extended_scalar */

    case E_V512SImode:
      if (pattern686 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10318; /* pred_single_widen_addsv512si_extended_scalar */

    case E_V1024SImode:
      if (pattern686 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
          || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10320; /* pred_single_widen_addsv1024si_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_647 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128SImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13120; /* *pred_mul_plusv128si_undef */
}

 int
recog_653 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4DImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13126; /* *pred_mul_plusv4di_undef */
}

 int
recog_659 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256DImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13132; /* *pred_mul_plusv256di_undef */
}

 int
recog_665 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_656 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V32DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13197; /* *pred_maddv32di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13265; /* *pred_maccv32di */
}

 int
recog_671 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_650 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13191; /* *pred_maddv1024si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13259; /* *pred_maccv1024si */
}

 int
recog_678 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_643 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13184; /* *pred_maddv8si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13252; /* *pred_maccv8si */
}

 int
recog_685 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_636 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13177; /* *pred_maddv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13245; /* *pred_maccv256hi */
}

 int
recog_692 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_629 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13170; /* *pred_maddv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13238; /* *pred_maccv2hi */
}

 int
recog_699 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_622 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13163; /* *pred_maddv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13231; /* *pred_maccv128qi */
}

 int
recog_706 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13332; /* *pred_maddv16di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13400; /* *pred_maccv16di_scalar */
}

 int
recog_713 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13325; /* *pred_maddv256si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13393; /* *pred_maccv256si_scalar */
}

 int
recog_720 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13318; /* *pred_maddv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13386; /* *pred_maccv2si_scalar */
}

 int
recog_727 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13311; /* *pred_maddv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13379; /* *pred_maccv64hi_scalar */
}

 int
recog_734 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      switch (pattern562 (x2))
        {
        case 0:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9287; /* pred_dual_widen_addurvvm8hi */

        case 1:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9293; /* pred_dual_widen_addurvvm4hi */

        case 2:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9299; /* pred_dual_widen_addurvvm2hi */

        case 3:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9305; /* pred_dual_widen_addurvvm1hi */

        case 4:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9311; /* pred_dual_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9317; /* pred_dual_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9323; /* pred_dual_widen_addurvvm8si */

        case 7:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9329; /* pred_dual_widen_addurvvm4si */

        case 8:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9335; /* pred_dual_widen_addurvvm2si */

        case 9:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9341; /* pred_dual_widen_addurvvm1si */

        case 10:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9347; /* pred_dual_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9353; /* pred_dual_widen_addurvvm8di */

        case 12:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9359; /* pred_dual_widen_addurvvm4di */

        case 13:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9365; /* pred_dual_widen_addurvvm2di */

        case 14:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9371; /* pred_dual_widen_addurvvm1di */

        case 15:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9377; /* pred_dual_widen_adduv1hi */

        case 16:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9383; /* pred_dual_widen_adduv2hi */

        case 17:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9389; /* pred_dual_widen_adduv4hi */

        case 18:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9395; /* pred_dual_widen_adduv8hi */

        case 19:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9401; /* pred_dual_widen_adduv16hi */

        case 20:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9407; /* pred_dual_widen_adduv32hi */

        case 21:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9413; /* pred_dual_widen_adduv64hi */

        case 22:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9419; /* pred_dual_widen_adduv128hi */

        case 23:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9425; /* pred_dual_widen_adduv256hi */

        case 24:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9431; /* pred_dual_widen_adduv512hi */

        case 25:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9437; /* pred_dual_widen_adduv1024hi */

        case 26:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9443; /* pred_dual_widen_adduv2048hi */

        case 27:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9449; /* pred_dual_widen_adduv1si */

        case 28:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9455; /* pred_dual_widen_adduv2si */

        case 29:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9461; /* pred_dual_widen_adduv4si */

        case 30:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9467; /* pred_dual_widen_adduv8si */

        case 31:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9473; /* pred_dual_widen_adduv16si */

        case 32:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9479; /* pred_dual_widen_adduv32si */

        case 33:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9485; /* pred_dual_widen_adduv64si */

        case 34:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9491; /* pred_dual_widen_adduv128si */

        case 35:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9497; /* pred_dual_widen_adduv256si */

        case 36:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9503; /* pred_dual_widen_adduv512si */

        case 37:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9509; /* pred_dual_widen_adduv1024si */

        case 38:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9515; /* pred_dual_widen_adduv1di */

        case 39:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9521; /* pred_dual_widen_adduv2di */

        case 40:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9527; /* pred_dual_widen_adduv4di */

        case 41:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9533; /* pred_dual_widen_adduv8di */

        case 42:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9539; /* pred_dual_widen_adduv16di */

        case 43:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9545; /* pred_dual_widen_adduv32di */

        case 44:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9551; /* pred_dual_widen_adduv64di */

        case 45:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9557; /* pred_dual_widen_adduv128di */

        case 46:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9563; /* pred_dual_widen_adduv256di */

        case 47:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9569; /* pred_dual_widen_adduv512di */

        case 48:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9575; /* pred_dual_widen_addurvvm8hi_scalar */

        case 49:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9581; /* pred_dual_widen_addurvvm4hi_scalar */

        case 50:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9587; /* pred_dual_widen_addurvvm2hi_scalar */

        case 51:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9593; /* pred_dual_widen_addurvvm1hi_scalar */

        case 52:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9599; /* pred_dual_widen_addurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9605; /* pred_dual_widen_addurvvmf4hi_scalar */

        case 54:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9611; /* pred_dual_widen_addurvvm8si_scalar */

        case 55:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9617; /* pred_dual_widen_addurvvm4si_scalar */

        case 56:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9623; /* pred_dual_widen_addurvvm2si_scalar */

        case 57:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9629; /* pred_dual_widen_addurvvm1si_scalar */

        case 58:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9635; /* pred_dual_widen_addurvvmf2si_scalar */

        case 59:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9641; /* pred_dual_widen_addurvvm8di_scalar */

        case 60:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9647; /* pred_dual_widen_addurvvm4di_scalar */

        case 61:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9653; /* pred_dual_widen_addurvvm2di_scalar */

        case 62:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9659; /* pred_dual_widen_addurvvm1di_scalar */

        case 63:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9665; /* pred_dual_widen_adduv1hi_scalar */

        case 64:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9671; /* pred_dual_widen_adduv2hi_scalar */

        case 65:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9677; /* pred_dual_widen_adduv4hi_scalar */

        case 66:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9683; /* pred_dual_widen_adduv8hi_scalar */

        case 67:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9689; /* pred_dual_widen_adduv16hi_scalar */

        case 68:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9695; /* pred_dual_widen_adduv32hi_scalar */

        case 69:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9701; /* pred_dual_widen_adduv64hi_scalar */

        case 70:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9707; /* pred_dual_widen_adduv128hi_scalar */

        case 71:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9713; /* pred_dual_widen_adduv256hi_scalar */

        case 72:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9719; /* pred_dual_widen_adduv512hi_scalar */

        case 73:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9725; /* pred_dual_widen_adduv1024hi_scalar */

        case 74:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9731; /* pred_dual_widen_adduv2048hi_scalar */

        case 75:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9737; /* pred_dual_widen_adduv1si_scalar */

        case 76:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9743; /* pred_dual_widen_adduv2si_scalar */

        case 77:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9749; /* pred_dual_widen_adduv4si_scalar */

        case 78:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9755; /* pred_dual_widen_adduv8si_scalar */

        case 79:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9761; /* pred_dual_widen_adduv16si_scalar */

        case 80:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9767; /* pred_dual_widen_adduv32si_scalar */

        case 81:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9773; /* pred_dual_widen_adduv64si_scalar */

        case 82:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9779; /* pred_dual_widen_adduv128si_scalar */

        case 83:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9785; /* pred_dual_widen_adduv256si_scalar */

        case 84:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9791; /* pred_dual_widen_adduv512si_scalar */

        case 85:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9797; /* pred_dual_widen_adduv1024si_scalar */

        case 86:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9803; /* pred_dual_widen_adduv1di_scalar */

        case 87:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9809; /* pred_dual_widen_adduv2di_scalar */

        case 88:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9815; /* pred_dual_widen_adduv4di_scalar */

        case 89:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9821; /* pred_dual_widen_adduv8di_scalar */

        case 90:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9827; /* pred_dual_widen_adduv16di_scalar */

        case 91:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9833; /* pred_dual_widen_adduv32di_scalar */

        case 92:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9839; /* pred_dual_widen_adduv64di_scalar */

        case 93:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9845; /* pred_dual_widen_adduv128di_scalar */

        case 94:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9851; /* pred_dual_widen_adduv256di_scalar */

        case 95:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9857; /* pred_dual_widen_adduv512di_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern563 (x2))
        {
        case 0:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9959; /* pred_single_widen_addurvvm8hi */

        case 1:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9961; /* pred_single_widen_addurvvm4hi */

        case 2:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9963; /* pred_single_widen_addurvvm2hi */

        case 3:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9965; /* pred_single_widen_addurvvm1hi */

        case 4:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9967; /* pred_single_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9969; /* pred_single_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9971; /* pred_single_widen_addurvvm8si */

        case 7:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9973; /* pred_single_widen_addurvvm4si */

        case 8:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9975; /* pred_single_widen_addurvvm2si */

        case 9:
          if (!
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9977; /* pred_single_widen_addurvvm1si */

        case 10:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9979; /* pred_single_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9981; /* pred_single_widen_addurvvm8di */

        case 12:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9983; /* pred_single_widen_addurvvm4di */

        case 13:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9985; /* pred_single_widen_addurvvm2di */

        case 14:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9987; /* pred_single_widen_addurvvm1di */

        case 15:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9989; /* pred_single_widen_adduv1hi */

        case 16:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9991; /* pred_single_widen_adduv2hi */

        case 17:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9993; /* pred_single_widen_adduv4hi */

        case 18:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9995; /* pred_single_widen_adduv8hi */

        case 19:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9997; /* pred_single_widen_adduv16hi */

        case 20:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9999; /* pred_single_widen_adduv32hi */

        case 21:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10001; /* pred_single_widen_adduv64hi */

        case 22:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10003; /* pred_single_widen_adduv128hi */

        case 23:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10005; /* pred_single_widen_adduv256hi */

        case 24:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10007; /* pred_single_widen_adduv512hi */

        case 25:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10009; /* pred_single_widen_adduv1024hi */

        case 26:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10011; /* pred_single_widen_adduv2048hi */

        case 27:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10013; /* pred_single_widen_adduv1si */

        case 28:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10015; /* pred_single_widen_adduv2si */

        case 29:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10017; /* pred_single_widen_adduv4si */

        case 30:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10019; /* pred_single_widen_adduv8si */

        case 31:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10021; /* pred_single_widen_adduv16si */

        case 32:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10023; /* pred_single_widen_adduv32si */

        case 33:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10025; /* pred_single_widen_adduv64si */

        case 34:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10027; /* pred_single_widen_adduv128si */

        case 35:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10029; /* pred_single_widen_adduv256si */

        case 36:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10031; /* pred_single_widen_adduv512si */

        case 37:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10033; /* pred_single_widen_adduv1024si */

        case 38:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10035; /* pred_single_widen_adduv1di */

        case 39:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10037; /* pred_single_widen_adduv2di */

        case 40:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10039; /* pred_single_widen_adduv4di */

        case 41:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10041; /* pred_single_widen_adduv8di */

        case 42:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10043; /* pred_single_widen_adduv16di */

        case 43:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10045; /* pred_single_widen_adduv32di */

        case 44:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10047; /* pred_single_widen_adduv64di */

        case 45:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10049; /* pred_single_widen_adduv128di */

        case 46:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10051; /* pred_single_widen_adduv256di */

        case 47:
          if (!(
#line 4066 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10053; /* pred_single_widen_adduv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern565 (x2))
        {
        case 0:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10535; /* pred_zero_extendrvvm8hi */

        case 1:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10537; /* pred_zero_extendrvvm4hi */

        case 2:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10539; /* pred_zero_extendrvvm2hi */

        case 3:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10541; /* pred_zero_extendrvvm1hi */

        case 4:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10543; /* pred_zero_extendrvvmf2hi */

        case 5:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10545; /* pred_zero_extendrvvmf4hi */

        case 6:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10547; /* pred_zero_extendrvvm8si */

        case 7:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10549; /* pred_zero_extendrvvm4si */

        case 8:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10551; /* pred_zero_extendrvvm2si */

        case 9:
          if (!
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10553; /* pred_zero_extendrvvm1si */

        case 10:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10555; /* pred_zero_extendrvvmf2si */

        case 11:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10557; /* pred_zero_extendrvvm8di */

        case 12:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10559; /* pred_zero_extendrvvm4di */

        case 13:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10561; /* pred_zero_extendrvvm2di */

        case 14:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10563; /* pred_zero_extendrvvm1di */

        case 15:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10565; /* pred_zero_extendv1hi */

        case 16:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10567; /* pred_zero_extendv2hi */

        case 17:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10569; /* pred_zero_extendv4hi */

        case 18:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10571; /* pred_zero_extendv8hi */

        case 19:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10573; /* pred_zero_extendv16hi */

        case 20:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10575; /* pred_zero_extendv32hi */

        case 21:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10577; /* pred_zero_extendv64hi */

        case 22:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10579; /* pred_zero_extendv128hi */

        case 23:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10581; /* pred_zero_extendv256hi */

        case 24:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10583; /* pred_zero_extendv512hi */

        case 25:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10585; /* pred_zero_extendv1024hi */

        case 26:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10587; /* pred_zero_extendv2048hi */

        case 27:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10589; /* pred_zero_extendv1si */

        case 28:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10591; /* pred_zero_extendv2si */

        case 29:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10593; /* pred_zero_extendv4si */

        case 30:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10595; /* pred_zero_extendv8si */

        case 31:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10597; /* pred_zero_extendv16si */

        case 32:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10599; /* pred_zero_extendv32si */

        case 33:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10601; /* pred_zero_extendv64si */

        case 34:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10603; /* pred_zero_extendv128si */

        case 35:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10605; /* pred_zero_extendv256si */

        case 36:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10607; /* pred_zero_extendv512si */

        case 37:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10609; /* pred_zero_extendv1024si */

        case 38:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10611; /* pred_zero_extendv1di */

        case 39:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10613; /* pred_zero_extendv2di */

        case 40:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10615; /* pred_zero_extendv4di */

        case 41:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10617; /* pred_zero_extendv8di */

        case 42:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10619; /* pred_zero_extendv16di */

        case 43:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10621; /* pred_zero_extendv32di */

        case 44:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10623; /* pred_zero_extendv64di */

        case 45:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10625; /* pred_zero_extendv128di */

        case 46:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10627; /* pred_zero_extendv256di */

        case 47:
          if (!(
#line 4202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10629; /* pred_zero_extendv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_773 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V2048QImode) == 0
      && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13467; /* *pred_minus_mulv2048qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2048QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2048QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13535; /* *pred_nmsubv2048qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13603; /* *pred_nmsacv2048qi */
}

 int
recog_781 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V8QImode) == 0
      && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 13459; /* *pred_minus_mulv8qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V8QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 13527; /* *pred_nmsubv8qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 13595; /* *pred_nmsacv8qi */
}

 int
recog_789 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13704; /* *pred_nmsubv256di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13772; /* *pred_nmsacv256di_scalar */
}

 int
recog_794 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 13699; /* *pred_nmsubv8di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13767; /* *pred_nmsacv8di_scalar */
}

 int
recog_802 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13691; /* *pred_nmsubv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13759; /* *pred_nmsacv64si_scalar */
}

 int
recog_810 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13683; /* *pred_nmsubv1024hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13751; /* *pred_nmsacv1024hi_scalar */
}

 int
recog_818 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM8QImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13434; /* *pred_minus_mulrvvm8qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13502; /* *pred_nmsubrvvm8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13570; /* *pred_nmsacrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM4QImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13435; /* *pred_minus_mulrvvm4qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13503; /* *pred_nmsubrvvm4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13571; /* *pred_nmsacrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM2QImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13436; /* *pred_minus_mulrvvm2qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13504; /* *pred_nmsubrvvm2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13572; /* *pred_nmsacrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM1QImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13437; /* *pred_minus_mulrvvm1qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13505; /* *pred_nmsubrvvm1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13573; /* *pred_nmsacrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM8HImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13438; /* *pred_minus_mulrvvm8hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13506; /* *pred_nmsubrvvm8hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13574; /* *pred_nmsacrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM4HImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13439; /* *pred_minus_mulrvvm4hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13507; /* *pred_nmsubrvvm4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13575; /* *pred_nmsacrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM2HImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13440; /* *pred_minus_mulrvvm2hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13508; /* *pred_nmsubrvvm2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13576; /* *pred_nmsacrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM1HImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13441; /* *pred_minus_mulrvvm1hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13509; /* *pred_nmsubrvvm1hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13577; /* *pred_nmsacrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM8SImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13442; /* *pred_minus_mulrvvm8si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13510; /* *pred_nmsubrvvm8si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13578; /* *pred_nmsacrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM4SImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13443; /* *pred_minus_mulrvvm4si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13511; /* *pred_nmsubrvvm4si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13579; /* *pred_nmsacrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM2SImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13444; /* *pred_minus_mulrvvm2si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13512; /* *pred_nmsubrvvm2si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13580; /* *pred_nmsacrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM1SImode) == 0
          && 
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13445; /* *pred_minus_mulrvvm1si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13513; /* *pred_nmsubrvvm1si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13581; /* *pred_nmsacrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM8DImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13446; /* *pred_minus_mulrvvm8di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13514; /* *pred_nmsubrvvm8di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13582; /* *pred_nmsacrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM4DImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13447; /* *pred_minus_mulrvvm4di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13515; /* *pred_nmsubrvvm4di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13583; /* *pred_nmsacrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM2DImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13448; /* *pred_minus_mulrvvm2di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13516; /* *pred_nmsubrvvm2di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13584; /* *pred_nmsacrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVM1DImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13449; /* *pred_minus_mulrvvm1di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13517; /* *pred_nmsubrvvm1di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13585; /* *pred_nmsacrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVMF2QImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13450; /* *pred_minus_mulrvvmf2qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF2QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF2QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13518; /* *pred_nmsubrvvmf2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13586; /* *pred_nmsacrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVMF4QImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13451; /* *pred_minus_mulrvvmf4qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF4QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF4QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13519; /* *pred_nmsubrvvmf4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13587; /* *pred_nmsacrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern570 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern702 (x2, 
E_RVVMF8QImode) == 0
          && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13452; /* *pred_minus_mulrvvmf8qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF8QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF8QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13520; /* *pred_nmsubrvvmf8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13588; /* *pred_nmsacrvvmf8qi */

    case E_RVVMF2HImode:
      return recog_787 (x1, insn, pnum_clobbers);

    case E_RVVMF4HImode:
      return recog_786 (x1, insn, pnum_clobbers);

    case E_RVVMF2SImode:
      return recog_785 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_784 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_783 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_782 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_781 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_780 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_779 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_778 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_777 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_776 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_775 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_774 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_773 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_772 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_771 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_770 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_769 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_768 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_767 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_766 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_765 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_764 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_763 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_762 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_761 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_760 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_759 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_758 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_757 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_756 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_755 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_754 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_753 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_752 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_751 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_750 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_749 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_748 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_747 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_746 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_745 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_744 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_743 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_742 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_741 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_740 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_739 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_845 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 6303; /* pred_ashlv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 6782; /* pred_ashlv2si_scalar */
}

 int
recog_850 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256HImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 6218; /* pred_ashlv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6767; /* pred_ashlv256hi_scalar */
}

 int
recog_855 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern668 (x2, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 31843; /* pred_vwsllv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 31891; /* pred_vwsllv512di_scalar */
}

 int
recog_860 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern668 (x2, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 31838; /* pred_vwsllv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 31886; /* pred_vwsllv16di_scalar */
}

 int
recog_865 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      switch (pattern530 (x2))
        {
        case 0:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9290; /* pred_dual_widen_mulsrvvm8hi */

        case 1:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9296; /* pred_dual_widen_mulsrvvm4hi */

        case 2:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9302; /* pred_dual_widen_mulsrvvm2hi */

        case 3:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9308; /* pred_dual_widen_mulsrvvm1hi */

        case 4:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9314; /* pred_dual_widen_mulsrvvmf2hi */

        case 5:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9320; /* pred_dual_widen_mulsrvvmf4hi */

        case 6:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9326; /* pred_dual_widen_mulsrvvm8si */

        case 7:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9332; /* pred_dual_widen_mulsrvvm4si */

        case 8:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9338; /* pred_dual_widen_mulsrvvm2si */

        case 9:
          if (!
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9344; /* pred_dual_widen_mulsrvvm1si */

        case 10:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9350; /* pred_dual_widen_mulsrvvmf2si */

        case 11:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9356; /* pred_dual_widen_mulsrvvm8di */

        case 12:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9362; /* pred_dual_widen_mulsrvvm4di */

        case 13:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9368; /* pred_dual_widen_mulsrvvm2di */

        case 14:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9374; /* pred_dual_widen_mulsrvvm1di */

        case 15:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9380; /* pred_dual_widen_mulsv1hi */

        case 16:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9386; /* pred_dual_widen_mulsv2hi */

        case 17:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9392; /* pred_dual_widen_mulsv4hi */

        case 18:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9398; /* pred_dual_widen_mulsv8hi */

        case 19:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9404; /* pred_dual_widen_mulsv16hi */

        case 20:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9410; /* pred_dual_widen_mulsv32hi */

        case 21:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9416; /* pred_dual_widen_mulsv64hi */

        case 22:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9422; /* pred_dual_widen_mulsv128hi */

        case 23:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9428; /* pred_dual_widen_mulsv256hi */

        case 24:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9434; /* pred_dual_widen_mulsv512hi */

        case 25:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9440; /* pred_dual_widen_mulsv1024hi */

        case 26:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9446; /* pred_dual_widen_mulsv2048hi */

        case 27:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9452; /* pred_dual_widen_mulsv1si */

        case 28:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9458; /* pred_dual_widen_mulsv2si */

        case 29:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9464; /* pred_dual_widen_mulsv4si */

        case 30:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9470; /* pred_dual_widen_mulsv8si */

        case 31:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9476; /* pred_dual_widen_mulsv16si */

        case 32:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9482; /* pred_dual_widen_mulsv32si */

        case 33:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9488; /* pred_dual_widen_mulsv64si */

        case 34:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9494; /* pred_dual_widen_mulsv128si */

        case 35:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9500; /* pred_dual_widen_mulsv256si */

        case 36:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9506; /* pred_dual_widen_mulsv512si */

        case 37:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9512; /* pred_dual_widen_mulsv1024si */

        case 38:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9518; /* pred_dual_widen_mulsv1di */

        case 39:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9524; /* pred_dual_widen_mulsv2di */

        case 40:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9530; /* pred_dual_widen_mulsv4di */

        case 41:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9536; /* pred_dual_widen_mulsv8di */

        case 42:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9542; /* pred_dual_widen_mulsv16di */

        case 43:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9548; /* pred_dual_widen_mulsv32di */

        case 44:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9554; /* pred_dual_widen_mulsv64di */

        case 45:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9560; /* pred_dual_widen_mulsv128di */

        case 46:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9566; /* pred_dual_widen_mulsv256di */

        case 47:
          if (!(
#line 4001 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9572; /* pred_dual_widen_mulsv512di */

        case 48:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9578; /* pred_dual_widen_mulsrvvm8hi_scalar */

        case 49:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9584; /* pred_dual_widen_mulsrvvm4hi_scalar */

        case 50:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9590; /* pred_dual_widen_mulsrvvm2hi_scalar */

        case 51:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9596; /* pred_dual_widen_mulsrvvm1hi_scalar */

        case 52:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9602; /* pred_dual_widen_mulsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9608; /* pred_dual_widen_mulsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9614; /* pred_dual_widen_mulsrvvm8si_scalar */

        case 55:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9620; /* pred_dual_widen_mulsrvvm4si_scalar */

        case 56:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9626; /* pred_dual_widen_mulsrvvm2si_scalar */

        case 57:
          if (!
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9632; /* pred_dual_widen_mulsrvvm1si_scalar */

        case 58:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9638; /* pred_dual_widen_mulsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9644; /* pred_dual_widen_mulsrvvm8di_scalar */

        case 60:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9650; /* pred_dual_widen_mulsrvvm4di_scalar */

        case 61:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9656; /* pred_dual_widen_mulsrvvm2di_scalar */

        case 62:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9662; /* pred_dual_widen_mulsrvvm1di_scalar */

        case 63:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9668; /* pred_dual_widen_mulsv1hi_scalar */

        case 64:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9674; /* pred_dual_widen_mulsv2hi_scalar */

        case 65:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9680; /* pred_dual_widen_mulsv4hi_scalar */

        case 66:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9686; /* pred_dual_widen_mulsv8hi_scalar */

        case 67:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9692; /* pred_dual_widen_mulsv16hi_scalar */

        case 68:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9698; /* pred_dual_widen_mulsv32hi_scalar */

        case 69:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9704; /* pred_dual_widen_mulsv64hi_scalar */

        case 70:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9710; /* pred_dual_widen_mulsv128hi_scalar */

        case 71:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9716; /* pred_dual_widen_mulsv256hi_scalar */

        case 72:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9722; /* pred_dual_widen_mulsv512hi_scalar */

        case 73:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9728; /* pred_dual_widen_mulsv1024hi_scalar */

        case 74:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9734; /* pred_dual_widen_mulsv2048hi_scalar */

        case 75:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9740; /* pred_dual_widen_mulsv1si_scalar */

        case 76:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9746; /* pred_dual_widen_mulsv2si_scalar */

        case 77:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9752; /* pred_dual_widen_mulsv4si_scalar */

        case 78:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9758; /* pred_dual_widen_mulsv8si_scalar */

        case 79:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9764; /* pred_dual_widen_mulsv16si_scalar */

        case 80:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9770; /* pred_dual_widen_mulsv32si_scalar */

        case 81:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9776; /* pred_dual_widen_mulsv64si_scalar */

        case 82:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9782; /* pred_dual_widen_mulsv128si_scalar */

        case 83:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9788; /* pred_dual_widen_mulsv256si_scalar */

        case 84:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9794; /* pred_dual_widen_mulsv512si_scalar */

        case 85:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9800; /* pred_dual_widen_mulsv1024si_scalar */

        case 86:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9806; /* pred_dual_widen_mulsv1di_scalar */

        case 87:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9812; /* pred_dual_widen_mulsv2di_scalar */

        case 88:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9818; /* pred_dual_widen_mulsv4di_scalar */

        case 89:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9824; /* pred_dual_widen_mulsv8di_scalar */

        case 90:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9830; /* pred_dual_widen_mulsv16di_scalar */

        case 91:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9836; /* pred_dual_widen_mulsv32di_scalar */

        case 92:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9842; /* pred_dual_widen_mulsv64di_scalar */

        case 93:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9848; /* pred_dual_widen_mulsv128di_scalar */

        case 94:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9854; /* pred_dual_widen_mulsv256di_scalar */

        case 95:
          if (!(
#line 4024 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9860; /* pred_dual_widen_mulsv512di_scalar */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern530 (x2))
        {
        case 0:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10438; /* pred_widen_mulsurvvm8hi */

        case 1:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10439; /* pred_widen_mulsurvvm4hi */

        case 2:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10440; /* pred_widen_mulsurvvm2hi */

        case 3:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10441; /* pred_widen_mulsurvvm1hi */

        case 4:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10442; /* pred_widen_mulsurvvmf2hi */

        case 5:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10443; /* pred_widen_mulsurvvmf4hi */

        case 6:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10444; /* pred_widen_mulsurvvm8si */

        case 7:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10445; /* pred_widen_mulsurvvm4si */

        case 8:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10446; /* pred_widen_mulsurvvm2si */

        case 9:
          if (!
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10447; /* pred_widen_mulsurvvm1si */

        case 10:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10448; /* pred_widen_mulsurvvmf2si */

        case 11:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10449; /* pred_widen_mulsurvvm8di */

        case 12:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10450; /* pred_widen_mulsurvvm4di */

        case 13:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10451; /* pred_widen_mulsurvvm2di */

        case 14:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10452; /* pred_widen_mulsurvvm1di */

        case 15:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10453; /* pred_widen_mulsuv1hi */

        case 16:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10454; /* pred_widen_mulsuv2hi */

        case 17:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10455; /* pred_widen_mulsuv4hi */

        case 18:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10456; /* pred_widen_mulsuv8hi */

        case 19:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10457; /* pred_widen_mulsuv16hi */

        case 20:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10458; /* pred_widen_mulsuv32hi */

        case 21:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10459; /* pred_widen_mulsuv64hi */

        case 22:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10460; /* pred_widen_mulsuv128hi */

        case 23:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10461; /* pred_widen_mulsuv256hi */

        case 24:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10462; /* pred_widen_mulsuv512hi */

        case 25:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10463; /* pred_widen_mulsuv1024hi */

        case 26:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10464; /* pred_widen_mulsuv2048hi */

        case 27:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10465; /* pred_widen_mulsuv1si */

        case 28:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10466; /* pred_widen_mulsuv2si */

        case 29:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10467; /* pred_widen_mulsuv4si */

        case 30:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10468; /* pred_widen_mulsuv8si */

        case 31:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10469; /* pred_widen_mulsuv16si */

        case 32:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10470; /* pred_widen_mulsuv32si */

        case 33:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10471; /* pred_widen_mulsuv64si */

        case 34:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10472; /* pred_widen_mulsuv128si */

        case 35:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10473; /* pred_widen_mulsuv256si */

        case 36:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10474; /* pred_widen_mulsuv512si */

        case 37:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10475; /* pred_widen_mulsuv1024si */

        case 38:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10476; /* pred_widen_mulsuv1di */

        case 39:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10477; /* pred_widen_mulsuv2di */

        case 40:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10478; /* pred_widen_mulsuv4di */

        case 41:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10479; /* pred_widen_mulsuv8di */

        case 42:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10480; /* pred_widen_mulsuv16di */

        case 43:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10481; /* pred_widen_mulsuv32di */

        case 44:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10482; /* pred_widen_mulsuv64di */

        case 45:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10483; /* pred_widen_mulsuv128di */

        case 46:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10484; /* pred_widen_mulsuv256di */

        case 47:
          if (!(
#line 4156 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10485; /* pred_widen_mulsuv512di */

        case 48:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10486; /* pred_widen_mulsurvvm8hi_scalar */

        case 49:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10487; /* pred_widen_mulsurvvm4hi_scalar */

        case 50:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10488; /* pred_widen_mulsurvvm2hi_scalar */

        case 51:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10489; /* pred_widen_mulsurvvm1hi_scalar */

        case 52:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10490; /* pred_widen_mulsurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10491; /* pred_widen_mulsurvvmf4hi_scalar */

        case 54:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10492; /* pred_widen_mulsurvvm8si_scalar */

        case 55:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10493; /* pred_widen_mulsurvvm4si_scalar */

        case 56:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10494; /* pred_widen_mulsurvvm2si_scalar */

        case 57:
          if (!
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10495; /* pred_widen_mulsurvvm1si_scalar */

        case 58:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10496; /* pred_widen_mulsurvvmf2si_scalar */

        case 59:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10497; /* pred_widen_mulsurvvm8di_scalar */

        case 60:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10498; /* pred_widen_mulsurvvm4di_scalar */

        case 61:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10499; /* pred_widen_mulsurvvm2di_scalar */

        case 62:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10500; /* pred_widen_mulsurvvm1di_scalar */

        case 63:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10501; /* pred_widen_mulsuv1hi_scalar */

        case 64:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10502; /* pred_widen_mulsuv2hi_scalar */

        case 65:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10503; /* pred_widen_mulsuv4hi_scalar */

        case 66:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10504; /* pred_widen_mulsuv8hi_scalar */

        case 67:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10505; /* pred_widen_mulsuv16hi_scalar */

        case 68:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10506; /* pred_widen_mulsuv32hi_scalar */

        case 69:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10507; /* pred_widen_mulsuv64hi_scalar */

        case 70:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10508; /* pred_widen_mulsuv128hi_scalar */

        case 71:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10509; /* pred_widen_mulsuv256hi_scalar */

        case 72:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10510; /* pred_widen_mulsuv512hi_scalar */

        case 73:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10511; /* pred_widen_mulsuv1024hi_scalar */

        case 74:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10512; /* pred_widen_mulsuv2048hi_scalar */

        case 75:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10513; /* pred_widen_mulsuv1si_scalar */

        case 76:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10514; /* pred_widen_mulsuv2si_scalar */

        case 77:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10515; /* pred_widen_mulsuv4si_scalar */

        case 78:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10516; /* pred_widen_mulsuv8si_scalar */

        case 79:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10517; /* pred_widen_mulsuv16si_scalar */

        case 80:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10518; /* pred_widen_mulsuv32si_scalar */

        case 81:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10519; /* pred_widen_mulsuv64si_scalar */

        case 82:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10520; /* pred_widen_mulsuv128si_scalar */

        case 83:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10521; /* pred_widen_mulsuv256si_scalar */

        case 84:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10522; /* pred_widen_mulsuv512si_scalar */

        case 85:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10523; /* pred_widen_mulsuv1024si_scalar */

        case 86:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10524; /* pred_widen_mulsuv1di_scalar */

        case 87:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10525; /* pred_widen_mulsuv2di_scalar */

        case 88:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10526; /* pred_widen_mulsuv4di_scalar */

        case 89:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10527; /* pred_widen_mulsuv8di_scalar */

        case 90:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10528; /* pred_widen_mulsuv16di_scalar */

        case 91:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10529; /* pred_widen_mulsuv32di_scalar */

        case 92:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10530; /* pred_widen_mulsuv64di_scalar */

        case 93:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10531; /* pred_widen_mulsuv128di_scalar */

        case 94:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10532; /* pred_widen_mulsuv256di_scalar */

        case 95:
          if (!(
#line 4179 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10533; /* pred_widen_mulsuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_879 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_737 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern485 (x2))
            {
            case 0:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6842; /* pred_addrvvm8qi_scalar */

            case 1:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6851; /* pred_addrvvm4qi_scalar */

            case 2:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6860; /* pred_addrvvm2qi_scalar */

            case 3:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6869; /* pred_addrvvm1qi_scalar */

            case 4:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6878; /* pred_addrvvmf2qi_scalar */

            case 5:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6887; /* pred_addrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6896; /* pred_addrvvmf8qi_scalar */

            case 7:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6905; /* pred_addrvvm8hi_scalar */

            case 8:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6914; /* pred_addrvvm4hi_scalar */

            case 9:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6923; /* pred_addrvvm2hi_scalar */

            case 10:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6932; /* pred_addrvvm1hi_scalar */

            case 11:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6941; /* pred_addrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6950; /* pred_addrvvmf4hi_scalar */

            case 13:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6959; /* pred_addrvvm8si_scalar */

            case 14:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6968; /* pred_addrvvm4si_scalar */

            case 15:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6977; /* pred_addrvvm2si_scalar */

            case 16:
              if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6986; /* pred_addrvvm1si_scalar */

            case 17:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6995; /* pred_addrvvmf2si_scalar */

            case 18:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7004; /* pred_addv1qi_scalar */

            case 19:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7013; /* pred_addv2qi_scalar */

            case 20:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7022; /* pred_addv4qi_scalar */

            case 21:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7031; /* pred_addv8qi_scalar */

            case 22:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7040; /* pred_addv16qi_scalar */

            case 23:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7049; /* pred_addv32qi_scalar */

            case 24:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7058; /* pred_addv64qi_scalar */

            case 25:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7067; /* pred_addv128qi_scalar */

            case 26:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7076; /* pred_addv256qi_scalar */

            case 27:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7085; /* pred_addv512qi_scalar */

            case 28:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7094; /* pred_addv1024qi_scalar */

            case 29:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7103; /* pred_addv2048qi_scalar */

            case 30:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7112; /* pred_addv4096qi_scalar */

            case 31:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7121; /* pred_addv1hi_scalar */

            case 32:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7130; /* pred_addv2hi_scalar */

            case 33:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7139; /* pred_addv4hi_scalar */

            case 34:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7148; /* pred_addv8hi_scalar */

            case 35:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7157; /* pred_addv16hi_scalar */

            case 36:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7166; /* pred_addv32hi_scalar */

            case 37:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7175; /* pred_addv64hi_scalar */

            case 38:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7184; /* pred_addv128hi_scalar */

            case 39:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7193; /* pred_addv256hi_scalar */

            case 40:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7202; /* pred_addv512hi_scalar */

            case 41:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7211; /* pred_addv1024hi_scalar */

            case 42:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7220; /* pred_addv2048hi_scalar */

            case 43:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7229; /* pred_addv1si_scalar */

            case 44:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7238; /* pred_addv2si_scalar */

            case 45:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7247; /* pred_addv4si_scalar */

            case 46:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7256; /* pred_addv8si_scalar */

            case 47:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7265; /* pred_addv16si_scalar */

            case 48:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7274; /* pred_addv32si_scalar */

            case 49:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7283; /* pred_addv64si_scalar */

            case 50:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7292; /* pred_addv128si_scalar */

            case 51:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7301; /* pred_addv256si_scalar */

            case 52:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7310; /* pred_addv512si_scalar */

            case 53:
              if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7319; /* pred_addv1024si_scalar */

            case 54:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7652; /* *pred_addrvvm8di_scalar */

            case 55:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7661; /* *pred_addrvvm4di_scalar */

            case 56:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7670; /* *pred_addrvvm2di_scalar */

            case 57:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7679; /* *pred_addrvvm1di_scalar */

            case 58:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7688; /* *pred_addv1di_scalar */

            case 59:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7697; /* *pred_addv2di_scalar */

            case 60:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7706; /* *pred_addv4di_scalar */

            case 61:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7715; /* *pred_addv8di_scalar */

            case 62:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7724; /* *pred_addv16di_scalar */

            case 63:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7733; /* *pred_addv32di_scalar */

            case 64:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7742; /* *pred_addv64di_scalar */

            case 65:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7751; /* *pred_addv128di_scalar */

            case 66:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7760; /* *pred_addv256di_scalar */

            case 67:
              if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7769; /* *pred_addv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          return recog_592 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HImode:
              if (pattern686 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10247; /* pred_single_widen_addurvvm8hi_extended_scalar */

            case E_RVVM4HImode:
              if (pattern686 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10249; /* pred_single_widen_addurvvm4hi_extended_scalar */

            case E_RVVM2HImode:
              if (pattern686 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10251; /* pred_single_widen_addurvvm2hi_extended_scalar */

            case E_RVVM1HImode:
              if (pattern686 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10253; /* pred_single_widen_addurvvm1hi_extended_scalar */

            case E_RVVMF2HImode:
              if (pattern686 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10255; /* pred_single_widen_addurvvmf2hi_extended_scalar */

            case E_RVVMF4HImode:
              if (pattern686 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10257; /* pred_single_widen_addurvvmf4hi_extended_scalar */

            case E_RVVM8SImode:
              if (pattern686 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10259; /* pred_single_widen_addurvvm8si_extended_scalar */

            case E_RVVM4SImode:
              if (pattern686 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10261; /* pred_single_widen_addurvvm4si_extended_scalar */

            case E_RVVM2SImode:
              if (pattern686 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10263; /* pred_single_widen_addurvvm2si_extended_scalar */

            case E_RVVM1SImode:
              if (pattern686 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10265; /* pred_single_widen_addurvvm1si_extended_scalar */

            case E_RVVMF2SImode:
              if (pattern686 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10267; /* pred_single_widen_addurvvmf2si_extended_scalar */

            case E_RVVM8DImode:
              if (pattern686 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10269; /* pred_single_widen_addurvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern686 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10271; /* pred_single_widen_addurvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern686 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10273; /* pred_single_widen_addurvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern686 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10275; /* pred_single_widen_addurvvm1di_extended_scalar */

            case E_V1HImode:
              if (pattern686 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 10277; /* pred_single_widen_adduv1hi_extended_scalar */

            case E_V2HImode:
              if (pattern686 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 10279; /* pred_single_widen_adduv2hi_extended_scalar */

            case E_V4HImode:
              if (pattern686 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 10281; /* pred_single_widen_adduv4hi_extended_scalar */

            case E_V8HImode:
              if (pattern686 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 10283; /* pred_single_widen_adduv8hi_extended_scalar */

            case E_V16HImode:
              if (pattern686 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 10285; /* pred_single_widen_adduv16hi_extended_scalar */

            case E_V32HImode:
              if (pattern686 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10287; /* pred_single_widen_adduv32hi_extended_scalar */

            case E_V64HImode:
              if (pattern686 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10289; /* pred_single_widen_adduv64hi_extended_scalar */

            case E_V128HImode:
              if (pattern686 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10291; /* pred_single_widen_adduv128hi_extended_scalar */

            case E_V256HImode:
              if (pattern686 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10293; /* pred_single_widen_adduv256hi_extended_scalar */

            case E_V512HImode:
              if (pattern686 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10295; /* pred_single_widen_adduv512hi_extended_scalar */

            case E_V1024HImode:
              if (pattern686 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10297; /* pred_single_widen_adduv1024hi_extended_scalar */

            case E_V2048HImode:
              if (pattern686 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10299; /* pred_single_widen_adduv2048hi_extended_scalar */

            case E_V1SImode:
              if (pattern686 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 10301; /* pred_single_widen_adduv1si_extended_scalar */

            case E_V2SImode:
              if (pattern686 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 10303; /* pred_single_widen_adduv2si_extended_scalar */

            case E_V4SImode:
              if (pattern686 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 10305; /* pred_single_widen_adduv4si_extended_scalar */

            case E_V8SImode:
              if (pattern686 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 10307; /* pred_single_widen_adduv8si_extended_scalar */

            case E_V16SImode:
              if (pattern686 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10309; /* pred_single_widen_adduv16si_extended_scalar */

            case E_V32SImode:
              if (pattern686 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10311; /* pred_single_widen_adduv32si_extended_scalar */

            case E_V64SImode:
              if (pattern686 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10313; /* pred_single_widen_adduv64si_extended_scalar */

            case E_V128SImode:
              if (pattern686 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10315; /* pred_single_widen_adduv128si_extended_scalar */

            case E_V256SImode:
              if (pattern686 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10317; /* pred_single_widen_adduv256si_extended_scalar */

            case E_V512SImode:
              if (pattern686 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10319; /* pred_single_widen_adduv512si_extended_scalar */

            case E_V1024SImode:
              if (pattern686 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10321; /* pred_single_widen_adduv1024si_extended_scalar */

            case E_V1DImode:
              if (pattern686 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10323; /* pred_single_widen_adduv1di_extended_scalar */

            case E_V2DImode:
              if (pattern686 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10325; /* pred_single_widen_adduv2di_extended_scalar */

            case E_V4DImode:
              if (pattern686 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10327; /* pred_single_widen_adduv4di_extended_scalar */

            case E_V8DImode:
              if (pattern686 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10329; /* pred_single_widen_adduv8di_extended_scalar */

            case E_V16DImode:
              if (pattern686 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10331; /* pred_single_widen_adduv16di_extended_scalar */

            case E_V32DImode:
              if (pattern686 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10333; /* pred_single_widen_adduv32di_extended_scalar */

            case E_V64DImode:
              if (pattern686 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10335; /* pred_single_widen_adduv64di_extended_scalar */

            case E_V128DImode:
              if (pattern686 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10337; /* pred_single_widen_adduv128di_extended_scalar */

            case E_V256DImode:
              if (pattern686 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10339; /* pred_single_widen_adduv256di_extended_scalar */

            case E_V512DImode:
              if (pattern686 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10341; /* pred_single_widen_adduv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_735 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_734 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_736 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_888 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern495 (x2))
    {
    case 0:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5491; /* pred_umaxrvvm8qi */

    case 1:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5508; /* pred_umaxrvvm4qi */

    case 2:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5525; /* pred_umaxrvvm2qi */

    case 3:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5542; /* pred_umaxrvvm1qi */

    case 4:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5559; /* pred_umaxrvvm8hi */

    case 5:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5576; /* pred_umaxrvvm4hi */

    case 6:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5593; /* pred_umaxrvvm2hi */

    case 7:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5610; /* pred_umaxrvvm1hi */

    case 8:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5627; /* pred_umaxrvvm8si */

    case 9:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5644; /* pred_umaxrvvm4si */

    case 10:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5661; /* pred_umaxrvvm2si */

    case 11:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5678; /* pred_umaxrvvm1si */

    case 12:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5695; /* pred_umaxrvvm8di */

    case 13:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5712; /* pred_umaxrvvm4di */

    case 14:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5729; /* pred_umaxrvvm2di */

    case 15:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5746; /* pred_umaxrvvm1di */

    case 16:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5763; /* pred_umaxrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5780; /* pred_umaxrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5797; /* pred_umaxrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5814; /* pred_umaxrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5831; /* pred_umaxrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5848; /* pred_umaxrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5865; /* pred_umaxv1qi */

    case 23:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5882; /* pred_umaxv2qi */

    case 24:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5899; /* pred_umaxv4qi */

    case 25:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5916; /* pred_umaxv8qi */

    case 26:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5933; /* pred_umaxv16qi */

    case 27:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5950; /* pred_umaxv32qi */

    case 28:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5967; /* pred_umaxv64qi */

    case 29:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5984; /* pred_umaxv128qi */

    case 30:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6001; /* pred_umaxv256qi */

    case 31:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6018; /* pred_umaxv512qi */

    case 32:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6035; /* pred_umaxv1024qi */

    case 33:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6052; /* pred_umaxv2048qi */

    case 34:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6069; /* pred_umaxv4096qi */

    case 35:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6086; /* pred_umaxv1hi */

    case 36:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6103; /* pred_umaxv2hi */

    case 37:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6120; /* pred_umaxv4hi */

    case 38:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6137; /* pred_umaxv8hi */

    case 39:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6154; /* pred_umaxv16hi */

    case 40:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6171; /* pred_umaxv32hi */

    case 41:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6188; /* pred_umaxv64hi */

    case 42:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6205; /* pred_umaxv128hi */

    case 43:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6222; /* pred_umaxv256hi */

    case 44:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6239; /* pred_umaxv512hi */

    case 45:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6256; /* pred_umaxv1024hi */

    case 46:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6273; /* pred_umaxv2048hi */

    case 47:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6290; /* pred_umaxv1si */

    case 48:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6307; /* pred_umaxv2si */

    case 49:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6324; /* pred_umaxv4si */

    case 50:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6341; /* pred_umaxv8si */

    case 51:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6358; /* pred_umaxv16si */

    case 52:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6375; /* pred_umaxv32si */

    case 53:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6392; /* pred_umaxv64si */

    case 54:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6409; /* pred_umaxv128si */

    case 55:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6426; /* pred_umaxv256si */

    case 56:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6443; /* pred_umaxv512si */

    case 57:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6460; /* pred_umaxv1024si */

    case 58:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6477; /* pred_umaxv1di */

    case 59:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6494; /* pred_umaxv2di */

    case 60:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6511; /* pred_umaxv4di */

    case 61:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6528; /* pred_umaxv8di */

    case 62:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6545; /* pred_umaxv16di */

    case 63:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6562; /* pred_umaxv32di */

    case 64:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6579; /* pred_umaxv64di */

    case 65:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6596; /* pred_umaxv128di */

    case 66:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6613; /* pred_umaxv256di */

    case 67:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6630; /* pred_umaxv512di */

    case 68:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6847; /* pred_umaxrvvm8qi_scalar */

    case 69:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6856; /* pred_umaxrvvm4qi_scalar */

    case 70:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6865; /* pred_umaxrvvm2qi_scalar */

    case 71:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6874; /* pred_umaxrvvm1qi_scalar */

    case 72:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6883; /* pred_umaxrvvmf2qi_scalar */

    case 73:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6892; /* pred_umaxrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6901; /* pred_umaxrvvmf8qi_scalar */

    case 75:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6910; /* pred_umaxrvvm8hi_scalar */

    case 76:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6919; /* pred_umaxrvvm4hi_scalar */

    case 77:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6928; /* pred_umaxrvvm2hi_scalar */

    case 78:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6937; /* pred_umaxrvvm1hi_scalar */

    case 79:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6946; /* pred_umaxrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6955; /* pred_umaxrvvmf4hi_scalar */

    case 81:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6964; /* pred_umaxrvvm8si_scalar */

    case 82:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6973; /* pred_umaxrvvm4si_scalar */

    case 83:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6982; /* pred_umaxrvvm2si_scalar */

    case 84:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6991; /* pred_umaxrvvm1si_scalar */

    case 85:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7000; /* pred_umaxrvvmf2si_scalar */

    case 86:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7009; /* pred_umaxv1qi_scalar */

    case 87:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7018; /* pred_umaxv2qi_scalar */

    case 88:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7027; /* pred_umaxv4qi_scalar */

    case 89:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7036; /* pred_umaxv8qi_scalar */

    case 90:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7045; /* pred_umaxv16qi_scalar */

    case 91:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7054; /* pred_umaxv32qi_scalar */

    case 92:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7063; /* pred_umaxv64qi_scalar */

    case 93:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7072; /* pred_umaxv128qi_scalar */

    case 94:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7081; /* pred_umaxv256qi_scalar */

    case 95:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7090; /* pred_umaxv512qi_scalar */

    case 96:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7099; /* pred_umaxv1024qi_scalar */

    case 97:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7108; /* pred_umaxv2048qi_scalar */

    case 98:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7117; /* pred_umaxv4096qi_scalar */

    case 99:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7126; /* pred_umaxv1hi_scalar */

    case 100:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7135; /* pred_umaxv2hi_scalar */

    case 101:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7144; /* pred_umaxv4hi_scalar */

    case 102:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7153; /* pred_umaxv8hi_scalar */

    case 103:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7162; /* pred_umaxv16hi_scalar */

    case 104:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7171; /* pred_umaxv32hi_scalar */

    case 105:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7180; /* pred_umaxv64hi_scalar */

    case 106:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7189; /* pred_umaxv128hi_scalar */

    case 107:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7198; /* pred_umaxv256hi_scalar */

    case 108:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7207; /* pred_umaxv512hi_scalar */

    case 109:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7216; /* pred_umaxv1024hi_scalar */

    case 110:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7225; /* pred_umaxv2048hi_scalar */

    case 111:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7234; /* pred_umaxv1si_scalar */

    case 112:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7243; /* pred_umaxv2si_scalar */

    case 113:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7252; /* pred_umaxv4si_scalar */

    case 114:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7261; /* pred_umaxv8si_scalar */

    case 115:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7270; /* pred_umaxv16si_scalar */

    case 116:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7279; /* pred_umaxv32si_scalar */

    case 117:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7288; /* pred_umaxv64si_scalar */

    case 118:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7297; /* pred_umaxv128si_scalar */

    case 119:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7306; /* pred_umaxv256si_scalar */

    case 120:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7315; /* pred_umaxv512si_scalar */

    case 121:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7324; /* pred_umaxv1024si_scalar */

    case 122:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7657; /* *pred_umaxrvvm8di_scalar */

    case 123:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7666; /* *pred_umaxrvvm4di_scalar */

    case 124:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7675; /* *pred_umaxrvvm2di_scalar */

    case 125:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7684; /* *pred_umaxrvvm1di_scalar */

    case 126:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7693; /* *pred_umaxv1di_scalar */

    case 127:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7702; /* *pred_umaxv2di_scalar */

    case 128:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7711; /* *pred_umaxv4di_scalar */

    case 129:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7720; /* *pred_umaxv8di_scalar */

    case 130:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7729; /* *pred_umaxv16di_scalar */

    case 131:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7738; /* *pred_umaxv32di_scalar */

    case 132:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7747; /* *pred_umaxv64di_scalar */

    case 133:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7756; /* *pred_umaxv128di_scalar */

    case 134:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7765; /* *pred_umaxv256di_scalar */

    case 135:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7774; /* *pred_umaxv512di_scalar */

    case 136:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7783; /* *pred_umaxrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7792; /* *pred_umaxrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7801; /* *pred_umaxrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7810; /* *pred_umaxrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7819; /* *pred_umaxv1di_extended_scalar */

    case 141:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7828; /* *pred_umaxv2di_extended_scalar */

    case 142:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7837; /* *pred_umaxv4di_extended_scalar */

    case 143:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7846; /* *pred_umaxv8di_extended_scalar */

    case 144:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7855; /* *pred_umaxv16di_extended_scalar */

    case 145:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7864; /* *pred_umaxv32di_extended_scalar */

    case 146:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7873; /* *pred_umaxv64di_extended_scalar */

    case 147:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7882; /* *pred_umaxv128di_extended_scalar */

    case 148:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7891; /* *pred_umaxv256di_extended_scalar */

    case 149:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7900; /* *pred_umaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_900 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern501 (x2))
    {
    case 0:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9103; /* pred_zero_extendrvvm8hi_vf2 */

    case 1:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9105; /* pred_zero_extendrvvm4hi_vf2 */

    case 2:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9107; /* pred_zero_extendrvvm2hi_vf2 */

    case 3:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9109; /* pred_zero_extendrvvm1hi_vf2 */

    case 4:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9111; /* pred_zero_extendrvvmf2hi_vf2 */

    case 5:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9113; /* pred_zero_extendrvvmf4hi_vf2 */

    case 6:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9115; /* pred_zero_extendrvvm8si_vf2 */

    case 7:
      if (!
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9199; /* pred_zero_extendrvvm8si_vf4 */

    case 8:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9117; /* pred_zero_extendrvvm4si_vf2 */

    case 9:
      if (!
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9201; /* pred_zero_extendrvvm4si_vf4 */

    case 10:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9119; /* pred_zero_extendrvvm2si_vf2 */

    case 11:
      if (!
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9203; /* pred_zero_extendrvvm2si_vf4 */

    case 12:
      if (!
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9121; /* pred_zero_extendrvvm1si_vf2 */

    case 13:
      if (!
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9205; /* pred_zero_extendrvvm1si_vf4 */

    case 14:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9123; /* pred_zero_extendrvvmf2si_vf2 */

    case 15:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9207; /* pred_zero_extendrvvmf2si_vf4 */

    case 16:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9125; /* pred_zero_extendrvvm8di_vf2 */

    case 17:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9209; /* pred_zero_extendrvvm8di_vf4 */

    case 18:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9259; /* pred_zero_extendrvvm8di_vf8 */

    case 19:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9127; /* pred_zero_extendrvvm4di_vf2 */

    case 20:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9211; /* pred_zero_extendrvvm4di_vf4 */

    case 21:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9261; /* pred_zero_extendrvvm4di_vf8 */

    case 22:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9129; /* pred_zero_extendrvvm2di_vf2 */

    case 23:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9213; /* pred_zero_extendrvvm2di_vf4 */

    case 24:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9263; /* pred_zero_extendrvvm2di_vf8 */

    case 25:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9131; /* pred_zero_extendrvvm1di_vf2 */

    case 26:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9215; /* pred_zero_extendrvvm1di_vf4 */

    case 27:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9265; /* pred_zero_extendrvvm1di_vf8 */

    case 28:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9133; /* pred_zero_extendv1hi_vf2 */

    case 29:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9135; /* pred_zero_extendv2hi_vf2 */

    case 30:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9137; /* pred_zero_extendv4hi_vf2 */

    case 31:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9139; /* pred_zero_extendv8hi_vf2 */

    case 32:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9141; /* pred_zero_extendv16hi_vf2 */

    case 33:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9143; /* pred_zero_extendv32hi_vf2 */

    case 34:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9145; /* pred_zero_extendv64hi_vf2 */

    case 35:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9147; /* pred_zero_extendv128hi_vf2 */

    case 36:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9149; /* pred_zero_extendv256hi_vf2 */

    case 37:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9151; /* pred_zero_extendv512hi_vf2 */

    case 38:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9153; /* pred_zero_extendv1024hi_vf2 */

    case 39:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9155; /* pred_zero_extendv2048hi_vf2 */

    case 40:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9157; /* pred_zero_extendv1si_vf2 */

    case 41:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9217; /* pred_zero_extendv1si_vf4 */

    case 42:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9159; /* pred_zero_extendv2si_vf2 */

    case 43:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9219; /* pred_zero_extendv2si_vf4 */

    case 44:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9161; /* pred_zero_extendv4si_vf2 */

    case 45:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9221; /* pred_zero_extendv4si_vf4 */

    case 46:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9163; /* pred_zero_extendv8si_vf2 */

    case 47:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9223; /* pred_zero_extendv8si_vf4 */

    case 48:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9165; /* pred_zero_extendv16si_vf2 */

    case 49:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9225; /* pred_zero_extendv16si_vf4 */

    case 50:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9167; /* pred_zero_extendv32si_vf2 */

    case 51:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9227; /* pred_zero_extendv32si_vf4 */

    case 52:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9169; /* pred_zero_extendv64si_vf2 */

    case 53:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9229; /* pred_zero_extendv64si_vf4 */

    case 54:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9171; /* pred_zero_extendv128si_vf2 */

    case 55:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9231; /* pred_zero_extendv128si_vf4 */

    case 56:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9173; /* pred_zero_extendv256si_vf2 */

    case 57:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9233; /* pred_zero_extendv256si_vf4 */

    case 58:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9175; /* pred_zero_extendv512si_vf2 */

    case 59:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9235; /* pred_zero_extendv512si_vf4 */

    case 60:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9177; /* pred_zero_extendv1024si_vf2 */

    case 61:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9237; /* pred_zero_extendv1024si_vf4 */

    case 62:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9179; /* pred_zero_extendv1di_vf2 */

    case 63:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9239; /* pred_zero_extendv1di_vf4 */

    case 64:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1140 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9267; /* pred_zero_extendv1di_vf8 */

    case 65:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9181; /* pred_zero_extendv2di_vf2 */

    case 66:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9241; /* pred_zero_extendv2di_vf4 */

    case 67:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1141 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9269; /* pred_zero_extendv2di_vf8 */

    case 68:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9183; /* pred_zero_extendv4di_vf2 */

    case 69:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9243; /* pred_zero_extendv4di_vf4 */

    case 70:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1142 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9271; /* pred_zero_extendv4di_vf8 */

    case 71:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9185; /* pred_zero_extendv8di_vf2 */

    case 72:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9245; /* pred_zero_extendv8di_vf4 */

    case 73:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1143 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9273; /* pred_zero_extendv8di_vf8 */

    case 74:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9187; /* pred_zero_extendv16di_vf2 */

    case 75:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9247; /* pred_zero_extendv16di_vf4 */

    case 76:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1144 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9275; /* pred_zero_extendv16di_vf8 */

    case 77:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9189; /* pred_zero_extendv32di_vf2 */

    case 78:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9249; /* pred_zero_extendv32di_vf4 */

    case 79:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1145 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9277; /* pred_zero_extendv32di_vf8 */

    case 80:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9191; /* pred_zero_extendv64di_vf2 */

    case 81:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9251; /* pred_zero_extendv64di_vf4 */

    case 82:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1146 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9279; /* pred_zero_extendv64di_vf8 */

    case 83:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9193; /* pred_zero_extendv128di_vf2 */

    case 84:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9253; /* pred_zero_extendv128di_vf4 */

    case 85:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1147 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9281; /* pred_zero_extendv128di_vf8 */

    case 86:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9195; /* pred_zero_extendv256di_vf2 */

    case 87:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9255; /* pred_zero_extendv256di_vf4 */

    case 88:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1148 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9283; /* pred_zero_extendv256di_vf8 */

    case 89:
      if (!(
#line 3938 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9197; /* pred_zero_extendv512di_vf2 */

    case 90:
      if (!(
#line 3958 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9257; /* pred_zero_extendv512di_vf4 */

    case 91:
      if (!(
#line 3978 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1149 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9285; /* pred_zero_extendv512di_vf8 */

    default:
      return -1;
    }
}

 int
recog_910 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern470 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1237; /* *pred_mov_widthburvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1243; /* *pred_mov_widthburvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1249; /* *pred_mov_widthburvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1255; /* *pred_mov_widthburvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1261; /* *pred_mov_widthburvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1267; /* *pred_mov_widthburvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1273; /* *pred_mov_widthburvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1279; /* *pred_mov_widthburvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1285; /* *pred_mov_widthburvvm8si */

    case 9:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1291; /* *pred_mov_widthburvvm4si */

    case 10:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1297; /* *pred_mov_widthburvvm2si */

    case 11:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1303; /* *pred_mov_widthburvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1309; /* *pred_mov_widthburvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1315; /* *pred_mov_widthburvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1321; /* *pred_mov_widthburvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1327; /* *pred_mov_widthburvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1333; /* *pred_mov_widthburvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1339; /* *pred_mov_widthburvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1345; /* *pred_mov_widthburvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1351; /* *pred_mov_widthburvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1357; /* *pred_mov_widthburvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1363; /* *pred_mov_widthburvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1369; /* *pred_mov_widthburvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1375; /* *pred_mov_widthburvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1381; /* *pred_mov_widthburvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1387; /* *pred_mov_widthburvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1393; /* *pred_mov_widthburvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1399; /* *pred_mov_widthburvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1405; /* *pred_mov_widthburvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1411; /* *pred_mov_widthburvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1417; /* *pred_mov_widthburvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1423; /* *pred_mov_widthburvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1429; /* *pred_mov_widthburvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1435; /* *pred_mov_widthburvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1441; /* *pred_mov_widthburvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1447; /* *pred_mov_widthburvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1453; /* *pred_mov_widthburvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1459; /* *pred_mov_widthburvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1465; /* *pred_mov_widthburvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1471; /* *pred_mov_widthburvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1477; /* *pred_mov_widthburvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1483; /* *pred_mov_widthburvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1489; /* *pred_mov_widthburvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1495; /* *pred_mov_widthbuv1qi */

    case 44:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1501; /* *pred_mov_widthbuv2qi */

    case 45:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1507; /* *pred_mov_widthbuv4qi */

    case 46:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1513; /* *pred_mov_widthbuv8qi */

    case 47:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1519; /* *pred_mov_widthbuv16qi */

    case 48:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1525; /* *pred_mov_widthbuv32qi */

    case 49:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1531; /* *pred_mov_widthbuv64qi */

    case 50:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1537; /* *pred_mov_widthbuv128qi */

    case 51:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1543; /* *pred_mov_widthbuv256qi */

    case 52:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1549; /* *pred_mov_widthbuv512qi */

    case 53:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1555; /* *pred_mov_widthbuv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1561; /* *pred_mov_widthbuv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1567; /* *pred_mov_widthbuv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1573; /* *pred_mov_widthbuv1hi */

    case 57:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1579; /* *pred_mov_widthbuv2hi */

    case 58:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1585; /* *pred_mov_widthbuv4hi */

    case 59:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1591; /* *pred_mov_widthbuv8hi */

    case 60:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1597; /* *pred_mov_widthbuv16hi */

    case 61:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1603; /* *pred_mov_widthbuv32hi */

    case 62:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1609; /* *pred_mov_widthbuv64hi */

    case 63:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1615; /* *pred_mov_widthbuv128hi */

    case 64:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1621; /* *pred_mov_widthbuv256hi */

    case 65:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1627; /* *pred_mov_widthbuv512hi */

    case 66:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1633; /* *pred_mov_widthbuv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1639; /* *pred_mov_widthbuv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1645; /* *pred_mov_widthbuv1si */

    case 69:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1651; /* *pred_mov_widthbuv2si */

    case 70:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1657; /* *pred_mov_widthbuv4si */

    case 71:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1663; /* *pred_mov_widthbuv8si */

    case 72:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1669; /* *pred_mov_widthbuv16si */

    case 73:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1675; /* *pred_mov_widthbuv32si */

    case 74:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1681; /* *pred_mov_widthbuv64si */

    case 75:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1687; /* *pred_mov_widthbuv128si */

    case 76:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1693; /* *pred_mov_widthbuv256si */

    case 77:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1699; /* *pred_mov_widthbuv512si */

    case 78:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1705; /* *pred_mov_widthbuv1024si */

    case 79:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1711; /* *pred_mov_widthbuv1di */

    case 80:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1717; /* *pred_mov_widthbuv2di */

    case 81:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1723; /* *pred_mov_widthbuv4di */

    case 82:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1729; /* *pred_mov_widthbuv8di */

    case 83:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1735; /* *pred_mov_widthbuv16di */

    case 84:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1741; /* *pred_mov_widthbuv32di */

    case 85:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1747; /* *pred_mov_widthbuv64di */

    case 86:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1753; /* *pred_mov_widthbuv128di */

    case 87:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1759; /* *pred_mov_widthbuv256di */

    case 88:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1765; /* *pred_mov_widthbuv512di */

    case 89:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1771; /* *pred_mov_widthbuv1hf */

    case 90:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1777; /* *pred_mov_widthbuv2hf */

    case 91:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1783; /* *pred_mov_widthbuv4hf */

    case 92:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1789; /* *pred_mov_widthbuv8hf */

    case 93:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1795; /* *pred_mov_widthbuv16hf */

    case 94:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1801; /* *pred_mov_widthbuv32hf */

    case 95:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1807; /* *pred_mov_widthbuv64hf */

    case 96:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1813; /* *pred_mov_widthbuv128hf */

    case 97:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1819; /* *pred_mov_widthbuv256hf */

    case 98:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1825; /* *pred_mov_widthbuv512hf */

    case 99:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1831; /* *pred_mov_widthbuv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1837; /* *pred_mov_widthbuv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1843; /* *pred_mov_widthbuv1sf */

    case 102:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1849; /* *pred_mov_widthbuv2sf */

    case 103:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1855; /* *pred_mov_widthbuv4sf */

    case 104:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1861; /* *pred_mov_widthbuv8sf */

    case 105:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1867; /* *pred_mov_widthbuv16sf */

    case 106:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1873; /* *pred_mov_widthbuv32sf */

    case 107:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1879; /* *pred_mov_widthbuv64sf */

    case 108:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1885; /* *pred_mov_widthbuv128sf */

    case 109:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1891; /* *pred_mov_widthbuv256sf */

    case 110:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1897; /* *pred_mov_widthbuv512sf */

    case 111:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1903; /* *pred_mov_widthbuv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1909; /* *pred_mov_widthbuv1df */

    case 113:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1915; /* *pred_mov_widthbuv2df */

    case 114:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1921; /* *pred_mov_widthbuv4df */

    case 115:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1927; /* *pred_mov_widthbuv8df */

    case 116:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1933; /* *pred_mov_widthbuv16df */

    case 117:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1939; /* *pred_mov_widthbuv32df */

    case 118:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1945; /* *pred_mov_widthbuv64df */

    case 119:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1951; /* *pred_mov_widthbuv128df */

    case 120:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1957; /* *pred_mov_widthbuv256df */

    case 121:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1963; /* *pred_mov_widthbuv512df */

    default:
      return -1;
    }
}

 int
recog_931 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15255; /* *pred_mul_addrvvm2sf_undef */
}

 int
recog_936 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15265; /* *pred_mul_addrvvm2df_undef */
}

 int
recog_941 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15275; /* *pred_mul_addv8hf_undef */
}

 int
recog_946 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15285; /* *pred_mul_addv256hf_undef */
}

 int
recog_951 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15295; /* *pred_mul_addv2sf_undef */
}

 int
recog_956 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15305; /* *pred_mul_addv64sf_undef */
}

 int
recog_961 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15315; /* *pred_mul_addv1df_undef */
}

 int
recog_966 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15325; /* *pred_mul_addv32df_undef */
}

 int
recog_971 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16756; /* pred_widen_mul_addrvvmf2sf_scalar */

    case E_RVVMF4BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVMF4BFmode)
          || !(
#line 130 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 25 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 32728; /* pred_widen_bf16_mul_rvvmf2sf_scalar */

    default:
      return -1;
    }
}

 int
recog_976 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16696; /* pred_widen_mul_addrvvmf2sf */

    case E_RVVMF4BFmode:
      if (!register_operand (operands[3], E_RVVMF4BFmode)
          || !register_operand (operands[4], E_RVVMF4BFmode)
          || !(
#line 101 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 25 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 32723; /* pred_widen_bf16_mul_rvvmf2sf */

    default:
      return -1;
    }
}

 int
recog_981 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_970 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15429; /* *pred_maddv512df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15525; /* *pred_maccv512df */
}

 int
recog_986 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_965 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 15419; /* *pred_maddv16df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15515; /* *pred_maccv16df */
}

 int
recog_991 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_960 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15409; /* *pred_maddv1024sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15505; /* *pred_maccv1024sf */
}

 int
recog_996 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_955 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 15399; /* *pred_maddv32sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15495; /* *pred_maccv32sf */
}

 int
recog_1001 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_950 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15389; /* *pred_maddv1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15485; /* *pred_maccv1sf */
}

 int
recog_1006 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_945 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15379; /* *pred_maddv128hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15475; /* *pred_maccv128hf */
}

 int
recog_1012 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_939 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15367; /* *pred_maddv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15463; /* *pred_maccv2hf */
}

 int
recog_1018 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_933 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15355; /* *pred_maddrvvmf2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15451; /* *pred_maccrvvmf2sf */
}

 int
recog_1024 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_927 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15343; /* *pred_maddrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15439; /* *pred_maccrvvmf2hf */
}

 int
recog_1031 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15723; /* *pred_mul_neg_addrvvm2hf_undef */
}

 int
recog_1040 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15741; /* *pred_mul_neg_addrvvm8df_undef */
}

 int
recog_1049 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15759; /* *pred_mul_neg_addv32hf_undef */
}

 int
recog_1059 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15779; /* *pred_mul_neg_addv8sf_undef */
}

 int
recog_1069 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15799; /* *pred_mul_neg_addv4df_undef */
}

 int
recog_1079 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1074 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15905; /* *pred_nmsubv128df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 16001; /* *pred_nmsacv128df */
}

 int
recog_1089 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1064 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 15885; /* *pred_nmsubv256sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15981; /* *pred_nmsacv256sf */
}

 int
recog_1099 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1054 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15865; /* *pred_nmsubv1024hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15961; /* *pred_nmsacv1024hf */
}

 int
recog_1109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1044 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15845; /* *pred_nmsubv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15941; /* *pred_nmsacv1hf */
}

 int
recog_1119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1034 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return 15825; /* *pred_nmsubrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15921; /* *pred_nmsacrvvmf4hf */
}

 int
recog_1130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15244; /* *pred_mul_subrvvm2hf_undef */
}

 int
recog_1137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15258; /* *pred_mul_subrvvm1sf_undef */
}

 int
recog_1144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15272; /* *pred_mul_subv2hf_undef */
}

 int
recog_1151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15286; /* *pred_mul_subv256hf_undef */
}

 int
recog_1158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15300; /* *pred_mul_subv8sf_undef */
}

 int
recog_1165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15314; /* *pred_mul_subv1024sf_undef */
}

 int
recog_1172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15328; /* *pred_mul_subv64df_undef */
}

 int
recog_1179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1172 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15424; /* *pred_msubv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15520; /* *pred_msacv64df */
}

 int
recog_1186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1165 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15410; /* *pred_msubv1024sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15506; /* *pred_msacv1024sf */
}

 int
recog_1193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1158 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15396; /* *pred_msubv8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15492; /* *pred_msacv8sf */
}

 int
recog_1200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1151 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15382; /* *pred_msubv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15478; /* *pred_msacv256hf */
}

 int
recog_1207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1144 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15368; /* *pred_msubv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15464; /* *pred_msacv2hf */
}

 int
recog_1214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1137 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15354; /* *pred_msubrvvm1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15450; /* *pred_msacrvvm1sf */
}

 int
recog_1220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1131 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15342; /* *pred_msubrvvm1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15438; /* *pred_msacrvvm1hf */
}

 int
recog_1228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15728; /* *pred_mul_neg_subrvvmf2hf_undef */
}

 int
recog_1235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15742; /* *pred_mul_neg_subrvvm8df_undef */
}

 int
recog_1241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15754; /* *pred_mul_neg_subv4hf_undef */
}

 int
recog_1248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15768; /* *pred_mul_neg_subv512hf_undef */
}

 int
recog_1255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15782; /* *pred_mul_neg_subv16sf_undef */
}

 int
recog_1262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15796; /* *pred_mul_neg_subv1df_undef */
}

 int
recog_1269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15810; /* *pred_mul_neg_subv128df_undef */
}

 int
recog_1276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1267 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15902; /* *pred_nmaddv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15998; /* *pred_nmaccv32df */
}

 int
recog_1283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1260 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15888; /* *pred_nmaddv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15984; /* *pred_nmaccv512sf */
}

 int
recog_1290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1253 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15874; /* *pred_nmaddv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15970; /* *pred_nmaccv4sf */
}

 int
recog_1298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1245 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15858; /* *pred_nmaddv64hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15954; /* *pred_nmaccv64hf */
}

 int
recog_1306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1237 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15842; /* *pred_nmaddrvvm2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15938; /* *pred_nmaccrvvm2df */
}

 int
recog_1314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1229 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return 15826; /* *pred_nmaddrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15922; /* *pred_nmaccrvvmf4hf */
}

 int
recog_1324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[5] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[6] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[7] = x8;
  x9 = XVECEXP (x4, 0, 5);
  operands[8] = x9;
  x10 = XVECEXP (x3, 0, 0);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  switch (XINT (x3, 1))
    {
    case 119:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern599 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16358; /* pred_rec7rvvm8hf */

        case E_RVVM4HFmode:
          if (pattern599 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16359; /* pred_rec7rvvm4hf */

        case E_RVVM2HFmode:
          if (pattern599 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16360; /* pred_rec7rvvm2hf */

        case E_RVVM1HFmode:
          if (pattern599 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16361; /* pred_rec7rvvm1hf */

        case E_RVVMF2HFmode:
          if (pattern599 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16362; /* pred_rec7rvvmf2hf */

        case E_RVVMF4HFmode:
          if (pattern599 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16363; /* pred_rec7rvvmf4hf */

        case E_RVVM8SFmode:
          if (pattern599 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16364; /* pred_rec7rvvm8sf */

        case E_RVVM4SFmode:
          if (pattern599 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16365; /* pred_rec7rvvm4sf */

        case E_RVVM2SFmode:
          if (pattern599 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16366; /* pred_rec7rvvm2sf */

        case E_RVVM1SFmode:
          if (pattern599 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16367; /* pred_rec7rvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern599 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16368; /* pred_rec7rvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern599 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16369; /* pred_rec7rvvm8df */

        case E_RVVM4DFmode:
          if (pattern599 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16370; /* pred_rec7rvvm4df */

        case E_RVVM2DFmode:
          if (pattern599 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16371; /* pred_rec7rvvm2df */

        case E_RVVM1DFmode:
          if (pattern599 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6973 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16372; /* pred_rec7rvvm1df */

        default:
          return -1;
        }

    case 123:
      switch (pattern725 (x2))
        {
        case 0:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17264; /* pred_fcvt_x_frvvm8hf */

        case 1:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17266; /* pred_fcvt_x_frvvm4hf */

        case 2:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17810; /* pred_narrow_fcvt_x_frvvm8sf */

        case 3:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17268; /* pred_fcvt_x_frvvm2hf */

        case 4:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17812; /* pred_narrow_fcvt_x_frvvm4sf */

        case 5:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17270; /* pred_fcvt_x_frvvm1hf */

        case 6:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17814; /* pred_narrow_fcvt_x_frvvm2sf */

        case 7:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17272; /* pred_fcvt_x_frvvmf2hf */

        case 8:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17816; /* pred_narrow_fcvt_x_frvvm1sf */

        case 9:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17274; /* pred_fcvt_x_frvvmf4hf */

        case 10:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17818; /* pred_narrow_fcvt_x_frvvmf2sf */

        case 11:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17276; /* pred_fcvt_x_frvvm8sf */

        case 12:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17552; /* pred_widen_fcvt_x_frvvm8si */

        case 13:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17278; /* pred_fcvt_x_frvvm4sf */

        case 14:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17554; /* pred_widen_fcvt_x_frvvm4si */

        case 15:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17820; /* pred_narrow_fcvt_x_frvvm8df */

        case 16:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17280; /* pred_fcvt_x_frvvm2sf */

        case 17:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17556; /* pred_widen_fcvt_x_frvvm2si */

        case 18:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17822; /* pred_narrow_fcvt_x_frvvm4df */

        case 19:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17282; /* pred_fcvt_x_frvvm1sf */

        case 20:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17558; /* pred_widen_fcvt_x_frvvm1si */

        case 21:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17824; /* pred_narrow_fcvt_x_frvvm2df */

        case 22:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17284; /* pred_fcvt_x_frvvmf2sf */

        case 23:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17560; /* pred_widen_fcvt_x_frvvmf2si */

        case 24:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17826; /* pred_narrow_fcvt_x_frvvm1df */

        case 25:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17286; /* pred_fcvt_x_frvvm8df */

        case 26:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17562; /* pred_widen_fcvt_x_frvvm8di */

        case 27:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17288; /* pred_fcvt_x_frvvm4df */

        case 28:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17564; /* pred_widen_fcvt_x_frvvm4di */

        case 29:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17290; /* pred_fcvt_x_frvvm2df */

        case 30:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17566; /* pred_widen_fcvt_x_frvvm2di */

        case 31:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17292; /* pred_fcvt_x_frvvm1df */

        case 32:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17568; /* pred_widen_fcvt_x_frvvm1di */

        case 33:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17294; /* pred_fcvt_x_fv1hf */

        case 34:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17852; /* pred_narrow_fcvt_x_fv1sf */

        case 35:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17296; /* pred_fcvt_x_fv2hf */

        case 36:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17854; /* pred_narrow_fcvt_x_fv2sf */

        case 37:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17298; /* pred_fcvt_x_fv4hf */

        case 38:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17856; /* pred_narrow_fcvt_x_fv4sf */

        case 39:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 17300; /* pred_fcvt_x_fv8hf */

        case 40:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17858; /* pred_narrow_fcvt_x_fv8sf */

        case 41:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 17302; /* pred_fcvt_x_fv16hf */

        case 42:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17860; /* pred_narrow_fcvt_x_fv16sf */

        case 43:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17304; /* pred_fcvt_x_fv32hf */

        case 44:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17862; /* pred_narrow_fcvt_x_fv32sf */

        case 45:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17306; /* pred_fcvt_x_fv64hf */

        case 46:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17864; /* pred_narrow_fcvt_x_fv64sf */

        case 47:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17308; /* pred_fcvt_x_fv128hf */

        case 48:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17866; /* pred_narrow_fcvt_x_fv128sf */

        case 49:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17310; /* pred_fcvt_x_fv256hf */

        case 50:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17868; /* pred_narrow_fcvt_x_fv256sf */

        case 51:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17312; /* pred_fcvt_x_fv512hf */

        case 52:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17870; /* pred_narrow_fcvt_x_fv512sf */

        case 53:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17314; /* pred_fcvt_x_fv1024hf */

        case 54:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17872; /* pred_narrow_fcvt_x_fv1024sf */

        case 55:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17316; /* pred_fcvt_x_fv2048hf */

        case 56:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17318; /* pred_fcvt_x_fv1sf */

        case 57:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
            return -1;
          return 17570; /* pred_widen_fcvt_x_fv1si */

        case 58:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17874; /* pred_narrow_fcvt_x_fv1df */

        case 59:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17320; /* pred_fcvt_x_fv2sf */

        case 60:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
            return -1;
          return 17572; /* pred_widen_fcvt_x_fv2si */

        case 61:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17876; /* pred_narrow_fcvt_x_fv2df */

        case 62:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17322; /* pred_fcvt_x_fv4sf */

        case 63:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
            return -1;
          return 17574; /* pred_widen_fcvt_x_fv4si */

        case 64:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17878; /* pred_narrow_fcvt_x_fv4df */

        case 65:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17324; /* pred_fcvt_x_fv8sf */

        case 66:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
            return -1;
          return 17576; /* pred_widen_fcvt_x_fv8si */

        case 67:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17880; /* pred_narrow_fcvt_x_fv8df */

        case 68:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17326; /* pred_fcvt_x_fv16sf */

        case 69:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17578; /* pred_widen_fcvt_x_fv16si */

        case 70:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17882; /* pred_narrow_fcvt_x_fv16df */

        case 71:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17328; /* pred_fcvt_x_fv32sf */

        case 72:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17580; /* pred_widen_fcvt_x_fv32si */

        case 73:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17884; /* pred_narrow_fcvt_x_fv32df */

        case 74:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17330; /* pred_fcvt_x_fv64sf */

        case 75:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17582; /* pred_widen_fcvt_x_fv64si */

        case 76:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17886; /* pred_narrow_fcvt_x_fv64df */

        case 77:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17332; /* pred_fcvt_x_fv128sf */

        case 78:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17584; /* pred_widen_fcvt_x_fv128si */

        case 79:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17888; /* pred_narrow_fcvt_x_fv128df */

        case 80:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17334; /* pred_fcvt_x_fv256sf */

        case 81:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17586; /* pred_widen_fcvt_x_fv256si */

        case 82:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17890; /* pred_narrow_fcvt_x_fv256df */

        case 83:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17336; /* pred_fcvt_x_fv512sf */

        case 84:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17588; /* pred_widen_fcvt_x_fv512si */

        case 85:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17892; /* pred_narrow_fcvt_x_fv512df */

        case 86:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17338; /* pred_fcvt_x_fv1024sf */

        case 87:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17590; /* pred_widen_fcvt_x_fv1024si */

        case 88:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17340; /* pred_fcvt_x_fv1df */

        case 89:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17592; /* pred_widen_fcvt_x_fv1di */

        case 90:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17342; /* pred_fcvt_x_fv2df */

        case 91:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17594; /* pred_widen_fcvt_x_fv2di */

        case 92:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17344; /* pred_fcvt_x_fv4df */

        case 93:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17596; /* pred_widen_fcvt_x_fv4di */

        case 94:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17346; /* pred_fcvt_x_fv8df */

        case 95:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17598; /* pred_widen_fcvt_x_fv8di */

        case 96:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17348; /* pred_fcvt_x_fv16df */

        case 97:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17600; /* pred_widen_fcvt_x_fv16di */

        case 98:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17350; /* pred_fcvt_x_fv32df */

        case 99:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17602; /* pred_widen_fcvt_x_fv32di */

        case 100:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17352; /* pred_fcvt_x_fv64df */

        case 101:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17604; /* pred_widen_fcvt_x_fv64di */

        case 102:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17354; /* pred_fcvt_x_fv128df */

        case 103:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17606; /* pred_widen_fcvt_x_fv128di */

        case 104:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17356; /* pred_fcvt_x_fv256df */

        case 105:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17608; /* pred_widen_fcvt_x_fv256di */

        case 106:
          if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17358; /* pred_fcvt_x_fv512df */

        case 107:
          if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17610; /* pred_widen_fcvt_x_fv512di */

        case 108:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17798; /* pred_narrow_fcvt_x_frvvm8hf */

        case 109:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17800; /* pred_narrow_fcvt_x_frvvm4hf */

        case 110:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17802; /* pred_narrow_fcvt_x_frvvm2hf */

        case 111:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17804; /* pred_narrow_fcvt_x_frvvm1hf */

        case 112:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17806; /* pred_narrow_fcvt_x_frvvmf2hf */

        case 113:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17808; /* pred_narrow_fcvt_x_frvvmf4hf */

        case 114:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17828; /* pred_narrow_fcvt_x_fv1hf */

        case 115:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17830; /* pred_narrow_fcvt_x_fv2hf */

        case 116:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17832; /* pred_narrow_fcvt_x_fv4hf */

        case 117:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 17834; /* pred_narrow_fcvt_x_fv8hf */

        case 118:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 17836; /* pred_narrow_fcvt_x_fv16hf */

        case 119:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 17838; /* pred_narrow_fcvt_x_fv32hf */

        case 120:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 17840; /* pred_narrow_fcvt_x_fv64hf */

        case 121:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 17842; /* pred_narrow_fcvt_x_fv128hf */

        case 122:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 17844; /* pred_narrow_fcvt_x_fv256hf */

        case 123:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 17846; /* pred_narrow_fcvt_x_fv512hf */

        case 124:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17848; /* pred_narrow_fcvt_x_fv1024hf */

        case 125:
          if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17850; /* pred_narrow_fcvt_x_fv2048hf */

        default:
          return -1;
        }

    case 124:
      return recog_1323 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1344 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || !vector_arith_operand (operands[5], E_V128QImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12509; /* *pred_cmpv128qi */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12577; /* *pred_cmpv128qi_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || !vector_arith_operand (operands[5], E_V128HImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12522; /* *pred_cmpv128hi */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12590; /* *pred_cmpv128hi_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || !vector_arith_operand (operands[5], E_V128SImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12534; /* *pred_cmpv128si */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12602; /* *pred_cmpv128si_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || !vector_arith_operand (operands[5], E_V128DImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12545; /* *pred_cmpv128di */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12613; /* *pred_cmpv128di_narrow */

    default:
      return -1;
    }
}

 int
recog_1358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4QImode)
          || !
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12617; /* *pred_ltgervvm4qi_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM8HImode)
          || !
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12620; /* *pred_ltgervvm8hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1DImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12631; /* *pred_ltgervvm1di_merge_tie_mask */

    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF8QImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12634; /* *pred_ltgervvmf8qi_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF4HImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12636; /* *pred_ltgervvmf4hi_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2SImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12637; /* *pred_ltgervvmf2si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || !vector_neg_arith_operand (operands[4], E_V32QImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12643; /* *pred_ltgev32qi_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || !vector_neg_arith_operand (operands[4], E_V32HImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12656; /* *pred_ltgev32hi_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || !vector_neg_arith_operand (operands[4], E_V32SImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12668; /* *pred_ltgev32si_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || !vector_neg_arith_operand (operands[4], E_V32DImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12679; /* *pred_ltgev32di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern533 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1373 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || !vector_neg_arith_operand (operands[5], E_V512QImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12715; /* *pred_ltgev512qi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12783; /* *pred_ltgev512qi_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || !vector_neg_arith_operand (operands[5], E_V512HImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12728; /* *pred_ltgev512hi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12796; /* *pred_ltgev512hi_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || !vector_neg_arith_operand (operands[5], E_V512SImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12740; /* *pred_ltgev512si */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12808; /* *pred_ltgev512si_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || !vector_neg_arith_operand (operands[5], E_V512DImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12751; /* *pred_ltgev512di */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12819; /* *pred_ltgev512di_narrow */

    default:
      return -1;
    }
}

 int
recog_1384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern589 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) == 0
          && 
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12616; /* *pred_ltgervvm8qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern590 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
        return -1;
      if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12684; /* *pred_ltgervvm8qi */
      if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12752; /* *pred_ltgervvm8qi_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1358 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4QImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12685; /* *pred_ltgervvm4qi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12753; /* *pred_ltgervvm4qi_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8HImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12688; /* *pred_ltgervvm8hi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12756; /* *pred_ltgervvm8hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1359 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2QImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12686; /* *pred_ltgervvm2qi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12754; /* *pred_ltgervvm2qi_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4HImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12689; /* *pred_ltgervvm4hi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12757; /* *pred_ltgervvm4hi_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8SImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12692; /* *pred_ltgervvm8si */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12760; /* *pred_ltgervvm8si_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1360 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1QImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12687; /* *pred_ltgervvm1qi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12755; /* *pred_ltgervvm1qi_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2HImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12690; /* *pred_ltgervvm2hi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12758; /* *pred_ltgervvm2hi_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4SImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12693; /* *pred_ltgervvm4si */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12761; /* *pred_ltgervvm4si_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8DImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12696; /* *pred_ltgervvm8di */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12764; /* *pred_ltgervvm8di_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1361 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1HImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12691; /* *pred_ltgervvm1hi */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12759; /* *pred_ltgervvm1hi_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2SImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12694; /* *pred_ltgervvm2si */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12762; /* *pred_ltgervvm2si_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4DImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12697; /* *pred_ltgervvm4di */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12765; /* *pred_ltgervvm4di_narrow */

        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12700; /* *pred_ltgervvmf2qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12768; /* *pred_ltgervvmf2qi_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1362 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1SImode))
            return -1;
          if (
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12695; /* *pred_ltgervvm1si */
          if (!
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12763; /* *pred_ltgervvm1si_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2DImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12698; /* *pred_ltgervvm2di */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12766; /* *pred_ltgervvm2di_narrow */

        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF4QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12701; /* *pred_ltgervvmf4qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12769; /* *pred_ltgervvmf4qi_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2HImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12703; /* *pred_ltgervvmf2hi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12771; /* *pred_ltgervvmf2hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1DImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12699; /* *pred_ltgervvm1di */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12767; /* *pred_ltgervvm1di_narrow */

        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF8QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12702; /* *pred_ltgervvmf8qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12770; /* *pred_ltgervvmf8qi_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF4HImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12704; /* *pred_ltgervvmf4hi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12772; /* *pred_ltgervvmf4hi_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2SImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12705; /* *pred_ltgervvmf2si */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12773; /* *pred_ltgervvmf2si_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1364 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1QImode:
          if (!register_operand (operands[4], E_V1QImode)
              || !vector_neg_arith_operand (operands[5], E_V1QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 12706; /* *pred_ltgev1qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 12774; /* *pred_ltgev1qi_narrow */

        case E_V1HImode:
          if (!register_operand (operands[4], E_V1HImode)
              || !vector_neg_arith_operand (operands[5], E_V1HImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 12719; /* *pred_ltgev1hi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 12787; /* *pred_ltgev1hi_narrow */

        case E_V1SImode:
          if (!register_operand (operands[4], E_V1SImode)
              || !vector_neg_arith_operand (operands[5], E_V1SImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 12731; /* *pred_ltgev1si */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 12799; /* *pred_ltgev1si_narrow */

        case E_V1DImode:
          if (!register_operand (operands[4], E_V1DImode)
              || !vector_neg_arith_operand (operands[5], E_V1DImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 12742; /* *pred_ltgev1di */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12810; /* *pred_ltgev1di_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1365 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2QImode:
          if (!register_operand (operands[4], E_V2QImode)
              || !vector_neg_arith_operand (operands[5], E_V2QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 12707; /* *pred_ltgev2qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 12775; /* *pred_ltgev2qi_narrow */

        case E_V2HImode:
          if (!register_operand (operands[4], E_V2HImode)
              || !vector_neg_arith_operand (operands[5], E_V2HImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 12720; /* *pred_ltgev2hi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 12788; /* *pred_ltgev2hi_narrow */

        case E_V2SImode:
          if (!register_operand (operands[4], E_V2SImode)
              || !vector_neg_arith_operand (operands[5], E_V2SImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 12732; /* *pred_ltgev2si */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 12800; /* *pred_ltgev2si_narrow */

        case E_V2DImode:
          if (!register_operand (operands[4], E_V2DImode)
              || !vector_neg_arith_operand (operands[5], E_V2DImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 12743; /* *pred_ltgev2di */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12811; /* *pred_ltgev2di_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      return recog_1383 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1382 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1381 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1380 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1379 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1378 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1377 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1376 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1374 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || !vector_neg_arith_operand (operands[5], E_V1024QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12716; /* *pred_ltgev1024qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12784; /* *pred_ltgev1024qi_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || !vector_neg_arith_operand (operands[5], E_V1024HImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12729; /* *pred_ltgev1024hi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12797; /* *pred_ltgev1024hi_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || !vector_neg_arith_operand (operands[5], E_V1024SImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12741; /* *pred_ltgev1024si */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12809; /* *pred_ltgev1024si_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1375 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || !vector_neg_arith_operand (operands[5], E_V2048QImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12717; /* *pred_ltgev2048qi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12785; /* *pred_ltgev2048qi_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || !vector_neg_arith_operand (operands[5], E_V2048HImode))
            return -1;
          if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12730; /* *pred_ltgev2048hi */
          if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12798; /* *pred_ltgev2048hi_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern589 (x2, 
E_V4096QImode, 
E_V4096BImode) == 0
          && (
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12650; /* *pred_ltgev4096qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern590 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0)
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12718; /* *pred_ltgev4096qi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12786; /* *pred_ltgev4096qi_narrow */

    default:
      return -1;
    }
}

 int
recog_1462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern107 (x3))
        {
        case 0:
          if (!
#line 274 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return -1;
          return 511; /* *popcountsi2 */

        case 1:
          if (!
#line 302 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
            return -1;
          return 523; /* *popcountdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 5
          || XINT (x4, 1) != 91
          || pattern324 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          if (!vector_length_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern545 (x3, 
E_SImode))
                {
                case 0:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                    return -1;
                  return 14318; /* pred_popcountrvvmf64bisi */

                case 1:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14320; /* pred_popcountrvvmf32bisi */

                case 2:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14322; /* pred_popcountrvvmf16bisi */

                case 3:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14324; /* pred_popcountrvvmf8bisi */

                case 4:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14326; /* pred_popcountrvvmf4bisi */

                case 5:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14328; /* pred_popcountrvvmf2bisi */

                case 6:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14330; /* pred_popcountrvvm1bisi */

                case 7:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14332; /* pred_popcountv1bisi */

                case 8:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14334; /* pred_popcountv2bisi */

                case 9:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14336; /* pred_popcountv4bisi */

                case 10:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14338; /* pred_popcountv8bisi */

                case 11:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14340; /* pred_popcountv16bisi */

                case 12:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14342; /* pred_popcountv32bisi */

                case 13:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14344; /* pred_popcountv64bisi */

                case 14:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14346; /* pred_popcountv128bisi */

                case 15:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14348; /* pred_popcountv256bisi */

                case 16:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14350; /* pred_popcountv512bisi */

                case 17:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14352; /* pred_popcountv1024bisi */

                case 18:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14354; /* pred_popcountv2048bisi */

                case 19:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14356; /* pred_popcountv4096bisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern545 (x3, 
E_DImode))
                {
                case 0:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                    return -1;
                  return 14319; /* pred_popcountrvvmf64bidi */

                case 1:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14321; /* pred_popcountrvvmf32bidi */

                case 2:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14323; /* pred_popcountrvvmf16bidi */

                case 3:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14325; /* pred_popcountrvvmf8bidi */

                case 4:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14327; /* pred_popcountrvvmf4bidi */

                case 5:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14329; /* pred_popcountrvvmf2bidi */

                case 6:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14331; /* pred_popcountrvvm1bidi */

                case 7:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14333; /* pred_popcountv1bidi */

                case 8:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14335; /* pred_popcountv2bidi */

                case 9:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14337; /* pred_popcountv4bidi */

                case 10:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14339; /* pred_popcountv8bidi */

                case 11:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14341; /* pred_popcountv16bidi */

                case 12:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14343; /* pred_popcountv32bidi */

                case 13:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14345; /* pred_popcountv64bidi */

                case 14:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14347; /* pred_popcountv128bidi */

                case 15:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14349; /* pred_popcountv256bidi */

                case 16:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14351; /* pred_popcountv512bidi */

                case 17:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14353; /* pred_popcountv1024bidi */

                case 18:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14355; /* pred_popcountv2048bidi */

                case 19:
                  if (!(
#line 6086 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14357; /* pred_popcountv4096bidi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 5
              || XINT (x5, 1) != 155)
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern452 (x3))
            {
            case 0:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 31152; /* *vcond_mask_len_popcount_rvvmf64bisi */

            case 1:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31154; /* *vcond_mask_len_popcount_rvvmf32bisi */

            case 2:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31156; /* *vcond_mask_len_popcount_rvvmf16bisi */

            case 3:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31158; /* *vcond_mask_len_popcount_rvvmf8bisi */

            case 4:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31160; /* *vcond_mask_len_popcount_rvvmf4bisi */

            case 5:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31162; /* *vcond_mask_len_popcount_rvvmf2bisi */

            case 6:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31164; /* *vcond_mask_len_popcount_rvvm1bisi */

            case 7:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 31166; /* *vcond_mask_len_popcount_v1bisi */

            case 8:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 31168; /* *vcond_mask_len_popcount_v2bisi */

            case 9:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 31170; /* *vcond_mask_len_popcount_v4bisi */

            case 10:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 31172; /* *vcond_mask_len_popcount_v8bisi */

            case 11:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 31174; /* *vcond_mask_len_popcount_v16bisi */

            case 12:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 31176; /* *vcond_mask_len_popcount_v32bisi */

            case 13:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 31178; /* *vcond_mask_len_popcount_v64bisi */

            case 14:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 31180; /* *vcond_mask_len_popcount_v128bisi */

            case 15:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 31182; /* *vcond_mask_len_popcount_v256bisi */

            case 16:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 31184; /* *vcond_mask_len_popcount_v512bisi */

            case 17:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 31186; /* *vcond_mask_len_popcount_v1024bisi */

            case 18:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 31188; /* *vcond_mask_len_popcount_v2048bisi */

            case 19:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 31190; /* *vcond_mask_len_popcount_v4096bisi */

            case 20:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 31153; /* *vcond_mask_len_popcount_rvvmf64bidi */

            case 21:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31155; /* *vcond_mask_len_popcount_rvvmf32bidi */

            case 22:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31157; /* *vcond_mask_len_popcount_rvvmf16bidi */

            case 23:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31159; /* *vcond_mask_len_popcount_rvvmf8bidi */

            case 24:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31161; /* *vcond_mask_len_popcount_rvvmf4bidi */

            case 25:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31163; /* *vcond_mask_len_popcount_rvvmf2bidi */

            case 26:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31165; /* *vcond_mask_len_popcount_rvvm1bidi */

            case 27:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 31167; /* *vcond_mask_len_popcount_v1bidi */

            case 28:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 31169; /* *vcond_mask_len_popcount_v2bidi */

            case 29:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 31171; /* *vcond_mask_len_popcount_v4bidi */

            case 30:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 31173; /* *vcond_mask_len_popcount_v8bidi */

            case 31:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 31175; /* *vcond_mask_len_popcount_v16bidi */

            case 32:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 31177; /* *vcond_mask_len_popcount_v32bidi */

            case 33:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 31179; /* *vcond_mask_len_popcount_v64bidi */

            case 34:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 31181; /* *vcond_mask_len_popcount_v128bidi */

            case 35:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 31183; /* *vcond_mask_len_popcount_v256bidi */

            case 36:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 31185; /* *vcond_mask_len_popcount_v512bidi */

            case 37:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 31187; /* *vcond_mask_len_popcount_v1024bidi */

            case 38:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 31189; /* *vcond_mask_len_popcount_v2048bidi */

            case 39:
              if (!(
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 31191; /* *vcond_mask_len_popcount_v4096bidi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32098; /* pred_vpopcountrvvm8qi */

        case 1:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32101; /* pred_vpopcountrvvm4qi */

        case 2:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32104; /* pred_vpopcountrvvm2qi */

        case 3:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32107; /* pred_vpopcountrvvm1qi */

        case 4:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32110; /* pred_vpopcountrvvm8hi */

        case 5:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32113; /* pred_vpopcountrvvm4hi */

        case 6:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32116; /* pred_vpopcountrvvm2hi */

        case 7:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32119; /* pred_vpopcountrvvm1hi */

        case 8:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32122; /* pred_vpopcountrvvm8si */

        case 9:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32125; /* pred_vpopcountrvvm4si */

        case 10:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32128; /* pred_vpopcountrvvm2si */

        case 11:
          if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32131; /* pred_vpopcountrvvm1si */

        case 12:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32134; /* pred_vpopcountrvvm8di */

        case 13:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32137; /* pred_vpopcountrvvm4di */

        case 14:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32140; /* pred_vpopcountrvvm2di */

        case 15:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32143; /* pred_vpopcountrvvm1di */

        case 16:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32146; /* pred_vpopcountrvvmf2qi */

        case 17:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32149; /* pred_vpopcountrvvmf4qi */

        case 18:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32152; /* pred_vpopcountrvvmf8qi */

        case 19:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32155; /* pred_vpopcountrvvmf2hi */

        case 20:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32158; /* pred_vpopcountrvvmf4hi */

        case 21:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32161; /* pred_vpopcountrvvmf2si */

        case 22:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 32164; /* pred_vpopcountv1qi */

        case 23:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 32167; /* pred_vpopcountv2qi */

        case 24:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 32170; /* pred_vpopcountv4qi */

        case 25:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 32173; /* pred_vpopcountv8qi */

        case 26:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 32176; /* pred_vpopcountv16qi */

        case 27:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 32179; /* pred_vpopcountv32qi */

        case 28:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32182; /* pred_vpopcountv64qi */

        case 29:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32185; /* pred_vpopcountv128qi */

        case 30:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32188; /* pred_vpopcountv256qi */

        case 31:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32191; /* pred_vpopcountv512qi */

        case 32:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32194; /* pred_vpopcountv1024qi */

        case 33:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32197; /* pred_vpopcountv2048qi */

        case 34:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32200; /* pred_vpopcountv4096qi */

        case 35:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 32203; /* pred_vpopcountv1hi */

        case 36:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 32206; /* pred_vpopcountv2hi */

        case 37:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 32209; /* pred_vpopcountv4hi */

        case 38:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 32212; /* pred_vpopcountv8hi */

        case 39:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 32215; /* pred_vpopcountv16hi */

        case 40:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32218; /* pred_vpopcountv32hi */

        case 41:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32221; /* pred_vpopcountv64hi */

        case 42:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32224; /* pred_vpopcountv128hi */

        case 43:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32227; /* pred_vpopcountv256hi */

        case 44:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32230; /* pred_vpopcountv512hi */

        case 45:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32233; /* pred_vpopcountv1024hi */

        case 46:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32236; /* pred_vpopcountv2048hi */

        case 47:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 32239; /* pred_vpopcountv1si */

        case 48:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 32242; /* pred_vpopcountv2si */

        case 49:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 32245; /* pred_vpopcountv4si */

        case 50:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 32248; /* pred_vpopcountv8si */

        case 51:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32251; /* pred_vpopcountv16si */

        case 52:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32254; /* pred_vpopcountv32si */

        case 53:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32257; /* pred_vpopcountv64si */

        case 54:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32260; /* pred_vpopcountv128si */

        case 55:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32263; /* pred_vpopcountv256si */

        case 56:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32266; /* pred_vpopcountv512si */

        case 57:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32269; /* pred_vpopcountv1024si */

        case 58:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32272; /* pred_vpopcountv1di */

        case 59:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32275; /* pred_vpopcountv2di */

        case 60:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32278; /* pred_vpopcountv4di */

        case 61:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32281; /* pred_vpopcountv8di */

        case 62:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32284; /* pred_vpopcountv16di */

        case 63:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32287; /* pred_vpopcountv32di */

        case 64:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32290; /* pred_vpopcountv64di */

        case 65:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32293; /* pred_vpopcountv128di */

        case 66:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32296; /* pred_vpopcountv256di */

        case 67:
          if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32299; /* pred_vpopcountv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 557; /* *umaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 625 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 32875; /* riscv_cv_alu_maxu */

    case 1:
      if (!(
#line 546 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 561; /* *umaxdi3 */

    case 2:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23620; /* umaxrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23634; /* umaxrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23648; /* umaxrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23662; /* umaxrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23676; /* umaxrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23690; /* umaxrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23704; /* umaxrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23718; /* umaxrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23732; /* umaxrvvm8si3 */

    case 11:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23746; /* umaxrvvm4si3 */

    case 12:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23760; /* umaxrvvm2si3 */

    case 13:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23774; /* umaxrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23788; /* umaxrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23802; /* umaxrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23816; /* umaxrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23830; /* umaxrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23844; /* umaxrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23858; /* umaxrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23872; /* umaxrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23886; /* umaxrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23900; /* umaxrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23914; /* umaxrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23928; /* umaxv1qi3 */

    case 25:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23942; /* umaxv2qi3 */

    case 26:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23956; /* umaxv4qi3 */

    case 27:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23970; /* umaxv8qi3 */

    case 28:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23984; /* umaxv16qi3 */

    case 29:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 23998; /* umaxv32qi3 */

    case 30:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24012; /* umaxv64qi3 */

    case 31:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24026; /* umaxv128qi3 */

    case 32:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24040; /* umaxv256qi3 */

    case 33:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24054; /* umaxv512qi3 */

    case 34:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24068; /* umaxv1024qi3 */

    case 35:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24082; /* umaxv2048qi3 */

    case 36:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24096; /* umaxv4096qi3 */

    case 37:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24110; /* umaxv1hi3 */

    case 38:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24124; /* umaxv2hi3 */

    case 39:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24138; /* umaxv4hi3 */

    case 40:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24152; /* umaxv8hi3 */

    case 41:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24166; /* umaxv16hi3 */

    case 42:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24180; /* umaxv32hi3 */

    case 43:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24194; /* umaxv64hi3 */

    case 44:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24208; /* umaxv128hi3 */

    case 45:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24222; /* umaxv256hi3 */

    case 46:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24236; /* umaxv512hi3 */

    case 47:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24250; /* umaxv1024hi3 */

    case 48:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24264; /* umaxv2048hi3 */

    case 49:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24278; /* umaxv1si3 */

    case 50:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24292; /* umaxv2si3 */

    case 51:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24306; /* umaxv4si3 */

    case 52:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24320; /* umaxv8si3 */

    case 53:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24334; /* umaxv16si3 */

    case 54:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24348; /* umaxv32si3 */

    case 55:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24362; /* umaxv64si3 */

    case 56:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24376; /* umaxv128si3 */

    case 57:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24390; /* umaxv256si3 */

    case 58:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24404; /* umaxv512si3 */

    case 59:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24418; /* umaxv1024si3 */

    case 60:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24432; /* umaxv1di3 */

    case 61:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24446; /* umaxv2di3 */

    case 62:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24460; /* umaxv4di3 */

    case 63:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24474; /* umaxv8di3 */

    case 64:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24488; /* umaxv16di3 */

    case 65:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24502; /* umaxv32di3 */

    case 66:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24516; /* umaxv64di3 */

    case 67:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24530; /* umaxv128di3 */

    case 68:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24544; /* umaxv256di3 */

    case 69:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24558; /* umaxv512di3 */

    default:
      return -1;
    }
}

 int
recog_1486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern118 (x3))
    {
    case 0:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27013; /* umulrvvm8qi3_highpart */

    case 1:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27015; /* umulrvvm4qi3_highpart */

    case 2:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27017; /* umulrvvm2qi3_highpart */

    case 3:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27019; /* umulrvvm1qi3_highpart */

    case 4:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27021; /* umulrvvmf2qi3_highpart */

    case 5:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27023; /* umulrvvmf4qi3_highpart */

    case 6:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27025; /* umulrvvmf8qi3_highpart */

    case 7:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27027; /* umulrvvm8hi3_highpart */

    case 8:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27029; /* umulrvvm4hi3_highpart */

    case 9:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27031; /* umulrvvm2hi3_highpart */

    case 10:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27033; /* umulrvvm1hi3_highpart */

    case 11:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27035; /* umulrvvmf2hi3_highpart */

    case 12:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27037; /* umulrvvmf4hi3_highpart */

    case 13:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27039; /* umulrvvm8si3_highpart */

    case 14:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27041; /* umulrvvm4si3_highpart */

    case 15:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27043; /* umulrvvm2si3_highpart */

    case 16:
      if (!
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27045; /* umulrvvm1si3_highpart */

    case 17:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27047; /* umulrvvmf2si3_highpart */

    case 18:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27049; /* umulrvvm8di3_highpart */

    case 19:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27051; /* umulrvvm4di3_highpart */

    case 20:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27053; /* umulrvvm2di3_highpart */

    case 21:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27055; /* umulrvvm1di3_highpart */

    case 22:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27057; /* umulv1qi3_highpart */

    case 23:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27059; /* umulv2qi3_highpart */

    case 24:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27061; /* umulv4qi3_highpart */

    case 25:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27063; /* umulv8qi3_highpart */

    case 26:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27065; /* umulv16qi3_highpart */

    case 27:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27067; /* umulv32qi3_highpart */

    case 28:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27069; /* umulv64qi3_highpart */

    case 29:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27071; /* umulv128qi3_highpart */

    case 30:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27073; /* umulv256qi3_highpart */

    case 31:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27075; /* umulv512qi3_highpart */

    case 32:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27077; /* umulv1024qi3_highpart */

    case 33:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27079; /* umulv2048qi3_highpart */

    case 34:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27081; /* umulv4096qi3_highpart */

    case 35:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27083; /* umulv1hi3_highpart */

    case 36:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27085; /* umulv2hi3_highpart */

    case 37:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27087; /* umulv4hi3_highpart */

    case 38:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27089; /* umulv8hi3_highpart */

    case 39:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27091; /* umulv16hi3_highpart */

    case 40:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27093; /* umulv32hi3_highpart */

    case 41:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27095; /* umulv64hi3_highpart */

    case 42:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27097; /* umulv128hi3_highpart */

    case 43:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27099; /* umulv256hi3_highpart */

    case 44:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27101; /* umulv512hi3_highpart */

    case 45:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27103; /* umulv1024hi3_highpart */

    case 46:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27105; /* umulv2048hi3_highpart */

    case 47:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27107; /* umulv1si3_highpart */

    case 48:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27109; /* umulv2si3_highpart */

    case 49:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27111; /* umulv4si3_highpart */

    case 50:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27113; /* umulv8si3_highpart */

    case 51:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27115; /* umulv16si3_highpart */

    case 52:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27117; /* umulv32si3_highpart */

    case 53:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27119; /* umulv64si3_highpart */

    case 54:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27121; /* umulv128si3_highpart */

    case 55:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27123; /* umulv256si3_highpart */

    case 56:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27125; /* umulv512si3_highpart */

    case 57:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27127; /* umulv1024si3_highpart */

    case 58:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 27129; /* umulv1di3_highpart */

    case 59:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 27131; /* umulv2di3_highpart */

    case 60:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 27133; /* umulv4di3_highpart */

    case 61:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27135; /* umulv8di3_highpart */

    case 62:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27137; /* umulv16di3_highpart */

    case 63:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27139; /* umulv32di3_highpart */

    case 64:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27141; /* umulv64di3_highpart */

    case 65:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27143; /* umulv128di3_highpart */

    case 66:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27145; /* umulv256di3_highpart */

    case 67:
      if (!(
#line 1684 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27147; /* umulv512di3_highpart */

    default:
      return -1;
    }
}

 int
recog_1502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern411 (
E_SImode) != 0
          || !
#line 424 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, SImode)))
        return -1;
      return 900; /* *th_mempair_store_si2 */

    case E_DImode:
      if (pattern411 (
E_DImode) != 0
          || !(
#line 424 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, DImode)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 901; /* *th_mempair_store_di2 */

    default:
      return -1;
    }
}

 int
recog_1505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (REGNO (x3))
    {
    case 69:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (REGNO (x5) != 69
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!reg_or_int_operand (operands[1], E_SImode)
          || !
#line 1099 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2707; /* fsrmsi_backup */

    case 1:
      x6 = XEXP (x2, 0);
      if (pattern364 (x6) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x5 = XEXP (x4, 0);
      if (REGNO (x5) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      operands[0] = x9;
      if (!stack_push_up_to_ra_operand (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      x11 = XEXP (x10, 1);
      switch (XWINT (x11, 0))
        {
        case -4L:
          if (pattern547 (x1, 
E_SImode) != 0
              || !(
#line 1111 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32824; /* gpr_multi_push_up_to_ra_si */

        case -8L:
          if (pattern547 (x1, 
E_DImode) != 0
              || !(
#line 1111 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32825; /* gpr_multi_push_up_to_ra_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
          res = recog_1496 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!fp_native_comparison (x4, E_VOIDmode))
        return -1;
      switch (pattern406 (x3))
        {
        case 0:
          if (!(
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 371; /* *cbranchsf4 */

        case 1:
          if (!(
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 372; /* *cbranchsf4 */

        case 2:
          if (!(
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 373; /* *cbranchdf4 */

        case 3:
          if (!(
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 374; /* *cbranchdf4 */

        case 4:
          if (!(
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 375; /* *cbranchhf4 */

        case 5:
          if (!(
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 376; /* *cbranchhf4 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 7
          || XINT (x4, 1) != 91)
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 66
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 67
          || GET_MODE (x11) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XINT (x5, 1) != 135)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x12 = XEXP (x8, 1);
      if (pattern370 (x12, 
136, 
1, 
UNSPEC) != 0)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x13) != IF_THEN_ELSE)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != UNSPEC
          || XVECLEN (x14, 0) != 7
          || XINT (x14, 1) != 91)
        return -1;
      x15 = XVECEXP (x14, 0, 5);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 66
          || GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XVECEXP (x14, 0, 6);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 67
          || GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x13, 1);
      if (GET_CODE (x17) != UNSPEC
          || XINT (x17, 1) != 135)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_SImode)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x18 = XVECEXP (x4, 0, 0);
      operands[1] = x18;
      x19 = XVECEXP (x4, 0, 1);
      operands[4] = x19;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x20 = XVECEXP (x4, 0, 2);
      operands[5] = x20;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x21 = XVECEXP (x4, 0, 3);
      operands[6] = x21;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x22 = XVECEXP (x4, 0, 4);
      operands[7] = x22;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      x23 = XVECEXP (x14, 0, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XVECEXP (x14, 0, 1);
      if (!rtx_equal_p (x24, operands[4]))
        return -1;
      x25 = XVECEXP (x14, 0, 2);
      if (!rtx_equal_p (x25, operands[5]))
        return -1;
      x26 = XVECEXP (x14, 0, 3);
      if (!rtx_equal_p (x26, operands[6]))
        return -1;
      x27 = XVECEXP (x14, 0, 4);
      if (!rtx_equal_p (x27, operands[7]))
        return -1;
      x28 = XEXP (x13, 2);
      if (!rtx_equal_p (x28, operands[2]))
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XVECLEN (x17, 0) != 1)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern747 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20138; /* pred_fault_loadrvvm8qi */

            case E_RVVM4QImode:
              if (pattern747 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20139; /* pred_fault_loadrvvm4qi */

            case E_RVVM2QImode:
              if (pattern747 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20140; /* pred_fault_loadrvvm2qi */

            case E_RVVM1QImode:
              if (pattern747 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20141; /* pred_fault_loadrvvm1qi */

            case E_RVVM8HImode:
              if (pattern747 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20142; /* pred_fault_loadrvvm8hi */

            case E_RVVM4HImode:
              if (pattern747 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20143; /* pred_fault_loadrvvm4hi */

            case E_RVVM2HImode:
              if (pattern747 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20144; /* pred_fault_loadrvvm2hi */

            case E_RVVM1HImode:
              if (pattern747 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20145; /* pred_fault_loadrvvm1hi */

            case E_RVVM8SImode:
              if (pattern747 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20146; /* pred_fault_loadrvvm8si */

            case E_RVVM4SImode:
              if (pattern747 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20147; /* pred_fault_loadrvvm4si */

            case E_RVVM2SImode:
              if (pattern747 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20148; /* pred_fault_loadrvvm2si */

            case E_RVVM1SImode:
              if (pattern747 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
                  || !
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20149; /* pred_fault_loadrvvm1si */

            case E_RVVM8DImode:
              if (pattern747 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20150; /* pred_fault_loadrvvm8di */

            case E_RVVM4DImode:
              if (pattern747 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20151; /* pred_fault_loadrvvm4di */

            case E_RVVM2DImode:
              if (pattern747 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20152; /* pred_fault_loadrvvm2di */

            case E_RVVM1DImode:
              if (pattern747 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20153; /* pred_fault_loadrvvm1di */

            case E_RVVMF2QImode:
              if (pattern747 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 20154; /* pred_fault_loadrvvmf2qi */

            case E_RVVMF4QImode:
              if (pattern747 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 20155; /* pred_fault_loadrvvmf4qi */

            case E_RVVMF8QImode:
              if (pattern747 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 20156; /* pred_fault_loadrvvmf8qi */

            case E_RVVMF2HImode:
              if (pattern747 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 20157; /* pred_fault_loadrvvmf2hi */

            case E_RVVMF4HImode:
              if (pattern747 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 20158; /* pred_fault_loadrvvmf4hi */

            case E_RVVMF2SImode:
              if (pattern747 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 20159; /* pred_fault_loadrvvmf2si */

            case E_RVVM8BFmode:
              if (pattern747 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20160; /* pred_fault_loadrvvm8bf */

            case E_RVVM4BFmode:
              if (pattern747 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20161; /* pred_fault_loadrvvm4bf */

            case E_RVVM2BFmode:
              if (pattern747 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20162; /* pred_fault_loadrvvm2bf */

            case E_RVVM1BFmode:
              if (pattern747 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20163; /* pred_fault_loadrvvm1bf */

            case E_RVVMF2BFmode:
              if (pattern747 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20164; /* pred_fault_loadrvvmf2bf */

            case E_RVVMF4BFmode:
              if (pattern747 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 20165; /* pred_fault_loadrvvmf4bf */

            case E_RVVM8HFmode:
              if (pattern747 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20166; /* pred_fault_loadrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern747 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20167; /* pred_fault_loadrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern747 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20168; /* pred_fault_loadrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern747 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20169; /* pred_fault_loadrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern747 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20170; /* pred_fault_loadrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern747 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 20171; /* pred_fault_loadrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern747 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20172; /* pred_fault_loadrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern747 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20173; /* pred_fault_loadrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern747 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20174; /* pred_fault_loadrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern747 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20175; /* pred_fault_loadrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern747 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 20176; /* pred_fault_loadrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern747 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20177; /* pred_fault_loadrvvm8df */

            case E_RVVM4DFmode:
              if (pattern747 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20178; /* pred_fault_loadrvvm4df */

            case E_RVVM2DFmode:
              if (pattern747 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20179; /* pred_fault_loadrvvm2df */

            case E_RVVM1DFmode:
              if (pattern747 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20180; /* pred_fault_loadrvvm1df */

            default:
              return -1;
            }

        case 2:
          x31 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x31) != MEM
              || GET_MODE (x31) != E_BLKmode)
            return -1;
          x32 = XEXP (x31, 0);
          if (GET_CODE (x32) != SCRATCH
              || XVECLEN (x17, 0) != 2)
            return -1;
          x33 = XVECEXP (x17, 0, 1);
          if (GET_CODE (x33) != MEM
              || GET_MODE (x33) != E_BLKmode)
            return -1;
          x34 = XEXP (x33, 0);
          if (GET_CODE (x34) != SCRATCH)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
            return -1;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          return recog_1497 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern371 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern726 (x1))
        {
        case 0:
          switch (pattern734 (x1, 
E_SImode, 
-28, 
-24, 
-20, 
-16))
            {
            case 0:
              if (!(
#line 157 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32764; /* gpr_multi_pop_up_to_s5_si */

            case 1:
              if (!(
#line 445 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32784; /* gpr_multi_popret_up_to_s3_si */

            case 2:
              if (!(
#line 764 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32804; /* gpr_multi_popretz_up_to_s1_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern734 (x1, 
E_DImode, 
-56, 
-48, 
-40, 
-32))
            {
            case 0:
              if (!(
#line 157 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32765; /* gpr_multi_pop_up_to_s5_di */

            case 1:
              if (!(
#line 445 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32785; /* gpr_multi_popret_up_to_s3_di */

            case 2:
              if (!(
#line 764 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32805; /* gpr_multi_popretz_up_to_s1_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 21)
        return -1;
      x6 = XEXP (x2, 0);
      if (pattern364 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 20)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MEM)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x1, 0, 2);
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 19)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != MEM)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != PLUS)
        return -1;
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x1, 0, 3);
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 18)
        return -1;
      x21 = XEXP (x19, 0);
      if (GET_CODE (x21) != MEM)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 2)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != CONST_INT
          || pattern733 (x1, 
9) != 0
          || pattern737 (x1, 
8) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (pattern536 (x25, 
1) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x26) != SET)
        return -1;
      x27 = XEXP (x26, 1);
      if (GET_CODE (x27) != PLUS)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 2)
        return -1;
      x30 = XEXP (x27, 1);
      operands[0] = x30;
      if (!stack_push_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern756 (x1))
        {
        case 0:
          if (pattern761 (x1, 
E_SImode) != 0
              || !(
#line 1240 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32836; /* gpr_multi_push_up_to_s5_si */

        case 1:
          if (pattern761 (x1, 
E_DImode) != 0
              || !(
#line 1240 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32837; /* gpr_multi_push_up_to_s5_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x2) != SET)
    return -1;
  switch (pattern391 (x1, 
23, 
24))
    {
    case 0:
      x3 = XVECEXP (x1, 0, 6);
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 2)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      switch (pattern739 (x1))
        {
        case 0:
          if (XWINT (x7, 0) != -24L)
            return -1;
          switch (pattern751 (x1, 
-28, 
E_SImode, 
-32))
            {
            case 0:
              if (pattern775 (x1, 
9) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern787 (x12) != 0
                  || !(
#line 262 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32770; /* gpr_multi_pop_up_to_s8_si */

            case 1:
              if (!(
#line 538 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32790; /* gpr_multi_popret_up_to_s6_si */

            case 2:
              if (!(
#line 848 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32810; /* gpr_multi_popretz_up_to_s4_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x7, 0) != -48L)
            return -1;
          switch (pattern751 (x1, 
-56, 
E_DImode, 
-64))
            {
            case 0:
              x13 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x13) != SET)
                return -1;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != MEM
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 2
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XEXP (x15, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 9
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x19 = XEXP (x10, 1);
              if (GET_CODE (x19) != MEM
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 2
                  || GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x20, 1);
              if (GET_CODE (x22) != CONST_INT
                  || XWINT (x22, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern788 (x12) != 0
                  || !(
#line 262 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32771; /* gpr_multi_pop_up_to_s8_di */

            case 1:
              if (!(
#line 538 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32791; /* gpr_multi_popret_up_to_s6_di */

            case 2:
              if (!(
#line 848 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32811; /* gpr_multi_popretz_up_to_s4_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern537 (x1, 
18, 
19, 
20, 
21, 
22) != 0
          || pattern749 (x1, 
9) != 0
          || pattern759 (x1, 
1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x12) != SET)
        return -1;
      x23 = XEXP (x12, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 2)
        return -1;
      x25 = XEXP (x12, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x23, 1);
      operands[0] = x26;
      if (!stack_push_up_to_s8_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern766 (x1))
        {
        case 0:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -40L
              || pattern773 (x1, 
E_SImode) != 0
              || !(
#line 1345 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32842; /* gpr_multi_push_up_to_s8_si */

        case 1:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -80L
              || pattern773 (x1, 
E_DImode) != 0
              || !(
#line 1345 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32843; /* gpr_multi_push_up_to_s8_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (pattern755 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XVECEXP (x1, 0, 11);
  if (pattern763 (x9) != 0)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG)
    return -1;
  x13 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x13) != RETURN)
    return -1;
  x14 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x14) != USE)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 1
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  operands[0] = x18;
  switch (pattern771 (x1))
    {
    case 0:
      switch (pattern780 (x1, 
E_SImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern798 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern801 (x20) != 0
              || !(
#line 707 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32798; /* gpr_multi_popret_up_to_s11_si */

        case 1:
          if (!(
#line 1048 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32820; /* gpr_multi_popretz_up_to_s9_si */

        default:
          return -1;
        }

    case 1:
      switch (pattern780 (x1, 
E_DImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern799 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern802 (x20) != 0
              || !(
#line 707 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32799; /* gpr_multi_popret_up_to_s11_di */

        case 1:
          if (!(
#line 1048 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32821; /* gpr_multi_popretz_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_1527 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_1509 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_1510 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_1511 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_1514 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_1515 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 17:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == UNSPEC_VOLATILE
              && pattern119 (x1, 
USE, 
21) == 0
              && 
#line 253 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
            return 884; /* th_int_push */
          break;

        case 18:
          res = recog_1516 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_1517 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_1518 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 9:
          res = recog_1519 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          res = recog_1520 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 11:
          res = recog_1521 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 12:
          res = recog_1522 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 14:
          res = recog_1523 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 13:
          res = recog_1524 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_1525 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 15:
          res = recog_1526 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[1] = x1;
      if (!gpr_save_operation (operands[1], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      return 458; /* gpr_save */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 293; /* fence */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2839 "../../gcc/config/riscv/riscv.md"
(TARGET_ZIFENCEI))
                return -1;
              return 294; /* fence_i */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 295; /* riscv_pause */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 446; /* blockage */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 459; /* gpr_restore */

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4056 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 462; /* riscv_fscsr */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!csr_operand (operands[0], E_SImode)
                  || !
#line 4069 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 464; /* riscv_fsflags */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4215 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 477; /* riscv_clean_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4215 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 478; /* riscv_clean_di */

                default:
                  return -1;
                }

            case 16:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4223 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 479; /* riscv_flush_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4223 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 480; /* riscv_flush_di */

                default:
                  return -1;
                }

            case 17:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4231 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 481; /* riscv_inval_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4231 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 482; /* riscv_inval_di */

                default:
                  return -1;
                }

            case 18:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4239 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 483; /* riscv_zero_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4239 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 484; /* riscv_zero_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          switch (XINT (x1, 1))
            {
            case 6:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (!register_operand (operands[0], E_SFmode)
                      || !register_operand (operands[1], E_SFmode)
                      || !
#line 4077 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                    return -1;
                  return 465; /* *riscv_fsnvsnansf2 */

                case E_DFmode:
                  if (!register_operand (operands[0], E_DFmode)
                      || !register_operand (operands[1], E_DFmode)
                      || !(
#line 4077 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 466; /* *riscv_fsnvsnandf2 */

                case E_HFmode:
                  if (!register_operand (operands[0], E_HFmode)
                      || !register_operand (operands[1], E_HFmode)
                      || !(
#line 4077 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 467; /* *riscv_fsnvsnanhf2 */

                default:
                  return -1;
                }

            case 19:
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!address_operand (operands[0], E_SImode)
                      || !imm5_operand (operands[1], E_SImode)
                      || !(
#line 4268 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 486; /* riscv_prefetchi_si */

                case E_DImode:
                  if (!address_operand (operands[0], E_DImode)
                      || !imm5_operand (operands[1], E_DImode)
                      || !(
#line 4268 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 487; /* riscv_prefetchi_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 447; /* simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3834 "../../gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 449; /* eh_set_lr_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 3841 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 450; /* eh_set_lr_di */

        default:
          return -1;
        }

    case EH_RETURN:
      return 451; /* eh_return_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 456; /* nop */

    case TRAP_IF:
      x5 = XEXP (x1, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 457; /* trap */

    case PREFETCH:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[1] = x6;
      if (!imm5_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x1, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 4248 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP))
        return -1;
      return 485; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern147 (x2))
        {
        case 0:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8133 (insn, operands);

        case 1:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8139 (insn, operands);

        case 2:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8145 (insn, operands);

        case 3:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8151 (insn, operands);

        case 4:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8157 (insn, operands);

        case 5:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8163 (insn, operands);

        case 6:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8169 (insn, operands);

        case 7:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8175 (insn, operands);

        case 8:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8181 (insn, operands);

        case 9:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8187 (insn, operands);

        case 10:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8193 (insn, operands);

        case 11:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8199 (insn, operands);

        case 12:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8205 (insn, operands);

        case 13:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8211 (insn, operands);

        case 14:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8217 (insn, operands);

        case 15:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8223 (insn, operands);

        case 16:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8229 (insn, operands);

        case 17:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8235 (insn, operands);

        case 18:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8241 (insn, operands);

        case 19:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8247 (insn, operands);

        case 20:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8253 (insn, operands);

        case 21:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8259 (insn, operands);

        case 22:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8265 (insn, operands);

        case 23:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8271 (insn, operands);

        case 24:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8277 (insn, operands);

        case 25:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8283 (insn, operands);

        case 26:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8289 (insn, operands);

        case 27:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8295 (insn, operands);

        case 28:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8301 (insn, operands);

        case 29:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8307 (insn, operands);

        case 30:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8313 (insn, operands);

        case 31:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8319 (insn, operands);

        case 32:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8325 (insn, operands);

        case 33:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8331 (insn, operands);

        case 34:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8337 (insn, operands);

        case 35:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8343 (insn, operands);

        case 36:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8349 (insn, operands);

        case 37:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8355 (insn, operands);

        case 38:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8361 (insn, operands);

        case 39:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8367 (insn, operands);

        case 40:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8373 (insn, operands);

        case 41:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8379 (insn, operands);

        case 42:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8385 (insn, operands);

        case 43:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8391 (insn, operands);

        case 44:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8397 (insn, operands);

        case 45:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8403 (insn, operands);

        case 46:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8409 (insn, operands);

        case 47:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8415 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern148 (x2))
        {
        case 0:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8517 (insn, operands);

        case 1:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8519 (insn, operands);

        case 2:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8521 (insn, operands);

        case 3:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8523 (insn, operands);

        case 4:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8525 (insn, operands);

        case 5:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8527 (insn, operands);

        case 6:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8529 (insn, operands);

        case 7:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8531 (insn, operands);

        case 8:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8533 (insn, operands);

        case 9:
          if (!(
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8535 (insn, operands);

        case 10:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8537 (insn, operands);

        case 11:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8539 (insn, operands);

        case 12:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8541 (insn, operands);

        case 13:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8543 (insn, operands);

        case 14:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8545 (insn, operands);

        case 15:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8547 (insn, operands);

        case 16:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8549 (insn, operands);

        case 17:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8551 (insn, operands);

        case 18:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8553 (insn, operands);

        case 19:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8555 (insn, operands);

        case 20:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8557 (insn, operands);

        case 21:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8559 (insn, operands);

        case 22:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8561 (insn, operands);

        case 23:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8563 (insn, operands);

        case 24:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8565 (insn, operands);

        case 25:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8567 (insn, operands);

        case 26:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8569 (insn, operands);

        case 27:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8571 (insn, operands);

        case 28:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8573 (insn, operands);

        case 29:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8575 (insn, operands);

        case 30:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8577 (insn, operands);

        case 31:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8579 (insn, operands);

        case 32:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8581 (insn, operands);

        case 33:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8583 (insn, operands);

        case 34:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8585 (insn, operands);

        case 35:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8587 (insn, operands);

        case 36:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8589 (insn, operands);

        case 37:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8591 (insn, operands);

        case 38:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8593 (insn, operands);

        case 39:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8595 (insn, operands);

        case 40:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8597 (insn, operands);

        case 41:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8599 (insn, operands);

        case 42:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8601 (insn, operands);

        case 43:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8603 (insn, operands);

        case 44:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8605 (insn, operands);

        case 45:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8607 (insn, operands);

        case 46:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8609 (insn, operands);

        case 47:
          if (!((
#line 647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8611 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return gen_split_317 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16DFmode)
       || !register_operand (operands[1], V16DFmode)))))
        return gen_split_1981 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2164 (insn, operands);
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_315 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DFmode)
       || !register_operand (operands[1], V4DFmode)))))
        return gen_split_1979 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2162 (insn, operands);
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SFmode)
      && reg_or_mem_operand (operands[1], E_V16SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return gen_split_306 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))) && 
#line 4274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SFmode)
       || !register_operand (operands[1], V16SFmode)))))
        return gen_split_1976 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SFmode)
      || !register_operand (operands[1], E_V16SFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2153 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SFmode)
      && reg_or_mem_operand (operands[1], E_V1SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_302 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SFmode)
       || register_operand (operands[1], V1SFmode))) && 
#line 4270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SFmode)
       || !register_operand (operands[1], V1SFmode)))))
        return gen_split_1972 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SFmode)
      || !register_operand (operands[1], E_V1SFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2149 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HFmode)
      && reg_or_mem_operand (operands[1], E_V2HFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_291 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HFmode)
       || register_operand (operands[1], V2HFmode))) && 
#line 4266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HFmode)
       || !register_operand (operands[1], V2HFmode)))))
        return gen_split_1968 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HFmode)
      || !register_operand (operands[1], E_V2HFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2138 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DImode)
      && reg_or_mem_operand (operands[1], E_V4DImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_282 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))) && 
#line 4262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DImode)
       || !register_operand (operands[1], V4DImode)))))
        return gen_split_1964 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DImode)
      || !register_operand (operands[1], E_V4DImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2129 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return gen_split_271 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4SImode)
       || !register_operand (operands[1], V4SImode)))))
        return gen_split_1959 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2118 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HImode)
      && reg_or_mem_operand (operands[1], E_V2HImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return gen_split_258 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 4251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HImode)
       || !register_operand (operands[1], V2HImode)))))
        return gen_split_1953 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HImode)
      || !register_operand (operands[1], E_V2HImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2105 (insn, operands);
}

 rtx_insn *
split_44 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return gen_split_244 (insn, operands);
      if (((
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1440 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1QImode)
       || !register_operand (operands[1], V1QImode)))))
        return gen_split_1947 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2091 (insn, operands);
}

 rtx_insn *
split_52 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DFmode)
      && reg_or_mem_operand (operands[1], E_V128DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_320 (insn, operands);
  if (!register_operand (operands[0], E_V128DFmode)
      || !register_operand (operands[1], E_V128DFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2167 (insn, operands);
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SFmode)
      && reg_or_mem_operand (operands[1], E_V128SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return gen_split_309 (insn, operands);
  if (!register_operand (operands[0], E_V128SFmode)
      || !register_operand (operands[1], E_V128SFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2156 (insn, operands);
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HFmode)
      && reg_or_mem_operand (operands[1], E_V256HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return gen_split_298 (insn, operands);
  if (!register_operand (operands[0], E_V256HFmode)
      || !register_operand (operands[1], E_V256HFmode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2145 (insn, operands);
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DImode)
      && reg_or_mem_operand (operands[1], E_V128DImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_287 (insn, operands);
  if (!register_operand (operands[0], E_V128DImode)
      || !register_operand (operands[1], E_V128DImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2134 (insn, operands);
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SImode)
      && reg_or_mem_operand (operands[1], E_V128SImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_276 (insn, operands);
  if (!register_operand (operands[0], E_V128SImode)
      || !register_operand (operands[1], E_V128SImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2123 (insn, operands);
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128HImode)
      && reg_or_mem_operand (operands[1], E_V128HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_264 (insn, operands);
  if (!register_operand (operands[0], E_V128HImode)
      || !register_operand (operands[1], E_V128HImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2111 (insn, operands);
}

 rtx_insn *
split_90 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256QImode)
      && reg_or_mem_operand (operands[1], E_V256QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_252 (insn, operands);
  if (!register_operand (operands[0], E_V256QImode)
      || !register_operand (operands[1], E_V256QImode)
      || !((
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1510 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2099 (insn, operands);
}

 rtx_insn *
split_97 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8BImode)
      && 
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_240 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8BImode)
      || !register_operand (operands[1], E_RVVMF8BImode)
      || !(
#line 1293 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1295 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1577 (insn, operands);
}

 rtx_insn *
split_104 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
    return gen_split_221 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BFmode)
      || !register_operand (operands[1], E_RVVMF4BFmode)
      || !((
#line 1256 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 1258 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1569 (insn, operands);
}

 rtx_insn *
split_112 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern200 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM4QImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10105 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10201 (insn, operands);

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM2QImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10106 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10202 (insn, operands);

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM1QImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10107 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10203 (insn, operands);

    case 3:
      if (vector_shift_operand (operands[2], E_RVVMF2QImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10108 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10204 (insn, operands);

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF4QImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10109 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10205 (insn, operands);

    case 5:
      if (vector_shift_operand (operands[2], E_RVVMF8QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10110 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10206 (insn, operands);

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4HImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10111 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10207 (insn, operands);

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2HImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10112 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10208 (insn, operands);

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1HImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10113 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10209 (insn, operands);

    case 9:
      if (vector_shift_operand (operands[2], E_RVVMF2HImode)
          && (
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10114 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10210 (insn, operands);

    case 10:
      if (vector_shift_operand (operands[2], E_RVVMF4HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10115 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10211 (insn, operands);

    case 11:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10116 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10212 (insn, operands);

    case 12:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10117 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10213 (insn, operands);

    case 13:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10118 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10214 (insn, operands);

    case 14:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10119 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10215 (insn, operands);

    case 15:
      if (vector_shift_operand (operands[2], E_V1QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10120 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10216 (insn, operands);

    case 16:
      if (vector_shift_operand (operands[2], E_V2QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10121 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10217 (insn, operands);

    case 17:
      if (vector_shift_operand (operands[2], E_V4QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10122 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10218 (insn, operands);

    case 18:
      if (vector_shift_operand (operands[2], E_V8QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10123 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10219 (insn, operands);

    case 19:
      if (vector_shift_operand (operands[2], E_V16QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10124 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10220 (insn, operands);

    case 20:
      if (vector_shift_operand (operands[2], E_V32QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10125 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10221 (insn, operands);

    case 21:
      if (vector_shift_operand (operands[2], E_V64QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10126 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10222 (insn, operands);

    case 22:
      if (vector_shift_operand (operands[2], E_V128QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10127 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10223 (insn, operands);

    case 23:
      if (vector_shift_operand (operands[2], E_V256QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10128 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10224 (insn, operands);

    case 24:
      if (vector_shift_operand (operands[2], E_V512QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10129 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10225 (insn, operands);

    case 25:
      if (vector_shift_operand (operands[2], E_V1024QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10130 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10226 (insn, operands);

    case 26:
      if (vector_shift_operand (operands[2], E_V2048QImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10131 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10227 (insn, operands);

    case 27:
      if (vector_shift_operand (operands[2], E_V1HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10132 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10228 (insn, operands);

    case 28:
      if (vector_shift_operand (operands[2], E_V2HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10133 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10229 (insn, operands);

    case 29:
      if (vector_shift_operand (operands[2], E_V4HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10134 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10230 (insn, operands);

    case 30:
      if (vector_shift_operand (operands[2], E_V8HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10135 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10231 (insn, operands);

    case 31:
      if (vector_shift_operand (operands[2], E_V16HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10136 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10232 (insn, operands);

    case 32:
      if (vector_shift_operand (operands[2], E_V32HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10137 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10233 (insn, operands);

    case 33:
      if (vector_shift_operand (operands[2], E_V64HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10138 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10234 (insn, operands);

    case 34:
      if (vector_shift_operand (operands[2], E_V128HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10139 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10235 (insn, operands);

    case 35:
      if (vector_shift_operand (operands[2], E_V256HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10140 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10236 (insn, operands);

    case 36:
      if (vector_shift_operand (operands[2], E_V512HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10141 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10237 (insn, operands);

    case 37:
      if (vector_shift_operand (operands[2], E_V1024HImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10142 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10238 (insn, operands);

    case 38:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10143 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10239 (insn, operands);

    case 39:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10144 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10240 (insn, operands);

    case 40:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10145 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10241 (insn, operands);

    case 41:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10146 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10242 (insn, operands);

    case 42:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10147 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10243 (insn, operands);

    case 43:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10148 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10244 (insn, operands);

    case 44:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10149 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10245 (insn, operands);

    case 45:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10150 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10246 (insn, operands);

    case 46:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10151 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10247 (insn, operands);

    case 47:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && ((
#line 1479 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1481 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return gen_split_10152 (insn, operands);
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !((
#line 1515 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1517 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10248 (insn, operands);

    case 48:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10153 (insn, operands);

    case 49:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10154 (insn, operands);

    case 50:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10155 (insn, operands);

    case 51:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10156 (insn, operands);

    case 52:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10157 (insn, operands);

    case 53:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10158 (insn, operands);

    case 54:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10159 (insn, operands);

    case 55:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10160 (insn, operands);

    case 56:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10161 (insn, operands);

    case 57:
      if (!(
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10162 (insn, operands);

    case 58:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10163 (insn, operands);

    case 59:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10164 (insn, operands);

    case 60:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10165 (insn, operands);

    case 61:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10166 (insn, operands);

    case 62:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10167 (insn, operands);

    case 63:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10168 (insn, operands);

    case 64:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10169 (insn, operands);

    case 65:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10170 (insn, operands);

    case 66:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10171 (insn, operands);

    case 67:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10172 (insn, operands);

    case 68:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10173 (insn, operands);

    case 69:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10174 (insn, operands);

    case 70:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10175 (insn, operands);

    case 71:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10176 (insn, operands);

    case 72:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10177 (insn, operands);

    case 73:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10178 (insn, operands);

    case 74:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10179 (insn, operands);

    case 75:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10180 (insn, operands);

    case 76:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10181 (insn, operands);

    case 77:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10182 (insn, operands);

    case 78:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10183 (insn, operands);

    case 79:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10184 (insn, operands);

    case 80:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10185 (insn, operands);

    case 81:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10186 (insn, operands);

    case 82:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10187 (insn, operands);

    case 83:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10188 (insn, operands);

    case 84:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10189 (insn, operands);

    case 85:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10190 (insn, operands);

    case 86:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10191 (insn, operands);

    case 87:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10192 (insn, operands);

    case 88:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10193 (insn, operands);

    case 89:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10194 (insn, operands);

    case 90:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10195 (insn, operands);

    case 91:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10196 (insn, operands);

    case 92:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10197 (insn, operands);

    case 93:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10198 (insn, operands);

    case 94:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10199 (insn, operands);

    case 95:
      if (!((
#line 1497 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1499 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10200 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_124 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return NULL;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_MERGE)
    return NULL;
  x6 = XVECEXP (x3, 0, 1);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return NULL;
  x7 = XVECEXP (x3, 0, 2);
  operands[6] = x7;
  x8 = XEXP (x5, 1);
  operands[1] = x8;
  x9 = XEXP (x5, 2);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return NULL;
  x11 = XEXP (x5, 0);
  switch (GET_CODE (x11))
    {
    case SIGN_EXTEND:
      switch (pattern591 (x2))
        {
        case 0:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6594 (insn, operands);

        case 1:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6596 (insn, operands);

        case 2:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6598 (insn, operands);

        case 3:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6600 (insn, operands);

        case 4:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6602 (insn, operands);

        case 5:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6604 (insn, operands);

        case 6:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6606 (insn, operands);

        case 7:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6690 (insn, operands);

        case 8:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6608 (insn, operands);

        case 9:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6692 (insn, operands);

        case 10:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6610 (insn, operands);

        case 11:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6694 (insn, operands);

        case 12:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6612 (insn, operands);

        case 13:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6696 (insn, operands);

        case 14:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6614 (insn, operands);

        case 15:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6698 (insn, operands);

        case 16:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6616 (insn, operands);

        case 17:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6700 (insn, operands);

        case 18:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6750 (insn, operands);

        case 19:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6618 (insn, operands);

        case 20:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6702 (insn, operands);

        case 21:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6752 (insn, operands);

        case 22:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6620 (insn, operands);

        case 23:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6704 (insn, operands);

        case 24:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6754 (insn, operands);

        case 25:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6622 (insn, operands);

        case 26:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6706 (insn, operands);

        case 27:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6756 (insn, operands);

        case 28:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6624 (insn, operands);

        case 29:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6626 (insn, operands);

        case 30:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6628 (insn, operands);

        case 31:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6630 (insn, operands);

        case 32:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6632 (insn, operands);

        case 33:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6634 (insn, operands);

        case 34:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6636 (insn, operands);

        case 35:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6638 (insn, operands);

        case 36:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6640 (insn, operands);

        case 37:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6642 (insn, operands);

        case 38:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6644 (insn, operands);

        case 39:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6646 (insn, operands);

        case 40:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6648 (insn, operands);

        case 41:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6708 (insn, operands);

        case 42:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6650 (insn, operands);

        case 43:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6710 (insn, operands);

        case 44:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6652 (insn, operands);

        case 45:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6712 (insn, operands);

        case 46:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6654 (insn, operands);

        case 47:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6714 (insn, operands);

        case 48:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6656 (insn, operands);

        case 49:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6716 (insn, operands);

        case 50:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6658 (insn, operands);

        case 51:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6718 (insn, operands);

        case 52:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6660 (insn, operands);

        case 53:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6720 (insn, operands);

        case 54:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6662 (insn, operands);

        case 55:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6722 (insn, operands);

        case 56:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6664 (insn, operands);

        case 57:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6724 (insn, operands);

        case 58:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6666 (insn, operands);

        case 59:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6726 (insn, operands);

        case 60:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6668 (insn, operands);

        case 61:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6728 (insn, operands);

        case 62:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6670 (insn, operands);

        case 63:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6730 (insn, operands);

        case 64:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1140 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6758 (insn, operands);

        case 65:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6672 (insn, operands);

        case 66:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6732 (insn, operands);

        case 67:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1141 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6760 (insn, operands);

        case 68:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6674 (insn, operands);

        case 69:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6734 (insn, operands);

        case 70:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1142 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6762 (insn, operands);

        case 71:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6676 (insn, operands);

        case 72:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6736 (insn, operands);

        case 73:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1143 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6764 (insn, operands);

        case 74:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6678 (insn, operands);

        case 75:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6738 (insn, operands);

        case 76:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1144 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6766 (insn, operands);

        case 77:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6680 (insn, operands);

        case 78:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6740 (insn, operands);

        case 79:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1145 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6768 (insn, operands);

        case 80:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6682 (insn, operands);

        case 81:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6742 (insn, operands);

        case 82:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1146 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6770 (insn, operands);

        case 83:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6684 (insn, operands);

        case 84:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6744 (insn, operands);

        case 85:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1147 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6772 (insn, operands);

        case 86:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6686 (insn, operands);

        case 87:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6746 (insn, operands);

        case 88:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1148 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6774 (insn, operands);

        case 89:
          if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6688 (insn, operands);

        case 90:
          if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6748 (insn, operands);

        case 91:
          if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1149 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6776 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      return split_123 (x1, insn);

    case FLOAT_EXTEND:
      x12 = XEXP (x11, 0);
      operands[2] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern466 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6856 (insn, operands);

        case E_RVVM4SFmode:
          if (pattern466 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6857 (insn, operands);

        case E_RVVM2SFmode:
          if (pattern466 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6858 (insn, operands);

        case E_RVVM1SFmode:
          if (pattern466 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6859 (insn, operands);

        case E_RVVMF2SFmode:
          if (pattern466 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6860 (insn, operands);

        case E_RVVM8DFmode:
          if (pattern466 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6861 (insn, operands);

        case E_RVVM4DFmode:
          if (pattern466 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6862 (insn, operands);

        case E_RVVM2DFmode:
          if (pattern466 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6863 (insn, operands);

        case E_RVVM1DFmode:
          if (pattern466 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6864 (insn, operands);

        case E_V1SFmode:
          if (pattern466 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6865 (insn, operands);

        case E_V2SFmode:
          if (pattern466 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6866 (insn, operands);

        case E_V4SFmode:
          if (pattern466 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6867 (insn, operands);

        case E_V8SFmode:
          if (pattern466 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6868 (insn, operands);

        case E_V16SFmode:
          if (pattern466 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6869 (insn, operands);

        case E_V32SFmode:
          if (pattern466 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6870 (insn, operands);

        case E_V64SFmode:
          if (pattern466 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6871 (insn, operands);

        case E_V128SFmode:
          if (pattern466 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6872 (insn, operands);

        case E_V256SFmode:
          if (pattern466 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6873 (insn, operands);

        case E_V512SFmode:
          if (pattern466 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6874 (insn, operands);

        case E_V1024SFmode:
          if (pattern466 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6875 (insn, operands);

        case E_V1DFmode:
          if (pattern466 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6876 (insn, operands);

        case E_V2DFmode:
          if (pattern466 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6877 (insn, operands);

        case E_V4DFmode:
          if (pattern466 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6878 (insn, operands);

        case E_V8DFmode:
          if (pattern466 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6879 (insn, operands);

        case E_V16DFmode:
          if (pattern466 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6880 (insn, operands);

        case E_V32DFmode:
          if (pattern466 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6881 (insn, operands);

        case E_V64DFmode:
          if (pattern466 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6882 (insn, operands);

        case E_V128DFmode:
          if (pattern466 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6883 (insn, operands);

        case E_V256DFmode:
          if (pattern466 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6884 (insn, operands);

        case E_V512DFmode:
          if (pattern466 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !((
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 333 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_6885 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_129 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_803 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_809 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_815 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_821 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_827 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_833 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_839 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_845 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_851 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_857 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_863 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_869 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_875 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_881 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_887 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_893 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_899 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_905 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_911 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_917 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_923 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_929 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_935 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_941 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_947 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_953 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_959 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_965 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_971 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_977 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_983 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_989 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_995 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_1001 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1007 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1013 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1019 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1025 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1031 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1037 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1043 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1049 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1055 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1061 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1067 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1073 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1079 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1085 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1091 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1097 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1103 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1109 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1115 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1121 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1127 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1133 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1139 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1145 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1151 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1157 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1163 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1169 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1175 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1181 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1187 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1193 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1199 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1205 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1211 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1217 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1223 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1229 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1235 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1241 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1247 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1253 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1259 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1265 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1271 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1277 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1283 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1289 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1295 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1301 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1307 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1313 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1319 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1325 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1331 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1337 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1343 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1349 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1355 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1361 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1367 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1373 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1379 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1385 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1391 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1397 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1403 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1409 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1415 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1421 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1427 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1433 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1439 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1445 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1451 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1457 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1463 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1469 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1475 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1481 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1487 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1493 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1499 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1505 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1511 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1517 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1523 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1529 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_139 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern150 (x2))
    {
    case 0:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8137 (insn, operands);

    case 1:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8143 (insn, operands);

    case 2:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8149 (insn, operands);

    case 3:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8155 (insn, operands);

    case 4:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8161 (insn, operands);

    case 5:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8167 (insn, operands);

    case 6:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8173 (insn, operands);

    case 7:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8179 (insn, operands);

    case 8:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8185 (insn, operands);

    case 9:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8191 (insn, operands);

    case 10:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8197 (insn, operands);

    case 11:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8203 (insn, operands);

    case 12:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8209 (insn, operands);

    case 13:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8215 (insn, operands);

    case 14:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8221 (insn, operands);

    case 15:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8227 (insn, operands);

    case 16:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8233 (insn, operands);

    case 17:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8239 (insn, operands);

    case 18:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8245 (insn, operands);

    case 19:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8251 (insn, operands);

    case 20:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8257 (insn, operands);

    case 21:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8263 (insn, operands);

    case 22:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8269 (insn, operands);

    case 23:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8275 (insn, operands);

    case 24:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8281 (insn, operands);

    case 25:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8287 (insn, operands);

    case 26:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8293 (insn, operands);

    case 27:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8299 (insn, operands);

    case 28:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8305 (insn, operands);

    case 29:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8311 (insn, operands);

    case 30:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8317 (insn, operands);

    case 31:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8323 (insn, operands);

    case 32:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8329 (insn, operands);

    case 33:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8335 (insn, operands);

    case 34:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8341 (insn, operands);

    case 35:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8347 (insn, operands);

    case 36:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8353 (insn, operands);

    case 37:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8359 (insn, operands);

    case 38:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8365 (insn, operands);

    case 39:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8371 (insn, operands);

    case 40:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8377 (insn, operands);

    case 41:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8383 (insn, operands);

    case 42:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8389 (insn, operands);

    case 43:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8395 (insn, operands);

    case 44:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8401 (insn, operands);

    case 45:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8407 (insn, operands);

    case 46:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8413 (insn, operands);

    case 47:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8419 (insn, operands);

    case 48:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8613 (insn, operands);

    case 49:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8615 (insn, operands);

    case 50:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8617 (insn, operands);

    case 51:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8619 (insn, operands);

    case 52:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8621 (insn, operands);

    case 53:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8623 (insn, operands);

    case 54:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8625 (insn, operands);

    case 55:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8627 (insn, operands);

    case 56:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8629 (insn, operands);

    case 57:
      if (!(
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8631 (insn, operands);

    case 58:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8633 (insn, operands);

    case 59:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8635 (insn, operands);

    case 60:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8637 (insn, operands);

    case 61:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8639 (insn, operands);

    case 62:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8641 (insn, operands);

    case 63:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8643 (insn, operands);

    case 64:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8645 (insn, operands);

    case 65:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8647 (insn, operands);

    case 66:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8649 (insn, operands);

    case 67:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8651 (insn, operands);

    case 68:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8653 (insn, operands);

    case 69:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8655 (insn, operands);

    case 70:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8657 (insn, operands);

    case 71:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8659 (insn, operands);

    case 72:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8661 (insn, operands);

    case 73:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8663 (insn, operands);

    case 74:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8665 (insn, operands);

    case 75:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8667 (insn, operands);

    case 76:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8669 (insn, operands);

    case 77:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8671 (insn, operands);

    case 78:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8673 (insn, operands);

    case 79:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8675 (insn, operands);

    case 80:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8677 (insn, operands);

    case 81:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8679 (insn, operands);

    case 82:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8681 (insn, operands);

    case 83:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8683 (insn, operands);

    case 84:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8685 (insn, operands);

    case 85:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8687 (insn, operands);

    case 86:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8689 (insn, operands);

    case 87:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8691 (insn, operands);

    case 88:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8693 (insn, operands);

    case 89:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8695 (insn, operands);

    case 90:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8697 (insn, operands);

    case 91:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8699 (insn, operands);

    case 92:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8701 (insn, operands);

    case 93:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8703 (insn, operands);

    case 94:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8705 (insn, operands);

    case 95:
      if (!((
#line 669 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 671 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8707 (insn, operands);

    case 96:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8756 (insn, operands);

    case 97:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8757 (insn, operands);

    case 98:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8758 (insn, operands);

    case 99:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8759 (insn, operands);

    case 100:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8760 (insn, operands);

    case 101:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8761 (insn, operands);

    case 102:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8762 (insn, operands);

    case 103:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8763 (insn, operands);

    case 104:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8764 (insn, operands);

    case 105:
      if (!(
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8765 (insn, operands);

    case 106:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8766 (insn, operands);

    case 107:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8767 (insn, operands);

    case 108:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8768 (insn, operands);

    case 109:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8769 (insn, operands);

    case 110:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8770 (insn, operands);

    case 111:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8771 (insn, operands);

    case 112:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8772 (insn, operands);

    case 113:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8773 (insn, operands);

    case 114:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8774 (insn, operands);

    case 115:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8775 (insn, operands);

    case 116:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8776 (insn, operands);

    case 117:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8777 (insn, operands);

    case 118:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8778 (insn, operands);

    case 119:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8779 (insn, operands);

    case 120:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8780 (insn, operands);

    case 121:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8781 (insn, operands);

    case 122:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8782 (insn, operands);

    case 123:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8783 (insn, operands);

    case 124:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8784 (insn, operands);

    case 125:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8785 (insn, operands);

    case 126:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8786 (insn, operands);

    case 127:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8787 (insn, operands);

    case 128:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8788 (insn, operands);

    case 129:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8789 (insn, operands);

    case 130:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8790 (insn, operands);

    case 131:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8791 (insn, operands);

    case 132:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8792 (insn, operands);

    case 133:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8793 (insn, operands);

    case 134:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8794 (insn, operands);

    case 135:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8795 (insn, operands);

    case 136:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8796 (insn, operands);

    case 137:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8797 (insn, operands);

    case 138:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8798 (insn, operands);

    case 139:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8799 (insn, operands);

    case 140:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8800 (insn, operands);

    case 141:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8801 (insn, operands);

    case 142:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8802 (insn, operands);

    case 143:
      if (!((
#line 711 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 713 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8803 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_147 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern226 (x2))
            {
            case 0:
              if (!((
#line 2978 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 2983 "../../gcc/config/riscv/riscv.md"
( 1)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!((
#line 2978 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2983 "../../gcc/config/riscv/riscv.md"
( 1)))
                return NULL;
              return gen_split_44 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_DImode
              || pattern278 (x2, 
E_HImode) != 0)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode)
              || !
#line 170 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
            return NULL;
          return gen_split_187 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern229 (x2))
        {
        case 0:
          if (!((
#line 1020 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1022 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_176 (insn, operands);

        case 1:
          if (!((
#line 1020 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1022 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 2:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2590 (insn, operands);

        case 3:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2604 (insn, operands);

        case 4:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        case 5:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2632 (insn, operands);

        case 6:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2646 (insn, operands);

        case 7:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2660 (insn, operands);

        case 8:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2674 (insn, operands);

        case 9:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2688 (insn, operands);

        case 10:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 11:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2716 (insn, operands);

        case 12:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2730 (insn, operands);

        case 13:
          if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2744 (insn, operands);

        case 14:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2758 (insn, operands);

        case 15:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2772 (insn, operands);

        case 16:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2786 (insn, operands);

        case 17:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2800 (insn, operands);

        case 18:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2814 (insn, operands);

        case 19:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2828 (insn, operands);

        case 20:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2842 (insn, operands);

        case 21:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2856 (insn, operands);

        case 22:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2870 (insn, operands);

        case 23:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2884 (insn, operands);

        case 24:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2898 (insn, operands);

        case 25:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2912 (insn, operands);

        case 26:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2926 (insn, operands);

        case 27:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2940 (insn, operands);

        case 28:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2954 (insn, operands);

        case 29:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2968 (insn, operands);

        case 30:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2982 (insn, operands);

        case 31:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2996 (insn, operands);

        case 32:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3010 (insn, operands);

        case 33:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3024 (insn, operands);

        case 34:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3038 (insn, operands);

        case 35:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3052 (insn, operands);

        case 36:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3066 (insn, operands);

        case 37:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3080 (insn, operands);

        case 38:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3094 (insn, operands);

        case 39:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3108 (insn, operands);

        case 40:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3122 (insn, operands);

        case 41:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3136 (insn, operands);

        case 42:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3150 (insn, operands);

        case 43:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3164 (insn, operands);

        case 44:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3178 (insn, operands);

        case 45:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3192 (insn, operands);

        case 46:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3206 (insn, operands);

        case 47:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3220 (insn, operands);

        case 48:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3234 (insn, operands);

        case 49:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3248 (insn, operands);

        case 50:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3262 (insn, operands);

        case 51:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3276 (insn, operands);

        case 52:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3290 (insn, operands);

        case 53:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3304 (insn, operands);

        case 54:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3318 (insn, operands);

        case 55:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3332 (insn, operands);

        case 56:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3346 (insn, operands);

        case 57:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3360 (insn, operands);

        case 58:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3374 (insn, operands);

        case 59:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3388 (insn, operands);

        case 60:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3402 (insn, operands);

        case 61:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3416 (insn, operands);

        case 62:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3430 (insn, operands);

        case 63:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3444 (insn, operands);

        case 64:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3458 (insn, operands);

        case 65:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3472 (insn, operands);

        case 66:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3486 (insn, operands);

        case 67:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3500 (insn, operands);

        case 68:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3514 (insn, operands);

        case 69:
          if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3528 (insn, operands);

        case 70:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3948 (insn, operands);

        case 71:
          if (!(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3951 (insn, operands);

        case 72:
          if (!(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3954 (insn, operands);

        case 73:
          if (!(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3957 (insn, operands);

        case 74:
          if (!(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3960 (insn, operands);

        case 75:
          if (!(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3963 (insn, operands);

        case 76:
          if (!(
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3966 (insn, operands);

        case 77:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3969 (insn, operands);

        case 78:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3972 (insn, operands);

        case 79:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3975 (insn, operands);

        case 80:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3978 (insn, operands);

        case 81:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3981 (insn, operands);

        case 82:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3984 (insn, operands);

        case 83:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3987 (insn, operands);

        case 84:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3990 (insn, operands);

        case 85:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3993 (insn, operands);

        case 86:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3996 (insn, operands);

        case 87:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3999 (insn, operands);

        case 88:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4002 (insn, operands);

        case 89:
          if (!((
#line 538 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 540 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4005 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern337 (x2, 
E_RVVMF64BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9966 (insn, operands);

        case E_RVVMF32BImode:
          if (pattern337 (x2, 
E_RVVMF32BImode) != 0
              || !(
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9968 (insn, operands);

        case E_RVVMF16BImode:
          if (pattern337 (x2, 
E_RVVMF16BImode) != 0
              || !(
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9970 (insn, operands);

        case E_RVVMF8BImode:
          if (pattern337 (x2, 
E_RVVMF8BImode) != 0
              || !(
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9972 (insn, operands);

        case E_RVVMF4BImode:
          if (pattern337 (x2, 
E_RVVMF4BImode) != 0
              || !(
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9974 (insn, operands);

        case E_RVVMF2BImode:
          if (pattern337 (x2, 
E_RVVMF2BImode) != 0
              || !(
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9976 (insn, operands);

        case E_RVVM1BImode:
          if (pattern337 (x2, 
E_RVVM1BImode) != 0
              || !(
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9978 (insn, operands);

        case E_V1BImode:
          if (pattern337 (x2, 
E_V1BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9980 (insn, operands);

        case E_V2BImode:
          if (pattern337 (x2, 
E_V2BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9982 (insn, operands);

        case E_V4BImode:
          if (pattern337 (x2, 
E_V4BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9984 (insn, operands);

        case E_V8BImode:
          if (pattern337 (x2, 
E_V8BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9986 (insn, operands);

        case E_V16BImode:
          if (pattern337 (x2, 
E_V16BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9988 (insn, operands);

        case E_V32BImode:
          if (pattern337 (x2, 
E_V32BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9990 (insn, operands);

        case E_V64BImode:
          if (pattern337 (x2, 
E_V64BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9992 (insn, operands);

        case E_V128BImode:
          if (pattern337 (x2, 
E_V128BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9994 (insn, operands);

        case E_V256BImode:
          if (pattern337 (x2, 
E_V256BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9996 (insn, operands);

        case E_V512BImode:
          if (pattern337 (x2, 
E_V512BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9998 (insn, operands);

        case E_V1024BImode:
          if (pattern337 (x2, 
E_V1024BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10000 (insn, operands);

        case E_V2048BImode:
          if (pattern337 (x2, 
E_V2048BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10002 (insn, operands);

        case E_V4096BImode:
          if (pattern337 (x2, 
E_V4096BImode) != 0
              || !((
#line 1411 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1413 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10004 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_153 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern117 (x2))
    {
    case 0:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2183 (insn, operands);

    case 1:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2184 (insn, operands);

    case 2:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2185 (insn, operands);

    case 3:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2186 (insn, operands);

    case 4:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2187 (insn, operands);

    case 5:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2188 (insn, operands);

    case 6:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2189 (insn, operands);

    case 7:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2190 (insn, operands);

    case 8:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2191 (insn, operands);

    case 9:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2192 (insn, operands);

    case 10:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2193 (insn, operands);

    case 11:
      if (!(
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2194 (insn, operands);

    case 12:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2195 (insn, operands);

    case 13:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2196 (insn, operands);

    case 14:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2197 (insn, operands);

    case 15:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2198 (insn, operands);

    case 16:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2199 (insn, operands);

    case 17:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2200 (insn, operands);

    case 18:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2201 (insn, operands);

    case 19:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2202 (insn, operands);

    case 20:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2203 (insn, operands);

    case 21:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2204 (insn, operands);

    case 22:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2205 (insn, operands);

    case 23:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2206 (insn, operands);

    case 24:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2207 (insn, operands);

    case 25:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2208 (insn, operands);

    case 26:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2209 (insn, operands);

    case 27:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2210 (insn, operands);

    case 28:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2211 (insn, operands);

    case 29:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2212 (insn, operands);

    case 30:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2213 (insn, operands);

    case 31:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2214 (insn, operands);

    case 32:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2215 (insn, operands);

    case 33:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2216 (insn, operands);

    case 34:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2217 (insn, operands);

    case 35:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2218 (insn, operands);

    case 36:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2219 (insn, operands);

    case 37:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2220 (insn, operands);

    case 38:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2221 (insn, operands);

    case 39:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2222 (insn, operands);

    case 40:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2223 (insn, operands);

    case 41:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2224 (insn, operands);

    case 42:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2225 (insn, operands);

    case 43:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2226 (insn, operands);

    case 44:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2227 (insn, operands);

    case 45:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2228 (insn, operands);

    case 46:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2229 (insn, operands);

    case 47:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2230 (insn, operands);

    case 48:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2231 (insn, operands);

    case 49:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2232 (insn, operands);

    case 50:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2233 (insn, operands);

    case 51:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2234 (insn, operands);

    case 52:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2235 (insn, operands);

    case 53:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2236 (insn, operands);

    case 54:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2237 (insn, operands);

    case 55:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2238 (insn, operands);

    case 56:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2239 (insn, operands);

    case 57:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2240 (insn, operands);

    case 58:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2241 (insn, operands);

    case 59:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2242 (insn, operands);

    case 60:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2243 (insn, operands);

    case 61:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2244 (insn, operands);

    case 62:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2245 (insn, operands);

    case 63:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2246 (insn, operands);

    case 64:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2247 (insn, operands);

    case 65:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2248 (insn, operands);

    case 66:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2249 (insn, operands);

    case 67:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2250 (insn, operands);

    case 68:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2251 (insn, operands);

    case 69:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2252 (insn, operands);

    case 70:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2253 (insn, operands);

    case 71:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2254 (insn, operands);

    case 72:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2255 (insn, operands);

    case 73:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2256 (insn, operands);

    case 74:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2257 (insn, operands);

    case 75:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2258 (insn, operands);

    case 76:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2259 (insn, operands);

    case 77:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2260 (insn, operands);

    case 78:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2261 (insn, operands);

    case 79:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2262 (insn, operands);

    case 80:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2263 (insn, operands);

    case 81:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2264 (insn, operands);

    case 82:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2265 (insn, operands);

    case 83:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2266 (insn, operands);

    case 84:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2267 (insn, operands);

    case 85:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2268 (insn, operands);

    case 86:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2269 (insn, operands);

    case 87:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2270 (insn, operands);

    case 88:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2271 (insn, operands);

    case 89:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2272 (insn, operands);

    case 90:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2273 (insn, operands);

    case 91:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2274 (insn, operands);

    case 92:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2275 (insn, operands);

    case 93:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2276 (insn, operands);

    case 94:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2277 (insn, operands);

    case 95:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2278 (insn, operands);

    case 96:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2279 (insn, operands);

    case 97:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2280 (insn, operands);

    case 98:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2281 (insn, operands);

    case 99:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2282 (insn, operands);

    case 100:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2283 (insn, operands);

    case 101:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2284 (insn, operands);

    case 102:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2285 (insn, operands);

    case 103:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2286 (insn, operands);

    case 104:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2287 (insn, operands);

    case 105:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2288 (insn, operands);

    case 106:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2289 (insn, operands);

    case 107:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2290 (insn, operands);

    case 108:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2291 (insn, operands);

    case 109:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2292 (insn, operands);

    case 110:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2293 (insn, operands);

    case 111:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2294 (insn, operands);

    case 112:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2295 (insn, operands);

    case 113:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2296 (insn, operands);

    case 114:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2297 (insn, operands);

    case 115:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2298 (insn, operands);

    case 116:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2299 (insn, operands);

    case 117:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2300 (insn, operands);

    case 118:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2301 (insn, operands);

    case 119:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2302 (insn, operands);

    case 120:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2303 (insn, operands);

    case 121:
      if (!((
#line 1591 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1593 "../../gcc/config/riscv/vector.md"
( 1)))
        return NULL;
      return gen_split_2304 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_164 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2600 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2614 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2628 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2642 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2656 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2670 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2684 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2698 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2712 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2726 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2740 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2754 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2768 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2782 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2796 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2810 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2824 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2838 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2852 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2866 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2880 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2894 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2908 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2922 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2936 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2950 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2964 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2978 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2992 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3006 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3020 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3034 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3048 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3062 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3076 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3090 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3104 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3118 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3132 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3146 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3160 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3174 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3188 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3202 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3216 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3230 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3244 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3258 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3272 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3286 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3300 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3314 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3328 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3342 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3356 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3370 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3384 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3398 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3412 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3426 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3440 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3454 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3468 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3482 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3496 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3510 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3524 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3538 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_173 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return NULL;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return NULL;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 0);
  switch (GET_CODE (x9))
    {
    case NE:
    case EQ:
      res = split_172 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!fp_native_comparison (x9, E_VOIDmode))
    return NULL;
  switch (pattern406 (x3))
    {
    case 0:
      if (!((
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3354 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_85 (insn, operands);

    case 1:
      if (!((
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3354 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_86 (insn, operands);

    case 2:
      if (!((
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3354 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_87 (insn, operands);

    case 3:
      if (!((
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3354 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_88 (insn, operands);

    case 4:
      if (!((
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3354 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_89 (insn, operands);

    case 5:
      if (!((
#line 3352 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3354 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_90 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_176 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  switch (pattern341 (x6))
    {
    case 0:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1581 (insn, operands);

    case 1:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1592 (insn, operands);

    case 2:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1582 (insn, operands);

    case 3:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1593 (insn, operands);

    case 4:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 918 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1583 (insn, operands);

    case 5:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 918 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1594 (insn, operands);

    case 6:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1584 (insn, operands);

    case 7:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1595 (insn, operands);

    case 8:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 920 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1585 (insn, operands);

    case 9:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 920 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1596 (insn, operands);

    case 10:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1586 (insn, operands);

    case 11:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1597 (insn, operands);

    case 12:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1587 (insn, operands);

    case 13:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1598 (insn, operands);

    case 14:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1588 (insn, operands);

    case 15:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1599 (insn, operands);

    case 16:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1589 (insn, operands);

    case 17:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1600 (insn, operands);

    case 18:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 926 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1590 (insn, operands);

    case 19:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 926 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1601 (insn, operands);

    case 20:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 928 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1591 (insn, operands);

    case 21:
      if (!((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 928 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1333 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1602 (insn, operands);

    case 22:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1603 (insn, operands);

    case 23:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1604 (insn, operands);

    case 24:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1605 (insn, operands);

    case 25:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1606 (insn, operands);

    case 26:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1607 (insn, operands);

    case 27:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1608 (insn, operands);

    case 28:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 29:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 30:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 31:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 32:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 33:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 34:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 35:
      if (!((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1355 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 36:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1987 (insn, operands);

    case 37:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1988 (insn, operands);

    case 38:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1989 (insn, operands);

    case 39:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1990 (insn, operands);

    case 40:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1991 (insn, operands);

    case 41:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1992 (insn, operands);

    case 42:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1993 (insn, operands);

    case 43:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1994 (insn, operands);

    case 44:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1995 (insn, operands);

    case 45:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1996 (insn, operands);

    case 46:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1997 (insn, operands);

    case 47:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1998 (insn, operands);

    case 48:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1999 (insn, operands);

    case 49:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2000 (insn, operands);

    case 50:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2001 (insn, operands);

    case 51:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2002 (insn, operands);

    case 52:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2003 (insn, operands);

    case 53:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2004 (insn, operands);

    case 54:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2005 (insn, operands);

    case 55:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2006 (insn, operands);

    case 56:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2007 (insn, operands);

    case 57:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2008 (insn, operands);

    case 58:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2009 (insn, operands);

    case 59:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2010 (insn, operands);

    case 60:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2011 (insn, operands);

    case 61:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2012 (insn, operands);

    case 62:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2013 (insn, operands);

    case 63:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2014 (insn, operands);

    case 64:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2015 (insn, operands);

    case 65:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2016 (insn, operands);

    case 66:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2017 (insn, operands);

    case 67:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2018 (insn, operands);

    case 68:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4305 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2019 (insn, operands);

    case 69:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4305 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2020 (insn, operands);

    case 70:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4306 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2021 (insn, operands);

    case 71:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4306 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2022 (insn, operands);

    case 72:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4307 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2023 (insn, operands);

    case 73:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4307 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2024 (insn, operands);

    case 74:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4308 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2025 (insn, operands);

    case 75:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4308 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2026 (insn, operands);

    case 76:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4309 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2027 (insn, operands);

    case 77:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4309 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2028 (insn, operands);

    case 78:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4310 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2029 (insn, operands);

    case 79:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4310 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2030 (insn, operands);

    case 80:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4311 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2031 (insn, operands);

    case 81:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4311 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2032 (insn, operands);

    case 82:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4312 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2033 (insn, operands);

    case 83:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4312 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2034 (insn, operands);

    case 84:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4313 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2035 (insn, operands);

    case 85:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4313 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2036 (insn, operands);

    case 86:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4314 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2037 (insn, operands);

    case 87:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4314 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2038 (insn, operands);

    case 88:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4315 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2039 (insn, operands);

    case 89:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4315 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2040 (insn, operands);

    case 90:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4316 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2041 (insn, operands);

    case 91:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4316 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2042 (insn, operands);

    case 92:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4317 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2043 (insn, operands);

    case 93:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4317 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2044 (insn, operands);

    case 94:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4318 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2045 (insn, operands);

    case 95:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4318 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2046 (insn, operands);

    case 96:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4319 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2047 (insn, operands);

    case 97:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4319 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2048 (insn, operands);

    case 98:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4320 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2049 (insn, operands);

    case 99:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4320 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2050 (insn, operands);

    case 100:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4321 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2051 (insn, operands);

    case 101:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4321 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2052 (insn, operands);

    case 102:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4322 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2053 (insn, operands);

    case 103:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4322 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2054 (insn, operands);

    case 104:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4323 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2055 (insn, operands);

    case 105:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4323 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2056 (insn, operands);

    case 106:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4324 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2057 (insn, operands);

    case 107:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4324 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2058 (insn, operands);

    case 108:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4325 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2059 (insn, operands);

    case 109:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4325 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2060 (insn, operands);

    case 110:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4326 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2061 (insn, operands);

    case 111:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4326 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2062 (insn, operands);

    case 112:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4327 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2063 (insn, operands);

    case 113:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4327 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2064 (insn, operands);

    case 114:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4328 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2065 (insn, operands);

    case 115:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4328 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2066 (insn, operands);

    case 116:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4329 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2067 (insn, operands);

    case 117:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4329 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2068 (insn, operands);

    case 118:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4330 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2069 (insn, operands);

    case 119:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4330 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2070 (insn, operands);

    case 120:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4331 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2071 (insn, operands);

    case 121:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4331 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2072 (insn, operands);

    case 122:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4332 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2073 (insn, operands);

    case 123:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4332 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2074 (insn, operands);

    case 124:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4334 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2075 (insn, operands);

    case 125:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4334 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2076 (insn, operands);

    case 126:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4335 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2077 (insn, operands);

    case 127:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4335 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2078 (insn, operands);

    case 128:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4336 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2079 (insn, operands);

    case 129:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4336 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2080 (insn, operands);

    case 130:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4337 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2081 (insn, operands);

    case 131:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4337 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2082 (insn, operands);

    case 132:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4338 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2083 (insn, operands);

    case 133:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4338 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2084 (insn, operands);

    case 134:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4339 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2085 (insn, operands);

    case 135:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4339 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2086 (insn, operands);

    case 136:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4340 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2087 (insn, operands);

    case 137:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4340 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2088 (insn, operands);

    case 138:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4341 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2089 (insn, operands);

    case 139:
      if (!((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4341 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1481 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_2090 (insn, operands);

    default:
      return NULL;
    }
}
