/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          return pattern156 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode); /* [-1, 0] */

        case E_RVVM2HImode:
          if (pattern156 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 1;

        case E_RVVM1HImode:
          if (pattern156 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 2;

        case E_RVVMF2HImode:
          if (pattern156 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4HImode:
          if (pattern156 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 4;

        case E_RVVM4SImode:
          if (pattern156 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (pattern156 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 6;

        case E_RVVM1SImode:
          if (pattern156 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 7;

        case E_RVVMF2SImode:
          if (pattern156 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 8;

        case E_V1HImode:
          if (pattern156 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 9;

        case E_V2HImode:
          if (pattern156 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 10;

        case E_V4HImode:
          if (pattern156 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern156 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16HImode:
          if (pattern156 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 13;

        case E_V32HImode:
          if (pattern156 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 14;

        case E_V64HImode:
          if (pattern156 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 15;

        case E_V128HImode:
          if (pattern156 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 16;

        case E_V256HImode:
          if (pattern156 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 17;

        case E_V512HImode:
          if (pattern156 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 18;

        case E_V1024HImode:
          if (pattern156 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 19;

        case E_V1SImode:
          if (pattern156 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 20;

        case E_V2SImode:
          if (pattern156 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 21;

        case E_V4SImode:
          if (pattern156 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 22;

        case E_V8SImode:
          if (pattern156 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 23;

        case E_V16SImode:
          if (pattern156 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 24;

        case E_V32SImode:
          if (pattern156 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 25;

        case E_V64SImode:
          if (pattern156 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 26;

        case E_V128SImode:
          if (pattern156 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 27;

        case E_V256SImode:
          if (pattern156 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 28;

        case E_V512SImode:
          if (pattern156 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 29;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          if (pattern157 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 30;

        case E_RVVM2HImode:
          if (pattern157 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 31;

        case E_RVVM1HImode:
          if (pattern157 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 32;

        case E_RVVMF2HImode:
          if (pattern157 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 33;

        case E_RVVMF4HImode:
          if (pattern157 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SImode:
          if (pattern157 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SImode:
          if (pattern157 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SImode:
          if (pattern157 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (pattern157 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 38;

        case E_V1HImode:
          if (pattern157 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 39;

        case E_V2HImode:
          if (pattern157 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 40;

        case E_V4HImode:
          if (pattern157 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 41;

        case E_V8HImode:
          if (pattern157 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 42;

        case E_V16HImode:
          if (pattern157 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 43;

        case E_V32HImode:
          if (pattern157 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 44;

        case E_V64HImode:
          if (pattern157 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 45;

        case E_V128HImode:
          if (pattern157 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 46;

        case E_V256HImode:
          if (pattern157 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 47;

        case E_V512HImode:
          if (pattern157 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 48;

        case E_V1024HImode:
          if (pattern157 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 49;

        case E_V1SImode:
          if (pattern157 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 50;

        case E_V2SImode:
          if (pattern157 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 51;

        case E_V4SImode:
          if (pattern157 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 52;

        case E_V8SImode:
          if (pattern157 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 53;

        case E_V16SImode:
          if (pattern157 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 54;

        case E_V32SImode:
          if (pattern157 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 55;

        case E_V64SImode:
          if (pattern157 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 56;

        case E_V128SImode:
          if (pattern157 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 57;

        case E_V256SImode:
          if (pattern157 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 58;

        case E_V512SImode:
          if (pattern157 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 59;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!const_int2_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern204 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HImode
          || !register_operand (operands[3], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HImode
          || !register_operand (operands[3], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HImode
          || !register_operand (operands[3], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HImode
          || !register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HImode
          || !register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SImode
          || !register_operand (operands[3], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SImode
          || !register_operand (operands[3], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SImode
          || !register_operand (operands[3], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SImode
          || !register_operand (operands[3], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SImode
          || !register_operand (operands[3], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DImode
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DImode
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DImode
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DImode
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[3], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[3], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[3], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HImode
          || !register_operand (operands[3], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HImode
          || !register_operand (operands[3], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HImode
          || !register_operand (operands[3], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HImode
          || !register_operand (operands[3], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HImode
          || !register_operand (operands[3], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HImode
          || !register_operand (operands[3], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern204 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[3], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[3], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SImode
          || !register_operand (operands[3], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SImode
          || !register_operand (operands[3], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SImode
          || !register_operand (operands[3], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SImode
          || !register_operand (operands[3], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SImode
          || !register_operand (operands[3], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SImode
          || !register_operand (operands[3], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SImode
          || !register_operand (operands[3], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DImode
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DImode
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DImode
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DImode
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DImode
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DImode
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DImode
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern204 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern204 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern204 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern204 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern204 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern204 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern204 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern204 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern204 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern204 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern322 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern322 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode)
          || GET_MODE (x1) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode))
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x1) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 23;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 24;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 25;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 26;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 27;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 28;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 29;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 30;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode))
        return -1;
      return 31;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 32;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode))
        return -1;
      return 33;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode))
        return -1;
      return 34;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 35;

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode)
          || GET_MODE (x1) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode))
        return -1;
      return 36;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 37;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 38;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 39;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 40;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 41;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 42;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 43;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 44;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 45;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 46;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 47;

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x1) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 48;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 49;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 50;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 51;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 52;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 53;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 54;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 55;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 56;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 57;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 58;

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 59;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 60;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 61;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 62;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 63;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 64;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 65;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 66;

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 67;

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 68;

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern335 (x6); /* [-1, 3] */
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[1], E_V1SImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 9;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 10;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 11;

    case E_V128SImode:
      if (!register_operand (operands[1], E_V128SImode))
        return -1;
      return 12;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 13;

    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 14;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_RVVMF64BImode:
      x3 = XVECEXP (x2, 0, 0);
      return pattern450 (x3, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    case E_V1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V1BImode) != 0)
        return -1;
      return 7;

    case E_V2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V2BImode) != 0)
        return -1;
      return 8;

    case E_V4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V4BImode) != 0)
        return -1;
      return 9;

    case E_V8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V8BImode) != 0)
        return -1;
      return 10;

    case E_V16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V16BImode) != 0)
        return -1;
      return 11;

    case E_V32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V32BImode) != 0)
        return -1;
      return 12;

    case E_V64BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V64BImode) != 0)
        return -1;
      return 13;

    case E_V128BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V128BImode) != 0)
        return -1;
      return 14;

    case E_V256BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V256BImode) != 0)
        return -1;
      return 15;

    case E_V512BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V512BImode) != 0)
        return -1;
      return 16;

    case E_V1024BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V1024BImode) != 0)
        return -1;
      return 17;

    case E_V2048BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V2048BImode) != 0)
        return -1;
      return 18;

    case E_V4096BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V4096BImode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern477 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x1, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x6) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF4BImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 0;

        case E_RVVMF8BImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 1;

        case E_RVVMF16BImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 2;

        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 3;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x6) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF8BImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 5;

        case E_RVVMF16BImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 6;

        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 7;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x6) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF16BImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 9;

        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 10;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x6) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 12;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern476 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern490 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern489 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern489 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern489 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern489 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern489 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern489 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern489 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern489 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern489 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern489 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern489 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern489 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern489 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern489 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern489 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern489 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern489 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern489 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern489 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern489 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern489 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern489 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern489 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern489 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern489 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern489 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern489 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern489 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern489 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern489 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern489 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern489 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern489 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern489 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern489 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern489 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern489 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern489 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern489 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern489 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern489 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern489 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern489 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern489 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern489 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern489 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern489 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern489 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern489 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern489 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern489 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern489 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern489 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern489 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern489 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern489 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern489 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern489 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern489 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern489 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern489 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern489 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern489 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern489 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern489 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern489 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern489 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern489 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern503 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern500 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM4HImode
          || !vector_merge_operand (operands[2], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM2HImode
          || !vector_merge_operand (operands[2], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM1HImode
          || !vector_merge_operand (operands[2], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVMF2HImode
          || !vector_merge_operand (operands[2], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF4HImode
          || !vector_merge_operand (operands[2], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1HImode
          || !vector_merge_operand (operands[2], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2HImode
          || !vector_merge_operand (operands[2], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4HImode
          || !vector_merge_operand (operands[2], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8HImode
          || !vector_merge_operand (operands[2], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16HImode
          || !vector_merge_operand (operands[2], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32HImode
          || !vector_merge_operand (operands[2], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64HImode
          || !vector_merge_operand (operands[2], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128HImode
          || !vector_merge_operand (operands[2], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256HImode
          || !vector_merge_operand (operands[2], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512HImode
          || !vector_merge_operand (operands[2], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024HImode
          || !vector_merge_operand (operands[2], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern500 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern500 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern500 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern500 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern500 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern500 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern500 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern500 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern500 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern500 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern500 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern500 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern500 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern500 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern500 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern500 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern500 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern500 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern500 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[4], E_RVVMF4HFmode)
          || !register_operand (operands[5], E_RVVMF4HFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[4], E_RVVMF2SFmode)
          || !register_operand (operands[5], E_RVVMF2SFmode))
        return -1;
      return 1;

    case E_RVVM1DFmode:
      if (!register_operand (operands[4], E_RVVM1DFmode)
          || !register_operand (operands[5], E_RVVM1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[4], E_V4HFmode)
          || !register_operand (operands[5], E_V4HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[4], E_V4SFmode)
          || !register_operand (operands[5], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[4], E_V4DFmode)
          || !register_operand (operands[5], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[4], E_V32HFmode)
          || !register_operand (operands[5], E_V32HFmode))
        return -1;
      return 0;

    case E_V32SFmode:
      if (!register_operand (operands[4], E_V32SFmode)
          || !register_operand (operands[5], E_V32SFmode))
        return -1;
      return 1;

    case E_V32DFmode:
      if (!register_operand (operands[4], E_V32DFmode)
          || !register_operand (operands[5], E_V32DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[4], E_V256HFmode)
          || !register_operand (operands[5], E_V256HFmode))
        return -1;
      return 0;

    case E_V256SFmode:
      if (!register_operand (operands[4], E_V256SFmode)
          || !register_operand (operands[5], E_V256SFmode))
        return -1;
      return 1;

    case E_V256DFmode:
      if (!register_operand (operands[4], E_V256DFmode)
          || !register_operand (operands[5], E_V256DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern622 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!register_operand (operands[5], i3))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern628 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode)
          || !vector_arith_operand (operands[2], E_RVVM1HImode))
        return -1;
      return 0;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode)
          || !vector_arith_operand (operands[2], E_RVVM2SImode))
        return -1;
      return 1;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode)
          || !vector_arith_operand (operands[2], E_RVVM4DImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode)
          || !vector_arith_operand (operands[2], E_RVVMF2QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern632 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode)
          || !register_operand (operands[2], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode)
          || !register_operand (operands[2], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode)
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew8_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern639 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew32_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern656 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 1;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern676 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_RVVM1DImode
      || !register_operand (operands[4], E_RVVM1DImode)
      || !vector_merge_operand (operands[2], E_RVVM1DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      return 4;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 5;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      return 6;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      return 7;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      return 8;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      return 9;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      return 10;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      return 11;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      return 12;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern680 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern683 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_broadcast_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern690 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x1, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern697 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[2], i3)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern708 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern712 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew8_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew64_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern719 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern599 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern599 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern599 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern599 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern599 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern599 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern599 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern599 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern599 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern599 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern599 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern599 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern599 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern599 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern599 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern599 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern599 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern599 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern599 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern599 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern599 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern599 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern550 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern550 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern550 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern550 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern550 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern550 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern550 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern550 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern550 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern550 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern550 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern550 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern550 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern550 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern550 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern550 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern550 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern550 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern550 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern550 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern550 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern550 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern550 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern550 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern550 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern550 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern550 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern550 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern550 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern550 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern550 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern550 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern550 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern550 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern550 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern550 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern550 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern550 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern550 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern550 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern550 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern550 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern550 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern550 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern550 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern550 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern736 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern739 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern744 (rtx x1, int i1, machine_mode i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i2)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i2)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i2)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i2)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i2)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i2)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i2)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i2)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i2)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i2)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i2)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i2)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i2)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i2)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i2)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i2)
    return -1;
  switch (REGNO (x7))
    {
    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21
          || REGNO (x22) != 20
          || REGNO (x27) != 19)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i2)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i2)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i2)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x32) != 18)
        return -1;
      return 0;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i2)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i2)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i2)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x32) != 8)
        return -1;
      x37 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x37) != SET)
        return -1;
      x38 = XEXP (x37, 1);
      if (GET_CODE (x38) != MEM
          || GET_MODE (x38) != i2)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != i2)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 2
          || GET_MODE (x40) != i2)
        return -1;
      x41 = XEXP (x39, 1);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x42 = XEXP (x37, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 1
          || GET_MODE (x42) != i2)
        return -1;
      x43 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x43) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 1
          || GET_MODE (x45) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 19:
      if (REGNO (x12) != 18
          || REGNO (x17) != 9
          || REGNO (x22) != 8
          || REGNO (x27) != 1)
        return -1;
      x33 = XEXP (x31, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x32) != 10)
        return -1;
      x37 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x37) != USE)
        return -1;
      x42 = XEXP (x37, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 10
          || GET_MODE (x42) != i2)
        return -1;
      x43 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x43) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 1
          || GET_MODE (x45) != E_SImode
          || !stack_pop_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern764 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x12) != 23
          || REGNO (x17) != 22
          || REGNO (x22) != 21
          || REGNO (x27) != 20
          || REGNO (x32) != 19
          || REGNO (x37) != 18
          || REGNO (x42) != 9)
        return -1;
      return 0;

    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19
          || REGNO (x27) != 18
          || REGNO (x32) != 9
          || REGNO (x37) != 8
          || REGNO (x42) != 1)
        return -1;
      x48 = XEXP (x46, 1);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x47) != 10)
        return -1;
      x49 = XVECEXP (x1, 0, 10);
      if (pattern750 (x49, 
i1, 
10) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -72L)
    return -1;
  return 0;
}

int
pattern778 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != PLUS
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 2
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
    return -1;
  x15 = XEXP (x10, 0);
  if (REGNO (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x16) != SET)
    return -1;
  x17 = XEXP (x16, 1);
  return pattern777 (x17); /* [-1, 0] */
}

int
pattern783 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s7_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 9
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PLUS
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern787 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
    return -1;
  x6 = XEXP (x1, 0);
  return pattern786 (x6, 
E_SImode); /* [-1, 0] */
}

int
pattern792 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -88L)
    return -1;
  return 0;
}

int
pattern795 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s9_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 11);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 13);
  return pattern779 (x5, 
E_SImode, 
1); /* [-1, 0] */
}

int
pattern800 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s11_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern802 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -104L)
    return -1;
  x6 = XEXP (x1, 0);
  return pattern800 (x6, 
E_DImode); /* [-1, 0] */
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 325 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC))
        return -1;
      return 890; /* *th_maddhisi4 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30257; /* *dual_widen_fmasrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30259; /* *dual_widen_fmasrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30261; /* *dual_widen_fmasrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30263; /* *dual_widen_fmasrvvm1hi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30265; /* *dual_widen_fmasrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30267; /* *dual_widen_fmasrvvmf4hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30269; /* *dual_widen_fmasrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30271; /* *dual_widen_fmasrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30273; /* *dual_widen_fmasrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
          || !
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30275; /* *dual_widen_fmasrvvm1si */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30277; /* *dual_widen_fmasrvvmf2si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30279; /* *dual_widen_fmasrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30281; /* *dual_widen_fmasrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30283; /* *dual_widen_fmasrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30285; /* *dual_widen_fmasrvvm1di */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1HImode, 
E_V1QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30287; /* *dual_widen_fmasv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2HImode, 
E_V2QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30289; /* *dual_widen_fmasv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V4HImode, 
E_V4QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30291; /* *dual_widen_fmasv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V8HImode, 
E_V8QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30293; /* *dual_widen_fmasv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V16HImode, 
E_V16QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30295; /* *dual_widen_fmasv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V32HImode, 
E_V32QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30297; /* *dual_widen_fmasv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V64HImode, 
E_V64QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30299; /* *dual_widen_fmasv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V128HImode, 
E_V128QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30301; /* *dual_widen_fmasv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V256HImode, 
E_V256QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30303; /* *dual_widen_fmasv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V512HImode, 
E_V512QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30305; /* *dual_widen_fmasv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30307; /* *dual_widen_fmasv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30309; /* *dual_widen_fmasv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1SImode, 
E_V1HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30311; /* *dual_widen_fmasv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2SImode, 
E_V2HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30313; /* *dual_widen_fmasv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V4SImode, 
E_V4HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30315; /* *dual_widen_fmasv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V8SImode, 
E_V8HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30317; /* *dual_widen_fmasv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V16SImode, 
E_V16HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30319; /* *dual_widen_fmasv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V32SImode, 
E_V32HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30321; /* *dual_widen_fmasv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V64SImode, 
E_V64HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30323; /* *dual_widen_fmasv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V128SImode, 
E_V128HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30325; /* *dual_widen_fmasv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V256SImode, 
E_V256HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30327; /* *dual_widen_fmasv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V512SImode, 
E_V512HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30329; /* *dual_widen_fmasv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30331; /* *dual_widen_fmasv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1DImode, 
E_V1SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30333; /* *dual_widen_fmasv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2DImode, 
E_V2SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30335; /* *dual_widen_fmasv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V4DImode, 
E_V4SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30337; /* *dual_widen_fmasv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V8DImode, 
E_V8SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30339; /* *dual_widen_fmasv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V16DImode, 
E_V16SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30341; /* *dual_widen_fmasv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V32DImode, 
E_V32SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30343; /* *dual_widen_fmasv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V64DImode, 
E_V64SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30345; /* *dual_widen_fmasv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V128DImode, 
E_V128SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30347; /* *dual_widen_fmasv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V256DImode, 
E_V256SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30349; /* *dual_widen_fmasv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V512DImode, 
E_V512SImode) != 0
          || !(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30351; /* *dual_widen_fmasv512di */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !
#line 901 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 12; /* subsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 901 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 13; /* subdf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 901 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 14; /* subhf3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern352 (x2, 
E_DImode) != 0
          || !
#line 910 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 15; /* subdi3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern352 (x2, 
E_SImode) != 0)
        return -1;
      return 16; /* *subsi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23615; /* subrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23629; /* subrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23643; /* subrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23657; /* subrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23671; /* subrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23685; /* subrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23699; /* subrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23713; /* subrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23727; /* subrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23741; /* subrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23755; /* subrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23769; /* subrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23783; /* subrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23797; /* subrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23811; /* subrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23825; /* subrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23839; /* subrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23853; /* subrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23867; /* subrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23881; /* subrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23895; /* subrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23909; /* subrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23923; /* subv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23937; /* subv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23951; /* subv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23965; /* subv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23979; /* subv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 23993; /* subv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24007; /* subv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24021; /* subv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24035; /* subv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24049; /* subv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24063; /* subv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24077; /* subv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24091; /* subv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24105; /* subv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24119; /* subv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24133; /* subv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24147; /* subv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24161; /* subv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24175; /* subv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24189; /* subv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24203; /* subv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24217; /* subv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24231; /* subv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24245; /* subv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24259; /* subv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24273; /* subv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24287; /* subv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24301; /* subv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24315; /* subv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24329; /* subv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24343; /* subv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24357; /* subv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24371; /* subv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24385; /* subv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24399; /* subv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24413; /* subv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24427; /* subv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24441; /* subv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24455; /* subv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24469; /* subv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24483; /* subv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24497; /* subv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24511; /* subv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24525; /* subv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24539; /* subv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24553; /* subv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26582; /* subrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26586; /* subrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26590; /* subrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26594; /* subrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26598; /* subrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26602; /* subrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26606; /* subrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26610; /* subrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26614; /* subrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26618; /* subrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26622; /* subrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26626; /* subrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26630; /* subrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26634; /* subrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26638; /* subrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26642; /* subv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26646; /* subv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26650; /* subv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26654; /* subv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26658; /* subv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26662; /* subv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26666; /* subv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26670; /* subv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26674; /* subv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26678; /* subv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26682; /* subv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26686; /* subv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26690; /* subv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26694; /* subv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26698; /* subv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26702; /* subv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26706; /* subv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26710; /* subv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26714; /* subv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26718; /* subv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26722; /* subv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26726; /* subv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26730; /* subv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26734; /* subv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26738; /* subv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26742; /* subv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26746; /* subv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26750; /* subv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26754; /* subv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26758; /* subv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26762; /* subv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26766; /* subv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26770; /* subv512df3 */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern155 (x2))
    {
    case 0:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28931; /* *narrow_ashrextendrvvm8hi */

    case 1:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28935; /* *narrow_ashrextendrvvm4hi */

    case 2:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28939; /* *narrow_ashrextendrvvm2hi */

    case 3:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28943; /* *narrow_ashrextendrvvm1hi */

    case 4:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28947; /* *narrow_ashrextendrvvmf2hi */

    case 5:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28951; /* *narrow_ashrextendrvvmf4hi */

    case 6:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28955; /* *narrow_ashrextendrvvm8si */

    case 7:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28959; /* *narrow_ashrextendrvvm4si */

    case 8:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28963; /* *narrow_ashrextendrvvm2si */

    case 9:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28967; /* *narrow_ashrextendrvvm1si */

    case 10:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28971; /* *narrow_ashrextendrvvmf2si */

    case 11:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28975; /* *narrow_ashrextendrvvm8di */

    case 12:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28979; /* *narrow_ashrextendrvvm4di */

    case 13:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28983; /* *narrow_ashrextendrvvm2di */

    case 14:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28987; /* *narrow_ashrextendrvvm1di */

    case 15:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28991; /* *narrow_ashrextendv1hi */

    case 16:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28995; /* *narrow_ashrextendv2hi */

    case 17:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28999; /* *narrow_ashrextendv4hi */

    case 18:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29003; /* *narrow_ashrextendv8hi */

    case 19:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29007; /* *narrow_ashrextendv16hi */

    case 20:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29011; /* *narrow_ashrextendv32hi */

    case 21:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29015; /* *narrow_ashrextendv64hi */

    case 22:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29019; /* *narrow_ashrextendv128hi */

    case 23:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29023; /* *narrow_ashrextendv256hi */

    case 24:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29027; /* *narrow_ashrextendv512hi */

    case 25:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29031; /* *narrow_ashrextendv1024hi */

    case 26:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29035; /* *narrow_ashrextendv2048hi */

    case 27:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29039; /* *narrow_ashrextendv1si */

    case 28:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29043; /* *narrow_ashrextendv2si */

    case 29:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29047; /* *narrow_ashrextendv4si */

    case 30:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29051; /* *narrow_ashrextendv8si */

    case 31:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29055; /* *narrow_ashrextendv16si */

    case 32:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29059; /* *narrow_ashrextendv32si */

    case 33:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29063; /* *narrow_ashrextendv64si */

    case 34:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29067; /* *narrow_ashrextendv128si */

    case 35:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29071; /* *narrow_ashrextendv256si */

    case 36:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29075; /* *narrow_ashrextendv512si */

    case 37:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29079; /* *narrow_ashrextendv1024si */

    case 38:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29083; /* *narrow_ashrextendv1di */

    case 39:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29087; /* *narrow_ashrextendv2di */

    case 40:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29091; /* *narrow_ashrextendv4di */

    case 41:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29095; /* *narrow_ashrextendv8di */

    case 42:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29099; /* *narrow_ashrextendv16di */

    case 43:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29103; /* *narrow_ashrextendv32di */

    case 44:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29107; /* *narrow_ashrextendv64di */

    case 45:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29111; /* *narrow_ashrextendv128di */

    case 46:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29115; /* *narrow_ashrextendv256di */

    case 47:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29119; /* *narrow_ashrextendv512di */

    case 48:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28933; /* *narrow_ashrzero_extendrvvm8hi */

    case 49:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28937; /* *narrow_ashrzero_extendrvvm4hi */

    case 50:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28941; /* *narrow_ashrzero_extendrvvm2hi */

    case 51:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28945; /* *narrow_ashrzero_extendrvvm1hi */

    case 52:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28949; /* *narrow_ashrzero_extendrvvmf2hi */

    case 53:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28953; /* *narrow_ashrzero_extendrvvmf4hi */

    case 54:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28957; /* *narrow_ashrzero_extendrvvm8si */

    case 55:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28961; /* *narrow_ashrzero_extendrvvm4si */

    case 56:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28965; /* *narrow_ashrzero_extendrvvm2si */

    case 57:
      if (!
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28969; /* *narrow_ashrzero_extendrvvm1si */

    case 58:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28973; /* *narrow_ashrzero_extendrvvmf2si */

    case 59:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28977; /* *narrow_ashrzero_extendrvvm8di */

    case 60:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28981; /* *narrow_ashrzero_extendrvvm4di */

    case 61:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28985; /* *narrow_ashrzero_extendrvvm2di */

    case 62:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28989; /* *narrow_ashrzero_extendrvvm1di */

    case 63:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28993; /* *narrow_ashrzero_extendv1hi */

    case 64:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28997; /* *narrow_ashrzero_extendv2hi */

    case 65:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29001; /* *narrow_ashrzero_extendv4hi */

    case 66:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29005; /* *narrow_ashrzero_extendv8hi */

    case 67:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29009; /* *narrow_ashrzero_extendv16hi */

    case 68:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29013; /* *narrow_ashrzero_extendv32hi */

    case 69:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29017; /* *narrow_ashrzero_extendv64hi */

    case 70:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29021; /* *narrow_ashrzero_extendv128hi */

    case 71:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29025; /* *narrow_ashrzero_extendv256hi */

    case 72:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29029; /* *narrow_ashrzero_extendv512hi */

    case 73:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29033; /* *narrow_ashrzero_extendv1024hi */

    case 74:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29037; /* *narrow_ashrzero_extendv2048hi */

    case 75:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29041; /* *narrow_ashrzero_extendv1si */

    case 76:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29045; /* *narrow_ashrzero_extendv2si */

    case 77:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29049; /* *narrow_ashrzero_extendv4si */

    case 78:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29053; /* *narrow_ashrzero_extendv8si */

    case 79:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29057; /* *narrow_ashrzero_extendv16si */

    case 80:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29061; /* *narrow_ashrzero_extendv32si */

    case 81:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29065; /* *narrow_ashrzero_extendv64si */

    case 82:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29069; /* *narrow_ashrzero_extendv128si */

    case 83:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29073; /* *narrow_ashrzero_extendv256si */

    case 84:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29077; /* *narrow_ashrzero_extendv512si */

    case 85:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29081; /* *narrow_ashrzero_extendv1024si */

    case 86:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29085; /* *narrow_ashrzero_extendv1di */

    case 87:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29089; /* *narrow_ashrzero_extendv2di */

    case 88:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29093; /* *narrow_ashrzero_extendv4di */

    case 89:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29097; /* *narrow_ashrzero_extendv8di */

    case 90:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29101; /* *narrow_ashrzero_extendv16di */

    case 91:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29105; /* *narrow_ashrzero_extendv32di */

    case 92:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29109; /* *narrow_ashrzero_extendv64di */

    case 93:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29113; /* *narrow_ashrzero_extendv128di */

    case 94:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29117; /* *narrow_ashrzero_extendv256di */

    case 95:
      if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29121; /* *narrow_ashrzero_extendv512di */

    case 96:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29123; /* *narrow_ashrrvvm8hi_scalar */

    case 97:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29125; /* *narrow_ashrrvvm4hi_scalar */

    case 98:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29127; /* *narrow_ashrrvvm2hi_scalar */

    case 99:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29129; /* *narrow_ashrrvvm1hi_scalar */

    case 100:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29131; /* *narrow_ashrrvvmf2hi_scalar */

    case 101:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29133; /* *narrow_ashrrvvmf4hi_scalar */

    case 102:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29135; /* *narrow_ashrrvvm8si_scalar */

    case 103:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29137; /* *narrow_ashrrvvm4si_scalar */

    case 104:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29139; /* *narrow_ashrrvvm2si_scalar */

    case 105:
      if (!
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29141; /* *narrow_ashrrvvm1si_scalar */

    case 106:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29143; /* *narrow_ashrrvvmf2si_scalar */

    case 107:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29145; /* *narrow_ashrrvvm8di_scalar */

    case 108:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29147; /* *narrow_ashrrvvm4di_scalar */

    case 109:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29149; /* *narrow_ashrrvvm2di_scalar */

    case 110:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29151; /* *narrow_ashrrvvm1di_scalar */

    case 111:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29153; /* *narrow_ashrv1hi_scalar */

    case 112:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29155; /* *narrow_ashrv2hi_scalar */

    case 113:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29157; /* *narrow_ashrv4hi_scalar */

    case 114:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29159; /* *narrow_ashrv8hi_scalar */

    case 115:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29161; /* *narrow_ashrv16hi_scalar */

    case 116:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29163; /* *narrow_ashrv32hi_scalar */

    case 117:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29165; /* *narrow_ashrv64hi_scalar */

    case 118:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29167; /* *narrow_ashrv128hi_scalar */

    case 119:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29169; /* *narrow_ashrv256hi_scalar */

    case 120:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29171; /* *narrow_ashrv512hi_scalar */

    case 121:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29173; /* *narrow_ashrv1024hi_scalar */

    case 122:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29175; /* *narrow_ashrv2048hi_scalar */

    case 123:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29177; /* *narrow_ashrv1si_scalar */

    case 124:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29179; /* *narrow_ashrv2si_scalar */

    case 125:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29181; /* *narrow_ashrv4si_scalar */

    case 126:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29183; /* *narrow_ashrv8si_scalar */

    case 127:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29185; /* *narrow_ashrv16si_scalar */

    case 128:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29187; /* *narrow_ashrv32si_scalar */

    case 129:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29189; /* *narrow_ashrv64si_scalar */

    case 130:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29191; /* *narrow_ashrv128si_scalar */

    case 131:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29193; /* *narrow_ashrv256si_scalar */

    case 132:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29195; /* *narrow_ashrv512si_scalar */

    case 133:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29197; /* *narrow_ashrv1024si_scalar */

    case 134:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29199; /* *narrow_ashrv1di_scalar */

    case 135:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29201; /* *narrow_ashrv2di_scalar */

    case 136:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29203; /* *narrow_ashrv4di_scalar */

    case 137:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29205; /* *narrow_ashrv8di_scalar */

    case 138:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29207; /* *narrow_ashrv16di_scalar */

    case 139:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29209; /* *narrow_ashrv32di_scalar */

    case 140:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29211; /* *narrow_ashrv64di_scalar */

    case 141:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29213; /* *narrow_ashrv128di_scalar */

    case 142:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29215; /* *narrow_ashrv256di_scalar */

    case 143:
      if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29217; /* *narrow_ashrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern162 (x1))
    {
    case 0:
      if (!(
#line 3549 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 394; /* fle_quietsfsi4_zfa */

    case 1:
      if (!(
#line 3549 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 398; /* fle_quietdfsi4_zfa */

    case 2:
      if (!(
#line 3549 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 402; /* fle_quiethfsi4_zfa */

    case 3:
      if (!(
#line 3549 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 396; /* fle_quietsfdi4_zfa */

    case 4:
      if (!(
#line 3549 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 400; /* fle_quietdfdi4_zfa */

    case 5:
      if (!(
#line 3549 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 404; /* fle_quiethfdi4_zfa */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_10_operand (operands[2], E_SImode)
      || !
#line 261 "../../gcc/config/riscv/crypto.md"
((TARGET_ZKND || TARGET_ZKNE) && TARGET_64BIT))
    return -1;
  return 672; /* riscv_aes64ks1i */
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2489; /* vundefinedrvvm8qi */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2490; /* vundefinedrvvm4qi */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2491; /* vundefinedrvvm2qi */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2492; /* vundefinedrvvm1qi */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2493; /* vundefinedrvvm8hi */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2494; /* vundefinedrvvm4hi */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2495; /* vundefinedrvvm2hi */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2496; /* vundefinedrvvm1hi */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2497; /* vundefinedrvvm8si */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2498; /* vundefinedrvvm4si */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2499; /* vundefinedrvvm2si */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2500; /* vundefinedrvvm1si */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2501; /* vundefinedrvvm8di */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2502; /* vundefinedrvvm4di */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2503; /* vundefinedrvvm2di */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2504; /* vundefinedrvvm1di */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 2505; /* vundefinedrvvmf2qi */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 2506; /* vundefinedrvvmf4qi */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2507; /* vundefinedrvvmf8qi */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 2508; /* vundefinedrvvmf2hi */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2509; /* vundefinedrvvmf4hi */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2510; /* vundefinedrvvmf2si */

    case E_RVVM8BFmode:
      if (!register_operand (operands[0], E_RVVM8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8BFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2511; /* vundefinedrvvm8bf */

    case E_RVVM4BFmode:
      if (!register_operand (operands[0], E_RVVM4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4BFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2512; /* vundefinedrvvm4bf */

    case E_RVVM2BFmode:
      if (!register_operand (operands[0], E_RVVM2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2BFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2513; /* vundefinedrvvm2bf */

    case E_RVVM1BFmode:
      if (!register_operand (operands[0], E_RVVM1BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2514; /* vundefinedrvvm1bf */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[0], E_RVVMF2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2515; /* vundefinedrvvmf2bf */

    case E_RVVMF4BFmode:
      if (!register_operand (operands[0], E_RVVMF4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2516; /* vundefinedrvvmf4bf */

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2517; /* vundefinedrvvm8hf */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2518; /* vundefinedrvvm4hf */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2519; /* vundefinedrvvm2hf */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2520; /* vundefinedrvvm1hf */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2521; /* vundefinedrvvmf2hf */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2522; /* vundefinedrvvmf4hf */

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2523; /* vundefinedrvvm8sf */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2524; /* vundefinedrvvm4sf */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2525; /* vundefinedrvvm2sf */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2526; /* vundefinedrvvm1sf */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2527; /* vundefinedrvvmf2sf */

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2528; /* vundefinedrvvm8df */

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2529; /* vundefinedrvvm4df */

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2530; /* vundefinedrvvm2df */

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !(
#line 1013 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2531; /* vundefinedrvvm1df */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !(
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2532; /* vundefinedrvvmf64bi */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2533; /* vundefinedrvvmf32bi */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2534; /* vundefinedrvvmf16bi */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2535; /* vundefinedrvvmf8bi */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2536; /* vundefinedrvvmf4bi */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2537; /* vundefinedrvvmf2bi */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !
#line 1020 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2538; /* vundefinedrvvm1bi */

    case E_RVVMF8x2QImode:
      if (!register_operand (operands[0], E_RVVMF8x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x2QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2539; /* vundefinedrvvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[0], E_RVVMF8x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x3QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2540; /* vundefinedrvvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[0], E_RVVMF8x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x4QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2541; /* vundefinedrvvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[0], E_RVVMF8x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x5QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2542; /* vundefinedrvvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[0], E_RVVMF8x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x6QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2543; /* vundefinedrvvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[0], E_RVVMF8x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x7QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2544; /* vundefinedrvvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[0], E_RVVMF8x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x8QImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2545; /* vundefinedrvvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[0], E_RVVMF4x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2546; /* vundefinedrvvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[0], E_RVVMF4x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2547; /* vundefinedrvvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[0], E_RVVMF4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2548; /* vundefinedrvvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[0], E_RVVMF4x5HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2549; /* vundefinedrvvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[0], E_RVVMF4x6HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2550; /* vundefinedrvvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[0], E_RVVMF4x7HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2551; /* vundefinedrvvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[0], E_RVVMF4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8HImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2552; /* vundefinedrvvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[0], E_RVVMF2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2553; /* vundefinedrvvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[0], E_RVVMF2x3SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2554; /* vundefinedrvvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[0], E_RVVMF2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2555; /* vundefinedrvvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[0], E_RVVMF2x5SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2556; /* vundefinedrvvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[0], E_RVVMF2x6SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2557; /* vundefinedrvvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[0], E_RVVMF2x7SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2558; /* vundefinedrvvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[0], E_RVVMF2x8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8SImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2559; /* vundefinedrvvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[0], E_RVVM1x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2560; /* vundefinedrvvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[0], E_RVVM1x3DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2561; /* vundefinedrvvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[0], E_RVVM1x4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2562; /* vundefinedrvvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[0], E_RVVM1x5DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2563; /* vundefinedrvvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[0], E_RVVM1x6DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2564; /* vundefinedrvvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[0], E_RVVM1x7DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2565; /* vundefinedrvvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[0], E_RVVM1x8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2566; /* vundefinedrvvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[0], E_RVVMF4x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2567; /* vundefinedrvvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[0], E_RVVMF4x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2568; /* vundefinedrvvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[0], E_RVVMF4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2569; /* vundefinedrvvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[0], E_RVVMF4x5BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2570; /* vundefinedrvvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[0], E_RVVMF4x6BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2571; /* vundefinedrvvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[0], E_RVVMF4x7BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2572; /* vundefinedrvvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[0], E_RVVMF4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2573; /* vundefinedrvvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[0], E_RVVMF4x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2574; /* vundefinedrvvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[0], E_RVVMF4x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2575; /* vundefinedrvvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[0], E_RVVMF4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2576; /* vundefinedrvvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[0], E_RVVMF4x5HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2577; /* vundefinedrvvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[0], E_RVVMF4x6HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2578; /* vundefinedrvvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[0], E_RVVMF4x7HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2579; /* vundefinedrvvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[0], E_RVVMF4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2580; /* vundefinedrvvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[0], E_RVVMF2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2581; /* vundefinedrvvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[0], E_RVVMF2x3SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2582; /* vundefinedrvvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[0], E_RVVMF2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2583; /* vundefinedrvvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[0], E_RVVMF2x5SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2584; /* vundefinedrvvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[0], E_RVVMF2x6SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2585; /* vundefinedrvvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[0], E_RVVMF2x7SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2586; /* vundefinedrvvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[0], E_RVVMF2x8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2587; /* vundefinedrvvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[0], E_RVVM1x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2588; /* vundefinedrvvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[0], E_RVVM1x3DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2589; /* vundefinedrvvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[0], E_RVVM1x4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2590; /* vundefinedrvvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[0], E_RVVM1x5DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2591; /* vundefinedrvvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[0], E_RVVM1x6DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2592; /* vundefinedrvvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[0], E_RVVM1x7DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2593; /* vundefinedrvvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[0], E_RVVM1x8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2594; /* vundefinedrvvm1x8df */

    case E_RVVMF4x2QImode:
      if (!register_operand (operands[0], E_RVVMF4x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2595; /* vundefinedrvvmf4x2qi */

    case E_RVVMF4x3QImode:
      if (!register_operand (operands[0], E_RVVMF4x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2596; /* vundefinedrvvmf4x3qi */

    case E_RVVMF4x4QImode:
      if (!register_operand (operands[0], E_RVVMF4x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2597; /* vundefinedrvvmf4x4qi */

    case E_RVVMF4x5QImode:
      if (!register_operand (operands[0], E_RVVMF4x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2598; /* vundefinedrvvmf4x5qi */

    case E_RVVMF4x6QImode:
      if (!register_operand (operands[0], E_RVVMF4x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2599; /* vundefinedrvvmf4x6qi */

    case E_RVVMF4x7QImode:
      if (!register_operand (operands[0], E_RVVMF4x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2600; /* vundefinedrvvmf4x7qi */

    case E_RVVMF4x8QImode:
      if (!register_operand (operands[0], E_RVVMF4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2601; /* vundefinedrvvmf4x8qi */

    case E_RVVMF2x2HImode:
      if (!register_operand (operands[0], E_RVVMF2x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2602; /* vundefinedrvvmf2x2hi */

    case E_RVVMF2x3HImode:
      if (!register_operand (operands[0], E_RVVMF2x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2603; /* vundefinedrvvmf2x3hi */

    case E_RVVMF2x4HImode:
      if (!register_operand (operands[0], E_RVVMF2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2604; /* vundefinedrvvmf2x4hi */

    case E_RVVMF2x5HImode:
      if (!register_operand (operands[0], E_RVVMF2x5HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2605; /* vundefinedrvvmf2x5hi */

    case E_RVVMF2x6HImode:
      if (!register_operand (operands[0], E_RVVMF2x6HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2606; /* vundefinedrvvmf2x6hi */

    case E_RVVMF2x7HImode:
      if (!register_operand (operands[0], E_RVVMF2x7HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2607; /* vundefinedrvvmf2x7hi */

    case E_RVVMF2x8HImode:
      if (!register_operand (operands[0], E_RVVMF2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2608; /* vundefinedrvvmf2x8hi */

    case E_RVVM1x2SImode:
      if (!register_operand (operands[0], E_RVVM1x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2609; /* vundefinedrvvm1x2si */

    case E_RVVM1x3SImode:
      if (!register_operand (operands[0], E_RVVM1x3SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2610; /* vundefinedrvvm1x3si */

    case E_RVVM1x4SImode:
      if (!register_operand (operands[0], E_RVVM1x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2611; /* vundefinedrvvm1x4si */

    case E_RVVM1x5SImode:
      if (!register_operand (operands[0], E_RVVM1x5SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2612; /* vundefinedrvvm1x5si */

    case E_RVVM1x6SImode:
      if (!register_operand (operands[0], E_RVVM1x6SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2613; /* vundefinedrvvm1x6si */

    case E_RVVM1x7SImode:
      if (!register_operand (operands[0], E_RVVM1x7SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2614; /* vundefinedrvvm1x7si */

    case E_RVVM1x8SImode:
      if (!register_operand (operands[0], E_RVVM1x8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2615; /* vundefinedrvvm1x8si */

    case E_RVVM2x2DImode:
      if (!register_operand (operands[0], E_RVVM2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2616; /* vundefinedrvvm2x2di */

    case E_RVVM2x3DImode:
      if (!register_operand (operands[0], E_RVVM2x3DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2617; /* vundefinedrvvm2x3di */

    case E_RVVM2x4DImode:
      if (!register_operand (operands[0], E_RVVM2x4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2618; /* vundefinedrvvm2x4di */

    case E_RVVMF2x2BFmode:
      if (!register_operand (operands[0], E_RVVMF2x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2619; /* vundefinedrvvmf2x2bf */

    case E_RVVMF2x3BFmode:
      if (!register_operand (operands[0], E_RVVMF2x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2620; /* vundefinedrvvmf2x3bf */

    case E_RVVMF2x4BFmode:
      if (!register_operand (operands[0], E_RVVMF2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2621; /* vundefinedrvvmf2x4bf */

    case E_RVVMF2x5BFmode:
      if (!register_operand (operands[0], E_RVVMF2x5BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2622; /* vundefinedrvvmf2x5bf */

    case E_RVVMF2x6BFmode:
      if (!register_operand (operands[0], E_RVVMF2x6BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2623; /* vundefinedrvvmf2x6bf */

    case E_RVVMF2x7BFmode:
      if (!register_operand (operands[0], E_RVVMF2x7BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2624; /* vundefinedrvvmf2x7bf */

    case E_RVVMF2x8BFmode:
      if (!register_operand (operands[0], E_RVVMF2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2625; /* vundefinedrvvmf2x8bf */

    case E_RVVMF2x2HFmode:
      if (!register_operand (operands[0], E_RVVMF2x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2626; /* vundefinedrvvmf2x2hf */

    case E_RVVMF2x3HFmode:
      if (!register_operand (operands[0], E_RVVMF2x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2627; /* vundefinedrvvmf2x3hf */

    case E_RVVMF2x4HFmode:
      if (!register_operand (operands[0], E_RVVMF2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2628; /* vundefinedrvvmf2x4hf */

    case E_RVVMF2x5HFmode:
      if (!register_operand (operands[0], E_RVVMF2x5HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2629; /* vundefinedrvvmf2x5hf */

    case E_RVVMF2x6HFmode:
      if (!register_operand (operands[0], E_RVVMF2x6HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2630; /* vundefinedrvvmf2x6hf */

    case E_RVVMF2x7HFmode:
      if (!register_operand (operands[0], E_RVVMF2x7HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2631; /* vundefinedrvvmf2x7hf */

    case E_RVVMF2x8HFmode:
      if (!register_operand (operands[0], E_RVVMF2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2632; /* vundefinedrvvmf2x8hf */

    case E_RVVM1x2SFmode:
      if (!register_operand (operands[0], E_RVVM1x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2633; /* vundefinedrvvm1x2sf */

    case E_RVVM1x3SFmode:
      if (!register_operand (operands[0], E_RVVM1x3SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2634; /* vundefinedrvvm1x3sf */

    case E_RVVM1x4SFmode:
      if (!register_operand (operands[0], E_RVVM1x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2635; /* vundefinedrvvm1x4sf */

    case E_RVVM1x5SFmode:
      if (!register_operand (operands[0], E_RVVM1x5SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2636; /* vundefinedrvvm1x5sf */

    case E_RVVM1x6SFmode:
      if (!register_operand (operands[0], E_RVVM1x6SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2637; /* vundefinedrvvm1x6sf */

    case E_RVVM1x7SFmode:
      if (!register_operand (operands[0], E_RVVM1x7SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2638; /* vundefinedrvvm1x7sf */

    case E_RVVM1x8SFmode:
      if (!register_operand (operands[0], E_RVVM1x8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2639; /* vundefinedrvvm1x8sf */

    case E_RVVM2x2DFmode:
      if (!register_operand (operands[0], E_RVVM2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2640; /* vundefinedrvvm2x2df */

    case E_RVVM2x3DFmode:
      if (!register_operand (operands[0], E_RVVM2x3DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2641; /* vundefinedrvvm2x3df */

    case E_RVVM2x4DFmode:
      if (!register_operand (operands[0], E_RVVM2x4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2642; /* vundefinedrvvm2x4df */

    case E_RVVMF2x2QImode:
      if (!register_operand (operands[0], E_RVVMF2x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2643; /* vundefinedrvvmf2x2qi */

    case E_RVVMF2x3QImode:
      if (!register_operand (operands[0], E_RVVMF2x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2644; /* vundefinedrvvmf2x3qi */

    case E_RVVMF2x4QImode:
      if (!register_operand (operands[0], E_RVVMF2x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2645; /* vundefinedrvvmf2x4qi */

    case E_RVVMF2x5QImode:
      if (!register_operand (operands[0], E_RVVMF2x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2646; /* vundefinedrvvmf2x5qi */

    case E_RVVMF2x6QImode:
      if (!register_operand (operands[0], E_RVVMF2x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2647; /* vundefinedrvvmf2x6qi */

    case E_RVVMF2x7QImode:
      if (!register_operand (operands[0], E_RVVMF2x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2648; /* vundefinedrvvmf2x7qi */

    case E_RVVMF2x8QImode:
      if (!register_operand (operands[0], E_RVVMF2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2649; /* vundefinedrvvmf2x8qi */

    case E_RVVM1x2HImode:
      if (!register_operand (operands[0], E_RVVM1x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2650; /* vundefinedrvvm1x2hi */

    case E_RVVM1x3HImode:
      if (!register_operand (operands[0], E_RVVM1x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2651; /* vundefinedrvvm1x3hi */

    case E_RVVM1x4HImode:
      if (!register_operand (operands[0], E_RVVM1x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2652; /* vundefinedrvvm1x4hi */

    case E_RVVM1x5HImode:
      if (!register_operand (operands[0], E_RVVM1x5HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2653; /* vundefinedrvvm1x5hi */

    case E_RVVM1x6HImode:
      if (!register_operand (operands[0], E_RVVM1x6HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2654; /* vundefinedrvvm1x6hi */

    case E_RVVM1x7HImode:
      if (!register_operand (operands[0], E_RVVM1x7HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2655; /* vundefinedrvvm1x7hi */

    case E_RVVM1x8HImode:
      if (!register_operand (operands[0], E_RVVM1x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2656; /* vundefinedrvvm1x8hi */

    case E_RVVM2x2SImode:
      if (!register_operand (operands[0], E_RVVM2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2657; /* vundefinedrvvm2x2si */

    case E_RVVM2x3SImode:
      if (!register_operand (operands[0], E_RVVM2x3SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2658; /* vundefinedrvvm2x3si */

    case E_RVVM2x4SImode:
      if (!register_operand (operands[0], E_RVVM2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2659; /* vundefinedrvvm2x4si */

    case E_RVVM4x2DImode:
      if (!register_operand (operands[0], E_RVVM4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2DImode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2660; /* vundefinedrvvm4x2di */

    case E_RVVM1x2BFmode:
      if (!register_operand (operands[0], E_RVVM1x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2661; /* vundefinedrvvm1x2bf */

    case E_RVVM1x3BFmode:
      if (!register_operand (operands[0], E_RVVM1x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2662; /* vundefinedrvvm1x3bf */

    case E_RVVM1x4BFmode:
      if (!register_operand (operands[0], E_RVVM1x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2663; /* vundefinedrvvm1x4bf */

    case E_RVVM1x5BFmode:
      if (!register_operand (operands[0], E_RVVM1x5BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2664; /* vundefinedrvvm1x5bf */

    case E_RVVM1x6BFmode:
      if (!register_operand (operands[0], E_RVVM1x6BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2665; /* vundefinedrvvm1x6bf */

    case E_RVVM1x7BFmode:
      if (!register_operand (operands[0], E_RVVM1x7BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2666; /* vundefinedrvvm1x7bf */

    case E_RVVM1x8BFmode:
      if (!register_operand (operands[0], E_RVVM1x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2667; /* vundefinedrvvm1x8bf */

    case E_RVVM1x2HFmode:
      if (!register_operand (operands[0], E_RVVM1x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2668; /* vundefinedrvvm1x2hf */

    case E_RVVM1x3HFmode:
      if (!register_operand (operands[0], E_RVVM1x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2669; /* vundefinedrvvm1x3hf */

    case E_RVVM1x4HFmode:
      if (!register_operand (operands[0], E_RVVM1x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2670; /* vundefinedrvvm1x4hf */

    case E_RVVM1x5HFmode:
      if (!register_operand (operands[0], E_RVVM1x5HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2671; /* vundefinedrvvm1x5hf */

    case E_RVVM1x6HFmode:
      if (!register_operand (operands[0], E_RVVM1x6HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2672; /* vundefinedrvvm1x6hf */

    case E_RVVM1x7HFmode:
      if (!register_operand (operands[0], E_RVVM1x7HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2673; /* vundefinedrvvm1x7hf */

    case E_RVVM1x8HFmode:
      if (!register_operand (operands[0], E_RVVM1x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2674; /* vundefinedrvvm1x8hf */

    case E_RVVM2x2SFmode:
      if (!register_operand (operands[0], E_RVVM2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2675; /* vundefinedrvvm2x2sf */

    case E_RVVM2x3SFmode:
      if (!register_operand (operands[0], E_RVVM2x3SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2676; /* vundefinedrvvm2x3sf */

    case E_RVVM2x4SFmode:
      if (!register_operand (operands[0], E_RVVM2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2677; /* vundefinedrvvm2x4sf */

    case E_RVVM4x2DFmode:
      if (!register_operand (operands[0], E_RVVM4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2DFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2678; /* vundefinedrvvm4x2df */

    case E_RVVM1x2QImode:
      if (!register_operand (operands[0], E_RVVM1x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2679; /* vundefinedrvvm1x2qi */

    case E_RVVM1x3QImode:
      if (!register_operand (operands[0], E_RVVM1x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2680; /* vundefinedrvvm1x3qi */

    case E_RVVM1x4QImode:
      if (!register_operand (operands[0], E_RVVM1x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2681; /* vundefinedrvvm1x4qi */

    case E_RVVM1x5QImode:
      if (!register_operand (operands[0], E_RVVM1x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2682; /* vundefinedrvvm1x5qi */

    case E_RVVM1x6QImode:
      if (!register_operand (operands[0], E_RVVM1x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2683; /* vundefinedrvvm1x6qi */

    case E_RVVM1x7QImode:
      if (!register_operand (operands[0], E_RVVM1x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2684; /* vundefinedrvvm1x7qi */

    case E_RVVM1x8QImode:
      if (!register_operand (operands[0], E_RVVM1x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2685; /* vundefinedrvvm1x8qi */

    case E_RVVM2x2HImode:
      if (!register_operand (operands[0], E_RVVM2x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2686; /* vundefinedrvvm2x2hi */

    case E_RVVM2x3HImode:
      if (!register_operand (operands[0], E_RVVM2x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2687; /* vundefinedrvvm2x3hi */

    case E_RVVM2x4HImode:
      if (!register_operand (operands[0], E_RVVM2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2688; /* vundefinedrvvm2x4hi */

    case E_RVVM4x2SImode:
      if (!register_operand (operands[0], E_RVVM4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2SImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2689; /* vundefinedrvvm4x2si */

    case E_RVVM2x2BFmode:
      if (!register_operand (operands[0], E_RVVM2x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2690; /* vundefinedrvvm2x2bf */

    case E_RVVM2x3BFmode:
      if (!register_operand (operands[0], E_RVVM2x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2691; /* vundefinedrvvm2x3bf */

    case E_RVVM2x4BFmode:
      if (!register_operand (operands[0], E_RVVM2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2692; /* vundefinedrvvm2x4bf */

    case E_RVVM2x2HFmode:
      if (!register_operand (operands[0], E_RVVM2x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2693; /* vundefinedrvvm2x2hf */

    case E_RVVM2x3HFmode:
      if (!register_operand (operands[0], E_RVVM2x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2694; /* vundefinedrvvm2x3hf */

    case E_RVVM2x4HFmode:
      if (!register_operand (operands[0], E_RVVM2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2695; /* vundefinedrvvm2x4hf */

    case E_RVVM4x2SFmode:
      if (!register_operand (operands[0], E_RVVM4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2SFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2696; /* vundefinedrvvm4x2sf */

    case E_RVVM2x2QImode:
      if (!register_operand (operands[0], E_RVVM2x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2697; /* vundefinedrvvm2x2qi */

    case E_RVVM2x3QImode:
      if (!register_operand (operands[0], E_RVVM2x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2698; /* vundefinedrvvm2x3qi */

    case E_RVVM2x4QImode:
      if (!register_operand (operands[0], E_RVVM2x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2699; /* vundefinedrvvm2x4qi */

    case E_RVVM4x2HImode:
      if (!register_operand (operands[0], E_RVVM4x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2HImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2700; /* vundefinedrvvm4x2hi */

    case E_RVVM4x2BFmode:
      if (!register_operand (operands[0], E_RVVM4x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2BFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2701; /* vundefinedrvvm4x2bf */

    case E_RVVM4x2HFmode:
      if (!register_operand (operands[0], E_RVVM4x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2HFmode
          || !(
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2702; /* vundefinedrvvm4x2hf */

    case E_RVVM4x2QImode:
      if (!register_operand (operands[0], E_RVVM4x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2QImode
          || !
#line 1027 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2703; /* vundefinedrvvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern190 (x1))
    {
    case 0:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19396; /* pred_slide1uprvvm8qi */

    case 1:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19398; /* pred_slide1uprvvm4qi */

    case 2:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19400; /* pred_slide1uprvvm2qi */

    case 3:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19402; /* pred_slide1uprvvm1qi */

    case 4:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19404; /* pred_slide1uprvvmf2qi */

    case 5:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19406; /* pred_slide1uprvvmf4qi */

    case 6:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 19408; /* pred_slide1uprvvmf8qi */

    case 7:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19410; /* pred_slide1uprvvm8hi */

    case 8:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19412; /* pred_slide1uprvvm4hi */

    case 9:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19414; /* pred_slide1uprvvm2hi */

    case 10:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19416; /* pred_slide1uprvvm1hi */

    case 11:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19418; /* pred_slide1uprvvmf2hi */

    case 12:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 19420; /* pred_slide1uprvvmf4hi */

    case 13:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19422; /* pred_slide1uprvvm8si */

    case 14:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19424; /* pred_slide1uprvvm4si */

    case 15:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19426; /* pred_slide1uprvvm2si */

    case 16:
      if (!
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19428; /* pred_slide1uprvvm1si */

    case 17:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 19430; /* pred_slide1uprvvmf2si */

    case 18:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 19432; /* pred_slide1upv1qi */

    case 19:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 19434; /* pred_slide1upv2qi */

    case 20:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 19436; /* pred_slide1upv4qi */

    case 21:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 19438; /* pred_slide1upv8qi */

    case 22:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 19440; /* pred_slide1upv16qi */

    case 23:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 19442; /* pred_slide1upv32qi */

    case 24:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19444; /* pred_slide1upv64qi */

    case 25:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19446; /* pred_slide1upv128qi */

    case 26:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19448; /* pred_slide1upv256qi */

    case 27:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19450; /* pred_slide1upv512qi */

    case 28:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19452; /* pred_slide1upv1024qi */

    case 29:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19454; /* pred_slide1upv2048qi */

    case 30:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19456; /* pred_slide1upv4096qi */

    case 31:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 19458; /* pred_slide1upv1hi */

    case 32:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 19460; /* pred_slide1upv2hi */

    case 33:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 19462; /* pred_slide1upv4hi */

    case 34:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 19464; /* pred_slide1upv8hi */

    case 35:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 19466; /* pred_slide1upv16hi */

    case 36:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19468; /* pred_slide1upv32hi */

    case 37:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19470; /* pred_slide1upv64hi */

    case 38:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19472; /* pred_slide1upv128hi */

    case 39:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19474; /* pred_slide1upv256hi */

    case 40:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19476; /* pred_slide1upv512hi */

    case 41:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19478; /* pred_slide1upv1024hi */

    case 42:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19480; /* pred_slide1upv2048hi */

    case 43:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 19482; /* pred_slide1upv1si */

    case 44:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 19484; /* pred_slide1upv2si */

    case 45:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 19486; /* pred_slide1upv4si */

    case 46:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 19488; /* pred_slide1upv8si */

    case 47:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19490; /* pred_slide1upv16si */

    case 48:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19492; /* pred_slide1upv32si */

    case 49:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19494; /* pred_slide1upv64si */

    case 50:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19496; /* pred_slide1upv128si */

    case 51:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19498; /* pred_slide1upv256si */

    case 52:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19500; /* pred_slide1upv512si */

    case 53:
      if (!(
#line 8000 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19502; /* pred_slide1upv1024si */

    case 54:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19504; /* *pred_slide1uprvvm8di */

    case 55:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19506; /* *pred_slide1uprvvm4di */

    case 56:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19508; /* *pred_slide1uprvvm2di */

    case 57:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19510; /* *pred_slide1uprvvm1di */

    case 58:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19512; /* *pred_slide1upv1di */

    case 59:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19514; /* *pred_slide1upv2di */

    case 60:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19516; /* *pred_slide1upv4di */

    case 61:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19518; /* *pred_slide1upv8di */

    case 62:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19520; /* *pred_slide1upv16di */

    case 63:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19522; /* *pred_slide1upv32di */

    case 64:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19524; /* *pred_slide1upv64di */

    case 65:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19526; /* *pred_slide1upv128di */

    case 66:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19528; /* *pred_slide1upv256di */

    case 67:
      if (!(
#line 8044 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19530; /* *pred_slide1upv512di */

    case 68:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19532; /* *pred_slide1uprvvm8di_extended */

    case 69:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19534; /* *pred_slide1uprvvm4di_extended */

    case 70:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19536; /* *pred_slide1uprvvm2di_extended */

    case 71:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19538; /* *pred_slide1uprvvm1di_extended */

    case 72:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19540; /* *pred_slide1upv1di_extended */

    case 73:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19542; /* *pred_slide1upv2di_extended */

    case 74:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19544; /* *pred_slide1upv4di_extended */

    case 75:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19546; /* *pred_slide1upv8di_extended */

    case 76:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19548; /* *pred_slide1upv16di_extended */

    case 77:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19550; /* *pred_slide1upv32di_extended */

    case 78:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19552; /* *pred_slide1upv64di_extended */

    case 79:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19554; /* *pred_slide1upv128di_extended */

    case 80:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19556; /* *pred_slide1upv256di_extended */

    case 81:
      if (!(
#line 8064 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19558; /* *pred_slide1upv512di_extended */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 36:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          switch (pattern328 (x2, 
E_HFmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 142; /* *movhf_softfloat_boxing */

            case 1:
              if (!(
#line 2064 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 144; /* *movhf_softfloat_boxing */

            default:
              return -1;
            }

        case E_BFmode:
          switch (pattern328 (x2, 
E_BFmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 143; /* *movbf_softfloat_boxing */

            case 1:
              if (!(
#line 2064 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZFHMIN) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 145; /* *movbf_softfloat_boxing */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern172 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 2163 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 176; /* *lrintsfsi2 */

            case 1:
              if (!(
#line 2163 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 177; /* *lrintdfsi2 */

            case 2:
              if (!(
#line 2163 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 178; /* *lrinthfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern172 (x2, 
E_DImode))
            {
            case 0:
              if (!(
#line 2183 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 182; /* lrintsfdi2 */

            case 1:
              if (!(
#line 2183 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 183; /* lrintdfdi2 */

            case 2:
              if (!(
#line 2183 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 184; /* lrinthfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 17:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 185; /* *lroundsfsi2 */

        case 1:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 191; /* *lrounddfsi2 */

        case 2:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 197; /* *lroundhfsi2 */

        case 3:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 221; /* lroundsfdi2 */

        case 4:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 227; /* lrounddfdi2 */

        case 5:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 233; /* lroundhfdi2 */

        case 6:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 239; /* roundsf_zfa2 */

        case 7:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 245; /* rounddf_zfa2 */

        case 8:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 251; /* roundhf_zfa2 */

        default:
          return -1;
        }

    case 18:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 186; /* *lfloorsfsi2 */

        case 1:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 192; /* *lfloordfsi2 */

        case 2:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 198; /* *lfloorhfsi2 */

        case 3:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 222; /* lfloorsfdi2 */

        case 4:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 228; /* lfloordfdi2 */

        case 5:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 234; /* lfloorhfdi2 */

        case 6:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 240; /* floorsf_zfa2 */

        case 7:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 246; /* floordf_zfa2 */

        case 8:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 252; /* floorhf_zfa2 */

        default:
          return -1;
        }

    case 19:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 187; /* *lceilsfsi2 */

        case 1:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 193; /* *lceildfsi2 */

        case 2:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 199; /* *lceilhfsi2 */

        case 3:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 223; /* lceilsfdi2 */

        case 4:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 229; /* lceildfdi2 */

        case 5:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 235; /* lceilhfdi2 */

        case 6:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 241; /* ceilsf_zfa2 */

        case 7:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 247; /* ceildf_zfa2 */

        case 8:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 253; /* ceilhf_zfa2 */

        default:
          return -1;
        }

    case 20:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 188; /* *lbtruncsfsi2 */

        case 1:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 194; /* *lbtruncdfsi2 */

        case 2:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 200; /* *lbtrunchfsi2 */

        case 3:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 224; /* lbtruncsfdi2 */

        case 4:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 230; /* lbtruncdfdi2 */

        case 5:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 236; /* lbtrunchfdi2 */

        case 6:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 242; /* btruncsf_zfa2 */

        case 7:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 248; /* btruncdf_zfa2 */

        case 8:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 254; /* btrunchf_zfa2 */

        default:
          return -1;
        }

    case 21:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 189; /* *lroundevensfsi2 */

        case 1:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 195; /* *lroundevendfsi2 */

        case 2:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 201; /* *lroundevenhfsi2 */

        case 3:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 225; /* lroundevensfdi2 */

        case 4:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 231; /* lroundevendfdi2 */

        case 5:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 237; /* lroundevenhfdi2 */

        case 6:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 243; /* roundevensf_zfa2 */

        case 7:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 249; /* roundevendf_zfa2 */

        case 8:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 255; /* roundevenhf_zfa2 */

        default:
          return -1;
        }

    case 22:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 190; /* *lnearbyintsfsi2 */

        case 1:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 196; /* *lnearbyintdfsi2 */

        case 2:
          if (!(
#line 2212 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 202; /* *lnearbyinthfsi2 */

        case 3:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 226; /* lnearbyintsfdi2 */

        case 4:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 232; /* lnearbyintdfdi2 */

        case 5:
          if (!(
#line 2232 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 238; /* lnearbyinthfdi2 */

        case 6:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 244; /* nearbyintsf_zfa2 */

        case 7:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 250; /* nearbyintdf_zfa2 */

        case 8:
          if (!(
#line 2310 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 256; /* nearbyinthf_zfa2 */

        default:
          return -1;
        }

    case 16:
      return recog_51 (x1, insn, pnum_clobbers);

    case 4:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 260; /* got_loadsi */

        case 1:
          if (!
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 261; /* got_loaddi */

        default:
          return -1;
        }

    case 8:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 264; /* got_load_tls_gdsi */

        case 1:
          if (!
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 265; /* got_load_tls_gddi */

        default:
          return -1;
        }

    case 7:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 266; /* got_load_tls_iesi */

        case 1:
          if (!
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 267; /* got_load_tls_iedi */

        default:
          return -1;
        }

    case 9:
      return recog_53 (x1, insn, pnum_clobbers);

    case 14:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 2685 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
        return -1;
      return 290; /* movsidf2_low_rv32 */

    case 15:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 2697 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
        return -1;
      return 291; /* movsidf2_high_rv32 */

    case 28:
      return recog_52 (x1, insn, pnum_clobbers);

    case 30:
      switch (pattern175 (x1))
        {
        case 0:
          if (
#line 465 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return 550; /* orcbsi2 */
          if (!(
#line 140 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 873; /* th_tstnbzsi2 */

        case 1:
          if ((
#line 465 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 551; /* orcbdi2 */
          if (!(
#line 140 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 874; /* th_tstnbzdi2 */

        default:
          return -1;
        }

    case 41:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 78 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB))
            return -1;
          return 645; /* riscv_brev8_si */

        case 1:
          if (!(
#line 78 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 646; /* riscv_brev8_di */

        default:
          return -1;
        }

    case 42:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 86 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && !TARGET_64BIT))
        return -1;
      return 647; /* riscv_zip */

    case 43:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 94 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && !TARGET_64BIT))
        return -1;
      return 648; /* riscv_unzip */

    case 53:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 252 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKND && TARGET_64BIT))
        return -1;
      return 671; /* riscv_aes64im */

    case 60:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 678; /* *riscv_sha256sig0_si */

    case 61:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 679; /* *riscv_sha256sig1_si */

    case 62:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 680; /* *riscv_sha256sum0_si */

    case 63:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 327 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && !TARGET_64BIT))
        return -1;
      return 681; /* *riscv_sha256sum1_si */

    case 64:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 419 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 692; /* riscv_sha512sig0 */

    case 67:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 427 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 693; /* riscv_sha512sig1 */

    case 70:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 435 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 694; /* riscv_sha512sum0 */

    case 72:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 443 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
        return -1;
      return 695; /* riscv_sha512sum1 */

    case 74:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 456 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSH && !TARGET_64BIT))
        return -1;
      return 696; /* *riscv_sm3p0_si */

    case 75:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 456 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSH && !TARGET_64BIT))
        return -1;
      return 697; /* *riscv_sm3p1_si */

    case 37:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 199 "../../gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 882; /* th_fmv_x_w */

    case 38:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 209 "../../gcc/config/riscv/thead.md"
(!TARGET_64BIT && TARGET_XTHEADFMV))
        return -1;
      return 883; /* th_fmv_x_hw */

    case 90:
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 0
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      return recog_48 (x1, insn, pnum_clobbers);

    case 92:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[1], E_SImode)
              || !(
#line 1079 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            return -1;
          return 2704; /* vlmax_avlsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const_int_operand (operands[1], E_DImode)
              || !(
#line 1079 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          return 2705; /* vlmax_avldi */

        default:
          return -1;
        }

    case 141:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      return recog_49 (x1, insn, pnum_clobbers);

    case 143:
      return recog_50 (x1, insn, pnum_clobbers);

    case 274:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1555 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 32947; /* riscv_cv_simd_abs_h_si */

    case 275:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1564 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 32948; /* riscv_cv_simd_abs_b_si */

    case 276:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1573 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 32949; /* riscv_cv_simd_neg_h_si */

    case 277:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1582 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 32950; /* riscv_cv_simd_neg_b_si */

    case 360:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2597 "../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33033; /* riscv_cv_simd_cplxconj_si */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!absolute_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 802; /* *local_pic_load_uqi */

        case E_HImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 805; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 808; /* *local_pic_load_usi */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 803; /* *local_pic_load_uqi */

        case E_HImode:
          if (!
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 806; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 809; /* *local_pic_load_usi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 804; /* *local_pic_load_uqi */

        case E_HImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 807; /* *local_pic_load_uhi */

        case E_SImode:
          if (!(
#line 44 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 810; /* *local_pic_load_usi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048BImode)
      && reg_or_mem_operand (operands[1], E_V2048BImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4340 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3317; /* *movv2048bisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4340 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3318; /* *movv2048bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048BImode)
      || !register_operand (operands[1], E_V2048BImode)
      || !(
#line 1529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3490; /* *movv2048bi_vls */
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128BImode)
      && reg_or_mem_operand (operands[1], E_V128BImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4336 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3309; /* *movv128bisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4336 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3310; /* *movv128bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128BImode)
      || !register_operand (operands[1], E_V128BImode)
      || !(
#line 1529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3486; /* *movv128bi_vls */
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128DFmode)
      && reg_or_mem_operand (operands[1], E_V128DFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4330 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3299; /* *movv128dfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4330 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3300; /* *movv128dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128DFmode)
      || !register_operand (operands[1], E_V128DFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3397; /* *movv128df_vls */
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256SFmode)
      && reg_or_mem_operand (operands[1], E_V256SFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4325 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3289; /* *movv256sfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4325 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3290; /* *movv256sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256SFmode)
      || !register_operand (operands[1], E_V256SFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3387; /* *movv256sf_vls */
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HFmode)
      && reg_or_mem_operand (operands[1], E_V1024HFmode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4320 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3279; /* *movv1024hfsi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4320 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3280; /* *movv1024hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HFmode)
      || !register_operand (operands[1], E_V1024HFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3377; /* *movv1024hf_vls */
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512DImode)
      && reg_or_mem_operand (operands[1], E_V512DImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4314 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3267; /* *movv512disi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4314 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3268; /* *movv512didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512DImode)
      || !register_operand (operands[1], E_V512DImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3366; /* *movv512di_vls */
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SImode)
      && reg_or_mem_operand (operands[1], E_V512SImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4308 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3255; /* *movv512sisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4308 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3256; /* *movv512sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SImode)
      || !register_operand (operands[1], E_V512SImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3355; /* *movv512si_vls */
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3243; /* *movv1024hisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3244; /* *movv1024hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3344; /* *movv1024hi_vls */
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3231; /* *movv4096qisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3232; /* *movv4096qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3333; /* *movv4096qi_vls */
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode))
    {
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3219; /* *movv64qisi_lra */
        }
      if ((
#line 1477 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3220; /* *movv64qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3327; /* *movv64qi_vls */
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF32BImode)
      && register_operand (operands[1], E_RVVMF32BImode)
      && 
#line 1293 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2798; /* *movrvvmf32bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF32BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF32BImode))
    return -1;
  if ((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2835; /* *movrvvmf32bisi_lra */
    }
  if (!(
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2836; /* *movrvvmf32bidi_lra */
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2BFmode)
      && register_operand (operands[1], E_RVVMF2BFmode)
      && (
#line 1256 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
    return 2780; /* *movrvvmf2bf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2BFmode))
    return -1;
  if ((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2816; /* *movrvvmf2bfsi_lra */
    }
  if (!(
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 922 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2827; /* *movrvvmf2bfdi_lra */
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16BImode)
      && reg_or_mem_operand (operands[1], E_V16BImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))) && 
#line 4285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return 3216; /* *movv16bi */
  if (!register_operand (operands[0], E_V16BImode)
      || !register_operand (operands[1], E_V16BImode)
      || !(
#line 1529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return -1;
  return 3483; /* *movv16bi_vls */
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 3211; /* *movv16df */
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3394; /* *movv16df_vls */
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SFmode)
      && reg_or_mem_operand (operands[1], E_V4SFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))) && 
#line 4272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3204; /* *movv4sf */
  if (!register_operand (operands[0], E_V4SFmode)
      || !register_operand (operands[1], E_V4SFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3381; /* *movv4sf_vls */
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3197; /* *movv1hf */
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3367; /* *movv1hf_vls */
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SImode)
      && reg_or_mem_operand (operands[1], E_V8SImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))) && 
#line 4258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 3190; /* *movv8si */
  if (!register_operand (operands[0], E_V8SImode)
      || !register_operand (operands[1], E_V8SImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 3349; /* *movv8si_vls */
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HImode)
      && reg_or_mem_operand (operands[1], E_V2HImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 4251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 3183; /* *movv2hi */
  if (!register_operand (operands[0], E_V2HImode)
      || !register_operand (operands[1], E_V2HImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 3335; /* *movv2hi_vls */
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_SImode)
      && splittable_const_int_operand (operands[1], E_SImode)
      && 
#line 2458 "../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], SImode)
        || high_mask_shift_operand (operands[1], SImode))))
    return 274; /* *mvconst_internal */
  if (!nonimmediate_operand (operands[0], E_SImode)
      || !move_operand (operands[1], E_SImode)
      || !
#line 2520 "../../gcc/config/riscv/riscv.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
    && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))))
    return -1;
  return 278; /* *movsi_internal */
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3161; /* *movrvvm4x2sf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3162; /* *movrvvm4x2sf_di */
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3147; /* *movrvvm4x2si_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3148; /* *movrvvm4x2si_di */
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3135; /* *movrvvm1x6qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3136; /* *movrvvm1x6qi_di */
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3SFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3121; /* *movrvvm2x3sf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3122; /* *movrvvm2x3sf_di */
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3107; /* *movrvvm1x3hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3108; /* *movrvvm1x3hf_di */
}

 int
recog_252 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3093; /* *movrvvm1x3bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3094; /* *movrvvm1x3bf_di */
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3079; /* *movrvvm1x7hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3080; /* *movrvvm1x7hi_di */
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3065; /* *movrvvmf2x7qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3066; /* *movrvvmf2x7qi_di */
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2DFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3049; /* *movrvvm2x2df_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3050; /* *movrvvm2x2df_di */
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3033; /* *movrvvmf2x8hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3034; /* *movrvvmf2x8hf_di */
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3017; /* *movrvvmf2x7bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3018; /* *movrvvmf2x7bf_di */
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2DImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3001; /* *movrvvm2x2di_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3002; /* *movrvvm2x2di_di */
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2977; /* *movrvvmf2x4hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2978; /* *movrvvmf2x4hi_di */
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2961; /* *movrvvmf4x3qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2962; /* *movrvvmf4x3qi_di */
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2DFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2945; /* *movrvvm1x2df_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2946; /* *movrvvm1x2df_di */
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2929; /* *movrvvmf4x8hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2930; /* *movrvvmf4x8hf_di */
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2913; /* *movrvvmf4x7bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2914; /* *movrvvmf4x7bf_di */
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6DImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2897; /* *movrvvm1x6di_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2898; /* *movrvvm1x6di_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2883; /* *movrvvmf2x6si_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2884; /* *movrvvmf2x6si_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern323 (x2))
    {
    case 0:
      return 297; /* *ashrsi3 */

    case 1:
      if (!
#line 2900 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 300; /* ashrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24567; /* ashrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24771; /* vashrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24570; /* ashrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24774; /* vashrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24573; /* ashrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24777; /* vashrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24576; /* ashrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24780; /* vashrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24579; /* ashrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24783; /* vashrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24582; /* ashrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24786; /* vashrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24585; /* ashrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24789; /* vashrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24588; /* ashrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24792; /* vashrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24591; /* ashrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24795; /* vashrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24594; /* ashrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24798; /* vashrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24597; /* ashrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24801; /* vashrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24600; /* ashrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24804; /* vashrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24603; /* ashrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24807; /* vashrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24606; /* ashrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24810; /* vashrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24609; /* ashrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24813; /* vashrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24612; /* ashrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24816; /* vashrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24615; /* ashrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24819; /* vashrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24618; /* ashrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24822; /* vashrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24621; /* ashrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24825; /* vashrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24624; /* ashrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24828; /* vashrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24627; /* ashrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24831; /* vashrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24630; /* ashrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24834; /* vashrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 24633; /* ashrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24837; /* vashrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 24636; /* ashrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24840; /* vashrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 24639; /* ashrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24843; /* vashrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 24642; /* ashrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24846; /* vashrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 24645; /* ashrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24849; /* vashrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 24648; /* ashrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24852; /* vashrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 24651; /* ashrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24855; /* vashrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 24654; /* ashrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24858; /* vashrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 24657; /* ashrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24861; /* vashrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 24660; /* ashrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24864; /* vashrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 24663; /* ashrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24867; /* vashrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 24666; /* ashrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24870; /* vashrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 24669; /* ashrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24873; /* vashrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 24672; /* ashrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24876; /* vashrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 24675; /* ashrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24879; /* vashrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 24678; /* ashrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24882; /* vashrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 24681; /* ashrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24885; /* vashrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 24684; /* ashrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24888; /* vashrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 24687; /* ashrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24891; /* vashrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 24690; /* ashrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24894; /* vashrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 24693; /* ashrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24897; /* vashrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 24696; /* ashrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24900; /* vashrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 24699; /* ashrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24903; /* vashrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 24702; /* ashrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24906; /* vashrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 24705; /* ashrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24909; /* vashrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 24708; /* ashrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24912; /* vashrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 24711; /* ashrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24915; /* vashrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 24714; /* ashrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24918; /* vashrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 24717; /* ashrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24921; /* vashrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 24720; /* ashrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24924; /* vashrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 24723; /* ashrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24927; /* vashrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 24726; /* ashrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24930; /* vashrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 24729; /* ashrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24933; /* vashrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 24732; /* ashrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24936; /* vashrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 24735; /* ashrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24939; /* vashrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 24738; /* ashrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24942; /* vashrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 24741; /* ashrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24945; /* vashrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 24744; /* ashrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24948; /* vashrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 24747; /* ashrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24951; /* vashrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 24750; /* ashrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24954; /* vashrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 24753; /* ashrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24957; /* vashrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 24756; /* ashrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24960; /* vashrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 24759; /* ashrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24963; /* vashrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 24762; /* ashrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24966; /* vashrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 24765; /* ashrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24969; /* vashrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 24768; /* ashrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 513 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24972; /* vashrv512di3 */

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32455; /* pred_crypto_vvsm4rvsrvvm8si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32515; /* pred_crypto_vvsm4rvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32575; /* pred_crypto_vvsm4rvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32623; /* pred_crypto_vvsm4rvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32659; /* pred_crypto_vvsm4rvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32683; /* pred_crypto_vvsm4rvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32467; /* pred_crypto_vvsm4rvsrvvm4si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32527; /* pred_crypto_vvsm4rvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32587; /* pred_crypto_vvsm4rvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32635; /* pred_crypto_vvsm4rvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32671; /* pred_crypto_vvsm4rvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32479; /* pred_crypto_vvsm4rvsrvvm2si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32539; /* pred_crypto_vvsm4rvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32599; /* pred_crypto_vvsm4rvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32647; /* pred_crypto_vvsm4rvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32491; /* pred_crypto_vvsm4rvsrvvm1si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32551; /* pred_crypto_vvsm4rvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32611; /* pred_crypto_vvsm4rvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32503; /* pred_crypto_vvsm4rvsrvvmf2si */
      if (!(
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32563; /* pred_crypto_vvsm4rvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32452; /* pred_crypto_vvaesdmvsrvvm8si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32512; /* pred_crypto_vvaesdmvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32572; /* pred_crypto_vvaesdmvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32620; /* pred_crypto_vvaesdmvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32656; /* pred_crypto_vvaesdmvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32680; /* pred_crypto_vvaesdmvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32464; /* pred_crypto_vvaesdmvsrvvm4si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32524; /* pred_crypto_vvaesdmvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32584; /* pred_crypto_vvaesdmvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32632; /* pred_crypto_vvaesdmvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32668; /* pred_crypto_vvaesdmvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32476; /* pred_crypto_vvaesdmvsrvvm2si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32536; /* pred_crypto_vvaesdmvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32596; /* pred_crypto_vvaesdmvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32644; /* pred_crypto_vvaesdmvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32488; /* pred_crypto_vvaesdmvsrvvm1si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32548; /* pred_crypto_vvaesdmvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32608; /* pred_crypto_vvaesdmvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32500; /* pred_crypto_vvaesdmvsrvvmf2si */
      if (!(
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32560; /* pred_crypto_vvaesdmvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x7;
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      return recog_381 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      x12 = XEXP (x7, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          return recog_382 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern680 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4018; /* *pred_mergervvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern680 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4019; /* *pred_mergervvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern680 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4020; /* *pred_mergervvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern680 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4021; /* *pred_mergervvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern680 (x2, 
E_V1DImode, 
E_V1BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4022; /* *pred_mergev1di_extended_scalar */

            case E_V2DImode:
              if (pattern680 (x2, 
E_V2DImode, 
E_V2BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4023; /* *pred_mergev2di_extended_scalar */

            case E_V4DImode:
              if (pattern680 (x2, 
E_V4DImode, 
E_V4BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4024; /* *pred_mergev4di_extended_scalar */

            case E_V8DImode:
              if (pattern680 (x2, 
E_V8DImode, 
E_V8BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 4025; /* *pred_mergev8di_extended_scalar */

            case E_V16DImode:
              if (pattern680 (x2, 
E_V16DImode, 
E_V16BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 4026; /* *pred_mergev16di_extended_scalar */

            case E_V32DImode:
              if (pattern680 (x2, 
E_V32DImode, 
E_V32BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 4027; /* *pred_mergev32di_extended_scalar */

            case E_V64DImode:
              if (pattern680 (x2, 
E_V64DImode, 
E_V64BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 4028; /* *pred_mergev64di_extended_scalar */

            case E_V128DImode:
              if (pattern680 (x2, 
E_V128DImode, 
E_V128BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 4029; /* *pred_mergev128di_extended_scalar */

            case E_V256DImode:
              if (pattern680 (x2, 
E_V256DImode, 
E_V256BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 4030; /* *pred_mergev256di_extended_scalar */

            case E_V512DImode:
              if (pattern680 (x2, 
E_V512DImode, 
E_V512BImode) != 0
                  || !(
#line 2103 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 4031; /* *pred_mergev512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern468 (x2))
        {
        case 0:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27681; /* *cond_len_extendrvvm4qirvvm8hi */

        case 1:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27683; /* *cond_len_extendrvvm2qirvvm4hi */

        case 2:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27685; /* *cond_len_extendrvvm1qirvvm2hi */

        case 3:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27687; /* *cond_len_extendrvvmf2qirvvm1hi */

        case 4:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27689; /* *cond_len_extendrvvmf4qirvvmf2hi */

        case 5:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 27691; /* *cond_len_extendrvvmf8qirvvmf4hi */

        case 6:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27693; /* *cond_len_extendrvvm4hirvvm8si */

        case 7:
          if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27777; /* *cond_len_extendrvvm2qirvvm8si */

        case 8:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27695; /* *cond_len_extendrvvm2hirvvm4si */

        case 9:
          if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27779; /* *cond_len_extendrvvm1qirvvm4si */

        case 10:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27697; /* *cond_len_extendrvvm1hirvvm2si */

        case 11:
          if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27781; /* *cond_len_extendrvvmf2qirvvm2si */

        case 12:
          if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27699; /* *cond_len_extendrvvmf2hirvvm1si */

        case 13:
          if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27783; /* *cond_len_extendrvvmf4qirvvm1si */

        case 14:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 27701; /* *cond_len_extendrvvmf4hirvvmf2si */

        case 15:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 27785; /* *cond_len_extendrvvmf8qirvvmf2si */

        case 16:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27703; /* *cond_len_extendrvvm4sirvvm8di */

        case 17:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27787; /* *cond_len_extendrvvm2hirvvm8di */

        case 18:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27837; /* *cond_len_extendrvvm1qirvvm8di */

        case 19:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27705; /* *cond_len_extendrvvm2sirvvm4di */

        case 20:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27789; /* *cond_len_extendrvvm1hirvvm4di */

        case 21:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27839; /* *cond_len_extendrvvmf2qirvvm4di */

        case 22:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27707; /* *cond_len_extendrvvm1sirvvm2di */

        case 23:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27791; /* *cond_len_extendrvvmf2hirvvm2di */

        case 24:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27841; /* *cond_len_extendrvvmf4qirvvm2di */

        case 25:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27709; /* *cond_len_extendrvvmf2sirvvm1di */

        case 26:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27793; /* *cond_len_extendrvvmf4hirvvm1di */

        case 27:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27843; /* *cond_len_extendrvvmf8qirvvm1di */

        case 28:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 27711; /* *cond_len_extendv1qiv1hi */

        case 29:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 27713; /* *cond_len_extendv2qiv2hi */

        case 30:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 27715; /* *cond_len_extendv4qiv4hi */

        case 31:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 27717; /* *cond_len_extendv8qiv8hi */

        case 32:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 27719; /* *cond_len_extendv16qiv16hi */

        case 33:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27721; /* *cond_len_extendv32qiv32hi */

        case 34:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27723; /* *cond_len_extendv64qiv64hi */

        case 35:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27725; /* *cond_len_extendv128qiv128hi */

        case 36:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27727; /* *cond_len_extendv256qiv256hi */

        case 37:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27729; /* *cond_len_extendv512qiv512hi */

        case 38:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27731; /* *cond_len_extendv1024qiv1024hi */

        case 39:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27733; /* *cond_len_extendv2048qiv2048hi */

        case 40:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 27735; /* *cond_len_extendv1hiv1si */

        case 41:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 27795; /* *cond_len_extendv1qiv1si */

        case 42:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 27737; /* *cond_len_extendv2hiv2si */

        case 43:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 27797; /* *cond_len_extendv2qiv2si */

        case 44:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 27739; /* *cond_len_extendv4hiv4si */

        case 45:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 27799; /* *cond_len_extendv4qiv4si */

        case 46:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 27741; /* *cond_len_extendv8hiv8si */

        case 47:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 27801; /* *cond_len_extendv8qiv8si */

        case 48:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27743; /* *cond_len_extendv16hiv16si */

        case 49:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27803; /* *cond_len_extendv16qiv16si */

        case 50:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27745; /* *cond_len_extendv32hiv32si */

        case 51:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27805; /* *cond_len_extendv32qiv32si */

        case 52:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27747; /* *cond_len_extendv64hiv64si */

        case 53:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27807; /* *cond_len_extendv64qiv64si */

        case 54:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27749; /* *cond_len_extendv128hiv128si */

        case 55:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27809; /* *cond_len_extendv128qiv128si */

        case 56:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27751; /* *cond_len_extendv256hiv256si */

        case 57:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27811; /* *cond_len_extendv256qiv256si */

        case 58:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27753; /* *cond_len_extendv512hiv512si */

        case 59:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27813; /* *cond_len_extendv512qiv512si */

        case 60:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27755; /* *cond_len_extendv1024hiv1024si */

        case 61:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27815; /* *cond_len_extendv1024qiv1024si */

        case 62:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27757; /* *cond_len_extendv1siv1di */

        case 63:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27817; /* *cond_len_extendv1hiv1di */

        case 64:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1140 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27845; /* *cond_len_extendv1qiv1di */

        case 65:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27759; /* *cond_len_extendv2siv2di */

        case 66:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27819; /* *cond_len_extendv2hiv2di */

        case 67:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1141 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27847; /* *cond_len_extendv2qiv2di */

        case 68:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27761; /* *cond_len_extendv4siv4di */

        case 69:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27821; /* *cond_len_extendv4hiv4di */

        case 70:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1142 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27849; /* *cond_len_extendv4qiv4di */

        case 71:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27763; /* *cond_len_extendv8siv8di */

        case 72:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27823; /* *cond_len_extendv8hiv8di */

        case 73:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1143 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27851; /* *cond_len_extendv8qiv8di */

        case 74:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27765; /* *cond_len_extendv16siv16di */

        case 75:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27825; /* *cond_len_extendv16hiv16di */

        case 76:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1144 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27853; /* *cond_len_extendv16qiv16di */

        case 77:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27767; /* *cond_len_extendv32siv32di */

        case 78:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27827; /* *cond_len_extendv32hiv32di */

        case 79:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1145 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27855; /* *cond_len_extendv32qiv32di */

        case 80:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27769; /* *cond_len_extendv64siv64di */

        case 81:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27829; /* *cond_len_extendv64hiv64di */

        case 82:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1146 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27857; /* *cond_len_extendv64qiv64di */

        case 83:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27771; /* *cond_len_extendv128siv128di */

        case 84:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27831; /* *cond_len_extendv128hiv128di */

        case 85:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1147 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27859; /* *cond_len_extendv128qiv128di */

        case 86:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27773; /* *cond_len_extendv256siv256di */

        case 87:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27833; /* *cond_len_extendv256hiv256di */

        case 88:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1148 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27861; /* *cond_len_extendv256qiv256di */

        case 89:
          if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27775; /* *cond_len_extendv512siv512di */

        case 90:
          if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27835; /* *cond_len_extendv512hiv512di */

        case 91:
          if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1149 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27863; /* *cond_len_extendv512qiv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_383 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      operands[4] = x4;
      operands[5] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[6] = x8;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      x10 = XEXP (x6, 2);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern466 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27943; /* *cond_len_extendrvvm4hfrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern466 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27944; /* *cond_len_extendrvvm2hfrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern466 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27945; /* *cond_len_extendrvvm1hfrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern466 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27946; /* *cond_len_extendrvvmf2hfrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern466 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 27947; /* *cond_len_extendrvvmf4hfrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern466 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27948; /* *cond_len_extendrvvm4sfrvvm8df */

        case E_RVVM4DFmode:
          if (pattern466 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27949; /* *cond_len_extendrvvm2sfrvvm4df */

        case E_RVVM2DFmode:
          if (pattern466 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27950; /* *cond_len_extendrvvm1sfrvvm2df */

        case E_RVVM1DFmode:
          if (pattern466 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27951; /* *cond_len_extendrvvmf2sfrvvm1df */

        case E_V1SFmode:
          if (pattern466 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27952; /* *cond_len_extendv1hfv1sf */

        case E_V2SFmode:
          if (pattern466 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27953; /* *cond_len_extendv2hfv2sf */

        case E_V4SFmode:
          if (pattern466 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27954; /* *cond_len_extendv4hfv4sf */

        case E_V8SFmode:
          if (pattern466 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27955; /* *cond_len_extendv8hfv8sf */

        case E_V16SFmode:
          if (pattern466 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27956; /* *cond_len_extendv16hfv16sf */

        case E_V32SFmode:
          if (pattern466 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27957; /* *cond_len_extendv32hfv32sf */

        case E_V64SFmode:
          if (pattern466 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27958; /* *cond_len_extendv64hfv64sf */

        case E_V128SFmode:
          if (pattern466 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27959; /* *cond_len_extendv128hfv128sf */

        case E_V256SFmode:
          if (pattern466 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27960; /* *cond_len_extendv256hfv256sf */

        case E_V512SFmode:
          if (pattern466 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27961; /* *cond_len_extendv512hfv512sf */

        case E_V1024SFmode:
          if (pattern466 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27962; /* *cond_len_extendv1024hfv1024sf */

        case E_V1DFmode:
          if (pattern466 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27963; /* *cond_len_extendv1sfv1df */

        case E_V2DFmode:
          if (pattern466 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27964; /* *cond_len_extendv2sfv2df */

        case E_V4DFmode:
          if (pattern466 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27965; /* *cond_len_extendv4sfv4df */

        case E_V8DFmode:
          if (pattern466 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27966; /* *cond_len_extendv8sfv8df */

        case E_V16DFmode:
          if (pattern466 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27967; /* *cond_len_extendv16sfv16df */

        case E_V32DFmode:
          if (pattern466 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27968; /* *cond_len_extendv32sfv32df */

        case E_V64DFmode:
          if (pattern466 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27969; /* *cond_len_extendv64sfv64df */

        case E_V128DFmode:
          if (pattern466 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27970; /* *cond_len_extendv128sfv128df */

        case E_V256DFmode:
          if (pattern466 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27971; /* *cond_len_extendv256sfv256df */

        case E_V512DFmode:
          if (pattern466 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !(
#line 331 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27972; /* *cond_len_extendv512sfv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 4282; /* *pred_broadcastv1024hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4404; /* *pred_broadcastv1024hi_imm */
}

 int
recog_462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 4274; /* *pred_broadcastv4hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 4396; /* *pred_broadcastv4hi_imm */
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128QImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 4266; /* *pred_broadcastv128qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128QImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4388; /* *pred_broadcastv128qi_imm */
}

 int
recog_478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVM1DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4258; /* *pred_broadcastrvvm1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4380; /* *pred_broadcastrvvm1df_imm */
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM4SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4251; /* *pred_broadcastrvvm4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4373; /* *pred_broadcastrvvm4sf_imm */
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4460; /* pred_strided_loadrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4461; /* pred_strided_loadrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4462; /* pred_strided_loadrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4463; /* pred_strided_loadrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4464; /* pred_strided_loadrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4465; /* pred_strided_loadrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4466; /* pred_strided_loadrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4467; /* pred_strided_loadrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4468; /* pred_strided_loadrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4469; /* pred_strided_loadrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4470; /* pred_strided_loadrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4471; /* pred_strided_loadrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4472; /* pred_strided_loadrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4473; /* pred_strided_loadrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4474; /* pred_strided_loadrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4475; /* pred_strided_loadrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4476; /* pred_strided_loadrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4477; /* pred_strided_loadrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4478; /* pred_strided_loadrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4479; /* pred_strided_loadrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4480; /* pred_strided_loadrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4481; /* pred_strided_loadrvvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4482; /* pred_strided_loadrvvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4483; /* pred_strided_loadrvvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4484; /* pred_strided_loadrvvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4485; /* pred_strided_loadrvvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4486; /* pred_strided_loadrvvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4487; /* pred_strided_loadrvvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4488; /* pred_strided_loadrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4489; /* pred_strided_loadrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4490; /* pred_strided_loadrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4491; /* pred_strided_loadrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4492; /* pred_strided_loadrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4493; /* pred_strided_loadrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4494; /* pred_strided_loadrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4495; /* pred_strided_loadrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4496; /* pred_strided_loadrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4497; /* pred_strided_loadrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4498; /* pred_strided_loadrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4499; /* pred_strided_loadrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4500; /* pred_strided_loadrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4501; /* pred_strided_loadrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4502; /* pred_strided_loadrvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4503; /* pred_strided_loadv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4504; /* pred_strided_loadv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4505; /* pred_strided_loadv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4506; /* pred_strided_loadv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4507; /* pred_strided_loadv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4508; /* pred_strided_loadv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4509; /* pred_strided_loadv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4510; /* pred_strided_loadv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4511; /* pred_strided_loadv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4512; /* pred_strided_loadv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4513; /* pred_strided_loadv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4514; /* pred_strided_loadv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4515; /* pred_strided_loadv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4516; /* pred_strided_loadv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4517; /* pred_strided_loadv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4518; /* pred_strided_loadv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4519; /* pred_strided_loadv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4520; /* pred_strided_loadv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4521; /* pred_strided_loadv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4522; /* pred_strided_loadv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4523; /* pred_strided_loadv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4524; /* pred_strided_loadv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4525; /* pred_strided_loadv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4526; /* pred_strided_loadv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4527; /* pred_strided_loadv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4528; /* pred_strided_loadv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4529; /* pred_strided_loadv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4530; /* pred_strided_loadv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4531; /* pred_strided_loadv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4532; /* pred_strided_loadv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4533; /* pred_strided_loadv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4534; /* pred_strided_loadv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4535; /* pred_strided_loadv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4536; /* pred_strided_loadv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4537; /* pred_strided_loadv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4538; /* pred_strided_loadv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4539; /* pred_strided_loadv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4540; /* pred_strided_loadv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4541; /* pred_strided_loadv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4542; /* pred_strided_loadv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4543; /* pred_strided_loadv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4544; /* pred_strided_loadv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4545; /* pred_strided_loadv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4546; /* pred_strided_loadv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4547; /* pred_strided_loadv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4548; /* pred_strided_loadv512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4549; /* pred_strided_loadv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4550; /* pred_strided_loadv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4551; /* pred_strided_loadv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4552; /* pred_strided_loadv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4553; /* pred_strided_loadv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4554; /* pred_strided_loadv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4555; /* pred_strided_loadv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4556; /* pred_strided_loadv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4557; /* pred_strided_loadv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4558; /* pred_strided_loadv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4559; /* pred_strided_loadv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4560; /* pred_strided_loadv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4561; /* pred_strided_loadv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4562; /* pred_strided_loadv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4563; /* pred_strided_loadv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4564; /* pred_strided_loadv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4565; /* pred_strided_loadv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4566; /* pred_strided_loadv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4567; /* pred_strided_loadv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4568; /* pred_strided_loadv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4569; /* pred_strided_loadv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4570; /* pred_strided_loadv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4571; /* pred_strided_loadv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4572; /* pred_strided_loadv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4573; /* pred_strided_loadv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4574; /* pred_strided_loadv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4575; /* pred_strided_loadv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4576; /* pred_strided_loadv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4577; /* pred_strided_loadv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4578; /* pred_strided_loadv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4579; /* pred_strided_loadv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4580; /* pred_strided_loadv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4581; /* pred_strided_loadv512df */

    default:
      return -1;
    }
}

 int
recog_586 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern558 (x2))
    {
    case 0:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15017; /* pred_copysignrvvm8hf */

    case 1:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15019; /* pred_copysignrvvm4hf */

    case 2:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15021; /* pred_copysignrvvm2hf */

    case 3:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15023; /* pred_copysignrvvm1hf */

    case 4:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15025; /* pred_copysignrvvmf2hf */

    case 5:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15027; /* pred_copysignrvvmf4hf */

    case 6:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15029; /* pred_copysignrvvm8sf */

    case 7:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15031; /* pred_copysignrvvm4sf */

    case 8:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15033; /* pred_copysignrvvm2sf */

    case 9:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15035; /* pred_copysignrvvm1sf */

    case 10:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15037; /* pred_copysignrvvmf2sf */

    case 11:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15039; /* pred_copysignrvvm8df */

    case 12:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15041; /* pred_copysignrvvm4df */

    case 13:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15043; /* pred_copysignrvvm2df */

    case 14:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15045; /* pred_copysignrvvm1df */

    case 15:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15047; /* pred_copysignv1hf */

    case 16:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15049; /* pred_copysignv2hf */

    case 17:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15051; /* pred_copysignv4hf */

    case 18:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15053; /* pred_copysignv8hf */

    case 19:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15055; /* pred_copysignv16hf */

    case 20:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15057; /* pred_copysignv32hf */

    case 21:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15059; /* pred_copysignv64hf */

    case 22:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15061; /* pred_copysignv128hf */

    case 23:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15063; /* pred_copysignv256hf */

    case 24:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15065; /* pred_copysignv512hf */

    case 25:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15067; /* pred_copysignv1024hf */

    case 26:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15069; /* pred_copysignv2048hf */

    case 27:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15071; /* pred_copysignv1sf */

    case 28:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15073; /* pred_copysignv2sf */

    case 29:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15075; /* pred_copysignv4sf */

    case 30:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15077; /* pred_copysignv8sf */

    case 31:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15079; /* pred_copysignv16sf */

    case 32:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15081; /* pred_copysignv32sf */

    case 33:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15083; /* pred_copysignv64sf */

    case 34:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15085; /* pred_copysignv128sf */

    case 35:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15087; /* pred_copysignv256sf */

    case 36:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15089; /* pred_copysignv512sf */

    case 37:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15091; /* pred_copysignv1024sf */

    case 38:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15093; /* pred_copysignv1df */

    case 39:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15095; /* pred_copysignv2df */

    case 40:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15097; /* pred_copysignv4df */

    case 41:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15099; /* pred_copysignv8df */

    case 42:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15101; /* pred_copysignv16df */

    case 43:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15103; /* pred_copysignv32df */

    case 44:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15105; /* pred_copysignv64df */

    case 45:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15107; /* pred_copysignv128df */

    case 46:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15109; /* pred_copysignv256df */

    case 47:
      if (!(
#line 6372 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15111; /* pred_copysignv512df */

    case 48:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15128; /* pred_copysignrvvm8hf_scalar */

    case 49:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15130; /* pred_copysignrvvm4hf_scalar */

    case 50:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15132; /* pred_copysignrvvm2hf_scalar */

    case 51:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15134; /* pred_copysignrvvm1hf_scalar */

    case 52:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15136; /* pred_copysignrvvmf2hf_scalar */

    case 53:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15138; /* pred_copysignrvvmf4hf_scalar */

    case 54:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15140; /* pred_copysignrvvm8sf_scalar */

    case 55:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15142; /* pred_copysignrvvm4sf_scalar */

    case 56:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15144; /* pred_copysignrvvm2sf_scalar */

    case 57:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15146; /* pred_copysignrvvm1sf_scalar */

    case 58:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15148; /* pred_copysignrvvmf2sf_scalar */

    case 59:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15150; /* pred_copysignrvvm8df_scalar */

    case 60:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15152; /* pred_copysignrvvm4df_scalar */

    case 61:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15154; /* pred_copysignrvvm2df_scalar */

    case 62:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15156; /* pred_copysignrvvm1df_scalar */

    case 63:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15158; /* pred_copysignv1hf_scalar */

    case 64:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15160; /* pred_copysignv2hf_scalar */

    case 65:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15162; /* pred_copysignv4hf_scalar */

    case 66:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15164; /* pred_copysignv8hf_scalar */

    case 67:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15166; /* pred_copysignv16hf_scalar */

    case 68:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15168; /* pred_copysignv32hf_scalar */

    case 69:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15170; /* pred_copysignv64hf_scalar */

    case 70:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15172; /* pred_copysignv128hf_scalar */

    case 71:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15174; /* pred_copysignv256hf_scalar */

    case 72:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15176; /* pred_copysignv512hf_scalar */

    case 73:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15178; /* pred_copysignv1024hf_scalar */

    case 74:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15180; /* pred_copysignv2048hf_scalar */

    case 75:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15182; /* pred_copysignv1sf_scalar */

    case 76:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15184; /* pred_copysignv2sf_scalar */

    case 77:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15186; /* pred_copysignv4sf_scalar */

    case 78:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15188; /* pred_copysignv8sf_scalar */

    case 79:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15190; /* pred_copysignv16sf_scalar */

    case 80:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15192; /* pred_copysignv32sf_scalar */

    case 81:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15194; /* pred_copysignv64sf_scalar */

    case 82:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15196; /* pred_copysignv128sf_scalar */

    case 83:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15198; /* pred_copysignv256sf_scalar */

    case 84:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15200; /* pred_copysignv512sf_scalar */

    case 85:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15202; /* pred_copysignv1024sf_scalar */

    case 86:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15204; /* pred_copysignv1df_scalar */

    case 87:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15206; /* pred_copysignv2df_scalar */

    case 88:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15208; /* pred_copysignv4df_scalar */

    case 89:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15210; /* pred_copysignv8df_scalar */

    case 90:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15212; /* pred_copysignv16df_scalar */

    case 91:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15214; /* pred_copysignv32df_scalar */

    case 92:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15216; /* pred_copysignv64df_scalar */

    case 93:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15218; /* pred_copysignv128df_scalar */

    case 94:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15220; /* pred_copysignv256df_scalar */

    case 95:
      if (!(
#line 6414 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15222; /* pred_copysignv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_625 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024QImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13098; /* *pred_mul_plusv1024qi_undef */
}

 int
recog_630 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4HImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13103; /* *pred_mul_plusv4hi_undef */
}

 int
recog_635 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128HImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13108; /* *pred_mul_plusv128hi_undef */
}

 int
recog_640 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1SImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13113; /* *pred_mul_plusv1si_undef */
}

 int
recog_645 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32SImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13118; /* *pred_mul_plusv32si_undef */
}

 int
recog_651 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1DImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13124; /* *pred_mul_plusv1di_undef */
}

 int
recog_657 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64DImode)
      || !(
#line 5320 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13130; /* *pred_mul_plusv64di_undef */
}

 int
recog_663 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_658 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13199; /* *pred_maddv128di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13267; /* *pred_maccv128di */
}

 int
recog_670 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_651 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13192; /* *pred_maddv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13260; /* *pred_maccv1di */
}

 int
recog_677 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_644 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13185; /* *pred_maddv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13253; /* *pred_maccv16si */
}

 int
recog_683 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_638 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13179; /* *pred_maddv1024hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13247; /* *pred_maccv1024hi */
}

 int
recog_691 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_630 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13171; /* *pred_maddv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13239; /* *pred_maccv4hi */
}

 int
recog_698 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_623 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 13164; /* *pred_maddv256qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13232; /* *pred_maccv256qi */
}

 int
recog_705 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13333; /* *pred_maddv32di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13401; /* *pred_maccv32di_scalar */
}

 int
recog_712 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13326; /* *pred_maddv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13394; /* *pred_maccv512si_scalar */
}

 int
recog_719 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13319; /* *pred_maddv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13387; /* *pred_maccv4si_scalar */
}

 int
recog_726 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13312; /* *pred_maddv128hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13380; /* *pred_maccv128hi_scalar */
}

 int
recog_733 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XEXP (x8, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      operands[3] = x13;
      x14 = XEXP (x11, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          switch (pattern699 (x2))
            {
            case 0:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13803; /* pred_widen_mul_plusurvvm8hi */

            case 1:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13805; /* pred_widen_mul_plusurvvm4hi */

            case 2:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13807; /* pred_widen_mul_plusurvvm2hi */

            case 3:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13809; /* pred_widen_mul_plusurvvm1hi */

            case 4:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13811; /* pred_widen_mul_plusurvvmf2hi */

            case 5:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13813; /* pred_widen_mul_plusurvvmf4hi */

            case 6:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13815; /* pred_widen_mul_plusurvvm8si */

            case 7:
              if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 31495; /* pred_matrix_mul_plusurvvm8si_qoq */

            case 8:
              if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 31511; /* pred_matrix_mul_plusurvvm8si_dod */

            case 9:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13817; /* pred_widen_mul_plusurvvm4si */

            case 10:
              if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 31497; /* pred_matrix_mul_plusurvvm4si_qoq */

            case 11:
              if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 31513; /* pred_matrix_mul_plusurvvm4si_dod */

            case 12:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13819; /* pred_widen_mul_plusurvvm2si */

            case 13:
              if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 31499; /* pred_matrix_mul_plusurvvm2si_qoq */

            case 14:
              if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 31515; /* pred_matrix_mul_plusurvvm2si_dod */

            case 15:
              if (!
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13821; /* pred_widen_mul_plusurvvm1si */

            case 16:
              if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                return -1;
              return 31501; /* pred_matrix_mul_plusurvvm1si_qoq */

            case 17:
              if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                return -1;
              return 31517; /* pred_matrix_mul_plusurvvm1si_dod */

            case 18:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13823; /* pred_widen_mul_plusurvvmf2si */

            case 19:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13825; /* pred_widen_mul_plusurvvm8di */

            case 20:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13827; /* pred_widen_mul_plusurvvm4di */

            case 21:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13829; /* pred_widen_mul_plusurvvm2di */

            case 22:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13831; /* pred_widen_mul_plusurvvm1di */

            case 23:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 13833; /* pred_widen_mul_plusuv1hi */

            case 24:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 13835; /* pred_widen_mul_plusuv2hi */

            case 25:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 13837; /* pred_widen_mul_plusuv4hi */

            case 26:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 13839; /* pred_widen_mul_plusuv8hi */

            case 27:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 13841; /* pred_widen_mul_plusuv16hi */

            case 28:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13843; /* pred_widen_mul_plusuv32hi */

            case 29:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13845; /* pred_widen_mul_plusuv64hi */

            case 30:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13847; /* pred_widen_mul_plusuv128hi */

            case 31:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13849; /* pred_widen_mul_plusuv256hi */

            case 32:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13851; /* pred_widen_mul_plusuv512hi */

            case 33:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13853; /* pred_widen_mul_plusuv1024hi */

            case 34:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13855; /* pred_widen_mul_plusuv2048hi */

            case 35:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 13857; /* pred_widen_mul_plusuv1si */

            case 36:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 13859; /* pred_widen_mul_plusuv2si */

            case 37:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 13861; /* pred_widen_mul_plusuv4si */

            case 38:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 13863; /* pred_widen_mul_plusuv8si */

            case 39:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13865; /* pred_widen_mul_plusuv16si */

            case 40:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13867; /* pred_widen_mul_plusuv32si */

            case 41:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13869; /* pred_widen_mul_plusuv64si */

            case 42:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13871; /* pred_widen_mul_plusuv128si */

            case 43:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13873; /* pred_widen_mul_plusuv256si */

            case 44:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13875; /* pred_widen_mul_plusuv512si */

            case 45:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13877; /* pred_widen_mul_plusuv1024si */

            case 46:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13879; /* pred_widen_mul_plusuv1di */

            case 47:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13881; /* pred_widen_mul_plusuv2di */

            case 48:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13883; /* pred_widen_mul_plusuv4di */

            case 49:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13885; /* pred_widen_mul_plusuv8di */

            case 50:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13887; /* pred_widen_mul_plusuv16di */

            case 51:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13889; /* pred_widen_mul_plusuv32di */

            case 52:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13891; /* pred_widen_mul_plusuv64di */

            case 53:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13893; /* pred_widen_mul_plusuv128di */

            case 54:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13895; /* pred_widen_mul_plusuv256di */

            case 55:
              if (!(
#line 5873 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13897; /* pred_widen_mul_plusuv512di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[4] = x15;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SImode:
              if (pattern727 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM4QImode:
                  if (!register_operand (operands[4], E_RVVM4QImode)
                      || !
#line 89 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 31506; /* pred_matrix_mul_plususrvvm8si_qoq */

                case E_RVVM8QImode:
                  if (!register_operand (operands[4], E_RVVM8QImode)
                      || !
#line 161 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 31522; /* pred_matrix_mul_plususrvvm8si_dod */

                default:
                  return -1;
                }

            case E_RVVM4SImode:
              if (pattern727 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM2QImode:
                  if (!register_operand (operands[4], E_RVVM2QImode)
                      || !
#line 89 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 31507; /* pred_matrix_mul_plususrvvm4si_qoq */

                case E_RVVM4QImode:
                  if (!register_operand (operands[4], E_RVVM4QImode)
                      || !
#line 161 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 31523; /* pred_matrix_mul_plususrvvm4si_dod */

                default:
                  return -1;
                }

            case E_RVVM2SImode:
              if (pattern727 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVM1QImode:
                  if (!register_operand (operands[4], E_RVVM1QImode)
                      || !
#line 89 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 31508; /* pred_matrix_mul_plususrvvm2si_qoq */

                case E_RVVM2QImode:
                  if (!register_operand (operands[4], E_RVVM2QImode)
                      || !
#line 161 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 31524; /* pred_matrix_mul_plususrvvm2si_dod */

                default:
                  return -1;
                }

            case E_RVVM1SImode:
              if (pattern727 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_RVVMF2QImode:
                  if (!register_operand (operands[4], E_RVVMF2QImode)
                      || !
#line 89 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
                    return -1;
                  return 31509; /* pred_matrix_mul_plususrvvm1si_qoq */

                case E_RVVM1QImode:
                  if (!register_operand (operands[4], E_RVVM1QImode)
                      || !
#line 161 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
                    return -1;
                  return 31525; /* pred_matrix_mul_plususrvvm1si_dod */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x16 = XEXP (x13, 0);
      operands[3] = x16;
      x14 = XEXP (x11, 1);
      switch (GET_CODE (x14))
        {
        case ZERO_EXTEND:
          switch (pattern701 (x2))
            {
            case 0:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13899; /* pred_widen_mul_plusurvvm8hi_scalar */

            case 1:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13901; /* pred_widen_mul_plusurvvm4hi_scalar */

            case 2:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13903; /* pred_widen_mul_plusurvvm2hi_scalar */

            case 3:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13905; /* pred_widen_mul_plusurvvm1hi_scalar */

            case 4:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13907; /* pred_widen_mul_plusurvvmf2hi_scalar */

            case 5:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13909; /* pred_widen_mul_plusurvvmf4hi_scalar */

            case 6:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13911; /* pred_widen_mul_plusurvvm8si_scalar */

            case 7:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13913; /* pred_widen_mul_plusurvvm4si_scalar */

            case 8:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13915; /* pred_widen_mul_plusurvvm2si_scalar */

            case 9:
              if (!
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 13917; /* pred_widen_mul_plusurvvm1si_scalar */

            case 10:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 13919; /* pred_widen_mul_plusurvvmf2si_scalar */

            case 11:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13921; /* pred_widen_mul_plusurvvm8di_scalar */

            case 12:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13923; /* pred_widen_mul_plusurvvm4di_scalar */

            case 13:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13925; /* pred_widen_mul_plusurvvm2di_scalar */

            case 14:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13927; /* pred_widen_mul_plusurvvm1di_scalar */

            case 15:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 13929; /* pred_widen_mul_plusuv1hi_scalar */

            case 16:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 13931; /* pred_widen_mul_plusuv2hi_scalar */

            case 17:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 13933; /* pred_widen_mul_plusuv4hi_scalar */

            case 18:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 13935; /* pred_widen_mul_plusuv8hi_scalar */

            case 19:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 13937; /* pred_widen_mul_plusuv16hi_scalar */

            case 20:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13939; /* pred_widen_mul_plusuv32hi_scalar */

            case 21:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13941; /* pred_widen_mul_plusuv64hi_scalar */

            case 22:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13943; /* pred_widen_mul_plusuv128hi_scalar */

            case 23:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13945; /* pred_widen_mul_plusuv256hi_scalar */

            case 24:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13947; /* pred_widen_mul_plusuv512hi_scalar */

            case 25:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13949; /* pred_widen_mul_plusuv1024hi_scalar */

            case 26:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13951; /* pred_widen_mul_plusuv2048hi_scalar */

            case 27:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 13953; /* pred_widen_mul_plusuv1si_scalar */

            case 28:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 13955; /* pred_widen_mul_plusuv2si_scalar */

            case 29:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 13957; /* pred_widen_mul_plusuv4si_scalar */

            case 30:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 13959; /* pred_widen_mul_plusuv8si_scalar */

            case 31:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13961; /* pred_widen_mul_plusuv16si_scalar */

            case 32:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13963; /* pred_widen_mul_plusuv32si_scalar */

            case 33:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13965; /* pred_widen_mul_plusuv64si_scalar */

            case 34:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13967; /* pred_widen_mul_plusuv128si_scalar */

            case 35:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13969; /* pred_widen_mul_plusuv256si_scalar */

            case 36:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13971; /* pred_widen_mul_plusuv512si_scalar */

            case 37:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13973; /* pred_widen_mul_plusuv1024si_scalar */

            case 38:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13975; /* pred_widen_mul_plusuv1di_scalar */

            case 39:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13977; /* pred_widen_mul_plusuv2di_scalar */

            case 40:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13979; /* pred_widen_mul_plusuv4di_scalar */

            case 41:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13981; /* pred_widen_mul_plusuv8di_scalar */

            case 42:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13983; /* pred_widen_mul_plusuv16di_scalar */

            case 43:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13985; /* pred_widen_mul_plusuv32di_scalar */

            case 44:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13987; /* pred_widen_mul_plusuv64di_scalar */

            case 45:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13989; /* pred_widen_mul_plusuv128di_scalar */

            case 46:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13991; /* pred_widen_mul_plusuv256di_scalar */

            case 47:
              if (!(
#line 5898 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13993; /* pred_widen_mul_plusuv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern701 (x2))
            {
            case 0:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14090; /* pred_widen_mul_plususrvvm8hi_scalar */

            case 1:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14091; /* pred_widen_mul_plususrvvm4hi_scalar */

            case 2:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14092; /* pred_widen_mul_plususrvvm2hi_scalar */

            case 3:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14093; /* pred_widen_mul_plususrvvm1hi_scalar */

            case 4:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14094; /* pred_widen_mul_plususrvvmf2hi_scalar */

            case 5:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 14095; /* pred_widen_mul_plususrvvmf4hi_scalar */

            case 6:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14096; /* pred_widen_mul_plususrvvm8si_scalar */

            case 7:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14097; /* pred_widen_mul_plususrvvm4si_scalar */

            case 8:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14098; /* pred_widen_mul_plususrvvm2si_scalar */

            case 9:
              if (!
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 14099; /* pred_widen_mul_plususrvvm1si_scalar */

            case 10:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 14100; /* pred_widen_mul_plususrvvmf2si_scalar */

            case 11:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14101; /* pred_widen_mul_plususrvvm8di_scalar */

            case 12:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14102; /* pred_widen_mul_plususrvvm4di_scalar */

            case 13:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14103; /* pred_widen_mul_plususrvvm2di_scalar */

            case 14:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14104; /* pred_widen_mul_plususrvvm1di_scalar */

            case 15:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 14105; /* pred_widen_mul_plususv1hi_scalar */

            case 16:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 14106; /* pred_widen_mul_plususv2hi_scalar */

            case 17:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 14107; /* pred_widen_mul_plususv4hi_scalar */

            case 18:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 14108; /* pred_widen_mul_plususv8hi_scalar */

            case 19:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 14109; /* pred_widen_mul_plususv16hi_scalar */

            case 20:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14110; /* pred_widen_mul_plususv32hi_scalar */

            case 21:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14111; /* pred_widen_mul_plususv64hi_scalar */

            case 22:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14112; /* pred_widen_mul_plususv128hi_scalar */

            case 23:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14113; /* pred_widen_mul_plususv256hi_scalar */

            case 24:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14114; /* pred_widen_mul_plususv512hi_scalar */

            case 25:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14115; /* pred_widen_mul_plususv1024hi_scalar */

            case 26:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14116; /* pred_widen_mul_plususv2048hi_scalar */

            case 27:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 14117; /* pred_widen_mul_plususv1si_scalar */

            case 28:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 14118; /* pred_widen_mul_plususv2si_scalar */

            case 29:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 14119; /* pred_widen_mul_plususv4si_scalar */

            case 30:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 14120; /* pred_widen_mul_plususv8si_scalar */

            case 31:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14121; /* pred_widen_mul_plususv16si_scalar */

            case 32:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14122; /* pred_widen_mul_plususv32si_scalar */

            case 33:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14123; /* pred_widen_mul_plususv64si_scalar */

            case 34:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14124; /* pred_widen_mul_plususv128si_scalar */

            case 35:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14125; /* pred_widen_mul_plususv256si_scalar */

            case 36:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14126; /* pred_widen_mul_plususv512si_scalar */

            case 37:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14127; /* pred_widen_mul_plususv1024si_scalar */

            case 38:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14128; /* pred_widen_mul_plususv1di_scalar */

            case 39:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14129; /* pred_widen_mul_plususv2di_scalar */

            case 40:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 14130; /* pred_widen_mul_plususv4di_scalar */

            case 41:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14131; /* pred_widen_mul_plususv8di_scalar */

            case 42:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14132; /* pred_widen_mul_plususv16di_scalar */

            case 43:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14133; /* pred_widen_mul_plususv32di_scalar */

            case 44:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14134; /* pred_widen_mul_plususv64di_scalar */

            case 45:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14135; /* pred_widen_mul_plususv128di_scalar */

            case 46:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14136; /* pred_widen_mul_plususv256di_scalar */

            case 47:
              if (!(
#line 5972 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14137; /* pred_widen_mul_plususv512di_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_760 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V2048HImode) == 0
      && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13480; /* *pred_minus_mulv2048hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2048HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2048HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13548; /* *pred_nmsubv2048hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13616; /* *pred_nmsacv2048hi */
}

 int
recog_766 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V32HImode) == 0
      && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13474; /* *pred_minus_mulv32hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13542; /* *pred_nmsubv32hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13610; /* *pred_nmsacv32hi */
}

 int
recog_772 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V4096QImode) == 0
      && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13468; /* *pred_minus_mulv4096qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4096QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4096QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4096QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13536; /* *pred_nmsubv4096qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13604; /* *pred_nmsacv4096qi */
}

 int
recog_780 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V16QImode) == 0
      && (
#line 5602 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 13460; /* *pred_minus_mulv16qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 13528; /* *pred_nmsubv16qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 13596; /* *pred_nmsacv16qi */
}

 int
recog_788 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13705; /* *pred_nmsubv512di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13773; /* *pred_nmsacv512di_scalar */
}

 int
recog_793 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13700; /* *pred_nmsubv16di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13768; /* *pred_nmsacv16di_scalar */
}

 int
recog_801 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13692; /* *pred_nmsubv128si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13760; /* *pred_nmsacv128si_scalar */
}

 int
recog_809 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13684; /* *pred_nmsubv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13752; /* *pred_nmsacv2048hi_scalar */
}

 int
recog_817 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern706 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13638; /* *pred_nmsubrvvm8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13706; /* *pred_nmsacrvvm8qi_scalar */

    case E_RVVM4QImode:
      if (pattern706 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13639; /* *pred_nmsubrvvm4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13707; /* *pred_nmsacrvvm4qi_scalar */

    case E_RVVM2QImode:
      if (pattern706 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13640; /* *pred_nmsubrvvm2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13708; /* *pred_nmsacrvvm2qi_scalar */

    case E_RVVM1QImode:
      if (pattern706 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13641; /* *pred_nmsubrvvm1qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13709; /* *pred_nmsacrvvm1qi_scalar */

    case E_RVVM8HImode:
      if (pattern706 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13642; /* *pred_nmsubrvvm8hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13710; /* *pred_nmsacrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern706 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13643; /* *pred_nmsubrvvm4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13711; /* *pred_nmsacrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern706 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13644; /* *pred_nmsubrvvm2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13712; /* *pred_nmsacrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern706 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13645; /* *pred_nmsubrvvm1hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13713; /* *pred_nmsacrvvm1hi_scalar */

    case E_RVVM8SImode:
      if (pattern706 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13646; /* *pred_nmsubrvvm8si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13714; /* *pred_nmsacrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern706 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13647; /* *pred_nmsubrvvm4si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13715; /* *pred_nmsacrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern706 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13648; /* *pred_nmsubrvvm2si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13716; /* *pred_nmsacrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern706 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13649; /* *pred_nmsubrvvm1si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13717; /* *pred_nmsacrvvm1si_scalar */

    case E_RVVM8DImode:
      if (pattern706 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13650; /* *pred_nmsubrvvm8di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13718; /* *pred_nmsacrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern706 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13651; /* *pred_nmsubrvvm4di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13719; /* *pred_nmsacrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern706 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13652; /* *pred_nmsubrvvm2di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13720; /* *pred_nmsacrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern706 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13653; /* *pred_nmsubrvvm1di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13721; /* *pred_nmsacrvvm1di_scalar */

    case E_RVVMF2QImode:
      if (pattern706 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13654; /* *pred_nmsubrvvmf2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13722; /* *pred_nmsacrvvmf2qi_scalar */

    case E_RVVMF4QImode:
      if (pattern706 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13655; /* *pred_nmsubrvvmf4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13723; /* *pred_nmsacrvvmf4qi_scalar */

    case E_RVVMF8QImode:
      if (pattern706 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13656; /* *pred_nmsubrvvmf8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13724; /* *pred_nmsacrvvmf8qi_scalar */

    case E_RVVMF2HImode:
      if (pattern706 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13657; /* *pred_nmsubrvvmf2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13725; /* *pred_nmsacrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern706 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13658; /* *pred_nmsubrvvmf4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13726; /* *pred_nmsacrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      if (pattern706 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13659; /* *pred_nmsubrvvmf2si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13727; /* *pred_nmsacrvvmf2si_scalar */

    case E_V1QImode:
      if (pattern706 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 13660; /* *pred_nmsubv1qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 13728; /* *pred_nmsacv1qi_scalar */

    case E_V2QImode:
      if (pattern706 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 13661; /* *pred_nmsubv2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 13729; /* *pred_nmsacv2qi_scalar */

    case E_V4QImode:
      if (pattern706 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 13662; /* *pred_nmsubv4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 13730; /* *pred_nmsacv4qi_scalar */

    case E_V8QImode:
      if (pattern706 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 13663; /* *pred_nmsubv8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 13731; /* *pred_nmsacv8qi_scalar */

    case E_V16QImode:
      if (pattern706 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 13664; /* *pred_nmsubv16qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 13732; /* *pred_nmsacv16qi_scalar */

    case E_V32QImode:
      if (pattern706 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 13665; /* *pred_nmsubv32qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 13733; /* *pred_nmsacv32qi_scalar */

    case E_V64QImode:
      if (pattern706 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 13666; /* *pred_nmsubv64qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13734; /* *pred_nmsacv64qi_scalar */

    case E_V128QImode:
      if (pattern706 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 13667; /* *pred_nmsubv128qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13735; /* *pred_nmsacv128qi_scalar */

    case E_V256QImode:
      if (pattern706 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 13668; /* *pred_nmsubv256qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13736; /* *pred_nmsacv256qi_scalar */

    case E_V512QImode:
      if (pattern706 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 13669; /* *pred_nmsubv512qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 13737; /* *pred_nmsacv512qi_scalar */

    case E_V1024QImode:
      if (pattern706 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 13670; /* *pred_nmsubv1024qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 13738; /* *pred_nmsacv1024qi_scalar */

    case E_V2048QImode:
      if (pattern706 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 13671; /* *pred_nmsubv2048qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 13739; /* *pred_nmsacv2048qi_scalar */

    case E_V4096QImode:
      if (pattern706 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 13672; /* *pred_nmsubv4096qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13740; /* *pred_nmsacv4096qi_scalar */

    case E_V1HImode:
      if (pattern706 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 13673; /* *pred_nmsubv1hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 13741; /* *pred_nmsacv1hi_scalar */

    case E_V2HImode:
      if (pattern706 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 13674; /* *pred_nmsubv2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 13742; /* *pred_nmsacv2hi_scalar */

    case E_V4HImode:
      if (pattern706 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 13675; /* *pred_nmsubv4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 13743; /* *pred_nmsacv4hi_scalar */

    case E_V8HImode:
      if (pattern706 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5708 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 13676; /* *pred_nmsubv8hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5738 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 13744; /* *pred_nmsacv8hi_scalar */

    case E_V16HImode:
      return recog_816 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_815 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_814 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_813 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_812 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_811 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_810 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_809 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_808 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_807 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_806 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_805 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_804 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_803 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_802 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_801 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_800 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_799 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_798 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_797 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_796 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_795 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_794 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_793 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_792 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_791 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_790 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_789 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_788 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_832 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V8DImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 6524; /* pred_ashlv8di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6821; /* pred_ashlv8di_scalar */
}

 int
recog_835 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V1DImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 6473; /* pred_ashlv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 6812; /* pred_ashlv1di_scalar */
}

 int
recog_838 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256SImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 6422; /* pred_ashlv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6803; /* pred_ashlv256si_scalar */
}

 int
recog_841 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32SImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 6371; /* pred_ashlv32si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 6794; /* pred_ashlv32si_scalar */
}

 int
recog_844 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V4SImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 6320; /* pred_ashlv4si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 6785; /* pred_ashlv4si_scalar */
}

 int
recog_849 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512HImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 6235; /* pred_ashlv512hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6770; /* pred_ashlv512hi_scalar */
}

 int
recog_854 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16HImode)
      && (
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 6150; /* pred_ashlv16hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 6755; /* pred_ashlv16hi_scalar */
}

 int
recog_859 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern668 (x2, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 31839; /* pred_vwsllv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 31887; /* pred_vwsllv32di_scalar */
}

 int
recog_864 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      if (pattern668 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31796; /* pred_vwsllrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31844; /* pred_vwsllrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern668 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31797; /* pred_vwsllrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31845; /* pred_vwsllrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern668 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31798; /* pred_vwsllrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31846; /* pred_vwsllrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern668 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31799; /* pred_vwsllrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31847; /* pred_vwsllrvvm1hi_scalar */

    case E_RVVMF2HImode:
      if (pattern668 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31800; /* pred_vwsllrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31848; /* pred_vwsllrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern668 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 31801; /* pred_vwsllrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31849; /* pred_vwsllrvvmf4hi_scalar */

    case E_RVVM8SImode:
      if (pattern668 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31802; /* pred_vwsllrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31850; /* pred_vwsllrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern668 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31803; /* pred_vwsllrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31851; /* pred_vwsllrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern668 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31804; /* pred_vwsllrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31852; /* pred_vwsllrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern668 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return 31805; /* pred_vwsllrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 31853; /* pred_vwsllrvvm1si_scalar */

    case E_RVVMF2SImode:
      if (pattern668 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 31806; /* pred_vwsllrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31854; /* pred_vwsllrvvmf2si_scalar */

    case E_RVVM8DImode:
      if (pattern668 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 31807; /* pred_vwsllrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31855; /* pred_vwsllrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern668 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 31808; /* pred_vwsllrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31856; /* pred_vwsllrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern668 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 31809; /* pred_vwsllrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31857; /* pred_vwsllrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern668 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 31810; /* pred_vwsllrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31858; /* pred_vwsllrvvm1di_scalar */

    case E_V1HImode:
      if (pattern668 (x2, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 31811; /* pred_vwsllv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31859; /* pred_vwsllv1hi_scalar */

    case E_V2HImode:
      if (pattern668 (x2, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 31812; /* pred_vwsllv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31860; /* pred_vwsllv2hi_scalar */

    case E_V4HImode:
      if (pattern668 (x2, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 31813; /* pred_vwsllv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31861; /* pred_vwsllv4hi_scalar */

    case E_V8HImode:
      if (pattern668 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 31814; /* pred_vwsllv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31862; /* pred_vwsllv8hi_scalar */

    case E_V16HImode:
      if (pattern668 (x2, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 31815; /* pred_vwsllv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31863; /* pred_vwsllv16hi_scalar */

    case E_V32HImode:
      if (pattern668 (x2, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 31816; /* pred_vwsllv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31864; /* pred_vwsllv32hi_scalar */

    case E_V64HImode:
      if (pattern668 (x2, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 31817; /* pred_vwsllv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31865; /* pred_vwsllv64hi_scalar */

    case E_V128HImode:
      if (pattern668 (x2, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 31818; /* pred_vwsllv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31866; /* pred_vwsllv128hi_scalar */

    case E_V256HImode:
      if (pattern668 (x2, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 31819; /* pred_vwsllv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31867; /* pred_vwsllv256hi_scalar */

    case E_V512HImode:
      if (pattern668 (x2, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 31820; /* pred_vwsllv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31868; /* pred_vwsllv512hi_scalar */

    case E_V1024HImode:
      if (pattern668 (x2, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 31821; /* pred_vwsllv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31869; /* pred_vwsllv1024hi_scalar */

    case E_V2048HImode:
      if (pattern668 (x2, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 31822; /* pred_vwsllv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31870; /* pred_vwsllv2048hi_scalar */

    case E_V1SImode:
      if (pattern668 (x2, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 31823; /* pred_vwsllv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31871; /* pred_vwsllv1si_scalar */

    case E_V2SImode:
      if (pattern668 (x2, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 31824; /* pred_vwsllv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31872; /* pred_vwsllv2si_scalar */

    case E_V4SImode:
      if (pattern668 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 31825; /* pred_vwsllv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31873; /* pred_vwsllv4si_scalar */

    case E_V8SImode:
      if (pattern668 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 31826; /* pred_vwsllv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31874; /* pred_vwsllv8si_scalar */

    case E_V16SImode:
      if (pattern668 (x2, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 31827; /* pred_vwsllv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31875; /* pred_vwsllv16si_scalar */

    case E_V32SImode:
      if (pattern668 (x2, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 31828; /* pred_vwsllv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31876; /* pred_vwsllv32si_scalar */

    case E_V64SImode:
      if (pattern668 (x2, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 31829; /* pred_vwsllv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31877; /* pred_vwsllv64si_scalar */

    case E_V128SImode:
      if (pattern668 (x2, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 31830; /* pred_vwsllv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31878; /* pred_vwsllv128si_scalar */

    case E_V256SImode:
      if (pattern668 (x2, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 31831; /* pred_vwsllv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31879; /* pred_vwsllv256si_scalar */

    case E_V512SImode:
      if (pattern668 (x2, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 31832; /* pred_vwsllv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31880; /* pred_vwsllv512si_scalar */

    case E_V1024SImode:
      if (pattern668 (x2, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 31833; /* pred_vwsllv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31881; /* pred_vwsllv1024si_scalar */

    case E_V1DImode:
      if (pattern668 (x2, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 31834; /* pred_vwsllv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31882; /* pred_vwsllv1di_scalar */

    case E_V2DImode:
      return recog_863 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_862 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_861 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_860 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_859 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_858 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_857 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_856 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_855 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_873 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern493 (x2))
    {
    case 0:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5490; /* pred_smaxrvvm8qi */

    case 1:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5507; /* pred_smaxrvvm4qi */

    case 2:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5524; /* pred_smaxrvvm2qi */

    case 3:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5541; /* pred_smaxrvvm1qi */

    case 4:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5558; /* pred_smaxrvvm8hi */

    case 5:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5575; /* pred_smaxrvvm4hi */

    case 6:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5592; /* pred_smaxrvvm2hi */

    case 7:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5609; /* pred_smaxrvvm1hi */

    case 8:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5626; /* pred_smaxrvvm8si */

    case 9:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5643; /* pred_smaxrvvm4si */

    case 10:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5660; /* pred_smaxrvvm2si */

    case 11:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5677; /* pred_smaxrvvm1si */

    case 12:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5694; /* pred_smaxrvvm8di */

    case 13:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5711; /* pred_smaxrvvm4di */

    case 14:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5728; /* pred_smaxrvvm2di */

    case 15:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5745; /* pred_smaxrvvm1di */

    case 16:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5762; /* pred_smaxrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5779; /* pred_smaxrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5796; /* pred_smaxrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5813; /* pred_smaxrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5830; /* pred_smaxrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5847; /* pred_smaxrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5864; /* pred_smaxv1qi */

    case 23:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5881; /* pred_smaxv2qi */

    case 24:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5898; /* pred_smaxv4qi */

    case 25:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5915; /* pred_smaxv8qi */

    case 26:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5932; /* pred_smaxv16qi */

    case 27:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5949; /* pred_smaxv32qi */

    case 28:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5966; /* pred_smaxv64qi */

    case 29:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5983; /* pred_smaxv128qi */

    case 30:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6000; /* pred_smaxv256qi */

    case 31:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6017; /* pred_smaxv512qi */

    case 32:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6034; /* pred_smaxv1024qi */

    case 33:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6051; /* pred_smaxv2048qi */

    case 34:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6068; /* pred_smaxv4096qi */

    case 35:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6085; /* pred_smaxv1hi */

    case 36:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6102; /* pred_smaxv2hi */

    case 37:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6119; /* pred_smaxv4hi */

    case 38:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6136; /* pred_smaxv8hi */

    case 39:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6153; /* pred_smaxv16hi */

    case 40:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6170; /* pred_smaxv32hi */

    case 41:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6187; /* pred_smaxv64hi */

    case 42:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6204; /* pred_smaxv128hi */

    case 43:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6221; /* pred_smaxv256hi */

    case 44:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6238; /* pred_smaxv512hi */

    case 45:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6255; /* pred_smaxv1024hi */

    case 46:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6272; /* pred_smaxv2048hi */

    case 47:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6289; /* pred_smaxv1si */

    case 48:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6306; /* pred_smaxv2si */

    case 49:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6323; /* pred_smaxv4si */

    case 50:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6340; /* pred_smaxv8si */

    case 51:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6357; /* pred_smaxv16si */

    case 52:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6374; /* pred_smaxv32si */

    case 53:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6391; /* pred_smaxv64si */

    case 54:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6408; /* pred_smaxv128si */

    case 55:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6425; /* pred_smaxv256si */

    case 56:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6442; /* pred_smaxv512si */

    case 57:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6459; /* pred_smaxv1024si */

    case 58:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6476; /* pred_smaxv1di */

    case 59:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6493; /* pred_smaxv2di */

    case 60:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6510; /* pred_smaxv4di */

    case 61:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6527; /* pred_smaxv8di */

    case 62:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6544; /* pred_smaxv16di */

    case 63:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6561; /* pred_smaxv32di */

    case 64:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6578; /* pred_smaxv64di */

    case 65:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6595; /* pred_smaxv128di */

    case 66:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6612; /* pred_smaxv256di */

    case 67:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6629; /* pred_smaxv512di */

    case 68:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14675; /* pred_smaxrvvm8hf */

    case 69:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14677; /* pred_smaxrvvm4hf */

    case 70:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14679; /* pred_smaxrvvm2hf */

    case 71:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14681; /* pred_smaxrvvm1hf */

    case 72:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14683; /* pred_smaxrvvmf2hf */

    case 73:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14685; /* pred_smaxrvvmf4hf */

    case 74:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14687; /* pred_smaxrvvm8sf */

    case 75:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14689; /* pred_smaxrvvm4sf */

    case 76:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14691; /* pred_smaxrvvm2sf */

    case 77:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14693; /* pred_smaxrvvm1sf */

    case 78:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14695; /* pred_smaxrvvmf2sf */

    case 79:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14697; /* pred_smaxrvvm8df */

    case 80:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14699; /* pred_smaxrvvm4df */

    case 81:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14701; /* pred_smaxrvvm2df */

    case 82:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14703; /* pred_smaxrvvm1df */

    case 83:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 14705; /* pred_smaxv1hf */

    case 84:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 14707; /* pred_smaxv2hf */

    case 85:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 14709; /* pred_smaxv4hf */

    case 86:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 14711; /* pred_smaxv8hf */

    case 87:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 14713; /* pred_smaxv16hf */

    case 88:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14715; /* pred_smaxv32hf */

    case 89:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14717; /* pred_smaxv64hf */

    case 90:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14719; /* pred_smaxv128hf */

    case 91:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14721; /* pred_smaxv256hf */

    case 92:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14723; /* pred_smaxv512hf */

    case 93:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14725; /* pred_smaxv1024hf */

    case 94:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14727; /* pred_smaxv2048hf */

    case 95:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14729; /* pred_smaxv1sf */

    case 96:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14731; /* pred_smaxv2sf */

    case 97:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14733; /* pred_smaxv4sf */

    case 98:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14735; /* pred_smaxv8sf */

    case 99:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14737; /* pred_smaxv16sf */

    case 100:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14739; /* pred_smaxv32sf */

    case 101:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14741; /* pred_smaxv64sf */

    case 102:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14743; /* pred_smaxv128sf */

    case 103:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14745; /* pred_smaxv256sf */

    case 104:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14747; /* pred_smaxv512sf */

    case 105:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14749; /* pred_smaxv1024sf */

    case 106:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14751; /* pred_smaxv1df */

    case 107:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14753; /* pred_smaxv2df */

    case 108:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14755; /* pred_smaxv4df */

    case 109:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14757; /* pred_smaxv8df */

    case 110:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14759; /* pred_smaxv16df */

    case 111:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14761; /* pred_smaxv32df */

    case 112:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14763; /* pred_smaxv64df */

    case 113:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14765; /* pred_smaxv128df */

    case 114:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14767; /* pred_smaxv256df */

    case 115:
      if (!(
#line 6213 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14769; /* pred_smaxv512df */

    case 116:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6846; /* pred_smaxrvvm8qi_scalar */

    case 117:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6855; /* pred_smaxrvvm4qi_scalar */

    case 118:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6864; /* pred_smaxrvvm2qi_scalar */

    case 119:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6873; /* pred_smaxrvvm1qi_scalar */

    case 120:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6882; /* pred_smaxrvvmf2qi_scalar */

    case 121:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6891; /* pred_smaxrvvmf4qi_scalar */

    case 122:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6900; /* pred_smaxrvvmf8qi_scalar */

    case 123:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6909; /* pred_smaxrvvm8hi_scalar */

    case 124:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6918; /* pred_smaxrvvm4hi_scalar */

    case 125:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6927; /* pred_smaxrvvm2hi_scalar */

    case 126:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6936; /* pred_smaxrvvm1hi_scalar */

    case 127:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6945; /* pred_smaxrvvmf2hi_scalar */

    case 128:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6954; /* pred_smaxrvvmf4hi_scalar */

    case 129:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6963; /* pred_smaxrvvm8si_scalar */

    case 130:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6972; /* pred_smaxrvvm4si_scalar */

    case 131:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6981; /* pred_smaxrvvm2si_scalar */

    case 132:
      if (!
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6990; /* pred_smaxrvvm1si_scalar */

    case 133:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6999; /* pred_smaxrvvmf2si_scalar */

    case 134:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7008; /* pred_smaxv1qi_scalar */

    case 135:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7017; /* pred_smaxv2qi_scalar */

    case 136:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7026; /* pred_smaxv4qi_scalar */

    case 137:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7035; /* pred_smaxv8qi_scalar */

    case 138:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7044; /* pred_smaxv16qi_scalar */

    case 139:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7053; /* pred_smaxv32qi_scalar */

    case 140:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7062; /* pred_smaxv64qi_scalar */

    case 141:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7071; /* pred_smaxv128qi_scalar */

    case 142:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7080; /* pred_smaxv256qi_scalar */

    case 143:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7089; /* pred_smaxv512qi_scalar */

    case 144:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7098; /* pred_smaxv1024qi_scalar */

    case 145:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7107; /* pred_smaxv2048qi_scalar */

    case 146:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7116; /* pred_smaxv4096qi_scalar */

    case 147:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7125; /* pred_smaxv1hi_scalar */

    case 148:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7134; /* pred_smaxv2hi_scalar */

    case 149:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7143; /* pred_smaxv4hi_scalar */

    case 150:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7152; /* pred_smaxv8hi_scalar */

    case 151:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7161; /* pred_smaxv16hi_scalar */

    case 152:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7170; /* pred_smaxv32hi_scalar */

    case 153:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7179; /* pred_smaxv64hi_scalar */

    case 154:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7188; /* pred_smaxv128hi_scalar */

    case 155:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7197; /* pred_smaxv256hi_scalar */

    case 156:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7206; /* pred_smaxv512hi_scalar */

    case 157:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7215; /* pred_smaxv1024hi_scalar */

    case 158:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7224; /* pred_smaxv2048hi_scalar */

    case 159:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7233; /* pred_smaxv1si_scalar */

    case 160:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7242; /* pred_smaxv2si_scalar */

    case 161:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7251; /* pred_smaxv4si_scalar */

    case 162:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7260; /* pred_smaxv8si_scalar */

    case 163:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7269; /* pred_smaxv16si_scalar */

    case 164:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7278; /* pred_smaxv32si_scalar */

    case 165:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7287; /* pred_smaxv64si_scalar */

    case 166:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7296; /* pred_smaxv128si_scalar */

    case 167:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7305; /* pred_smaxv256si_scalar */

    case 168:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7314; /* pred_smaxv512si_scalar */

    case 169:
      if (!(
#line 2780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7323; /* pred_smaxv1024si_scalar */

    case 170:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7656; /* *pred_smaxrvvm8di_scalar */

    case 171:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7665; /* *pred_smaxrvvm4di_scalar */

    case 172:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7674; /* *pred_smaxrvvm2di_scalar */

    case 173:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7683; /* *pred_smaxrvvm1di_scalar */

    case 174:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7692; /* *pred_smaxv1di_scalar */

    case 175:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7701; /* *pred_smaxv2di_scalar */

    case 176:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7710; /* *pred_smaxv4di_scalar */

    case 177:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7719; /* *pred_smaxv8di_scalar */

    case 178:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7728; /* *pred_smaxv16di_scalar */

    case 179:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7737; /* *pred_smaxv32di_scalar */

    case 180:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7746; /* *pred_smaxv64di_scalar */

    case 181:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7755; /* *pred_smaxv128di_scalar */

    case 182:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7764; /* *pred_smaxv256di_scalar */

    case 183:
      if (!(
#line 2878 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7773; /* *pred_smaxv512di_scalar */

    case 184:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14897; /* pred_smaxrvvm8hf_scalar */

    case 185:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14899; /* pred_smaxrvvm4hf_scalar */

    case 186:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14901; /* pred_smaxrvvm2hf_scalar */

    case 187:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14903; /* pred_smaxrvvm1hf_scalar */

    case 188:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14905; /* pred_smaxrvvmf2hf_scalar */

    case 189:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14907; /* pred_smaxrvvmf4hf_scalar */

    case 190:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14909; /* pred_smaxrvvm8sf_scalar */

    case 191:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14911; /* pred_smaxrvvm4sf_scalar */

    case 192:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14913; /* pred_smaxrvvm2sf_scalar */

    case 193:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14915; /* pred_smaxrvvm1sf_scalar */

    case 194:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14917; /* pred_smaxrvvmf2sf_scalar */

    case 195:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14919; /* pred_smaxrvvm8df_scalar */

    case 196:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14921; /* pred_smaxrvvm4df_scalar */

    case 197:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14923; /* pred_smaxrvvm2df_scalar */

    case 198:
      if (!(
#line 6280 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14925; /* pred_smaxrvvm1df_scalar */

    case 199:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7782; /* *pred_smaxrvvm8di_extended_scalar */

    case 200:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7791; /* *pred_smaxrvvm4di_extended_scalar */

    case 201:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7800; /* *pred_smaxrvvm2di_extended_scalar */

    case 202:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7809; /* *pred_smaxrvvm1di_extended_scalar */

    case 203:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7818; /* *pred_smaxv1di_extended_scalar */

    case 204:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7827; /* *pred_smaxv2di_extended_scalar */

    case 205:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7836; /* *pred_smaxv4di_extended_scalar */

    case 206:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7845; /* *pred_smaxv8di_extended_scalar */

    case 207:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7854; /* *pred_smaxv16di_extended_scalar */

    case 208:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7863; /* *pred_smaxv32di_extended_scalar */

    case 209:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7872; /* *pred_smaxv64di_extended_scalar */

    case 210:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7881; /* *pred_smaxv128di_extended_scalar */

    case 211:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7890; /* *pred_smaxv256di_extended_scalar */

    case 212:
      if (!(
#line 2900 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7899; /* *pred_smaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_886 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5497; /* pred_modrvvm8qi */

    case 1:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5514; /* pred_modrvvm4qi */

    case 2:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5531; /* pred_modrvvm2qi */

    case 3:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5548; /* pred_modrvvm1qi */

    case 4:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5565; /* pred_modrvvm8hi */

    case 5:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5582; /* pred_modrvvm4hi */

    case 6:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5599; /* pred_modrvvm2hi */

    case 7:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5616; /* pred_modrvvm1hi */

    case 8:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5633; /* pred_modrvvm8si */

    case 9:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5650; /* pred_modrvvm4si */

    case 10:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5667; /* pred_modrvvm2si */

    case 11:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5684; /* pred_modrvvm1si */

    case 12:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5701; /* pred_modrvvm8di */

    case 13:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5718; /* pred_modrvvm4di */

    case 14:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5735; /* pred_modrvvm2di */

    case 15:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5752; /* pred_modrvvm1di */

    case 16:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5769; /* pred_modrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5786; /* pred_modrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5803; /* pred_modrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5820; /* pred_modrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5837; /* pred_modrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5854; /* pred_modrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5871; /* pred_modv1qi */

    case 23:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5888; /* pred_modv2qi */

    case 24:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5905; /* pred_modv4qi */

    case 25:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5922; /* pred_modv8qi */

    case 26:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5939; /* pred_modv16qi */

    case 27:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5956; /* pred_modv32qi */

    case 28:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5973; /* pred_modv64qi */

    case 29:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5990; /* pred_modv128qi */

    case 30:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6007; /* pred_modv256qi */

    case 31:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6024; /* pred_modv512qi */

    case 32:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6041; /* pred_modv1024qi */

    case 33:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6058; /* pred_modv2048qi */

    case 34:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6075; /* pred_modv4096qi */

    case 35:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6092; /* pred_modv1hi */

    case 36:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6109; /* pred_modv2hi */

    case 37:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6126; /* pred_modv4hi */

    case 38:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6143; /* pred_modv8hi */

    case 39:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6160; /* pred_modv16hi */

    case 40:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6177; /* pred_modv32hi */

    case 41:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6194; /* pred_modv64hi */

    case 42:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6211; /* pred_modv128hi */

    case 43:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6228; /* pred_modv256hi */

    case 44:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6245; /* pred_modv512hi */

    case 45:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6262; /* pred_modv1024hi */

    case 46:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6279; /* pred_modv2048hi */

    case 47:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6296; /* pred_modv1si */

    case 48:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6313; /* pred_modv2si */

    case 49:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6330; /* pred_modv4si */

    case 50:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6347; /* pred_modv8si */

    case 51:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6364; /* pred_modv16si */

    case 52:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6381; /* pred_modv32si */

    case 53:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6398; /* pred_modv64si */

    case 54:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6415; /* pred_modv128si */

    case 55:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6432; /* pred_modv256si */

    case 56:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6449; /* pred_modv512si */

    case 57:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6466; /* pred_modv1024si */

    case 58:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6483; /* pred_modv1di */

    case 59:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6500; /* pred_modv2di */

    case 60:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6517; /* pred_modv4di */

    case 61:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6534; /* pred_modv8di */

    case 62:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6551; /* pred_modv16di */

    case 63:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6568; /* pred_modv32di */

    case 64:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6585; /* pred_modv64di */

    case 65:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6602; /* pred_modv128di */

    case 66:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6619; /* pred_modv256di */

    case 67:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6636; /* pred_modv512di */

    case 68:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7331; /* pred_modrvvm8qi_scalar */

    case 69:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7336; /* pred_modrvvm4qi_scalar */

    case 70:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7341; /* pred_modrvvm2qi_scalar */

    case 71:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7346; /* pred_modrvvm1qi_scalar */

    case 72:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7351; /* pred_modrvvmf2qi_scalar */

    case 73:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7356; /* pred_modrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7361; /* pred_modrvvmf8qi_scalar */

    case 75:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7366; /* pred_modrvvm8hi_scalar */

    case 76:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7371; /* pred_modrvvm4hi_scalar */

    case 77:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7376; /* pred_modrvvm2hi_scalar */

    case 78:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7381; /* pred_modrvvm1hi_scalar */

    case 79:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7386; /* pred_modrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7391; /* pred_modrvvmf4hi_scalar */

    case 81:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7396; /* pred_modrvvm8si_scalar */

    case 82:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7401; /* pred_modrvvm4si_scalar */

    case 83:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7406; /* pred_modrvvm2si_scalar */

    case 84:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7411; /* pred_modrvvm1si_scalar */

    case 85:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7416; /* pred_modrvvmf2si_scalar */

    case 86:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7421; /* pred_modv1qi_scalar */

    case 87:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7426; /* pred_modv2qi_scalar */

    case 88:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7431; /* pred_modv4qi_scalar */

    case 89:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7436; /* pred_modv8qi_scalar */

    case 90:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7441; /* pred_modv16qi_scalar */

    case 91:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7446; /* pred_modv32qi_scalar */

    case 92:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7451; /* pred_modv64qi_scalar */

    case 93:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7456; /* pred_modv128qi_scalar */

    case 94:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7461; /* pred_modv256qi_scalar */

    case 95:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7466; /* pred_modv512qi_scalar */

    case 96:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7471; /* pred_modv1024qi_scalar */

    case 97:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7476; /* pred_modv2048qi_scalar */

    case 98:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7481; /* pred_modv4096qi_scalar */

    case 99:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7486; /* pred_modv1hi_scalar */

    case 100:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7491; /* pred_modv2hi_scalar */

    case 101:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7496; /* pred_modv4hi_scalar */

    case 102:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7501; /* pred_modv8hi_scalar */

    case 103:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7506; /* pred_modv16hi_scalar */

    case 104:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7511; /* pred_modv32hi_scalar */

    case 105:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7516; /* pred_modv64hi_scalar */

    case 106:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7521; /* pred_modv128hi_scalar */

    case 107:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7526; /* pred_modv256hi_scalar */

    case 108:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7531; /* pred_modv512hi_scalar */

    case 109:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7536; /* pred_modv1024hi_scalar */

    case 110:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7541; /* pred_modv2048hi_scalar */

    case 111:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7546; /* pred_modv1si_scalar */

    case 112:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7551; /* pred_modv2si_scalar */

    case 113:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7556; /* pred_modv4si_scalar */

    case 114:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7561; /* pred_modv8si_scalar */

    case 115:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7566; /* pred_modv16si_scalar */

    case 116:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7571; /* pred_modv32si_scalar */

    case 117:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7576; /* pred_modv64si_scalar */

    case 118:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7581; /* pred_modv128si_scalar */

    case 119:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7586; /* pred_modv256si_scalar */

    case 120:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7591; /* pred_modv512si_scalar */

    case 121:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7596; /* pred_modv1024si_scalar */

    case 122:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7907; /* *pred_modrvvm8di_scalar */

    case 123:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7912; /* *pred_modrvvm4di_scalar */

    case 124:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7917; /* *pred_modrvvm2di_scalar */

    case 125:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7922; /* *pred_modrvvm1di_scalar */

    case 126:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7927; /* *pred_modv1di_scalar */

    case 127:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7932; /* *pred_modv2di_scalar */

    case 128:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7937; /* *pred_modv4di_scalar */

    case 129:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7942; /* *pred_modv8di_scalar */

    case 130:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7947; /* *pred_modv16di_scalar */

    case 131:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7952; /* *pred_modv32di_scalar */

    case 132:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7957; /* *pred_modv64di_scalar */

    case 133:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7962; /* *pred_modv128di_scalar */

    case 134:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7967; /* *pred_modv256di_scalar */

    case 135:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7972; /* *pred_modv512di_scalar */

    case 136:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7977; /* *pred_modrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7982; /* *pred_modrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7987; /* *pred_modrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7992; /* *pred_modrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7997; /* *pred_modv1di_extended_scalar */

    case 141:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8002; /* *pred_modv2di_extended_scalar */

    case 142:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8007; /* *pred_modv4di_extended_scalar */

    case 143:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8012; /* *pred_modv8di_extended_scalar */

    case 144:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8017; /* *pred_modv16di_extended_scalar */

    case 145:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8022; /* *pred_modv32di_extended_scalar */

    case 146:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8027; /* *pred_modv64di_extended_scalar */

    case 147:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8032; /* *pred_modv128di_extended_scalar */

    case 148:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8037; /* *pred_modv256di_extended_scalar */

    case 149:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8042; /* *pred_modv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_896 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern503 (x2))
    {
    case 0:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17360; /* pred_fix_truncrvvm8hf */

    case 1:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17362; /* pred_fix_truncrvvm4hf */

    case 2:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17906; /* pred_narrow_fix_truncrvvm8sf */

    case 3:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17364; /* pred_fix_truncrvvm2hf */

    case 4:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17908; /* pred_narrow_fix_truncrvvm4sf */

    case 5:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17366; /* pred_fix_truncrvvm1hf */

    case 6:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17910; /* pred_narrow_fix_truncrvvm2sf */

    case 7:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17368; /* pred_fix_truncrvvmf2hf */

    case 8:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17912; /* pred_narrow_fix_truncrvvm1sf */

    case 9:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17370; /* pred_fix_truncrvvmf4hf */

    case 10:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17914; /* pred_narrow_fix_truncrvvmf2sf */

    case 11:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17372; /* pred_fix_truncrvvm8sf */

    case 12:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17612; /* pred_widen_fix_truncrvvm8si */

    case 13:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17374; /* pred_fix_truncrvvm4sf */

    case 14:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17614; /* pred_widen_fix_truncrvvm4si */

    case 15:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17916; /* pred_narrow_fix_truncrvvm8df */

    case 16:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17376; /* pred_fix_truncrvvm2sf */

    case 17:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17616; /* pred_widen_fix_truncrvvm2si */

    case 18:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17918; /* pred_narrow_fix_truncrvvm4df */

    case 19:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17378; /* pred_fix_truncrvvm1sf */

    case 20:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17618; /* pred_widen_fix_truncrvvm1si */

    case 21:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17920; /* pred_narrow_fix_truncrvvm2df */

    case 22:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17380; /* pred_fix_truncrvvmf2sf */

    case 23:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17620; /* pred_widen_fix_truncrvvmf2si */

    case 24:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17922; /* pred_narrow_fix_truncrvvm1df */

    case 25:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17382; /* pred_fix_truncrvvm8df */

    case 26:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17622; /* pred_widen_fix_truncrvvm8di */

    case 27:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17384; /* pred_fix_truncrvvm4df */

    case 28:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17624; /* pred_widen_fix_truncrvvm4di */

    case 29:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17386; /* pred_fix_truncrvvm2df */

    case 30:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17626; /* pred_widen_fix_truncrvvm2di */

    case 31:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17388; /* pred_fix_truncrvvm1df */

    case 32:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17628; /* pred_widen_fix_truncrvvm1di */

    case 33:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17390; /* pred_fix_truncv1hf */

    case 34:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17948; /* pred_narrow_fix_truncv1sf */

    case 35:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17392; /* pred_fix_truncv2hf */

    case 36:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17950; /* pred_narrow_fix_truncv2sf */

    case 37:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17394; /* pred_fix_truncv4hf */

    case 38:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17952; /* pred_narrow_fix_truncv4sf */

    case 39:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17396; /* pred_fix_truncv8hf */

    case 40:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17954; /* pred_narrow_fix_truncv8sf */

    case 41:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17398; /* pred_fix_truncv16hf */

    case 42:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17956; /* pred_narrow_fix_truncv16sf */

    case 43:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17400; /* pred_fix_truncv32hf */

    case 44:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17958; /* pred_narrow_fix_truncv32sf */

    case 45:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17402; /* pred_fix_truncv64hf */

    case 46:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17960; /* pred_narrow_fix_truncv64sf */

    case 47:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17404; /* pred_fix_truncv128hf */

    case 48:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17962; /* pred_narrow_fix_truncv128sf */

    case 49:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17406; /* pred_fix_truncv256hf */

    case 50:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17964; /* pred_narrow_fix_truncv256sf */

    case 51:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17408; /* pred_fix_truncv512hf */

    case 52:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17966; /* pred_narrow_fix_truncv512sf */

    case 53:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17410; /* pred_fix_truncv1024hf */

    case 54:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17968; /* pred_narrow_fix_truncv1024sf */

    case 55:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17412; /* pred_fix_truncv2048hf */

    case 56:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17414; /* pred_fix_truncv1sf */

    case 57:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 17630; /* pred_widen_fix_truncv1si */

    case 58:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17970; /* pred_narrow_fix_truncv1df */

    case 59:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17416; /* pred_fix_truncv2sf */

    case 60:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 17632; /* pred_widen_fix_truncv2si */

    case 61:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17972; /* pred_narrow_fix_truncv2df */

    case 62:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17418; /* pred_fix_truncv4sf */

    case 63:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 17634; /* pred_widen_fix_truncv4si */

    case 64:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17974; /* pred_narrow_fix_truncv4df */

    case 65:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17420; /* pred_fix_truncv8sf */

    case 66:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 17636; /* pred_widen_fix_truncv8si */

    case 67:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17976; /* pred_narrow_fix_truncv8df */

    case 68:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17422; /* pred_fix_truncv16sf */

    case 69:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17638; /* pred_widen_fix_truncv16si */

    case 70:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17978; /* pred_narrow_fix_truncv16df */

    case 71:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17424; /* pred_fix_truncv32sf */

    case 72:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17640; /* pred_widen_fix_truncv32si */

    case 73:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17980; /* pred_narrow_fix_truncv32df */

    case 74:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17426; /* pred_fix_truncv64sf */

    case 75:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17642; /* pred_widen_fix_truncv64si */

    case 76:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17982; /* pred_narrow_fix_truncv64df */

    case 77:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17428; /* pred_fix_truncv128sf */

    case 78:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17644; /* pred_widen_fix_truncv128si */

    case 79:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17984; /* pred_narrow_fix_truncv128df */

    case 80:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17430; /* pred_fix_truncv256sf */

    case 81:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17646; /* pred_widen_fix_truncv256si */

    case 82:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17986; /* pred_narrow_fix_truncv256df */

    case 83:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17432; /* pred_fix_truncv512sf */

    case 84:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17648; /* pred_widen_fix_truncv512si */

    case 85:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17988; /* pred_narrow_fix_truncv512df */

    case 86:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17434; /* pred_fix_truncv1024sf */

    case 87:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17650; /* pred_widen_fix_truncv1024si */

    case 88:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17436; /* pred_fix_truncv1df */

    case 89:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17652; /* pred_widen_fix_truncv1di */

    case 90:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17438; /* pred_fix_truncv2df */

    case 91:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17654; /* pred_widen_fix_truncv2di */

    case 92:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17440; /* pred_fix_truncv4df */

    case 93:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17656; /* pred_widen_fix_truncv4di */

    case 94:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17442; /* pred_fix_truncv8df */

    case 95:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17658; /* pred_widen_fix_truncv8di */

    case 96:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17444; /* pred_fix_truncv16df */

    case 97:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17660; /* pred_widen_fix_truncv16di */

    case 98:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17446; /* pred_fix_truncv32df */

    case 99:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17662; /* pred_widen_fix_truncv32di */

    case 100:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17448; /* pred_fix_truncv64df */

    case 101:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17664; /* pred_widen_fix_truncv64di */

    case 102:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17450; /* pred_fix_truncv128df */

    case 103:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17666; /* pred_widen_fix_truncv128di */

    case 104:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17452; /* pred_fix_truncv256df */

    case 105:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17668; /* pred_widen_fix_truncv256di */

    case 106:
      if (!(
#line 7506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17454; /* pred_fix_truncv512df */

    case 107:
      if (!(
#line 7578 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17670; /* pred_widen_fix_truncv512di */

    case 108:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17894; /* pred_narrow_fix_truncrvvm8hf */

    case 109:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17896; /* pred_narrow_fix_truncrvvm4hf */

    case 110:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17898; /* pred_narrow_fix_truncrvvm2hf */

    case 111:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17900; /* pred_narrow_fix_truncrvvm1hf */

    case 112:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17902; /* pred_narrow_fix_truncrvvmf2hf */

    case 113:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17904; /* pred_narrow_fix_truncrvvmf4hf */

    case 114:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17924; /* pred_narrow_fix_truncv1hf */

    case 115:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17926; /* pred_narrow_fix_truncv2hf */

    case 116:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17928; /* pred_narrow_fix_truncv4hf */

    case 117:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17930; /* pred_narrow_fix_truncv8hf */

    case 118:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17932; /* pred_narrow_fix_truncv16hf */

    case 119:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17934; /* pred_narrow_fix_truncv32hf */

    case 120:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17936; /* pred_narrow_fix_truncv64hf */

    case 121:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17938; /* pred_narrow_fix_truncv128hf */

    case 122:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17940; /* pred_narrow_fix_truncv256hf */

    case 123:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17942; /* pred_narrow_fix_truncv512hf */

    case 124:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17944; /* pred_narrow_fix_truncv1024hf */

    case 125:
      if (!(
#line 7666 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17946; /* pred_narrow_fix_truncv2048hf */

    default:
      return -1;
    }
}

 int
recog_912 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2, 
175))
    {
    case 0:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2201; /* pred_indexed_load_widthwurvvm8qi */

    case 1:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2207; /* pred_indexed_load_widthwurvvm4qi */

    case 2:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2213; /* pred_indexed_load_widthwurvvm2qi */

    case 3:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2219; /* pred_indexed_load_widthwurvvm1qi */

    case 4:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2225; /* pred_indexed_load_widthwurvvm8hi */

    case 5:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2231; /* pred_indexed_load_widthwurvvm4hi */

    case 6:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2237; /* pred_indexed_load_widthwurvvm2hi */

    case 7:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2243; /* pred_indexed_load_widthwurvvm1hi */

    case 8:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2249; /* pred_indexed_load_widthwurvvm8si */

    case 9:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2255; /* pred_indexed_load_widthwurvvm4si */

    case 10:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2261; /* pred_indexed_load_widthwurvvm2si */

    case 11:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2267; /* pred_indexed_load_widthwurvvm1si */

    case 12:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2273; /* pred_indexed_load_widthwurvvm8di */

    case 13:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2279; /* pred_indexed_load_widthwurvvm4di */

    case 14:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2285; /* pred_indexed_load_widthwurvvm2di */

    case 15:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2291; /* pred_indexed_load_widthwurvvm1di */

    case 16:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2297; /* pred_indexed_load_widthwurvvmf8qi */

    case 17:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2303; /* pred_indexed_load_widthwurvvmf4hi */

    case 18:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2309; /* pred_indexed_load_widthwurvvmf2si */

    default:
      return -1;
    }
}

 int
recog_915 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern718 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11394; /* pred_smulrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11870; /* pred_smulrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11401; /* pred_smulrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11875; /* pred_smulrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11408; /* pred_smulrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11880; /* pred_smulrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11415; /* pred_smulrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11885; /* pred_smulrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11422; /* pred_smulrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11905; /* pred_smulrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11429; /* pred_smulrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11910; /* pred_smulrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11436; /* pred_smulrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11915; /* pred_smulrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11443; /* pred_smulrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11920; /* pred_smulrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11450; /* pred_smulrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11935; /* pred_smulrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11457; /* pred_smulrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11940; /* pred_smulrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11464; /* pred_smulrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11945; /* pred_smulrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11471; /* pred_smulrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11950; /* pred_smulrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11478; /* pred_smulrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12184; /* *pred_smulrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11485; /* pred_smulrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12189; /* *pred_smulrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11492; /* pred_smulrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12194; /* *pred_smulrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11499; /* pred_smulrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12199; /* *pred_smulrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11506; /* pred_smulrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11890; /* pred_smulrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11513; /* pred_smulrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11895; /* pred_smulrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11520; /* pred_smulrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11900; /* pred_smulrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11527; /* pred_smulrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11925; /* pred_smulrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11534; /* pred_smulrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11930; /* pred_smulrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11541; /* pred_smulrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11955; /* pred_smulrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11548; /* pred_smulv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 557 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11960; /* pred_smulv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11555; /* pred_smulv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 558 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11965; /* pred_smulv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11562; /* pred_smulv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 559 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11970; /* pred_smulv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11569; /* pred_smulv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 560 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11975; /* pred_smulv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11576; /* pred_smulv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 561 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11980; /* pred_smulv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11583; /* pred_smulv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 562 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11985; /* pred_smulv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11590; /* pred_smulv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 563 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11990; /* pred_smulv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11597; /* pred_smulv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 564 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11995; /* pred_smulv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11604; /* pred_smulv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12000; /* pred_smulv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11611; /* pred_smulv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 566 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12005; /* pred_smulv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11618; /* pred_smulv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12010; /* pred_smulv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11625; /* pred_smulv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 568 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12015; /* pred_smulv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11632; /* pred_smulv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12020; /* pred_smulv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11639; /* pred_smulv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 570 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12025; /* pred_smulv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11646; /* pred_smulv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12030; /* pred_smulv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11653; /* pred_smulv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12035; /* pred_smulv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11660; /* pred_smulv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12040; /* pred_smulv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11667; /* pred_smulv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12045; /* pred_smulv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11674; /* pred_smulv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12050; /* pred_smulv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11681; /* pred_smulv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12055; /* pred_smulv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11688; /* pred_smulv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12060; /* pred_smulv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11695; /* pred_smulv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12065; /* pred_smulv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11702; /* pred_smulv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12070; /* pred_smulv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11709; /* pred_smulv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12075; /* pred_smulv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11716; /* pred_smulv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12080; /* pred_smulv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11723; /* pred_smulv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12085; /* pred_smulv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11730; /* pred_smulv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12090; /* pred_smulv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11737; /* pred_smulv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12095; /* pred_smulv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11744; /* pred_smulv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12100; /* pred_smulv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11751; /* pred_smulv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12105; /* pred_smulv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11758; /* pred_smulv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12110; /* pred_smulv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11765; /* pred_smulv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12115; /* pred_smulv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11772; /* pred_smulv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12120; /* pred_smulv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11779; /* pred_smulv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12125; /* pred_smulv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11786; /* pred_smulv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12130; /* pred_smulv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11793; /* pred_smulv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12135; /* pred_smulv1024si_scalar */

    case 58:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11800; /* pred_smulv1di */

    case 59:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11807; /* pred_smulv2di */

    case 60:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11814; /* pred_smulv4di */

    case 61:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11821; /* pred_smulv8di */

    case 62:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11828; /* pred_smulv16di */

    case 63:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11835; /* pred_smulv32di */

    case 64:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11842; /* pred_smulv64di */

    case 65:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11849; /* pred_smulv128di */

    case 66:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11856; /* pred_smulv256di */

    case 67:
      if (!(
#line 4542 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11863; /* pred_smulv512di */

    case 68:
      if (!(
#line 4668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12204; /* *pred_smulrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12209; /* *pred_smulrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12214; /* *pred_smulrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12219; /* *pred_smulrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_920 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern720 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12220; /* pred_narrow_cliprvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12316; /* pred_narrow_cliprvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12222; /* pred_narrow_cliprvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12318; /* pred_narrow_cliprvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12224; /* pred_narrow_cliprvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12320; /* pred_narrow_cliprvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12226; /* pred_narrow_cliprvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12322; /* pred_narrow_cliprvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12228; /* pred_narrow_cliprvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12324; /* pred_narrow_cliprvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12230; /* pred_narrow_cliprvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12326; /* pred_narrow_cliprvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12232; /* pred_narrow_cliprvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12328; /* pred_narrow_cliprvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12234; /* pred_narrow_cliprvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12330; /* pred_narrow_cliprvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12236; /* pred_narrow_cliprvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12332; /* pred_narrow_cliprvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12238; /* pred_narrow_cliprvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12334; /* pred_narrow_cliprvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 12240; /* pred_narrow_cliprvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 12336; /* pred_narrow_cliprvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12242; /* pred_narrow_cliprvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12338; /* pred_narrow_cliprvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12244; /* pred_narrow_cliprvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12340; /* pred_narrow_cliprvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12246; /* pred_narrow_cliprvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12342; /* pred_narrow_cliprvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 12248; /* pred_narrow_cliprvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12344; /* pred_narrow_cliprvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 12250; /* pred_narrow_clipv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12346; /* pred_narrow_clipv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 12252; /* pred_narrow_clipv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12348; /* pred_narrow_clipv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12254; /* pred_narrow_clipv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12350; /* pred_narrow_clipv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12256; /* pred_narrow_clipv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12352; /* pred_narrow_clipv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 12258; /* pred_narrow_clipv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12354; /* pred_narrow_clipv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12260; /* pred_narrow_clipv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12356; /* pred_narrow_clipv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12262; /* pred_narrow_clipv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12358; /* pred_narrow_clipv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12264; /* pred_narrow_clipv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12360; /* pred_narrow_clipv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12266; /* pred_narrow_clipv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12362; /* pred_narrow_clipv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12268; /* pred_narrow_clipv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12364; /* pred_narrow_clipv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 12270; /* pred_narrow_clipv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12366; /* pred_narrow_clipv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 12272; /* pred_narrow_clipv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12368; /* pred_narrow_clipv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 12274; /* pred_narrow_clipv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12370; /* pred_narrow_clipv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 12276; /* pred_narrow_clipv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12372; /* pred_narrow_clipv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12278; /* pred_narrow_clipv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12374; /* pred_narrow_clipv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12280; /* pred_narrow_clipv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12376; /* pred_narrow_clipv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 12282; /* pred_narrow_clipv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12378; /* pred_narrow_clipv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12284; /* pred_narrow_clipv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12380; /* pred_narrow_clipv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12286; /* pred_narrow_clipv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12382; /* pred_narrow_clipv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12288; /* pred_narrow_clipv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12384; /* pred_narrow_clipv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12290; /* pred_narrow_clipv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12386; /* pred_narrow_clipv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12292; /* pred_narrow_clipv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12388; /* pred_narrow_clipv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 12294; /* pred_narrow_clipv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12390; /* pred_narrow_clipv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 12296; /* pred_narrow_clipv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12392; /* pred_narrow_clipv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 12298; /* pred_narrow_clipv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12394; /* pred_narrow_clipv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12300; /* pred_narrow_clipv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12396; /* pred_narrow_clipv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12302; /* pred_narrow_clipv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12398; /* pred_narrow_clipv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 12304; /* pred_narrow_clipv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12400; /* pred_narrow_clipv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12306; /* pred_narrow_clipv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12402; /* pred_narrow_clipv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12308; /* pred_narrow_clipv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12404; /* pred_narrow_clipv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12310; /* pred_narrow_clipv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12406; /* pred_narrow_clipv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12312; /* pred_narrow_clipv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12408; /* pred_narrow_clipv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4691 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12314; /* pred_narrow_clipv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4714 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12410; /* pred_narrow_clipv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_1028 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_923 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15335; /* *pred_maddrvvm8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15431; /* *pred_maccrvvm8hf */
}

 int
recog_1039 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15739; /* *pred_mul_neg_addrvvmf2sf_undef */
}

 int
recog_1048 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15757; /* *pred_mul_neg_addv16hf_undef */
}

 int
recog_1058 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15777; /* *pred_mul_neg_addv4sf_undef */
}

 int
recog_1068 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15797; /* *pred_mul_neg_addv2df_undef */
}

 int
recog_1078 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1075 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15907; /* *pred_nmsubv256df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 16003; /* *pred_nmsacv256df */
}

 int
recog_1088 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1065 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15887; /* *pred_nmsubv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15983; /* *pred_nmsacv512sf */
}

 int
recog_1098 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1055 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15867; /* *pred_nmsubv2048hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15963; /* *pred_nmsacv2048hf */
}

 int
recog_1108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1045 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15847; /* *pred_nmsubv2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15943; /* *pred_nmsacv2hf */
}

 int
recog_1118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1035 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15827; /* *pred_nmsubrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15923; /* *pred_nmsacrvvm8sf */
}

 int
recog_1128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15240; /* *pred_mul_subrvvm8hf_undef */
}

 int
recog_1135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15254; /* *pred_mul_subrvvm4sf_undef */
}

 int
recog_1142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15268; /* *pred_mul_subrvvm1df_undef */
}

 int
recog_1149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15282; /* *pred_mul_subv64hf_undef */
}

 int
recog_1156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15296; /* *pred_mul_subv2sf_undef */
}

 int
recog_1163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15310; /* *pred_mul_subv256sf_undef */
}

 int
recog_1170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15324; /* *pred_mul_subv16df_undef */
}

 int
recog_1177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1174 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15428; /* *pred_msubv256df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15524; /* *pred_msacv256df */
}

 int
recog_1184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1167 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15414; /* *pred_msubv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15510; /* *pred_msacv2df */
}

 int
recog_1191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1160 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 15400; /* *pred_msubv32sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15496; /* *pred_msacv32sf */
}

 int
recog_1198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1153 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15386; /* *pred_msubv1024hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15482; /* *pred_msacv1024hf */
}

 int
recog_1205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1146 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15372; /* *pred_msubv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15468; /* *pred_msacv8hf */
}

 int
recog_1212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1139 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15358; /* *pred_msubrvvm8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15454; /* *pred_msacrvvm8df */
}

 int
recog_1219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1132 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15344; /* *pred_msubrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15440; /* *pred_msacrvvmf2hf */
}

 int
recog_1226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15724; /* *pred_mul_neg_subrvvm2hf_undef */
}

 int
recog_1233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15738; /* *pred_mul_neg_subrvvm1sf_undef */
}

 int
recog_1240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15752; /* *pred_mul_neg_subv2hf_undef */
}

 int
recog_1247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15766; /* *pred_mul_neg_subv256hf_undef */
}

 int
recog_1254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15780; /* *pred_mul_neg_subv8sf_undef */
}

 int
recog_1261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15794; /* *pred_mul_neg_subv1024sf_undef */
}

 int
recog_1268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15808; /* *pred_mul_neg_subv64df_undef */
}

 int
recog_1275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1268 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15904; /* *pred_nmaddv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 16000; /* *pred_nmaccv64df */
}

 int
recog_1282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1261 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15890; /* *pred_nmaddv1024sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15986; /* *pred_nmaccv1024sf */
}

 int
recog_1289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1254 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15876; /* *pred_nmaddv8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15972; /* *pred_nmaccv8sf */
}

 int
recog_1296 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1247 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15862; /* *pred_nmaddv256hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15958; /* *pred_nmaccv256hf */
}

 int
recog_1304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1239 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15846; /* *pred_nmaddv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15942; /* *pred_nmaccv1hf */
}

 int
recog_1312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1231 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15830; /* *pred_nmaddrvvm4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15926; /* *pred_nmaccrvvm4sf */
}

 int
recog_1320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern579 (x2))
    {
    case 0:
      return recog_1223 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1222 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1221 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1220 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1219 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1218 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1217 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1216 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1215 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1214 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1213 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1212 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1211 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1210 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1209 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1208 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1207 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1206 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1205 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1204 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1203 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1202 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1201 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1200 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1199 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1198 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1197 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1196 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1195 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1194 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1193 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1192 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1191 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1190 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1189 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1188 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1187 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1186 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1185 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1184 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1183 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1182 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1181 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1180 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1179 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1178 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1177 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1176 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15528; /* *pred_msubrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15624; /* *pred_msacrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15530; /* *pred_msubrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15626; /* *pred_msacrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15532; /* *pred_msubrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15628; /* *pred_msacrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15534; /* *pred_msubrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15630; /* *pred_msacrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15536; /* *pred_msubrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15632; /* *pred_msacrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 15538; /* *pred_msubrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15634; /* *pred_msacrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15540; /* *pred_msubrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15636; /* *pred_msacrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15542; /* *pred_msubrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15638; /* *pred_msacrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15544; /* *pred_msubrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15640; /* *pred_msacrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15546; /* *pred_msubrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15642; /* *pred_msacrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 15548; /* *pred_msubrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15644; /* *pred_msacrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15550; /* *pred_msubrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15646; /* *pred_msacrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15552; /* *pred_msubrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15648; /* *pred_msacrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15554; /* *pred_msubrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15650; /* *pred_msacrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15556; /* *pred_msubrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15652; /* *pred_msacrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 15558; /* *pred_msubv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15654; /* *pred_msacv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 15560; /* *pred_msubv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15656; /* *pred_msacv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 15562; /* *pred_msubv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15658; /* *pred_msacv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 15564; /* *pred_msubv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15660; /* *pred_msacv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 15566; /* *pred_msubv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15662; /* *pred_msacv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 15568; /* *pred_msubv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15664; /* *pred_msacv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 15570; /* *pred_msubv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15666; /* *pred_msacv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 15572; /* *pred_msubv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15668; /* *pred_msacv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 15574; /* *pred_msubv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15670; /* *pred_msacv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 15576; /* *pred_msubv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15672; /* *pred_msacv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 15578; /* *pred_msubv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15674; /* *pred_msacv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 15580; /* *pred_msubv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15676; /* *pred_msacv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15582; /* *pred_msubv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15678; /* *pred_msacv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15584; /* *pred_msubv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15680; /* *pred_msacv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15586; /* *pred_msubv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15682; /* *pred_msacv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15588; /* *pred_msubv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15684; /* *pred_msacv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 15590; /* *pred_msubv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15686; /* *pred_msacv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 15592; /* *pred_msubv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15688; /* *pred_msacv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 15594; /* *pred_msubv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15690; /* *pred_msacv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 15596; /* *pred_msubv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15692; /* *pred_msacv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 15598; /* *pred_msubv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15694; /* *pred_msacv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 15600; /* *pred_msubv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15696; /* *pred_msacv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 15602; /* *pred_msubv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15698; /* *pred_msacv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15604; /* *pred_msubv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15700; /* *pred_msacv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15606; /* *pred_msubv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15702; /* *pred_msacv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15608; /* *pred_msubv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15704; /* *pred_msacv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 15610; /* *pred_msubv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15706; /* *pred_msacv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 15612; /* *pred_msubv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15708; /* *pred_msacv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 15614; /* *pred_msubv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15710; /* *pred_msacv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 15616; /* *pred_msubv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15712; /* *pred_msacv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 15618; /* *pred_msubv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15714; /* *pred_msacv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 15620; /* *pred_msubv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15716; /* *pred_msacv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6611 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 15622; /* *pred_msubv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6645 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15718; /* *pred_msacv512df_scalar */

    case 96:
      if (pattern698 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16689; /* pred_widen_mul_subrvvm8sf */

    case 97:
      if (pattern698 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16691; /* pred_widen_mul_subrvvm4sf */

    case 98:
      if (pattern698 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16693; /* pred_widen_mul_subrvvm2sf */

    case 99:
      if (pattern698 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16695; /* pred_widen_mul_subrvvm1sf */

    case 100:
      if (pattern698 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16697; /* pred_widen_mul_subrvvmf2sf */

    case 101:
      if (pattern698 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16699; /* pred_widen_mul_subrvvm8df */

    case 102:
      if (pattern698 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16701; /* pred_widen_mul_subrvvm4df */

    case 103:
      if (pattern698 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16703; /* pred_widen_mul_subrvvm2df */

    case 104:
      if (pattern698 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16705; /* pred_widen_mul_subrvvm1df */

    case 105:
      if (pattern698 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16707; /* pred_widen_mul_subv1sf */

    case 106:
      if (pattern698 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16709; /* pred_widen_mul_subv2sf */

    case 107:
      if (pattern698 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16711; /* pred_widen_mul_subv4sf */

    case 108:
      if (pattern698 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16713; /* pred_widen_mul_subv8sf */

    case 109:
      if (pattern698 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16715; /* pred_widen_mul_subv16sf */

    case 110:
      if (pattern698 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16717; /* pred_widen_mul_subv32sf */

    case 111:
      if (pattern698 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16719; /* pred_widen_mul_subv64sf */

    case 112:
      if (pattern698 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16721; /* pred_widen_mul_subv128sf */

    case 113:
      if (pattern698 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16723; /* pred_widen_mul_subv256sf */

    case 114:
      if (pattern698 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16725; /* pred_widen_mul_subv512sf */

    case 115:
      if (pattern698 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16727; /* pred_widen_mul_subv1024sf */

    case 116:
      if (pattern698 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16729; /* pred_widen_mul_subv1df */

    case 117:
      if (pattern698 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16731; /* pred_widen_mul_subv2df */

    case 118:
      if (pattern698 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16733; /* pred_widen_mul_subv4df */

    case 119:
      if (pattern698 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16735; /* pred_widen_mul_subv8df */

    case 120:
      if (pattern698 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16737; /* pred_widen_mul_subv16df */

    case 121:
      if (pattern698 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16739; /* pred_widen_mul_subv32df */

    case 122:
      if (pattern698 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16741; /* pred_widen_mul_subv64df */

    case 123:
      if (pattern698 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16743; /* pred_widen_mul_subv128df */

    case 124:
      if (pattern698 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16745; /* pred_widen_mul_subv256df */

    case 125:
      if (pattern698 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16747; /* pred_widen_mul_subv512df */

    case 126:
      if (pattern700 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16749; /* pred_widen_mul_subrvvm8sf_scalar */

    case 127:
      if (pattern700 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16751; /* pred_widen_mul_subrvvm4sf_scalar */

    case 128:
      if (pattern700 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16753; /* pred_widen_mul_subrvvm2sf_scalar */

    case 129:
      if (pattern700 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16755; /* pred_widen_mul_subrvvm1sf_scalar */

    case 130:
      if (pattern700 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16757; /* pred_widen_mul_subrvvmf2sf_scalar */

    case 131:
      if (pattern700 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16759; /* pred_widen_mul_subrvvm8df_scalar */

    case 132:
      if (pattern700 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16761; /* pred_widen_mul_subrvvm4df_scalar */

    case 133:
      if (pattern700 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16763; /* pred_widen_mul_subrvvm2df_scalar */

    case 134:
      if (pattern700 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16765; /* pred_widen_mul_subrvvm1df_scalar */

    case 135:
      if (pattern700 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16767; /* pred_widen_mul_subv1sf_scalar */

    case 136:
      if (pattern700 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16769; /* pred_widen_mul_subv2sf_scalar */

    case 137:
      if (pattern700 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16771; /* pred_widen_mul_subv4sf_scalar */

    case 138:
      if (pattern700 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16773; /* pred_widen_mul_subv8sf_scalar */

    case 139:
      if (pattern700 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16775; /* pred_widen_mul_subv16sf_scalar */

    case 140:
      if (pattern700 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16777; /* pred_widen_mul_subv32sf_scalar */

    case 141:
      if (pattern700 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16779; /* pred_widen_mul_subv64sf_scalar */

    case 142:
      if (pattern700 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16781; /* pred_widen_mul_subv128sf_scalar */

    case 143:
      if (pattern700 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16783; /* pred_widen_mul_subv256sf_scalar */

    case 144:
      if (pattern700 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16785; /* pred_widen_mul_subv512sf_scalar */

    case 145:
      if (pattern700 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16787; /* pred_widen_mul_subv1024sf_scalar */

    case 146:
      if (pattern700 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16789; /* pred_widen_mul_subv1df_scalar */

    case 147:
      if (pattern700 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16791; /* pred_widen_mul_subv2df_scalar */

    case 148:
      if (pattern700 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16793; /* pred_widen_mul_subv4df_scalar */

    case 149:
      if (pattern700 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16795; /* pred_widen_mul_subv8df_scalar */

    case 150:
      if (pattern700 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16797; /* pred_widen_mul_subv16df_scalar */

    case 151:
      if (pattern700 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16799; /* pred_widen_mul_subv32df_scalar */

    case 152:
      if (pattern700 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16801; /* pred_widen_mul_subv64df_scalar */

    case 153:
      if (pattern700 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16803; /* pred_widen_mul_subv128df_scalar */

    case 154:
      if (pattern700 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16805; /* pred_widen_mul_subv256df_scalar */

    case 155:
      if (pattern700 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16807; /* pred_widen_mul_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern533 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1366 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || !vector_neg_arith_operand (operands[5], E_V4QImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12708; /* *pred_ltgev4qi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12776; /* *pred_ltgev4qi_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || !vector_neg_arith_operand (operands[5], E_V4HImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12721; /* *pred_ltgev4hi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12789; /* *pred_ltgev4hi_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || !vector_neg_arith_operand (operands[5], E_V4SImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12733; /* *pred_ltgev4si */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12801; /* *pred_ltgev4si_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || !vector_neg_arith_operand (operands[5], E_V4DImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12744; /* *pred_ltgev4di */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12812; /* *pred_ltgev4di_narrow */

    default:
      return -1;
    }
}

 int
recog_1393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12840; /* *pred_cmpv4qi_scalar_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12853; /* *pred_cmpv4hi_scalar_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12865; /* *pred_cmpv4si_scalar_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12988; /* *pred_cmpv4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12847; /* *pred_cmpv512qi_scalar_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12860; /* *pred_cmpv512hi_scalar_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12872; /* *pred_cmpv512si_scalar_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12995; /* *pred_cmpv512di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern567 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1394 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || GET_MODE (x9) != E_V8QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12895; /* *pred_cmpv8qi_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12949; /* *pred_cmpv8qi_scalar_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || GET_MODE (x9) != E_V8HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12908; /* *pred_cmpv8hi_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12962; /* *pred_cmpv8hi_scalar_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || GET_MODE (x9) != E_V8SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12920; /* *pred_cmpv8si_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12974; /* *pred_cmpv8si_scalar_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || GET_MODE (x9) != E_V8DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5059 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 13003; /* *pred_cmpv8di_scalar */
      if (!(
#line 5081 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13017; /* *pred_cmpv8di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16978; /* *pred_cmprvvm2hf_narrow_merge_tie_mask */

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode)
          || !register_operand (operands[4], E_RVVM4SFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16983; /* *pred_cmprvvm4sf_narrow_merge_tie_mask */

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode)
          || !register_operand (operands[4], E_RVVM8DFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16987; /* *pred_cmprvvm8df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16980; /* *pred_cmprvvmf2hf_narrow_merge_tie_mask */

    case E_RVVM1SFmode:
      if (!register_operand (operands[3], E_RVVM1SFmode)
          || !register_operand (operands[4], E_RVVM1SFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16985; /* *pred_cmprvvm1sf_narrow_merge_tie_mask */

    case E_RVVM2DFmode:
      if (!register_operand (operands[3], E_RVVM2DFmode)
          || !register_operand (operands[4], E_RVVM2DFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16989; /* *pred_cmprvvm2df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1423 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || !register_operand (operands[4], E_V8HFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16994; /* *pred_cmpv8hf_narrow_merge_tie_mask */

    case E_V8SFmode:
      if (!register_operand (operands[3], E_V8SFmode)
          || !register_operand (operands[4], E_V8SFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17006; /* *pred_cmpv8sf_narrow_merge_tie_mask */

    case E_V8DFmode:
      if (!register_operand (operands[3], E_V8DFmode)
          || !register_operand (operands[4], E_V8DFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17017; /* *pred_cmpv8df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1428 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[3], E_V256HFmode)
          || !register_operand (operands[4], E_V256HFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16999; /* *pred_cmpv256hf_narrow_merge_tie_mask */

    case E_V256SFmode:
      if (!register_operand (operands[3], E_V256SFmode)
          || !register_operand (operands[4], E_V256SFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17011; /* *pred_cmpv256sf_narrow_merge_tie_mask */

    case E_V256DFmode:
      if (!register_operand (operands[3], E_V256DFmode)
          || !register_operand (operands[4], E_V256DFmode)
          || !(
#line 7319 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17022; /* *pred_cmpv256df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[3], E_RVVM1HFmode)
          || GET_MODE (x9) != E_RVVM1HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17075; /* *pred_cmprvvm1hf_scalar_merge_tie_mask */

    case E_RVVM2SFmode:
      if (!register_operand (operands[3], E_RVVM2SFmode)
          || GET_MODE (x9) != E_RVVM2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17080; /* *pred_cmprvvm2sf_scalar_merge_tie_mask */

    case E_RVVM4DFmode:
      if (!register_operand (operands[3], E_RVVM4DFmode)
          || GET_MODE (x9) != E_RVVM4DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17084; /* *pred_cmprvvm4df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || GET_MODE (x9) != E_V8HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17090; /* *pred_cmpv8hf_scalar_merge_tie_mask */

    case E_V8SFmode:
      if (!register_operand (operands[3], E_V8SFmode)
          || GET_MODE (x9) != E_V8SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17102; /* *pred_cmpv8sf_scalar_merge_tie_mask */

    case E_V8DFmode:
      if (!register_operand (operands[3], E_V8DFmode)
          || GET_MODE (x9) != E_V8DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17113; /* *pred_cmpv8df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1445 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17096; /* *pred_cmpv512hf_scalar_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17108; /* *pred_cmpv512sf_scalar_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17119; /* *pred_cmpv512df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern544 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1439 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || GET_MODE (x9) != E_V8HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7407 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HFmode)) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 17138; /* *pred_cmpv8hf_scalar */
      if (!(
#line 7429 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HFmode)) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17186; /* *pred_cmpv8hf_scalar_narrow */

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || GET_MODE (x9) != E_V8SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7407 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SFmode)) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 17150; /* *pred_cmpv8sf_scalar */
      if (!(
#line 7429 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SFmode)) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17198; /* *pred_cmpv8sf_scalar_narrow */

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || GET_MODE (x9) != E_V8DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7407 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DFmode)) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 17161; /* *pred_cmpv8df_scalar */
      if (!(
#line 7429 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DFmode)) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17209; /* *pred_cmpv8df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1458 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern214 (x2))
    {
    case 0:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25054; /* vcond_mask_rvvm8qirvvm1bi */

    case 1:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25055; /* vcond_mask_rvvm4qirvvmf2bi */

    case 2:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25056; /* vcond_mask_rvvm2qirvvmf4bi */

    case 3:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25057; /* vcond_mask_rvvm1qirvvmf8bi */

    case 4:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25058; /* vcond_mask_rvvm8hirvvmf2bi */

    case 5:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25059; /* vcond_mask_rvvm4hirvvmf4bi */

    case 6:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25060; /* vcond_mask_rvvm2hirvvmf8bi */

    case 7:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25061; /* vcond_mask_rvvm1hirvvmf16bi */

    case 8:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25062; /* vcond_mask_rvvm8sirvvmf4bi */

    case 9:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25063; /* vcond_mask_rvvm4sirvvmf8bi */

    case 10:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25064; /* vcond_mask_rvvm2sirvvmf16bi */

    case 11:
      if (!
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25065; /* vcond_mask_rvvm1sirvvmf32bi */

    case 12:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25066; /* vcond_mask_rvvm8dirvvmf8bi */

    case 13:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25067; /* vcond_mask_rvvm4dirvvmf16bi */

    case 14:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25068; /* vcond_mask_rvvm2dirvvmf32bi */

    case 15:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25069; /* vcond_mask_rvvm1dirvvmf64bi */

    case 16:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25070; /* vcond_mask_rvvmf2qirvvmf16bi */

    case 17:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25071; /* vcond_mask_rvvmf4qirvvmf32bi */

    case 18:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25072; /* vcond_mask_rvvmf8qirvvmf64bi */

    case 19:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25073; /* vcond_mask_rvvmf2hirvvmf32bi */

    case 20:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25074; /* vcond_mask_rvvmf4hirvvmf64bi */

    case 21:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25075; /* vcond_mask_rvvmf2sirvvmf64bi */

    case 22:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25076; /* vcond_mask_rvvm8bfrvvmf2bi */

    case 23:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25077; /* vcond_mask_rvvm4bfrvvmf4bi */

    case 24:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25078; /* vcond_mask_rvvm2bfrvvmf8bi */

    case 25:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25079; /* vcond_mask_rvvm1bfrvvmf16bi */

    case 26:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 25080; /* vcond_mask_rvvmf2bfrvvmf32bi */

    case 27:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25081; /* vcond_mask_rvvmf4bfrvvmf64bi */

    case 28:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25082; /* vcond_mask_rvvm8hfrvvmf2bi */

    case 29:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25083; /* vcond_mask_rvvm4hfrvvmf4bi */

    case 30:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25084; /* vcond_mask_rvvm2hfrvvmf8bi */

    case 31:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25085; /* vcond_mask_rvvm1hfrvvmf16bi */

    case 32:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25086; /* vcond_mask_rvvmf2hfrvvmf32bi */

    case 33:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25087; /* vcond_mask_rvvmf4hfrvvmf64bi */

    case 34:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25088; /* vcond_mask_rvvm8sfrvvmf4bi */

    case 35:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25089; /* vcond_mask_rvvm4sfrvvmf8bi */

    case 36:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25090; /* vcond_mask_rvvm2sfrvvmf16bi */

    case 37:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25091; /* vcond_mask_rvvm1sfrvvmf32bi */

    case 38:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25092; /* vcond_mask_rvvmf2sfrvvmf64bi */

    case 39:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25093; /* vcond_mask_rvvm8dfrvvmf8bi */

    case 40:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25094; /* vcond_mask_rvvm4dfrvvmf16bi */

    case 41:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25095; /* vcond_mask_rvvm2dfrvvmf32bi */

    case 42:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25096; /* vcond_mask_rvvm1dfrvvmf64bi */

    case 43:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25097; /* vcond_mask_v1qiv1bi */

    case 44:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25098; /* vcond_mask_v2qiv2bi */

    case 45:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25099; /* vcond_mask_v4qiv4bi */

    case 46:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25100; /* vcond_mask_v8qiv8bi */

    case 47:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25101; /* vcond_mask_v16qiv16bi */

    case 48:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25102; /* vcond_mask_v32qiv32bi */

    case 49:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25103; /* vcond_mask_v64qiv64bi */

    case 50:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25104; /* vcond_mask_v128qiv128bi */

    case 51:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25105; /* vcond_mask_v256qiv256bi */

    case 52:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25106; /* vcond_mask_v512qiv512bi */

    case 53:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25107; /* vcond_mask_v1024qiv1024bi */

    case 54:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25108; /* vcond_mask_v2048qiv2048bi */

    case 55:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25109; /* vcond_mask_v4096qiv4096bi */

    case 56:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25110; /* vcond_mask_v1hiv1bi */

    case 57:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25111; /* vcond_mask_v2hiv2bi */

    case 58:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25112; /* vcond_mask_v4hiv4bi */

    case 59:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25113; /* vcond_mask_v8hiv8bi */

    case 60:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25114; /* vcond_mask_v16hiv16bi */

    case 61:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25115; /* vcond_mask_v32hiv32bi */

    case 62:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25116; /* vcond_mask_v64hiv64bi */

    case 63:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25117; /* vcond_mask_v128hiv128bi */

    case 64:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25118; /* vcond_mask_v256hiv256bi */

    case 65:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25119; /* vcond_mask_v512hiv512bi */

    case 66:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25120; /* vcond_mask_v1024hiv1024bi */

    case 67:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25121; /* vcond_mask_v2048hiv2048bi */

    case 68:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25122; /* vcond_mask_v1siv1bi */

    case 69:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25123; /* vcond_mask_v2siv2bi */

    case 70:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25124; /* vcond_mask_v4siv4bi */

    case 71:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25125; /* vcond_mask_v8siv8bi */

    case 72:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25126; /* vcond_mask_v16siv16bi */

    case 73:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25127; /* vcond_mask_v32siv32bi */

    case 74:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25128; /* vcond_mask_v64siv64bi */

    case 75:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25129; /* vcond_mask_v128siv128bi */

    case 76:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25130; /* vcond_mask_v256siv256bi */

    case 77:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25131; /* vcond_mask_v512siv512bi */

    case 78:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25132; /* vcond_mask_v1024siv1024bi */

    case 79:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25133; /* vcond_mask_v1div1bi */

    case 80:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25134; /* vcond_mask_v2div2bi */

    case 81:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25135; /* vcond_mask_v4div4bi */

    case 82:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25136; /* vcond_mask_v8div8bi */

    case 83:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25137; /* vcond_mask_v16div16bi */

    case 84:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25138; /* vcond_mask_v32div32bi */

    case 85:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25139; /* vcond_mask_v64div64bi */

    case 86:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25140; /* vcond_mask_v128div128bi */

    case 87:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25141; /* vcond_mask_v256div256bi */

    case 88:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25142; /* vcond_mask_v512div512bi */

    case 89:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25143; /* vcond_mask_v1hfv1bi */

    case 90:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25144; /* vcond_mask_v2hfv2bi */

    case 91:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25145; /* vcond_mask_v4hfv4bi */

    case 92:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25146; /* vcond_mask_v8hfv8bi */

    case 93:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 25147; /* vcond_mask_v16hfv16bi */

    case 94:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25148; /* vcond_mask_v32hfv32bi */

    case 95:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25149; /* vcond_mask_v64hfv64bi */

    case 96:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25150; /* vcond_mask_v128hfv128bi */

    case 97:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25151; /* vcond_mask_v256hfv256bi */

    case 98:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25152; /* vcond_mask_v512hfv512bi */

    case 99:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25153; /* vcond_mask_v1024hfv1024bi */

    case 100:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25154; /* vcond_mask_v2048hfv2048bi */

    case 101:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25155; /* vcond_mask_v1sfv1bi */

    case 102:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25156; /* vcond_mask_v2sfv2bi */

    case 103:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25157; /* vcond_mask_v4sfv4bi */

    case 104:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25158; /* vcond_mask_v8sfv8bi */

    case 105:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25159; /* vcond_mask_v16sfv16bi */

    case 106:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25160; /* vcond_mask_v32sfv32bi */

    case 107:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25161; /* vcond_mask_v64sfv64bi */

    case 108:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25162; /* vcond_mask_v128sfv128bi */

    case 109:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25163; /* vcond_mask_v256sfv256bi */

    case 110:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25164; /* vcond_mask_v512sfv512bi */

    case 111:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25165; /* vcond_mask_v1024sfv1024bi */

    case 112:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25166; /* vcond_mask_v1dfv1bi */

    case 113:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25167; /* vcond_mask_v2dfv2bi */

    case 114:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25168; /* vcond_mask_v4dfv4bi */

    case 115:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25169; /* vcond_mask_v8dfv8bi */

    case 116:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25170; /* vcond_mask_v16dfv16bi */

    case 117:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25171; /* vcond_mask_v32dfv32bi */

    case 118:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25172; /* vcond_mask_v64dfv64bi */

    case 119:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25173; /* vcond_mask_v128dfv128bi */

    case 120:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25174; /* vcond_mask_v256dfv256bi */

    case 121:
      if (!(
#line 591 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25175; /* vcond_mask_v512dfv512bi */

    case 122:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27401; /* *cond_absrvvm8hf */

    case 123:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27402; /* *cond_absrvvm4hf */

    case 124:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27403; /* *cond_absrvvm2hf */

    case 125:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27404; /* *cond_absrvvm1hf */

    case 126:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27405; /* *cond_absrvvmf2hf */

    case 127:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27406; /* *cond_absrvvmf4hf */

    case 128:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27407; /* *cond_absrvvm8sf */

    case 129:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27408; /* *cond_absrvvm4sf */

    case 130:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27409; /* *cond_absrvvm2sf */

    case 131:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27410; /* *cond_absrvvm1sf */

    case 132:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27411; /* *cond_absrvvmf2sf */

    case 133:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27412; /* *cond_absrvvm8df */

    case 134:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27413; /* *cond_absrvvm4df */

    case 135:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27414; /* *cond_absrvvm2df */

    case 136:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27415; /* *cond_absrvvm1df */

    case 137:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27416; /* *cond_absv1hf */

    case 138:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27417; /* *cond_absv2hf */

    case 139:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27418; /* *cond_absv4hf */

    case 140:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27419; /* *cond_absv8hf */

    case 141:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27420; /* *cond_absv16hf */

    case 142:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27421; /* *cond_absv32hf */

    case 143:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27422; /* *cond_absv64hf */

    case 144:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27423; /* *cond_absv128hf */

    case 145:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27424; /* *cond_absv256hf */

    case 146:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27425; /* *cond_absv512hf */

    case 147:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27426; /* *cond_absv1024hf */

    case 148:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27427; /* *cond_absv2048hf */

    case 149:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27428; /* *cond_absv1sf */

    case 150:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27429; /* *cond_absv2sf */

    case 151:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27430; /* *cond_absv4sf */

    case 152:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27431; /* *cond_absv8sf */

    case 153:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27432; /* *cond_absv16sf */

    case 154:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27433; /* *cond_absv32sf */

    case 155:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27434; /* *cond_absv64sf */

    case 156:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27435; /* *cond_absv128sf */

    case 157:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27436; /* *cond_absv256sf */

    case 158:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27437; /* *cond_absv512sf */

    case 159:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27438; /* *cond_absv1024sf */

    case 160:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27439; /* *cond_absv1df */

    case 161:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27440; /* *cond_absv2df */

    case 162:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27441; /* *cond_absv4df */

    case 163:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27442; /* *cond_absv8df */

    case 164:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27443; /* *cond_absv16df */

    case 165:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27444; /* *cond_absv32df */

    case 166:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27445; /* *cond_absv64df */

    case 167:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27446; /* *cond_absv128df */

    case 168:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27447; /* *cond_absv256df */

    case 169:
      if (!(
#line 107 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27448; /* *cond_absv512df */

    case 170:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27449; /* *cond_sqrtrvvm8hf */

    case 171:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27450; /* *cond_sqrtrvvm4hf */

    case 172:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27451; /* *cond_sqrtrvvm2hf */

    case 173:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27452; /* *cond_sqrtrvvm1hf */

    case 174:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27453; /* *cond_sqrtrvvmf2hf */

    case 175:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27454; /* *cond_sqrtrvvmf4hf */

    case 176:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27455; /* *cond_sqrtrvvm8sf */

    case 177:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27456; /* *cond_sqrtrvvm4sf */

    case 178:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27457; /* *cond_sqrtrvvm2sf */

    case 179:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27458; /* *cond_sqrtrvvm1sf */

    case 180:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27459; /* *cond_sqrtrvvmf2sf */

    case 181:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27460; /* *cond_sqrtrvvm8df */

    case 182:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27461; /* *cond_sqrtrvvm4df */

    case 183:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27462; /* *cond_sqrtrvvm2df */

    case 184:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27463; /* *cond_sqrtrvvm1df */

    case 185:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27464; /* *cond_sqrtv1hf */

    case 186:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27465; /* *cond_sqrtv2hf */

    case 187:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27466; /* *cond_sqrtv4hf */

    case 188:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27467; /* *cond_sqrtv8hf */

    case 189:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27468; /* *cond_sqrtv16hf */

    case 190:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27469; /* *cond_sqrtv32hf */

    case 191:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27470; /* *cond_sqrtv64hf */

    case 192:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27471; /* *cond_sqrtv128hf */

    case 193:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27472; /* *cond_sqrtv256hf */

    case 194:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27473; /* *cond_sqrtv512hf */

    case 195:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27474; /* *cond_sqrtv1024hf */

    case 196:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27475; /* *cond_sqrtv2048hf */

    case 197:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27476; /* *cond_sqrtv1sf */

    case 198:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27477; /* *cond_sqrtv2sf */

    case 199:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27478; /* *cond_sqrtv4sf */

    case 200:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27479; /* *cond_sqrtv8sf */

    case 201:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27480; /* *cond_sqrtv16sf */

    case 202:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27481; /* *cond_sqrtv32sf */

    case 203:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27482; /* *cond_sqrtv64sf */

    case 204:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27483; /* *cond_sqrtv128sf */

    case 205:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27484; /* *cond_sqrtv256sf */

    case 206:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27485; /* *cond_sqrtv512sf */

    case 207:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27486; /* *cond_sqrtv1024sf */

    case 208:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27487; /* *cond_sqrtv1df */

    case 209:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27488; /* *cond_sqrtv2df */

    case 210:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27489; /* *cond_sqrtv4df */

    case 211:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27490; /* *cond_sqrtv8df */

    case 212:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27491; /* *cond_sqrtv16df */

    case 213:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27492; /* *cond_sqrtv32df */

    case 214:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27493; /* *cond_sqrtv64df */

    case 215:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27494; /* *cond_sqrtv128df */

    case 216:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27495; /* *cond_sqrtv256df */

    case 217:
      if (!(
#line 126 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27496; /* *cond_sqrtv512df */

    case 218:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27497; /* *cond_extendrvvm4qirvvm8hi */

    case 219:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27499; /* *cond_extendrvvm2qirvvm4hi */

    case 220:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27501; /* *cond_extendrvvm1qirvvm2hi */

    case 221:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27503; /* *cond_extendrvvmf2qirvvm1hi */

    case 222:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27505; /* *cond_extendrvvmf4qirvvmf2hi */

    case 223:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27507; /* *cond_extendrvvmf8qirvvmf4hi */

    case 224:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27509; /* *cond_extendrvvm4hirvvm8si */

    case 225:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27593; /* *cond_extendrvvm2qirvvm8si */

    case 226:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27511; /* *cond_extendrvvm2hirvvm4si */

    case 227:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27595; /* *cond_extendrvvm1qirvvm4si */

    case 228:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27513; /* *cond_extendrvvm1hirvvm2si */

    case 229:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27597; /* *cond_extendrvvmf2qirvvm2si */

    case 230:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27515; /* *cond_extendrvvmf2hirvvm1si */

    case 231:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27599; /* *cond_extendrvvmf4qirvvm1si */

    case 232:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27517; /* *cond_extendrvvmf4hirvvmf2si */

    case 233:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27601; /* *cond_extendrvvmf8qirvvmf2si */

    case 234:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27519; /* *cond_extendrvvm4sirvvm8di */

    case 235:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27603; /* *cond_extendrvvm2hirvvm8di */

    case 236:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27653; /* *cond_extendrvvm1qirvvm8di */

    case 237:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27521; /* *cond_extendrvvm2sirvvm4di */

    case 238:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27605; /* *cond_extendrvvm1hirvvm4di */

    case 239:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27655; /* *cond_extendrvvmf2qirvvm4di */

    case 240:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27523; /* *cond_extendrvvm1sirvvm2di */

    case 241:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27607; /* *cond_extendrvvmf2hirvvm2di */

    case 242:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27657; /* *cond_extendrvvmf4qirvvm2di */

    case 243:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27525; /* *cond_extendrvvmf2sirvvm1di */

    case 244:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27609; /* *cond_extendrvvmf4hirvvm1di */

    case 245:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27659; /* *cond_extendrvvmf8qirvvm1di */

    case 246:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27527; /* *cond_extendv1qiv1hi */

    case 247:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27529; /* *cond_extendv2qiv2hi */

    case 248:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27531; /* *cond_extendv4qiv4hi */

    case 249:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27533; /* *cond_extendv8qiv8hi */

    case 250:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27535; /* *cond_extendv16qiv16hi */

    case 251:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27537; /* *cond_extendv32qiv32hi */

    case 252:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27539; /* *cond_extendv64qiv64hi */

    case 253:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27541; /* *cond_extendv128qiv128hi */

    case 254:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27543; /* *cond_extendv256qiv256hi */

    case 255:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27545; /* *cond_extendv512qiv512hi */

    case 256:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27547; /* *cond_extendv1024qiv1024hi */

    case 257:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27549; /* *cond_extendv2048qiv2048hi */

    case 258:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27551; /* *cond_extendv1hiv1si */

    case 259:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27611; /* *cond_extendv1qiv1si */

    case 260:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27553; /* *cond_extendv2hiv2si */

    case 261:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27613; /* *cond_extendv2qiv2si */

    case 262:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27555; /* *cond_extendv4hiv4si */

    case 263:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27615; /* *cond_extendv4qiv4si */

    case 264:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27557; /* *cond_extendv8hiv8si */

    case 265:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27617; /* *cond_extendv8qiv8si */

    case 266:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27559; /* *cond_extendv16hiv16si */

    case 267:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27619; /* *cond_extendv16qiv16si */

    case 268:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27561; /* *cond_extendv32hiv32si */

    case 269:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27621; /* *cond_extendv32qiv32si */

    case 270:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27563; /* *cond_extendv64hiv64si */

    case 271:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27623; /* *cond_extendv64qiv64si */

    case 272:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27565; /* *cond_extendv128hiv128si */

    case 273:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27625; /* *cond_extendv128qiv128si */

    case 274:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27567; /* *cond_extendv256hiv256si */

    case 275:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27627; /* *cond_extendv256qiv256si */

    case 276:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27569; /* *cond_extendv512hiv512si */

    case 277:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27629; /* *cond_extendv512qiv512si */

    case 278:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27571; /* *cond_extendv1024hiv1024si */

    case 279:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27631; /* *cond_extendv1024qiv1024si */

    case 280:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27573; /* *cond_extendv1siv1di */

    case 281:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27633; /* *cond_extendv1hiv1di */

    case 282:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27661; /* *cond_extendv1qiv1di */

    case 283:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27575; /* *cond_extendv2siv2di */

    case 284:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27635; /* *cond_extendv2hiv2di */

    case 285:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27663; /* *cond_extendv2qiv2di */

    case 286:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27577; /* *cond_extendv4siv4di */

    case 287:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27637; /* *cond_extendv4hiv4di */

    case 288:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27665; /* *cond_extendv4qiv4di */

    case 289:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27579; /* *cond_extendv8siv8di */

    case 290:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27639; /* *cond_extendv8hiv8di */

    case 291:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27667; /* *cond_extendv8qiv8di */

    case 292:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27581; /* *cond_extendv16siv16di */

    case 293:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27641; /* *cond_extendv16hiv16di */

    case 294:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27669; /* *cond_extendv16qiv16di */

    case 295:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27583; /* *cond_extendv32siv32di */

    case 296:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27643; /* *cond_extendv32hiv32di */

    case 297:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27671; /* *cond_extendv32qiv32di */

    case 298:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27585; /* *cond_extendv64siv64di */

    case 299:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27645; /* *cond_extendv64hiv64di */

    case 300:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27673; /* *cond_extendv64qiv64di */

    case 301:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27587; /* *cond_extendv128siv128di */

    case 302:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27647; /* *cond_extendv128hiv128di */

    case 303:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27675; /* *cond_extendv128qiv128di */

    case 304:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27589; /* *cond_extendv256siv256di */

    case 305:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27649; /* *cond_extendv256hiv256di */

    case 306:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27677; /* *cond_extendv256qiv256di */

    case 307:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27591; /* *cond_extendv512siv512di */

    case 308:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27651; /* *cond_extendv512hiv512di */

    case 309:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27679; /* *cond_extendv512qiv512di */

    case 310:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27498; /* *cond_zero_extendrvvm4qirvvm8hi */

    case 311:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27500; /* *cond_zero_extendrvvm2qirvvm4hi */

    case 312:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27502; /* *cond_zero_extendrvvm1qirvvm2hi */

    case 313:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27504; /* *cond_zero_extendrvvmf2qirvvm1hi */

    case 314:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27506; /* *cond_zero_extendrvvmf4qirvvmf2hi */

    case 315:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27508; /* *cond_zero_extendrvvmf8qirvvmf4hi */

    case 316:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27510; /* *cond_zero_extendrvvm4hirvvm8si */

    case 317:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27594; /* *cond_zero_extendrvvm2qirvvm8si */

    case 318:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27512; /* *cond_zero_extendrvvm2hirvvm4si */

    case 319:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27596; /* *cond_zero_extendrvvm1qirvvm4si */

    case 320:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27514; /* *cond_zero_extendrvvm1hirvvm2si */

    case 321:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27598; /* *cond_zero_extendrvvmf2qirvvm2si */

    case 322:
      if (!
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27516; /* *cond_zero_extendrvvmf2hirvvm1si */

    case 323:
      if (!
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27600; /* *cond_zero_extendrvvmf4qirvvm1si */

    case 324:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27518; /* *cond_zero_extendrvvmf4hirvvmf2si */

    case 325:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27602; /* *cond_zero_extendrvvmf8qirvvmf2si */

    case 326:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27520; /* *cond_zero_extendrvvm4sirvvm8di */

    case 327:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27604; /* *cond_zero_extendrvvm2hirvvm8di */

    case 328:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27654; /* *cond_zero_extendrvvm1qirvvm8di */

    case 329:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27522; /* *cond_zero_extendrvvm2sirvvm4di */

    case 330:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27606; /* *cond_zero_extendrvvm1hirvvm4di */

    case 331:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27656; /* *cond_zero_extendrvvmf2qirvvm4di */

    case 332:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27524; /* *cond_zero_extendrvvm1sirvvm2di */

    case 333:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27608; /* *cond_zero_extendrvvmf2hirvvm2di */

    case 334:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27658; /* *cond_zero_extendrvvmf4qirvvm2di */

    case 335:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27526; /* *cond_zero_extendrvvmf2sirvvm1di */

    case 336:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27610; /* *cond_zero_extendrvvmf4hirvvm1di */

    case 337:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27660; /* *cond_zero_extendrvvmf8qirvvm1di */

    case 338:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27528; /* *cond_zero_extendv1qiv1hi */

    case 339:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27530; /* *cond_zero_extendv2qiv2hi */

    case 340:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27532; /* *cond_zero_extendv4qiv4hi */

    case 341:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27534; /* *cond_zero_extendv8qiv8hi */

    case 342:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27536; /* *cond_zero_extendv16qiv16hi */

    case 343:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27538; /* *cond_zero_extendv32qiv32hi */

    case 344:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27540; /* *cond_zero_extendv64qiv64hi */

    case 345:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27542; /* *cond_zero_extendv128qiv128hi */

    case 346:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27544; /* *cond_zero_extendv256qiv256hi */

    case 347:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27546; /* *cond_zero_extendv512qiv512hi */

    case 348:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27548; /* *cond_zero_extendv1024qiv1024hi */

    case 349:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27550; /* *cond_zero_extendv2048qiv2048hi */

    case 350:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27552; /* *cond_zero_extendv1hiv1si */

    case 351:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27612; /* *cond_zero_extendv1qiv1si */

    case 352:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27554; /* *cond_zero_extendv2hiv2si */

    case 353:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27614; /* *cond_zero_extendv2qiv2si */

    case 354:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27556; /* *cond_zero_extendv4hiv4si */

    case 355:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27616; /* *cond_zero_extendv4qiv4si */

    case 356:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27558; /* *cond_zero_extendv8hiv8si */

    case 357:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27618; /* *cond_zero_extendv8qiv8si */

    case 358:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27560; /* *cond_zero_extendv16hiv16si */

    case 359:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27620; /* *cond_zero_extendv16qiv16si */

    case 360:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27562; /* *cond_zero_extendv32hiv32si */

    case 361:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27622; /* *cond_zero_extendv32qiv32si */

    case 362:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27564; /* *cond_zero_extendv64hiv64si */

    case 363:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27624; /* *cond_zero_extendv64qiv64si */

    case 364:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27566; /* *cond_zero_extendv128hiv128si */

    case 365:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27626; /* *cond_zero_extendv128qiv128si */

    case 366:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27568; /* *cond_zero_extendv256hiv256si */

    case 367:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27628; /* *cond_zero_extendv256qiv256si */

    case 368:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27570; /* *cond_zero_extendv512hiv512si */

    case 369:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27630; /* *cond_zero_extendv512qiv512si */

    case 370:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27572; /* *cond_zero_extendv1024hiv1024si */

    case 371:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27632; /* *cond_zero_extendv1024qiv1024si */

    case 372:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27574; /* *cond_zero_extendv1siv1di */

    case 373:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27634; /* *cond_zero_extendv1hiv1di */

    case 374:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27662; /* *cond_zero_extendv1qiv1di */

    case 375:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27576; /* *cond_zero_extendv2siv2di */

    case 376:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27636; /* *cond_zero_extendv2hiv2di */

    case 377:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27664; /* *cond_zero_extendv2qiv2di */

    case 378:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27578; /* *cond_zero_extendv4siv4di */

    case 379:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27638; /* *cond_zero_extendv4hiv4di */

    case 380:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27666; /* *cond_zero_extendv4qiv4di */

    case 381:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27580; /* *cond_zero_extendv8siv8di */

    case 382:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27640; /* *cond_zero_extendv8hiv8di */

    case 383:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27668; /* *cond_zero_extendv8qiv8di */

    case 384:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27582; /* *cond_zero_extendv16siv16di */

    case 385:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27642; /* *cond_zero_extendv16hiv16di */

    case 386:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27670; /* *cond_zero_extendv16qiv16di */

    case 387:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27584; /* *cond_zero_extendv32siv32di */

    case 388:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27644; /* *cond_zero_extendv32hiv32di */

    case 389:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27672; /* *cond_zero_extendv32qiv32di */

    case 390:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27586; /* *cond_zero_extendv64siv64di */

    case 391:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27646; /* *cond_zero_extendv64hiv64di */

    case 392:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27674; /* *cond_zero_extendv64qiv64di */

    case 393:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27588; /* *cond_zero_extendv128siv128di */

    case 394:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27648; /* *cond_zero_extendv128hiv128di */

    case 395:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27676; /* *cond_zero_extendv128qiv128di */

    case 396:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27590; /* *cond_zero_extendv256siv256di */

    case 397:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27650; /* *cond_zero_extendv256hiv256di */

    case 398:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27678; /* *cond_zero_extendv256qiv256di */

    case 399:
      if (!(
#line 144 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27592; /* *cond_zero_extendv512siv512di */

    case 400:
      if (!(
#line 164 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27652; /* *cond_zero_extendv512hiv512di */

    case 401:
      if (!(
#line 184 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27680; /* *cond_zero_extendv512qiv512di */

    case 402:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27865; /* *cond_truncrvvm8hirvvm4qi */

    case 403:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27866; /* *cond_truncrvvm4hirvvm2qi */

    case 404:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27867; /* *cond_truncrvvm2hirvvm1qi */

    case 405:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27868; /* *cond_truncrvvm1hirvvmf2qi */

    case 406:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27869; /* *cond_truncrvvmf2hirvvmf4qi */

    case 407:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27870; /* *cond_truncrvvmf4hirvvmf8qi */

    case 408:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27871; /* *cond_truncrvvm8sirvvm4hi */

    case 409:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27872; /* *cond_truncrvvm4sirvvm2hi */

    case 410:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27873; /* *cond_truncrvvm2sirvvm1hi */

    case 411:
      if (!
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27874; /* *cond_truncrvvm1sirvvmf2hi */

    case 412:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27875; /* *cond_truncrvvmf2sirvvmf4hi */

    case 413:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27876; /* *cond_truncrvvm8dirvvm4si */

    case 414:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27877; /* *cond_truncrvvm4dirvvm2si */

    case 415:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27878; /* *cond_truncrvvm2dirvvm1si */

    case 416:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27879; /* *cond_truncrvvm1dirvvmf2si */

    case 417:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27880; /* *cond_truncv1hiv1qi */

    case 418:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27881; /* *cond_truncv2hiv2qi */

    case 419:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27882; /* *cond_truncv4hiv4qi */

    case 420:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27883; /* *cond_truncv8hiv8qi */

    case 421:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27884; /* *cond_truncv16hiv16qi */

    case 422:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27885; /* *cond_truncv32hiv32qi */

    case 423:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27886; /* *cond_truncv64hiv64qi */

    case 424:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27887; /* *cond_truncv128hiv128qi */

    case 425:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27888; /* *cond_truncv256hiv256qi */

    case 426:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27889; /* *cond_truncv512hiv512qi */

    case 427:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27890; /* *cond_truncv1024hiv1024qi */

    case 428:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27891; /* *cond_truncv2048hiv2048qi */

    case 429:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27892; /* *cond_truncv1siv1hi */

    case 430:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27893; /* *cond_truncv2siv2hi */

    case 431:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27894; /* *cond_truncv4siv4hi */

    case 432:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27895; /* *cond_truncv8siv8hi */

    case 433:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27896; /* *cond_truncv16siv16hi */

    case 434:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27897; /* *cond_truncv32siv32hi */

    case 435:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27898; /* *cond_truncv64siv64hi */

    case 436:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27899; /* *cond_truncv128siv128hi */

    case 437:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27900; /* *cond_truncv256siv256hi */

    case 438:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27901; /* *cond_truncv512siv512hi */

    case 439:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27902; /* *cond_truncv1024siv1024hi */

    case 440:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27903; /* *cond_truncv1div1si */

    case 441:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27904; /* *cond_truncv2div2si */

    case 442:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27905; /* *cond_truncv4div4si */

    case 443:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27906; /* *cond_truncv8div8si */

    case 444:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27907; /* *cond_truncv16div16si */

    case 445:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27908; /* *cond_truncv32div32si */

    case 446:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27909; /* *cond_truncv64div64si */

    case 447:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27910; /* *cond_truncv128div128si */

    case 448:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27911; /* *cond_truncv256div256si */

    case 449:
      if (!(
#line 283 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27912; /* *cond_truncv512div512si */

    case 450:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28507; /* *cond_vashrextendtruncrvvm8hi */

    case 451:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28511; /* *cond_vashrextendtruncrvvm4hi */

    case 452:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28515; /* *cond_vashrextendtruncrvvm2hi */

    case 453:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28519; /* *cond_vashrextendtruncrvvm1hi */

    case 454:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28523; /* *cond_vashrextendtruncrvvmf2hi */

    case 455:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28527; /* *cond_vashrextendtruncrvvmf4hi */

    case 456:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28531; /* *cond_vashrextendtruncrvvm8si */

    case 457:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28535; /* *cond_vashrextendtruncrvvm4si */

    case 458:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28539; /* *cond_vashrextendtruncrvvm2si */

    case 459:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28543; /* *cond_vashrextendtruncrvvm1si */

    case 460:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28547; /* *cond_vashrextendtruncrvvmf2si */

    case 461:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28551; /* *cond_vashrextendtruncrvvm8di */

    case 462:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28555; /* *cond_vashrextendtruncrvvm4di */

    case 463:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28559; /* *cond_vashrextendtruncrvvm2di */

    case 464:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28563; /* *cond_vashrextendtruncrvvm1di */

    case 465:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28567; /* *cond_vashrextendtruncv1hi */

    case 466:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28571; /* *cond_vashrextendtruncv2hi */

    case 467:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28575; /* *cond_vashrextendtruncv4hi */

    case 468:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28579; /* *cond_vashrextendtruncv8hi */

    case 469:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28583; /* *cond_vashrextendtruncv16hi */

    case 470:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28587; /* *cond_vashrextendtruncv32hi */

    case 471:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28591; /* *cond_vashrextendtruncv64hi */

    case 472:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28595; /* *cond_vashrextendtruncv128hi */

    case 473:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28599; /* *cond_vashrextendtruncv256hi */

    case 474:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28603; /* *cond_vashrextendtruncv512hi */

    case 475:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28607; /* *cond_vashrextendtruncv1024hi */

    case 476:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28611; /* *cond_vashrextendtruncv2048hi */

    case 477:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28615; /* *cond_vashrextendtruncv1si */

    case 478:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28619; /* *cond_vashrextendtruncv2si */

    case 479:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28623; /* *cond_vashrextendtruncv4si */

    case 480:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28627; /* *cond_vashrextendtruncv8si */

    case 481:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28631; /* *cond_vashrextendtruncv16si */

    case 482:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28635; /* *cond_vashrextendtruncv32si */

    case 483:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28639; /* *cond_vashrextendtruncv64si */

    case 484:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28643; /* *cond_vashrextendtruncv128si */

    case 485:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28647; /* *cond_vashrextendtruncv256si */

    case 486:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28651; /* *cond_vashrextendtruncv512si */

    case 487:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28655; /* *cond_vashrextendtruncv1024si */

    case 488:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28659; /* *cond_vashrextendtruncv1di */

    case 489:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28663; /* *cond_vashrextendtruncv2di */

    case 490:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28667; /* *cond_vashrextendtruncv4di */

    case 491:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28671; /* *cond_vashrextendtruncv8di */

    case 492:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28675; /* *cond_vashrextendtruncv16di */

    case 493:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28679; /* *cond_vashrextendtruncv32di */

    case 494:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28683; /* *cond_vashrextendtruncv64di */

    case 495:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28687; /* *cond_vashrextendtruncv128di */

    case 496:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28691; /* *cond_vashrextendtruncv256di */

    case 497:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28695; /* *cond_vashrextendtruncv512di */

    case 498:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28509; /* *cond_vashrzero_extendtruncrvvm8hi */

    case 499:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28513; /* *cond_vashrzero_extendtruncrvvm4hi */

    case 500:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28517; /* *cond_vashrzero_extendtruncrvvm2hi */

    case 501:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28521; /* *cond_vashrzero_extendtruncrvvm1hi */

    case 502:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28525; /* *cond_vashrzero_extendtruncrvvmf2hi */

    case 503:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28529; /* *cond_vashrzero_extendtruncrvvmf4hi */

    case 504:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28533; /* *cond_vashrzero_extendtruncrvvm8si */

    case 505:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28537; /* *cond_vashrzero_extendtruncrvvm4si */

    case 506:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28541; /* *cond_vashrzero_extendtruncrvvm2si */

    case 507:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28545; /* *cond_vashrzero_extendtruncrvvm1si */

    case 508:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28549; /* *cond_vashrzero_extendtruncrvvmf2si */

    case 509:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28553; /* *cond_vashrzero_extendtruncrvvm8di */

    case 510:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28557; /* *cond_vashrzero_extendtruncrvvm4di */

    case 511:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28561; /* *cond_vashrzero_extendtruncrvvm2di */

    case 512:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28565; /* *cond_vashrzero_extendtruncrvvm1di */

    case 513:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28569; /* *cond_vashrzero_extendtruncv1hi */

    case 514:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28573; /* *cond_vashrzero_extendtruncv2hi */

    case 515:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28577; /* *cond_vashrzero_extendtruncv4hi */

    case 516:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28581; /* *cond_vashrzero_extendtruncv8hi */

    case 517:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28585; /* *cond_vashrzero_extendtruncv16hi */

    case 518:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28589; /* *cond_vashrzero_extendtruncv32hi */

    case 519:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28593; /* *cond_vashrzero_extendtruncv64hi */

    case 520:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28597; /* *cond_vashrzero_extendtruncv128hi */

    case 521:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28601; /* *cond_vashrzero_extendtruncv256hi */

    case 522:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28605; /* *cond_vashrzero_extendtruncv512hi */

    case 523:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28609; /* *cond_vashrzero_extendtruncv1024hi */

    case 524:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28613; /* *cond_vashrzero_extendtruncv2048hi */

    case 525:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28617; /* *cond_vashrzero_extendtruncv1si */

    case 526:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28621; /* *cond_vashrzero_extendtruncv2si */

    case 527:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28625; /* *cond_vashrzero_extendtruncv4si */

    case 528:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28629; /* *cond_vashrzero_extendtruncv8si */

    case 529:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28633; /* *cond_vashrzero_extendtruncv16si */

    case 530:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28637; /* *cond_vashrzero_extendtruncv32si */

    case 531:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28641; /* *cond_vashrzero_extendtruncv64si */

    case 532:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28645; /* *cond_vashrzero_extendtruncv128si */

    case 533:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28649; /* *cond_vashrzero_extendtruncv256si */

    case 534:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28653; /* *cond_vashrzero_extendtruncv512si */

    case 535:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28657; /* *cond_vashrzero_extendtruncv1024si */

    case 536:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28661; /* *cond_vashrzero_extendtruncv1di */

    case 537:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28665; /* *cond_vashrzero_extendtruncv2di */

    case 538:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28669; /* *cond_vashrzero_extendtruncv4di */

    case 539:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28673; /* *cond_vashrzero_extendtruncv8di */

    case 540:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28677; /* *cond_vashrzero_extendtruncv16di */

    case 541:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28681; /* *cond_vashrzero_extendtruncv32di */

    case 542:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28685; /* *cond_vashrzero_extendtruncv64di */

    case 543:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28689; /* *cond_vashrzero_extendtruncv128di */

    case 544:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28693; /* *cond_vashrzero_extendtruncv256di */

    case 545:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28697; /* *cond_vashrzero_extendtruncv512di */

    case 546:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28699; /* *cond_ashrtruncrvvm8hi */

    case 547:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28701; /* *cond_ashrtruncrvvm4hi */

    case 548:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28703; /* *cond_ashrtruncrvvm2hi */

    case 549:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28705; /* *cond_ashrtruncrvvm1hi */

    case 550:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28707; /* *cond_ashrtruncrvvmf2hi */

    case 551:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28709; /* *cond_ashrtruncrvvmf4hi */

    case 552:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28711; /* *cond_ashrtruncrvvm8si */

    case 553:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28713; /* *cond_ashrtruncrvvm4si */

    case 554:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28715; /* *cond_ashrtruncrvvm2si */

    case 555:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28717; /* *cond_ashrtruncrvvm1si */

    case 556:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28719; /* *cond_ashrtruncrvvmf2si */

    case 557:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28721; /* *cond_ashrtruncrvvm8di */

    case 558:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28723; /* *cond_ashrtruncrvvm4di */

    case 559:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28725; /* *cond_ashrtruncrvvm2di */

    case 560:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28727; /* *cond_ashrtruncrvvm1di */

    case 561:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28729; /* *cond_ashrtruncv1hi */

    case 562:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28731; /* *cond_ashrtruncv2hi */

    case 563:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28733; /* *cond_ashrtruncv4hi */

    case 564:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28735; /* *cond_ashrtruncv8hi */

    case 565:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28737; /* *cond_ashrtruncv16hi */

    case 566:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28739; /* *cond_ashrtruncv32hi */

    case 567:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28741; /* *cond_ashrtruncv64hi */

    case 568:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28743; /* *cond_ashrtruncv128hi */

    case 569:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28745; /* *cond_ashrtruncv256hi */

    case 570:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28747; /* *cond_ashrtruncv512hi */

    case 571:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28749; /* *cond_ashrtruncv1024hi */

    case 572:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28751; /* *cond_ashrtruncv2048hi */

    case 573:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28753; /* *cond_ashrtruncv1si */

    case 574:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28755; /* *cond_ashrtruncv2si */

    case 575:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28757; /* *cond_ashrtruncv4si */

    case 576:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28759; /* *cond_ashrtruncv8si */

    case 577:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28761; /* *cond_ashrtruncv16si */

    case 578:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28763; /* *cond_ashrtruncv32si */

    case 579:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28765; /* *cond_ashrtruncv64si */

    case 580:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28767; /* *cond_ashrtruncv128si */

    case 581:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28769; /* *cond_ashrtruncv256si */

    case 582:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28771; /* *cond_ashrtruncv512si */

    case 583:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28773; /* *cond_ashrtruncv1024si */

    case 584:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28775; /* *cond_ashrtruncv1di */

    case 585:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28777; /* *cond_ashrtruncv2di */

    case 586:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28779; /* *cond_ashrtruncv4di */

    case 587:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28781; /* *cond_ashrtruncv8di */

    case 588:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28783; /* *cond_ashrtruncv16di */

    case 589:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28785; /* *cond_ashrtruncv32di */

    case 590:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28787; /* *cond_ashrtruncv64di */

    case 591:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28789; /* *cond_ashrtruncv128di */

    case 592:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28791; /* *cond_ashrtruncv256di */

    case 593:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28793; /* *cond_ashrtruncv512di */

    case 594:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28508; /* *cond_vlshrextendtruncrvvm8hi */

    case 595:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28512; /* *cond_vlshrextendtruncrvvm4hi */

    case 596:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28516; /* *cond_vlshrextendtruncrvvm2hi */

    case 597:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28520; /* *cond_vlshrextendtruncrvvm1hi */

    case 598:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28524; /* *cond_vlshrextendtruncrvvmf2hi */

    case 599:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28528; /* *cond_vlshrextendtruncrvvmf4hi */

    case 600:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28532; /* *cond_vlshrextendtruncrvvm8si */

    case 601:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28536; /* *cond_vlshrextendtruncrvvm4si */

    case 602:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28540; /* *cond_vlshrextendtruncrvvm2si */

    case 603:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28544; /* *cond_vlshrextendtruncrvvm1si */

    case 604:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28548; /* *cond_vlshrextendtruncrvvmf2si */

    case 605:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28552; /* *cond_vlshrextendtruncrvvm8di */

    case 606:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28556; /* *cond_vlshrextendtruncrvvm4di */

    case 607:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28560; /* *cond_vlshrextendtruncrvvm2di */

    case 608:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28564; /* *cond_vlshrextendtruncrvvm1di */

    case 609:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28568; /* *cond_vlshrextendtruncv1hi */

    case 610:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28572; /* *cond_vlshrextendtruncv2hi */

    case 611:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28576; /* *cond_vlshrextendtruncv4hi */

    case 612:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28580; /* *cond_vlshrextendtruncv8hi */

    case 613:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28584; /* *cond_vlshrextendtruncv16hi */

    case 614:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28588; /* *cond_vlshrextendtruncv32hi */

    case 615:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28592; /* *cond_vlshrextendtruncv64hi */

    case 616:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28596; /* *cond_vlshrextendtruncv128hi */

    case 617:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28600; /* *cond_vlshrextendtruncv256hi */

    case 618:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28604; /* *cond_vlshrextendtruncv512hi */

    case 619:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28608; /* *cond_vlshrextendtruncv1024hi */

    case 620:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28612; /* *cond_vlshrextendtruncv2048hi */

    case 621:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28616; /* *cond_vlshrextendtruncv1si */

    case 622:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28620; /* *cond_vlshrextendtruncv2si */

    case 623:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28624; /* *cond_vlshrextendtruncv4si */

    case 624:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28628; /* *cond_vlshrextendtruncv8si */

    case 625:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28632; /* *cond_vlshrextendtruncv16si */

    case 626:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28636; /* *cond_vlshrextendtruncv32si */

    case 627:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28640; /* *cond_vlshrextendtruncv64si */

    case 628:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28644; /* *cond_vlshrextendtruncv128si */

    case 629:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28648; /* *cond_vlshrextendtruncv256si */

    case 630:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28652; /* *cond_vlshrextendtruncv512si */

    case 631:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28656; /* *cond_vlshrextendtruncv1024si */

    case 632:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28660; /* *cond_vlshrextendtruncv1di */

    case 633:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28664; /* *cond_vlshrextendtruncv2di */

    case 634:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28668; /* *cond_vlshrextendtruncv4di */

    case 635:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28672; /* *cond_vlshrextendtruncv8di */

    case 636:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28676; /* *cond_vlshrextendtruncv16di */

    case 637:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28680; /* *cond_vlshrextendtruncv32di */

    case 638:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28684; /* *cond_vlshrextendtruncv64di */

    case 639:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28688; /* *cond_vlshrextendtruncv128di */

    case 640:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28692; /* *cond_vlshrextendtruncv256di */

    case 641:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28696; /* *cond_vlshrextendtruncv512di */

    case 642:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28510; /* *cond_vlshrzero_extendtruncrvvm8hi */

    case 643:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28514; /* *cond_vlshrzero_extendtruncrvvm4hi */

    case 644:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28518; /* *cond_vlshrzero_extendtruncrvvm2hi */

    case 645:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28522; /* *cond_vlshrzero_extendtruncrvvm1hi */

    case 646:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28526; /* *cond_vlshrzero_extendtruncrvvmf2hi */

    case 647:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28530; /* *cond_vlshrzero_extendtruncrvvmf4hi */

    case 648:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28534; /* *cond_vlshrzero_extendtruncrvvm8si */

    case 649:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28538; /* *cond_vlshrzero_extendtruncrvvm4si */

    case 650:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28542; /* *cond_vlshrzero_extendtruncrvvm2si */

    case 651:
      if (!
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28546; /* *cond_vlshrzero_extendtruncrvvm1si */

    case 652:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28550; /* *cond_vlshrzero_extendtruncrvvmf2si */

    case 653:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28554; /* *cond_vlshrzero_extendtruncrvvm8di */

    case 654:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28558; /* *cond_vlshrzero_extendtruncrvvm4di */

    case 655:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28562; /* *cond_vlshrzero_extendtruncrvvm2di */

    case 656:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28566; /* *cond_vlshrzero_extendtruncrvvm1di */

    case 657:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28570; /* *cond_vlshrzero_extendtruncv1hi */

    case 658:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28574; /* *cond_vlshrzero_extendtruncv2hi */

    case 659:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28578; /* *cond_vlshrzero_extendtruncv4hi */

    case 660:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28582; /* *cond_vlshrzero_extendtruncv8hi */

    case 661:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28586; /* *cond_vlshrzero_extendtruncv16hi */

    case 662:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28590; /* *cond_vlshrzero_extendtruncv32hi */

    case 663:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28594; /* *cond_vlshrzero_extendtruncv64hi */

    case 664:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28598; /* *cond_vlshrzero_extendtruncv128hi */

    case 665:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28602; /* *cond_vlshrzero_extendtruncv256hi */

    case 666:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28606; /* *cond_vlshrzero_extendtruncv512hi */

    case 667:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28610; /* *cond_vlshrzero_extendtruncv1024hi */

    case 668:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28614; /* *cond_vlshrzero_extendtruncv2048hi */

    case 669:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28618; /* *cond_vlshrzero_extendtruncv1si */

    case 670:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28622; /* *cond_vlshrzero_extendtruncv2si */

    case 671:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28626; /* *cond_vlshrzero_extendtruncv4si */

    case 672:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28630; /* *cond_vlshrzero_extendtruncv8si */

    case 673:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28634; /* *cond_vlshrzero_extendtruncv16si */

    case 674:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28638; /* *cond_vlshrzero_extendtruncv32si */

    case 675:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28642; /* *cond_vlshrzero_extendtruncv64si */

    case 676:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28646; /* *cond_vlshrzero_extendtruncv128si */

    case 677:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28650; /* *cond_vlshrzero_extendtruncv256si */

    case 678:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28654; /* *cond_vlshrzero_extendtruncv512si */

    case 679:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28658; /* *cond_vlshrzero_extendtruncv1024si */

    case 680:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28662; /* *cond_vlshrzero_extendtruncv1di */

    case 681:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28666; /* *cond_vlshrzero_extendtruncv2di */

    case 682:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28670; /* *cond_vlshrzero_extendtruncv4di */

    case 683:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28674; /* *cond_vlshrzero_extendtruncv8di */

    case 684:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28678; /* *cond_vlshrzero_extendtruncv16di */

    case 685:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28682; /* *cond_vlshrzero_extendtruncv32di */

    case 686:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28686; /* *cond_vlshrzero_extendtruncv64di */

    case 687:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28690; /* *cond_vlshrzero_extendtruncv128di */

    case 688:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28694; /* *cond_vlshrzero_extendtruncv256di */

    case 689:
      if (!(
#line 500 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28698; /* *cond_vlshrzero_extendtruncv512di */

    case 690:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28700; /* *cond_lshrtruncrvvm8hi */

    case 691:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28702; /* *cond_lshrtruncrvvm4hi */

    case 692:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28704; /* *cond_lshrtruncrvvm2hi */

    case 693:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28706; /* *cond_lshrtruncrvvm1hi */

    case 694:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28708; /* *cond_lshrtruncrvvmf2hi */

    case 695:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28710; /* *cond_lshrtruncrvvmf4hi */

    case 696:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28712; /* *cond_lshrtruncrvvm8si */

    case 697:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28714; /* *cond_lshrtruncrvvm4si */

    case 698:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28716; /* *cond_lshrtruncrvvm2si */

    case 699:
      if (!
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28718; /* *cond_lshrtruncrvvm1si */

    case 700:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28720; /* *cond_lshrtruncrvvmf2si */

    case 701:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28722; /* *cond_lshrtruncrvvm8di */

    case 702:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28724; /* *cond_lshrtruncrvvm4di */

    case 703:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28726; /* *cond_lshrtruncrvvm2di */

    case 704:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28728; /* *cond_lshrtruncrvvm1di */

    case 705:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28730; /* *cond_lshrtruncv1hi */

    case 706:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28732; /* *cond_lshrtruncv2hi */

    case 707:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28734; /* *cond_lshrtruncv4hi */

    case 708:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28736; /* *cond_lshrtruncv8hi */

    case 709:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28738; /* *cond_lshrtruncv16hi */

    case 710:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28740; /* *cond_lshrtruncv32hi */

    case 711:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28742; /* *cond_lshrtruncv64hi */

    case 712:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28744; /* *cond_lshrtruncv128hi */

    case 713:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28746; /* *cond_lshrtruncv256hi */

    case 714:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28748; /* *cond_lshrtruncv512hi */

    case 715:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28750; /* *cond_lshrtruncv1024hi */

    case 716:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28752; /* *cond_lshrtruncv2048hi */

    case 717:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28754; /* *cond_lshrtruncv1si */

    case 718:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28756; /* *cond_lshrtruncv2si */

    case 719:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28758; /* *cond_lshrtruncv4si */

    case 720:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28760; /* *cond_lshrtruncv8si */

    case 721:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28762; /* *cond_lshrtruncv16si */

    case 722:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28764; /* *cond_lshrtruncv32si */

    case 723:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28766; /* *cond_lshrtruncv64si */

    case 724:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28768; /* *cond_lshrtruncv128si */

    case 725:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28770; /* *cond_lshrtruncv256si */

    case 726:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28772; /* *cond_lshrtruncv512si */

    case 727:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28774; /* *cond_lshrtruncv1024si */

    case 728:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28776; /* *cond_lshrtruncv1di */

    case 729:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28778; /* *cond_lshrtruncv2di */

    case 730:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28780; /* *cond_lshrtruncv4di */

    case 731:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28782; /* *cond_lshrtruncv8di */

    case 732:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28784; /* *cond_lshrtruncv16di */

    case 733:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28786; /* *cond_lshrtruncv32di */

    case 734:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28788; /* *cond_lshrtruncv64di */

    case 735:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28790; /* *cond_lshrtruncv128di */

    case 736:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28792; /* *cond_lshrtruncv256di */

    case 737:
      if (!(
#line 522 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28794; /* *cond_lshrtruncv512di */

    case 738:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27913; /* *cond_extendrvvm4hfrvvm8sf */

    case 739:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27914; /* *cond_extendrvvm2hfrvvm4sf */

    case 740:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27915; /* *cond_extendrvvm1hfrvvm2sf */

    case 741:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27916; /* *cond_extendrvvmf2hfrvvm1sf */

    case 742:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27917; /* *cond_extendrvvmf4hfrvvmf2sf */

    case 743:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27918; /* *cond_extendrvvm4sfrvvm8df */

    case 744:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27919; /* *cond_extendrvvm2sfrvvm4df */

    case 745:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27920; /* *cond_extendrvvm1sfrvvm2df */

    case 746:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27921; /* *cond_extendrvvmf2sfrvvm1df */

    case 747:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27922; /* *cond_extendv1hfv1sf */

    case 748:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27923; /* *cond_extendv2hfv2sf */

    case 749:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27924; /* *cond_extendv4hfv4sf */

    case 750:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27925; /* *cond_extendv8hfv8sf */

    case 751:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27926; /* *cond_extendv16hfv16sf */

    case 752:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27927; /* *cond_extendv32hfv32sf */

    case 753:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27928; /* *cond_extendv64hfv64sf */

    case 754:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27929; /* *cond_extendv128hfv128sf */

    case 755:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27930; /* *cond_extendv256hfv256sf */

    case 756:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27931; /* *cond_extendv512hfv512sf */

    case 757:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27932; /* *cond_extendv1024hfv1024sf */

    case 758:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27933; /* *cond_extendv1sfv1df */

    case 759:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27934; /* *cond_extendv2sfv2df */

    case 760:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27935; /* *cond_extendv4sfv4df */

    case 761:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27936; /* *cond_extendv8sfv8df */

    case 762:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27937; /* *cond_extendv16sfv16df */

    case 763:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27938; /* *cond_extendv32sfv32df */

    case 764:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27939; /* *cond_extendv64sfv64df */

    case 765:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27940; /* *cond_extendv128sfv128df */

    case 766:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27941; /* *cond_extendv256sfv256df */

    case 767:
      if (!(
#line 303 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27942; /* *cond_extendv512sfv512df */

    case 768:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27973; /* *cond_truncrvvm8sfrvvm4hf */

    case 769:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27974; /* *cond_truncrvvm4sfrvvm2hf */

    case 770:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27975; /* *cond_truncrvvm2sfrvvm1hf */

    case 771:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27976; /* *cond_truncrvvm1sfrvvmf2hf */

    case 772:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27977; /* *cond_truncrvvmf2sfrvvmf4hf */

    case 773:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27978; /* *cond_truncrvvm8dfrvvm4sf */

    case 774:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27979; /* *cond_truncrvvm4dfrvvm2sf */

    case 775:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27980; /* *cond_truncrvvm2dfrvvm1sf */

    case 776:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27981; /* *cond_truncrvvm1dfrvvmf2sf */

    case 777:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27982; /* *cond_truncv1sfv1hf */

    case 778:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27983; /* *cond_truncv2sfv2hf */

    case 779:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27984; /* *cond_truncv4sfv4hf */

    case 780:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27985; /* *cond_truncv8sfv8hf */

    case 781:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27986; /* *cond_truncv16sfv16hf */

    case 782:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27987; /* *cond_truncv32sfv32hf */

    case 783:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27988; /* *cond_truncv64sfv64hf */

    case 784:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27989; /* *cond_truncv128sfv128hf */

    case 785:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27990; /* *cond_truncv256sfv256hf */

    case 786:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27991; /* *cond_truncv512sfv512hf */

    case 787:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27992; /* *cond_truncv1024sfv1024hf */

    case 788:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27993; /* *cond_truncv1dfv1sf */

    case 789:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27994; /* *cond_truncv2dfv2sf */

    case 790:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27995; /* *cond_truncv4dfv4sf */

    case 791:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27996; /* *cond_truncv8dfv8sf */

    case 792:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27997; /* *cond_truncv16dfv16sf */

    case 793:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27998; /* *cond_truncv32dfv32sf */

    case 794:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27999; /* *cond_truncv64dfv64sf */

    case 795:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28000; /* *cond_truncv128dfv128sf */

    case 796:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28001; /* *cond_truncv256dfv256sf */

    case 797:
      if (!(
#line 350 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28002; /* *cond_truncv512dfv512sf */

    case 798:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28003; /* *cond_fix_truncrvvm8hfrvvm8hi */

    case 799:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28005; /* *cond_fix_truncrvvm4hfrvvm4hi */

    case 800:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28363; /* *cond_fix_truncrvvm8sfrvvm4hi */

    case 801:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28007; /* *cond_fix_truncrvvm2hfrvvm2hi */

    case 802:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28365; /* *cond_fix_truncrvvm4sfrvvm2hi */

    case 803:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28009; /* *cond_fix_truncrvvm1hfrvvm1hi */

    case 804:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28367; /* *cond_fix_truncrvvm2sfrvvm1hi */

    case 805:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28011; /* *cond_fix_truncrvvmf2hfrvvmf2hi */

    case 806:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28369; /* *cond_fix_truncrvvm1sfrvvmf2hi */

    case 807:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28013; /* *cond_fix_truncrvvmf4hfrvvmf4hi */

    case 808:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28371; /* *cond_fix_truncrvvmf2sfrvvmf4hi */

    case 809:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28015; /* *cond_fix_truncrvvm8sfrvvm8si */

    case 810:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28195; /* *cond_fix_truncrvvm4hfrvvm8si */

    case 811:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28017; /* *cond_fix_truncrvvm4sfrvvm4si */

    case 812:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28197; /* *cond_fix_truncrvvm2hfrvvm4si */

    case 813:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28373; /* *cond_fix_truncrvvm8dfrvvm4si */

    case 814:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28019; /* *cond_fix_truncrvvm2sfrvvm2si */

    case 815:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28199; /* *cond_fix_truncrvvm1hfrvvm2si */

    case 816:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28375; /* *cond_fix_truncrvvm4dfrvvm2si */

    case 817:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28021; /* *cond_fix_truncrvvm1sfrvvm1si */

    case 818:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28201; /* *cond_fix_truncrvvmf2hfrvvm1si */

    case 819:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28377; /* *cond_fix_truncrvvm2dfrvvm1si */

    case 820:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28023; /* *cond_fix_truncrvvmf2sfrvvmf2si */

    case 821:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28203; /* *cond_fix_truncrvvmf4hfrvvmf2si */

    case 822:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28379; /* *cond_fix_truncrvvm1dfrvvmf2si */

    case 823:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28025; /* *cond_fix_truncrvvm8dfrvvm8di */

    case 824:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28205; /* *cond_fix_truncrvvm4sfrvvm8di */

    case 825:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28027; /* *cond_fix_truncrvvm4dfrvvm4di */

    case 826:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28207; /* *cond_fix_truncrvvm2sfrvvm4di */

    case 827:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28029; /* *cond_fix_truncrvvm2dfrvvm2di */

    case 828:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28209; /* *cond_fix_truncrvvm1sfrvvm2di */

    case 829:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28031; /* *cond_fix_truncrvvm1dfrvvm1di */

    case 830:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28211; /* *cond_fix_truncrvvmf2sfrvvm1di */

    case 831:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28033; /* *cond_fix_truncv1hfv1hi */

    case 832:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28405; /* *cond_fix_truncv1sfv1hi */

    case 833:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28035; /* *cond_fix_truncv2hfv2hi */

    case 834:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28407; /* *cond_fix_truncv2sfv2hi */

    case 835:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28037; /* *cond_fix_truncv4hfv4hi */

    case 836:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28409; /* *cond_fix_truncv4sfv4hi */

    case 837:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28039; /* *cond_fix_truncv8hfv8hi */

    case 838:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28411; /* *cond_fix_truncv8sfv8hi */

    case 839:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28041; /* *cond_fix_truncv16hfv16hi */

    case 840:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28413; /* *cond_fix_truncv16sfv16hi */

    case 841:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28043; /* *cond_fix_truncv32hfv32hi */

    case 842:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28415; /* *cond_fix_truncv32sfv32hi */

    case 843:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28045; /* *cond_fix_truncv64hfv64hi */

    case 844:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28417; /* *cond_fix_truncv64sfv64hi */

    case 845:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28047; /* *cond_fix_truncv128hfv128hi */

    case 846:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28419; /* *cond_fix_truncv128sfv128hi */

    case 847:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28049; /* *cond_fix_truncv256hfv256hi */

    case 848:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28421; /* *cond_fix_truncv256sfv256hi */

    case 849:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28051; /* *cond_fix_truncv512hfv512hi */

    case 850:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28423; /* *cond_fix_truncv512sfv512hi */

    case 851:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28053; /* *cond_fix_truncv1024hfv1024hi */

    case 852:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28425; /* *cond_fix_truncv1024sfv1024hi */

    case 853:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28055; /* *cond_fix_truncv2048hfv2048hi */

    case 854:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28057; /* *cond_fix_truncv1sfv1si */

    case 855:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28213; /* *cond_fix_truncv1hfv1si */

    case 856:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28427; /* *cond_fix_truncv1dfv1si */

    case 857:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28059; /* *cond_fix_truncv2sfv2si */

    case 858:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28215; /* *cond_fix_truncv2hfv2si */

    case 859:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28429; /* *cond_fix_truncv2dfv2si */

    case 860:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28061; /* *cond_fix_truncv4sfv4si */

    case 861:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28217; /* *cond_fix_truncv4hfv4si */

    case 862:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28431; /* *cond_fix_truncv4dfv4si */

    case 863:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28063; /* *cond_fix_truncv8sfv8si */

    case 864:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28219; /* *cond_fix_truncv8hfv8si */

    case 865:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28433; /* *cond_fix_truncv8dfv8si */

    case 866:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28065; /* *cond_fix_truncv16sfv16si */

    case 867:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28221; /* *cond_fix_truncv16hfv16si */

    case 868:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28435; /* *cond_fix_truncv16dfv16si */

    case 869:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28067; /* *cond_fix_truncv32sfv32si */

    case 870:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28223; /* *cond_fix_truncv32hfv32si */

    case 871:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28437; /* *cond_fix_truncv32dfv32si */

    case 872:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28069; /* *cond_fix_truncv64sfv64si */

    case 873:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28225; /* *cond_fix_truncv64hfv64si */

    case 874:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28439; /* *cond_fix_truncv64dfv64si */

    case 875:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28071; /* *cond_fix_truncv128sfv128si */

    case 876:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28227; /* *cond_fix_truncv128hfv128si */

    case 877:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28441; /* *cond_fix_truncv128dfv128si */

    case 878:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28073; /* *cond_fix_truncv256sfv256si */

    case 879:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28229; /* *cond_fix_truncv256hfv256si */

    case 880:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28443; /* *cond_fix_truncv256dfv256si */

    case 881:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28075; /* *cond_fix_truncv512sfv512si */

    case 882:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28231; /* *cond_fix_truncv512hfv512si */

    case 883:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28445; /* *cond_fix_truncv512dfv512si */

    case 884:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28077; /* *cond_fix_truncv1024sfv1024si */

    case 885:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28233; /* *cond_fix_truncv1024hfv1024si */

    case 886:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28079; /* *cond_fix_truncv1dfv1di */

    case 887:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28235; /* *cond_fix_truncv1sfv1di */

    case 888:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28081; /* *cond_fix_truncv2dfv2di */

    case 889:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28237; /* *cond_fix_truncv2sfv2di */

    case 890:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28083; /* *cond_fix_truncv4dfv4di */

    case 891:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28239; /* *cond_fix_truncv4sfv4di */

    case 892:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28085; /* *cond_fix_truncv8dfv8di */

    case 893:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28241; /* *cond_fix_truncv8sfv8di */

    case 894:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28087; /* *cond_fix_truncv16dfv16di */

    case 895:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28243; /* *cond_fix_truncv16sfv16di */

    case 896:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28089; /* *cond_fix_truncv32dfv32di */

    case 897:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28245; /* *cond_fix_truncv32sfv32di */

    case 898:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28091; /* *cond_fix_truncv64dfv64di */

    case 899:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28247; /* *cond_fix_truncv64sfv64di */

    case 900:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28093; /* *cond_fix_truncv128dfv128di */

    case 901:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28249; /* *cond_fix_truncv128sfv128di */

    case 902:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28095; /* *cond_fix_truncv256dfv256di */

    case 903:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28251; /* *cond_fix_truncv256sfv256di */

    case 904:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28097; /* *cond_fix_truncv512dfv512di */

    case 905:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28253; /* *cond_fix_truncv512sfv512di */

    case 906:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28351; /* *cond_fix_truncrvvm8hfrvvm4qi */

    case 907:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28353; /* *cond_fix_truncrvvm4hfrvvm2qi */

    case 908:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28355; /* *cond_fix_truncrvvm2hfrvvm1qi */

    case 909:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28357; /* *cond_fix_truncrvvm1hfrvvmf2qi */

    case 910:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28359; /* *cond_fix_truncrvvmf2hfrvvmf4qi */

    case 911:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28361; /* *cond_fix_truncrvvmf4hfrvvmf8qi */

    case 912:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28381; /* *cond_fix_truncv1hfv1qi */

    case 913:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28383; /* *cond_fix_truncv2hfv2qi */

    case 914:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28385; /* *cond_fix_truncv4hfv4qi */

    case 915:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28387; /* *cond_fix_truncv8hfv8qi */

    case 916:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28389; /* *cond_fix_truncv16hfv16qi */

    case 917:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28391; /* *cond_fix_truncv32hfv32qi */

    case 918:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28393; /* *cond_fix_truncv64hfv64qi */

    case 919:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28395; /* *cond_fix_truncv128hfv128qi */

    case 920:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28397; /* *cond_fix_truncv256hfv256qi */

    case 921:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28399; /* *cond_fix_truncv512hfv512qi */

    case 922:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28401; /* *cond_fix_truncv1024hfv1024qi */

    case 923:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28403; /* *cond_fix_truncv2048hfv2048qi */

    case 924:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28004; /* *cond_fixuns_truncrvvm8hfrvvm8hi */

    case 925:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28006; /* *cond_fixuns_truncrvvm4hfrvvm4hi */

    case 926:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28364; /* *cond_fixuns_truncrvvm8sfrvvm4hi */

    case 927:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28008; /* *cond_fixuns_truncrvvm2hfrvvm2hi */

    case 928:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28366; /* *cond_fixuns_truncrvvm4sfrvvm2hi */

    case 929:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28010; /* *cond_fixuns_truncrvvm1hfrvvm1hi */

    case 930:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28368; /* *cond_fixuns_truncrvvm2sfrvvm1hi */

    case 931:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28012; /* *cond_fixuns_truncrvvmf2hfrvvmf2hi */

    case 932:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28370; /* *cond_fixuns_truncrvvm1sfrvvmf2hi */

    case 933:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28014; /* *cond_fixuns_truncrvvmf4hfrvvmf4hi */

    case 934:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28372; /* *cond_fixuns_truncrvvmf2sfrvvmf4hi */

    case 935:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28016; /* *cond_fixuns_truncrvvm8sfrvvm8si */

    case 936:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28196; /* *cond_fixuns_truncrvvm4hfrvvm8si */

    case 937:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28018; /* *cond_fixuns_truncrvvm4sfrvvm4si */

    case 938:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28198; /* *cond_fixuns_truncrvvm2hfrvvm4si */

    case 939:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28374; /* *cond_fixuns_truncrvvm8dfrvvm4si */

    case 940:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28020; /* *cond_fixuns_truncrvvm2sfrvvm2si */

    case 941:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28200; /* *cond_fixuns_truncrvvm1hfrvvm2si */

    case 942:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28376; /* *cond_fixuns_truncrvvm4dfrvvm2si */

    case 943:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28022; /* *cond_fixuns_truncrvvm1sfrvvm1si */

    case 944:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28202; /* *cond_fixuns_truncrvvmf2hfrvvm1si */

    case 945:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28378; /* *cond_fixuns_truncrvvm2dfrvvm1si */

    case 946:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28024; /* *cond_fixuns_truncrvvmf2sfrvvmf2si */

    case 947:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28204; /* *cond_fixuns_truncrvvmf4hfrvvmf2si */

    case 948:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28380; /* *cond_fixuns_truncrvvm1dfrvvmf2si */

    case 949:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28026; /* *cond_fixuns_truncrvvm8dfrvvm8di */

    case 950:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28206; /* *cond_fixuns_truncrvvm4sfrvvm8di */

    case 951:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28028; /* *cond_fixuns_truncrvvm4dfrvvm4di */

    case 952:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28208; /* *cond_fixuns_truncrvvm2sfrvvm4di */

    case 953:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28030; /* *cond_fixuns_truncrvvm2dfrvvm2di */

    case 954:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28210; /* *cond_fixuns_truncrvvm1sfrvvm2di */

    case 955:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28032; /* *cond_fixuns_truncrvvm1dfrvvm1di */

    case 956:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28212; /* *cond_fixuns_truncrvvmf2sfrvvm1di */

    case 957:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28034; /* *cond_fixuns_truncv1hfv1hi */

    case 958:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28406; /* *cond_fixuns_truncv1sfv1hi */

    case 959:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28036; /* *cond_fixuns_truncv2hfv2hi */

    case 960:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28408; /* *cond_fixuns_truncv2sfv2hi */

    case 961:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28038; /* *cond_fixuns_truncv4hfv4hi */

    case 962:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28410; /* *cond_fixuns_truncv4sfv4hi */

    case 963:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28040; /* *cond_fixuns_truncv8hfv8hi */

    case 964:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28412; /* *cond_fixuns_truncv8sfv8hi */

    case 965:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28042; /* *cond_fixuns_truncv16hfv16hi */

    case 966:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28414; /* *cond_fixuns_truncv16sfv16hi */

    case 967:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28044; /* *cond_fixuns_truncv32hfv32hi */

    case 968:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28416; /* *cond_fixuns_truncv32sfv32hi */

    case 969:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28046; /* *cond_fixuns_truncv64hfv64hi */

    case 970:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28418; /* *cond_fixuns_truncv64sfv64hi */

    case 971:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28048; /* *cond_fixuns_truncv128hfv128hi */

    case 972:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28420; /* *cond_fixuns_truncv128sfv128hi */

    case 973:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28050; /* *cond_fixuns_truncv256hfv256hi */

    case 974:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28422; /* *cond_fixuns_truncv256sfv256hi */

    case 975:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28052; /* *cond_fixuns_truncv512hfv512hi */

    case 976:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28424; /* *cond_fixuns_truncv512sfv512hi */

    case 977:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28054; /* *cond_fixuns_truncv1024hfv1024hi */

    case 978:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28426; /* *cond_fixuns_truncv1024sfv1024hi */

    case 979:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28056; /* *cond_fixuns_truncv2048hfv2048hi */

    case 980:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28058; /* *cond_fixuns_truncv1sfv1si */

    case 981:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28214; /* *cond_fixuns_truncv1hfv1si */

    case 982:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28428; /* *cond_fixuns_truncv1dfv1si */

    case 983:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28060; /* *cond_fixuns_truncv2sfv2si */

    case 984:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28216; /* *cond_fixuns_truncv2hfv2si */

    case 985:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28430; /* *cond_fixuns_truncv2dfv2si */

    case 986:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28062; /* *cond_fixuns_truncv4sfv4si */

    case 987:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28218; /* *cond_fixuns_truncv4hfv4si */

    case 988:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28432; /* *cond_fixuns_truncv4dfv4si */

    case 989:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28064; /* *cond_fixuns_truncv8sfv8si */

    case 990:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28220; /* *cond_fixuns_truncv8hfv8si */

    case 991:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28434; /* *cond_fixuns_truncv8dfv8si */

    case 992:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28066; /* *cond_fixuns_truncv16sfv16si */

    case 993:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28222; /* *cond_fixuns_truncv16hfv16si */

    case 994:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28436; /* *cond_fixuns_truncv16dfv16si */

    case 995:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28068; /* *cond_fixuns_truncv32sfv32si */

    case 996:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28224; /* *cond_fixuns_truncv32hfv32si */

    case 997:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28438; /* *cond_fixuns_truncv32dfv32si */

    case 998:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28070; /* *cond_fixuns_truncv64sfv64si */

    case 999:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28226; /* *cond_fixuns_truncv64hfv64si */

    case 1000:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28440; /* *cond_fixuns_truncv64dfv64si */

    case 1001:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28072; /* *cond_fixuns_truncv128sfv128si */

    case 1002:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28228; /* *cond_fixuns_truncv128hfv128si */

    case 1003:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28442; /* *cond_fixuns_truncv128dfv128si */

    case 1004:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28074; /* *cond_fixuns_truncv256sfv256si */

    case 1005:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28230; /* *cond_fixuns_truncv256hfv256si */

    case 1006:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28444; /* *cond_fixuns_truncv256dfv256si */

    case 1007:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28076; /* *cond_fixuns_truncv512sfv512si */

    case 1008:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28232; /* *cond_fixuns_truncv512hfv512si */

    case 1009:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28446; /* *cond_fixuns_truncv512dfv512si */

    case 1010:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28078; /* *cond_fixuns_truncv1024sfv1024si */

    case 1011:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28234; /* *cond_fixuns_truncv1024hfv1024si */

    case 1012:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28080; /* *cond_fixuns_truncv1dfv1di */

    case 1013:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28236; /* *cond_fixuns_truncv1sfv1di */

    case 1014:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28082; /* *cond_fixuns_truncv2dfv2di */

    case 1015:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28238; /* *cond_fixuns_truncv2sfv2di */

    case 1016:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28084; /* *cond_fixuns_truncv4dfv4di */

    case 1017:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28240; /* *cond_fixuns_truncv4sfv4di */

    case 1018:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28086; /* *cond_fixuns_truncv8dfv8di */

    case 1019:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28242; /* *cond_fixuns_truncv8sfv8di */

    case 1020:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28088; /* *cond_fixuns_truncv16dfv16di */

    case 1021:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28244; /* *cond_fixuns_truncv16sfv16di */

    case 1022:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28090; /* *cond_fixuns_truncv32dfv32di */

    case 1023:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28246; /* *cond_fixuns_truncv32sfv32di */

    case 1024:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28092; /* *cond_fixuns_truncv64dfv64di */

    case 1025:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28248; /* *cond_fixuns_truncv64sfv64di */

    case 1026:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28094; /* *cond_fixuns_truncv128dfv128di */

    case 1027:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28250; /* *cond_fixuns_truncv128sfv128di */

    case 1028:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28096; /* *cond_fixuns_truncv256dfv256di */

    case 1029:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28252; /* *cond_fixuns_truncv256sfv256di */

    case 1030:
      if (!(
#line 371 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28098; /* *cond_fixuns_truncv512dfv512di */

    case 1031:
      if (!(
#line 413 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28254; /* *cond_fixuns_truncv512sfv512di */

    case 1032:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28352; /* *cond_fixuns_truncrvvm8hfrvvm4qi */

    case 1033:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28354; /* *cond_fixuns_truncrvvm4hfrvvm2qi */

    case 1034:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28356; /* *cond_fixuns_truncrvvm2hfrvvm1qi */

    case 1035:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28358; /* *cond_fixuns_truncrvvm1hfrvvmf2qi */

    case 1036:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28360; /* *cond_fixuns_truncrvvmf2hfrvvmf4qi */

    case 1037:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28362; /* *cond_fixuns_truncrvvmf4hfrvvmf8qi */

    case 1038:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28382; /* *cond_fixuns_truncv1hfv1qi */

    case 1039:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28384; /* *cond_fixuns_truncv2hfv2qi */

    case 1040:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28386; /* *cond_fixuns_truncv4hfv4qi */

    case 1041:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28388; /* *cond_fixuns_truncv8hfv8qi */

    case 1042:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28390; /* *cond_fixuns_truncv16hfv16qi */

    case 1043:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28392; /* *cond_fixuns_truncv32hfv32qi */

    case 1044:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28394; /* *cond_fixuns_truncv64hfv64qi */

    case 1045:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28396; /* *cond_fixuns_truncv128hfv128qi */

    case 1046:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28398; /* *cond_fixuns_truncv256hfv256qi */

    case 1047:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28400; /* *cond_fixuns_truncv512hfv512qi */

    case 1048:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28402; /* *cond_fixuns_truncv1024hfv1024qi */

    case 1049:
      if (!(
#line 455 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28404; /* *cond_fixuns_truncv2048hfv2048qi */

    case 1050:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28099; /* *cond_floatrvvm8hirvvm8hf */

    case 1051:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28255; /* *cond_floatrvvm4qirvvm8hf */

    case 1052:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28101; /* *cond_floatrvvm4hirvvm4hf */

    case 1053:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28257; /* *cond_floatrvvm2qirvvm4hf */

    case 1054:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28447; /* *cond_floatrvvm8sirvvm4hf2 */

    case 1055:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28103; /* *cond_floatrvvm2hirvvm2hf */

    case 1056:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28259; /* *cond_floatrvvm1qirvvm2hf */

    case 1057:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28449; /* *cond_floatrvvm4sirvvm2hf2 */

    case 1058:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28105; /* *cond_floatrvvm1hirvvm1hf */

    case 1059:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28261; /* *cond_floatrvvmf2qirvvm1hf */

    case 1060:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28451; /* *cond_floatrvvm2sirvvm1hf2 */

    case 1061:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28107; /* *cond_floatrvvmf2hirvvmf2hf */

    case 1062:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28263; /* *cond_floatrvvmf4qirvvmf2hf */

    case 1063:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28453; /* *cond_floatrvvm1sirvvmf2hf2 */

    case 1064:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28109; /* *cond_floatrvvmf4hirvvmf4hf */

    case 1065:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28265; /* *cond_floatrvvmf8qirvvmf4hf */

    case 1066:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28455; /* *cond_floatrvvmf2sirvvmf4hf2 */

    case 1067:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28111; /* *cond_floatrvvm8sirvvm8sf */

    case 1068:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28267; /* *cond_floatrvvm4hirvvm8sf */

    case 1069:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28113; /* *cond_floatrvvm4sirvvm4sf */

    case 1070:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28269; /* *cond_floatrvvm2hirvvm4sf */

    case 1071:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28457; /* *cond_floatrvvm8dirvvm4sf2 */

    case 1072:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28115; /* *cond_floatrvvm2sirvvm2sf */

    case 1073:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28271; /* *cond_floatrvvm1hirvvm2sf */

    case 1074:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28459; /* *cond_floatrvvm4dirvvm2sf2 */

    case 1075:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28117; /* *cond_floatrvvm1sirvvm1sf */

    case 1076:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28273; /* *cond_floatrvvmf2hirvvm1sf */

    case 1077:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28461; /* *cond_floatrvvm2dirvvm1sf2 */

    case 1078:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28119; /* *cond_floatrvvmf2sirvvmf2sf */

    case 1079:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28275; /* *cond_floatrvvmf4hirvvmf2sf */

    case 1080:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28463; /* *cond_floatrvvm1dirvvmf2sf2 */

    case 1081:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28121; /* *cond_floatrvvm8dirvvm8df */

    case 1082:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28277; /* *cond_floatrvvm4sirvvm8df */

    case 1083:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28123; /* *cond_floatrvvm4dirvvm4df */

    case 1084:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28279; /* *cond_floatrvvm2sirvvm4df */

    case 1085:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28125; /* *cond_floatrvvm2dirvvm2df */

    case 1086:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28281; /* *cond_floatrvvm1sirvvm2df */

    case 1087:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28127; /* *cond_floatrvvm1dirvvm1df */

    case 1088:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28283; /* *cond_floatrvvmf2sirvvm1df */

    case 1089:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28129; /* *cond_floatv1hiv1hf */

    case 1090:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28285; /* *cond_floatv1qiv1hf */

    case 1091:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28465; /* *cond_floatv1siv1hf2 */

    case 1092:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28131; /* *cond_floatv2hiv2hf */

    case 1093:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28287; /* *cond_floatv2qiv2hf */

    case 1094:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28467; /* *cond_floatv2siv2hf2 */

    case 1095:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28133; /* *cond_floatv4hiv4hf */

    case 1096:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28289; /* *cond_floatv4qiv4hf */

    case 1097:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28469; /* *cond_floatv4siv4hf2 */

    case 1098:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28135; /* *cond_floatv8hiv8hf */

    case 1099:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28291; /* *cond_floatv8qiv8hf */

    case 1100:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28471; /* *cond_floatv8siv8hf2 */

    case 1101:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28137; /* *cond_floatv16hiv16hf */

    case 1102:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28293; /* *cond_floatv16qiv16hf */

    case 1103:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28473; /* *cond_floatv16siv16hf2 */

    case 1104:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28139; /* *cond_floatv32hiv32hf */

    case 1105:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28295; /* *cond_floatv32qiv32hf */

    case 1106:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28475; /* *cond_floatv32siv32hf2 */

    case 1107:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28141; /* *cond_floatv64hiv64hf */

    case 1108:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28297; /* *cond_floatv64qiv64hf */

    case 1109:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28477; /* *cond_floatv64siv64hf2 */

    case 1110:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28143; /* *cond_floatv128hiv128hf */

    case 1111:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28299; /* *cond_floatv128qiv128hf */

    case 1112:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28479; /* *cond_floatv128siv128hf2 */

    case 1113:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28145; /* *cond_floatv256hiv256hf */

    case 1114:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28301; /* *cond_floatv256qiv256hf */

    case 1115:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28481; /* *cond_floatv256siv256hf2 */

    case 1116:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28147; /* *cond_floatv512hiv512hf */

    case 1117:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28303; /* *cond_floatv512qiv512hf */

    case 1118:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28483; /* *cond_floatv512siv512hf2 */

    case 1119:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28149; /* *cond_floatv1024hiv1024hf */

    case 1120:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28305; /* *cond_floatv1024qiv1024hf */

    case 1121:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28485; /* *cond_floatv1024siv1024hf2 */

    case 1122:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28151; /* *cond_floatv2048hiv2048hf */

    case 1123:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28307; /* *cond_floatv2048qiv2048hf */

    case 1124:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28153; /* *cond_floatv1siv1sf */

    case 1125:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28309; /* *cond_floatv1hiv1sf */

    case 1126:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28487; /* *cond_floatv1div1sf2 */

    case 1127:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28155; /* *cond_floatv2siv2sf */

    case 1128:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28311; /* *cond_floatv2hiv2sf */

    case 1129:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28489; /* *cond_floatv2div2sf2 */

    case 1130:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28157; /* *cond_floatv4siv4sf */

    case 1131:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28313; /* *cond_floatv4hiv4sf */

    case 1132:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28491; /* *cond_floatv4div4sf2 */

    case 1133:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28159; /* *cond_floatv8siv8sf */

    case 1134:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28315; /* *cond_floatv8hiv8sf */

    case 1135:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28493; /* *cond_floatv8div8sf2 */

    case 1136:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28161; /* *cond_floatv16siv16sf */

    case 1137:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28317; /* *cond_floatv16hiv16sf */

    case 1138:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28495; /* *cond_floatv16div16sf2 */

    case 1139:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28163; /* *cond_floatv32siv32sf */

    case 1140:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28319; /* *cond_floatv32hiv32sf */

    case 1141:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28497; /* *cond_floatv32div32sf2 */

    case 1142:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28165; /* *cond_floatv64siv64sf */

    case 1143:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28321; /* *cond_floatv64hiv64sf */

    case 1144:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28499; /* *cond_floatv64div64sf2 */

    case 1145:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28167; /* *cond_floatv128siv128sf */

    case 1146:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28323; /* *cond_floatv128hiv128sf */

    case 1147:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28501; /* *cond_floatv128div128sf2 */

    case 1148:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28169; /* *cond_floatv256siv256sf */

    case 1149:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28325; /* *cond_floatv256hiv256sf */

    case 1150:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28503; /* *cond_floatv256div256sf2 */

    case 1151:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28171; /* *cond_floatv512siv512sf */

    case 1152:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28327; /* *cond_floatv512hiv512sf */

    case 1153:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28505; /* *cond_floatv512div512sf2 */

    case 1154:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28173; /* *cond_floatv1024siv1024sf */

    case 1155:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28329; /* *cond_floatv1024hiv1024sf */

    case 1156:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28175; /* *cond_floatv1div1df */

    case 1157:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28331; /* *cond_floatv1siv1df */

    case 1158:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28177; /* *cond_floatv2div2df */

    case 1159:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28333; /* *cond_floatv2siv2df */

    case 1160:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28179; /* *cond_floatv4div4df */

    case 1161:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28335; /* *cond_floatv4siv4df */

    case 1162:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28181; /* *cond_floatv8div8df */

    case 1163:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28337; /* *cond_floatv8siv8df */

    case 1164:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28183; /* *cond_floatv16div16df */

    case 1165:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28339; /* *cond_floatv16siv16df */

    case 1166:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28185; /* *cond_floatv32div32df */

    case 1167:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28341; /* *cond_floatv32siv32df */

    case 1168:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28187; /* *cond_floatv64div64df */

    case 1169:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28343; /* *cond_floatv64siv64df */

    case 1170:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28189; /* *cond_floatv128div128df */

    case 1171:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28345; /* *cond_floatv128siv128df */

    case 1172:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28191; /* *cond_floatv256div256df */

    case 1173:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28347; /* *cond_floatv256siv256df */

    case 1174:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28193; /* *cond_floatv512div512df */

    case 1175:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28349; /* *cond_floatv512siv512df */

    case 1176:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28100; /* *cond_floatunsrvvm8hirvvm8hf */

    case 1177:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28256; /* *cond_floatunsrvvm4qirvvm8hf */

    case 1178:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28102; /* *cond_floatunsrvvm4hirvvm4hf */

    case 1179:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28258; /* *cond_floatunsrvvm2qirvvm4hf */

    case 1180:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28448; /* *cond_floatunsrvvm8sirvvm4hf2 */

    case 1181:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28104; /* *cond_floatunsrvvm2hirvvm2hf */

    case 1182:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28260; /* *cond_floatunsrvvm1qirvvm2hf */

    case 1183:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28450; /* *cond_floatunsrvvm4sirvvm2hf2 */

    case 1184:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28106; /* *cond_floatunsrvvm1hirvvm1hf */

    case 1185:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28262; /* *cond_floatunsrvvmf2qirvvm1hf */

    case 1186:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28452; /* *cond_floatunsrvvm2sirvvm1hf2 */

    case 1187:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28108; /* *cond_floatunsrvvmf2hirvvmf2hf */

    case 1188:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28264; /* *cond_floatunsrvvmf4qirvvmf2hf */

    case 1189:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28454; /* *cond_floatunsrvvm1sirvvmf2hf2 */

    case 1190:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28110; /* *cond_floatunsrvvmf4hirvvmf4hf */

    case 1191:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28266; /* *cond_floatunsrvvmf8qirvvmf4hf */

    case 1192:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28456; /* *cond_floatunsrvvmf2sirvvmf4hf2 */

    case 1193:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28112; /* *cond_floatunsrvvm8sirvvm8sf */

    case 1194:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28268; /* *cond_floatunsrvvm4hirvvm8sf */

    case 1195:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28114; /* *cond_floatunsrvvm4sirvvm4sf */

    case 1196:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28270; /* *cond_floatunsrvvm2hirvvm4sf */

    case 1197:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28458; /* *cond_floatunsrvvm8dirvvm4sf2 */

    case 1198:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28116; /* *cond_floatunsrvvm2sirvvm2sf */

    case 1199:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28272; /* *cond_floatunsrvvm1hirvvm2sf */

    case 1200:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28460; /* *cond_floatunsrvvm4dirvvm2sf2 */

    case 1201:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28118; /* *cond_floatunsrvvm1sirvvm1sf */

    case 1202:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28274; /* *cond_floatunsrvvmf2hirvvm1sf */

    case 1203:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28462; /* *cond_floatunsrvvm2dirvvm1sf2 */

    case 1204:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28120; /* *cond_floatunsrvvmf2sirvvmf2sf */

    case 1205:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28276; /* *cond_floatunsrvvmf4hirvvmf2sf */

    case 1206:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28464; /* *cond_floatunsrvvm1dirvvmf2sf2 */

    case 1207:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28122; /* *cond_floatunsrvvm8dirvvm8df */

    case 1208:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28278; /* *cond_floatunsrvvm4sirvvm8df */

    case 1209:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28124; /* *cond_floatunsrvvm4dirvvm4df */

    case 1210:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28280; /* *cond_floatunsrvvm2sirvvm4df */

    case 1211:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28126; /* *cond_floatunsrvvm2dirvvm2df */

    case 1212:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28282; /* *cond_floatunsrvvm1sirvvm2df */

    case 1213:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28128; /* *cond_floatunsrvvm1dirvvm1df */

    case 1214:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28284; /* *cond_floatunsrvvmf2sirvvm1df */

    case 1215:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28130; /* *cond_floatunsv1hiv1hf */

    case 1216:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28286; /* *cond_floatunsv1qiv1hf */

    case 1217:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 28466; /* *cond_floatunsv1siv1hf2 */

    case 1218:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28132; /* *cond_floatunsv2hiv2hf */

    case 1219:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28288; /* *cond_floatunsv2qiv2hf */

    case 1220:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 28468; /* *cond_floatunsv2siv2hf2 */

    case 1221:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28134; /* *cond_floatunsv4hiv4hf */

    case 1222:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28290; /* *cond_floatunsv4qiv4hf */

    case 1223:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 28470; /* *cond_floatunsv4siv4hf2 */

    case 1224:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28136; /* *cond_floatunsv8hiv8hf */

    case 1225:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28292; /* *cond_floatunsv8qiv8hf */

    case 1226:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 28472; /* *cond_floatunsv8siv8hf2 */

    case 1227:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28138; /* *cond_floatunsv16hiv16hf */

    case 1228:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28294; /* *cond_floatunsv16qiv16hf */

    case 1229:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28474; /* *cond_floatunsv16siv16hf2 */

    case 1230:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28140; /* *cond_floatunsv32hiv32hf */

    case 1231:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28296; /* *cond_floatunsv32qiv32hf */

    case 1232:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28476; /* *cond_floatunsv32siv32hf2 */

    case 1233:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28142; /* *cond_floatunsv64hiv64hf */

    case 1234:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28298; /* *cond_floatunsv64qiv64hf */

    case 1235:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28478; /* *cond_floatunsv64siv64hf2 */

    case 1236:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28144; /* *cond_floatunsv128hiv128hf */

    case 1237:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28300; /* *cond_floatunsv128qiv128hf */

    case 1238:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28480; /* *cond_floatunsv128siv128hf2 */

    case 1239:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28146; /* *cond_floatunsv256hiv256hf */

    case 1240:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28302; /* *cond_floatunsv256qiv256hf */

    case 1241:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28482; /* *cond_floatunsv256siv256hf2 */

    case 1242:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28148; /* *cond_floatunsv512hiv512hf */

    case 1243:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28304; /* *cond_floatunsv512qiv512hf */

    case 1244:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28484; /* *cond_floatunsv512siv512hf2 */

    case 1245:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28150; /* *cond_floatunsv1024hiv1024hf */

    case 1246:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28306; /* *cond_floatunsv1024qiv1024hf */

    case 1247:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28486; /* *cond_floatunsv1024siv1024hf2 */

    case 1248:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28152; /* *cond_floatunsv2048hiv2048hf */

    case 1249:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28308; /* *cond_floatunsv2048qiv2048hf */

    case 1250:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28154; /* *cond_floatunsv1siv1sf */

    case 1251:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28310; /* *cond_floatunsv1hiv1sf */

    case 1252:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28488; /* *cond_floatunsv1div1sf2 */

    case 1253:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28156; /* *cond_floatunsv2siv2sf */

    case 1254:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28312; /* *cond_floatunsv2hiv2sf */

    case 1255:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28490; /* *cond_floatunsv2div2sf2 */

    case 1256:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28158; /* *cond_floatunsv4siv4sf */

    case 1257:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28314; /* *cond_floatunsv4hiv4sf */

    case 1258:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28492; /* *cond_floatunsv4div4sf2 */

    case 1259:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28160; /* *cond_floatunsv8siv8sf */

    case 1260:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28316; /* *cond_floatunsv8hiv8sf */

    case 1261:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28494; /* *cond_floatunsv8div8sf2 */

    case 1262:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28162; /* *cond_floatunsv16siv16sf */

    case 1263:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28318; /* *cond_floatunsv16hiv16sf */

    case 1264:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28496; /* *cond_floatunsv16div16sf2 */

    case 1265:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28164; /* *cond_floatunsv32siv32sf */

    case 1266:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28320; /* *cond_floatunsv32hiv32sf */

    case 1267:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28498; /* *cond_floatunsv32div32sf2 */

    case 1268:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28166; /* *cond_floatunsv64siv64sf */

    case 1269:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28322; /* *cond_floatunsv64hiv64sf */

    case 1270:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28500; /* *cond_floatunsv64div64sf2 */

    case 1271:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28168; /* *cond_floatunsv128siv128sf */

    case 1272:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28324; /* *cond_floatunsv128hiv128sf */

    case 1273:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28502; /* *cond_floatunsv128div128sf2 */

    case 1274:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28170; /* *cond_floatunsv256siv256sf */

    case 1275:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28326; /* *cond_floatunsv256hiv256sf */

    case 1276:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28504; /* *cond_floatunsv256div256sf2 */

    case 1277:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28172; /* *cond_floatunsv512siv512sf */

    case 1278:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28328; /* *cond_floatunsv512hiv512sf */

    case 1279:
      if (!(
#line 476 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28506; /* *cond_floatunsv512div512sf2 */

    case 1280:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28174; /* *cond_floatunsv1024siv1024sf */

    case 1281:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28330; /* *cond_floatunsv1024hiv1024sf */

    case 1282:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28176; /* *cond_floatunsv1div1df */

    case 1283:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28332; /* *cond_floatunsv1siv1df */

    case 1284:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28178; /* *cond_floatunsv2div2df */

    case 1285:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28334; /* *cond_floatunsv2siv2df */

    case 1286:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28180; /* *cond_floatunsv4div4df */

    case 1287:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28336; /* *cond_floatunsv4siv4df */

    case 1288:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28182; /* *cond_floatunsv8div8df */

    case 1289:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28338; /* *cond_floatunsv8siv8df */

    case 1290:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28184; /* *cond_floatunsv16div16df */

    case 1291:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28340; /* *cond_floatunsv16siv16df */

    case 1292:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28186; /* *cond_floatunsv32div32df */

    case 1293:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28342; /* *cond_floatunsv32siv32df */

    case 1294:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28188; /* *cond_floatunsv64div64df */

    case 1295:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28344; /* *cond_floatunsv64siv64df */

    case 1296:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28190; /* *cond_floatunsv128div128df */

    case 1297:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28346; /* *cond_floatunsv128siv128df */

    case 1298:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28192; /* *cond_floatunsv256div256df */

    case 1299:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28348; /* *cond_floatunsv256siv256df */

    case 1300:
      if (!(
#line 392 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28194; /* *cond_floatunsv512div512df */

    case 1301:
      if (!(
#line 434 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28350; /* *cond_floatunsv512siv512df */

    case 1302:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28795; /* *cond_smulrvvm8qi3_highpart */

    case 1303:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28797; /* *cond_smulrvvm4qi3_highpart */

    case 1304:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28799; /* *cond_smulrvvm2qi3_highpart */

    case 1305:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28801; /* *cond_smulrvvm1qi3_highpart */

    case 1306:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28803; /* *cond_smulrvvmf2qi3_highpart */

    case 1307:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28805; /* *cond_smulrvvmf4qi3_highpart */

    case 1308:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28807; /* *cond_smulrvvmf8qi3_highpart */

    case 1309:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28809; /* *cond_smulrvvm8hi3_highpart */

    case 1310:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28811; /* *cond_smulrvvm4hi3_highpart */

    case 1311:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28813; /* *cond_smulrvvm2hi3_highpart */

    case 1312:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28815; /* *cond_smulrvvm1hi3_highpart */

    case 1313:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28817; /* *cond_smulrvvmf2hi3_highpart */

    case 1314:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28819; /* *cond_smulrvvmf4hi3_highpart */

    case 1315:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28821; /* *cond_smulrvvm8si3_highpart */

    case 1316:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28823; /* *cond_smulrvvm4si3_highpart */

    case 1317:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28825; /* *cond_smulrvvm2si3_highpart */

    case 1318:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28827; /* *cond_smulrvvm1si3_highpart */

    case 1319:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28829; /* *cond_smulrvvmf2si3_highpart */

    case 1320:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28831; /* *cond_smulrvvm8di3_highpart */

    case 1321:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28833; /* *cond_smulrvvm4di3_highpart */

    case 1322:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28835; /* *cond_smulrvvm2di3_highpart */

    case 1323:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28837; /* *cond_smulrvvm1di3_highpart */

    case 1324:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 28839; /* *cond_smulv1qi3_highpart */

    case 1325:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 28841; /* *cond_smulv2qi3_highpart */

    case 1326:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 28843; /* *cond_smulv4qi3_highpart */

    case 1327:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 28845; /* *cond_smulv8qi3_highpart */

    case 1328:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 28847; /* *cond_smulv16qi3_highpart */

    case 1329:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 28849; /* *cond_smulv32qi3_highpart */

    case 1330:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28851; /* *cond_smulv64qi3_highpart */

    case 1331:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28853; /* *cond_smulv128qi3_highpart */

    case 1332:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28855; /* *cond_smulv256qi3_highpart */

    case 1333:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28857; /* *cond_smulv512qi3_highpart */

    case 1334:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28859; /* *cond_smulv1024qi3_highpart */

    case 1335:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28861; /* *cond_smulv2048qi3_highpart */

    case 1336:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28863; /* *cond_smulv4096qi3_highpart */

    case 1337:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28865; /* *cond_smulv1hi3_highpart */

    case 1338:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28867; /* *cond_smulv2hi3_highpart */

    case 1339:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28869; /* *cond_smulv4hi3_highpart */

    case 1340:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28871; /* *cond_smulv8hi3_highpart */

    case 1341:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28873; /* *cond_smulv16hi3_highpart */

    case 1342:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28875; /* *cond_smulv32hi3_highpart */

    case 1343:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28877; /* *cond_smulv64hi3_highpart */

    case 1344:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28879; /* *cond_smulv128hi3_highpart */

    case 1345:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28881; /* *cond_smulv256hi3_highpart */

    case 1346:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28883; /* *cond_smulv512hi3_highpart */

    case 1347:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28885; /* *cond_smulv1024hi3_highpart */

    case 1348:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28887; /* *cond_smulv2048hi3_highpart */

    case 1349:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28889; /* *cond_smulv1si3_highpart */

    case 1350:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28891; /* *cond_smulv2si3_highpart */

    case 1351:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28893; /* *cond_smulv4si3_highpart */

    case 1352:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28895; /* *cond_smulv8si3_highpart */

    case 1353:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28897; /* *cond_smulv16si3_highpart */

    case 1354:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28899; /* *cond_smulv32si3_highpart */

    case 1355:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28901; /* *cond_smulv64si3_highpart */

    case 1356:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28903; /* *cond_smulv128si3_highpart */

    case 1357:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28905; /* *cond_smulv256si3_highpart */

    case 1358:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28907; /* *cond_smulv512si3_highpart */

    case 1359:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28909; /* *cond_smulv1024si3_highpart */

    case 1360:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28911; /* *cond_smulv1di3_highpart */

    case 1361:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28913; /* *cond_smulv2di3_highpart */

    case 1362:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28915; /* *cond_smulv4di3_highpart */

    case 1363:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28917; /* *cond_smulv8di3_highpart */

    case 1364:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28919; /* *cond_smulv16di3_highpart */

    case 1365:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28921; /* *cond_smulv32di3_highpart */

    case 1366:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28923; /* *cond_smulv64di3_highpart */

    case 1367:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28925; /* *cond_smulv128di3_highpart */

    case 1368:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28927; /* *cond_smulv256di3_highpart */

    case 1369:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28929; /* *cond_smulv512di3_highpart */

    case 1370:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28796; /* *cond_umulrvvm8qi3_highpart */

    case 1371:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28798; /* *cond_umulrvvm4qi3_highpart */

    case 1372:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28800; /* *cond_umulrvvm2qi3_highpart */

    case 1373:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28802; /* *cond_umulrvvm1qi3_highpart */

    case 1374:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28804; /* *cond_umulrvvmf2qi3_highpart */

    case 1375:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28806; /* *cond_umulrvvmf4qi3_highpart */

    case 1376:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28808; /* *cond_umulrvvmf8qi3_highpart */

    case 1377:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28810; /* *cond_umulrvvm8hi3_highpart */

    case 1378:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28812; /* *cond_umulrvvm4hi3_highpart */

    case 1379:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28814; /* *cond_umulrvvm2hi3_highpart */

    case 1380:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28816; /* *cond_umulrvvm1hi3_highpart */

    case 1381:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28818; /* *cond_umulrvvmf2hi3_highpart */

    case 1382:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28820; /* *cond_umulrvvmf4hi3_highpart */

    case 1383:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28822; /* *cond_umulrvvm8si3_highpart */

    case 1384:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28824; /* *cond_umulrvvm4si3_highpart */

    case 1385:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28826; /* *cond_umulrvvm2si3_highpart */

    case 1386:
      if (!
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28828; /* *cond_umulrvvm1si3_highpart */

    case 1387:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28830; /* *cond_umulrvvmf2si3_highpart */

    case 1388:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28832; /* *cond_umulrvvm8di3_highpart */

    case 1389:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28834; /* *cond_umulrvvm4di3_highpart */

    case 1390:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28836; /* *cond_umulrvvm2di3_highpart */

    case 1391:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 28838; /* *cond_umulrvvm1di3_highpart */

    case 1392:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 28840; /* *cond_umulv1qi3_highpart */

    case 1393:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 28842; /* *cond_umulv2qi3_highpart */

    case 1394:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 28844; /* *cond_umulv4qi3_highpart */

    case 1395:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 28846; /* *cond_umulv8qi3_highpart */

    case 1396:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 28848; /* *cond_umulv16qi3_highpart */

    case 1397:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 28850; /* *cond_umulv32qi3_highpart */

    case 1398:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28852; /* *cond_umulv64qi3_highpart */

    case 1399:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28854; /* *cond_umulv128qi3_highpart */

    case 1400:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28856; /* *cond_umulv256qi3_highpart */

    case 1401:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28858; /* *cond_umulv512qi3_highpart */

    case 1402:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28860; /* *cond_umulv1024qi3_highpart */

    case 1403:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28862; /* *cond_umulv2048qi3_highpart */

    case 1404:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28864; /* *cond_umulv4096qi3_highpart */

    case 1405:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28866; /* *cond_umulv1hi3_highpart */

    case 1406:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28868; /* *cond_umulv2hi3_highpart */

    case 1407:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28870; /* *cond_umulv4hi3_highpart */

    case 1408:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28872; /* *cond_umulv8hi3_highpart */

    case 1409:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28874; /* *cond_umulv16hi3_highpart */

    case 1410:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28876; /* *cond_umulv32hi3_highpart */

    case 1411:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28878; /* *cond_umulv64hi3_highpart */

    case 1412:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28880; /* *cond_umulv128hi3_highpart */

    case 1413:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28882; /* *cond_umulv256hi3_highpart */

    case 1414:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28884; /* *cond_umulv512hi3_highpart */

    case 1415:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28886; /* *cond_umulv1024hi3_highpart */

    case 1416:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28888; /* *cond_umulv2048hi3_highpart */

    case 1417:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28890; /* *cond_umulv1si3_highpart */

    case 1418:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28892; /* *cond_umulv2si3_highpart */

    case 1419:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28894; /* *cond_umulv4si3_highpart */

    case 1420:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28896; /* *cond_umulv8si3_highpart */

    case 1421:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28898; /* *cond_umulv16si3_highpart */

    case 1422:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28900; /* *cond_umulv32si3_highpart */

    case 1423:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28902; /* *cond_umulv64si3_highpart */

    case 1424:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28904; /* *cond_umulv128si3_highpart */

    case 1425:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28906; /* *cond_umulv256si3_highpart */

    case 1426:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28908; /* *cond_umulv512si3_highpart */

    case 1427:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28910; /* *cond_umulv1024si3_highpart */

    case 1428:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28912; /* *cond_umulv1di3_highpart */

    case 1429:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28914; /* *cond_umulv2di3_highpart */

    case 1430:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28916; /* *cond_umulv4di3_highpart */

    case 1431:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28918; /* *cond_umulv8di3_highpart */

    case 1432:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28920; /* *cond_umulv16di3_highpart */

    case 1433:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28922; /* *cond_umulv32di3_highpart */

    case 1434:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28924; /* *cond_umulv64di3_highpart */

    case 1435:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28926; /* *cond_umulv128di3_highpart */

    case 1436:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28928; /* *cond_umulv256di3_highpart */

    case 1437:
      if (!(
#line 544 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28930; /* *cond_umulv512di3_highpart */

    default:
      return -1;
    }
}

 rtx_insn *
split_143 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern151 (x2))
        {
        case 0:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4333 (insn, operands);

        case 1:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4334 (insn, operands);

        case 2:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4335 (insn, operands);

        case 3:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4336 (insn, operands);

        case 4:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4337 (insn, operands);

        case 5:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4338 (insn, operands);

        case 6:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4339 (insn, operands);

        case 7:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4340 (insn, operands);

        case 8:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4341 (insn, operands);

        case 9:
          if (!(
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4342 (insn, operands);

        case 10:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4343 (insn, operands);

        case 11:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4344 (insn, operands);

        case 12:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4345 (insn, operands);

        case 13:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4346 (insn, operands);

        case 14:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4347 (insn, operands);

        case 15:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4348 (insn, operands);

        case 16:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4349 (insn, operands);

        case 17:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4350 (insn, operands);

        case 18:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4351 (insn, operands);

        case 19:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4352 (insn, operands);

        case 20:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4353 (insn, operands);

        case 21:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4354 (insn, operands);

        case 22:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4355 (insn, operands);

        case 23:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4356 (insn, operands);

        case 24:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4357 (insn, operands);

        case 25:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4358 (insn, operands);

        case 26:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4359 (insn, operands);

        case 27:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4360 (insn, operands);

        case 28:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4361 (insn, operands);

        case 29:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4362 (insn, operands);

        case 30:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4363 (insn, operands);

        case 31:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4364 (insn, operands);

        case 32:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4365 (insn, operands);

        case 33:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4366 (insn, operands);

        case 34:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4367 (insn, operands);

        case 35:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4368 (insn, operands);

        case 36:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4369 (insn, operands);

        case 37:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4370 (insn, operands);

        case 38:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4371 (insn, operands);

        case 39:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4372 (insn, operands);

        case 40:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4373 (insn, operands);

        case 41:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4374 (insn, operands);

        case 42:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4375 (insn, operands);

        case 43:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4376 (insn, operands);

        case 44:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4377 (insn, operands);

        case 45:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4378 (insn, operands);

        case 46:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4379 (insn, operands);

        case 47:
          if (!((
#line 777 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 779 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4380 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern155 (x2))
        {
        case 0:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7844 (insn, operands);

        case 1:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7848 (insn, operands);

        case 2:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7852 (insn, operands);

        case 3:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7856 (insn, operands);

        case 4:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7860 (insn, operands);

        case 5:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7864 (insn, operands);

        case 6:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7868 (insn, operands);

        case 7:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7872 (insn, operands);

        case 8:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7876 (insn, operands);

        case 9:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7880 (insn, operands);

        case 10:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7884 (insn, operands);

        case 11:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7888 (insn, operands);

        case 12:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7892 (insn, operands);

        case 13:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7896 (insn, operands);

        case 14:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7900 (insn, operands);

        case 15:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7904 (insn, operands);

        case 16:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7908 (insn, operands);

        case 17:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7912 (insn, operands);

        case 18:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7916 (insn, operands);

        case 19:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7920 (insn, operands);

        case 20:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7924 (insn, operands);

        case 21:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7928 (insn, operands);

        case 22:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7932 (insn, operands);

        case 23:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7936 (insn, operands);

        case 24:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7940 (insn, operands);

        case 25:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7944 (insn, operands);

        case 26:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7948 (insn, operands);

        case 27:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7952 (insn, operands);

        case 28:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7956 (insn, operands);

        case 29:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7960 (insn, operands);

        case 30:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7964 (insn, operands);

        case 31:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7968 (insn, operands);

        case 32:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7972 (insn, operands);

        case 33:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7976 (insn, operands);

        case 34:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7980 (insn, operands);

        case 35:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7984 (insn, operands);

        case 36:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7988 (insn, operands);

        case 37:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7992 (insn, operands);

        case 38:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7996 (insn, operands);

        case 39:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8000 (insn, operands);

        case 40:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8004 (insn, operands);

        case 41:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8008 (insn, operands);

        case 42:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8012 (insn, operands);

        case 43:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8016 (insn, operands);

        case 44:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8020 (insn, operands);

        case 45:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8024 (insn, operands);

        case 46:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8028 (insn, operands);

        case 47:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8032 (insn, operands);

        case 48:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7846 (insn, operands);

        case 49:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7850 (insn, operands);

        case 50:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7854 (insn, operands);

        case 51:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7858 (insn, operands);

        case 52:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7862 (insn, operands);

        case 53:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7866 (insn, operands);

        case 54:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7870 (insn, operands);

        case 55:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7874 (insn, operands);

        case 56:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7878 (insn, operands);

        case 57:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7882 (insn, operands);

        case 58:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7886 (insn, operands);

        case 59:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7890 (insn, operands);

        case 60:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7894 (insn, operands);

        case 61:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7898 (insn, operands);

        case 62:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7902 (insn, operands);

        case 63:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7906 (insn, operands);

        case 64:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7910 (insn, operands);

        case 65:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7914 (insn, operands);

        case 66:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7918 (insn, operands);

        case 67:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7922 (insn, operands);

        case 68:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7926 (insn, operands);

        case 69:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7930 (insn, operands);

        case 70:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7934 (insn, operands);

        case 71:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7938 (insn, operands);

        case 72:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7942 (insn, operands);

        case 73:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7946 (insn, operands);

        case 74:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7950 (insn, operands);

        case 75:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7954 (insn, operands);

        case 76:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7958 (insn, operands);

        case 77:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7962 (insn, operands);

        case 78:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7966 (insn, operands);

        case 79:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7970 (insn, operands);

        case 80:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7974 (insn, operands);

        case 81:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7978 (insn, operands);

        case 82:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7982 (insn, operands);

        case 83:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7986 (insn, operands);

        case 84:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7990 (insn, operands);

        case 85:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7994 (insn, operands);

        case 86:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7998 (insn, operands);

        case 87:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8002 (insn, operands);

        case 88:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8006 (insn, operands);

        case 89:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8010 (insn, operands);

        case 90:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8014 (insn, operands);

        case 91:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8018 (insn, operands);

        case 92:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8022 (insn, operands);

        case 93:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8026 (insn, operands);

        case 94:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8030 (insn, operands);

        case 95:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8034 (insn, operands);

        case 96:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8036 (insn, operands);

        case 97:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8038 (insn, operands);

        case 98:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8040 (insn, operands);

        case 99:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8042 (insn, operands);

        case 100:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8044 (insn, operands);

        case 101:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8046 (insn, operands);

        case 102:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8048 (insn, operands);

        case 103:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8050 (insn, operands);

        case 104:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8052 (insn, operands);

        case 105:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8054 (insn, operands);

        case 106:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8056 (insn, operands);

        case 107:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8058 (insn, operands);

        case 108:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8060 (insn, operands);

        case 109:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8062 (insn, operands);

        case 110:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8064 (insn, operands);

        case 111:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8066 (insn, operands);

        case 112:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8068 (insn, operands);

        case 113:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8070 (insn, operands);

        case 114:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8072 (insn, operands);

        case 115:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8074 (insn, operands);

        case 116:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8076 (insn, operands);

        case 117:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8078 (insn, operands);

        case 118:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8080 (insn, operands);

        case 119:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8082 (insn, operands);

        case 120:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8084 (insn, operands);

        case 121:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8086 (insn, operands);

        case 122:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8088 (insn, operands);

        case 123:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8090 (insn, operands);

        case 124:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8092 (insn, operands);

        case 125:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8094 (insn, operands);

        case 126:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8096 (insn, operands);

        case 127:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8098 (insn, operands);

        case 128:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8100 (insn, operands);

        case 129:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8102 (insn, operands);

        case 130:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8104 (insn, operands);

        case 131:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8106 (insn, operands);

        case 132:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8108 (insn, operands);

        case 133:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8110 (insn, operands);

        case 134:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8112 (insn, operands);

        case 135:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8114 (insn, operands);

        case 136:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8116 (insn, operands);

        case 137:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8118 (insn, operands);

        case 138:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8120 (insn, operands);

        case 139:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8122 (insn, operands);

        case 140:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8124 (insn, operands);

        case 141:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8126 (insn, operands);

        case 142:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8128 (insn, operands);

        case 143:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8130 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      return split_142 (x1, insn);

    case ASHIFT:
      return split_141 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_154 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4411 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4412 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4413 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4414 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4415 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4416 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4417 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4418 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4419 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4420 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4421 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4422 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4423 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4424 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4425 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4426 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4427 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4428 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4429 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4430 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4431 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4432 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4433 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4434 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4435 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4436 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4437 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4438 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4439 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 865 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4440 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_159 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (XINT (x3, 1) != 91
              || pattern260 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case CONST_VECTOR:
              operands[1] = x4;
              x5 = XVECEXP (x3, 0, 1);
              operands[4] = x5;
              if (!vector_length_operand (operands[4], E_VOIDmode))
                return NULL;
              x6 = XVECEXP (x3, 0, 2);
              operands[5] = x6;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 2);
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVMF64BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF64BImode)
                      || pattern574 (x2, 
E_RVVMF64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_779 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF64BImode, 5))))
                    return NULL;
                  return gen_split_2431 (insn, operands);

                case E_RVVMF32BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF32BImode)
                      || pattern574 (x2, 
E_RVVMF32BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_780 (insn, operands);
                  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF32BImode, 5))))
                    return NULL;
                  return gen_split_2432 (insn, operands);

                case E_RVVMF16BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF16BImode)
                      || pattern574 (x2, 
E_RVVMF16BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_781 (insn, operands);
                  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF16BImode, 5))))
                    return NULL;
                  return gen_split_2433 (insn, operands);

                case E_RVVMF8BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF8BImode)
                      || pattern574 (x2, 
E_RVVMF8BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_782 (insn, operands);
                  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8BImode, 5))))
                    return NULL;
                  return gen_split_2434 (insn, operands);

                case E_RVVMF4BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF4BImode)
                      || pattern574 (x2, 
E_RVVMF4BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_783 (insn, operands);
                  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BImode, 5))))
                    return NULL;
                  return gen_split_2435 (insn, operands);

                case E_RVVMF2BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF2BImode)
                      || pattern574 (x2, 
E_RVVMF2BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_784 (insn, operands);
                  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BImode, 5))))
                    return NULL;
                  return gen_split_2436 (insn, operands);

                case E_RVVM1BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVM1BImode)
                      || pattern574 (x2, 
E_RVVM1BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_785 (insn, operands);
                  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BImode, 5))))
                    return NULL;
                  return gen_split_2437 (insn, operands);

                case E_V1BImode:
                  if (!nonimmediate_operand (operands[0], E_V1BImode)
                      || pattern574 (x2, 
E_V1BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_786 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1BImode, 5))))
                    return NULL;
                  return gen_split_2438 (insn, operands);

                case E_V2BImode:
                  if (!nonimmediate_operand (operands[0], E_V2BImode)
                      || pattern574 (x2, 
E_V2BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_787 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2BImode, 5))))
                    return NULL;
                  return gen_split_2439 (insn, operands);

                case E_V4BImode:
                  if (!nonimmediate_operand (operands[0], E_V4BImode)
                      || pattern574 (x2, 
E_V4BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_788 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4BImode, 5))))
                    return NULL;
                  return gen_split_2440 (insn, operands);

                case E_V8BImode:
                  if (!nonimmediate_operand (operands[0], E_V8BImode)
                      || pattern574 (x2, 
E_V8BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_789 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8BImode, 5))))
                    return NULL;
                  return gen_split_2441 (insn, operands);

                case E_V16BImode:
                  if (!nonimmediate_operand (operands[0], E_V16BImode)
                      || pattern574 (x2, 
E_V16BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_790 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16BImode, 5))))
                    return NULL;
                  return gen_split_2442 (insn, operands);

                case E_V32BImode:
                  if (!nonimmediate_operand (operands[0], E_V32BImode)
                      || pattern574 (x2, 
E_V32BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_791 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32BImode, 5))))
                    return NULL;
                  return gen_split_2443 (insn, operands);

                case E_V64BImode:
                  if (!nonimmediate_operand (operands[0], E_V64BImode)
                      || pattern574 (x2, 
E_V64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_792 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64BImode, 5))))
                    return NULL;
                  return gen_split_2444 (insn, operands);

                case E_V128BImode:
                  if (!nonimmediate_operand (operands[0], E_V128BImode)
                      || pattern574 (x2, 
E_V128BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_793 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128BImode, 5))))
                    return NULL;
                  return gen_split_2445 (insn, operands);

                case E_V256BImode:
                  if (!nonimmediate_operand (operands[0], E_V256BImode)
                      || pattern574 (x2, 
E_V256BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_794 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256BImode, 5))))
                    return NULL;
                  return gen_split_2446 (insn, operands);

                case E_V512BImode:
                  if (!nonimmediate_operand (operands[0], E_V512BImode)
                      || pattern574 (x2, 
E_V512BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_795 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512BImode, 5))))
                    return NULL;
                  return gen_split_2447 (insn, operands);

                case E_V1024BImode:
                  if (!nonimmediate_operand (operands[0], E_V1024BImode)
                      || pattern574 (x2, 
E_V1024BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_796 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024BImode, 5))))
                    return NULL;
                  return gen_split_2448 (insn, operands);

                case E_V2048BImode:
                  if (!nonimmediate_operand (operands[0], E_V2048BImode)
                      || pattern574 (x2, 
E_V2048BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_797 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048BImode, 5))))
                    return NULL;
                  return gen_split_2449 (insn, operands);

                case E_V4096BImode:
                  if (!nonimmediate_operand (operands[0], E_V4096BImode)
                      || pattern574 (x2, 
E_V4096BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_798 (insn, operands);
                  if (!((
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1970 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096BImode, 5))))
                    return NULL;
                  return gen_split_2450 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              return split_124 (x1, insn);

            default:
              return NULL;
            }

        case 7:
          return split_132 (x1, insn);

        case 6:
          if (pattern262 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[4] = x5;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x3, 0, 2);
          operands[5] = x6;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x3, 0, 3);
          operands[6] = x9;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || pattern574 (x2, 
E_RVVMF64BImode) != 0
                  || !(
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return NULL;
              return gen_split_6307 (insn, operands);

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || pattern574 (x2, 
E_RVVMF32BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6308 (insn, operands);

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || pattern574 (x2, 
E_RVVMF16BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6309 (insn, operands);

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || pattern574 (x2, 
E_RVVMF8BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6310 (insn, operands);

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || pattern574 (x2, 
E_RVVMF4BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6311 (insn, operands);

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || pattern574 (x2, 
E_RVVMF2BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6312 (insn, operands);

            case E_RVVM1BImode:
              if (!register_operand (operands[0], E_RVVM1BImode)
                  || pattern574 (x2, 
E_RVVM1BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6313 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_133 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_165 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2598 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2612 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2626 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2640 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2654 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2668 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2682 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2696 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2710 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2724 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2738 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2752 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2766 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2780 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2794 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2808 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2822 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2836 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2850 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2864 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2878 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2892 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2906 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2920 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2934 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2948 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2962 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2976 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2990 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3004 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3018 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3032 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3046 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3060 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3074 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3088 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3102 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3116 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3130 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3144 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3158 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3172 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3186 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3200 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3214 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3228 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3242 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3256 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3270 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3284 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3298 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3312 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3326 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3340 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3354 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3368 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3382 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3396 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3410 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3424 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3438 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3452 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3466 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3480 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3494 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3508 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3522 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3536 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_174 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT
      || GET_MODE (x4) != E_DImode)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_SImode))
    return NULL;
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern463 (x10))
        {
        case 0:
          if (!((
#line 734 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 739 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 1:
          if (!((
#line 762 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 766 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern463 (x10))
        {
        case 0:
          if (!((
#line 734 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 739 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_156 (insn, operands);

        case 1:
          if (!((
#line 762 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 766 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_177 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern376 (x1))
    {
    case 0:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1617 (insn, operands);

    case 1:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1618 (insn, operands);

    case 2:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1619 (insn, operands);

    case 3:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1620 (insn, operands);

    case 4:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1621 (insn, operands);

    case 5:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1622 (insn, operands);

    case 6:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1623 (insn, operands);

    case 7:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1624 (insn, operands);

    case 8:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1625 (insn, operands);

    case 9:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case 10:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case 11:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1628 (insn, operands);

    case 12:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case 13:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case 14:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1631 (insn, operands);

    case 15:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case 16:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case 17:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1634 (insn, operands);

    case 18:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1635 (insn, operands);

    case 19:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1636 (insn, operands);

    case 20:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1637 (insn, operands);

    case 21:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1638 (insn, operands);

    case 22:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1639 (insn, operands);

    case 23:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1640 (insn, operands);

    case 24:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1641 (insn, operands);

    case 25:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1642 (insn, operands);

    case 26:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1643 (insn, operands);

    case 27:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1644 (insn, operands);

    case 28:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1645 (insn, operands);

    case 29:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1646 (insn, operands);

    case 30:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1647 (insn, operands);

    case 31:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1648 (insn, operands);

    case 32:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1649 (insn, operands);

    case 33:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1650 (insn, operands);

    case 34:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1651 (insn, operands);

    case 35:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1652 (insn, operands);

    case 36:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1653 (insn, operands);

    case 37:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1654 (insn, operands);

    case 38:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1655 (insn, operands);

    case 39:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1656 (insn, operands);

    case 40:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1657 (insn, operands);

    case 41:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1658 (insn, operands);

    case 42:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1659 (insn, operands);

    case 43:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1660 (insn, operands);

    case 44:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1661 (insn, operands);

    case 45:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1662 (insn, operands);

    case 46:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1663 (insn, operands);

    case 47:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1664 (insn, operands);

    case 48:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1665 (insn, operands);

    case 49:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1666 (insn, operands);

    case 50:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1667 (insn, operands);

    case 51:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1668 (insn, operands);

    case 52:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1669 (insn, operands);

    case 53:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1670 (insn, operands);

    case 54:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1671 (insn, operands);

    case 55:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1672 (insn, operands);

    case 56:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1673 (insn, operands);

    case 57:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1674 (insn, operands);

    case 58:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1675 (insn, operands);

    case 59:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1676 (insn, operands);

    case 60:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1677 (insn, operands);

    case 61:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1678 (insn, operands);

    case 62:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1679 (insn, operands);

    case 63:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1680 (insn, operands);

    case 64:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1681 (insn, operands);

    case 65:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1682 (insn, operands);

    case 66:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1683 (insn, operands);

    case 67:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1684 (insn, operands);

    case 68:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1685 (insn, operands);

    case 69:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1686 (insn, operands);

    case 70:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1687 (insn, operands);

    case 71:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1688 (insn, operands);

    case 72:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1689 (insn, operands);

    case 73:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1690 (insn, operands);

    case 74:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1691 (insn, operands);

    case 75:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1692 (insn, operands);

    case 76:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1693 (insn, operands);

    case 77:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1694 (insn, operands);

    case 78:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1695 (insn, operands);

    case 79:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1696 (insn, operands);

    case 80:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1697 (insn, operands);

    case 81:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1698 (insn, operands);

    case 82:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1699 (insn, operands);

    case 83:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1700 (insn, operands);

    case 84:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1701 (insn, operands);

    case 85:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1702 (insn, operands);

    case 86:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1703 (insn, operands);

    case 87:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1704 (insn, operands);

    case 88:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1705 (insn, operands);

    case 89:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1706 (insn, operands);

    case 90:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1707 (insn, operands);

    case 91:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1708 (insn, operands);

    case 92:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1709 (insn, operands);

    case 93:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1710 (insn, operands);

    case 94:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1711 (insn, operands);

    case 95:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1712 (insn, operands);

    case 96:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1713 (insn, operands);

    case 97:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1714 (insn, operands);

    case 98:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1715 (insn, operands);

    case 99:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1716 (insn, operands);

    case 100:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1717 (insn, operands);

    case 101:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1718 (insn, operands);

    case 102:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1719 (insn, operands);

    case 103:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1720 (insn, operands);

    case 104:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1721 (insn, operands);

    case 105:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1722 (insn, operands);

    case 106:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1723 (insn, operands);

    case 107:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1724 (insn, operands);

    case 108:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1725 (insn, operands);

    case 109:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1726 (insn, operands);

    case 110:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1727 (insn, operands);

    case 111:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1728 (insn, operands);

    case 112:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1729 (insn, operands);

    case 113:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1730 (insn, operands);

    case 114:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1731 (insn, operands);

    case 115:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1732 (insn, operands);

    case 116:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1733 (insn, operands);

    case 117:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1734 (insn, operands);

    case 118:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1735 (insn, operands);

    case 119:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1736 (insn, operands);

    case 120:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1737 (insn, operands);

    case 121:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1738 (insn, operands);

    case 122:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1739 (insn, operands);

    case 123:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1740 (insn, operands);

    case 124:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1741 (insn, operands);

    case 125:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1742 (insn, operands);

    case 126:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1743 (insn, operands);

    case 127:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1744 (insn, operands);

    case 128:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1745 (insn, operands);

    case 129:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1746 (insn, operands);

    case 130:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1747 (insn, operands);

    case 131:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1748 (insn, operands);

    case 132:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1749 (insn, operands);

    case 133:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1750 (insn, operands);

    case 134:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1751 (insn, operands);

    case 135:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1752 (insn, operands);

    case 136:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1753 (insn, operands);

    case 137:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1754 (insn, operands);

    case 138:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1755 (insn, operands);

    case 139:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1756 (insn, operands);

    case 140:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1757 (insn, operands);

    case 141:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1758 (insn, operands);

    case 142:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1759 (insn, operands);

    case 143:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1760 (insn, operands);

    case 144:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1761 (insn, operands);

    case 145:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1762 (insn, operands);

    case 146:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1763 (insn, operands);

    case 147:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1764 (insn, operands);

    case 148:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1765 (insn, operands);

    case 149:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1766 (insn, operands);

    case 150:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1767 (insn, operands);

    case 151:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1768 (insn, operands);

    case 152:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1769 (insn, operands);

    case 153:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1770 (insn, operands);

    case 154:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1771 (insn, operands);

    case 155:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1772 (insn, operands);

    case 156:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1773 (insn, operands);

    case 157:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1774 (insn, operands);

    case 158:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1775 (insn, operands);

    case 159:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1776 (insn, operands);

    case 160:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1777 (insn, operands);

    case 161:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1778 (insn, operands);

    case 162:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1779 (insn, operands);

    case 163:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1780 (insn, operands);

    case 164:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1781 (insn, operands);

    case 165:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1782 (insn, operands);

    case 166:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1783 (insn, operands);

    case 167:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1784 (insn, operands);

    case 168:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1785 (insn, operands);

    case 169:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1786 (insn, operands);

    case 170:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1787 (insn, operands);

    case 171:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1788 (insn, operands);

    case 172:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1789 (insn, operands);

    case 173:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1790 (insn, operands);

    case 174:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1791 (insn, operands);

    case 175:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1792 (insn, operands);

    case 176:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1793 (insn, operands);

    case 177:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1794 (insn, operands);

    case 178:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1795 (insn, operands);

    case 179:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1796 (insn, operands);

    case 180:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1797 (insn, operands);

    case 181:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1798 (insn, operands);

    case 182:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1799 (insn, operands);

    case 183:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1800 (insn, operands);

    case 184:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1801 (insn, operands);

    case 185:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1802 (insn, operands);

    case 186:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1803 (insn, operands);

    case 187:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1804 (insn, operands);

    case 188:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1805 (insn, operands);

    case 189:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1806 (insn, operands);

    case 190:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1807 (insn, operands);

    case 191:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1808 (insn, operands);

    case 192:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1809 (insn, operands);

    case 193:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1810 (insn, operands);

    case 194:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1811 (insn, operands);

    case 195:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1812 (insn, operands);

    case 196:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1813 (insn, operands);

    case 197:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1814 (insn, operands);

    case 198:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1815 (insn, operands);

    case 199:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1816 (insn, operands);

    case 200:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1817 (insn, operands);

    case 201:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1818 (insn, operands);

    case 202:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1819 (insn, operands);

    case 203:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1820 (insn, operands);

    case 204:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1821 (insn, operands);

    case 205:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1822 (insn, operands);

    case 206:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1823 (insn, operands);

    case 207:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1824 (insn, operands);

    case 208:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1825 (insn, operands);

    case 209:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1826 (insn, operands);

    case 210:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1827 (insn, operands);

    case 211:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1828 (insn, operands);

    case 212:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1829 (insn, operands);

    case 213:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1830 (insn, operands);

    case 214:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1831 (insn, operands);

    case 215:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1832 (insn, operands);

    case 216:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1833 (insn, operands);

    case 217:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1834 (insn, operands);

    case 218:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1835 (insn, operands);

    case 219:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1836 (insn, operands);

    case 220:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1837 (insn, operands);

    case 221:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1838 (insn, operands);

    case 222:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1839 (insn, operands);

    case 223:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1840 (insn, operands);

    case 224:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1841 (insn, operands);

    case 225:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1842 (insn, operands);

    case 226:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1843 (insn, operands);

    case 227:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1844 (insn, operands);

    case 228:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1845 (insn, operands);

    case 229:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1846 (insn, operands);

    case 230:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1847 (insn, operands);

    case 231:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1848 (insn, operands);

    case 232:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1849 (insn, operands);

    case 233:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1850 (insn, operands);

    case 234:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1851 (insn, operands);

    case 235:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1852 (insn, operands);

    case 236:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1853 (insn, operands);

    case 237:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1854 (insn, operands);

    case 238:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1855 (insn, operands);

    case 239:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1856 (insn, operands);

    case 240:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1857 (insn, operands);

    case 241:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1858 (insn, operands);

    case 242:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1859 (insn, operands);

    case 243:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1860 (insn, operands);

    case 244:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1861 (insn, operands);

    case 245:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1862 (insn, operands);

    case 246:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1863 (insn, operands);

    case 247:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1864 (insn, operands);

    case 248:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1865 (insn, operands);

    case 249:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1866 (insn, operands);

    case 250:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1867 (insn, operands);

    case 251:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1868 (insn, operands);

    case 252:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1869 (insn, operands);

    case 253:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1870 (insn, operands);

    case 254:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1871 (insn, operands);

    case 255:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1872 (insn, operands);

    case 256:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1873 (insn, operands);

    case 257:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1874 (insn, operands);

    case 258:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1875 (insn, operands);

    case 259:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1876 (insn, operands);

    case 260:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1877 (insn, operands);

    case 261:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1878 (insn, operands);

    case 262:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1879 (insn, operands);

    case 263:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1880 (insn, operands);

    case 264:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1881 (insn, operands);

    case 265:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1882 (insn, operands);

    case 266:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1883 (insn, operands);

    case 267:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1884 (insn, operands);

    case 268:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1885 (insn, operands);

    case 269:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1886 (insn, operands);

    case 270:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1887 (insn, operands);

    case 271:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1888 (insn, operands);

    case 272:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1889 (insn, operands);

    case 273:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1890 (insn, operands);

    case 274:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1891 (insn, operands);

    case 275:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1892 (insn, operands);

    case 276:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1893 (insn, operands);

    case 277:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1894 (insn, operands);

    case 278:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1895 (insn, operands);

    case 279:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1896 (insn, operands);

    case 280:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1897 (insn, operands);

    case 281:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1898 (insn, operands);

    case 282:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1899 (insn, operands);

    case 283:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1900 (insn, operands);

    case 284:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1901 (insn, operands);

    case 285:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1902 (insn, operands);

    case 286:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1903 (insn, operands);

    case 287:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1904 (insn, operands);

    case 288:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1905 (insn, operands);

    case 289:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 290:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1907 (insn, operands);

    case 291:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1908 (insn, operands);

    case 292:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1909 (insn, operands);

    case 293:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1910 (insn, operands);

    case 294:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1911 (insn, operands);

    case 295:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1912 (insn, operands);

    case 296:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 297:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1914 (insn, operands);

    case 298:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1915 (insn, operands);

    case 299:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1916 (insn, operands);

    case 300:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1917 (insn, operands);

    case 301:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1918 (insn, operands);

    case 302:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1919 (insn, operands);

    case 303:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 304:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1921 (insn, operands);

    case 305:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1922 (insn, operands);

    case 306:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1923 (insn, operands);

    case 307:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1924 (insn, operands);

    case 308:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1925 (insn, operands);

    case 309:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1926 (insn, operands);

    case 310:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 311:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1928 (insn, operands);

    case 312:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1929 (insn, operands);

    case 313:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1930 (insn, operands);

    case 314:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1931 (insn, operands);

    case 315:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1932 (insn, operands);

    case 316:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1933 (insn, operands);

    case 317:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1934 (insn, operands);

    case 318:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1935 (insn, operands);

    case 319:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1936 (insn, operands);

    case 320:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 321:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1938 (insn, operands);

    case 322:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1939 (insn, operands);

    case 323:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1940 (insn, operands);

    case 324:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 325:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1942 (insn, operands);

    case 326:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1943 (insn, operands);

    case 327:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1944 (insn, operands);

    case 328:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    case 329:
      if (!((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1406 "../../gcc/config/riscv/vector.md"
( reload_completed)))
        return NULL;
      return gen_split_1946 (insn, operands);

    default:
      return NULL;
    }
}
