/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND
      || GET_MODE (x6) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x9 = XEXP (x6, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2)
      || !csr_operand (operands[3], i4)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x1) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[2], E_RVVM8HImode))
            return -1;
          return 0;

        case E_RVVM4QImode:
          if (!register_operand (operands[2], E_RVVM4QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 2;

        case E_RVVM2QImode:
          if (!register_operand (operands[2], E_RVVM2QImode))
            return -1;
          return 3;

        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 5;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 8;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 11;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 12;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 15;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x1) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 17;

        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 19;

        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 20;

        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 22;

        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 23;

        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 25;

        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 26;

        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 28;

        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 29;

        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x1) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 31;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x1) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[3], E_RVVM4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 33;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x1) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[3], E_RVVM2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 35;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x1) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[3], E_RVVM1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 39;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 40;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 43;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 45;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 46;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 48;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 49;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 51;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 52;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 54;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 55;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 57;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 58;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 60;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 61;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 63;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 64;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 65;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 66;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 67;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 68;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 69;

        case E_V1024QImode:
          if (!register_operand (operands[2], E_V1024QImode))
            return -1;
          return 70;

        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 71;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x1) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048BImode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2048HImode:
          if (!register_operand (operands[2], E_V2048HImode))
            return -1;
          return 72;

        case E_V2048QImode:
          if (!register_operand (operands[2], E_V2048QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 74;

        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 75;

        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 77;

        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 78;

        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 80;

        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 81;

        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 83;

        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 84;

        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 86;

        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 87;

        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 89;

        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 90;

        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 92;

        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 93;

        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 95;

        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 96;

        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 98;

        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 99;

        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 100;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 101;

        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 102;

        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x1) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 104;

        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x1) != E_V1DFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[3], E_V1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 106;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[3], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 108;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 109;

        default:
          return -1;
        }

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[3], E_V4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 110;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 111;

        default:
          return -1;
        }

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[3], E_V8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 112;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x1) != E_V16DFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[3], E_V16DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 114;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 115;

        default:
          return -1;
        }

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x1) != E_V32DFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[3], E_V32DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 116;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 117;

        default:
          return -1;
        }

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x1) != E_V64DFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[3], E_V64DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 118;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 119;

        default:
          return -1;
        }

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x1) != E_V128DFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[3], E_V128DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 120;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 121;

        default:
          return -1;
        }

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x1) != E_V256DFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[3], E_V256DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 122;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 123;

        default:
          return -1;
        }

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x1) != E_V512DFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[3], E_V512DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 124;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 125;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern287 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern286 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern286 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8SImode)
      || GET_MODE (x1) != E_RVVM8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || GET_MODE (x1) != E_RVVMF2SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1SImode)
      || GET_MODE (x1) != E_V1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1HImode:
      if (!register_operand (operands[1], E_V1HImode))
        return -1;
      return 0;

    case E_V1QImode:
      if (!register_operand (operands[1], E_V1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SImode)
      || GET_MODE (x1) != E_V32SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024SImode)
      || GET_MODE (x1) != E_V1024SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16DImode)
      || GET_MODE (x1) != E_V16DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x1) != E_HFmode
              || !register_operand (operands[1], E_HFmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_RVVM8HFmode:
              if (!register_operand (operands[2], E_RVVM8HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF2BImode))
                return -1;
              return 0;

            case E_RVVM4HFmode:
              if (!register_operand (operands[2], E_RVVM4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF4BImode))
                return -1;
              return 1;

            case E_RVVM2HFmode:
              if (!register_operand (operands[2], E_RVVM2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 2;

            case E_RVVM1HFmode:
              if (!register_operand (operands[2], E_RVVM1HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 3;

            case E_RVVMF2HFmode:
              if (!register_operand (operands[2], E_RVVMF2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 4;

            case E_RVVMF4HFmode:
              if (!register_operand (operands[2], E_RVVMF4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x1) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_RVVM8SFmode:
              if (!register_operand (operands[2], E_RVVM8SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF4BImode))
                return -1;
              return 6;

            case E_RVVM4SFmode:
              if (!register_operand (operands[2], E_RVVM4SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 7;

            case E_RVVM2SFmode:
              if (!register_operand (operands[2], E_RVVM2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 8;

            case E_RVVM1SFmode:
              if (!register_operand (operands[2], E_RVVM1SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 9;

            case E_RVVMF2SFmode:
              if (!register_operand (operands[2], E_RVVMF2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x1) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_RVVM8DFmode:
              if (!register_operand (operands[2], E_RVVM8DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 11;

            case E_RVVM4DFmode:
              if (!register_operand (operands[2], E_RVVM4DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 12;

            case E_RVVM2DFmode:
              if (!register_operand (operands[2], E_RVVM2DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 13;

            case E_RVVM1DFmode:
              if (!register_operand (operands[2], E_RVVM1DFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x1) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_RVVM8SFmode:
              if (!register_operand (operands[2], E_RVVM4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF4BImode))
                return -1;
              return 15;

            case E_RVVM4SFmode:
              if (!register_operand (operands[2], E_RVVM2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 16;

            case E_RVVM2SFmode:
              if (!register_operand (operands[2], E_RVVM1HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 17;

            case E_RVVM1SFmode:
              if (!register_operand (operands[2], E_RVVMF2HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 18;

            case E_RVVMF2SFmode:
              if (!register_operand (operands[2], E_RVVMF4HFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 19;

            case E_V1SFmode:
              if (!register_operand (operands[2], E_V1HFmode)
                  || !vector_mask_operand (operands[3], E_V1BImode))
                return -1;
              return 20;

            case E_V2SFmode:
              if (!register_operand (operands[2], E_V2HFmode)
                  || !vector_mask_operand (operands[3], E_V2BImode))
                return -1;
              return 21;

            case E_V4SFmode:
              if (!register_operand (operands[2], E_V4HFmode)
                  || !vector_mask_operand (operands[3], E_V4BImode))
                return -1;
              return 22;

            case E_V8SFmode:
              if (!register_operand (operands[2], E_V8HFmode)
                  || !vector_mask_operand (operands[3], E_V8BImode))
                return -1;
              return 23;

            case E_V16SFmode:
              if (!register_operand (operands[2], E_V16HFmode)
                  || !vector_mask_operand (operands[3], E_V16BImode))
                return -1;
              return 24;

            case E_V32SFmode:
              if (!register_operand (operands[2], E_V32HFmode)
                  || !vector_mask_operand (operands[3], E_V32BImode))
                return -1;
              return 25;

            case E_V64SFmode:
              if (!register_operand (operands[2], E_V64HFmode)
                  || !vector_mask_operand (operands[3], E_V64BImode))
                return -1;
              return 26;

            case E_V128SFmode:
              if (!register_operand (operands[2], E_V128HFmode)
                  || !vector_mask_operand (operands[3], E_V128BImode))
                return -1;
              return 27;

            case E_V256SFmode:
              if (!register_operand (operands[2], E_V256HFmode)
                  || !vector_mask_operand (operands[3], E_V256BImode))
                return -1;
              return 28;

            case E_V512SFmode:
              if (!register_operand (operands[2], E_V512HFmode)
                  || !vector_mask_operand (operands[3], E_V512BImode))
                return -1;
              return 29;

            case E_V1024SFmode:
              if (!register_operand (operands[2], E_V1024HFmode)
                  || !vector_mask_operand (operands[3], E_V1024BImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x1) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_RVVM8DFmode:
              if (!register_operand (operands[2], E_RVVM4SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF8BImode))
                return -1;
              return 31;

            case E_RVVM4DFmode:
              if (!register_operand (operands[2], E_RVVM2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF16BImode))
                return -1;
              return 32;

            case E_RVVM2DFmode:
              if (!register_operand (operands[2], E_RVVM1SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF32BImode))
                return -1;
              return 33;

            case E_RVVM1DFmode:
              if (!register_operand (operands[2], E_RVVMF2SFmode)
                  || !vector_mask_operand (operands[3], E_RVVMF64BImode))
                return -1;
              return 34;

            case E_V1DFmode:
              if (!register_operand (operands[2], E_V1SFmode)
                  || !vector_mask_operand (operands[3], E_V1BImode))
                return -1;
              return 35;

            case E_V2DFmode:
              if (!register_operand (operands[2], E_V2SFmode)
                  || !vector_mask_operand (operands[3], E_V2BImode))
                return -1;
              return 36;

            case E_V4DFmode:
              if (!register_operand (operands[2], E_V4SFmode)
                  || !vector_mask_operand (operands[3], E_V4BImode))
                return -1;
              return 37;

            case E_V8DFmode:
              if (!register_operand (operands[2], E_V8SFmode)
                  || !vector_mask_operand (operands[3], E_V8BImode))
                return -1;
              return 38;

            case E_V16DFmode:
              if (!register_operand (operands[2], E_V16SFmode)
                  || !vector_mask_operand (operands[3], E_V16BImode))
                return -1;
              return 39;

            case E_V32DFmode:
              if (!register_operand (operands[2], E_V32SFmode)
                  || !vector_mask_operand (operands[3], E_V32BImode))
                return -1;
              return 40;

            case E_V64DFmode:
              if (!register_operand (operands[2], E_V64SFmode)
                  || !vector_mask_operand (operands[3], E_V64BImode))
                return -1;
              return 41;

            case E_V128DFmode:
              if (!register_operand (operands[2], E_V128SFmode)
                  || !vector_mask_operand (operands[3], E_V128BImode))
                return -1;
              return 42;

            case E_V256DFmode:
              if (!register_operand (operands[2], E_V256SFmode)
                  || !vector_mask_operand (operands[3], E_V256BImode))
                return -1;
              return 43;

            case E_V512DFmode:
              if (!register_operand (operands[2], E_V512SFmode)
                  || !vector_mask_operand (operands[3], E_V512BImode))
                return -1;
              return 44;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern407 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  if (!vector_length_operand (x3, E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (!const_int_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (!const_int_operand (x6, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern420 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG)
    return -1;
  x36 = XVECEXP (x1, 0, 6);
  x37 = XEXP (x36, 1);
  if (GET_CODE (x37) != MEM)
    return -1;
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != PLUS)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != REG
      || REGNO (x39) != 2)
    return -1;
  x40 = XEXP (x38, 1);
  if (GET_CODE (x40) != CONST_INT)
    return -1;
  x41 = XEXP (x36, 0);
  if (GET_CODE (x41) != REG)
    return -1;
  x42 = XVECEXP (x1, 0, 7);
  x43 = XEXP (x42, 1);
  if (GET_CODE (x43) != MEM)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != PLUS)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_CODE (x45) != REG
      || REGNO (x45) != 2)
    return -1;
  x46 = XEXP (x44, 1);
  if (GET_CODE (x46) != CONST_INT)
    return -1;
  x47 = XEXP (x42, 0);
  if (GET_CODE (x47) != REG)
    return -1;
  return 0;
}

int
pattern448 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern460 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !scratch_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !scratch_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern466 (x1, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern466 (x1, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern466 (x1, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern466 (x1, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern466 (x1, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern466 (x1, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM8SImode
          || !vector_merge_operand (operands[1], E_RVVM8SImode)
          || !register_operand (operands[3], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[2], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4SImode
          || !vector_merge_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[3], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !vector_merge_operand (operands[1], E_RVVM2SImode)
          || !register_operand (operands[3], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1SImode
          || !vector_merge_operand (operands[1], E_RVVM1SImode)
          || !register_operand (operands[3], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2SImode
          || !vector_merge_operand (operands[1], E_RVVMF2SImode)
          || !register_operand (operands[3], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM8DImode
          || !vector_merge_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[3], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !vector_merge_operand (operands[1], E_RVVM4DImode)
          || !register_operand (operands[3], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2DImode
          || !vector_merge_operand (operands[1], E_RVVM2DImode)
          || !register_operand (operands[3], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1DImode
          || !vector_merge_operand (operands[1], E_RVVM1DImode)
          || !register_operand (operands[3], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern466 (x1, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern466 (x1, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern466 (x1, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern466 (x1, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern466 (x1, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern466 (x1, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern466 (x1, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern466 (x1, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern466 (x1, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern466 (x1, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern466 (x1, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern466 (x1, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1SImode
          || !vector_merge_operand (operands[1], E_V1SImode)
          || !register_operand (operands[3], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V2SImode
          || !vector_merge_operand (operands[1], E_V2SImode)
          || !register_operand (operands[3], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V4SImode
          || !vector_merge_operand (operands[1], E_V4SImode)
          || !register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V8SImode
          || !vector_merge_operand (operands[1], E_V8SImode)
          || !register_operand (operands[3], E_V8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V16SImode
          || !vector_merge_operand (operands[1], E_V16SImode)
          || !register_operand (operands[3], E_V16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V32SImode
          || !vector_merge_operand (operands[1], E_V32SImode)
          || !register_operand (operands[3], E_V32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V64SImode
          || !vector_merge_operand (operands[1], E_V64SImode)
          || !register_operand (operands[3], E_V64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V128SImode
          || !vector_merge_operand (operands[1], E_V128SImode)
          || !register_operand (operands[3], E_V128BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V256SImode
          || !vector_merge_operand (operands[1], E_V256SImode)
          || !register_operand (operands[3], E_V256BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512SImode
          || !vector_merge_operand (operands[1], E_V512SImode)
          || !register_operand (operands[3], E_V512BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1024SImode
          || !vector_merge_operand (operands[1], E_V1024SImode)
          || !register_operand (operands[3], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[2], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V1DImode
          || !vector_merge_operand (operands[1], E_V1DImode)
          || !register_operand (operands[3], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V2DImode
          || !vector_merge_operand (operands[1], E_V2DImode)
          || !register_operand (operands[3], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V4DImode
          || !vector_merge_operand (operands[1], E_V4DImode)
          || !register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V8DImode
          || !vector_merge_operand (operands[1], E_V8DImode)
          || !register_operand (operands[3], E_V8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V16DImode
          || !vector_merge_operand (operands[1], E_V16DImode)
          || !register_operand (operands[3], E_V16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V32DImode
          || !vector_merge_operand (operands[1], E_V32DImode)
          || !register_operand (operands[3], E_V32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V64DImode
          || !vector_merge_operand (operands[1], E_V64DImode)
          || !register_operand (operands[3], E_V64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V128DImode
          || !vector_merge_operand (operands[1], E_V128DImode)
          || !register_operand (operands[3], E_V128BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V256DImode
          || !vector_merge_operand (operands[1], E_V256DImode)
          || !register_operand (operands[3], E_V256BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512DImode
          || !vector_merge_operand (operands[1], E_V512DImode)
          || !register_operand (operands[3], E_V512BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern543 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x8, 1);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      return pattern542 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM2QImode:
      if (pattern542 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (pattern542 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (pattern542 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (pattern542 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (pattern542 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (pattern542 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (pattern542 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (pattern542 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (pattern542 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (pattern542 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern542 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern542 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern542 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (pattern542 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1QImode:
      if (pattern542 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2QImode:
      if (pattern542 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4QImode:
      if (pattern542 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8QImode:
      if (pattern542 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16QImode:
      if (pattern542 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32QImode:
      if (pattern542 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64QImode:
      if (pattern542 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128QImode:
      if (pattern542 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256QImode:
      if (pattern542 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512QImode:
      if (pattern542 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024QImode:
      if (pattern542 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048QImode:
      if (pattern542 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1HImode:
      if (pattern542 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2HImode:
      if (pattern542 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4HImode:
      if (pattern542 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8HImode:
      if (pattern542 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16HImode:
      if (pattern542 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32HImode:
      if (pattern542 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64HImode:
      if (pattern542 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128HImode:
      if (pattern542 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256HImode:
      if (pattern542 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512HImode:
      if (pattern542 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024HImode:
      if (pattern542 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1SImode:
      if (pattern542 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2SImode:
      if (pattern542 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4SImode:
      if (pattern542 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8SImode:
      if (pattern542 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16SImode:
      if (pattern542 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32SImode:
      if (pattern542 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64SImode:
      if (pattern542 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128SImode:
      if (pattern542 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256SImode:
      if (pattern542 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512SImode:
      if (pattern542 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern560 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], E_SFmode))
    return -1;
  x9 = XVECEXP (x7, 0, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM2QImode:
      return pattern559 (x1, 
E_RVVM2QImode, 
E_RVVM8SFmode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM1QImode:
      if (pattern559 (x1, 
E_RVVM1QImode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (pattern559 (x1, 
E_RVVMF2QImode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (pattern559 (x1, 
E_RVVMF4QImode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF8QImode:
      if (pattern559 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern563 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[6] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[7] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[8] = x8;
  x9 = XEXP (x2, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern492 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern492 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern492 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern492 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern492 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern492 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern492 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern492 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern492 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern492 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern492 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern492 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern492 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern492 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern492 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern492 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern492 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern492 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern492 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern492 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern492 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern492 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern492 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern492 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern492 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern492 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern492 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern492 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern492 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern492 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern492 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern492 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern492 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern492 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern492 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern492 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern492 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern492 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern492 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern492 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern492 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern492 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern492 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern492 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern492 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern492 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern492 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern492 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern583 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i4))
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern591 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  return pattern467 (x1); /* [-1, 91] */
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_arith_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern597 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_broadcast_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !direct_broadcast_operand (operands[3], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern601 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern538 (x1, 
E_RVVM8QImode, 
E_QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern538 (x1, 
E_RVVM4QImode, 
E_QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern538 (x1, 
E_RVVM2QImode, 
E_QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern538 (x1, 
E_RVVM1QImode, 
E_QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2QImode:
          if (pattern538 (x1, 
E_RVVMF2QImode, 
E_QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4QImode:
          if (pattern538 (x1, 
E_RVVMF4QImode, 
E_QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 5;

        case E_RVVMF8QImode:
          if (pattern538 (x1, 
E_RVVMF8QImode, 
E_QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 6;

        case E_RVVM8HImode:
          if (pattern538 (x1, 
E_RVVM8HImode, 
E_HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 7;

        case E_RVVM4HImode:
          if (pattern538 (x1, 
E_RVVM4HImode, 
E_HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM2HImode:
          if (pattern538 (x1, 
E_RVVM2HImode, 
E_HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM1HImode:
          if (pattern538 (x1, 
E_RVVM1HImode, 
E_HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVMF2HImode:
          if (pattern538 (x1, 
E_RVVMF2HImode, 
E_HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVMF4HImode:
          if (pattern538 (x1, 
E_RVVMF4HImode, 
E_HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 12;

        case E_RVVM8SImode:
          if (pattern538 (x1, 
E_RVVM8SImode, 
E_SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 13;

        case E_RVVM4SImode:
          if (pattern538 (x1, 
E_RVVM4SImode, 
E_SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 14;

        case E_RVVM2SImode:
          if (pattern538 (x1, 
E_RVVM2SImode, 
E_SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 15;

        case E_RVVM1SImode:
          if (pattern538 (x1, 
E_RVVM1SImode, 
E_SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF2SImode:
          if (pattern538 (x1, 
E_RVVMF2SImode, 
E_SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 17;

        case E_V1QImode:
          if (pattern538 (x1, 
E_V1QImode, 
E_QImode, 
E_V1BImode) != 0)
            return -1;
          return 18;

        case E_V2QImode:
          if (pattern538 (x1, 
E_V2QImode, 
E_QImode, 
E_V2BImode) != 0)
            return -1;
          return 19;

        case E_V4QImode:
          if (pattern538 (x1, 
E_V4QImode, 
E_QImode, 
E_V4BImode) != 0)
            return -1;
          return 20;

        case E_V8QImode:
          if (pattern538 (x1, 
E_V8QImode, 
E_QImode, 
E_V8BImode) != 0)
            return -1;
          return 21;

        case E_V16QImode:
          if (pattern538 (x1, 
E_V16QImode, 
E_QImode, 
E_V16BImode) != 0)
            return -1;
          return 22;

        case E_V32QImode:
          if (pattern538 (x1, 
E_V32QImode, 
E_QImode, 
E_V32BImode) != 0)
            return -1;
          return 23;

        case E_V64QImode:
          if (pattern538 (x1, 
E_V64QImode, 
E_QImode, 
E_V64BImode) != 0)
            return -1;
          return 24;

        case E_V128QImode:
          if (pattern538 (x1, 
E_V128QImode, 
E_QImode, 
E_V128BImode) != 0)
            return -1;
          return 25;

        case E_V256QImode:
          if (pattern538 (x1, 
E_V256QImode, 
E_QImode, 
E_V256BImode) != 0)
            return -1;
          return 26;

        case E_V512QImode:
          if (pattern538 (x1, 
E_V512QImode, 
E_QImode, 
E_V512BImode) != 0)
            return -1;
          return 27;

        case E_V1024QImode:
          if (pattern538 (x1, 
E_V1024QImode, 
E_QImode, 
E_V1024BImode) != 0)
            return -1;
          return 28;

        case E_V2048QImode:
          if (pattern538 (x1, 
E_V2048QImode, 
E_QImode, 
E_V2048BImode) != 0)
            return -1;
          return 29;

        case E_V4096QImode:
          if (pattern538 (x1, 
E_V4096QImode, 
E_QImode, 
E_V4096BImode) != 0)
            return -1;
          return 30;

        case E_V1HImode:
          if (pattern538 (x1, 
E_V1HImode, 
E_HImode, 
E_V1BImode) != 0)
            return -1;
          return 31;

        case E_V2HImode:
          if (pattern538 (x1, 
E_V2HImode, 
E_HImode, 
E_V2BImode) != 0)
            return -1;
          return 32;

        case E_V4HImode:
          if (pattern538 (x1, 
E_V4HImode, 
E_HImode, 
E_V4BImode) != 0)
            return -1;
          return 33;

        case E_V8HImode:
          if (pattern538 (x1, 
E_V8HImode, 
E_HImode, 
E_V8BImode) != 0)
            return -1;
          return 34;

        case E_V16HImode:
          if (pattern538 (x1, 
E_V16HImode, 
E_HImode, 
E_V16BImode) != 0)
            return -1;
          return 35;

        case E_V32HImode:
          if (pattern538 (x1, 
E_V32HImode, 
E_HImode, 
E_V32BImode) != 0)
            return -1;
          return 36;

        case E_V64HImode:
          if (pattern538 (x1, 
E_V64HImode, 
E_HImode, 
E_V64BImode) != 0)
            return -1;
          return 37;

        case E_V128HImode:
          if (pattern538 (x1, 
E_V128HImode, 
E_HImode, 
E_V128BImode) != 0)
            return -1;
          return 38;

        case E_V256HImode:
          if (pattern538 (x1, 
E_V256HImode, 
E_HImode, 
E_V256BImode) != 0)
            return -1;
          return 39;

        case E_V512HImode:
          if (pattern538 (x1, 
E_V512HImode, 
E_HImode, 
E_V512BImode) != 0)
            return -1;
          return 40;

        case E_V1024HImode:
          if (pattern538 (x1, 
E_V1024HImode, 
E_HImode, 
E_V1024BImode) != 0)
            return -1;
          return 41;

        case E_V2048HImode:
          if (pattern538 (x1, 
E_V2048HImode, 
E_HImode, 
E_V2048BImode) != 0)
            return -1;
          return 42;

        case E_V1SImode:
          if (pattern538 (x1, 
E_V1SImode, 
E_SImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2SImode:
          if (pattern538 (x1, 
E_V2SImode, 
E_SImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4SImode:
          if (pattern538 (x1, 
E_V4SImode, 
E_SImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8SImode:
          if (pattern538 (x1, 
E_V8SImode, 
E_SImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16SImode:
          if (pattern538 (x1, 
E_V16SImode, 
E_SImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32SImode:
          if (pattern538 (x1, 
E_V32SImode, 
E_SImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64SImode:
          if (pattern538 (x1, 
E_V64SImode, 
E_SImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128SImode:
          if (pattern538 (x1, 
E_V128SImode, 
E_SImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256SImode:
          if (pattern538 (x1, 
E_V256SImode, 
E_SImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512SImode:
          if (pattern538 (x1, 
E_V512SImode, 
E_SImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024SImode:
          if (pattern538 (x1, 
E_V1024SImode, 
E_SImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_RVVM8DImode:
          if (pattern496 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
            return -1;
          return 54;

        case E_RVVM4DImode:
          if (pattern496 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
            return -1;
          return 55;

        case E_RVVM2DImode:
          if (pattern496 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
            return -1;
          return 56;

        case E_RVVM1DImode:
          if (pattern496 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
            return -1;
          return 57;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern498 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 58;

        case E_RVVM4DImode:
          if (pattern498 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 59;

        case E_RVVM2DImode:
          if (pattern498 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 60;

        case E_RVVM1DImode:
          if (pattern498 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 61;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode)
          || !register_operand (operands[2], E_RVVM1DImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode)
          || !register_operand (operands[2], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode)
          || !register_operand (operands[2], E_RVVMF4HImode))
        return -1;
      return 2;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode)
          || !register_operand (operands[2], E_RVVMF2SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern643 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF2BImode
      || !vector_mask_operand (operands[1], E_RVVMF2BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[4], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[4], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF2BImode
      || !vector_mask_operand (operands[1], E_RVVMF2BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8HImode:
      if (!register_operand (operands[4], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM4QImode:
      if (!register_operand (operands[4], E_RVVM4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern661 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF16BImode
      || !vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4DImode:
      if (!register_operand (operands[4], E_RVVM4DImode))
        return -1;
      return 0;

    case E_RVVM2SImode:
      if (!register_operand (operands[4], E_RVVM2SImode))
        return -1;
      return 1;

    case E_RVVM1HImode:
      if (!register_operand (operands[4], E_RVVM1HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[4], E_RVVMF2QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern668 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern673 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVM1BImode:
      if (!vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[3], E_RVVM8QImode))
        return -1;
      return 0;

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM4QImode))
        return -1;
      return 1;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM2QImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM1QImode))
        return -1;
      return 3;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      return 4;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      return 5;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      return 6;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1QImode))
        return -1;
      return 7;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2QImode))
        return -1;
      return 8;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4QImode))
        return -1;
      return 9;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8QImode))
        return -1;
      return 10;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      return 11;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      return 12;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64QImode))
        return -1;
      return 13;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128QImode))
        return -1;
      return 14;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256QImode))
        return -1;
      return 15;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512QImode))
        return -1;
      return 16;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024QImode))
        return -1;
      return 17;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048QImode))
        return -1;
      return 18;

    case E_V4096BImode:
      if (!vector_mask_operand (operands[1], E_V4096BImode)
          || !register_operand (operands[3], E_V4096QImode))
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern685 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern692 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern702 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[9] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  x10 = XEXP (x8, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], i1))
    return -1;
  x11 = XEXP (x1, 2);
  operands[2] = x11;
  if (!vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern706 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[2], i3)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew32_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern718 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern599 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern599 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern599 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern599 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern599 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern599 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern599 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern599 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern599 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern599 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern599 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern599 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern599 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern599 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern599 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern599 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern599 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern599 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern599 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern599 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern599 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern599 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_V1QImode:
          if (pattern599 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 22;

        case E_V2QImode:
          if (pattern599 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 23;

        case E_V4QImode:
          if (pattern599 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 24;

        case E_V8QImode:
          if (pattern599 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 25;

        case E_V16QImode:
          if (pattern599 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 26;

        case E_V32QImode:
          if (pattern599 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 27;

        case E_V64QImode:
          if (pattern599 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 28;

        case E_V128QImode:
          if (pattern599 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 29;

        case E_V256QImode:
          if (pattern599 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 30;

        case E_V512QImode:
          if (pattern599 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 31;

        case E_V1024QImode:
          if (pattern599 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 32;

        case E_V2048QImode:
          if (pattern599 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 33;

        case E_V4096QImode:
          if (pattern599 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 34;

        case E_V1HImode:
          if (pattern599 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 35;

        case E_V2HImode:
          if (pattern599 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 36;

        case E_V4HImode:
          if (pattern599 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 37;

        case E_V8HImode:
          if (pattern599 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 38;

        case E_V16HImode:
          if (pattern599 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 39;

        case E_V32HImode:
          if (pattern599 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 40;

        case E_V64HImode:
          if (pattern599 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 41;

        case E_V128HImode:
          if (pattern599 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 42;

        case E_V256HImode:
          if (pattern599 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 43;

        case E_V512HImode:
          if (pattern599 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 44;

        case E_V1024HImode:
          if (pattern599 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 45;

        case E_V2048HImode:
          if (pattern599 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 46;

        case E_V1SImode:
          if (pattern599 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 47;

        case E_V2SImode:
          if (pattern599 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 48;

        case E_V4SImode:
          if (pattern599 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 49;

        case E_V8SImode:
          if (pattern599 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 50;

        case E_V16SImode:
          if (pattern599 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 51;

        case E_V32SImode:
          if (pattern599 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 52;

        case E_V64SImode:
          if (pattern599 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 53;

        case E_V128SImode:
          if (pattern599 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 54;

        case E_V256SImode:
          if (pattern599 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 55;

        case E_V512SImode:
          if (pattern599 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 56;

        case E_V1024SImode:
          if (pattern599 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 57;

        case E_V1DImode:
          if (pattern550 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 58;

        case E_V2DImode:
          if (pattern550 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 59;

        case E_V4DImode:
          if (pattern550 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 60;

        case E_V8DImode:
          if (pattern550 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 61;

        case E_V16DImode:
          if (pattern550 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 62;

        case E_V32DImode:
          if (pattern550 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 63;

        case E_V64DImode:
          if (pattern550 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 64;

        case E_V128DImode:
          if (pattern550 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 65;

        case E_V256DImode:
          if (pattern550 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 66;

        case E_V512DImode:
          if (pattern550 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 67;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[4] = x4;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern599 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 68;

        case E_RVVM4DImode:
          if (pattern599 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 69;

        case E_RVVM2DImode:
          if (pattern599 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 70;

        case E_RVVM1DImode:
          if (pattern599 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 71;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern742 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern748 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern750 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1
      || !stack_pop_up_to_s6_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern754 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  return 0;
}

int
pattern759 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x8) != SET
      || pattern758 (x8, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern762 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern772 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      x38 = XVECEXP (x1, 0, 9);
      x39 = XEXP (x38, 0);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -40L)
        return -1;
      x42 = XVECEXP (x1, 0, 10);
      x43 = XEXP (x42, 0);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -44L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      x38 = XVECEXP (x1, 0, 9);
      x39 = XEXP (x38, 0);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -80L)
        return -1;
      x42 = XVECEXP (x1, 0, 10);
      x43 = XEXP (x42, 0);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -88L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -80L)
    return -1;
  x6 = XEXP (x1, 0);
  return pattern786 (x6, 
E_DImode); /* [-1, 0] */
}

int
pattern793 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != PLUS
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 2
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (GET_CODE (x14) != CONST_INT
      || XWINT (x14, 0) != -80L)
    return -1;
  x15 = XEXP (x10, 0);
  if (REGNO (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 11);
  return pattern792 (x16); /* [-1, 0] */
}

int
pattern799 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -96L)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (arith_operand (operands[2], E_SImode))
    return 4; /* *addsi3 */
  if (!const_two_s12 (operands[2], E_SImode)
      || !(
#line 734 "../../gcc/config/riscv/riscv.md"
(!riscv_reg_frame_related (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    return -1;
  return 6; /* *addsi3_const_sum_of_two_s12 */
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern231 (x2))
    {
    case 0:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30258; /* *dual_widen_fmaurvvm8hi */

    case 1:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30260; /* *dual_widen_fmaurvvm4hi */

    case 2:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30262; /* *dual_widen_fmaurvvm2hi */

    case 3:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30264; /* *dual_widen_fmaurvvm1hi */

    case 4:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30266; /* *dual_widen_fmaurvvmf2hi */

    case 5:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30268; /* *dual_widen_fmaurvvmf4hi */

    case 6:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30270; /* *dual_widen_fmaurvvm8si */

    case 7:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30272; /* *dual_widen_fmaurvvm4si */

    case 8:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30274; /* *dual_widen_fmaurvvm2si */

    case 9:
      if (!
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30276; /* *dual_widen_fmaurvvm1si */

    case 10:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30278; /* *dual_widen_fmaurvvmf2si */

    case 11:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30280; /* *dual_widen_fmaurvvm8di */

    case 12:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30282; /* *dual_widen_fmaurvvm4di */

    case 13:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30284; /* *dual_widen_fmaurvvm2di */

    case 14:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30286; /* *dual_widen_fmaurvvm1di */

    case 15:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30288; /* *dual_widen_fmauv1hi */

    case 16:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30290; /* *dual_widen_fmauv2hi */

    case 17:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30292; /* *dual_widen_fmauv4hi */

    case 18:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30294; /* *dual_widen_fmauv8hi */

    case 19:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30296; /* *dual_widen_fmauv16hi */

    case 20:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30298; /* *dual_widen_fmauv32hi */

    case 21:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30300; /* *dual_widen_fmauv64hi */

    case 22:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30302; /* *dual_widen_fmauv128hi */

    case 23:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30304; /* *dual_widen_fmauv256hi */

    case 24:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30306; /* *dual_widen_fmauv512hi */

    case 25:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30308; /* *dual_widen_fmauv1024hi */

    case 26:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30310; /* *dual_widen_fmauv2048hi */

    case 27:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30312; /* *dual_widen_fmauv1si */

    case 28:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30314; /* *dual_widen_fmauv2si */

    case 29:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30316; /* *dual_widen_fmauv4si */

    case 30:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30318; /* *dual_widen_fmauv8si */

    case 31:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30320; /* *dual_widen_fmauv16si */

    case 32:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30322; /* *dual_widen_fmauv32si */

    case 33:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30324; /* *dual_widen_fmauv64si */

    case 34:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30326; /* *dual_widen_fmauv128si */

    case 35:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30328; /* *dual_widen_fmauv256si */

    case 36:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30330; /* *dual_widen_fmauv512si */

    case 37:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30332; /* *dual_widen_fmauv1024si */

    case 38:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30334; /* *dual_widen_fmauv1di */

    case 39:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30336; /* *dual_widen_fmauv2di */

    case 40:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30338; /* *dual_widen_fmauv4di */

    case 41:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30340; /* *dual_widen_fmauv8di */

    case 42:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30342; /* *dual_widen_fmauv16di */

    case 43:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30344; /* *dual_widen_fmauv32di */

    case 44:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30346; /* *dual_widen_fmauv64di */

    case 45:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30348; /* *dual_widen_fmauv128di */

    case 46:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30350; /* *dual_widen_fmauv256di */

    case 47:
      if (!(
#line 903 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30352; /* *dual_widen_fmauv512di */

    case 48:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30401; /* *dual_widen_fmausrvvm8hi */

    case 49:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30402; /* *dual_widen_fmausrvvm4hi */

    case 50:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30403; /* *dual_widen_fmausrvvm2hi */

    case 51:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30404; /* *dual_widen_fmausrvvm1hi */

    case 52:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30405; /* *dual_widen_fmausrvvmf2hi */

    case 53:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30406; /* *dual_widen_fmausrvvmf4hi */

    case 54:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30407; /* *dual_widen_fmausrvvm8si */

    case 55:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30408; /* *dual_widen_fmausrvvm4si */

    case 56:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30409; /* *dual_widen_fmausrvvm2si */

    case 57:
      if (!
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30410; /* *dual_widen_fmausrvvm1si */

    case 58:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30411; /* *dual_widen_fmausrvvmf2si */

    case 59:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30412; /* *dual_widen_fmausrvvm8di */

    case 60:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30413; /* *dual_widen_fmausrvvm4di */

    case 61:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30414; /* *dual_widen_fmausrvvm2di */

    case 62:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30415; /* *dual_widen_fmausrvvm1di */

    case 63:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30416; /* *dual_widen_fmausv1hi */

    case 64:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30417; /* *dual_widen_fmausv2hi */

    case 65:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30418; /* *dual_widen_fmausv4hi */

    case 66:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30419; /* *dual_widen_fmausv8hi */

    case 67:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30420; /* *dual_widen_fmausv16hi */

    case 68:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30421; /* *dual_widen_fmausv32hi */

    case 69:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30422; /* *dual_widen_fmausv64hi */

    case 70:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30423; /* *dual_widen_fmausv128hi */

    case 71:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30424; /* *dual_widen_fmausv256hi */

    case 72:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30425; /* *dual_widen_fmausv512hi */

    case 73:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30426; /* *dual_widen_fmausv1024hi */

    case 74:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30427; /* *dual_widen_fmausv2048hi */

    case 75:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30428; /* *dual_widen_fmausv1si */

    case 76:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30429; /* *dual_widen_fmausv2si */

    case 77:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30430; /* *dual_widen_fmausv4si */

    case 78:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30431; /* *dual_widen_fmausv8si */

    case 79:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30432; /* *dual_widen_fmausv16si */

    case 80:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30433; /* *dual_widen_fmausv32si */

    case 81:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30434; /* *dual_widen_fmausv64si */

    case 82:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30435; /* *dual_widen_fmausv128si */

    case 83:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30436; /* *dual_widen_fmausv256si */

    case 84:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30437; /* *dual_widen_fmausv512si */

    case 85:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30438; /* *dual_widen_fmausv1024si */

    case 86:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30439; /* *dual_widen_fmausv1di */

    case 87:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30440; /* *dual_widen_fmausv2di */

    case 88:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30441; /* *dual_widen_fmausv4di */

    case 89:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30442; /* *dual_widen_fmausv8di */

    case 90:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30443; /* *dual_widen_fmausv16di */

    case 91:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30444; /* *dual_widen_fmausv32di */

    case 92:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30445; /* *dual_widen_fmausv64di */

    case 93:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30446; /* *dual_widen_fmausv128di */

    case 94:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30447; /* *dual_widen_fmausv256di */

    case 95:
      if (!(
#line 947 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30448; /* *dual_widen_fmausv512di */

    case 96:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30450; /* *single_widen_fmaurvvm8hi */

    case 97:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30452; /* *single_widen_fmaurvvm4hi */

    case 98:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30454; /* *single_widen_fmaurvvm2hi */

    case 99:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30456; /* *single_widen_fmaurvvm1hi */

    case 100:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30458; /* *single_widen_fmaurvvmf2hi */

    case 101:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30460; /* *single_widen_fmaurvvmf4hi */

    case 102:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30462; /* *single_widen_fmaurvvm8si */

    case 103:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30464; /* *single_widen_fmaurvvm4si */

    case 104:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30466; /* *single_widen_fmaurvvm2si */

    case 105:
      if (!
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30468; /* *single_widen_fmaurvvm1si */

    case 106:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30470; /* *single_widen_fmaurvvmf2si */

    case 107:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30472; /* *single_widen_fmaurvvm8di */

    case 108:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30474; /* *single_widen_fmaurvvm4di */

    case 109:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30476; /* *single_widen_fmaurvvm2di */

    case 110:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30478; /* *single_widen_fmaurvvm1di */

    case 111:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30480; /* *single_widen_fmauv1hi */

    case 112:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30482; /* *single_widen_fmauv2hi */

    case 113:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30484; /* *single_widen_fmauv4hi */

    case 114:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30486; /* *single_widen_fmauv8hi */

    case 115:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30488; /* *single_widen_fmauv16hi */

    case 116:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30490; /* *single_widen_fmauv32hi */

    case 117:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30492; /* *single_widen_fmauv64hi */

    case 118:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30494; /* *single_widen_fmauv128hi */

    case 119:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30496; /* *single_widen_fmauv256hi */

    case 120:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30498; /* *single_widen_fmauv512hi */

    case 121:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30500; /* *single_widen_fmauv1024hi */

    case 122:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30502; /* *single_widen_fmauv2048hi */

    case 123:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30504; /* *single_widen_fmauv1si */

    case 124:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30506; /* *single_widen_fmauv2si */

    case 125:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30508; /* *single_widen_fmauv4si */

    case 126:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30510; /* *single_widen_fmauv8si */

    case 127:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30512; /* *single_widen_fmauv16si */

    case 128:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30514; /* *single_widen_fmauv32si */

    case 129:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30516; /* *single_widen_fmauv64si */

    case 130:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30518; /* *single_widen_fmauv128si */

    case 131:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30520; /* *single_widen_fmauv256si */

    case 132:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30522; /* *single_widen_fmauv512si */

    case 133:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30524; /* *single_widen_fmauv1024si */

    case 134:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30526; /* *single_widen_fmauv1di */

    case 135:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30528; /* *single_widen_fmauv2di */

    case 136:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30530; /* *single_widen_fmauv4di */

    case 137:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30532; /* *single_widen_fmauv8di */

    case 138:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30534; /* *single_widen_fmauv16di */

    case 139:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30536; /* *single_widen_fmauv32di */

    case 140:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30538; /* *single_widen_fmauv64di */

    case 141:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30540; /* *single_widen_fmauv128di */

    case 142:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30542; /* *single_widen_fmauv256di */

    case 143:
      if (!(
#line 971 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30544; /* *single_widen_fmauv512di */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1106 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 23; /* mulsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1106 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 24; /* muldf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1106 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 25; /* mulhf3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1115 "../../gcc/config/riscv/riscv.md"
(TARGET_ZMMUL || TARGET_MUL))
        return -1;
      return 26; /* *mulsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1142 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 27; /* muldi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23623; /* mulrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23637; /* mulrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23651; /* mulrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23665; /* mulrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23679; /* mulrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23693; /* mulrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23707; /* mulrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23721; /* mulrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23735; /* mulrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23749; /* mulrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23763; /* mulrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23777; /* mulrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23791; /* mulrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23805; /* mulrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23819; /* mulrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23833; /* mulrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23847; /* mulrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23861; /* mulrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23875; /* mulrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23889; /* mulrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23903; /* mulrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23917; /* mulrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23931; /* mulv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23945; /* mulv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23959; /* mulv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23973; /* mulv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23987; /* mulv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24001; /* mulv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24015; /* mulv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24029; /* mulv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24043; /* mulv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24057; /* mulv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24071; /* mulv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24085; /* mulv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24099; /* mulv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24113; /* mulv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24127; /* mulv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24141; /* mulv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24155; /* mulv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24169; /* mulv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24183; /* mulv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24197; /* mulv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24211; /* mulv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24225; /* mulv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24239; /* mulv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24253; /* mulv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24267; /* mulv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24281; /* mulv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24295; /* mulv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24309; /* mulv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24323; /* mulv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24337; /* mulv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24351; /* mulv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24365; /* mulv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24379; /* mulv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24393; /* mulv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24407; /* mulv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24421; /* mulv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24435; /* mulv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24449; /* mulv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24463; /* mulv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24477; /* mulv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24491; /* mulv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24505; /* mulv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24519; /* mulv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24533; /* mulv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24547; /* mulv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24561; /* mulv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26581; /* mulrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26585; /* mulrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26589; /* mulrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26593; /* mulrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26597; /* mulrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26601; /* mulrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26605; /* mulrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26609; /* mulrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26613; /* mulrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26617; /* mulrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26621; /* mulrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26625; /* mulrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26629; /* mulrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26633; /* mulrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26637; /* mulrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26641; /* mulv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26645; /* mulv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26649; /* mulv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26653; /* mulv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26657; /* mulv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26661; /* mulv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26665; /* mulv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26669; /* mulv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26673; /* mulv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26677; /* mulv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26681; /* mulv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26685; /* mulv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26689; /* mulv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26693; /* mulv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26697; /* mulv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26701; /* mulv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26705; /* mulv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26709; /* mulv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26713; /* mulv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26717; /* mulv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26721; /* mulv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26725; /* mulv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26729; /* mulv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26733; /* mulv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26737; /* mulv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26741; /* mulv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26745; /* mulv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26749; /* mulv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26753; /* mulv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26757; /* mulv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26761; /* mulv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26765; /* mulv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26769; /* mulv512df3 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2424; /* *pred_th_extractrvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2425; /* *pred_th_extractrvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2426; /* *pred_th_extractrvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2427; /* *pred_th_extractrvvm1qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2440; /* *pred_th_extractrvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 2443; /* *pred_th_extractv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 2444; /* *pred_th_extractv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 2445; /* *pred_th_extractv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 2446; /* *pred_th_extractv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 2447; /* *pred_th_extractv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 2448; /* *pred_th_extractv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2449; /* *pred_th_extractv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2450; /* *pred_th_extractv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2451; /* *pred_th_extractv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2452; /* *pred_th_extractv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2453; /* *pred_th_extractv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2454; /* *pred_th_extractv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2455; /* *pred_th_extractv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2428; /* *pred_th_extractrvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2429; /* *pred_th_extractrvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2430; /* *pred_th_extractrvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2431; /* *pred_th_extractrvvm1hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2441; /* *pred_th_extractrvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 2456; /* *pred_th_extractv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 2457; /* *pred_th_extractv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 2458; /* *pred_th_extractv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 2459; /* *pred_th_extractv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 2460; /* *pred_th_extractv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2461; /* *pred_th_extractv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2462; /* *pred_th_extractv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2463; /* *pred_th_extractv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2464; /* *pred_th_extractv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2465; /* *pred_th_extractv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2466; /* *pred_th_extractv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2467; /* *pred_th_extractv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern442 (x2))
            {
            case 0:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2432; /* *pred_th_extractrvvm8si */

            case 1:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2433; /* *pred_th_extractrvvm4si */

            case 2:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2434; /* *pred_th_extractrvvm2si */

            case 3:
              if (!
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2435; /* *pred_th_extractrvvm1si */

            case 4:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2442; /* *pred_th_extractrvvmf2si */

            case 5:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 2468; /* *pred_th_extractv1si */

            case 6:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 2469; /* *pred_th_extractv2si */

            case 7:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 2470; /* *pred_th_extractv4si */

            case 8:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 2471; /* *pred_th_extractv8si */

            case 9:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2472; /* *pred_th_extractv16si */

            case 10:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2473; /* *pred_th_extractv32si */

            case 11:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2474; /* *pred_th_extractv64si */

            case 12:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2475; /* *pred_th_extractv128si */

            case 13:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2476; /* *pred_th_extractv256si */

            case 14:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2477; /* *pred_th_extractv512si */

            case 15:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2478; /* *pred_th_extractv1024si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern443 (x2))
            {
            case 0:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2436; /* *pred_th_extractrvvm8di */

            case 1:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2437; /* *pred_th_extractrvvm4di */

            case 2:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2438; /* *pred_th_extractrvvm2di */

            case 3:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2439; /* *pred_th_extractrvvm1di */

            case 4:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2479; /* *pred_th_extractv1di */

            case 5:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2480; /* *pred_th_extractv2di */

            case 6:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2481; /* *pred_th_extractv4di */

            case 7:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2482; /* *pred_th_extractv8di */

            case 8:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2483; /* *pred_th_extractv16di */

            case 9:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2484; /* *pred_th_extractv32di */

            case 10:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2485; /* *pred_th_extractv64di */

            case 11:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2486; /* *pred_th_extractv128di */

            case 12:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2487; /* *pred_th_extractv256di */

            case 13:
              if (!(
#line 349 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2488; /* *pred_th_extractv512di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3571 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3571 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3571 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3571 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3571 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3571 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern585 (x2, 
E_RVVMF16BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 3495 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8678; /* pred_madcrvvmf2qi_scalar */

    case E_RVVM1HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 3495 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8684; /* pred_madcrvvm1hi_scalar */

    case E_RVVM2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 3495 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8689; /* pred_madcrvvm2si_scalar */

    case E_RVVM4DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 3566 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8783; /* *pred_madcrvvm4di_scalar */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18114; /* pred_redminrvvm8qi */

        case 1:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18122; /* pred_redminrvvm4qi */

        case 2:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18130; /* pred_redminrvvm2qi */

        case 3:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18138; /* pred_redminrvvm1qi */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18242; /* pred_redminrvvmf2qi */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18250; /* pred_redminrvvmf4qi */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18258; /* pred_redminrvvmf8qi */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18290; /* pred_redminv1qi */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18298; /* pred_redminv2qi */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18306; /* pred_redminv4qi */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18314; /* pred_redminv8qi */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18322; /* pred_redminv16qi */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18330; /* pred_redminv32qi */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18338; /* pred_redminv64qi */

        case 14:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18346; /* pred_redminv128qi */

        case 15:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18354; /* pred_redminv256qi */

        case 16:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18362; /* pred_redminv512qi */

        case 17:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18370; /* pred_redminv1024qi */

        case 18:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18378; /* pred_redminv2048qi */

        case 19:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18386; /* pred_redminv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18146; /* pred_redminrvvm8hi */

        case 1:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18154; /* pred_redminrvvm4hi */

        case 2:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18162; /* pred_redminrvvm2hi */

        case 3:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18170; /* pred_redminrvvm1hi */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18266; /* pred_redminrvvmf2hi */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18274; /* pred_redminrvvmf4hi */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18394; /* pred_redminv1hi */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18402; /* pred_redminv2hi */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18410; /* pred_redminv4hi */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18418; /* pred_redminv8hi */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18426; /* pred_redminv16hi */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18434; /* pred_redminv32hi */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18442; /* pred_redminv64hi */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18450; /* pred_redminv128hi */

        case 14:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18458; /* pred_redminv256hi */

        case 15:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18466; /* pred_redminv512hi */

        case 16:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18474; /* pred_redminv1024hi */

        case 17:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18482; /* pred_redminv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18178; /* pred_redminrvvm8si */

        case 1:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18186; /* pred_redminrvvm4si */

        case 2:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18194; /* pred_redminrvvm2si */

        case 3:
          if (!
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18202; /* pred_redminrvvm1si */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18282; /* pred_redminrvvmf2si */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18490; /* pred_redminv1si */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18498; /* pred_redminv2si */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18506; /* pred_redminv4si */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18514; /* pred_redminv8si */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18522; /* pred_redminv16si */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18530; /* pred_redminv32si */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18538; /* pred_redminv64si */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18546; /* pred_redminv128si */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18554; /* pred_redminv256si */

        case 14:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18562; /* pred_redminv512si */

        case 15:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18570; /* pred_redminv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2))
        {
        case 0:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18210; /* pred_redminrvvm8di */

        case 1:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18218; /* pred_redminrvvm4di */

        case 2:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18226; /* pred_redminrvvm2di */

        case 3:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18234; /* pred_redminrvvm1di */

        case 4:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18578; /* pred_redminv1di */

        case 5:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18586; /* pred_redminv2di */

        case 6:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18594; /* pred_redminv4di */

        case 7:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18602; /* pred_redminv8di */

        case 8:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18610; /* pred_redminv16di */

        case 9:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18618; /* pred_redminv32di */

        case 10:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18626; /* pred_redminv64di */

        case 11:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18634; /* pred_redminv128di */

        case 12:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18642; /* pred_redminv256di */

        case 13:
          if (!(
#line 7765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18650; /* pred_redminv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18763; /* pred_redminrvvm8hf */

        case 1:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18765; /* pred_redminrvvm4hf */

        case 2:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18767; /* pred_redminrvvm2hf */

        case 3:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18769; /* pred_redminrvvm1hf */

        case 4:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18771; /* pred_redminrvvmf2hf */

        case 5:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18773; /* pred_redminrvvmf4hf */

        case 6:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 18793; /* pred_redminv1hf */

        case 7:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 18795; /* pred_redminv2hf */

        case 8:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 18797; /* pred_redminv4hf */

        case 9:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 18799; /* pred_redminv8hf */

        case 10:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 18801; /* pred_redminv16hf */

        case 11:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18803; /* pred_redminv32hf */

        case 12:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18805; /* pred_redminv64hf */

        case 13:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18807; /* pred_redminv128hf */

        case 14:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18809; /* pred_redminv256hf */

        case 15:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18811; /* pred_redminv512hf */

        case 16:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18813; /* pred_redminv1024hf */

        case 17:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18815; /* pred_redminv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18775; /* pred_redminrvvm8sf */

        case 1:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18777; /* pred_redminrvvm4sf */

        case 2:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18779; /* pred_redminrvvm2sf */

        case 3:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18781; /* pred_redminrvvm1sf */

        case 4:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18783; /* pred_redminrvvmf2sf */

        case 5:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18817; /* pred_redminv1sf */

        case 6:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18819; /* pred_redminv2sf */

        case 7:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18821; /* pred_redminv4sf */

        case 8:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18823; /* pred_redminv8sf */

        case 9:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18825; /* pred_redminv16sf */

        case 10:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18827; /* pred_redminv32sf */

        case 11:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18829; /* pred_redminv64sf */

        case 12:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18831; /* pred_redminv128sf */

        case 13:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18833; /* pred_redminv256sf */

        case 14:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18835; /* pred_redminv512sf */

        case 15:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18837; /* pred_redminv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2))
        {
        case 0:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18785; /* pred_redminrvvm8df */

        case 1:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18787; /* pred_redminrvvm4df */

        case 2:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18789; /* pred_redminrvvm2df */

        case 3:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18791; /* pred_redminrvvm1df */

        case 4:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18839; /* pred_redminv1df */

        case 5:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18841; /* pred_redminv2df */

        case 6:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18843; /* pred_redminv4df */

        case 7:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18845; /* pred_redminv8df */

        case 8:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18847; /* pred_redminv16df */

        case 9:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18849; /* pred_redminv32df */

        case 10:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18851; /* pred_redminv64df */

        case 11:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18853; /* pred_redminv128df */

        case 12:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18855; /* pred_redminv256df */

        case 13:
          if (!(
#line 7807 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18857; /* pred_redminv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern447 (x2))
    {
    case 0:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 925; /* pred_th_whole_movrvvm8qi */

    case 1:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 926; /* pred_th_whole_movrvvm4qi */

    case 2:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 927; /* pred_th_whole_movrvvm2qi */

    case 3:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 928; /* pred_th_whole_movrvvm1qi */

    case 4:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 929; /* pred_th_whole_movrvvm8hi */

    case 5:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 930; /* pred_th_whole_movrvvm4hi */

    case 6:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 931; /* pred_th_whole_movrvvm2hi */

    case 7:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 932; /* pred_th_whole_movrvvm1hi */

    case 8:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 933; /* pred_th_whole_movrvvm8si */

    case 9:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 934; /* pred_th_whole_movrvvm4si */

    case 10:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 935; /* pred_th_whole_movrvvm2si */

    case 11:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 936; /* pred_th_whole_movrvvm1si */

    case 12:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 937; /* pred_th_whole_movrvvm8di */

    case 13:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 938; /* pred_th_whole_movrvvm4di */

    case 14:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 939; /* pred_th_whole_movrvvm2di */

    case 15:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 940; /* pred_th_whole_movrvvm1di */

    case 16:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 941; /* pred_th_whole_movrvvmf8qi */

    case 17:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 942; /* pred_th_whole_movrvvmf4hi */

    case 18:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 943; /* pred_th_whole_movrvvmf2si */

    case 19:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 944; /* pred_th_whole_movrvvm8bf */

    case 20:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 945; /* pred_th_whole_movrvvm4bf */

    case 21:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 946; /* pred_th_whole_movrvvm2bf */

    case 22:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 947; /* pred_th_whole_movrvvm1bf */

    case 23:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 948; /* pred_th_whole_movrvvmf2bf */

    case 24:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 949; /* pred_th_whole_movrvvmf4bf */

    case 25:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 950; /* pred_th_whole_movrvvm8hf */

    case 26:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 951; /* pred_th_whole_movrvvm4hf */

    case 27:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 952; /* pred_th_whole_movrvvm2hf */

    case 28:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 953; /* pred_th_whole_movrvvm1hf */

    case 29:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 954; /* pred_th_whole_movrvvmf2hf */

    case 30:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 955; /* pred_th_whole_movrvvmf4hf */

    case 31:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 956; /* pred_th_whole_movrvvm8sf */

    case 32:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 957; /* pred_th_whole_movrvvm4sf */

    case 33:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 958; /* pred_th_whole_movrvvm2sf */

    case 34:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 959; /* pred_th_whole_movrvvm1sf */

    case 35:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 960; /* pred_th_whole_movrvvmf2sf */

    case 36:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 961; /* pred_th_whole_movrvvm8df */

    case 37:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 962; /* pred_th_whole_movrvvm4df */

    case 38:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 963; /* pred_th_whole_movrvvm2df */

    case 39:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 964; /* pred_th_whole_movrvvm1df */

    case 40:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 965; /* pred_th_whole_movv1qi */

    case 41:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 966; /* pred_th_whole_movv2qi */

    case 42:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 967; /* pred_th_whole_movv4qi */

    case 43:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 968; /* pred_th_whole_movv8qi */

    case 44:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 969; /* pred_th_whole_movv16qi */

    case 45:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 970; /* pred_th_whole_movv32qi */

    case 46:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 971; /* pred_th_whole_movv64qi */

    case 47:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 972; /* pred_th_whole_movv128qi */

    case 48:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 973; /* pred_th_whole_movv256qi */

    case 49:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 974; /* pred_th_whole_movv512qi */

    case 50:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 975; /* pred_th_whole_movv1024qi */

    case 51:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 976; /* pred_th_whole_movv2048qi */

    case 52:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 977; /* pred_th_whole_movv4096qi */

    case 53:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 978; /* pred_th_whole_movv1hi */

    case 54:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 979; /* pred_th_whole_movv2hi */

    case 55:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 980; /* pred_th_whole_movv4hi */

    case 56:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 981; /* pred_th_whole_movv8hi */

    case 57:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 982; /* pred_th_whole_movv16hi */

    case 58:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 983; /* pred_th_whole_movv32hi */

    case 59:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 984; /* pred_th_whole_movv64hi */

    case 60:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 985; /* pred_th_whole_movv128hi */

    case 61:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 986; /* pred_th_whole_movv256hi */

    case 62:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 987; /* pred_th_whole_movv512hi */

    case 63:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 988; /* pred_th_whole_movv1024hi */

    case 64:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 989; /* pred_th_whole_movv2048hi */

    case 65:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 990; /* pred_th_whole_movv1si */

    case 66:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 991; /* pred_th_whole_movv2si */

    case 67:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 992; /* pred_th_whole_movv4si */

    case 68:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 993; /* pred_th_whole_movv8si */

    case 69:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 994; /* pred_th_whole_movv16si */

    case 70:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 995; /* pred_th_whole_movv32si */

    case 71:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 996; /* pred_th_whole_movv64si */

    case 72:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 997; /* pred_th_whole_movv128si */

    case 73:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 998; /* pred_th_whole_movv256si */

    case 74:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 999; /* pred_th_whole_movv512si */

    case 75:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1000; /* pred_th_whole_movv1024si */

    case 76:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1001; /* pred_th_whole_movv1di */

    case 77:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1002; /* pred_th_whole_movv2di */

    case 78:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1003; /* pred_th_whole_movv4di */

    case 79:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1004; /* pred_th_whole_movv8di */

    case 80:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1005; /* pred_th_whole_movv16di */

    case 81:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1006; /* pred_th_whole_movv32di */

    case 82:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1007; /* pred_th_whole_movv64di */

    case 83:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1008; /* pred_th_whole_movv128di */

    case 84:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1009; /* pred_th_whole_movv256di */

    case 85:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1010; /* pred_th_whole_movv512di */

    case 86:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1011; /* pred_th_whole_movv1hf */

    case 87:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1012; /* pred_th_whole_movv2hf */

    case 88:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1013; /* pred_th_whole_movv4hf */

    case 89:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1014; /* pred_th_whole_movv8hf */

    case 90:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1015; /* pred_th_whole_movv16hf */

    case 91:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1016; /* pred_th_whole_movv32hf */

    case 92:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1017; /* pred_th_whole_movv64hf */

    case 93:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1018; /* pred_th_whole_movv128hf */

    case 94:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1019; /* pred_th_whole_movv256hf */

    case 95:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1020; /* pred_th_whole_movv512hf */

    case 96:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1021; /* pred_th_whole_movv1024hf */

    case 97:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1022; /* pred_th_whole_movv2048hf */

    case 98:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1023; /* pred_th_whole_movv1sf */

    case 99:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1024; /* pred_th_whole_movv2sf */

    case 100:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1025; /* pred_th_whole_movv4sf */

    case 101:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1026; /* pred_th_whole_movv8sf */

    case 102:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1027; /* pred_th_whole_movv16sf */

    case 103:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1028; /* pred_th_whole_movv32sf */

    case 104:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1029; /* pred_th_whole_movv64sf */

    case 105:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1030; /* pred_th_whole_movv128sf */

    case 106:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1031; /* pred_th_whole_movv256sf */

    case 107:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1032; /* pred_th_whole_movv512sf */

    case 108:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1033; /* pred_th_whole_movv1024sf */

    case 109:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1034; /* pred_th_whole_movv1df */

    case 110:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1035; /* pred_th_whole_movv2df */

    case 111:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1036; /* pred_th_whole_movv4df */

    case 112:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1037; /* pred_th_whole_movv8df */

    case 113:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1038; /* pred_th_whole_movv16df */

    case 114:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1039; /* pred_th_whole_movv32df */

    case 115:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1040; /* pred_th_whole_movv64df */

    case 116:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1041; /* pred_th_whole_movv128df */

    case 117:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1042; /* pred_th_whole_movv256df */

    case 118:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1043; /* pred_th_whole_movv512df */

    case 119:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1044; /* pred_th_whole_movrvvmf8x2qi */

    case 120:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1045; /* pred_th_whole_movrvvmf8x3qi */

    case 121:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1046; /* pred_th_whole_movrvvmf8x4qi */

    case 122:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1047; /* pred_th_whole_movrvvmf8x5qi */

    case 123:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1048; /* pred_th_whole_movrvvmf8x6qi */

    case 124:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1049; /* pred_th_whole_movrvvmf8x7qi */

    case 125:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1050; /* pred_th_whole_movrvvmf8x8qi */

    case 126:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1051; /* pred_th_whole_movrvvmf4x2hi */

    case 127:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1052; /* pred_th_whole_movrvvmf4x3hi */

    case 128:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1053; /* pred_th_whole_movrvvmf4x4hi */

    case 129:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1054; /* pred_th_whole_movrvvmf4x5hi */

    case 130:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1055; /* pred_th_whole_movrvvmf4x6hi */

    case 131:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1056; /* pred_th_whole_movrvvmf4x7hi */

    case 132:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1057; /* pred_th_whole_movrvvmf4x8hi */

    case 133:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1058; /* pred_th_whole_movrvvmf2x2si */

    case 134:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1059; /* pred_th_whole_movrvvmf2x3si */

    case 135:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1060; /* pred_th_whole_movrvvmf2x4si */

    case 136:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1061; /* pred_th_whole_movrvvmf2x5si */

    case 137:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1062; /* pred_th_whole_movrvvmf2x6si */

    case 138:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1063; /* pred_th_whole_movrvvmf2x7si */

    case 139:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1064; /* pred_th_whole_movrvvmf2x8si */

    case 140:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1065; /* pred_th_whole_movrvvm1x2di */

    case 141:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1066; /* pred_th_whole_movrvvm1x3di */

    case 142:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1067; /* pred_th_whole_movrvvm1x4di */

    case 143:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1068; /* pred_th_whole_movrvvm1x5di */

    case 144:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1069; /* pred_th_whole_movrvvm1x6di */

    case 145:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1070; /* pred_th_whole_movrvvm1x7di */

    case 146:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1071; /* pred_th_whole_movrvvm1x8di */

    case 147:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1072; /* pred_th_whole_movrvvmf4x2bf */

    case 148:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1073; /* pred_th_whole_movrvvmf4x3bf */

    case 149:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1074; /* pred_th_whole_movrvvmf4x4bf */

    case 150:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1075; /* pred_th_whole_movrvvmf4x5bf */

    case 151:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1076; /* pred_th_whole_movrvvmf4x6bf */

    case 152:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1077; /* pred_th_whole_movrvvmf4x7bf */

    case 153:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1078; /* pred_th_whole_movrvvmf4x8bf */

    case 154:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1079; /* pred_th_whole_movrvvmf4x2hf */

    case 155:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1080; /* pred_th_whole_movrvvmf4x3hf */

    case 156:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1081; /* pred_th_whole_movrvvmf4x4hf */

    case 157:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1082; /* pred_th_whole_movrvvmf4x5hf */

    case 158:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1083; /* pred_th_whole_movrvvmf4x6hf */

    case 159:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1084; /* pred_th_whole_movrvvmf4x7hf */

    case 160:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1085; /* pred_th_whole_movrvvmf4x8hf */

    case 161:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1086; /* pred_th_whole_movrvvmf2x2sf */

    case 162:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1087; /* pred_th_whole_movrvvmf2x3sf */

    case 163:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1088; /* pred_th_whole_movrvvmf2x4sf */

    case 164:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1089; /* pred_th_whole_movrvvmf2x5sf */

    case 165:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1090; /* pred_th_whole_movrvvmf2x6sf */

    case 166:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1091; /* pred_th_whole_movrvvmf2x7sf */

    case 167:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1092; /* pred_th_whole_movrvvmf2x8sf */

    case 168:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1093; /* pred_th_whole_movrvvm1x2df */

    case 169:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1094; /* pred_th_whole_movrvvm1x3df */

    case 170:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1095; /* pred_th_whole_movrvvm1x4df */

    case 171:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1096; /* pred_th_whole_movrvvm1x5df */

    case 172:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1097; /* pred_th_whole_movrvvm1x6df */

    case 173:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1098; /* pred_th_whole_movrvvm1x7df */

    case 174:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1099; /* pred_th_whole_movrvvm1x8df */

    case 175:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1100; /* pred_th_whole_movrvvmf4x2qi */

    case 176:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1101; /* pred_th_whole_movrvvmf4x3qi */

    case 177:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1102; /* pred_th_whole_movrvvmf4x4qi */

    case 178:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1103; /* pred_th_whole_movrvvmf4x5qi */

    case 179:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1104; /* pred_th_whole_movrvvmf4x6qi */

    case 180:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1105; /* pred_th_whole_movrvvmf4x7qi */

    case 181:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1106; /* pred_th_whole_movrvvmf4x8qi */

    case 182:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1107; /* pred_th_whole_movrvvmf2x2hi */

    case 183:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1108; /* pred_th_whole_movrvvmf2x3hi */

    case 184:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1109; /* pred_th_whole_movrvvmf2x4hi */

    case 185:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1110; /* pred_th_whole_movrvvmf2x5hi */

    case 186:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1111; /* pred_th_whole_movrvvmf2x6hi */

    case 187:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1112; /* pred_th_whole_movrvvmf2x7hi */

    case 188:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1113; /* pred_th_whole_movrvvmf2x8hi */

    case 189:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1114; /* pred_th_whole_movrvvm1x2si */

    case 190:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1115; /* pred_th_whole_movrvvm1x3si */

    case 191:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1116; /* pred_th_whole_movrvvm1x4si */

    case 192:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1117; /* pred_th_whole_movrvvm1x5si */

    case 193:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1118; /* pred_th_whole_movrvvm1x6si */

    case 194:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1119; /* pred_th_whole_movrvvm1x7si */

    case 195:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1120; /* pred_th_whole_movrvvm1x8si */

    case 196:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1121; /* pred_th_whole_movrvvm2x2di */

    case 197:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1122; /* pred_th_whole_movrvvm2x3di */

    case 198:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1123; /* pred_th_whole_movrvvm2x4di */

    case 199:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1124; /* pred_th_whole_movrvvmf2x2bf */

    case 200:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1125; /* pred_th_whole_movrvvmf2x3bf */

    case 201:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1126; /* pred_th_whole_movrvvmf2x4bf */

    case 202:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1127; /* pred_th_whole_movrvvmf2x5bf */

    case 203:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1128; /* pred_th_whole_movrvvmf2x6bf */

    case 204:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1129; /* pred_th_whole_movrvvmf2x7bf */

    case 205:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1130; /* pred_th_whole_movrvvmf2x8bf */

    case 206:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1131; /* pred_th_whole_movrvvmf2x2hf */

    case 207:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1132; /* pred_th_whole_movrvvmf2x3hf */

    case 208:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1133; /* pred_th_whole_movrvvmf2x4hf */

    case 209:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1134; /* pred_th_whole_movrvvmf2x5hf */

    case 210:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1135; /* pred_th_whole_movrvvmf2x6hf */

    case 211:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1136; /* pred_th_whole_movrvvmf2x7hf */

    case 212:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1137; /* pred_th_whole_movrvvmf2x8hf */

    case 213:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1138; /* pred_th_whole_movrvvm1x2sf */

    case 214:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1139; /* pred_th_whole_movrvvm1x3sf */

    case 215:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1140; /* pred_th_whole_movrvvm1x4sf */

    case 216:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1141; /* pred_th_whole_movrvvm1x5sf */

    case 217:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1142; /* pred_th_whole_movrvvm1x6sf */

    case 218:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1143; /* pred_th_whole_movrvvm1x7sf */

    case 219:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1144; /* pred_th_whole_movrvvm1x8sf */

    case 220:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1145; /* pred_th_whole_movrvvm2x2df */

    case 221:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1146; /* pred_th_whole_movrvvm2x3df */

    case 222:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1147; /* pred_th_whole_movrvvm2x4df */

    case 223:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1148; /* pred_th_whole_movrvvmf2x2qi */

    case 224:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1149; /* pred_th_whole_movrvvmf2x3qi */

    case 225:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1150; /* pred_th_whole_movrvvmf2x4qi */

    case 226:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1151; /* pred_th_whole_movrvvmf2x5qi */

    case 227:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1152; /* pred_th_whole_movrvvmf2x6qi */

    case 228:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1153; /* pred_th_whole_movrvvmf2x7qi */

    case 229:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1154; /* pred_th_whole_movrvvmf2x8qi */

    case 230:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1155; /* pred_th_whole_movrvvm1x2hi */

    case 231:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1156; /* pred_th_whole_movrvvm1x3hi */

    case 232:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1157; /* pred_th_whole_movrvvm1x4hi */

    case 233:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1158; /* pred_th_whole_movrvvm1x5hi */

    case 234:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1159; /* pred_th_whole_movrvvm1x6hi */

    case 235:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1160; /* pred_th_whole_movrvvm1x7hi */

    case 236:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1161; /* pred_th_whole_movrvvm1x8hi */

    case 237:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1162; /* pred_th_whole_movrvvm2x2si */

    case 238:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1163; /* pred_th_whole_movrvvm2x3si */

    case 239:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1164; /* pred_th_whole_movrvvm2x4si */

    case 240:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1165; /* pred_th_whole_movrvvm4x2di */

    case 241:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1166; /* pred_th_whole_movrvvm1x2bf */

    case 242:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1167; /* pred_th_whole_movrvvm1x3bf */

    case 243:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1168; /* pred_th_whole_movrvvm1x4bf */

    case 244:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1169; /* pred_th_whole_movrvvm1x5bf */

    case 245:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1170; /* pred_th_whole_movrvvm1x6bf */

    case 246:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1171; /* pred_th_whole_movrvvm1x7bf */

    case 247:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1172; /* pred_th_whole_movrvvm1x8bf */

    case 248:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1173; /* pred_th_whole_movrvvm1x2hf */

    case 249:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1174; /* pred_th_whole_movrvvm1x3hf */

    case 250:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1175; /* pred_th_whole_movrvvm1x4hf */

    case 251:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1176; /* pred_th_whole_movrvvm1x5hf */

    case 252:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1177; /* pred_th_whole_movrvvm1x6hf */

    case 253:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1178; /* pred_th_whole_movrvvm1x7hf */

    case 254:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1179; /* pred_th_whole_movrvvm1x8hf */

    case 255:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1180; /* pred_th_whole_movrvvm2x2sf */

    case 256:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1181; /* pred_th_whole_movrvvm2x3sf */

    case 257:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1182; /* pred_th_whole_movrvvm2x4sf */

    case 258:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1183; /* pred_th_whole_movrvvm4x2df */

    case 259:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1184; /* pred_th_whole_movrvvm1x2qi */

    case 260:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1185; /* pred_th_whole_movrvvm1x3qi */

    case 261:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1186; /* pred_th_whole_movrvvm1x4qi */

    case 262:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1187; /* pred_th_whole_movrvvm1x5qi */

    case 263:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1188; /* pred_th_whole_movrvvm1x6qi */

    case 264:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1189; /* pred_th_whole_movrvvm1x7qi */

    case 265:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1190; /* pred_th_whole_movrvvm1x8qi */

    case 266:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1191; /* pred_th_whole_movrvvm2x2hi */

    case 267:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1192; /* pred_th_whole_movrvvm2x3hi */

    case 268:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1193; /* pred_th_whole_movrvvm2x4hi */

    case 269:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1194; /* pred_th_whole_movrvvm4x2si */

    case 270:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1195; /* pred_th_whole_movrvvm2x2bf */

    case 271:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1196; /* pred_th_whole_movrvvm2x3bf */

    case 272:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1197; /* pred_th_whole_movrvvm2x4bf */

    case 273:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1198; /* pred_th_whole_movrvvm2x2hf */

    case 274:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1199; /* pred_th_whole_movrvvm2x3hf */

    case 275:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1200; /* pred_th_whole_movrvvm2x4hf */

    case 276:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1201; /* pred_th_whole_movrvvm4x2sf */

    case 277:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1202; /* pred_th_whole_movrvvm2x2qi */

    case 278:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1203; /* pred_th_whole_movrvvm2x3qi */

    case 279:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1204; /* pred_th_whole_movrvvm2x4qi */

    case 280:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1205; /* pred_th_whole_movrvvm4x2hi */

    case 281:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1206; /* pred_th_whole_movrvvm4x2bf */

    case 282:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1207; /* pred_th_whole_movrvvm4x2hf */

    case 283:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1208; /* pred_th_whole_movrvvm4x2qi */

    case 284:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1209; /* pred_th_whole_movrvvmf64bi */

    case 285:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1210; /* pred_th_whole_movrvvmf32bi */

    case 286:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1211; /* pred_th_whole_movrvvmf16bi */

    case 287:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1212; /* pred_th_whole_movrvvmf8bi */

    case 288:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1213; /* pred_th_whole_movrvvmf4bi */

    case 289:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1214; /* pred_th_whole_movrvvmf2bi */

    case 290:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1215; /* pred_th_whole_movrvvm1bi */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
    return 114; /* one_cmplsi2 */
  if (!
#line 1774 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
    return -1;
  return 116; /* *one_cmplsi2_internal */
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return recog_95 (x1, insn, pnum_clobbers);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 115; /* one_cmpldi2 */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 25034; /* one_cmplrvvmf64bi2 */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25035; /* one_cmplrvvmf32bi2 */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25036; /* one_cmplrvvmf16bi2 */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25037; /* one_cmplrvvmf8bi2 */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25038; /* one_cmplrvvmf4bi2 */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25039; /* one_cmplrvvmf2bi2 */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25040; /* one_cmplrvvm1bi2 */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25041; /* one_cmplv1bi2 */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25042; /* one_cmplv2bi2 */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25043; /* one_cmplv4bi2 */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25044; /* one_cmplv8bi2 */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25045; /* one_cmplv16bi2 */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25046; /* one_cmplv32bi2 */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25047; /* one_cmplv64bi2 */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25048; /* one_cmplv128bi2 */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25049; /* one_cmplv256bi2 */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25050; /* one_cmplv512bi2 */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25051; /* one_cmplv1024bi2 */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25052; /* one_cmplv2048bi2 */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25053; /* one_cmplv4096bi2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25973; /* one_cmplrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25975; /* one_cmplrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25977; /* one_cmplrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25979; /* one_cmplrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25981; /* one_cmplrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25983; /* one_cmplrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25985; /* one_cmplrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25987; /* one_cmplrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25989; /* one_cmplrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25991; /* one_cmplrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25993; /* one_cmplrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25995; /* one_cmplrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25997; /* one_cmplrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25999; /* one_cmplrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26001; /* one_cmplrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26003; /* one_cmplrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26005; /* one_cmplrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26007; /* one_cmplrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26009; /* one_cmplrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26011; /* one_cmplrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26013; /* one_cmplrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26015; /* one_cmplrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26017; /* one_cmplv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26019; /* one_cmplv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26021; /* one_cmplv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26023; /* one_cmplv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26025; /* one_cmplv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26027; /* one_cmplv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26029; /* one_cmplv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26031; /* one_cmplv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26033; /* one_cmplv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26035; /* one_cmplv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26037; /* one_cmplv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26039; /* one_cmplv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26041; /* one_cmplv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26043; /* one_cmplv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26045; /* one_cmplv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26047; /* one_cmplv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26049; /* one_cmplv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26051; /* one_cmplv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26053; /* one_cmplv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26055; /* one_cmplv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26057; /* one_cmplv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26059; /* one_cmplv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26061; /* one_cmplv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26063; /* one_cmplv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26065; /* one_cmplv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26067; /* one_cmplv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26069; /* one_cmplv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26071; /* one_cmplv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 26073; /* one_cmplv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26075; /* one_cmplv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26077; /* one_cmplv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26079; /* one_cmplv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26081; /* one_cmplv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26083; /* one_cmplv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26085; /* one_cmplv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26087; /* one_cmplv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26089; /* one_cmplv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26091; /* one_cmplv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26093; /* one_cmplv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26095; /* one_cmplv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26097; /* one_cmplv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26099; /* one_cmplv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26101; /* one_cmplv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26103; /* one_cmplv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26105; /* one_cmplv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1073 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26107; /* one_cmplv512di2 */

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF8BImode)
      && register_operand (operands[1], E_RVVMF8BImode)
      && 
#line 1293 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2800; /* *movrvvmf8bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF8BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF8BImode))
    return -1;
  if ((
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2839; /* *movrvvmf8bisi_lra */
    }
  if (!(
#line 1353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2840; /* *movrvvmf8bidi_lra */
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2HFmode)
      && register_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 1256 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 2782; /* *movrvvmf2hf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2HFmode))
    return -1;
  if ((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2818; /* *movrvvmf2hfsi_lra */
    }
  if (!(
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2829; /* *movrvvmf2hfdi_lra */
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2QImode)
      && register_operand (operands[1], E_RVVMF2QImode)
      && 
#line 1256 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return 2775; /* *movrvvmf2qi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2QImode))
    return -1;
  if ((
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2811; /* *movrvvmf2qisi_lra */
    }
  if (!(
#line 1331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2822; /* *movrvvmf2qidi_lra */
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1BImode)
      && reg_or_mem_operand (operands[1], E_V1BImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1BImode)
       || register_operand (operands[1], V1BImode))) && 
#line 4281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
    return 3212; /* *movv1bi */
  if (!register_operand (operands[0], E_V1BImode)
      || !register_operand (operands[1], E_V1BImode)
      || !(
#line 1529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
    return -1;
  return 3479; /* *movv1bi_vls */
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3205; /* *movv8sf */
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3382; /* *movv8sf_vls */
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HFmode)
      && reg_or_mem_operand (operands[1], E_V4HFmode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))) && 
#line 4267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3199; /* *movv4hf */
  if (!register_operand (operands[0], E_V4HFmode)
      || !register_operand (operands[1], E_V4HFmode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3369; /* *movv4hf_vls */
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DImode)
      && reg_or_mem_operand (operands[1], E_V1DImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DImode)
       || register_operand (operands[1], V1DImode))) && 
#line 4260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 3192; /* *movv1di */
  if (!register_operand (operands[0], E_V1DImode)
      || !register_operand (operands[1], E_V1DImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 3357; /* *movv1di_vls */
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8HImode)
      && reg_or_mem_operand (operands[1], E_V8HImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))) && 
#line 4253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 3185; /* *movv8hi */
  if (!register_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 3337; /* *movv8hi_vls */
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2QImode)
      && reg_or_mem_operand (operands[1], E_V2QImode)
      && (
#line 1433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))) && 
#line 4246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 3178; /* *movv2qi */
  if (!register_operand (operands[0], E_V2QImode)
      || !register_operand (operands[1], E_V2QImode)
      || !(
#line 1508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 3322; /* *movv2qi_vls */
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3167; /* *movrvvm2x4qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3168; /* *movrvvm2x4qi_di */
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3155; /* *movrvvm2x2hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3156; /* *movrvvm2x2hf_di */
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3141; /* *movrvvm2x2hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3142; /* *movrvvm2x2hi_di */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3127; /* *movrvvm1x2qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3128; /* *movrvvm1x2qi_di */
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3113; /* *movrvvm1x6hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3114; /* *movrvvm1x6hf_di */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3099; /* *movrvvm1x6bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3100; /* *movrvvm1x6bf_di */
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3SImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3085; /* *movrvvm2x3si_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3086; /* *movrvvm2x3si_di */
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3073; /* *movrvvm1x4hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3074; /* *movrvvm1x4hi_di */
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3059; /* *movrvvmf2x4qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3060; /* *movrvvmf2x4qi_di */
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6SFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3043; /* *movrvvm1x6sf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3044; /* *movrvvm1x6sf_di */
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3027; /* *movrvvmf2x5hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3028; /* *movrvvmf2x5hf_di */
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3011; /* *movrvvmf2x4bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3012; /* *movrvvmf2x4bf_di */
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6SImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2995; /* *movrvvm1x6si_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2996; /* *movrvvm1x6si_di */
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8HImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2985; /* *movrvvmf2x8hi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2986; /* *movrvvmf2x8hi_di */
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7QImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2969; /* *movrvvmf4x7qi_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2970; /* *movrvvmf4x7qi_di */
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6DFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2953; /* *movrvvm1x6df_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2954; /* *movrvvm1x6df_di */
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5SFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2937; /* *movrvvmf2x5sf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2938; /* *movrvvmf2x5sf_di */
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4HFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2921; /* *movrvvmf4x4hf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2922; /* *movrvvmf4x4hf_di */
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3BFmode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2905; /* *movrvvmf4x3bf_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2906; /* *movrvvmf4x3bf_di */
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2DImode))
    return -1;
  if ((
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2889; /* *movrvvm1x2di_si */
    }
  if (!(
#line 1404 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2890; /* *movrvvm1x2di_di */
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !(
#line 815 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (SImode)
       || operands[2] == CONST1_RTX (SImode))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 609; /* *bsetclr_zero_extract */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !(
#line 815 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (DImode)
       || operands[2] == CONST1_RTX (DImode))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 610; /* *bsetclr_zero_extract */

    default:
      return -1;
    }
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 2);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      operands[3] = x5;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *branch_on_bitsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 384; /* *branch_on_bitdi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      operands[1] = x3;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !(
#line 1143 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 637; /* *branchsi_bext */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x5) != E_DImode
              || !(
#line 1143 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 638; /* *branchdi_bext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (equality_operator (x3, E_VOIDmode))
    {
      res = recog_369 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern359 (x2))
        {
        case 0:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32729; /* *czero.nez.sisi */

        case 1:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32731; /* *czero.nez.sidi */

        case 2:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32733; /* *czero.nez.didi */

        case 3:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32741; /* *czero.eqz.sisi.opt1 */

        case 4:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32743; /* *czero.eqz.sidi.opt1 */

        case 5:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && (((
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 32742; /* *czero.eqz.disi.opt1 */

        case 6:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32744; /* *czero.eqz.didi.opt1 */

        case 7:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32735; /* *czero.eqz.sisi */

        case 8:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32737; /* *czero.eqz.sidi */

        case 9:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32739; /* *czero.eqz.didi */

        default:
          return -1;
        }

    case NE:
      switch (pattern359 (x2))
        {
        case 0:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32730; /* *czero.eqz.sisi */

        case 1:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32732; /* *czero.eqz.sidi */

        case 2:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32734; /* *czero.eqz.didi */

        case 3:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32745; /* *czero.nez.sisi.opt2 */

        case 4:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32747; /* *czero.nez.sidi.opt2 */

        case 5:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && (((
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 32746; /* *czero.nez.disi.opt2 */

        case 6:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32748; /* *czero.nez.didi.opt2 */

        case 7:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32736; /* *czero.nez.sisi */

        case 8:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32738; /* *czero.nez.sidi */

        case 9:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32740; /* *czero.nez.didi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      switch (pattern409 ())
        {
        case 0:
          if (!(
#line 3238 "../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 369; /* *branchsi */

        case 1:
          if (!(
#line 3238 "../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 370; /* *branchdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (pattern332 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_SImode)
              || !sfb_alu_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_0_operand (operands[2], E_SImode)
                  || !(
#line 31 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32749; /* *movsisicc */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode)
                  || !(
#line 31 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32750; /* *movsidicc */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !register_operand (operands[3], E_DImode)
              || !sfb_alu_operand (operands[4], E_DImode)
              || !(
#line 31 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32751; /* *movdidicc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF64BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF64BImode))
    return -1;
  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 1216; /* *pred_th_movrvvmf64bi */
  if (!(
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return -1;
  return 3801; /* pred_movrvvmf64bi */
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF32BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF32BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1217; /* *pred_th_movrvvmf32bi */
  if (!
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3802; /* pred_movrvvmf32bi */
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF8BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1219; /* *pred_th_movrvvmf8bi */
  if (!
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3804; /* pred_movrvvmf8bi */
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF2BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF2BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1221; /* *pred_th_movrvvmf2bi */
  if (!
#line 1963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3806; /* pred_movrvvmf2bi */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3828; /* pred_mergervvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3829; /* pred_mergervvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3830; /* pred_mergervvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3831; /* pred_mergervvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3832; /* pred_mergervvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3833; /* pred_mergervvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3834; /* pred_mergervvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3835; /* pred_mergervvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3836; /* pred_mergervvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3837; /* pred_mergervvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3838; /* pred_mergervvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3839; /* pred_mergervvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3840; /* pred_mergervvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3841; /* pred_mergervvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3842; /* pred_mergervvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3843; /* pred_mergervvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3844; /* pred_mergervvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3845; /* pred_mergervvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3846; /* pred_mergervvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3847; /* pred_mergervvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3848; /* pred_mergervvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3849; /* pred_mergervvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3850; /* pred_mergervvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3851; /* pred_mergervvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3852; /* pred_mergervvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3853; /* pred_mergervvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3854; /* pred_mergervvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3855; /* pred_mergervvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3856; /* pred_mergervvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3857; /* pred_mergervvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3858; /* pred_mergervvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3859; /* pred_mergervvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3860; /* pred_mergervvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3861; /* pred_mergervvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3862; /* pred_mergervvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3863; /* pred_mergervvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3864; /* pred_mergervvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3865; /* pred_mergervvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3866; /* pred_mergervvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3867; /* pred_mergervvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3868; /* pred_mergervvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3869; /* pred_mergervvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3870; /* pred_mergervvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3871; /* pred_mergev1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3872; /* pred_mergev2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3873; /* pred_mergev4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3874; /* pred_mergev8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3875; /* pred_mergev16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3876; /* pred_mergev32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3877; /* pred_mergev64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3878; /* pred_mergev128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3879; /* pred_mergev256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3880; /* pred_mergev512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3881; /* pred_mergev1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3882; /* pred_mergev2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3883; /* pred_mergev4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3884; /* pred_mergev1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3885; /* pred_mergev2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3886; /* pred_mergev4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3887; /* pred_mergev8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3888; /* pred_mergev16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3889; /* pred_mergev32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3890; /* pred_mergev64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3891; /* pred_mergev128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3892; /* pred_mergev256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3893; /* pred_mergev512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3894; /* pred_mergev1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3895; /* pred_mergev2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3896; /* pred_mergev1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3897; /* pred_mergev2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3898; /* pred_mergev4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3899; /* pred_mergev8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3900; /* pred_mergev16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3901; /* pred_mergev32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3902; /* pred_mergev64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3903; /* pred_mergev128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3904; /* pred_mergev256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3905; /* pred_mergev512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3906; /* pred_mergev1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3907; /* pred_mergev1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3908; /* pred_mergev2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3909; /* pred_mergev4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3910; /* pred_mergev8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3911; /* pred_mergev16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3912; /* pred_mergev32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3913; /* pred_mergev64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3914; /* pred_mergev128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3915; /* pred_mergev256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3916; /* pred_mergev512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3917; /* pred_mergev1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3918; /* pred_mergev2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3919; /* pred_mergev4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3920; /* pred_mergev8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3921; /* pred_mergev16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3922; /* pred_mergev32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3923; /* pred_mergev64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3924; /* pred_mergev128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3925; /* pred_mergev256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3926; /* pred_mergev512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3927; /* pred_mergev1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3928; /* pred_mergev2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3929; /* pred_mergev1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3930; /* pred_mergev2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3931; /* pred_mergev4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3932; /* pred_mergev8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3933; /* pred_mergev16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3934; /* pred_mergev32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3935; /* pred_mergev64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3936; /* pred_mergev128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3937; /* pred_mergev256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3938; /* pred_mergev512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3939; /* pred_mergev1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3940; /* pred_mergev1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3941; /* pred_mergev2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3942; /* pred_mergev4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3943; /* pred_mergev8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3944; /* pred_mergev16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3945; /* pred_mergev32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3946; /* pred_mergev64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3947; /* pred_mergev128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3948; /* pred_mergev256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3949; /* pred_mergev512df */

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_394 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_393 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_392 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern438 (x2))
        {
        case 0:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14138; /* pred_andrvvmf64bi */

        case 1:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14141; /* pred_andrvvmf32bi */

        case 2:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14144; /* pred_andrvvmf16bi */

        case 3:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14147; /* pred_andrvvmf8bi */

        case 4:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14150; /* pred_andrvvmf4bi */

        case 5:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14153; /* pred_andrvvmf2bi */

        case 6:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14156; /* pred_andrvvm1bi */

        case 7:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14159; /* pred_andv1bi */

        case 8:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14162; /* pred_andv2bi */

        case 9:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14165; /* pred_andv4bi */

        case 10:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14168; /* pred_andv8bi */

        case 11:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14171; /* pred_andv16bi */

        case 12:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14174; /* pred_andv32bi */

        case 13:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14177; /* pred_andv64bi */

        case 14:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14180; /* pred_andv128bi */

        case 15:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14183; /* pred_andv256bi */

        case 16:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14186; /* pred_andv512bi */

        case 17:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14189; /* pred_andv1024bi */

        case 18:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14192; /* pred_andv2048bi */

        case 19:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14195; /* pred_andv4096bi */

        case 20:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14258; /* pred_andnotrvvmf64bi */

        case 21:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14260; /* pred_andnotrvvmf32bi */

        case 22:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14262; /* pred_andnotrvvmf16bi */

        case 23:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14264; /* pred_andnotrvvmf8bi */

        case 24:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14266; /* pred_andnotrvvmf4bi */

        case 25:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14268; /* pred_andnotrvvmf2bi */

        case 26:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14270; /* pred_andnotrvvm1bi */

        case 27:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14272; /* pred_andnotv1bi */

        case 28:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14274; /* pred_andnotv2bi */

        case 29:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14276; /* pred_andnotv4bi */

        case 30:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14278; /* pred_andnotv8bi */

        case 31:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14280; /* pred_andnotv16bi */

        case 32:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14282; /* pred_andnotv32bi */

        case 33:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14284; /* pred_andnotv64bi */

        case 34:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14286; /* pred_andnotv128bi */

        case 35:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14288; /* pred_andnotv256bi */

        case 36:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14290; /* pred_andnotv512bi */

        case 37:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14292; /* pred_andnotv1024bi */

        case 38:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14294; /* pred_andnotv2048bi */

        case 39:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14296; /* pred_andnotv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern438 (x2))
        {
        case 0:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14139; /* pred_iorrvvmf64bi */

        case 1:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14142; /* pred_iorrvvmf32bi */

        case 2:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14145; /* pred_iorrvvmf16bi */

        case 3:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14148; /* pred_iorrvvmf8bi */

        case 4:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14151; /* pred_iorrvvmf4bi */

        case 5:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14154; /* pred_iorrvvmf2bi */

        case 6:
          if (!
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14157; /* pred_iorrvvm1bi */

        case 7:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14160; /* pred_iorv1bi */

        case 8:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14163; /* pred_iorv2bi */

        case 9:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14166; /* pred_iorv4bi */

        case 10:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14169; /* pred_iorv8bi */

        case 11:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14172; /* pred_iorv16bi */

        case 12:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14175; /* pred_iorv32bi */

        case 13:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14178; /* pred_iorv64bi */

        case 14:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14181; /* pred_iorv128bi */

        case 15:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14184; /* pred_iorv256bi */

        case 16:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14187; /* pred_iorv512bi */

        case 17:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14190; /* pred_iorv1024bi */

        case 18:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14193; /* pred_iorv2048bi */

        case 19:
          if (!(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14196; /* pred_iorv4096bi */

        case 20:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14259; /* pred_iornotrvvmf64bi */

        case 21:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14261; /* pred_iornotrvvmf32bi */

        case 22:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14263; /* pred_iornotrvvmf16bi */

        case 23:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14265; /* pred_iornotrvvmf8bi */

        case 24:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14267; /* pred_iornotrvvmf4bi */

        case 25:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14269; /* pred_iornotrvvmf2bi */

        case 26:
          if (!
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14271; /* pred_iornotrvvm1bi */

        case 27:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14273; /* pred_iornotv1bi */

        case 28:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14275; /* pred_iornotv2bi */

        case 29:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14277; /* pred_iornotv4bi */

        case 30:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14279; /* pred_iornotv8bi */

        case 31:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14281; /* pred_iornotv16bi */

        case 32:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14283; /* pred_iornotv32bi */

        case 33:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14285; /* pred_iornotv64bi */

        case 34:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14287; /* pred_iornotv128bi */

        case 35:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14289; /* pred_iornotv256bi */

        case 36:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14291; /* pred_iornotv512bi */

        case 37:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14293; /* pred_iornotv1024bi */

        case 38:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14295; /* pred_iornotv2048bi */

        case 39:
          if (!(
#line 6049 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14297; /* pred_iornotv4096bi */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[5] = x6;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      operands[6] = x7;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern436 (x2, 
E_RVVMF64BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14140; /* pred_xorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern436 (x2, 
E_RVVMF32BImode) != 0
              || !
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14143; /* pred_xorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern436 (x2, 
E_RVVMF16BImode) != 0
              || !
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14146; /* pred_xorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern436 (x2, 
E_RVVMF8BImode) != 0
              || !
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14149; /* pred_xorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern436 (x2, 
E_RVVMF4BImode) != 0
              || !
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14152; /* pred_xorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern436 (x2, 
E_RVVMF2BImode) != 0
              || !
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14155; /* pred_xorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern436 (x2, 
E_RVVM1BImode) != 0
              || !
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14158; /* pred_xorrvvm1bi */

        case E_V1BImode:
          if (pattern436 (x2, 
E_V1BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14161; /* pred_xorv1bi */

        case E_V2BImode:
          if (pattern436 (x2, 
E_V2BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14164; /* pred_xorv2bi */

        case E_V4BImode:
          if (pattern436 (x2, 
E_V4BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14167; /* pred_xorv4bi */

        case E_V8BImode:
          if (pattern436 (x2, 
E_V8BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14170; /* pred_xorv8bi */

        case E_V16BImode:
          if (pattern436 (x2, 
E_V16BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14173; /* pred_xorv16bi */

        case E_V32BImode:
          if (pattern436 (x2, 
E_V32BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14176; /* pred_xorv32bi */

        case E_V64BImode:
          if (pattern436 (x2, 
E_V64BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14179; /* pred_xorv64bi */

        case E_V128BImode:
          if (pattern436 (x2, 
E_V128BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14182; /* pred_xorv128bi */

        case E_V256BImode:
          if (pattern436 (x2, 
E_V256BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14185; /* pred_xorv256bi */

        case E_V512BImode:
          if (pattern436 (x2, 
E_V512BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14188; /* pred_xorv512bi */

        case E_V1024BImode:
          if (pattern436 (x2, 
E_V1024BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14191; /* pred_xorv1024bi */

        case E_V2048BImode:
          if (pattern436 (x2, 
E_V2048BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14194; /* pred_xorv2048bi */

        case E_V4096BImode:
          if (pattern436 (x2, 
E_V4096BImode) != 0
              || !(
#line 6007 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14197; /* pred_xorv4096bi */

        default:
          return -1;
        }

    case NOT:
      return recog_395 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 4331; /* *pred_broadcastv8df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4453; /* *pred_broadcastv8df_imm */
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 4327; /* *pred_broadcastv1024sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4449; /* *pred_broadcastv1024sf_imm */
}

 int
recog_413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 4323; /* *pred_broadcastv64sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4445; /* *pred_broadcastv64sf_imm */
}

 int
recog_417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4SFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4319; /* *pred_broadcastv4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4SFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4441; /* *pred_broadcastv4sf_imm */
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return 4315; /* *pred_broadcastv1024hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4437; /* *pred_broadcastv1024hf_imm */
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return 4311; /* *pred_broadcastv64hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4433; /* *pred_broadcastv64hf_imm */
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4307; /* *pred_broadcastv4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4429; /* *pred_broadcastv4hf_imm */
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256DImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 4303; /* *pred_broadcastv256di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256DImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4425; /* *pred_broadcastv256di_imm */
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16DImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 4299; /* *pred_broadcastv16di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16DImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4421; /* *pred_broadcastv16di_imm */
}

 int
recog_442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024SImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 4294; /* *pred_broadcastv1024si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024SImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4416; /* *pred_broadcastv1024si_imm */
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16SImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 4288; /* *pred_broadcastv16si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16SImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4410; /* *pred_broadcastv16si_imm */
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512HImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 4281; /* *pred_broadcastv512hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512HImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4403; /* *pred_broadcastv512hi_imm */
}

 int
recog_463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2HImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 4273; /* *pred_broadcastv2hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2HImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 4395; /* *pred_broadcastv2hi_imm */
}

 int
recog_471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64QImode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 4265; /* *pred_broadcastv64qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64QImode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4387; /* *pred_broadcastv64qi_imm */
}

 int
recog_479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVM2DFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4257; /* *pred_broadcastrvvm2df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2DFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4379; /* *pred_broadcastrvvm2df_imm */
}

 int
recog_487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVMF4HFmode)
      && (
#line 2339 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return 4249; /* *pred_broadcastrvvmf4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4HFmode)
      || !(
#line 2359 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 4371; /* *pred_broadcastrvvmf4hf_imm */
}

 int
recog_495 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern665 (x2))
    {
    case 0:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4704; /* pred_indexed_oloadrvvm8qi_same_eew */

    case 1:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4706; /* pred_indexed_oloadrvvm4qi_same_eew */

    case 2:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5072; /* pred_indexed_oloadrvvm4qi_x2_smaller_eew */

    case 3:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4708; /* pred_indexed_oloadrvvm2qi_same_eew */

    case 4:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5074; /* pred_indexed_oloadrvvm2qi_x2_smaller_eew */

    case 5:
      if (!
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5130; /* pred_indexed_oloadrvvm2qi_x4_smaller_eew */

    case 6:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4710; /* pred_indexed_oloadrvvm1qi_same_eew */

    case 7:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5076; /* pred_indexed_oloadrvvm1qi_x2_smaller_eew */

    case 8:
      if (!
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5132; /* pred_indexed_oloadrvvm1qi_x4_smaller_eew */

    case 9:
      if (!(
#line 2570 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 381 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5164; /* pred_indexed_oloadrvvm1qi_x8_smaller_eew */

    case 10:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4712; /* pred_indexed_oloadrvvmf2qi_same_eew */

    case 11:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5078; /* pred_indexed_oloadrvvmf2qi_x2_smaller_eew */

    case 12:
      if (!
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5134; /* pred_indexed_oloadrvvmf2qi_x4_smaller_eew */

    case 13:
      if (!(
#line 2570 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 382 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5166; /* pred_indexed_oloadrvvmf2qi_x8_smaller_eew */

    case 14:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4714; /* pred_indexed_oloadrvvmf4qi_same_eew */

    case 15:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5080; /* pred_indexed_oloadrvvmf4qi_x2_smaller_eew */

    case 16:
      if (!
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5136; /* pred_indexed_oloadrvvmf4qi_x4_smaller_eew */

    case 17:
      if (!(
#line 2570 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 383 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5168; /* pred_indexed_oloadrvvmf4qi_x8_smaller_eew */

    case 18:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4716; /* pred_indexed_oloadrvvmf8qi_same_eew */

    case 19:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 338 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5082; /* pred_indexed_oloadrvvmf8qi_x2_smaller_eew */

    case 20:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 362 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5138; /* pred_indexed_oloadrvvmf8qi_x4_smaller_eew */

    case 21:
      if (!(
#line 2570 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 384 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5170; /* pred_indexed_oloadrvvmf8qi_x8_smaller_eew */

    case 22:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4718; /* pred_indexed_oloadrvvm8hi_same_eew */

    case 23:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4948; /* pred_indexed_oloadrvvm8hi_x2_greater_eew */

    case 24:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4720; /* pred_indexed_oloadrvvm4hi_same_eew */

    case 25:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4950; /* pred_indexed_oloadrvvm4hi_x2_greater_eew */

    case 26:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5084; /* pred_indexed_oloadrvvm4hi_x2_smaller_eew */

    case 27:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4722; /* pred_indexed_oloadrvvm2hi_same_eew */

    case 28:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4952; /* pred_indexed_oloadrvvm2hi_x2_greater_eew */

    case 29:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5086; /* pred_indexed_oloadrvvm2hi_x2_smaller_eew */

    case 30:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 364 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5140; /* pred_indexed_oloadrvvm2hi_x4_smaller_eew */

    case 31:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4724; /* pred_indexed_oloadrvvm1hi_same_eew */

    case 32:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4954; /* pred_indexed_oloadrvvm1hi_x2_greater_eew */

    case 33:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5088; /* pred_indexed_oloadrvvm1hi_x2_smaller_eew */

    case 34:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 365 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5142; /* pred_indexed_oloadrvvm1hi_x4_smaller_eew */

    case 35:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4726; /* pred_indexed_oloadrvvmf2hi_same_eew */

    case 36:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4956; /* pred_indexed_oloadrvvmf2hi_x2_greater_eew */

    case 37:
      if (!
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5090; /* pred_indexed_oloadrvvmf2hi_x2_smaller_eew */

    case 38:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 366 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5144; /* pred_indexed_oloadrvvmf2hi_x4_smaller_eew */

    case 39:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4728; /* pred_indexed_oloadrvvmf4hi_same_eew */

    case 40:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4958; /* pred_indexed_oloadrvvmf4hi_x2_greater_eew */

    case 41:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5092; /* pred_indexed_oloadrvvmf4hi_x2_smaller_eew */

    case 42:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 367 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5146; /* pred_indexed_oloadrvvmf4hi_x4_smaller_eew */

    case 43:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4730; /* pred_indexed_oloadrvvm8si_same_eew */

    case 44:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4984; /* pred_indexed_oloadrvvm8si_x2_greater_eew */

    case 45:
      if (!
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5020; /* pred_indexed_oloadrvvm8si_x4_greater_eew */

    case 46:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4732; /* pred_indexed_oloadrvvm4si_same_eew */

    case 47:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4986; /* pred_indexed_oloadrvvm4si_x2_greater_eew */

    case 48:
      if (!
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5022; /* pred_indexed_oloadrvvm4si_x4_greater_eew */

    case 49:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 350 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5114; /* pred_indexed_oloadrvvm4si_x2_smaller_eew */

    case 50:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4734; /* pred_indexed_oloadrvvm2si_same_eew */

    case 51:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4988; /* pred_indexed_oloadrvvm2si_x2_greater_eew */

    case 52:
      if (!
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5024; /* pred_indexed_oloadrvvm2si_x4_greater_eew */

    case 53:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 351 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5116; /* pred_indexed_oloadrvvm2si_x2_smaller_eew */

    case 54:
      if (!
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4736; /* pred_indexed_oloadrvvm1si_same_eew */

    case 55:
      if (!
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4990; /* pred_indexed_oloadrvvm1si_x2_greater_eew */

    case 56:
      if (!
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5026; /* pred_indexed_oloadrvvm1si_x4_greater_eew */

    case 57:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 352 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5118; /* pred_indexed_oloadrvvm1si_x2_smaller_eew */

    case 58:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1532 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4738; /* pred_indexed_oloadrvvmf2si_same_eew */

    case 59:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 4992; /* pred_indexed_oloadrvvmf2si_x2_greater_eew */

    case 60:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 5028; /* pred_indexed_oloadrvvmf2si_x4_greater_eew */

    case 61:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 353 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5120; /* pred_indexed_oloadrvvmf2si_x2_smaller_eew */

    case 62:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1534 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4740; /* pred_indexed_oloadrvvm8di_same_eew */

    case 63:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5004; /* pred_indexed_oloadrvvm8di_x2_greater_eew */

    case 64:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 322 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5040; /* pred_indexed_oloadrvvm8di_x4_greater_eew */

    case 65:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5056; /* pred_indexed_oloadrvvm8di_x8_greater_eew */

    case 66:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1535 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4742; /* pred_indexed_oloadrvvm4di_same_eew */

    case 67:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5006; /* pred_indexed_oloadrvvm4di_x2_greater_eew */

    case 68:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 322 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5042; /* pred_indexed_oloadrvvm4di_x4_greater_eew */

    case 69:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5058; /* pred_indexed_oloadrvvm4di_x8_greater_eew */

    case 70:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1536 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4744; /* pred_indexed_oloadrvvm2di_same_eew */

    case 71:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5008; /* pred_indexed_oloadrvvm2di_x2_greater_eew */

    case 72:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5044; /* pred_indexed_oloadrvvm2di_x4_greater_eew */

    case 73:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5060; /* pred_indexed_oloadrvvm2di_x8_greater_eew */

    case 74:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1537 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4746; /* pred_indexed_oloadrvvm1di_same_eew */

    case 75:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5010; /* pred_indexed_oloadrvvm1di_x2_greater_eew */

    case 76:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5046; /* pred_indexed_oloadrvvm1di_x4_greater_eew */

    case 77:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5062; /* pred_indexed_oloadrvvm1di_x8_greater_eew */

    case 78:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1539 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4748; /* pred_indexed_oloadrvvm8bf_same_eew */

    case 79:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4960; /* pred_indexed_oloadrvvm8bf_x2_greater_eew */

    case 80:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1540 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4750; /* pred_indexed_oloadrvvm4bf_same_eew */

    case 81:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4962; /* pred_indexed_oloadrvvm4bf_x2_greater_eew */

    case 82:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5094; /* pred_indexed_oloadrvvm4bf_x2_smaller_eew */

    case 83:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1541 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4752; /* pred_indexed_oloadrvvm2bf_same_eew */

    case 84:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4964; /* pred_indexed_oloadrvvm2bf_x2_greater_eew */

    case 85:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5096; /* pred_indexed_oloadrvvm2bf_x2_smaller_eew */

    case 86:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 369 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5148; /* pred_indexed_oloadrvvm2bf_x4_smaller_eew */

    case 87:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1542 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4754; /* pred_indexed_oloadrvvm1bf_same_eew */

    case 88:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4966; /* pred_indexed_oloadrvvm1bf_x2_greater_eew */

    case 89:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 343 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5098; /* pred_indexed_oloadrvvm1bf_x2_smaller_eew */

    case 90:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 370 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5150; /* pred_indexed_oloadrvvm1bf_x4_smaller_eew */

    case 91:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1543 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4756; /* pred_indexed_oloadrvvmf2bf_same_eew */

    case 92:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4968; /* pred_indexed_oloadrvvmf2bf_x2_greater_eew */

    case 93:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 343 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5100; /* pred_indexed_oloadrvvmf2bf_x2_smaller_eew */

    case 94:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 371 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5152; /* pred_indexed_oloadrvvmf2bf_x4_smaller_eew */

    case 95:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1544 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4758; /* pred_indexed_oloadrvvmf4bf_same_eew */

    case 96:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4970; /* pred_indexed_oloadrvvmf4bf_x2_greater_eew */

    case 97:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5102; /* pred_indexed_oloadrvvmf4bf_x2_smaller_eew */

    case 98:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 372 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5154; /* pred_indexed_oloadrvvmf4bf_x4_smaller_eew */

    case 99:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4760; /* pred_indexed_oloadrvvm8hf_same_eew */

    case 100:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4972; /* pred_indexed_oloadrvvm8hf_x2_greater_eew */

    case 101:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4762; /* pred_indexed_oloadrvvm4hf_same_eew */

    case 102:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4974; /* pred_indexed_oloadrvvm4hf_x2_greater_eew */

    case 103:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 346 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5104; /* pred_indexed_oloadrvvm4hf_x2_smaller_eew */

    case 104:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4764; /* pred_indexed_oloadrvvm2hf_same_eew */

    case 105:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4976; /* pred_indexed_oloadrvvm2hf_x2_greater_eew */

    case 106:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 346 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5106; /* pred_indexed_oloadrvvm2hf_x2_smaller_eew */

    case 107:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 374 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5156; /* pred_indexed_oloadrvvm2hf_x4_smaller_eew */

    case 108:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1547 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4766; /* pred_indexed_oloadrvvm1hf_same_eew */

    case 109:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4978; /* pred_indexed_oloadrvvm1hf_x2_greater_eew */

    case 110:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5108; /* pred_indexed_oloadrvvm1hf_x2_smaller_eew */

    case 111:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 375 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5158; /* pred_indexed_oloadrvvm1hf_x4_smaller_eew */

    case 112:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1547 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4768; /* pred_indexed_oloadrvvmf2hf_same_eew */

    case 113:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4980; /* pred_indexed_oloadrvvmf2hf_x2_greater_eew */

    case 114:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5110; /* pred_indexed_oloadrvvmf2hf_x2_smaller_eew */

    case 115:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 376 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5160; /* pred_indexed_oloadrvvmf2hf_x4_smaller_eew */

    case 116:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1548 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4770; /* pred_indexed_oloadrvvmf4hf_same_eew */

    case 117:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4982; /* pred_indexed_oloadrvvmf4hf_x2_greater_eew */

    case 118:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5112; /* pred_indexed_oloadrvvmf4hf_x2_smaller_eew */

    case 119:
      if (!(
#line 2549 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 377 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5162; /* pred_indexed_oloadrvvmf4hf_x4_smaller_eew */

    case 120:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4772; /* pred_indexed_oloadrvvm8sf_same_eew */

    case 121:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4994; /* pred_indexed_oloadrvvm8sf_x2_greater_eew */

    case 122:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5030; /* pred_indexed_oloadrvvm8sf_x4_greater_eew */

    case 123:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4774; /* pred_indexed_oloadrvvm4sf_same_eew */

    case 124:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4996; /* pred_indexed_oloadrvvm4sf_x2_greater_eew */

    case 125:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5032; /* pred_indexed_oloadrvvm4sf_x4_greater_eew */

    case 126:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 355 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5122; /* pred_indexed_oloadrvvm4sf_x2_smaller_eew */

    case 127:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4776; /* pred_indexed_oloadrvvm2sf_same_eew */

    case 128:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4998; /* pred_indexed_oloadrvvm2sf_x2_greater_eew */

    case 129:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5034; /* pred_indexed_oloadrvvm2sf_x4_greater_eew */

    case 130:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5124; /* pred_indexed_oloadrvvm2sf_x2_smaller_eew */

    case 131:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4778; /* pred_indexed_oloadrvvm1sf_same_eew */

    case 132:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5000; /* pred_indexed_oloadrvvm1sf_x2_greater_eew */

    case 133:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5036; /* pred_indexed_oloadrvvm1sf_x4_greater_eew */

    case 134:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5126; /* pred_indexed_oloadrvvm1sf_x2_smaller_eew */

    case 135:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1552 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4780; /* pred_indexed_oloadrvvmf2sf_same_eew */

    case 136:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5002; /* pred_indexed_oloadrvvmf2sf_x2_greater_eew */

    case 137:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 5038; /* pred_indexed_oloadrvvmf2sf_x4_greater_eew */

    case 138:
      if (!(
#line 2528 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 358 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32 && TARGET_64BIT)))
        return -1;
      return 5128; /* pred_indexed_oloadrvvmf2sf_x2_smaller_eew */

    case 139:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1554 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4782; /* pred_indexed_oloadrvvm8df_same_eew */

    case 140:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5012; /* pred_indexed_oloadrvvm8df_x2_greater_eew */

    case 141:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 325 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5048; /* pred_indexed_oloadrvvm8df_x4_greater_eew */

    case 142:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5064; /* pred_indexed_oloadrvvm8df_x8_greater_eew */

    case 143:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4784; /* pred_indexed_oloadrvvm4df_same_eew */

    case 144:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5014; /* pred_indexed_oloadrvvm4df_x2_greater_eew */

    case 145:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 325 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5050; /* pred_indexed_oloadrvvm4df_x4_greater_eew */

    case 146:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5066; /* pred_indexed_oloadrvvm4df_x8_greater_eew */

    case 147:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1556 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4786; /* pred_indexed_oloadrvvm2df_same_eew */

    case 148:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5016; /* pred_indexed_oloadrvvm2df_x2_greater_eew */

    case 149:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5052; /* pred_indexed_oloadrvvm2df_x4_greater_eew */

    case 150:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5068; /* pred_indexed_oloadrvvm2df_x8_greater_eew */

    case 151:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1557 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4788; /* pred_indexed_oloadrvvm1df_same_eew */

    case 152:
      if (!(
#line 2464 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5018; /* pred_indexed_oloadrvvm1df_x2_greater_eew */

    case 153:
      if (!(
#line 2485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5054; /* pred_indexed_oloadrvvm1df_x4_greater_eew */

    case 154:
      if (!(
#line 2506 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5070; /* pred_indexed_oloadrvvm1df_x8_greater_eew */

    case 155:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1559 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4790; /* pred_indexed_oloadv1qi_same_eew */

    case 156:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4792; /* pred_indexed_oloadv2qi_same_eew */

    case 157:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4794; /* pred_indexed_oloadv4qi_same_eew */

    case 158:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1562 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4796; /* pred_indexed_oloadv8qi_same_eew */

    case 159:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1563 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4798; /* pred_indexed_oloadv16qi_same_eew */

    case 160:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4800; /* pred_indexed_oloadv32qi_same_eew */

    case 161:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4802; /* pred_indexed_oloadv64qi_same_eew */

    case 162:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1566 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4804; /* pred_indexed_oloadv128qi_same_eew */

    case 163:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1567 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4806; /* pred_indexed_oloadv256qi_same_eew */

    case 164:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1568 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4808; /* pred_indexed_oloadv512qi_same_eew */

    case 165:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1569 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4810; /* pred_indexed_oloadv1024qi_same_eew */

    case 166:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1570 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4812; /* pred_indexed_oloadv2048qi_same_eew */

    case 167:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4814; /* pred_indexed_oloadv4096qi_same_eew */

    case 168:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4816; /* pred_indexed_oloadv1hi_same_eew */

    case 169:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4818; /* pred_indexed_oloadv2hi_same_eew */

    case 170:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4820; /* pred_indexed_oloadv4hi_same_eew */

    case 171:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4822; /* pred_indexed_oloadv8hi_same_eew */

    case 172:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4824; /* pred_indexed_oloadv16hi_same_eew */

    case 173:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4826; /* pred_indexed_oloadv32hi_same_eew */

    case 174:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4828; /* pred_indexed_oloadv64hi_same_eew */

    case 175:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4830; /* pred_indexed_oloadv128hi_same_eew */

    case 176:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4832; /* pred_indexed_oloadv256hi_same_eew */

    case 177:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4834; /* pred_indexed_oloadv512hi_same_eew */

    case 178:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4836; /* pred_indexed_oloadv1024hi_same_eew */

    case 179:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4838; /* pred_indexed_oloadv2048hi_same_eew */

    case 180:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4840; /* pred_indexed_oloadv1si_same_eew */

    case 181:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4842; /* pred_indexed_oloadv2si_same_eew */

    case 182:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4844; /* pred_indexed_oloadv4si_same_eew */

    case 183:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4846; /* pred_indexed_oloadv8si_same_eew */

    case 184:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4848; /* pred_indexed_oloadv16si_same_eew */

    case 185:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4850; /* pred_indexed_oloadv32si_same_eew */

    case 186:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4852; /* pred_indexed_oloadv64si_same_eew */

    case 187:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4854; /* pred_indexed_oloadv128si_same_eew */

    case 188:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4856; /* pred_indexed_oloadv256si_same_eew */

    case 189:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4858; /* pred_indexed_oloadv512si_same_eew */

    case 190:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4860; /* pred_indexed_oloadv1024si_same_eew */

    case 191:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4862; /* pred_indexed_oloadv1di_same_eew */

    case 192:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4864; /* pred_indexed_oloadv2di_same_eew */

    case 193:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4866; /* pred_indexed_oloadv4di_same_eew */

    case 194:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4868; /* pred_indexed_oloadv8di_same_eew */

    case 195:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4870; /* pred_indexed_oloadv16di_same_eew */

    case 196:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4872; /* pred_indexed_oloadv32di_same_eew */

    case 197:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4874; /* pred_indexed_oloadv64di_same_eew */

    case 198:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4876; /* pred_indexed_oloadv128di_same_eew */

    case 199:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4878; /* pred_indexed_oloadv256di_same_eew */

    case 200:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4880; /* pred_indexed_oloadv512di_same_eew */

    case 201:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 4882; /* pred_indexed_oloadv1hf_same_eew */

    case 202:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1607 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 4884; /* pred_indexed_oloadv2hf_same_eew */

    case 203:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1608 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 4886; /* pred_indexed_oloadv4hf_same_eew */

    case 204:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1609 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 4888; /* pred_indexed_oloadv8hf_same_eew */

    case 205:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1610 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 4890; /* pred_indexed_oloadv16hf_same_eew */

    case 206:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1611 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4892; /* pred_indexed_oloadv32hf_same_eew */

    case 207:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1612 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4894; /* pred_indexed_oloadv64hf_same_eew */

    case 208:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1613 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4896; /* pred_indexed_oloadv128hf_same_eew */

    case 209:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1614 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4898; /* pred_indexed_oloadv256hf_same_eew */

    case 210:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1615 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4900; /* pred_indexed_oloadv512hf_same_eew */

    case 211:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4902; /* pred_indexed_oloadv1024hf_same_eew */

    case 212:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4904; /* pred_indexed_oloadv2048hf_same_eew */

    case 213:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4906; /* pred_indexed_oloadv1sf_same_eew */

    case 214:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1619 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4908; /* pred_indexed_oloadv2sf_same_eew */

    case 215:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4910; /* pred_indexed_oloadv4sf_same_eew */

    case 216:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4912; /* pred_indexed_oloadv8sf_same_eew */

    case 217:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4914; /* pred_indexed_oloadv16sf_same_eew */

    case 218:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4916; /* pred_indexed_oloadv32sf_same_eew */

    case 219:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4918; /* pred_indexed_oloadv64sf_same_eew */

    case 220:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4920; /* pred_indexed_oloadv128sf_same_eew */

    case 221:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4922; /* pred_indexed_oloadv256sf_same_eew */

    case 222:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4924; /* pred_indexed_oloadv512sf_same_eew */

    case 223:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4926; /* pred_indexed_oloadv1024sf_same_eew */

    case 224:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4928; /* pred_indexed_oloadv1df_same_eew */

    case 225:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4930; /* pred_indexed_oloadv2df_same_eew */

    case 226:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4932; /* pred_indexed_oloadv4df_same_eew */

    case 227:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4934; /* pred_indexed_oloadv8df_same_eew */

    case 228:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4936; /* pred_indexed_oloadv16df_same_eew */

    case 229:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4938; /* pred_indexed_oloadv32df_same_eew */

    case 230:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4940; /* pred_indexed_oloadv64df_same_eew */

    case 231:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4942; /* pred_indexed_oloadv128df_same_eew */

    case 232:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4944; /* pred_indexed_oloadv256df_same_eew */

    case 233:
      if (!(
#line 2442 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4946; /* pred_indexed_oloadv512df_same_eew */

    case 234:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21006; /* pred_indexed_oloadrvvmf8x2qirvvmf8qi */

    case 235:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21008; /* pred_indexed_oloadrvvmf8x2qirvvmf4hi */

    case 236:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21010; /* pred_indexed_oloadrvvmf8x2qirvvmf2si */

    case 237:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21012; /* pred_indexed_oloadrvvmf8x2qirvvm1di */

    case 238:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21014; /* pred_indexed_oloadrvvmf8x3qirvvmf8qi */

    case 239:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21016; /* pred_indexed_oloadrvvmf8x3qirvvmf4hi */

    case 240:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21018; /* pred_indexed_oloadrvvmf8x3qirvvmf2si */

    case 241:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21020; /* pred_indexed_oloadrvvmf8x3qirvvm1di */

    case 242:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21022; /* pred_indexed_oloadrvvmf8x4qirvvmf8qi */

    case 243:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21024; /* pred_indexed_oloadrvvmf8x4qirvvmf4hi */

    case 244:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21026; /* pred_indexed_oloadrvvmf8x4qirvvmf2si */

    case 245:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21028; /* pred_indexed_oloadrvvmf8x4qirvvm1di */

    case 246:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21030; /* pred_indexed_oloadrvvmf8x5qirvvmf8qi */

    case 247:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21032; /* pred_indexed_oloadrvvmf8x5qirvvmf4hi */

    case 248:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21034; /* pred_indexed_oloadrvvmf8x5qirvvmf2si */

    case 249:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21036; /* pred_indexed_oloadrvvmf8x5qirvvm1di */

    case 250:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21038; /* pred_indexed_oloadrvvmf8x6qirvvmf8qi */

    case 251:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21040; /* pred_indexed_oloadrvvmf8x6qirvvmf4hi */

    case 252:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21042; /* pred_indexed_oloadrvvmf8x6qirvvmf2si */

    case 253:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21044; /* pred_indexed_oloadrvvmf8x6qirvvm1di */

    case 254:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21046; /* pred_indexed_oloadrvvmf8x7qirvvmf8qi */

    case 255:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21048; /* pred_indexed_oloadrvvmf8x7qirvvmf4hi */

    case 256:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21050; /* pred_indexed_oloadrvvmf8x7qirvvmf2si */

    case 257:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21052; /* pred_indexed_oloadrvvmf8x7qirvvm1di */

    case 258:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21054; /* pred_indexed_oloadrvvmf8x8qirvvmf8qi */

    case 259:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21056; /* pred_indexed_oloadrvvmf8x8qirvvmf4hi */

    case 260:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21058; /* pred_indexed_oloadrvvmf8x8qirvvmf2si */

    case 261:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21060; /* pred_indexed_oloadrvvmf8x8qirvvm1di */

    case 262:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21062; /* pred_indexed_oloadrvvmf4x2hirvvmf8qi */

    case 263:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21064; /* pred_indexed_oloadrvvmf4x2hirvvmf4hi */

    case 264:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21066; /* pred_indexed_oloadrvvmf4x2hirvvmf2si */

    case 265:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21068; /* pred_indexed_oloadrvvmf4x2hirvvm1di */

    case 266:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21070; /* pred_indexed_oloadrvvmf4x3hirvvmf8qi */

    case 267:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21072; /* pred_indexed_oloadrvvmf4x3hirvvmf4hi */

    case 268:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21074; /* pred_indexed_oloadrvvmf4x3hirvvmf2si */

    case 269:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21076; /* pred_indexed_oloadrvvmf4x3hirvvm1di */

    case 270:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21078; /* pred_indexed_oloadrvvmf4x4hirvvmf8qi */

    case 271:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21080; /* pred_indexed_oloadrvvmf4x4hirvvmf4hi */

    case 272:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21082; /* pred_indexed_oloadrvvmf4x4hirvvmf2si */

    case 273:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21084; /* pred_indexed_oloadrvvmf4x4hirvvm1di */

    case 274:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21086; /* pred_indexed_oloadrvvmf4x5hirvvmf8qi */

    case 275:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21088; /* pred_indexed_oloadrvvmf4x5hirvvmf4hi */

    case 276:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21090; /* pred_indexed_oloadrvvmf4x5hirvvmf2si */

    case 277:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21092; /* pred_indexed_oloadrvvmf4x5hirvvm1di */

    case 278:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21094; /* pred_indexed_oloadrvvmf4x6hirvvmf8qi */

    case 279:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21096; /* pred_indexed_oloadrvvmf4x6hirvvmf4hi */

    case 280:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21098; /* pred_indexed_oloadrvvmf4x6hirvvmf2si */

    case 281:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21100; /* pred_indexed_oloadrvvmf4x6hirvvm1di */

    case 282:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21102; /* pred_indexed_oloadrvvmf4x7hirvvmf8qi */

    case 283:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21104; /* pred_indexed_oloadrvvmf4x7hirvvmf4hi */

    case 284:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21106; /* pred_indexed_oloadrvvmf4x7hirvvmf2si */

    case 285:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21108; /* pred_indexed_oloadrvvmf4x7hirvvm1di */

    case 286:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21110; /* pred_indexed_oloadrvvmf4x8hirvvmf8qi */

    case 287:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21112; /* pred_indexed_oloadrvvmf4x8hirvvmf4hi */

    case 288:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21114; /* pred_indexed_oloadrvvmf4x8hirvvmf2si */

    case 289:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21116; /* pred_indexed_oloadrvvmf4x8hirvvm1di */

    case 290:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21118; /* pred_indexed_oloadrvvmf2x2sirvvmf8qi */

    case 291:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21120; /* pred_indexed_oloadrvvmf2x2sirvvmf4hi */

    case 292:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21122; /* pred_indexed_oloadrvvmf2x2sirvvmf2si */

    case 293:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21124; /* pred_indexed_oloadrvvmf2x2sirvvm1di */

    case 294:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21126; /* pred_indexed_oloadrvvmf2x3sirvvmf8qi */

    case 295:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21128; /* pred_indexed_oloadrvvmf2x3sirvvmf4hi */

    case 296:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21130; /* pred_indexed_oloadrvvmf2x3sirvvmf2si */

    case 297:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21132; /* pred_indexed_oloadrvvmf2x3sirvvm1di */

    case 298:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21134; /* pred_indexed_oloadrvvmf2x4sirvvmf8qi */

    case 299:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21136; /* pred_indexed_oloadrvvmf2x4sirvvmf4hi */

    case 300:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21138; /* pred_indexed_oloadrvvmf2x4sirvvmf2si */

    case 301:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21140; /* pred_indexed_oloadrvvmf2x4sirvvm1di */

    case 302:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21142; /* pred_indexed_oloadrvvmf2x5sirvvmf8qi */

    case 303:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21144; /* pred_indexed_oloadrvvmf2x5sirvvmf4hi */

    case 304:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21146; /* pred_indexed_oloadrvvmf2x5sirvvmf2si */

    case 305:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21148; /* pred_indexed_oloadrvvmf2x5sirvvm1di */

    case 306:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21150; /* pred_indexed_oloadrvvmf2x6sirvvmf8qi */

    case 307:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21152; /* pred_indexed_oloadrvvmf2x6sirvvmf4hi */

    case 308:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21154; /* pred_indexed_oloadrvvmf2x6sirvvmf2si */

    case 309:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21156; /* pred_indexed_oloadrvvmf2x6sirvvm1di */

    case 310:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21158; /* pred_indexed_oloadrvvmf2x7sirvvmf8qi */

    case 311:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21160; /* pred_indexed_oloadrvvmf2x7sirvvmf4hi */

    case 312:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21162; /* pred_indexed_oloadrvvmf2x7sirvvmf2si */

    case 313:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21164; /* pred_indexed_oloadrvvmf2x7sirvvm1di */

    case 314:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21166; /* pred_indexed_oloadrvvmf2x8sirvvmf8qi */

    case 315:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21168; /* pred_indexed_oloadrvvmf2x8sirvvmf4hi */

    case 316:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21170; /* pred_indexed_oloadrvvmf2x8sirvvmf2si */

    case 317:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
        return -1;
      return 21172; /* pred_indexed_oloadrvvmf2x8sirvvm1di */

    case 318:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21174; /* pred_indexed_oloadrvvm1x2dirvvmf8qi */

    case 319:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21176; /* pred_indexed_oloadrvvm1x2dirvvmf4hi */

    case 320:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21178; /* pred_indexed_oloadrvvm1x2dirvvmf2si */

    case 321:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21180; /* pred_indexed_oloadrvvm1x2dirvvm1di */

    case 322:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21182; /* pred_indexed_oloadrvvm1x3dirvvmf8qi */

    case 323:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21184; /* pred_indexed_oloadrvvm1x3dirvvmf4hi */

    case 324:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21186; /* pred_indexed_oloadrvvm1x3dirvvmf2si */

    case 325:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21188; /* pred_indexed_oloadrvvm1x3dirvvm1di */

    case 326:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21190; /* pred_indexed_oloadrvvm1x4dirvvmf8qi */

    case 327:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21192; /* pred_indexed_oloadrvvm1x4dirvvmf4hi */

    case 328:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21194; /* pred_indexed_oloadrvvm1x4dirvvmf2si */

    case 329:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21196; /* pred_indexed_oloadrvvm1x4dirvvm1di */

    case 330:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21198; /* pred_indexed_oloadrvvm1x5dirvvmf8qi */

    case 331:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21200; /* pred_indexed_oloadrvvm1x5dirvvmf4hi */

    case 332:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21202; /* pred_indexed_oloadrvvm1x5dirvvmf2si */

    case 333:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21204; /* pred_indexed_oloadrvvm1x5dirvvm1di */

    case 334:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21206; /* pred_indexed_oloadrvvm1x6dirvvmf8qi */

    case 335:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21208; /* pred_indexed_oloadrvvm1x6dirvvmf4hi */

    case 336:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21210; /* pred_indexed_oloadrvvm1x6dirvvmf2si */

    case 337:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21212; /* pred_indexed_oloadrvvm1x6dirvvm1di */

    case 338:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21214; /* pred_indexed_oloadrvvm1x7dirvvmf8qi */

    case 339:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21216; /* pred_indexed_oloadrvvm1x7dirvvmf4hi */

    case 340:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21218; /* pred_indexed_oloadrvvm1x7dirvvmf2si */

    case 341:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21220; /* pred_indexed_oloadrvvm1x7dirvvm1di */

    case 342:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21222; /* pred_indexed_oloadrvvm1x8dirvvmf8qi */

    case 343:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21224; /* pred_indexed_oloadrvvm1x8dirvvmf4hi */

    case 344:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21226; /* pred_indexed_oloadrvvm1x8dirvvmf2si */

    case 345:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21228; /* pred_indexed_oloadrvvm1x8dirvvm1di */

    case 346:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21230; /* pred_indexed_oloadrvvmf4x2bfrvvmf8qi */

    case 347:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21232; /* pred_indexed_oloadrvvmf4x2bfrvvmf4hi */

    case 348:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21234; /* pred_indexed_oloadrvvmf4x2bfrvvmf2si */

    case 349:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21236; /* pred_indexed_oloadrvvmf4x2bfrvvm1di */

    case 350:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21238; /* pred_indexed_oloadrvvmf4x3bfrvvmf8qi */

    case 351:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21240; /* pred_indexed_oloadrvvmf4x3bfrvvmf4hi */

    case 352:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21242; /* pred_indexed_oloadrvvmf4x3bfrvvmf2si */

    case 353:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21244; /* pred_indexed_oloadrvvmf4x3bfrvvm1di */

    case 354:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21246; /* pred_indexed_oloadrvvmf4x4bfrvvmf8qi */

    case 355:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21248; /* pred_indexed_oloadrvvmf4x4bfrvvmf4hi */

    case 356:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21250; /* pred_indexed_oloadrvvmf4x4bfrvvmf2si */

    case 357:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21252; /* pred_indexed_oloadrvvmf4x4bfrvvm1di */

    case 358:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21254; /* pred_indexed_oloadrvvmf4x5bfrvvmf8qi */

    case 359:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21256; /* pred_indexed_oloadrvvmf4x5bfrvvmf4hi */

    case 360:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21258; /* pred_indexed_oloadrvvmf4x5bfrvvmf2si */

    case 361:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21260; /* pred_indexed_oloadrvvmf4x5bfrvvm1di */

    case 362:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21262; /* pred_indexed_oloadrvvmf4x6bfrvvmf8qi */

    case 363:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21264; /* pred_indexed_oloadrvvmf4x6bfrvvmf4hi */

    case 364:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21266; /* pred_indexed_oloadrvvmf4x6bfrvvmf2si */

    case 365:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21268; /* pred_indexed_oloadrvvmf4x6bfrvvm1di */

    case 366:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21270; /* pred_indexed_oloadrvvmf4x7bfrvvmf8qi */

    case 367:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21272; /* pred_indexed_oloadrvvmf4x7bfrvvmf4hi */

    case 368:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21274; /* pred_indexed_oloadrvvmf4x7bfrvvmf2si */

    case 369:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21276; /* pred_indexed_oloadrvvmf4x7bfrvvm1di */

    case 370:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21278; /* pred_indexed_oloadrvvmf4x8bfrvvmf8qi */

    case 371:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21280; /* pred_indexed_oloadrvvmf4x8bfrvvmf4hi */

    case 372:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21282; /* pred_indexed_oloadrvvmf4x8bfrvvmf2si */

    case 373:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21284; /* pred_indexed_oloadrvvmf4x8bfrvvm1di */

    case 374:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21286; /* pred_indexed_oloadrvvmf4x2hfrvvmf8qi */

    case 375:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21288; /* pred_indexed_oloadrvvmf4x2hfrvvmf4hi */

    case 376:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21290; /* pred_indexed_oloadrvvmf4x2hfrvvmf2si */

    case 377:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21292; /* pred_indexed_oloadrvvmf4x2hfrvvm1di */

    case 378:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21294; /* pred_indexed_oloadrvvmf4x3hfrvvmf8qi */

    case 379:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21296; /* pred_indexed_oloadrvvmf4x3hfrvvmf4hi */

    case 380:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21298; /* pred_indexed_oloadrvvmf4x3hfrvvmf2si */

    case 381:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21300; /* pred_indexed_oloadrvvmf4x3hfrvvm1di */

    case 382:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21302; /* pred_indexed_oloadrvvmf4x4hfrvvmf8qi */

    case 383:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21304; /* pred_indexed_oloadrvvmf4x4hfrvvmf4hi */

    case 384:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21306; /* pred_indexed_oloadrvvmf4x4hfrvvmf2si */

    case 385:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21308; /* pred_indexed_oloadrvvmf4x4hfrvvm1di */

    case 386:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21310; /* pred_indexed_oloadrvvmf4x5hfrvvmf8qi */

    case 387:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21312; /* pred_indexed_oloadrvvmf4x5hfrvvmf4hi */

    case 388:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21314; /* pred_indexed_oloadrvvmf4x5hfrvvmf2si */

    case 389:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21316; /* pred_indexed_oloadrvvmf4x5hfrvvm1di */

    case 390:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21318; /* pred_indexed_oloadrvvmf4x6hfrvvmf8qi */

    case 391:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21320; /* pred_indexed_oloadrvvmf4x6hfrvvmf4hi */

    case 392:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21322; /* pred_indexed_oloadrvvmf4x6hfrvvmf2si */

    case 393:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21324; /* pred_indexed_oloadrvvmf4x6hfrvvm1di */

    case 394:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21326; /* pred_indexed_oloadrvvmf4x7hfrvvmf8qi */

    case 395:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21328; /* pred_indexed_oloadrvvmf4x7hfrvvmf4hi */

    case 396:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21330; /* pred_indexed_oloadrvvmf4x7hfrvvmf2si */

    case 397:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21332; /* pred_indexed_oloadrvvmf4x7hfrvvm1di */

    case 398:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21334; /* pred_indexed_oloadrvvmf4x8hfrvvmf8qi */

    case 399:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21336; /* pred_indexed_oloadrvvmf4x8hfrvvmf4hi */

    case 400:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21338; /* pred_indexed_oloadrvvmf4x8hfrvvmf2si */

    case 401:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21340; /* pred_indexed_oloadrvvmf4x8hfrvvm1di */

    case 402:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21342; /* pred_indexed_oloadrvvmf2x2sfrvvmf8qi */

    case 403:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21344; /* pred_indexed_oloadrvvmf2x2sfrvvmf4hi */

    case 404:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21346; /* pred_indexed_oloadrvvmf2x2sfrvvmf2si */

    case 405:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21348; /* pred_indexed_oloadrvvmf2x2sfrvvm1di */

    case 406:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21350; /* pred_indexed_oloadrvvmf2x3sfrvvmf8qi */

    case 407:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21352; /* pred_indexed_oloadrvvmf2x3sfrvvmf4hi */

    case 408:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21354; /* pred_indexed_oloadrvvmf2x3sfrvvmf2si */

    case 409:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21356; /* pred_indexed_oloadrvvmf2x3sfrvvm1di */

    case 410:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21358; /* pred_indexed_oloadrvvmf2x4sfrvvmf8qi */

    case 411:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21360; /* pred_indexed_oloadrvvmf2x4sfrvvmf4hi */

    case 412:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21362; /* pred_indexed_oloadrvvmf2x4sfrvvmf2si */

    case 413:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21364; /* pred_indexed_oloadrvvmf2x4sfrvvm1di */

    case 414:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21366; /* pred_indexed_oloadrvvmf2x5sfrvvmf8qi */

    case 415:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21368; /* pred_indexed_oloadrvvmf2x5sfrvvmf4hi */

    case 416:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21370; /* pred_indexed_oloadrvvmf2x5sfrvvmf2si */

    case 417:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21372; /* pred_indexed_oloadrvvmf2x5sfrvvm1di */

    case 418:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21374; /* pred_indexed_oloadrvvmf2x6sfrvvmf8qi */

    case 419:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21376; /* pred_indexed_oloadrvvmf2x6sfrvvmf4hi */

    case 420:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21378; /* pred_indexed_oloadrvvmf2x6sfrvvmf2si */

    case 421:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21380; /* pred_indexed_oloadrvvmf2x6sfrvvm1di */

    case 422:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21382; /* pred_indexed_oloadrvvmf2x7sfrvvmf8qi */

    case 423:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21384; /* pred_indexed_oloadrvvmf2x7sfrvvmf4hi */

    case 424:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21386; /* pred_indexed_oloadrvvmf2x7sfrvvmf2si */

    case 425:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21388; /* pred_indexed_oloadrvvmf2x7sfrvvm1di */

    case 426:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21390; /* pred_indexed_oloadrvvmf2x8sfrvvmf8qi */

    case 427:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21392; /* pred_indexed_oloadrvvmf2x8sfrvvmf4hi */

    case 428:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21394; /* pred_indexed_oloadrvvmf2x8sfrvvmf2si */

    case 429:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21396; /* pred_indexed_oloadrvvmf2x8sfrvvm1di */

    case 430:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21398; /* pred_indexed_oloadrvvm1x2dfrvvmf8qi */

    case 431:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21400; /* pred_indexed_oloadrvvm1x2dfrvvmf4hi */

    case 432:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21402; /* pred_indexed_oloadrvvm1x2dfrvvmf2si */

    case 433:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21404; /* pred_indexed_oloadrvvm1x2dfrvvm1di */

    case 434:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21406; /* pred_indexed_oloadrvvm1x3dfrvvmf8qi */

    case 435:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21408; /* pred_indexed_oloadrvvm1x3dfrvvmf4hi */

    case 436:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21410; /* pred_indexed_oloadrvvm1x3dfrvvmf2si */

    case 437:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21412; /* pred_indexed_oloadrvvm1x3dfrvvm1di */

    case 438:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21414; /* pred_indexed_oloadrvvm1x4dfrvvmf8qi */

    case 439:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21416; /* pred_indexed_oloadrvvm1x4dfrvvmf4hi */

    case 440:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21418; /* pred_indexed_oloadrvvm1x4dfrvvmf2si */

    case 441:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21420; /* pred_indexed_oloadrvvm1x4dfrvvm1di */

    case 442:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21422; /* pred_indexed_oloadrvvm1x5dfrvvmf8qi */

    case 443:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21424; /* pred_indexed_oloadrvvm1x5dfrvvmf4hi */

    case 444:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21426; /* pred_indexed_oloadrvvm1x5dfrvvmf2si */

    case 445:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21428; /* pred_indexed_oloadrvvm1x5dfrvvm1di */

    case 446:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21430; /* pred_indexed_oloadrvvm1x6dfrvvmf8qi */

    case 447:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21432; /* pred_indexed_oloadrvvm1x6dfrvvmf4hi */

    case 448:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21434; /* pred_indexed_oloadrvvm1x6dfrvvmf2si */

    case 449:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21436; /* pred_indexed_oloadrvvm1x6dfrvvm1di */

    case 450:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21438; /* pred_indexed_oloadrvvm1x7dfrvvmf8qi */

    case 451:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21440; /* pred_indexed_oloadrvvm1x7dfrvvmf4hi */

    case 452:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21442; /* pred_indexed_oloadrvvm1x7dfrvvmf2si */

    case 453:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21444; /* pred_indexed_oloadrvvm1x7dfrvvm1di */

    case 454:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 856 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21446; /* pred_indexed_oloadrvvm1x8dfrvvmf8qi */

    case 455:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 857 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21448; /* pred_indexed_oloadrvvm1x8dfrvvmf4hi */

    case 456:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 858 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21450; /* pred_indexed_oloadrvvm1x8dfrvvmf2si */

    case 457:
      if (!(
#line 8353 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 859 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21452; /* pred_indexed_oloadrvvm1x8dfrvvm1di */

    case 458:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21454; /* pred_indexed_oloadrvvmf4x2qirvvmf4qi */

    case 459:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21550; /* pred_indexed_oloadrvvmf4x2qirvvmf2hi */

    case 460:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21646; /* pred_indexed_oloadrvvmf4x2qirvvm1si */

    case 461:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21742; /* pred_indexed_oloadrvvmf4x2qirvvm2di */

    case 462:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21456; /* pred_indexed_oloadrvvmf4x3qirvvmf4qi */

    case 463:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21552; /* pred_indexed_oloadrvvmf4x3qirvvmf2hi */

    case 464:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21648; /* pred_indexed_oloadrvvmf4x3qirvvm1si */

    case 465:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21744; /* pred_indexed_oloadrvvmf4x3qirvvm2di */

    case 466:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21458; /* pred_indexed_oloadrvvmf4x4qirvvmf4qi */

    case 467:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21554; /* pred_indexed_oloadrvvmf4x4qirvvmf2hi */

    case 468:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21650; /* pred_indexed_oloadrvvmf4x4qirvvm1si */

    case 469:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21746; /* pred_indexed_oloadrvvmf4x4qirvvm2di */

    case 470:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21460; /* pred_indexed_oloadrvvmf4x5qirvvmf4qi */

    case 471:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21556; /* pred_indexed_oloadrvvmf4x5qirvvmf2hi */

    case 472:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21652; /* pred_indexed_oloadrvvmf4x5qirvvm1si */

    case 473:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21748; /* pred_indexed_oloadrvvmf4x5qirvvm2di */

    case 474:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21462; /* pred_indexed_oloadrvvmf4x6qirvvmf4qi */

    case 475:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21558; /* pred_indexed_oloadrvvmf4x6qirvvmf2hi */

    case 476:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21654; /* pred_indexed_oloadrvvmf4x6qirvvm1si */

    case 477:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21750; /* pred_indexed_oloadrvvmf4x6qirvvm2di */

    case 478:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21464; /* pred_indexed_oloadrvvmf4x7qirvvmf4qi */

    case 479:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21560; /* pred_indexed_oloadrvvmf4x7qirvvmf2hi */

    case 480:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21656; /* pred_indexed_oloadrvvmf4x7qirvvm1si */

    case 481:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21752; /* pred_indexed_oloadrvvmf4x7qirvvm2di */

    case 482:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21466; /* pred_indexed_oloadrvvmf4x8qirvvmf4qi */

    case 483:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21562; /* pred_indexed_oloadrvvmf4x8qirvvmf2hi */

    case 484:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21658; /* pred_indexed_oloadrvvmf4x8qirvvm1si */

    case 485:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21754; /* pred_indexed_oloadrvvmf4x8qirvvm2di */

    case 486:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21468; /* pred_indexed_oloadrvvmf2x2hirvvmf4qi */

    case 487:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21564; /* pred_indexed_oloadrvvmf2x2hirvvmf2hi */

    case 488:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21660; /* pred_indexed_oloadrvvmf2x2hirvvm1si */

    case 489:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21756; /* pred_indexed_oloadrvvmf2x2hirvvm2di */

    case 490:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21470; /* pred_indexed_oloadrvvmf2x3hirvvmf4qi */

    case 491:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21566; /* pred_indexed_oloadrvvmf2x3hirvvmf2hi */

    case 492:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21662; /* pred_indexed_oloadrvvmf2x3hirvvm1si */

    case 493:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21758; /* pred_indexed_oloadrvvmf2x3hirvvm2di */

    case 494:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21472; /* pred_indexed_oloadrvvmf2x4hirvvmf4qi */

    case 495:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21568; /* pred_indexed_oloadrvvmf2x4hirvvmf2hi */

    case 496:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21664; /* pred_indexed_oloadrvvmf2x4hirvvm1si */

    case 497:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21760; /* pred_indexed_oloadrvvmf2x4hirvvm2di */

    case 498:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21474; /* pred_indexed_oloadrvvmf2x5hirvvmf4qi */

    case 499:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21570; /* pred_indexed_oloadrvvmf2x5hirvvmf2hi */

    case 500:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21666; /* pred_indexed_oloadrvvmf2x5hirvvm1si */

    case 501:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21762; /* pred_indexed_oloadrvvmf2x5hirvvm2di */

    case 502:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21476; /* pred_indexed_oloadrvvmf2x6hirvvmf4qi */

    case 503:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21572; /* pred_indexed_oloadrvvmf2x6hirvvmf2hi */

    case 504:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21668; /* pred_indexed_oloadrvvmf2x6hirvvm1si */

    case 505:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21764; /* pred_indexed_oloadrvvmf2x6hirvvm2di */

    case 506:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21478; /* pred_indexed_oloadrvvmf2x7hirvvmf4qi */

    case 507:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21574; /* pred_indexed_oloadrvvmf2x7hirvvmf2hi */

    case 508:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21670; /* pred_indexed_oloadrvvmf2x7hirvvm1si */

    case 509:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21766; /* pred_indexed_oloadrvvmf2x7hirvvm2di */

    case 510:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21480; /* pred_indexed_oloadrvvmf2x8hirvvmf4qi */

    case 511:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21576; /* pred_indexed_oloadrvvmf2x8hirvvmf2hi */

    case 512:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21672; /* pred_indexed_oloadrvvmf2x8hirvvm1si */

    case 513:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21768; /* pred_indexed_oloadrvvmf2x8hirvvm2di */

    case 514:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21482; /* pred_indexed_oloadrvvm1x2sirvvmf4qi */

    case 515:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21578; /* pred_indexed_oloadrvvm1x2sirvvmf2hi */

    case 516:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21674; /* pred_indexed_oloadrvvm1x2sirvvm1si */

    case 517:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21770; /* pred_indexed_oloadrvvm1x2sirvvm2di */

    case 518:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21484; /* pred_indexed_oloadrvvm1x3sirvvmf4qi */

    case 519:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21580; /* pred_indexed_oloadrvvm1x3sirvvmf2hi */

    case 520:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21676; /* pred_indexed_oloadrvvm1x3sirvvm1si */

    case 521:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21772; /* pred_indexed_oloadrvvm1x3sirvvm2di */

    case 522:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21486; /* pred_indexed_oloadrvvm1x4sirvvmf4qi */

    case 523:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21582; /* pred_indexed_oloadrvvm1x4sirvvmf2hi */

    case 524:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21678; /* pred_indexed_oloadrvvm1x4sirvvm1si */

    case 525:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21774; /* pred_indexed_oloadrvvm1x4sirvvm2di */

    case 526:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21488; /* pred_indexed_oloadrvvm1x5sirvvmf4qi */

    case 527:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21584; /* pred_indexed_oloadrvvm1x5sirvvmf2hi */

    case 528:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21680; /* pred_indexed_oloadrvvm1x5sirvvm1si */

    case 529:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21776; /* pred_indexed_oloadrvvm1x5sirvvm2di */

    case 530:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21490; /* pred_indexed_oloadrvvm1x6sirvvmf4qi */

    case 531:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21586; /* pred_indexed_oloadrvvm1x6sirvvmf2hi */

    case 532:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21682; /* pred_indexed_oloadrvvm1x6sirvvm1si */

    case 533:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21778; /* pred_indexed_oloadrvvm1x6sirvvm2di */

    case 534:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21492; /* pred_indexed_oloadrvvm1x7sirvvmf4qi */

    case 535:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21588; /* pred_indexed_oloadrvvm1x7sirvvmf2hi */

    case 536:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21684; /* pred_indexed_oloadrvvm1x7sirvvm1si */

    case 537:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21780; /* pred_indexed_oloadrvvm1x7sirvvm2di */

    case 538:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21494; /* pred_indexed_oloadrvvm1x8sirvvmf4qi */

    case 539:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21590; /* pred_indexed_oloadrvvm1x8sirvvmf2hi */

    case 540:
      if (!
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21686; /* pred_indexed_oloadrvvm1x8sirvvm1si */

    case 541:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 21782; /* pred_indexed_oloadrvvm1x8sirvvm2di */

    case 542:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21496; /* pred_indexed_oloadrvvm2x2dirvvmf4qi */

    case 543:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21592; /* pred_indexed_oloadrvvm2x2dirvvmf2hi */

    case 544:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21688; /* pred_indexed_oloadrvvm2x2dirvvm1si */

    case 545:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21784; /* pred_indexed_oloadrvvm2x2dirvvm2di */

    case 546:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21498; /* pred_indexed_oloadrvvm2x3dirvvmf4qi */

    case 547:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21594; /* pred_indexed_oloadrvvm2x3dirvvmf2hi */

    case 548:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21690; /* pred_indexed_oloadrvvm2x3dirvvm1si */

    case 549:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21786; /* pred_indexed_oloadrvvm2x3dirvvm2di */

    case 550:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21500; /* pred_indexed_oloadrvvm2x4dirvvmf4qi */

    case 551:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21596; /* pred_indexed_oloadrvvm2x4dirvvmf2hi */

    case 552:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21692; /* pred_indexed_oloadrvvm2x4dirvvm1si */

    case 553:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21788; /* pred_indexed_oloadrvvm2x4dirvvm2di */

    case 554:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21502; /* pred_indexed_oloadrvvmf2x2bfrvvmf4qi */

    case 555:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21598; /* pred_indexed_oloadrvvmf2x2bfrvvmf2hi */

    case 556:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21694; /* pred_indexed_oloadrvvmf2x2bfrvvm1si */

    case 557:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21790; /* pred_indexed_oloadrvvmf2x2bfrvvm2di */

    case 558:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21504; /* pred_indexed_oloadrvvmf2x3bfrvvmf4qi */

    case 559:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21600; /* pred_indexed_oloadrvvmf2x3bfrvvmf2hi */

    case 560:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21696; /* pred_indexed_oloadrvvmf2x3bfrvvm1si */

    case 561:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21792; /* pred_indexed_oloadrvvmf2x3bfrvvm2di */

    case 562:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21506; /* pred_indexed_oloadrvvmf2x4bfrvvmf4qi */

    case 563:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21602; /* pred_indexed_oloadrvvmf2x4bfrvvmf2hi */

    case 564:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21698; /* pred_indexed_oloadrvvmf2x4bfrvvm1si */

    case 565:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21794; /* pred_indexed_oloadrvvmf2x4bfrvvm2di */

    case 566:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21508; /* pred_indexed_oloadrvvmf2x5bfrvvmf4qi */

    case 567:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21604; /* pred_indexed_oloadrvvmf2x5bfrvvmf2hi */

    case 568:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21700; /* pred_indexed_oloadrvvmf2x5bfrvvm1si */

    case 569:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21796; /* pred_indexed_oloadrvvmf2x5bfrvvm2di */

    case 570:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21510; /* pred_indexed_oloadrvvmf2x6bfrvvmf4qi */

    case 571:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21606; /* pred_indexed_oloadrvvmf2x6bfrvvmf2hi */

    case 572:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21702; /* pred_indexed_oloadrvvmf2x6bfrvvm1si */

    case 573:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21798; /* pred_indexed_oloadrvvmf2x6bfrvvm2di */

    case 574:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21512; /* pred_indexed_oloadrvvmf2x7bfrvvmf4qi */

    case 575:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21608; /* pred_indexed_oloadrvvmf2x7bfrvvmf2hi */

    case 576:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21704; /* pred_indexed_oloadrvvmf2x7bfrvvm1si */

    case 577:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21800; /* pred_indexed_oloadrvvmf2x7bfrvvm2di */

    case 578:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21514; /* pred_indexed_oloadrvvmf2x8bfrvvmf4qi */

    case 579:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21610; /* pred_indexed_oloadrvvmf2x8bfrvvmf2hi */

    case 580:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21706; /* pred_indexed_oloadrvvmf2x8bfrvvm1si */

    case 581:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 21802; /* pred_indexed_oloadrvvmf2x8bfrvvm2di */

    case 582:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21516; /* pred_indexed_oloadrvvmf2x2hfrvvmf4qi */

    case 583:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21612; /* pred_indexed_oloadrvvmf2x2hfrvvmf2hi */

    case 584:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21708; /* pred_indexed_oloadrvvmf2x2hfrvvm1si */

    case 585:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21804; /* pred_indexed_oloadrvvmf2x2hfrvvm2di */

    case 586:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21518; /* pred_indexed_oloadrvvmf2x3hfrvvmf4qi */

    case 587:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21614; /* pred_indexed_oloadrvvmf2x3hfrvvmf2hi */

    case 588:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21710; /* pred_indexed_oloadrvvmf2x3hfrvvm1si */

    case 589:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21806; /* pred_indexed_oloadrvvmf2x3hfrvvm2di */

    case 590:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21520; /* pred_indexed_oloadrvvmf2x4hfrvvmf4qi */

    case 591:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21616; /* pred_indexed_oloadrvvmf2x4hfrvvmf2hi */

    case 592:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21712; /* pred_indexed_oloadrvvmf2x4hfrvvm1si */

    case 593:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21808; /* pred_indexed_oloadrvvmf2x4hfrvvm2di */

    case 594:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21522; /* pred_indexed_oloadrvvmf2x5hfrvvmf4qi */

    case 595:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21618; /* pred_indexed_oloadrvvmf2x5hfrvvmf2hi */

    case 596:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21714; /* pred_indexed_oloadrvvmf2x5hfrvvm1si */

    case 597:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21810; /* pred_indexed_oloadrvvmf2x5hfrvvm2di */

    case 598:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21524; /* pred_indexed_oloadrvvmf2x6hfrvvmf4qi */

    case 599:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21620; /* pred_indexed_oloadrvvmf2x6hfrvvmf2hi */

    case 600:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21716; /* pred_indexed_oloadrvvmf2x6hfrvvm1si */

    case 601:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21812; /* pred_indexed_oloadrvvmf2x6hfrvvm2di */

    case 602:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21526; /* pred_indexed_oloadrvvmf2x7hfrvvmf4qi */

    case 603:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21622; /* pred_indexed_oloadrvvmf2x7hfrvvmf2hi */

    case 604:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21718; /* pred_indexed_oloadrvvmf2x7hfrvvm1si */

    case 605:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21814; /* pred_indexed_oloadrvvmf2x7hfrvvm2di */

    case 606:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21528; /* pred_indexed_oloadrvvmf2x8hfrvvmf4qi */

    case 607:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21624; /* pred_indexed_oloadrvvmf2x8hfrvvmf2hi */

    case 608:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21720; /* pred_indexed_oloadrvvmf2x8hfrvvm1si */

    case 609:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 21816; /* pred_indexed_oloadrvvmf2x8hfrvvm2di */

    case 610:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21530; /* pred_indexed_oloadrvvm1x2sfrvvmf4qi */

    case 611:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21626; /* pred_indexed_oloadrvvm1x2sfrvvmf2hi */

    case 612:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21722; /* pred_indexed_oloadrvvm1x2sfrvvm1si */

    case 613:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21818; /* pred_indexed_oloadrvvm1x2sfrvvm2di */

    case 614:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21532; /* pred_indexed_oloadrvvm1x3sfrvvmf4qi */

    case 615:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21628; /* pred_indexed_oloadrvvm1x3sfrvvmf2hi */

    case 616:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21724; /* pred_indexed_oloadrvvm1x3sfrvvm1si */

    case 617:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21820; /* pred_indexed_oloadrvvm1x3sfrvvm2di */

    case 618:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21534; /* pred_indexed_oloadrvvm1x4sfrvvmf4qi */

    case 619:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21630; /* pred_indexed_oloadrvvm1x4sfrvvmf2hi */

    case 620:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21726; /* pred_indexed_oloadrvvm1x4sfrvvm1si */

    case 621:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21822; /* pred_indexed_oloadrvvm1x4sfrvvm2di */

    case 622:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21536; /* pred_indexed_oloadrvvm1x5sfrvvmf4qi */

    case 623:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21632; /* pred_indexed_oloadrvvm1x5sfrvvmf2hi */

    case 624:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21728; /* pred_indexed_oloadrvvm1x5sfrvvm1si */

    case 625:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21824; /* pred_indexed_oloadrvvm1x5sfrvvm2di */

    case 626:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21538; /* pred_indexed_oloadrvvm1x6sfrvvmf4qi */

    case 627:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21634; /* pred_indexed_oloadrvvm1x6sfrvvmf2hi */

    case 628:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21730; /* pred_indexed_oloadrvvm1x6sfrvvm1si */

    case 629:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21826; /* pred_indexed_oloadrvvm1x6sfrvvm2di */

    case 630:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21540; /* pred_indexed_oloadrvvm1x7sfrvvmf4qi */

    case 631:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21636; /* pred_indexed_oloadrvvm1x7sfrvvmf2hi */

    case 632:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21732; /* pred_indexed_oloadrvvm1x7sfrvvm1si */

    case 633:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21828; /* pred_indexed_oloadrvvm1x7sfrvvm2di */

    case 634:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21542; /* pred_indexed_oloadrvvm1x8sfrvvmf4qi */

    case 635:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21638; /* pred_indexed_oloadrvvm1x8sfrvvmf2hi */

    case 636:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21734; /* pred_indexed_oloadrvvm1x8sfrvvm1si */

    case 637:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 21830; /* pred_indexed_oloadrvvm1x8sfrvvm2di */

    case 638:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21544; /* pred_indexed_oloadrvvm2x2dfrvvmf4qi */

    case 639:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21640; /* pred_indexed_oloadrvvm2x2dfrvvmf2hi */

    case 640:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21736; /* pred_indexed_oloadrvvm2x2dfrvvm1si */

    case 641:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21832; /* pred_indexed_oloadrvvm2x2dfrvvm2di */

    case 642:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21546; /* pred_indexed_oloadrvvm2x3dfrvvmf4qi */

    case 643:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21642; /* pred_indexed_oloadrvvm2x3dfrvvmf2hi */

    case 644:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21738; /* pred_indexed_oloadrvvm2x3dfrvvm1si */

    case 645:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21834; /* pred_indexed_oloadrvvm2x3dfrvvm2di */

    case 646:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21548; /* pred_indexed_oloadrvvm2x4dfrvvmf4qi */

    case 647:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21644; /* pred_indexed_oloadrvvm2x4dfrvvmf2hi */

    case 648:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21740; /* pred_indexed_oloadrvvm2x4dfrvvm1si */

    case 649:
      if (!(
#line 8374 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 866 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 21836; /* pred_indexed_oloadrvvm2x4dfrvvm2di */

    case 650:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21838; /* pred_indexed_oloadrvvmf2x2qirvvmf2qi */

    case 651:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21910; /* pred_indexed_oloadrvvmf2x2qirvvm1hi */

    case 652:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21982; /* pred_indexed_oloadrvvmf2x2qirvvm2si */

    case 653:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22054; /* pred_indexed_oloadrvvmf2x2qirvvm4di */

    case 654:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21840; /* pred_indexed_oloadrvvmf2x3qirvvmf2qi */

    case 655:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21912; /* pred_indexed_oloadrvvmf2x3qirvvm1hi */

    case 656:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21984; /* pred_indexed_oloadrvvmf2x3qirvvm2si */

    case 657:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22056; /* pred_indexed_oloadrvvmf2x3qirvvm4di */

    case 658:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21842; /* pred_indexed_oloadrvvmf2x4qirvvmf2qi */

    case 659:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21914; /* pred_indexed_oloadrvvmf2x4qirvvm1hi */

    case 660:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21986; /* pred_indexed_oloadrvvmf2x4qirvvm2si */

    case 661:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22058; /* pred_indexed_oloadrvvmf2x4qirvvm4di */

    case 662:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21844; /* pred_indexed_oloadrvvmf2x5qirvvmf2qi */

    case 663:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21916; /* pred_indexed_oloadrvvmf2x5qirvvm1hi */

    case 664:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21988; /* pred_indexed_oloadrvvmf2x5qirvvm2si */

    case 665:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22060; /* pred_indexed_oloadrvvmf2x5qirvvm4di */

    case 666:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21846; /* pred_indexed_oloadrvvmf2x6qirvvmf2qi */

    case 667:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21918; /* pred_indexed_oloadrvvmf2x6qirvvm1hi */

    case 668:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21990; /* pred_indexed_oloadrvvmf2x6qirvvm2si */

    case 669:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22062; /* pred_indexed_oloadrvvmf2x6qirvvm4di */

    case 670:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21848; /* pred_indexed_oloadrvvmf2x7qirvvmf2qi */

    case 671:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21920; /* pred_indexed_oloadrvvmf2x7qirvvm1hi */

    case 672:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21992; /* pred_indexed_oloadrvvmf2x7qirvvm2si */

    case 673:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22064; /* pred_indexed_oloadrvvmf2x7qirvvm4di */

    case 674:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21850; /* pred_indexed_oloadrvvmf2x8qirvvmf2qi */

    case 675:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21922; /* pred_indexed_oloadrvvmf2x8qirvvm1hi */

    case 676:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21994; /* pred_indexed_oloadrvvmf2x8qirvvm2si */

    case 677:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22066; /* pred_indexed_oloadrvvmf2x8qirvvm4di */

    case 678:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21852; /* pred_indexed_oloadrvvm1x2hirvvmf2qi */

    case 679:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21924; /* pred_indexed_oloadrvvm1x2hirvvm1hi */

    case 680:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21996; /* pred_indexed_oloadrvvm1x2hirvvm2si */

    case 681:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22068; /* pred_indexed_oloadrvvm1x2hirvvm4di */

    case 682:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21854; /* pred_indexed_oloadrvvm1x3hirvvmf2qi */

    case 683:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21926; /* pred_indexed_oloadrvvm1x3hirvvm1hi */

    case 684:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21998; /* pred_indexed_oloadrvvm1x3hirvvm2si */

    case 685:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22070; /* pred_indexed_oloadrvvm1x3hirvvm4di */

    case 686:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21856; /* pred_indexed_oloadrvvm1x4hirvvmf2qi */

    case 687:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21928; /* pred_indexed_oloadrvvm1x4hirvvm1hi */

    case 688:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22000; /* pred_indexed_oloadrvvm1x4hirvvm2si */

    case 689:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22072; /* pred_indexed_oloadrvvm1x4hirvvm4di */

    case 690:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21858; /* pred_indexed_oloadrvvm1x5hirvvmf2qi */

    case 691:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21930; /* pred_indexed_oloadrvvm1x5hirvvm1hi */

    case 692:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22002; /* pred_indexed_oloadrvvm1x5hirvvm2si */

    case 693:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22074; /* pred_indexed_oloadrvvm1x5hirvvm4di */

    case 694:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21860; /* pred_indexed_oloadrvvm1x6hirvvmf2qi */

    case 695:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21932; /* pred_indexed_oloadrvvm1x6hirvvm1hi */

    case 696:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22004; /* pred_indexed_oloadrvvm1x6hirvvm2si */

    case 697:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22076; /* pred_indexed_oloadrvvm1x6hirvvm4di */

    case 698:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21862; /* pred_indexed_oloadrvvm1x7hirvvmf2qi */

    case 699:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21934; /* pred_indexed_oloadrvvm1x7hirvvm1hi */

    case 700:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22006; /* pred_indexed_oloadrvvm1x7hirvvm2si */

    case 701:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22078; /* pred_indexed_oloadrvvm1x7hirvvm4di */

    case 702:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21864; /* pred_indexed_oloadrvvm1x8hirvvmf2qi */

    case 703:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21936; /* pred_indexed_oloadrvvm1x8hirvvm1hi */

    case 704:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22008; /* pred_indexed_oloadrvvm1x8hirvvm2si */

    case 705:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22080; /* pred_indexed_oloadrvvm1x8hirvvm4di */

    case 706:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21866; /* pred_indexed_oloadrvvm2x2sirvvmf2qi */

    case 707:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21938; /* pred_indexed_oloadrvvm2x2sirvvm1hi */

    case 708:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22010; /* pred_indexed_oloadrvvm2x2sirvvm2si */

    case 709:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22082; /* pred_indexed_oloadrvvm2x2sirvvm4di */

    case 710:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21868; /* pred_indexed_oloadrvvm2x3sirvvmf2qi */

    case 711:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21940; /* pred_indexed_oloadrvvm2x3sirvvm1hi */

    case 712:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22012; /* pred_indexed_oloadrvvm2x3sirvvm2si */

    case 713:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22084; /* pred_indexed_oloadrvvm2x3sirvvm4di */

    case 714:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21870; /* pred_indexed_oloadrvvm2x4sirvvmf2qi */

    case 715:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21942; /* pred_indexed_oloadrvvm2x4sirvvm1hi */

    case 716:
      if (!
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22014; /* pred_indexed_oloadrvvm2x4sirvvm2si */

    case 717:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22086; /* pred_indexed_oloadrvvm2x4sirvvm4di */

    case 718:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21872; /* pred_indexed_oloadrvvm4x2dirvvmf2qi */

    case 719:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21944; /* pred_indexed_oloadrvvm4x2dirvvm1hi */

    case 720:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22016; /* pred_indexed_oloadrvvm4x2dirvvm2si */

    case 721:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22088; /* pred_indexed_oloadrvvm4x2dirvvm4di */

    case 722:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21874; /* pred_indexed_oloadrvvm1x2bfrvvmf2qi */

    case 723:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21946; /* pred_indexed_oloadrvvm1x2bfrvvm1hi */

    case 724:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22018; /* pred_indexed_oloadrvvm1x2bfrvvm2si */

    case 725:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22090; /* pred_indexed_oloadrvvm1x2bfrvvm4di */

    case 726:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21876; /* pred_indexed_oloadrvvm1x3bfrvvmf2qi */

    case 727:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21948; /* pred_indexed_oloadrvvm1x3bfrvvm1hi */

    case 728:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22020; /* pred_indexed_oloadrvvm1x3bfrvvm2si */

    case 729:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22092; /* pred_indexed_oloadrvvm1x3bfrvvm4di */

    case 730:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21878; /* pred_indexed_oloadrvvm1x4bfrvvmf2qi */

    case 731:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21950; /* pred_indexed_oloadrvvm1x4bfrvvm1hi */

    case 732:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22022; /* pred_indexed_oloadrvvm1x4bfrvvm2si */

    case 733:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22094; /* pred_indexed_oloadrvvm1x4bfrvvm4di */

    case 734:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21880; /* pred_indexed_oloadrvvm1x5bfrvvmf2qi */

    case 735:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21952; /* pred_indexed_oloadrvvm1x5bfrvvm1hi */

    case 736:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22024; /* pred_indexed_oloadrvvm1x5bfrvvm2si */

    case 737:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22096; /* pred_indexed_oloadrvvm1x5bfrvvm4di */

    case 738:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21882; /* pred_indexed_oloadrvvm1x6bfrvvmf2qi */

    case 739:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21954; /* pred_indexed_oloadrvvm1x6bfrvvm1hi */

    case 740:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22026; /* pred_indexed_oloadrvvm1x6bfrvvm2si */

    case 741:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22098; /* pred_indexed_oloadrvvm1x6bfrvvm4di */

    case 742:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21884; /* pred_indexed_oloadrvvm1x7bfrvvmf2qi */

    case 743:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21956; /* pred_indexed_oloadrvvm1x7bfrvvm1hi */

    case 744:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22028; /* pred_indexed_oloadrvvm1x7bfrvvm2si */

    case 745:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22100; /* pred_indexed_oloadrvvm1x7bfrvvm4di */

    case 746:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21886; /* pred_indexed_oloadrvvm1x8bfrvvmf2qi */

    case 747:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21958; /* pred_indexed_oloadrvvm1x8bfrvvm1hi */

    case 748:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22030; /* pred_indexed_oloadrvvm1x8bfrvvm2si */

    case 749:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22102; /* pred_indexed_oloadrvvm1x8bfrvvm4di */

    case 750:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21888; /* pred_indexed_oloadrvvm1x2hfrvvmf2qi */

    case 751:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21960; /* pred_indexed_oloadrvvm1x2hfrvvm1hi */

    case 752:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22032; /* pred_indexed_oloadrvvm1x2hfrvvm2si */

    case 753:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22104; /* pred_indexed_oloadrvvm1x2hfrvvm4di */

    case 754:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21890; /* pred_indexed_oloadrvvm1x3hfrvvmf2qi */

    case 755:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21962; /* pred_indexed_oloadrvvm1x3hfrvvm1hi */

    case 756:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22034; /* pred_indexed_oloadrvvm1x3hfrvvm2si */

    case 757:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22106; /* pred_indexed_oloadrvvm1x3hfrvvm4di */

    case 758:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21892; /* pred_indexed_oloadrvvm1x4hfrvvmf2qi */

    case 759:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21964; /* pred_indexed_oloadrvvm1x4hfrvvm1hi */

    case 760:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22036; /* pred_indexed_oloadrvvm1x4hfrvvm2si */

    case 761:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22108; /* pred_indexed_oloadrvvm1x4hfrvvm4di */

    case 762:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21894; /* pred_indexed_oloadrvvm1x5hfrvvmf2qi */

    case 763:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21966; /* pred_indexed_oloadrvvm1x5hfrvvm1hi */

    case 764:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22038; /* pred_indexed_oloadrvvm1x5hfrvvm2si */

    case 765:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22110; /* pred_indexed_oloadrvvm1x5hfrvvm4di */

    case 766:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21896; /* pred_indexed_oloadrvvm1x6hfrvvmf2qi */

    case 767:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21968; /* pred_indexed_oloadrvvm1x6hfrvvm1hi */

    case 768:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22040; /* pred_indexed_oloadrvvm1x6hfrvvm2si */

    case 769:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22112; /* pred_indexed_oloadrvvm1x6hfrvvm4di */

    case 770:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21898; /* pred_indexed_oloadrvvm1x7hfrvvmf2qi */

    case 771:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21970; /* pred_indexed_oloadrvvm1x7hfrvvm1hi */

    case 772:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22042; /* pred_indexed_oloadrvvm1x7hfrvvm2si */

    case 773:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22114; /* pred_indexed_oloadrvvm1x7hfrvvm4di */

    case 774:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21900; /* pred_indexed_oloadrvvm1x8hfrvvmf2qi */

    case 775:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21972; /* pred_indexed_oloadrvvm1x8hfrvvm1hi */

    case 776:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22044; /* pred_indexed_oloadrvvm1x8hfrvvm2si */

    case 777:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22116; /* pred_indexed_oloadrvvm1x8hfrvvm4di */

    case 778:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21902; /* pred_indexed_oloadrvvm2x2sfrvvmf2qi */

    case 779:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21974; /* pred_indexed_oloadrvvm2x2sfrvvm1hi */

    case 780:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22046; /* pred_indexed_oloadrvvm2x2sfrvvm2si */

    case 781:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22118; /* pred_indexed_oloadrvvm2x2sfrvvm4di */

    case 782:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21904; /* pred_indexed_oloadrvvm2x3sfrvvmf2qi */

    case 783:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21976; /* pred_indexed_oloadrvvm2x3sfrvvm1hi */

    case 784:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22048; /* pred_indexed_oloadrvvm2x3sfrvvm2si */

    case 785:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22120; /* pred_indexed_oloadrvvm2x3sfrvvm4di */

    case 786:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21906; /* pred_indexed_oloadrvvm2x4sfrvvmf2qi */

    case 787:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21978; /* pred_indexed_oloadrvvm2x4sfrvvm1hi */

    case 788:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22050; /* pred_indexed_oloadrvvm2x4sfrvvm2si */

    case 789:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22122; /* pred_indexed_oloadrvvm2x4sfrvvm4di */

    case 790:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21908; /* pred_indexed_oloadrvvm4x2dfrvvmf2qi */

    case 791:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21980; /* pred_indexed_oloadrvvm4x2dfrvvm1hi */

    case 792:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22052; /* pred_indexed_oloadrvvm4x2dfrvvm2si */

    case 793:
      if (!(
#line 8395 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22124; /* pred_indexed_oloadrvvm4x2dfrvvm4di */

    case 794:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22126; /* pred_indexed_oloadrvvm1x2qirvvm1qi */

    case 795:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22128; /* pred_indexed_oloadrvvm1x2qirvvm2hi */

    case 796:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22130; /* pred_indexed_oloadrvvm1x2qirvvm4si */

    case 797:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22132; /* pred_indexed_oloadrvvm1x2qirvvm8di */

    case 798:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22134; /* pred_indexed_oloadrvvm1x3qirvvm1qi */

    case 799:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22136; /* pred_indexed_oloadrvvm1x3qirvvm2hi */

    case 800:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22138; /* pred_indexed_oloadrvvm1x3qirvvm4si */

    case 801:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22140; /* pred_indexed_oloadrvvm1x3qirvvm8di */

    case 802:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22142; /* pred_indexed_oloadrvvm1x4qirvvm1qi */

    case 803:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22144; /* pred_indexed_oloadrvvm1x4qirvvm2hi */

    case 804:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22146; /* pred_indexed_oloadrvvm1x4qirvvm4si */

    case 805:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22148; /* pred_indexed_oloadrvvm1x4qirvvm8di */

    case 806:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22150; /* pred_indexed_oloadrvvm1x5qirvvm1qi */

    case 807:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22152; /* pred_indexed_oloadrvvm1x5qirvvm2hi */

    case 808:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22154; /* pred_indexed_oloadrvvm1x5qirvvm4si */

    case 809:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22156; /* pred_indexed_oloadrvvm1x5qirvvm8di */

    case 810:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22158; /* pred_indexed_oloadrvvm1x6qirvvm1qi */

    case 811:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22160; /* pred_indexed_oloadrvvm1x6qirvvm2hi */

    case 812:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22162; /* pred_indexed_oloadrvvm1x6qirvvm4si */

    case 813:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22164; /* pred_indexed_oloadrvvm1x6qirvvm8di */

    case 814:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22166; /* pred_indexed_oloadrvvm1x7qirvvm1qi */

    case 815:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22168; /* pred_indexed_oloadrvvm1x7qirvvm2hi */

    case 816:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22170; /* pred_indexed_oloadrvvm1x7qirvvm4si */

    case 817:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22172; /* pred_indexed_oloadrvvm1x7qirvvm8di */

    case 818:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22174; /* pred_indexed_oloadrvvm1x8qirvvm1qi */

    case 819:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22176; /* pred_indexed_oloadrvvm1x8qirvvm2hi */

    case 820:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22178; /* pred_indexed_oloadrvvm1x8qirvvm4si */

    case 821:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22180; /* pred_indexed_oloadrvvm1x8qirvvm8di */

    case 822:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22182; /* pred_indexed_oloadrvvm2x2hirvvm1qi */

    case 823:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22184; /* pred_indexed_oloadrvvm2x2hirvvm2hi */

    case 824:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22186; /* pred_indexed_oloadrvvm2x2hirvvm4si */

    case 825:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22188; /* pred_indexed_oloadrvvm2x2hirvvm8di */

    case 826:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22190; /* pred_indexed_oloadrvvm2x3hirvvm1qi */

    case 827:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22192; /* pred_indexed_oloadrvvm2x3hirvvm2hi */

    case 828:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22194; /* pred_indexed_oloadrvvm2x3hirvvm4si */

    case 829:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22196; /* pred_indexed_oloadrvvm2x3hirvvm8di */

    case 830:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22198; /* pred_indexed_oloadrvvm2x4hirvvm1qi */

    case 831:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22200; /* pred_indexed_oloadrvvm2x4hirvvm2hi */

    case 832:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22202; /* pred_indexed_oloadrvvm2x4hirvvm4si */

    case 833:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22204; /* pred_indexed_oloadrvvm2x4hirvvm8di */

    case 834:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22206; /* pred_indexed_oloadrvvm4x2sirvvm1qi */

    case 835:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22208; /* pred_indexed_oloadrvvm4x2sirvvm2hi */

    case 836:
      if (!
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22210; /* pred_indexed_oloadrvvm4x2sirvvm4si */

    case 837:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22212; /* pred_indexed_oloadrvvm4x2sirvvm8di */

    case 838:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22214; /* pred_indexed_oloadrvvm2x2bfrvvm1qi */

    case 839:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22216; /* pred_indexed_oloadrvvm2x2bfrvvm2hi */

    case 840:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22218; /* pred_indexed_oloadrvvm2x2bfrvvm4si */

    case 841:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22220; /* pred_indexed_oloadrvvm2x2bfrvvm8di */

    case 842:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22222; /* pred_indexed_oloadrvvm2x3bfrvvm1qi */

    case 843:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22224; /* pred_indexed_oloadrvvm2x3bfrvvm2hi */

    case 844:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22226; /* pred_indexed_oloadrvvm2x3bfrvvm4si */

    case 845:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22228; /* pred_indexed_oloadrvvm2x3bfrvvm8di */

    case 846:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22230; /* pred_indexed_oloadrvvm2x4bfrvvm1qi */

    case 847:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22232; /* pred_indexed_oloadrvvm2x4bfrvvm2hi */

    case 848:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22234; /* pred_indexed_oloadrvvm2x4bfrvvm4si */

    case 849:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22236; /* pred_indexed_oloadrvvm2x4bfrvvm8di */

    case 850:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22238; /* pred_indexed_oloadrvvm2x2hfrvvm1qi */

    case 851:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22240; /* pred_indexed_oloadrvvm2x2hfrvvm2hi */

    case 852:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22242; /* pred_indexed_oloadrvvm2x2hfrvvm4si */

    case 853:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22244; /* pred_indexed_oloadrvvm2x2hfrvvm8di */

    case 854:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22246; /* pred_indexed_oloadrvvm2x3hfrvvm1qi */

    case 855:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22248; /* pred_indexed_oloadrvvm2x3hfrvvm2hi */

    case 856:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22250; /* pred_indexed_oloadrvvm2x3hfrvvm4si */

    case 857:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22252; /* pred_indexed_oloadrvvm2x3hfrvvm8di */

    case 858:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22254; /* pred_indexed_oloadrvvm2x4hfrvvm1qi */

    case 859:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22256; /* pred_indexed_oloadrvvm2x4hfrvvm2hi */

    case 860:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22258; /* pred_indexed_oloadrvvm2x4hfrvvm4si */

    case 861:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22260; /* pred_indexed_oloadrvvm2x4hfrvvm8di */

    case 862:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22262; /* pred_indexed_oloadrvvm4x2sfrvvm1qi */

    case 863:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22264; /* pred_indexed_oloadrvvm4x2sfrvvm2hi */

    case 864:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22266; /* pred_indexed_oloadrvvm4x2sfrvvm4si */

    case 865:
      if (!(
#line 8416 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22268; /* pred_indexed_oloadrvvm4x2sfrvvm8di */

    case 866:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22270; /* pred_indexed_oloadrvvm2x2qirvvm2qi */

    case 867:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22272; /* pred_indexed_oloadrvvm2x2qirvvm4hi */

    case 868:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22274; /* pred_indexed_oloadrvvm2x2qirvvm8si */

    case 869:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22276; /* pred_indexed_oloadrvvm2x3qirvvm2qi */

    case 870:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22278; /* pred_indexed_oloadrvvm2x3qirvvm4hi */

    case 871:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22280; /* pred_indexed_oloadrvvm2x3qirvvm8si */

    case 872:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22282; /* pred_indexed_oloadrvvm2x4qirvvm2qi */

    case 873:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22284; /* pred_indexed_oloadrvvm2x4qirvvm4hi */

    case 874:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22286; /* pred_indexed_oloadrvvm2x4qirvvm8si */

    case 875:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22288; /* pred_indexed_oloadrvvm4x2hirvvm2qi */

    case 876:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22290; /* pred_indexed_oloadrvvm4x2hirvvm4hi */

    case 877:
      if (!
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22292; /* pred_indexed_oloadrvvm4x2hirvvm8si */

    case 878:
      if (!(
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22294; /* pred_indexed_oloadrvvm4x2bfrvvm2qi */

    case 879:
      if (!(
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22296; /* pred_indexed_oloadrvvm4x2bfrvvm4hi */

    case 880:
      if (!(
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22298; /* pred_indexed_oloadrvvm4x2bfrvvm8si */

    case 881:
      if (!(
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22300; /* pred_indexed_oloadrvvm4x2hfrvvm2qi */

    case 882:
      if (!(
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22302; /* pred_indexed_oloadrvvm4x2hfrvvm4hi */

    case 883:
      if (!(
#line 8437 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22304; /* pred_indexed_oloadrvvm4x2hfrvvm8si */

    case 884:
      if (!
#line 8458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22306; /* pred_indexed_oloadrvvm4x2qirvvm4qi */

    case 885:
      if (!
#line 8458 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22308; /* pred_indexed_oloadrvvm4x2qirvvm8hi */

    default:
      return -1;
    }
}

 int
recog_884 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5496; /* pred_udivrvvm8qi */

    case 1:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5513; /* pred_udivrvvm4qi */

    case 2:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5530; /* pred_udivrvvm2qi */

    case 3:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5547; /* pred_udivrvvm1qi */

    case 4:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5564; /* pred_udivrvvm8hi */

    case 5:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5581; /* pred_udivrvvm4hi */

    case 6:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5598; /* pred_udivrvvm2hi */

    case 7:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5615; /* pred_udivrvvm1hi */

    case 8:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5632; /* pred_udivrvvm8si */

    case 9:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5649; /* pred_udivrvvm4si */

    case 10:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5666; /* pred_udivrvvm2si */

    case 11:
      if (!
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5683; /* pred_udivrvvm1si */

    case 12:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5700; /* pred_udivrvvm8di */

    case 13:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5717; /* pred_udivrvvm4di */

    case 14:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5734; /* pred_udivrvvm2di */

    case 15:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5751; /* pred_udivrvvm1di */

    case 16:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5768; /* pred_udivrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5785; /* pred_udivrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5802; /* pred_udivrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5819; /* pred_udivrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5836; /* pred_udivrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5853; /* pred_udivrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5870; /* pred_udivv1qi */

    case 23:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5887; /* pred_udivv2qi */

    case 24:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5904; /* pred_udivv4qi */

    case 25:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5921; /* pred_udivv8qi */

    case 26:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5938; /* pred_udivv16qi */

    case 27:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5955; /* pred_udivv32qi */

    case 28:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5972; /* pred_udivv64qi */

    case 29:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5989; /* pred_udivv128qi */

    case 30:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6006; /* pred_udivv256qi */

    case 31:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6023; /* pred_udivv512qi */

    case 32:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6040; /* pred_udivv1024qi */

    case 33:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6057; /* pred_udivv2048qi */

    case 34:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6074; /* pred_udivv4096qi */

    case 35:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6091; /* pred_udivv1hi */

    case 36:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6108; /* pred_udivv2hi */

    case 37:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6125; /* pred_udivv4hi */

    case 38:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6142; /* pred_udivv8hi */

    case 39:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6159; /* pred_udivv16hi */

    case 40:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6176; /* pred_udivv32hi */

    case 41:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6193; /* pred_udivv64hi */

    case 42:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6210; /* pred_udivv128hi */

    case 43:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6227; /* pred_udivv256hi */

    case 44:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6244; /* pred_udivv512hi */

    case 45:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6261; /* pred_udivv1024hi */

    case 46:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6278; /* pred_udivv2048hi */

    case 47:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6295; /* pred_udivv1si */

    case 48:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6312; /* pred_udivv2si */

    case 49:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6329; /* pred_udivv4si */

    case 50:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6346; /* pred_udivv8si */

    case 51:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6363; /* pred_udivv16si */

    case 52:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6380; /* pred_udivv32si */

    case 53:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6397; /* pred_udivv64si */

    case 54:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6414; /* pred_udivv128si */

    case 55:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6431; /* pred_udivv256si */

    case 56:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6448; /* pred_udivv512si */

    case 57:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6465; /* pred_udivv1024si */

    case 58:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6482; /* pred_udivv1di */

    case 59:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6499; /* pred_udivv2di */

    case 60:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6516; /* pred_udivv4di */

    case 61:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6533; /* pred_udivv8di */

    case 62:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6550; /* pred_udivv16di */

    case 63:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6567; /* pred_udivv32di */

    case 64:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6584; /* pred_udivv64di */

    case 65:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6601; /* pred_udivv128di */

    case 66:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6618; /* pred_udivv256di */

    case 67:
      if (!(
#line 2722 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6635; /* pred_udivv512di */

    case 68:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7330; /* pred_udivrvvm8qi_scalar */

    case 69:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7335; /* pred_udivrvvm4qi_scalar */

    case 70:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7340; /* pred_udivrvvm2qi_scalar */

    case 71:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7345; /* pred_udivrvvm1qi_scalar */

    case 72:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7350; /* pred_udivrvvmf2qi_scalar */

    case 73:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7355; /* pred_udivrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7360; /* pred_udivrvvmf8qi_scalar */

    case 75:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7365; /* pred_udivrvvm8hi_scalar */

    case 76:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7370; /* pred_udivrvvm4hi_scalar */

    case 77:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7375; /* pred_udivrvvm2hi_scalar */

    case 78:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7380; /* pred_udivrvvm1hi_scalar */

    case 79:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7385; /* pred_udivrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7390; /* pred_udivrvvmf4hi_scalar */

    case 81:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7395; /* pred_udivrvvm8si_scalar */

    case 82:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7400; /* pred_udivrvvm4si_scalar */

    case 83:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7405; /* pred_udivrvvm2si_scalar */

    case 84:
      if (!
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7410; /* pred_udivrvvm1si_scalar */

    case 85:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7415; /* pred_udivrvvmf2si_scalar */

    case 86:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7420; /* pred_udivv1qi_scalar */

    case 87:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7425; /* pred_udivv2qi_scalar */

    case 88:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7430; /* pred_udivv4qi_scalar */

    case 89:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7435; /* pred_udivv8qi_scalar */

    case 90:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7440; /* pred_udivv16qi_scalar */

    case 91:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7445; /* pred_udivv32qi_scalar */

    case 92:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7450; /* pred_udivv64qi_scalar */

    case 93:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7455; /* pred_udivv128qi_scalar */

    case 94:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7460; /* pred_udivv256qi_scalar */

    case 95:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7465; /* pred_udivv512qi_scalar */

    case 96:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7470; /* pred_udivv1024qi_scalar */

    case 97:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7475; /* pred_udivv2048qi_scalar */

    case 98:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7480; /* pred_udivv4096qi_scalar */

    case 99:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7485; /* pred_udivv1hi_scalar */

    case 100:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7490; /* pred_udivv2hi_scalar */

    case 101:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7495; /* pred_udivv4hi_scalar */

    case 102:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7500; /* pred_udivv8hi_scalar */

    case 103:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7505; /* pred_udivv16hi_scalar */

    case 104:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7510; /* pred_udivv32hi_scalar */

    case 105:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7515; /* pred_udivv64hi_scalar */

    case 106:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7520; /* pred_udivv128hi_scalar */

    case 107:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7525; /* pred_udivv256hi_scalar */

    case 108:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7530; /* pred_udivv512hi_scalar */

    case 109:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7535; /* pred_udivv1024hi_scalar */

    case 110:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7540; /* pred_udivv2048hi_scalar */

    case 111:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7545; /* pred_udivv1si_scalar */

    case 112:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7550; /* pred_udivv2si_scalar */

    case 113:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7555; /* pred_udivv4si_scalar */

    case 114:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7560; /* pred_udivv8si_scalar */

    case 115:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7565; /* pred_udivv16si_scalar */

    case 116:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7570; /* pred_udivv32si_scalar */

    case 117:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7575; /* pred_udivv64si_scalar */

    case 118:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7580; /* pred_udivv128si_scalar */

    case 119:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7585; /* pred_udivv256si_scalar */

    case 120:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7590; /* pred_udivv512si_scalar */

    case 121:
      if (!(
#line 2801 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7595; /* pred_udivv1024si_scalar */

    case 122:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7906; /* *pred_udivrvvm8di_scalar */

    case 123:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7911; /* *pred_udivrvvm4di_scalar */

    case 124:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7916; /* *pred_udivrvvm2di_scalar */

    case 125:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7921; /* *pred_udivrvvm1di_scalar */

    case 126:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7926; /* *pred_udivv1di_scalar */

    case 127:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7931; /* *pred_udivv2di_scalar */

    case 128:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7936; /* *pred_udivv4di_scalar */

    case 129:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7941; /* *pred_udivv8di_scalar */

    case 130:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7946; /* *pred_udivv16di_scalar */

    case 131:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7951; /* *pred_udivv32di_scalar */

    case 132:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7956; /* *pred_udivv64di_scalar */

    case 133:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7961; /* *pred_udivv128di_scalar */

    case 134:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7966; /* *pred_udivv256di_scalar */

    case 135:
      if (!(
#line 2954 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7971; /* *pred_udivv512di_scalar */

    case 136:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7976; /* *pred_udivrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7981; /* *pred_udivrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7986; /* *pred_udivrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7991; /* *pred_udivrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7996; /* *pred_udivv1di_extended_scalar */

    case 141:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8001; /* *pred_udivv2di_extended_scalar */

    case 142:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8006; /* *pred_udivv4di_extended_scalar */

    case 143:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8011; /* *pred_udivv8di_extended_scalar */

    case 144:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8016; /* *pred_udivv16di_extended_scalar */

    case 145:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8021; /* *pred_udivv32di_extended_scalar */

    case 146:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8026; /* *pred_udivv64di_extended_scalar */

    case 147:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8031; /* *pred_udivv128di_extended_scalar */

    case 148:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8036; /* *pred_udivv256di_extended_scalar */

    case 149:
      if (!(
#line 2976 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8041; /* *pred_udivv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_893 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      switch (pattern494 (x2))
        {
        case 0:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10873; /* pred_ussubrvvm8qi */

        case 1:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10877; /* pred_ussubrvvm4qi */

        case 2:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10881; /* pred_ussubrvvm2qi */

        case 3:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10885; /* pred_ussubrvvm1qi */

        case 4:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10889; /* pred_ussubrvvm8hi */

        case 5:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10893; /* pred_ussubrvvm4hi */

        case 6:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10897; /* pred_ussubrvvm2hi */

        case 7:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10901; /* pred_ussubrvvm1hi */

        case 8:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10905; /* pred_ussubrvvm8si */

        case 9:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10909; /* pred_ussubrvvm4si */

        case 10:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10913; /* pred_ussubrvvm2si */

        case 11:
          if (!
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10917; /* pred_ussubrvvm1si */

        case 12:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10921; /* pred_ussubrvvm8di */

        case 13:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10925; /* pred_ussubrvvm4di */

        case 14:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10929; /* pred_ussubrvvm2di */

        case 15:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10933; /* pred_ussubrvvm1di */

        case 16:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10937; /* pred_ussubrvvmf2qi */

        case 17:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10941; /* pred_ussubrvvmf4qi */

        case 18:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10945; /* pred_ussubrvvmf8qi */

        case 19:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 10949; /* pred_ussubrvvmf2hi */

        case 20:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10953; /* pred_ussubrvvmf4hi */

        case 21:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 10957; /* pred_ussubrvvmf2si */

        case 22:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 10961; /* pred_ussubv1qi */

        case 23:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 10965; /* pred_ussubv2qi */

        case 24:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 10969; /* pred_ussubv4qi */

        case 25:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 10973; /* pred_ussubv8qi */

        case 26:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 10977; /* pred_ussubv16qi */

        case 27:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 10981; /* pred_ussubv32qi */

        case 28:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10985; /* pred_ussubv64qi */

        case 29:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10989; /* pred_ussubv128qi */

        case 30:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10993; /* pred_ussubv256qi */

        case 31:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10997; /* pred_ussubv512qi */

        case 32:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11001; /* pred_ussubv1024qi */

        case 33:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11005; /* pred_ussubv2048qi */

        case 34:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11009; /* pred_ussubv4096qi */

        case 35:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11013; /* pred_ussubv1hi */

        case 36:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11017; /* pred_ussubv2hi */

        case 37:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11021; /* pred_ussubv4hi */

        case 38:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11025; /* pred_ussubv8hi */

        case 39:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11029; /* pred_ussubv16hi */

        case 40:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11033; /* pred_ussubv32hi */

        case 41:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11037; /* pred_ussubv64hi */

        case 42:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11041; /* pred_ussubv128hi */

        case 43:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11045; /* pred_ussubv256hi */

        case 44:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11049; /* pred_ussubv512hi */

        case 45:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11053; /* pred_ussubv1024hi */

        case 46:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11057; /* pred_ussubv2048hi */

        case 47:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11061; /* pred_ussubv1si */

        case 48:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11065; /* pred_ussubv2si */

        case 49:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11069; /* pred_ussubv4si */

        case 50:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11073; /* pred_ussubv8si */

        case 51:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11077; /* pred_ussubv16si */

        case 52:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11081; /* pred_ussubv32si */

        case 53:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11085; /* pred_ussubv64si */

        case 54:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11089; /* pred_ussubv128si */

        case 55:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11093; /* pred_ussubv256si */

        case 56:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11097; /* pred_ussubv512si */

        case 57:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11101; /* pred_ussubv1024si */

        case 58:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11105; /* pred_ussubv1di */

        case 59:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11109; /* pred_ussubv2di */

        case 60:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11113; /* pred_ussubv4di */

        case 61:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11117; /* pred_ussubv8di */

        case 62:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11121; /* pred_ussubv16di */

        case 63:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11125; /* pred_ussubv32di */

        case 64:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11129; /* pred_ussubv64di */

        case 65:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11133; /* pred_ussubv128di */

        case 66:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11137; /* pred_ussubv256di */

        case 67:
          if (!(
#line 4317 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11141; /* pred_ussubv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern601 (x2))
        {
        case 0:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11251; /* pred_ussubrvvm8qi_scalar */

        case 1:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11253; /* pred_ussubrvvm4qi_scalar */

        case 2:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11255; /* pred_ussubrvvm2qi_scalar */

        case 3:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11257; /* pred_ussubrvvm1qi_scalar */

        case 4:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11259; /* pred_ussubrvvmf2qi_scalar */

        case 5:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11261; /* pred_ussubrvvmf4qi_scalar */

        case 6:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11263; /* pred_ussubrvvmf8qi_scalar */

        case 7:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11265; /* pred_ussubrvvm8hi_scalar */

        case 8:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11267; /* pred_ussubrvvm4hi_scalar */

        case 9:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11269; /* pred_ussubrvvm2hi_scalar */

        case 10:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11271; /* pred_ussubrvvm1hi_scalar */

        case 11:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11273; /* pred_ussubrvvmf2hi_scalar */

        case 12:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11275; /* pred_ussubrvvmf4hi_scalar */

        case 13:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11277; /* pred_ussubrvvm8si_scalar */

        case 14:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11279; /* pred_ussubrvvm4si_scalar */

        case 15:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11281; /* pred_ussubrvvm2si_scalar */

        case 16:
          if (!
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11283; /* pred_ussubrvvm1si_scalar */

        case 17:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11285; /* pred_ussubrvvmf2si_scalar */

        case 18:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 557 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 11287; /* pred_ussubv1qi_scalar */

        case 19:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 558 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 11289; /* pred_ussubv2qi_scalar */

        case 20:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 559 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 11291; /* pred_ussubv4qi_scalar */

        case 21:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 560 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 11293; /* pred_ussubv8qi_scalar */

        case 22:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 561 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 11295; /* pred_ussubv16qi_scalar */

        case 23:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 562 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 11297; /* pred_ussubv32qi_scalar */

        case 24:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 563 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11299; /* pred_ussubv64qi_scalar */

        case 25:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 564 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11301; /* pred_ussubv128qi_scalar */

        case 26:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11303; /* pred_ussubv256qi_scalar */

        case 27:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 566 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11305; /* pred_ussubv512qi_scalar */

        case 28:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11307; /* pred_ussubv1024qi_scalar */

        case 29:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 568 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11309; /* pred_ussubv2048qi_scalar */

        case 30:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11311; /* pred_ussubv4096qi_scalar */

        case 31:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 570 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11313; /* pred_ussubv1hi_scalar */

        case 32:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11315; /* pred_ussubv2hi_scalar */

        case 33:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11317; /* pred_ussubv4hi_scalar */

        case 34:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11319; /* pred_ussubv8hi_scalar */

        case 35:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11321; /* pred_ussubv16hi_scalar */

        case 36:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11323; /* pred_ussubv32hi_scalar */

        case 37:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11325; /* pred_ussubv64hi_scalar */

        case 38:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11327; /* pred_ussubv128hi_scalar */

        case 39:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11329; /* pred_ussubv256hi_scalar */

        case 40:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11331; /* pred_ussubv512hi_scalar */

        case 41:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11333; /* pred_ussubv1024hi_scalar */

        case 42:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11335; /* pred_ussubv2048hi_scalar */

        case 43:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11337; /* pred_ussubv1si_scalar */

        case 44:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11339; /* pred_ussubv2si_scalar */

        case 45:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11341; /* pred_ussubv4si_scalar */

        case 46:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11343; /* pred_ussubv8si_scalar */

        case 47:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11345; /* pred_ussubv16si_scalar */

        case 48:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11347; /* pred_ussubv32si_scalar */

        case 49:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11349; /* pred_ussubv64si_scalar */

        case 50:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11351; /* pred_ussubv128si_scalar */

        case 51:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11353; /* pred_ussubv256si_scalar */

        case 52:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11355; /* pred_ussubv512si_scalar */

        case 53:
          if (!(
#line 4368 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11357; /* pred_ussubv1024si_scalar */

        case 54:
          if (!(
#line 4498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11375; /* *pred_ussubrvvm8di_scalar */

        case 55:
          if (!(
#line 4498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11377; /* *pred_ussubrvvm4di_scalar */

        case 56:
          if (!(
#line 4498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11379; /* *pred_ussubrvvm2di_scalar */

        case 57:
          if (!(
#line 4498 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11381; /* *pred_ussubrvvm1di_scalar */

        case 58:
          if (!(
#line 4520 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11383; /* *pred_ussubrvvm8di_extended_scalar */

        case 59:
          if (!(
#line 4520 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11385; /* *pred_ussubrvvm4di_extended_scalar */

        case 60:
          if (!(
#line 4520 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11387; /* *pred_ussubrvvm2di_extended_scalar */

        case 61:
          if (!(
#line 4520 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11389; /* *pred_ussubrvvm1di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_902 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      if (pattern602 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode)
              || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17768; /* pred_extendrvvm8sf */

        case E_RVVM4BFmode:
          if (!register_operand (operands[3], E_RVVM4BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 21 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32714; /* pred_extend_bf16_to_rvvm8sf */

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (pattern602 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode)
              || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17769; /* pred_extendrvvm4sf */

        case E_RVVM2BFmode:
          if (!register_operand (operands[3], E_RVVM2BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 22 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32715; /* pred_extend_bf16_to_rvvm4sf */

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (pattern602 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode)
              || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17770; /* pred_extendrvvm2sf */

        case E_RVVM1BFmode:
          if (!register_operand (operands[3], E_RVVM1BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 23 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32716; /* pred_extend_bf16_to_rvvm2sf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (pattern602 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode)
              || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17771; /* pred_extendrvvm1sf */

        case E_RVVMF2BFmode:
          if (!register_operand (operands[3], E_RVVMF2BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 24 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32717; /* pred_extend_bf16_to_rvvm1sf */

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (pattern602 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode)
              || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17772; /* pred_extendrvvmf2sf */

        case E_RVVMF4BFmode:
          if (!register_operand (operands[3], E_RVVMF4BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 25 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 32718; /* pred_extend_bf16_to_rvvmf2sf */

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (pattern500 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17773; /* pred_extendrvvm8df */

    case E_RVVM4DFmode:
      if (pattern500 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17774; /* pred_extendrvvm4df */

    case E_RVVM2DFmode:
      if (pattern500 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17775; /* pred_extendrvvm2df */

    case E_RVVM1DFmode:
      if (pattern500 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17776; /* pred_extendrvvm1df */

    case E_V1SFmode:
      if (pattern500 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17777; /* pred_extendv1sf */

    case E_V2SFmode:
      if (pattern500 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17778; /* pred_extendv2sf */

    case E_V4SFmode:
      if (pattern500 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17779; /* pred_extendv4sf */

    case E_V8SFmode:
      if (pattern500 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17780; /* pred_extendv8sf */

    case E_V16SFmode:
      if (pattern500 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17781; /* pred_extendv16sf */

    case E_V32SFmode:
      if (pattern500 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17782; /* pred_extendv32sf */

    case E_V64SFmode:
      if (pattern500 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17783; /* pred_extendv64sf */

    case E_V128SFmode:
      if (pattern500 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17784; /* pred_extendv128sf */

    case E_V256SFmode:
      if (pattern500 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17785; /* pred_extendv256sf */

    case E_V512SFmode:
      if (pattern500 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17786; /* pred_extendv512sf */

    case E_V1024SFmode:
      if (pattern500 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17787; /* pred_extendv1024sf */

    case E_V1DFmode:
      if (pattern500 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17788; /* pred_extendv1df */

    case E_V2DFmode:
      if (pattern500 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17789; /* pred_extendv2df */

    case E_V4DFmode:
      if (pattern500 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17790; /* pred_extendv4df */

    case E_V8DFmode:
      if (pattern500 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17791; /* pred_extendv8df */

    case E_V16DFmode:
      if (pattern500 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17792; /* pred_extendv16df */

    case E_V32DFmode:
      if (pattern500 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17793; /* pred_extendv32df */

    case E_V64DFmode:
      if (pattern500 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17794; /* pred_extendv64df */

    case E_V128DFmode:
      if (pattern500 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17795; /* pred_extendv128df */

    case E_V256DFmode:
      if (pattern500 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17796; /* pred_extendv256df */

    case E_V512DFmode:
      if (pattern500 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7616 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17797; /* pred_extendv512df */

    default:
      return -1;
    }
}

 int
recog_909 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern470 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1238; /* *pred_mov_widthhrvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1244; /* *pred_mov_widthhrvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1250; /* *pred_mov_widthhrvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1256; /* *pred_mov_widthhrvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1262; /* *pred_mov_widthhrvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1268; /* *pred_mov_widthhrvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1274; /* *pred_mov_widthhrvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1280; /* *pred_mov_widthhrvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1286; /* *pred_mov_widthhrvvm8si */

    case 9:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1292; /* *pred_mov_widthhrvvm4si */

    case 10:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1298; /* *pred_mov_widthhrvvm2si */

    case 11:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1304; /* *pred_mov_widthhrvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1310; /* *pred_mov_widthhrvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1316; /* *pred_mov_widthhrvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1322; /* *pred_mov_widthhrvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1328; /* *pred_mov_widthhrvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1334; /* *pred_mov_widthhrvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1340; /* *pred_mov_widthhrvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1346; /* *pred_mov_widthhrvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1352; /* *pred_mov_widthhrvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1358; /* *pred_mov_widthhrvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1364; /* *pred_mov_widthhrvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1370; /* *pred_mov_widthhrvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1376; /* *pred_mov_widthhrvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1382; /* *pred_mov_widthhrvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1388; /* *pred_mov_widthhrvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1394; /* *pred_mov_widthhrvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1400; /* *pred_mov_widthhrvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1406; /* *pred_mov_widthhrvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1412; /* *pred_mov_widthhrvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1418; /* *pred_mov_widthhrvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1424; /* *pred_mov_widthhrvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1430; /* *pred_mov_widthhrvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1436; /* *pred_mov_widthhrvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1442; /* *pred_mov_widthhrvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1448; /* *pred_mov_widthhrvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1454; /* *pred_mov_widthhrvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1460; /* *pred_mov_widthhrvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1466; /* *pred_mov_widthhrvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1472; /* *pred_mov_widthhrvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1478; /* *pred_mov_widthhrvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1484; /* *pred_mov_widthhrvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1490; /* *pred_mov_widthhrvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1496; /* *pred_mov_widthhv1qi */

    case 44:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1502; /* *pred_mov_widthhv2qi */

    case 45:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1508; /* *pred_mov_widthhv4qi */

    case 46:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1514; /* *pred_mov_widthhv8qi */

    case 47:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1520; /* *pred_mov_widthhv16qi */

    case 48:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1526; /* *pred_mov_widthhv32qi */

    case 49:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1532; /* *pred_mov_widthhv64qi */

    case 50:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1538; /* *pred_mov_widthhv128qi */

    case 51:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1544; /* *pred_mov_widthhv256qi */

    case 52:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1550; /* *pred_mov_widthhv512qi */

    case 53:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1556; /* *pred_mov_widthhv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1562; /* *pred_mov_widthhv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1568; /* *pred_mov_widthhv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1574; /* *pred_mov_widthhv1hi */

    case 57:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1580; /* *pred_mov_widthhv2hi */

    case 58:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1586; /* *pred_mov_widthhv4hi */

    case 59:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1592; /* *pred_mov_widthhv8hi */

    case 60:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1598; /* *pred_mov_widthhv16hi */

    case 61:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1604; /* *pred_mov_widthhv32hi */

    case 62:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1610; /* *pred_mov_widthhv64hi */

    case 63:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1616; /* *pred_mov_widthhv128hi */

    case 64:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1622; /* *pred_mov_widthhv256hi */

    case 65:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1628; /* *pred_mov_widthhv512hi */

    case 66:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1634; /* *pred_mov_widthhv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1640; /* *pred_mov_widthhv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1646; /* *pred_mov_widthhv1si */

    case 69:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1652; /* *pred_mov_widthhv2si */

    case 70:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1658; /* *pred_mov_widthhv4si */

    case 71:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1664; /* *pred_mov_widthhv8si */

    case 72:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1670; /* *pred_mov_widthhv16si */

    case 73:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1676; /* *pred_mov_widthhv32si */

    case 74:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1682; /* *pred_mov_widthhv64si */

    case 75:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1688; /* *pred_mov_widthhv128si */

    case 76:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1694; /* *pred_mov_widthhv256si */

    case 77:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1700; /* *pred_mov_widthhv512si */

    case 78:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1706; /* *pred_mov_widthhv1024si */

    case 79:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1712; /* *pred_mov_widthhv1di */

    case 80:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1718; /* *pred_mov_widthhv2di */

    case 81:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1724; /* *pred_mov_widthhv4di */

    case 82:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1730; /* *pred_mov_widthhv8di */

    case 83:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1736; /* *pred_mov_widthhv16di */

    case 84:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1742; /* *pred_mov_widthhv32di */

    case 85:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1748; /* *pred_mov_widthhv64di */

    case 86:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1754; /* *pred_mov_widthhv128di */

    case 87:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1760; /* *pred_mov_widthhv256di */

    case 88:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1766; /* *pred_mov_widthhv512di */

    case 89:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1772; /* *pred_mov_widthhv1hf */

    case 90:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1778; /* *pred_mov_widthhv2hf */

    case 91:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1784; /* *pred_mov_widthhv4hf */

    case 92:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1790; /* *pred_mov_widthhv8hf */

    case 93:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1796; /* *pred_mov_widthhv16hf */

    case 94:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1802; /* *pred_mov_widthhv32hf */

    case 95:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1808; /* *pred_mov_widthhv64hf */

    case 96:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1814; /* *pred_mov_widthhv128hf */

    case 97:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1820; /* *pred_mov_widthhv256hf */

    case 98:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1826; /* *pred_mov_widthhv512hf */

    case 99:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1832; /* *pred_mov_widthhv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1838; /* *pred_mov_widthhv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1844; /* *pred_mov_widthhv1sf */

    case 102:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1850; /* *pred_mov_widthhv2sf */

    case 103:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1856; /* *pred_mov_widthhv4sf */

    case 104:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1862; /* *pred_mov_widthhv8sf */

    case 105:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1868; /* *pred_mov_widthhv16sf */

    case 106:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1874; /* *pred_mov_widthhv32sf */

    case 107:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1880; /* *pred_mov_widthhv64sf */

    case 108:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1886; /* *pred_mov_widthhv128sf */

    case 109:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1892; /* *pred_mov_widthhv256sf */

    case 110:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1898; /* *pred_mov_widthhv512sf */

    case 111:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1904; /* *pred_mov_widthhv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1910; /* *pred_mov_widthhv1df */

    case 113:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1916; /* *pred_mov_widthhv2df */

    case 114:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1922; /* *pred_mov_widthhv4df */

    case 115:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1928; /* *pred_mov_widthhv8df */

    case 116:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1934; /* *pred_mov_widthhv16df */

    case 117:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1940; /* *pred_mov_widthhv32df */

    case 118:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1946; /* *pred_mov_widthhv64df */

    case 119:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1952; /* *pred_mov_widthhv128df */

    case 120:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1958; /* *pred_mov_widthhv256df */

    case 121:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1964; /* *pred_mov_widthhv512df */

    default:
      return -1;
    }
}

 int
recog_927 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15247; /* *pred_mul_addrvvmf2hf_undef */
}

 int
recog_932 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15257; /* *pred_mul_addrvvm1sf_undef */
}

 int
recog_937 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15267; /* *pred_mul_addrvvm1df_undef */
}

 int
recog_942 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15277; /* *pred_mul_addv16hf_undef */
}

 int
recog_947 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15287; /* *pred_mul_addv512hf_undef */
}

 int
recog_952 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15297; /* *pred_mul_addv4sf_undef */
}

 int
recog_957 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15307; /* *pred_mul_addv128sf_undef */
}

 int
recog_962 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15317; /* *pred_mul_addv2df_undef */
}

 int
recog_967 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15327; /* *pred_mul_addv64df_undef */
}

 int
recog_972 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7194 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16754; /* pred_widen_mul_addrvvm1sf_scalar */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVMF2BFmode)
          || !(
#line 130 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 24 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32727; /* pred_widen_bf16_mul_rvvm1sf_scalar */

    default:
      return -1;
    }
}

 int
recog_977 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7165 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16694; /* pred_widen_mul_addrvvm1sf */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[3], E_RVVMF2BFmode)
          || !register_operand (operands[4], E_RVVMF2BFmode)
          || !(
#line 101 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 24 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32722; /* pred_widen_bf16_mul_rvvm1sf */

    default:
      return -1;
    }
}

 int
recog_982 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_969 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15427; /* *pred_maddv256df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15523; /* *pred_maccv256df */
}

 int
recog_987 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_964 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15417; /* *pred_maddv8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15513; /* *pred_maccv8df */
}

 int
recog_992 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_959 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15407; /* *pred_maddv512sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15503; /* *pred_maccv512sf */
}

 int
recog_997 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_954 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15397; /* *pred_maddv16sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15493; /* *pred_maccv16sf */
}

 int
recog_1002 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_949 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15387; /* *pred_maddv2048hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15483; /* *pred_maccv2048hf */
}

 int
recog_1007 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_944 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15377; /* *pred_maddv64hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15473; /* *pred_maccv64hf */
}

 int
recog_1013 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_938 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15365; /* *pred_maddv1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15461; /* *pred_maccv1hf */
}

 int
recog_1019 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_932 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15353; /* *pred_maddrvvm1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15449; /* *pred_maccrvvm1sf */
}

 int
recog_1025 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_926 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15341; /* *pred_maddrvvm1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15437; /* *pred_maccrvvm1hf */
}

 int
recog_1032 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15725; /* *pred_mul_neg_addrvvm1hf_undef */
}

 int
recog_1041 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15743; /* *pred_mul_neg_addrvvm4df_undef */
}

 int
recog_1050 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15761; /* *pred_mul_neg_addv64hf_undef */
}

 int
recog_1060 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15781; /* *pred_mul_neg_addv16sf_undef */
}

 int
recog_1070 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15801; /* *pred_mul_neg_addv8df_undef */
}

 int
recog_1080 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1073 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15903; /* *pred_nmsubv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15999; /* *pred_nmsacv64df */
}

 int
recog_1090 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1063 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15883; /* *pred_nmsubv128sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15979; /* *pred_nmsacv128sf */
}

 int
recog_1100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1053 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15863; /* *pred_nmsubv512hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15959; /* *pred_nmsacv512hf */
}

 int
recog_1110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1043 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15843; /* *pred_nmsubrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15939; /* *pred_nmsacrvvm1df */
}

 int
recog_1120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1033 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15823; /* *pred_nmsubrvvmf2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15919; /* *pred_nmsacrvvmf2hf */
}

 int
recog_1129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15242; /* *pred_mul_subrvvm4hf_undef */
}

 int
recog_1136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15256; /* *pred_mul_subrvvm2sf_undef */
}

 int
recog_1143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15270; /* *pred_mul_subv1hf_undef */
}

 int
recog_1150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15284; /* *pred_mul_subv128hf_undef */
}

 int
recog_1157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15298; /* *pred_mul_subv4sf_undef */
}

 int
recog_1164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15312; /* *pred_mul_subv512sf_undef */
}

 int
recog_1171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6491 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15326; /* *pred_mul_subv32df_undef */
}

 int
recog_1178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1173 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15426; /* *pred_msubv128df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15522; /* *pred_msacv128df */
}

 int
recog_1185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1166 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15412; /* *pred_msubv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15508; /* *pred_msacv1df */
}

 int
recog_1192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1159 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15398; /* *pred_msubv16sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15494; /* *pred_msacv16sf */
}

 int
recog_1199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1152 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15384; /* *pred_msubv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15480; /* *pred_msacv512hf */
}

 int
recog_1206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1145 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15370; /* *pred_msubv4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15466; /* *pred_msacv4hf */
}

 int
recog_1213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1138 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15356; /* *pred_msubrvvmf2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15452; /* *pred_msacrvvmf2sf */
}

 int
recog_1221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1130 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15340; /* *pred_msubrvvm2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15436; /* *pred_msacrvvm2hf */
}

 int
recog_1229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15730; /* *pred_mul_neg_subrvvmf4hf_undef */
}

 int
recog_1236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15744; /* *pred_mul_neg_subrvvm4df_undef */
}

 int
recog_1243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15758; /* *pred_mul_neg_subv16hf_undef */
}

 int
recog_1250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15772; /* *pred_mul_neg_subv2048hf_undef */
}

 int
recog_1257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15786; /* *pred_mul_neg_subv64sf_undef */
}

 int
recog_1264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15800; /* *pred_mul_neg_subv4df_undef */
}

 int
recog_1271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6704 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15814; /* *pred_mul_neg_subv512df_undef */
}

 int
recog_1278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1265 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15898; /* *pred_nmaddv8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15994; /* *pred_nmaccv8df */
}

 int
recog_1285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1258 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15884; /* *pred_nmaddv128sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15980; /* *pred_nmaccv128sf */
}

 int
recog_1292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1251 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15870; /* *pred_nmaddv1sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15966; /* *pred_nmaccv1sf */
}

 int
recog_1300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1243 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15854; /* *pred_nmaddv16hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15950; /* *pred_nmaccv16hf */
}

 int
recog_1307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1236 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15840; /* *pred_nmaddrvvm4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15936; /* *pred_nmaccrvvm4df */
}

 int
recog_1315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1228 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15824; /* *pred_nmaddrvvmf2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15920; /* *pred_nmaccrvvmf2hf */
}

 int
recog_1323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern725 (x2))
    {
    case 0:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17265; /* pred_fcvt_xu_frvvm8hf */

    case 1:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17267; /* pred_fcvt_xu_frvvm4hf */

    case 2:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17811; /* pred_narrow_fcvt_xu_frvvm8sf */

    case 3:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17269; /* pred_fcvt_xu_frvvm2hf */

    case 4:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17813; /* pred_narrow_fcvt_xu_frvvm4sf */

    case 5:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17271; /* pred_fcvt_xu_frvvm1hf */

    case 6:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17815; /* pred_narrow_fcvt_xu_frvvm2sf */

    case 7:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17273; /* pred_fcvt_xu_frvvmf2hf */

    case 8:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17817; /* pred_narrow_fcvt_xu_frvvm1sf */

    case 9:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17275; /* pred_fcvt_xu_frvvmf4hf */

    case 10:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17819; /* pred_narrow_fcvt_xu_frvvmf2sf */

    case 11:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17277; /* pred_fcvt_xu_frvvm8sf */

    case 12:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17553; /* pred_widen_fcvt_xu_frvvm8si */

    case 13:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17279; /* pred_fcvt_xu_frvvm4sf */

    case 14:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17555; /* pred_widen_fcvt_xu_frvvm4si */

    case 15:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17821; /* pred_narrow_fcvt_xu_frvvm8df */

    case 16:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17281; /* pred_fcvt_xu_frvvm2sf */

    case 17:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17557; /* pred_widen_fcvt_xu_frvvm2si */

    case 18:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17823; /* pred_narrow_fcvt_xu_frvvm4df */

    case 19:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17283; /* pred_fcvt_xu_frvvm1sf */

    case 20:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17559; /* pred_widen_fcvt_xu_frvvm1si */

    case 21:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17825; /* pred_narrow_fcvt_xu_frvvm2df */

    case 22:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17285; /* pred_fcvt_xu_frvvmf2sf */

    case 23:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17561; /* pred_widen_fcvt_xu_frvvmf2si */

    case 24:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17827; /* pred_narrow_fcvt_xu_frvvm1df */

    case 25:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17287; /* pred_fcvt_xu_frvvm8df */

    case 26:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17563; /* pred_widen_fcvt_xu_frvvm8di */

    case 27:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17289; /* pred_fcvt_xu_frvvm4df */

    case 28:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17565; /* pred_widen_fcvt_xu_frvvm4di */

    case 29:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17291; /* pred_fcvt_xu_frvvm2df */

    case 30:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17567; /* pred_widen_fcvt_xu_frvvm2di */

    case 31:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17293; /* pred_fcvt_xu_frvvm1df */

    case 32:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17569; /* pred_widen_fcvt_xu_frvvm1di */

    case 33:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17295; /* pred_fcvt_xu_fv1hf */

    case 34:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17853; /* pred_narrow_fcvt_xu_fv1sf */

    case 35:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17297; /* pred_fcvt_xu_fv2hf */

    case 36:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17855; /* pred_narrow_fcvt_xu_fv2sf */

    case 37:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17299; /* pred_fcvt_xu_fv4hf */

    case 38:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17857; /* pred_narrow_fcvt_xu_fv4sf */

    case 39:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17301; /* pred_fcvt_xu_fv8hf */

    case 40:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17859; /* pred_narrow_fcvt_xu_fv8sf */

    case 41:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17303; /* pred_fcvt_xu_fv16hf */

    case 42:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17861; /* pred_narrow_fcvt_xu_fv16sf */

    case 43:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17305; /* pred_fcvt_xu_fv32hf */

    case 44:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17863; /* pred_narrow_fcvt_xu_fv32sf */

    case 45:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17307; /* pred_fcvt_xu_fv64hf */

    case 46:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17865; /* pred_narrow_fcvt_xu_fv64sf */

    case 47:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17309; /* pred_fcvt_xu_fv128hf */

    case 48:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17867; /* pred_narrow_fcvt_xu_fv128sf */

    case 49:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17311; /* pred_fcvt_xu_fv256hf */

    case 50:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17869; /* pred_narrow_fcvt_xu_fv256sf */

    case 51:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17313; /* pred_fcvt_xu_fv512hf */

    case 52:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17871; /* pred_narrow_fcvt_xu_fv512sf */

    case 53:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17315; /* pred_fcvt_xu_fv1024hf */

    case 54:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17873; /* pred_narrow_fcvt_xu_fv1024sf */

    case 55:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17317; /* pred_fcvt_xu_fv2048hf */

    case 56:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17319; /* pred_fcvt_xu_fv1sf */

    case 57:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 17571; /* pred_widen_fcvt_xu_fv1si */

    case 58:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17875; /* pred_narrow_fcvt_xu_fv1df */

    case 59:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17321; /* pred_fcvt_xu_fv2sf */

    case 60:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 17573; /* pred_widen_fcvt_xu_fv2si */

    case 61:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17877; /* pred_narrow_fcvt_xu_fv2df */

    case 62:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17323; /* pred_fcvt_xu_fv4sf */

    case 63:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 17575; /* pred_widen_fcvt_xu_fv4si */

    case 64:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17879; /* pred_narrow_fcvt_xu_fv4df */

    case 65:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17325; /* pred_fcvt_xu_fv8sf */

    case 66:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 17577; /* pred_widen_fcvt_xu_fv8si */

    case 67:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17881; /* pred_narrow_fcvt_xu_fv8df */

    case 68:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17327; /* pred_fcvt_xu_fv16sf */

    case 69:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17579; /* pred_widen_fcvt_xu_fv16si */

    case 70:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17883; /* pred_narrow_fcvt_xu_fv16df */

    case 71:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17329; /* pred_fcvt_xu_fv32sf */

    case 72:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17581; /* pred_widen_fcvt_xu_fv32si */

    case 73:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17885; /* pred_narrow_fcvt_xu_fv32df */

    case 74:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17331; /* pred_fcvt_xu_fv64sf */

    case 75:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17583; /* pred_widen_fcvt_xu_fv64si */

    case 76:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17887; /* pred_narrow_fcvt_xu_fv64df */

    case 77:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17333; /* pred_fcvt_xu_fv128sf */

    case 78:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17585; /* pred_widen_fcvt_xu_fv128si */

    case 79:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17889; /* pred_narrow_fcvt_xu_fv128df */

    case 80:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17335; /* pred_fcvt_xu_fv256sf */

    case 81:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17587; /* pred_widen_fcvt_xu_fv256si */

    case 82:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17891; /* pred_narrow_fcvt_xu_fv256df */

    case 83:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17337; /* pred_fcvt_xu_fv512sf */

    case 84:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17589; /* pred_widen_fcvt_xu_fv512si */

    case 85:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17893; /* pred_narrow_fcvt_xu_fv512df */

    case 86:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17339; /* pred_fcvt_xu_fv1024sf */

    case 87:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17591; /* pred_widen_fcvt_xu_fv1024si */

    case 88:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17341; /* pred_fcvt_xu_fv1df */

    case 89:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17593; /* pred_widen_fcvt_xu_fv1di */

    case 90:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17343; /* pred_fcvt_xu_fv2df */

    case 91:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17595; /* pred_widen_fcvt_xu_fv2di */

    case 92:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17345; /* pred_fcvt_xu_fv4df */

    case 93:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17597; /* pred_widen_fcvt_xu_fv4di */

    case 94:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17347; /* pred_fcvt_xu_fv8df */

    case 95:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17599; /* pred_widen_fcvt_xu_fv8di */

    case 96:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17349; /* pred_fcvt_xu_fv16df */

    case 97:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17601; /* pred_widen_fcvt_xu_fv16di */

    case 98:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17351; /* pred_fcvt_xu_fv32df */

    case 99:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17603; /* pred_widen_fcvt_xu_fv32di */

    case 100:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17353; /* pred_fcvt_xu_fv64df */

    case 101:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17605; /* pred_widen_fcvt_xu_fv64di */

    case 102:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17355; /* pred_fcvt_xu_fv128df */

    case 103:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17607; /* pred_widen_fcvt_xu_fv128di */

    case 104:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17357; /* pred_fcvt_xu_fv256df */

    case 105:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17609; /* pred_widen_fcvt_xu_fv256di */

    case 106:
      if (!(
#line 7485 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17359; /* pred_fcvt_xu_fv512df */

    case 107:
      if (!(
#line 7557 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17611; /* pred_widen_fcvt_xu_fv512di */

    case 108:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17799; /* pred_narrow_fcvt_xu_frvvm8hf */

    case 109:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17801; /* pred_narrow_fcvt_xu_frvvm4hf */

    case 110:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17803; /* pred_narrow_fcvt_xu_frvvm2hf */

    case 111:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17805; /* pred_narrow_fcvt_xu_frvvm1hf */

    case 112:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17807; /* pred_narrow_fcvt_xu_frvvmf2hf */

    case 113:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17809; /* pred_narrow_fcvt_xu_frvvmf4hf */

    case 114:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17829; /* pred_narrow_fcvt_xu_fv1hf */

    case 115:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17831; /* pred_narrow_fcvt_xu_fv2hf */

    case 116:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17833; /* pred_narrow_fcvt_xu_fv4hf */

    case 117:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17835; /* pred_narrow_fcvt_xu_fv8hf */

    case 118:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17837; /* pred_narrow_fcvt_xu_fv16hf */

    case 119:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17839; /* pred_narrow_fcvt_xu_fv32hf */

    case 120:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17841; /* pred_narrow_fcvt_xu_fv64hf */

    case 121:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17843; /* pred_narrow_fcvt_xu_fv128hf */

    case 122:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17845; /* pred_narrow_fcvt_xu_fv256hf */

    case 123:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17847; /* pred_narrow_fcvt_xu_fv512hf */

    case 124:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17849; /* pred_narrow_fcvt_xu_fv1024hf */

    case 125:
      if (!(
#line 7644 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17851; /* pred_narrow_fcvt_xu_fv2048hf */

    default:
      return -1;
    }
}

 int
recog_1335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || !vector_arith_operand (operands[4], E_RVVM1SImode)
          || !
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12423; /* *pred_cmprvvm1si_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || !vector_arith_operand (operands[4], E_RVVM2DImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12426; /* *pred_cmprvvm2di_merge_tie_mask */

    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || !vector_arith_operand (operands[4], E_RVVMF4QImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12429; /* *pred_cmprvvmf4qi_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || !vector_arith_operand (operands[4], E_RVVMF2HImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12431; /* *pred_cmprvvmf2hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2QImode:
      if (!register_operand (operands[3], E_V2QImode)
          || !vector_arith_operand (operands[4], E_V2QImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 12435; /* *pred_cmpv2qi_merge_tie_mask */

    case E_V2HImode:
      if (!register_operand (operands[3], E_V2HImode)
          || !vector_arith_operand (operands[4], E_V2HImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12448; /* *pred_cmpv2hi_merge_tie_mask */

    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode)
          || !vector_arith_operand (operands[4], E_V2SImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12460; /* *pred_cmpv2si_merge_tie_mask */

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode)
          || !vector_arith_operand (operands[4], E_V2DImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12471; /* *pred_cmpv2di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V64QImode:
      if (!register_operand (operands[3], E_V64QImode)
          || !vector_arith_operand (operands[4], E_V64QImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12440; /* *pred_cmpv64qi_merge_tie_mask */

    case E_V64HImode:
      if (!register_operand (operands[3], E_V64HImode)
          || !vector_arith_operand (operands[4], E_V64HImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12453; /* *pred_cmpv64hi_merge_tie_mask */

    case E_V64SImode:
      if (!register_operand (operands[3], E_V64SImode)
          || !vector_arith_operand (operands[4], E_V64SImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12465; /* *pred_cmpv64si_merge_tie_mask */

    case E_V64DImode:
      if (!register_operand (operands[3], E_V64DImode)
          || !vector_arith_operand (operands[4], E_V64DImode)
          || !(
#line 4758 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12476; /* *pred_cmpv64di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1346 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || !vector_arith_operand (operands[5], E_V512QImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12511; /* *pred_cmpv512qi */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12579; /* *pred_cmpv512qi_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || !vector_arith_operand (operands[5], E_V512HImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12524; /* *pred_cmpv512hi */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12592; /* *pred_cmpv512hi_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || !vector_arith_operand (operands[5], E_V512SImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12536; /* *pred_cmpv512si */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12604; /* *pred_cmpv512si_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || !vector_arith_operand (operands[5], E_V512DImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12547; /* *pred_cmpv512di */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12615; /* *pred_cmpv512di_narrow */

    default:
      return -1;
    }
}

 int
recog_1356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1339 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || !vector_arith_operand (operands[5], E_V4QImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12504; /* *pred_cmpv4qi */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12572; /* *pred_cmpv4qi_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || !vector_arith_operand (operands[5], E_V4HImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12517; /* *pred_cmpv4hi */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12585; /* *pred_cmpv4hi_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || !vector_arith_operand (operands[5], E_V4SImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12529; /* *pred_cmpv4si */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12597; /* *pred_cmpv4si_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || !vector_arith_operand (operands[5], E_V4DImode))
        return -1;
      if ((
#line 4782 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12540; /* *pred_cmpv4di */
      if (!(
#line 4803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12608; /* *pred_cmpv4di_narrow */

    default:
      return -1;
    }
}

 int
recog_1368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode)
          || !vector_neg_arith_operand (operands[4], E_V16QImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12642; /* *pred_ltgev16qi_merge_tie_mask */

    case E_V16HImode:
      if (!register_operand (operands[3], E_V16HImode)
          || !vector_neg_arith_operand (operands[4], E_V16HImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12655; /* *pred_ltgev16hi_merge_tie_mask */

    case E_V16SImode:
      if (!register_operand (operands[3], E_V16SImode)
          || !vector_neg_arith_operand (operands[4], E_V16SImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12667; /* *pred_ltgev16si_merge_tie_mask */

    case E_V16DImode:
      if (!register_operand (operands[3], E_V16DImode)
          || !vector_neg_arith_operand (operands[4], E_V16DImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12678; /* *pred_ltgev16di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2048QImode:
      if (!register_operand (operands[3], E_V2048QImode)
          || !vector_neg_arith_operand (operands[4], E_V2048QImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12649; /* *pred_ltgev2048qi_merge_tie_mask */

    case E_V2048HImode:
      if (!register_operand (operands[3], E_V2048HImode)
          || !vector_neg_arith_operand (operands[4], E_V2048HImode)
          || !(
#line 4840 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12662; /* *pred_ltgev2048hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern533 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1369 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32QImode:
      if (!register_operand (operands[4], E_V32QImode)
          || !vector_neg_arith_operand (operands[5], E_V32QImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32QImode)) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 12711; /* *pred_ltgev32qi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32QImode)) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12779; /* *pred_ltgev32qi_narrow */

    case E_V32HImode:
      if (!register_operand (operands[4], E_V32HImode)
          || !vector_neg_arith_operand (operands[5], E_V32HImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HImode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12724; /* *pred_ltgev32hi */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HImode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12792; /* *pred_ltgev32hi_narrow */

    case E_V32SImode:
      if (!register_operand (operands[4], E_V32SImode)
          || !vector_neg_arith_operand (operands[5], E_V32SImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SImode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12736; /* *pred_ltgev32si */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SImode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12804; /* *pred_ltgev32si_narrow */

    case E_V32DImode:
      if (!register_operand (operands[4], E_V32DImode)
          || !vector_neg_arith_operand (operands[5], E_V32DImode))
        return -1;
      if ((
#line 4864 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12747; /* *pred_ltgev32di */
      if (!(
#line 4885 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12815; /* *pred_ltgev32di_narrow */

    default:
      return -1;
    }
}

 int
recog_1388 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || GET_MODE (x9) != E_RVVMF2QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12824; /* *pred_cmprvvmf2qi_scalar_merge_tie_mask */

    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || GET_MODE (x9) != E_RVVM1HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12830; /* *pred_cmprvvm1hi_scalar_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || GET_MODE (x9) != E_RVVM2SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12835; /* *pred_cmprvvm2si_scalar_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || GET_MODE (x9) != E_RVVM4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12983; /* *pred_cmprvvm4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode)
          || GET_MODE (x9) != E_V16QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12842; /* *pred_cmpv16qi_scalar_merge_tie_mask */

    case E_V16HImode:
      if (!register_operand (operands[3], E_V16HImode)
          || GET_MODE (x9) != E_V16HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12855; /* *pred_cmpv16hi_scalar_merge_tie_mask */

    case E_V16SImode:
      if (!register_operand (operands[3], E_V16SImode)
          || GET_MODE (x9) != E_V16SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12867; /* *pred_cmpv16si_scalar_merge_tie_mask */

    case E_V16DImode:
      if (!register_operand (operands[3], E_V16DImode)
          || GET_MODE (x9) != E_V16DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12990; /* *pred_cmpv16di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2048QImode:
      if (!register_operand (operands[3], E_V2048QImode)
          || GET_MODE (x9) != E_V2048QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12849; /* *pred_cmpv2048qi_scalar_merge_tie_mask */

    case E_V2048HImode:
      if (!register_operand (operands[3], E_V2048HImode)
          || GET_MODE (x9) != E_V2048HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12862; /* *pred_cmpv2048hi_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern567 (x2, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V64BImode))
    {
      res = recog_1397 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64QImode:
      if (!register_operand (operands[4], E_V64QImode)
          || GET_MODE (x9) != E_V64QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64QImode)) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 12898; /* *pred_cmpv64qi_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64QImode)) && 
#line 722 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12952; /* *pred_cmpv64qi_scalar_narrow */

    case E_V64HImode:
      if (!register_operand (operands[4], E_V64HImode)
          || GET_MODE (x9) != E_V64HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64HImode)) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12911; /* *pred_cmpv64hi_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64HImode)) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12965; /* *pred_cmpv64hi_scalar_narrow */

    case E_V64SImode:
      if (!register_operand (operands[4], E_V64SImode)
          || GET_MODE (x9) != E_V64SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64SImode)) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12923; /* *pred_cmpv64si_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64SImode)) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12977; /* *pred_cmpv64si_scalar_narrow */

    case E_V64DImode:
      if (!register_operand (operands[4], E_V64DImode)
          || GET_MODE (x9) != E_V64DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5059 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DImode)) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 13006; /* *pred_cmpv64di_scalar */
      if (!(
#line 5081 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DImode)) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 13020; /* *pred_cmpv64di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern621 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) == 0
          && 
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12820; /* *pred_cmprvvm8qi_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern622 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode, 
E_QImode) != 0)
        return -1;
      if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12874; /* *pred_cmprvvm8qi_scalar */
      if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12928; /* *pred_cmprvvm8qi_scalar_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1385 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || GET_MODE (x9) != E_RVVM4QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12875; /* *pred_cmprvvm4qi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12929; /* *pred_cmprvvm4qi_scalar_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || GET_MODE (x9) != E_RVVM8HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12881; /* *pred_cmprvvm8hi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12935; /* *pred_cmprvvm8hi_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1386 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || GET_MODE (x9) != E_RVVM2QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12876; /* *pred_cmprvvm2qi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12930; /* *pred_cmprvvm2qi_scalar_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || GET_MODE (x9) != E_RVVM4HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12882; /* *pred_cmprvvm4hi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12936; /* *pred_cmprvvm4hi_scalar_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || GET_MODE (x9) != E_RVVM8SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12887; /* *pred_cmprvvm8si_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12941; /* *pred_cmprvvm8si_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1387 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || GET_MODE (x9) != E_RVVM1QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12877; /* *pred_cmprvvm1qi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12931; /* *pred_cmprvvm1qi_scalar_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || GET_MODE (x9) != E_RVVM2HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12883; /* *pred_cmprvvm2hi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12937; /* *pred_cmprvvm2hi_scalar_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || GET_MODE (x9) != E_RVVM4SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12888; /* *pred_cmprvvm4si_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12942; /* *pred_cmprvvm4si_scalar_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || GET_MODE (x9) != E_RVVM8DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5059 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12996; /* *pred_cmprvvm8di_scalar */
          if (!(
#line 5081 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13010; /* *pred_cmprvvm8di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1388 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || GET_MODE (x9) != E_RVVMF2QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)))
            return 12878; /* *pred_cmprvvmf2qi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)))
            return -1;
          return 12932; /* *pred_cmprvvmf2qi_scalar_narrow */

        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || GET_MODE (x9) != E_RVVM1HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12884; /* *pred_cmprvvm1hi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12938; /* *pred_cmprvvm1hi_scalar_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || GET_MODE (x9) != E_RVVM2SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12889; /* *pred_cmprvvm2si_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12943; /* *pred_cmprvvm2si_scalar_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || GET_MODE (x9) != E_RVVM4DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5059 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12997; /* *pred_cmprvvm4di_scalar */
          if (!(
#line 5081 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13011; /* *pred_cmprvvm4di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1389 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || GET_MODE (x9) != E_RVVMF4QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)))
            return 12879; /* *pred_cmprvvmf4qi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)))
            return -1;
          return 12933; /* *pred_cmprvvmf4qi_scalar_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || GET_MODE (x9) != E_RVVMF2HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)))
            return 12885; /* *pred_cmprvvmf2hi_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)))
            return -1;
          return 12939; /* *pred_cmprvvmf2hi_scalar_narrow */

        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || GET_MODE (x9) != E_RVVM1SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12890; /* *pred_cmprvvm1si_scalar */
          if (!
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12944; /* *pred_cmprvvm1si_scalar_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || GET_MODE (x9) != E_RVVM2DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5059 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12998; /* *pred_cmprvvm2di_scalar */
          if (!(
#line 5081 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13012; /* *pred_cmprvvm2di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1390 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || GET_MODE (x9) != E_RVVMF8QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return 12880; /* *pred_cmprvvmf8qi_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 12934; /* *pred_cmprvvmf8qi_scalar_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || GET_MODE (x9) != E_RVVMF4HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return 12886; /* *pred_cmprvvmf4hi_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 12940; /* *pred_cmprvvmf4hi_scalar_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || GET_MODE (x9) != E_RVVMF2SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return 12891; /* *pred_cmprvvmf2si_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 12945; /* *pred_cmprvvmf2si_scalar_narrow */

        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || GET_MODE (x9) != E_RVVM1DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5059 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12999; /* *pred_cmprvvm1di_scalar */
          if (!(
#line 5081 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13013; /* *pred_cmprvvm1di_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      return recog_1412 (x1, insn, pnum_clobbers);

    case E_V2BImode:
      return recog_1411 (x1, insn, pnum_clobbers);

    case E_V4BImode:
      return recog_1410 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1409 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1408 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1407 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1406 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1405 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1404 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1403 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1401 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || GET_MODE (x9) != E_V1024QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12902; /* *pred_cmpv1024qi_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12956; /* *pred_cmpv1024qi_scalar_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || GET_MODE (x9) != E_V1024HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12915; /* *pred_cmpv1024hi_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12969; /* *pred_cmpv1024hi_scalar_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || GET_MODE (x9) != E_V1024SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12927; /* *pred_cmpv1024si_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12981; /* *pred_cmpv1024si_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1402 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || GET_MODE (x9) != E_V2048QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12903; /* *pred_cmpv2048qi_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 727 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12957; /* *pred_cmpv2048qi_scalar_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || GET_MODE (x9) != E_V2048HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12916; /* *pred_cmpv2048hi_scalar */
          if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12970; /* *pred_cmpv2048hi_scalar_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern567 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern621 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) == 0
          && (
#line 4924 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12850; /* *pred_cmpv4096qi_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern622 (x2, 
E_V4096BImode, 
E_V4096QImode, 
E_QImode) != 0)
        return -1;
      if ((
#line 4949 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12904; /* *pred_cmpv4096qi_scalar */
      if (!(
#line 4971 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12958; /* *pred_cmpv4096qi_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (register_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 845 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return 8; /* addsi3_extended */
            }
          if (pnum_clobbers == NULL
              || GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (pattern415 (x7) != 0
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x7, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[4] = x6;
          if (!register_operand (operands[4], E_SImode)
              || !
#line 4424 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff))
            return -1;
          *pnum_clobbers = 1;
          return 489; /* *riscv.md:4414 */

        case ASHIFT:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 4575 "../../gcc/config/riscv/riscv.md"
((TARGET_64BIT
    && riscv_const_insns (operands[3], false)
    && ((riscv_const_insns (operands[3], false)
	 < riscv_const_insns (GEN_INT (INTVAL (operands[3]) >> INTVAL (operands[2])), false))
	|| riscv_const_insns (GEN_INT (INTVAL (operands[3]) >> INTVAL (operands[2])), false) == 0))))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *riscv.md:4568 */

        case MULT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 301 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 888; /* *th_mulawsi */

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_SImode)
                return -1;
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x10 = XEXP (x7, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 339 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 891; /* *th_sextw_maddhisi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case TRUNCATE:
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case TRUNCATE:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MEM:
          if (GET_MODE (x4) == E_SImode)
            {
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (absolute_symbolic_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && (
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 799; /* *local_pic_load_ssi */
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && (
#line 36 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 800; /* *local_pic_load_ssi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_11 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) == MEM)
        {
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern232 (x3) != 0)
        return -1;
      if (vector_length_operand (operands[1], E_SImode)
          && (
#line 1827 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return 3634; /* *vsetvldi_no_side_effects_si_extend */
      if (!vector_length_operand (operands[1], E_DImode)
          || !(
#line 1827 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 3635; /* *vsetvldi_no_side_effects_si_extend */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1026 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 17; /* subsi3_extended */

        case MULT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 362 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 894; /* *th_mulswsi */

            case SIGN_EXTEND:
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x6, 1);
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x15 = XEXP (x13, 0);
              operands[2] = x15;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 397 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 897; /* *th_sextw_msubhisi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      if (pattern132 (x3) != 0
          || !
#line 1079 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 21; /* negsi2_extended */

    case MULT:
      if (pattern133 (x3) != 0
          || !
#line 1243 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 28; /* mulsi3_extended */

    case DIV:
      if (pattern133 (x3) != 0
          || !
#line 1456 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 44; /* divsi3_extended */

    case UDIV:
      if (pattern133 (x3) != 0
          || !
#line 1456 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 45; /* udivsi3_extended */

    case MOD:
      if (pattern133 (x3) != 0
          || !
#line 1456 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 46; /* modsi3_extended */

    case UMOD:
      if (pattern133 (x3) != 0
          || !
#line 1456 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 47; /* umodsi3_extended */

    case FIX:
      switch (pattern134 (x3))
        {
        case 0:
          if (!(
#line 2107 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 152; /* fix_truncsfsi2_sext */

        case 1:
          if (!(
#line 2107 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 154; /* fix_truncdfsi2_sext */

        case 2:
          if (!(
#line 2107 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 156; /* fix_trunchfsi2_sext */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern134 (x3))
        {
        case 0:
          if (!(
#line 2107 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 153; /* fixuns_truncsfsi2_sext */

        case 1:
          if (!(
#line 2107 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 155; /* fixuns_truncdfsi2_sext */

        case 2:
          if (!(
#line 2107 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 157; /* fixuns_trunchfsi2_sext */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_16 (x1, insn, pnum_clobbers);

    case ASHIFT:
      switch (pattern135 (x3))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (arith_operand (operands[2], E_QImode)
              && 
#line 2934 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 314; /* ashlsi3_extend */
          if (!subreg_lowpart_operator (x6, E_VOIDmode))
            return -1;
          switch (pattern396 (x6))
            {
            case 0:
              if (!
#line 2953 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 317; /* *ashlsi3_extend_mask */

            case 1:
              if (!
#line 2953 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 320; /* *ashlsi3_extend_mask */

            default:
              return -1;
            }

        case 1:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern387 (x6, pnum_clobbers))
            {
            case 0:
              if ((
#line 636 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 573; /* *bitmanip.md:628 */
                }
              if (!(
#line 636 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 575; /* *bitmanip.md:628 */

            case 1:
              if (!
#line 659 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f))
                return -1;
              return 577; /* *bitmanip.md:652 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 2934 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return 315; /* ashrsi3_extend */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 2953 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 318; /* *ashrsi3_extend_mask */

        case 1:
          if (!
#line 2953 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 321; /* *ashrsi3_extend_mask */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 2934 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return 316; /* lshrsi3_extend */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 2953 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 319; /* *lshrsi3_extend_mask */

        case 1:
          if (!
#line 2953 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 322; /* *lshrsi3_extend_mask */

        default:
          return -1;
        }

    case CLZ:
      if (pattern132 (x3) != 0
          || !
#line 283 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 512; /* *clzdisi2 */

    case CTZ:
      if (pattern132 (x3) != 0
          || !
#line 283 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 513; /* *ctzdisi2 */

    case POPCOUNT:
      if (pattern132 (x3) != 0
          || !
#line 283 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 514; /* *popcountdisi2 */

    case ROTATERT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 378 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
        return 534; /* rotrsi3_sext */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 450 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return -1;
          return 547; /* *rotrsi3_sext_mask */

        case 1:
          if (!(
#line 450 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 549; /* *rotrsi3_sext_mask */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (register_operand (operands[2], E_QImode)
          && 
#line 420 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
        return 537; /* rotlsi3_sext */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 450 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return -1;
          return 546; /* *rotlsi3_sext_mask */

        case 1:
          if (!(
#line 450 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 548; /* *rotlsi3_sext_mask */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 184 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
        return -1;
      return 662; /* *riscv_packw_2 */

    default:
      return -1;
    }
}

 int
recog_1466 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 1790 "../../gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))
        return -1;
      return 117; /* truncdfsf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1799 "../../gcc/config/riscv/riscv.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN))
            return -1;
          return 118; /* truncsfhf2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 1808 "../../gcc/config/riscv/riscv.md"
((TARGET_ZFHMIN && TARGET_DOUBLE_FLOAT) ||
   (TARGET_ZHINXMIN && TARGET_ZDINX)))
            return -1;
          return 119; /* truncdfhf2 */

        default:
          return -1;
        }

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 1818 "../../gcc/config/riscv/riscv.md"
(TARGET_ZFBFMIN))
        return -1;
      return 120; /* truncsfbf2 */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25438; /* truncrvvm8sfrvvm4hf2 */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25439; /* truncrvvm4sfrvvm2hf2 */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25440; /* truncrvvm2sfrvvm1hf2 */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25441; /* truncrvvm1sfrvvmf2hf2 */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25442; /* truncrvvmf2sfrvvmf4hf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25443; /* truncrvvm8dfrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25444; /* truncrvvm4dfrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25445; /* truncrvvm2dfrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25446; /* truncrvvm1dfrvvmf2sf2 */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25447; /* truncv1sfv1hf2 */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25448; /* truncv2sfv2hf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25449; /* truncv4sfv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25450; /* truncv8sfv8hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25451; /* truncv16sfv16hf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25452; /* truncv32sfv32hf2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25453; /* truncv64sfv64hf2 */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25454; /* truncv128sfv128hf2 */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25455; /* truncv256sfv256hf2 */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25456; /* truncv512sfv512hf2 */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25457; /* truncv1024sfv1024hf2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25458; /* truncv1dfv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25459; /* truncv2dfv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25460; /* truncv4dfv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25461; /* truncv8dfv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25462; /* truncv16dfv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25463; /* truncv32dfv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25464; /* truncv64dfv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25465; /* truncv128dfv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25466; /* truncv256dfv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 863 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25467; /* truncv512dfv512sf2 */

    default:
      return -1;
    }
}

 int
recog_1469 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern52 (x1))
    {
    case 0:
      if (!
#line 2098 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 147; /* *fixuns_truncsfsi2 */

    case 1:
      if (!(
#line 2098 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 149; /* *fixuns_truncdfsi2 */

    case 2:
      if (!(
#line 2098 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 151; /* *fixuns_trunchfsi2 */

    case 3:
      if (!(
#line 2116 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 159; /* fixuns_truncsfdi2 */

    case 4:
      if (!(
#line 2116 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 161; /* fixuns_truncdfdi2 */

    case 5:
      if (!(
#line 2116 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 163; /* fixuns_trunchfdi2 */

    case 6:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25469; /* fixuns_truncrvvm8hfrvvm8hi2 */

    case 7:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25471; /* fixuns_truncrvvm4hfrvvm4hi2 */

    case 8:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25829; /* fixuns_truncrvvm8sfrvvm4hi2 */

    case 9:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25473; /* fixuns_truncrvvm2hfrvvm2hi2 */

    case 10:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25831; /* fixuns_truncrvvm4sfrvvm2hi2 */

    case 11:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25475; /* fixuns_truncrvvm1hfrvvm1hi2 */

    case 12:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25833; /* fixuns_truncrvvm2sfrvvm1hi2 */

    case 13:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25477; /* fixuns_truncrvvmf2hfrvvmf2hi2 */

    case 14:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25835; /* fixuns_truncrvvm1sfrvvmf2hi2 */

    case 15:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25479; /* fixuns_truncrvvmf4hfrvvmf4hi2 */

    case 16:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25837; /* fixuns_truncrvvmf2sfrvvmf4hi2 */

    case 17:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25481; /* fixuns_truncrvvm8sfrvvm8si2 */

    case 18:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25661; /* fixuns_truncrvvm4hfrvvm8si2 */

    case 19:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25483; /* fixuns_truncrvvm4sfrvvm4si2 */

    case 20:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25663; /* fixuns_truncrvvm2hfrvvm4si2 */

    case 21:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25839; /* fixuns_truncrvvm8dfrvvm4si2 */

    case 22:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25485; /* fixuns_truncrvvm2sfrvvm2si2 */

    case 23:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25665; /* fixuns_truncrvvm1hfrvvm2si2 */

    case 24:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25841; /* fixuns_truncrvvm4dfrvvm2si2 */

    case 25:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25487; /* fixuns_truncrvvm1sfrvvm1si2 */

    case 26:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25667; /* fixuns_truncrvvmf2hfrvvm1si2 */

    case 27:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25843; /* fixuns_truncrvvm2dfrvvm1si2 */

    case 28:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25489; /* fixuns_truncrvvmf2sfrvvmf2si2 */

    case 29:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25669; /* fixuns_truncrvvmf4hfrvvmf2si2 */

    case 30:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25845; /* fixuns_truncrvvm1dfrvvmf2si2 */

    case 31:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25491; /* fixuns_truncrvvm8dfrvvm8di2 */

    case 32:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25671; /* fixuns_truncrvvm4sfrvvm8di2 */

    case 33:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25493; /* fixuns_truncrvvm4dfrvvm4di2 */

    case 34:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25673; /* fixuns_truncrvvm2sfrvvm4di2 */

    case 35:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25495; /* fixuns_truncrvvm2dfrvvm2di2 */

    case 36:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25675; /* fixuns_truncrvvm1sfrvvm2di2 */

    case 37:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25497; /* fixuns_truncrvvm1dfrvvm1di2 */

    case 38:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25677; /* fixuns_truncrvvmf2sfrvvm1di2 */

    case 39:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 25499; /* fixuns_truncv1hfv1hi2 */

    case 40:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25871; /* fixuns_truncv1sfv1hi2 */

    case 41:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 25501; /* fixuns_truncv2hfv2hi2 */

    case 42:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25873; /* fixuns_truncv2sfv2hi2 */

    case 43:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 25503; /* fixuns_truncv4hfv4hi2 */

    case 44:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25875; /* fixuns_truncv4sfv4hi2 */

    case 45:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 25505; /* fixuns_truncv8hfv8hi2 */

    case 46:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25877; /* fixuns_truncv8sfv8hi2 */

    case 47:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 25507; /* fixuns_truncv16hfv16hi2 */

    case 48:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25879; /* fixuns_truncv16sfv16hi2 */

    case 49:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25509; /* fixuns_truncv32hfv32hi2 */

    case 50:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25881; /* fixuns_truncv32sfv32hi2 */

    case 51:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25511; /* fixuns_truncv64hfv64hi2 */

    case 52:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25883; /* fixuns_truncv64sfv64hi2 */

    case 53:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25513; /* fixuns_truncv128hfv128hi2 */

    case 54:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25885; /* fixuns_truncv128sfv128hi2 */

    case 55:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25515; /* fixuns_truncv256hfv256hi2 */

    case 56:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25887; /* fixuns_truncv256sfv256hi2 */

    case 57:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25517; /* fixuns_truncv512hfv512hi2 */

    case 58:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25889; /* fixuns_truncv512sfv512hi2 */

    case 59:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25519; /* fixuns_truncv1024hfv1024hi2 */

    case 60:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25891; /* fixuns_truncv1024sfv1024hi2 */

    case 61:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25521; /* fixuns_truncv2048hfv2048hi2 */

    case 62:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25523; /* fixuns_truncv1sfv1si2 */

    case 63:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 25679; /* fixuns_truncv1hfv1si2 */

    case 64:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25893; /* fixuns_truncv1dfv1si2 */

    case 65:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25525; /* fixuns_truncv2sfv2si2 */

    case 66:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 25681; /* fixuns_truncv2hfv2si2 */

    case 67:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25895; /* fixuns_truncv2dfv2si2 */

    case 68:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25527; /* fixuns_truncv4sfv4si2 */

    case 69:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 25683; /* fixuns_truncv4hfv4si2 */

    case 70:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25897; /* fixuns_truncv4dfv4si2 */

    case 71:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25529; /* fixuns_truncv8sfv8si2 */

    case 72:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 25685; /* fixuns_truncv8hfv8si2 */

    case 73:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25899; /* fixuns_truncv8dfv8si2 */

    case 74:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25531; /* fixuns_truncv16sfv16si2 */

    case 75:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25687; /* fixuns_truncv16hfv16si2 */

    case 76:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25901; /* fixuns_truncv16dfv16si2 */

    case 77:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25533; /* fixuns_truncv32sfv32si2 */

    case 78:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25689; /* fixuns_truncv32hfv32si2 */

    case 79:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25903; /* fixuns_truncv32dfv32si2 */

    case 80:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25535; /* fixuns_truncv64sfv64si2 */

    case 81:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25691; /* fixuns_truncv64hfv64si2 */

    case 82:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25905; /* fixuns_truncv64dfv64si2 */

    case 83:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25537; /* fixuns_truncv128sfv128si2 */

    case 84:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25693; /* fixuns_truncv128hfv128si2 */

    case 85:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25907; /* fixuns_truncv128dfv128si2 */

    case 86:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25539; /* fixuns_truncv256sfv256si2 */

    case 87:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25695; /* fixuns_truncv256hfv256si2 */

    case 88:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25909; /* fixuns_truncv256dfv256si2 */

    case 89:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25541; /* fixuns_truncv512sfv512si2 */

    case 90:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25697; /* fixuns_truncv512hfv512si2 */

    case 91:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25911; /* fixuns_truncv512dfv512si2 */

    case 92:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25543; /* fixuns_truncv1024sfv1024si2 */

    case 93:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25699; /* fixuns_truncv1024hfv1024si2 */

    case 94:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25545; /* fixuns_truncv1dfv1di2 */

    case 95:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25701; /* fixuns_truncv1sfv1di2 */

    case 96:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25547; /* fixuns_truncv2dfv2di2 */

    case 97:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25703; /* fixuns_truncv2sfv2di2 */

    case 98:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25549; /* fixuns_truncv4dfv4di2 */

    case 99:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25705; /* fixuns_truncv4sfv4di2 */

    case 100:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25551; /* fixuns_truncv8dfv8di2 */

    case 101:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25707; /* fixuns_truncv8sfv8di2 */

    case 102:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25553; /* fixuns_truncv16dfv16di2 */

    case 103:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25709; /* fixuns_truncv16sfv16di2 */

    case 104:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25555; /* fixuns_truncv32dfv32di2 */

    case 105:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25711; /* fixuns_truncv32sfv32di2 */

    case 106:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25557; /* fixuns_truncv64dfv64di2 */

    case 107:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25713; /* fixuns_truncv64sfv64di2 */

    case 108:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25559; /* fixuns_truncv128dfv128di2 */

    case 109:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25715; /* fixuns_truncv128sfv128di2 */

    case 110:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25561; /* fixuns_truncv256dfv256di2 */

    case 111:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25717; /* fixuns_truncv256sfv256di2 */

    case 112:
      if (!(
#line 914 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25563; /* fixuns_truncv512dfv512di2 */

    case 113:
      if (!(
#line 963 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25719; /* fixuns_truncv512sfv512di2 */

    case 114:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25817; /* fixuns_truncrvvm8hfrvvm4qi2 */

    case 115:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25819; /* fixuns_truncrvvm4hfrvvm2qi2 */

    case 116:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25821; /* fixuns_truncrvvm2hfrvvm1qi2 */

    case 117:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25823; /* fixuns_truncrvvm1hfrvvmf2qi2 */

    case 118:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25825; /* fixuns_truncrvvmf2hfrvvmf4qi2 */

    case 119:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25827; /* fixuns_truncrvvmf4hfrvvmf8qi2 */

    case 120:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 25847; /* fixuns_truncv1hfv1qi2 */

    case 121:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 25849; /* fixuns_truncv2hfv2qi2 */

    case 122:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 25851; /* fixuns_truncv4hfv4qi2 */

    case 123:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 25853; /* fixuns_truncv8hfv8qi2 */

    case 124:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 25855; /* fixuns_truncv16hfv16qi2 */

    case 125:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25857; /* fixuns_truncv32hfv32qi2 */

    case 126:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25859; /* fixuns_truncv64hfv64qi2 */

    case 127:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25861; /* fixuns_truncv128hfv128qi2 */

    case 128:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25863; /* fixuns_truncv256hfv256qi2 */

    case 129:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25865; /* fixuns_truncv512hfv512qi2 */

    case 130:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25867; /* fixuns_truncv1024hfv1024qi2 */

    case 131:
      if (!(
#line 1007 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25869; /* fixuns_truncv2048hfv2048qi2 */

    default:
      return -1;
    }
}

 int
recog_1479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 555; /* *uminsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 603 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 32873; /* riscv_cv_alu_minu */

    case 1:
      if (!(
#line 546 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 559; /* *umindi3 */

    case 2:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23622; /* uminrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23636; /* uminrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23650; /* uminrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23664; /* uminrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23678; /* uminrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23692; /* uminrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23706; /* uminrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23720; /* uminrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23734; /* uminrvvm8si3 */

    case 11:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23748; /* uminrvvm4si3 */

    case 12:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23762; /* uminrvvm2si3 */

    case 13:
      if (!
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23776; /* uminrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23790; /* uminrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23804; /* uminrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23818; /* uminrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23832; /* uminrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23846; /* uminrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23860; /* uminrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23874; /* uminrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23888; /* uminrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23902; /* uminrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23916; /* uminrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23930; /* uminv1qi3 */

    case 25:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23944; /* uminv2qi3 */

    case 26:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23958; /* uminv4qi3 */

    case 27:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23972; /* uminv8qi3 */

    case 28:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23986; /* uminv16qi3 */

    case 29:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24000; /* uminv32qi3 */

    case 30:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24014; /* uminv64qi3 */

    case 31:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24028; /* uminv128qi3 */

    case 32:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24042; /* uminv256qi3 */

    case 33:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24056; /* uminv512qi3 */

    case 34:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24070; /* uminv1024qi3 */

    case 35:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24084; /* uminv2048qi3 */

    case 36:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24098; /* uminv4096qi3 */

    case 37:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24112; /* uminv1hi3 */

    case 38:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24126; /* uminv2hi3 */

    case 39:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24140; /* uminv4hi3 */

    case 40:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24154; /* uminv8hi3 */

    case 41:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24168; /* uminv16hi3 */

    case 42:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24182; /* uminv32hi3 */

    case 43:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24196; /* uminv64hi3 */

    case 44:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24210; /* uminv128hi3 */

    case 45:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24224; /* uminv256hi3 */

    case 46:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24238; /* uminv512hi3 */

    case 47:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24252; /* uminv1024hi3 */

    case 48:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24266; /* uminv2048hi3 */

    case 49:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24280; /* uminv1si3 */

    case 50:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24294; /* uminv2si3 */

    case 51:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24308; /* uminv4si3 */

    case 52:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24322; /* uminv8si3 */

    case 53:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24336; /* uminv16si3 */

    case 54:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24350; /* uminv32si3 */

    case 55:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24364; /* uminv64si3 */

    case 56:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24378; /* uminv128si3 */

    case 57:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24392; /* uminv256si3 */

    case 58:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24406; /* uminv512si3 */

    case 59:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24420; /* uminv1024si3 */

    case 60:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24434; /* uminv1di3 */

    case 61:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24448; /* uminv2di3 */

    case 62:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24462; /* uminv4di3 */

    case 63:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24476; /* uminv8di3 */

    case 64:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24490; /* uminv16di3 */

    case 65:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24504; /* uminv32di3 */

    case 66:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24518; /* uminv64di3 */

    case 67:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24532; /* uminv128di3 */

    case 68:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24546; /* uminv256di3 */

    case 69:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24560; /* uminv512di3 */

    default:
      return -1;
    }
}

 int
recog_1491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!(
#line 1480 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 51; /* sqrtsf2 */

    case 1:
      if (!(
#line 1480 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 52; /* sqrtdf2 */

    case 2:
      if (!(
#line 1480 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 53; /* sqrthf2 */

    case 3:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26204; /* sqrtrvvm8hf2 */

    case 4:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26205; /* sqrtrvvm4hf2 */

    case 5:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26206; /* sqrtrvvm2hf2 */

    case 6:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26207; /* sqrtrvvm1hf2 */

    case 7:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26208; /* sqrtrvvmf2hf2 */

    case 8:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26209; /* sqrtrvvmf4hf2 */

    case 9:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26210; /* sqrtrvvm8sf2 */

    case 10:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26211; /* sqrtrvvm4sf2 */

    case 11:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26212; /* sqrtrvvm2sf2 */

    case 12:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26213; /* sqrtrvvm1sf2 */

    case 13:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26214; /* sqrtrvvmf2sf2 */

    case 14:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26215; /* sqrtrvvm8df2 */

    case 15:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26216; /* sqrtrvvm4df2 */

    case 16:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26217; /* sqrtrvvm2df2 */

    case 17:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26218; /* sqrtrvvm1df2 */

    case 18:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26219; /* sqrtv1hf2 */

    case 19:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26220; /* sqrtv2hf2 */

    case 20:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26221; /* sqrtv4hf2 */

    case 21:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26222; /* sqrtv8hf2 */

    case 22:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26223; /* sqrtv16hf2 */

    case 23:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26224; /* sqrtv32hf2 */

    case 24:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26225; /* sqrtv64hf2 */

    case 25:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26226; /* sqrtv128hf2 */

    case 26:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26227; /* sqrtv256hf2 */

    case 27:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26228; /* sqrtv512hf2 */

    case 28:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26229; /* sqrtv1024hf2 */

    case 29:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26230; /* sqrtv2048hf2 */

    case 30:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26231; /* sqrtv1sf2 */

    case 31:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26232; /* sqrtv2sf2 */

    case 32:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26233; /* sqrtv4sf2 */

    case 33:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26234; /* sqrtv8sf2 */

    case 34:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26235; /* sqrtv16sf2 */

    case 35:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26236; /* sqrtv32sf2 */

    case 36:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26237; /* sqrtv64sf2 */

    case 37:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26238; /* sqrtv128sf2 */

    case 38:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26239; /* sqrtv256sf2 */

    case 39:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26240; /* sqrtv512sf2 */

    case 40:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26241; /* sqrtv1024sf2 */

    case 41:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26242; /* sqrtv1df2 */

    case 42:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26243; /* sqrtv2df2 */

    case 43:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26244; /* sqrtv4df2 */

    case 44:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26245; /* sqrtv8df2 */

    case 45:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26246; /* sqrtv16df2 */

    case 46:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26247; /* sqrtv32df2 */

    case 47:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26248; /* sqrtv64df2 */

    case 48:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26249; /* sqrtv128df2 */

    case 49:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26250; /* sqrtv256df2 */

    case 50:
      if (!(
#line 1130 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26251; /* sqrtv512df2 */

    default:
      return -1;
    }
}

 int
recog_1504 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_1500 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_1501 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) == SET)
    {
      res = recog_1502 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (x5))
    {
    case USE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8QImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2743; /* *movrvvm8qi_reg_whole_vtype */

        case E_RVVM4QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4QImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2744; /* *movrvvm4qi_reg_whole_vtype */

        case E_RVVM2QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2QImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2745; /* *movrvvm2qi_reg_whole_vtype */

        case E_RVVM1QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1QImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2746; /* *movrvvm1qi_reg_whole_vtype */

        case E_RVVM8HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2747; /* *movrvvm8hi_reg_whole_vtype */

        case E_RVVM4HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2748; /* *movrvvm4hi_reg_whole_vtype */

        case E_RVVM2HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2749; /* *movrvvm2hi_reg_whole_vtype */

        case E_RVVM1HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2750; /* *movrvvm1hi_reg_whole_vtype */

        case E_RVVM8BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8BFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 899 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2751; /* *movrvvm8bf_reg_whole_vtype */

        case E_RVVM4BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4BFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 899 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2752; /* *movrvvm4bf_reg_whole_vtype */

        case E_RVVM2BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2BFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 900 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2753; /* *movrvvm2bf_reg_whole_vtype */

        case E_RVVM1BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1BFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 900 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2754; /* *movrvvm1bf_reg_whole_vtype */

        case E_RVVM8HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 902 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2755; /* *movrvvm8hf_reg_whole_vtype */

        case E_RVVM4HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 902 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2756; /* *movrvvm4hf_reg_whole_vtype */

        case E_RVVM2HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 903 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2757; /* *movrvvm2hf_reg_whole_vtype */

        case E_RVVM1HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 903 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2758; /* *movrvvm1hf_reg_whole_vtype */

        case E_RVVM8SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2759; /* *movrvvm8si_reg_whole_vtype */

        case E_RVVM4SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2760; /* *movrvvm4si_reg_whole_vtype */

        case E_RVVM2SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2761; /* *movrvvm2si_reg_whole_vtype */

        case E_RVVM1SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SImode)
              || !
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2762; /* *movrvvm1si_reg_whole_vtype */

        case E_RVVM8SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 907 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2763; /* *movrvvm8sf_reg_whole_vtype */

        case E_RVVM4SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 907 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2764; /* *movrvvm4sf_reg_whole_vtype */

        case E_RVVM2SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 908 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2765; /* *movrvvm2sf_reg_whole_vtype */

        case E_RVVM1SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 908 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2766; /* *movrvvm1sf_reg_whole_vtype */

        case E_RVVM8DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DImode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 910 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2767; /* *movrvvm8di_reg_whole_vtype */

        case E_RVVM4DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DImode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 910 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2768; /* *movrvvm4di_reg_whole_vtype */

        case E_RVVM2DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DImode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 911 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2769; /* *movrvvm2di_reg_whole_vtype */

        case E_RVVM1DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DImode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 911 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2770; /* *movrvvm1di_reg_whole_vtype */

        case E_RVVM8DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2771; /* *movrvvm8df_reg_whole_vtype */

        case E_RVVM4DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2772; /* *movrvvm4df_reg_whole_vtype */

        case E_RVVM2DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2773; /* *movrvvm2df_reg_whole_vtype */

        case E_RVVM1DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 1248 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2774; /* *movrvvm1df_reg_whole_vtype */

        default:
          return -1;
        }

    case CLOBBER:
      return recog_1503 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 2
          || !register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x5, 0, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[4] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 81:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          if (GET_MODE (x9) != E_SImode
              || !register_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          operands[5] = x10;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          switch (pattern573 (x9))
            {
            case 0:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 744; /* subword_atomic_fetch_strong_add */

            case 1:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 745; /* subword_atomic_fetch_strong_or */

            case 2:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 746; /* subword_atomic_fetch_strong_xor */

            case 3:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 747; /* subword_atomic_fetch_strong_and */

            case 4:
              if (!
#line 284 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 748; /* subword_atomic_fetch_strong_nand */

            default:
              return -1;
            }

        case 84:
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          operands[2] = x9;
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[4], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!scratch_operand (operands[5], E_SImode)
              || !
#line 493 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
            return -1;
          return 763; /* subword_atomic_exchange_strong */

        default:
          return -1;
        }

    case CLOBBER:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      return recog_1512 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1514 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_1513 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG
          || pattern221 (x1, 
9) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 8)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x10) != SET
          || pattern549 (x10, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x11) != SET)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PLUS)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 2)
        return -1;
      x14 = XEXP (x11, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x12, 1);
      operands[0] = x15;
      if (!stack_push_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern732 (x1))
        {
        case 0:
          if (pattern735 (x1, 
E_SImode) != 0
              || !(
#line 1142 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32828; /* gpr_multi_push_up_to_s1_si */

        case 1:
          if (pattern735 (x1, 
E_DImode) != 0
              || !(
#line 1142 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32829; /* gpr_multi_push_up_to_s1_di */

        default:
          return -1;
        }

    case PLUS:
      x16 = XEXP (x3, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 2)
        return -1;
      x17 = XEXP (x2, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern389 (x4) != 0)
        return -1;
      x18 = XEXP (x3, 1);
      operands[0] = x18;
      x5 = XEXP (x4, 1);
      x19 = XEXP (x5, 0);
      x20 = XEXP (x19, 1);
      switch (XWINT (x20, 0))
        {
        case -4L:
          switch (pattern475 (x1, 
E_SImode, 
-12, 
-8))
            {
            case 0:
              if (!(
#line 59 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32756; /* gpr_multi_pop_up_to_s1_si */

            case 1:
              if (!(
#line 363 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32776; /* gpr_multi_popret_up_to_ra_si */

            default:
              return -1;
            }

        case -8L:
          switch (pattern475 (x1, 
E_DImode, 
-24, 
-16))
            {
            case 0:
              if (!(
#line 59 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32757; /* gpr_multi_pop_up_to_s1_di */

            case 1:
              if (!(
#line 363 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32777; /* gpr_multi_popret_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (pattern119 (x1, 
CLOBBER, 
22) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != RETURN
          || !
#line 277 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
        return -1;
      return 885; /* th_int_pop */

    case SET:
      if (pattern120 (x1, 
23, 
24, 
25, 
26, 
27) != 0
          || pattern741 (x1, 
18, 
19, 
20, 
21, 
22) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 11);
      if (pattern763 (x4) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 9)
        return -1;
      x6 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 8)
        return -1;
      x12 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 1);
      if (GET_CODE (x13) != MEM)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XEXP (x12, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 1)
        return -1;
      x18 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x18) != SET)
        return -1;
      x19 = XEXP (x18, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x18, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 10)
        return -1;
      x21 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x21) != USE)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 10)
        return -1;
      x23 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != USE)
        return -1;
      x24 = XEXP (x3, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 1
          || GET_MODE (x24) != E_SImode)
        return -1;
      x25 = XEXP (x2, 1);
      x26 = XEXP (x25, 1);
      operands[0] = x26;
      if (!stack_pop_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern771 (x1))
        {
        case 0:
          if (XWINT (x10, 0) != -48L
              || XWINT (x16, 0) != -52L
              || pattern794 (x1, 
E_SImode) != 0
              || !(
#line 1100 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32822; /* gpr_multi_popretz_up_to_s11_si */

        case 1:
          if (XWINT (x10, 0) != -96L
              || XWINT (x16, 0) != -104L
              || pattern794 (x1, 
E_DImode) != 0
              || !(
#line 1100 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32823; /* gpr_multi_popretz_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern371 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 4);
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (pattern726 (x1))
        {
        case 0:
          if (XWINT (x9, 0) != -16L)
            return -1;
          switch (pattern738 (x1, 
E_SImode, 
-32, 
-28, 
-24, 
-20))
            {
            case 0:
              if (!(
#line 189 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32766; /* gpr_multi_pop_up_to_s6_si */

            case 1:
              if (!(
#line 473 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32786; /* gpr_multi_popret_up_to_s4_si */

            case 2:
              if (!(
#line 789 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32806; /* gpr_multi_popretz_up_to_s2_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x9, 0) != -32L)
            return -1;
          switch (pattern738 (x1, 
E_DImode, 
-64, 
-56, 
-48, 
-40))
            {
            case 0:
              if (!(
#line 189 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32767; /* gpr_multi_pop_up_to_s6_di */

            case 1:
              if (!(
#line 473 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32787; /* gpr_multi_popret_up_to_s4_di */

            case 2:
              if (!(
#line 789 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32807; /* gpr_multi_popretz_up_to_s2_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 22)
        return -1;
      x12 = XEXP (x3, 0);
      if (GET_CODE (x12) != MEM)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x13, 1);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      if (pattern413 (x16, 
21) != 0)
        return -1;
      x17 = XVECEXP (x1, 0, 2);
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 20)
        return -1;
      x19 = XEXP (x17, 0);
      if (GET_CODE (x19) != MEM)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != PLUS)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x22 = XEXP (x20, 1);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x1, 0, 3);
      if (pattern671 (x23, 
19) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 4);
      if (pattern731 (x5, 
18) != 0
          || pattern737 (x1, 
9) != 0
          || pattern743 (x1, 
8) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern748 (x24, 
1) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x25) != SET)
        return -1;
      x26 = XEXP (x25, 1);
      if (GET_CODE (x26) != PLUS)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 2)
        return -1;
      x28 = XEXP (x25, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 1);
      operands[0] = x29;
      if (!stack_push_up_to_s6_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern756 (x1))
        {
        case 0:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -32L
              || pattern765 (x1, 
E_SImode) != 0
              || !(
#line 1272 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32838; /* gpr_multi_push_up_to_s6_si */

        case 1:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -64L
              || pattern765 (x1, 
E_DImode) != 0
              || !(
#line 1272 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32839; /* gpr_multi_push_up_to_s6_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  if (pattern115 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern427 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 8);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern752 (x1))
        {
        case 0:
          switch (pattern760 (x1, 
E_SImode))
            {
            case 0:
              if (pattern776 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern784 (x1, 
E_SImode) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 10);
              x7 = XEXP (x6, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
                return -1;
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 8
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XVECEXP (x1, 0, 11);
              if (pattern790 (x11) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              if (pattern795 (x12, 
E_SImode) != 0
                  || !(
#line 303 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32772; /* gpr_multi_pop_up_to_s9_si */

            case 1:
              if (pattern776 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern785 (x1, 
E_SImode) != 0
                  || !(
#line 575 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32792; /* gpr_multi_popret_up_to_s7_si */

            case 2:
              if (!(
#line 882 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32812; /* gpr_multi_popretz_up_to_s5_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern760 (x1, 
E_DImode))
            {
            case 0:
              if (pattern778 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern784 (x1, 
E_DImode) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 10);
              x7 = XEXP (x6, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != CONST_INT
                  || XWINT (x9, 0) != -80L)
                return -1;
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 8
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XVECEXP (x1, 0, 11);
              if (pattern792 (x11) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              if (pattern795 (x12, 
E_DImode) != 0
                  || !(
#line 303 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32773; /* gpr_multi_pop_up_to_s9_di */

            case 1:
              if (pattern778 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern785 (x1, 
E_DImode) != 0
                  || !(
#line 575 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32793; /* gpr_multi_popret_up_to_s7_di */

            case 2:
              if (!(
#line 882 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32813; /* gpr_multi_popretz_up_to_s5_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern390 (x1, 
24, 
25) != 0
          || pattern537 (x1, 
19, 
20, 
21, 
22, 
23) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 7);
      if (pattern748 (x13, 
18) != 0
          || pattern759 (x1, 
8, 
9) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x6) != SET
          || pattern767 (x6, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x11) != SET)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      operands[0] = x16;
      if (!stack_push_up_to_s9_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern772 (x1))
        {
        case 0:
          if (pattern781 (x1, 
E_SImode) != 0
              || !(
#line 1386 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32844; /* gpr_multi_push_up_to_s9_si */

        case 1:
          if (pattern781 (x1, 
E_DImode) != 0
              || !(
#line 1386 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32845; /* gpr_multi_push_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1524 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode)
    return -1;
  switch (pattern752 (x1))
    {
    case 0:
      x7 = XVECEXP (x1, 0, 8);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (XWINT (x10, 0) != -32L)
        return -1;
      switch (pattern764 (x1, 
E_SImode))
        {
        case 0:
          x11 = XEXP (x2, 1);
          if (pattern774 (x11) != 0
              || REGNO (x3) != 8)
            return -1;
          x12 = XVECEXP (x1, 0, 10);
          if (pattern787 (x12) != 0
              || !(
#line 615 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32794; /* gpr_multi_popret_up_to_s8_si */

        case 1:
          if (!(
#line 919 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32814; /* gpr_multi_popretz_up_to_s6_si */

        default:
          return -1;
        }

    case 1:
      x7 = XVECEXP (x1, 0, 8);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (XWINT (x10, 0) != -64L)
        return -1;
      switch (pattern764 (x1, 
E_DImode))
        {
        case 0:
          x11 = XEXP (x2, 1);
          if (pattern777 (x11) != 0
              || REGNO (x3) != 8)
            return -1;
          x12 = XVECEXP (x1, 0, 10);
          if (pattern788 (x12) != 0
              || !(
#line 615 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32795; /* gpr_multi_popret_up_to_s8_di */

        case 1:
          if (!(
#line 919 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32815; /* gpr_multi_popretz_up_to_s6_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_1459 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_1463 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_1461 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_1493 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_1489 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_1477 (x1, insn, pnum_clobbers);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      return recog_29 (x1, insn, pnum_clobbers);

    case UDIV:
      return recog_1484 (x1, insn, pnum_clobbers);

    case MOD:
      return recog_1483 (x1, insn, pnum_clobbers);

    case UMOD:
      return recog_1482 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_1491 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_1495 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_1490 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_1468 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_1472 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_1471 (x1, insn, pnum_clobbers);

    case AND:
      return recog_1485 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_1475 (x1, insn, pnum_clobbers);

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_94 (x1, insn, pnum_clobbers);

        case ASHIFT:
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern226 (x2))
                {
                case 0:
                  if (!(
#line 2978 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 325; /* xor_shift_reversesi */

                case 1:
                  if (!(
#line 2978 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 328; /* xor_shift_reversedi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x6, 0) != 1L)
                return -1;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              switch (pattern287 (x2))
                {
                case 0:
                  if ((
#line 587 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 563; /* *binvsi */
                  break;

                case 1:
                  if ((
#line 587 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 565; /* *binvdi */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x7) != SUBREG)
                return -1;
              switch (pattern330 (x2))
                {
                case 0:
                  if (!(
#line 600 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 567; /* *binvsi_mask */

                case 1:
                  if (!(
#line 600 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 569; /* *binvdi_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern194 (x2, pnum_clobbers))
            {
            case 0:
              if ((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 580; /* *bitmanip.md:673 */
                }
              if (!(
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 584; /* *bitmanip.md:673 */

            case 1:
              if ((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 588; /* *bitmanip.md:699 */
                }
              if (!(
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 592; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern194 (x2, pnum_clobbers))
            {
            case 0:
              if ((
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 582; /* *bitmanip.md:673 */
                }
              if (!(
#line 684 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 586; /* *bitmanip.md:673 */

            case 1:
              if ((
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 590; /* *bitmanip.md:699 */
                }
              if (!(
#line 710 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 594; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_1476 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_1466 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_1492 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_1467 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_1488 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_1470 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_1469 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_1465 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_1464 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern321 (x2, 
E_SImode) != 0
              || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 272; /* *lowsi */

        case E_DImode:
          if (pattern321 (x2, 
E_DImode) != 0
              || !
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 273; /* *lowdi */

        default:
          return -1;
        }

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern265 (x2))
            {
            case 0:
              return 302; /* *ashlsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 308; /* *ashlsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 305; /* *ashldi3_mask_1 */

            case 3:
              if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 311; /* *ashldi3_mask_1 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_QImode))
            {
              switch (pattern332 (x2))
                {
                case 0:
                  if ((
#line 608 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 570; /* *bsetsi_1 */
                  break;

                case 1:
                  if ((
#line 608 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 571; /* *bsetdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_QImode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != AND)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern416 (x2, 
E_SImode) != 0
                  || !const_si_mask_operand (operands[2], E_VOIDmode)
                  || !(
#line 781 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 603; /* *bsetsi_1_mask */

            case E_DImode:
              if (pattern416 (x2, 
E_DImode) != 0
                  || !const_di_mask_operand (operands[2], E_VOIDmode)
                  || !(
#line 781 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 604; /* *bsetdi_1_mask */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          return recog_364 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern104 (x1, 
SIGN_EXTEND))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_365 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern265 (x2))
            {
            case 0:
              return 303; /* *ashrsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 309; /* *ashrsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 306; /* *ashrdi3_mask_1 */

            case 3:
              if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 312; /* *ashrdi3_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 262 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32856; /* riscv_cv_mac_mulsN */

        case 2:
          if (!
#line 281 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32857; /* riscv_cv_mac_mulhhsN */

        case 3:
          if (!
#line 352 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32860; /* riscv_cv_mac_mulsRN */

        case 4:
          if (!
#line 433 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32864; /* riscv_cv_mac_macsN */

        case 5:
          if (!
#line 377 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32861; /* riscv_cv_mac_mulhhsRN */

        case 6:
          if (!
#line 453 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32865; /* riscv_cv_mac_machhsN */

        case 7:
          if (!
#line 530 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32868; /* riscv_cv_mac_macsRN */

        case 8:
          if (!
#line 557 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32869; /* riscv_cv_mac_machhsRN */

        case 9:
          if (!
#line 709 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32882; /* riscv_cv_alu_addN */

        case 10:
          if (!
#line 748 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32884; /* riscv_cv_alu_addRN */

        case 11:
          if (!
#line 826 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32888; /* riscv_cv_alu_subRN */

        case 12:
          if (!
#line 787 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32886; /* riscv_cv_alu_subN */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern104 (x1, 
ZERO_EXTEND))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_366 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern265 (x2))
            {
            case 0:
              return 304; /* *lshrsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 310; /* *lshrsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 307; /* *lshrdi3_mask_1 */

            case 3:
              if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 313; /* *lshrdi3_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 226 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32854; /* riscv_cv_mac_muluN */

        case 2:
          if (!
#line 245 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32855; /* riscv_cv_mac_mulhhuN */

        case 3:
          if (!
#line 304 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32858; /* riscv_cv_mac_muluRN */

        case 4:
          if (!
#line 395 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32862; /* riscv_cv_mac_macuN */

        case 5:
          if (!
#line 329 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32859; /* riscv_cv_mac_mulhhuRN */

        case 6:
          if (!
#line 415 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32863; /* riscv_cv_mac_machhuN */

        case 7:
          if (!
#line 478 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32866; /* riscv_cv_mac_macuRN */

        case 8:
          if (!
#line 505 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32867; /* riscv_cv_mac_machhuRN */

        case 9:
          if (!
#line 725 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32883; /* riscv_cv_alu_adduN */

        case 10:
          if (!
#line 771 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32885; /* riscv_cv_alu_adduRN */

        case 11:
          if (!
#line 849 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32889; /* riscv_cv_alu_subuRN */

        case 12:
          if (!
#line 803 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32887; /* riscv_cv_alu_subuN */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (
#line 3015 "../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && (INTVAL (operands[3]) > 0)
    && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return 330; /* *lshrsi3_extend_2 */
          if (pnum_clobbers != NULL
              && (
#line 3050 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 335; /* *extractdi3 */
            }
          if (!(
#line 53 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 857; /* *th_extdi4 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 3050 "../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            {
              *pnum_clobbers = 1;
              return 333; /* *extractsi3 */
            }
          if (!
#line 53 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB))
            return -1;
          return 856; /* *th_extsi4 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          res = recog_367 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (XWINT (x5, 0) == 1L)
        {
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              if (register_operand (operands[2], E_QImode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern402 (x2, 
E_SImode) == 0
                          && (
#line 905 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                        return 618; /* *bextsi */
                      break;

                    case E_DImode:
                      if (pattern402 (x2, 
E_DImode) == 0
                          && (
#line 905 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 619; /* *bextdi */
                      break;

                    default:
                      break;
                    }
                }
              break;

            case REG:
            case SUBREG:
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern388 (x2, 
E_SImode) == 0
                      && (
#line 972 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 624; /* *bextsi */
                  break;

                case E_DImode:
                  if (pattern388 (x2, 
E_DImode) == 0
                      && (
#line 972 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 625; /* *bextdi */
                  break;

                default:
                  break;
                }
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x11;
              if (immediate_operand (operands[2], E_VOIDmode))
                {
                  switch (pattern107 (x2))
                    {
                    case 0:
                      if ((
#line 981 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                        return 626; /* *bexti */
                      break;

                    case 1:
                      if ((
#line 981 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 627; /* *bexti */
                      break;

                    default:
                      break;
                    }
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x11 = XEXP (x2, 2);
          operands[3] = x11;
          if (const_int_operand (operands[3], E_VOIDmode))
            {
              switch (pattern107 (x2))
                {
                case 0:
                  if (
#line 88 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB
   && (UINTVAL (operands[2]) + UINTVAL (operands[3])
       <= GET_MODE_BITSIZE (SImode))))
                    return 864; /* *th_extusi4 */
                  break;

                case 1:
                  if ((
#line 88 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB
   && (UINTVAL (operands[2]) + UINTVAL (operands[3])
       <= GET_MODE_BITSIZE (DImode))) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 865; /* *th_extudi4 */
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (pattern107 (x2))
        {
        case 0:
          if (!(
#line 151 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 875; /* *th_tstsi3 */

        case 1:
          if (!(
#line 151 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 876; /* *th_tstdi3 */

        default:
          return -1;
        }

    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      return recog_1494 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_1460 (x1, insn, pnum_clobbers);

    case NE:
      switch (pattern106 (x1, 
0))
        {
        case 0:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 414; /* *sne_zero_sisi */

        case 1:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 415; /* *sne_zero_disi */

        case 2:
          if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 416; /* *sne_zero_didi */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern215 (x2))
        {
        case 0:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 418; /* *sgtu_sisi */

        case 1:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 420; /* *sgtu_disi */

        case 2:
          if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 422; /* *sgtu_didi */

        default:
          return -1;
        }

    case GEU:
      switch (pattern106 (x1, 
1))
        {
        case 0:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 424; /* *sgeu_sisi */

        case 1:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 426; /* *sgeu_disi */

        case 2:
          if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 428; /* *sgeu_didi */

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern264 (x2))
        {
        case 0:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 430; /* sltu_sisi3 */

        case 1:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 432; /* sltu_disi3 */

        case 2:
          if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 434; /* sltu_didi3 */

        default:
          return -1;
        }

    case LEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern216 (x2))
        {
        case 0:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 436; /* *sleu_sisi */

        case 1:
          if (!
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 438; /* *sleu_disi */

        case 2:
          if (!
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 440; /* *sleu_didi */

        case 3:
          if (!
#line 581 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32871; /* riscv_cv_alu_sletu */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_1474 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_1480 (x1, insn, pnum_clobbers);

    case CTZ:
      return recog_1481 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      return recog_1462 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern107 (x2))
        {
        case 0:
          if (arith_operand (operands[2], E_QImode)
              && 
#line 342 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return 532; /* *rotrsi3 */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 38 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || SImode == SImode)))
            return 854; /* *th_srrisi3 */
          break;

        case 1:
          if (arith_operand (operands[2], E_QImode)
              && 
#line 370 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return 533; /* *rotrdi3 */
          if (const_int_operand (operands[2], E_VOIDmode)
              && (
#line 38 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || DImode == SImode)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 855; /* *th_srridi3 */
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x5, E_VOIDmode))
        return -1;
      switch (pattern265 (x2))
        {
        case 0:
          if (!
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return -1;
          return 539; /* *rotrsi3_mask */

        case 1:
          if (!(
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 543; /* *rotrsi3_mask */

        case 2:
          if (!(
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 541; /* *rotrdi3_mask */

        case 3:
          if (!(
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 545; /* *rotrdi3_mask */

        default:
          return -1;
        }

    case ROTATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (register_operand (operands[2], E_QImode))
        {
          switch (pattern107 (x2))
            {
            case 0:
              if (
#line 386 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
                return 535; /* *rotlsi3 */
              break;

            case 1:
              if (
#line 412 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
                return 536; /* rotldi3 */
              break;

            default:
              break;
            }
        }
      if (!subreg_lowpart_operator (x5, E_VOIDmode))
        return -1;
      switch (pattern265 (x2))
        {
        case 0:
          if (!
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return -1;
          return 538; /* *rotlsi3_mask */

        case 1:
          if (!(
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 542; /* *rotlsi3_mask */

        case 2:
          if (!(
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 540; /* *rotldi3_mask */

        case 3:
          if (!(
#line 432 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 544; /* *rotldi3_mask */

        default:
          return -1;
        }

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern107 (x2))
        {
        case 0:
          if ((
#line 491 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return 552; /* *bswapsi2 */
          if (!
#line 129 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || SImode == SImode)))
            return -1;
          return 871; /* th_revsi2 */

        case 1:
          if ((
#line 491 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 553; /* *bswapdi2 */
          if (!(
#line 129 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || DImode == SImode)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 872; /* th_revdi2 */

        default:
          return -1;
        }

    case UMIN:
      return recog_1479 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_1478 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_1473 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      return recog_1487 (x1, insn, pnum_clobbers);

    case UMUL_HIGHPART:
      return recog_1486 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern280 (x2, 
E_HImode))
        {
        case 0:
          if ((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_8 (insn, operands);
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_191 (insn, operands);
          break;

        case 1:
          if ((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_11 (insn, operands);
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_194 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_SImode:
      switch (pattern280 (x2, 
E_SImode))
        {
        case 0:
          if ((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_9 (insn, operands);
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_192 (insn, operands);
          break;

        case 1:
          if ((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_12 (insn, operands);
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_195 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern280 (x2, 
E_DImode))
        {
        case 0:
          if (((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1975 "../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_10 (insn, operands);
          if (((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 559 "../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_193 (insn, operands);
          break;

        case 1:
          if (((
#line 1971 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1975 "../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_13 (insn, operands);
          if (((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 559 "../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_196 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM8HImode:
      if (register_operand (operands[0], E_RVVM8HImode)
          && GET_MODE (x2) == E_RVVM8HImode
          && register_operand (operands[1], E_RVVM4QImode)
          && (
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4149 (insn, operands);
      break;

    case E_RVVM4HImode:
      if (register_operand (operands[0], E_RVVM4HImode)
          && GET_MODE (x2) == E_RVVM4HImode
          && register_operand (operands[1], E_RVVM2QImode)
          && (
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4151 (insn, operands);
      break;

    case E_RVVM2HImode:
      if (register_operand (operands[0], E_RVVM2HImode)
          && GET_MODE (x2) == E_RVVM2HImode
          && register_operand (operands[1], E_RVVM1QImode)
          && (
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4153 (insn, operands);
      break;

    case E_RVVM1HImode:
      if (register_operand (operands[0], E_RVVM1HImode)
          && GET_MODE (x2) == E_RVVM1HImode
          && register_operand (operands[1], E_RVVMF2QImode)
          && (
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4155 (insn, operands);
      break;

    case E_RVVMF2HImode:
      if (register_operand (operands[0], E_RVVMF2HImode)
          && GET_MODE (x2) == E_RVVMF2HImode
          && register_operand (operands[1], E_RVVMF4QImode)
          && (
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4157 (insn, operands);
      break;

    case E_RVVMF4HImode:
      if (register_operand (operands[0], E_RVVMF4HImode)
          && GET_MODE (x2) == E_RVVMF4HImode
          && register_operand (operands[1], E_RVVMF8QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4159 (insn, operands);
      break;

    case E_RVVM8SImode:
      switch (pattern291 (x2))
        {
        case 0:
          if ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4161 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4245 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM4SImode:
      switch (pattern292 (x2))
        {
        case 0:
          if ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4163 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4247 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM2SImode:
      switch (pattern293 (x2))
        {
        case 0:
          if ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4165 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4249 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM1SImode:
      switch (pattern294 (x2))
        {
        case 0:
          if ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4167 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4251 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVMF2SImode:
      switch (pattern295 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4169 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4253 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM8DImode:
      switch (pattern296 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4171 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4255 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4305 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM4DImode:
      switch (pattern297 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4173 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4257 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4307 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM2DImode:
      switch (pattern298 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4175 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4259 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4309 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM1DImode:
      switch (pattern299 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4177 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4261 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4311 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1HImode:
      if (register_operand (operands[0], E_V1HImode)
          && GET_MODE (x2) == E_V1HImode
          && register_operand (operands[1], E_V1QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4179 (insn, operands);
      break;

    case E_V2HImode:
      if (register_operand (operands[0], E_V2HImode)
          && GET_MODE (x2) == E_V2HImode
          && register_operand (operands[1], E_V2QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4181 (insn, operands);
      break;

    case E_V4HImode:
      if (register_operand (operands[0], E_V4HImode)
          && GET_MODE (x2) == E_V4HImode
          && register_operand (operands[1], E_V4QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4183 (insn, operands);
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && GET_MODE (x2) == E_V8HImode
          && register_operand (operands[1], E_V8QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4185 (insn, operands);
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && GET_MODE (x2) == E_V16HImode
          && register_operand (operands[1], E_V16QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4187 (insn, operands);
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && GET_MODE (x2) == E_V32HImode
          && register_operand (operands[1], E_V32QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4189 (insn, operands);
      break;

    case E_V64HImode:
      if (register_operand (operands[0], E_V64HImode)
          && GET_MODE (x2) == E_V64HImode
          && register_operand (operands[1], E_V64QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4191 (insn, operands);
      break;

    case E_V128HImode:
      if (register_operand (operands[0], E_V128HImode)
          && GET_MODE (x2) == E_V128HImode
          && register_operand (operands[1], E_V128QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4193 (insn, operands);
      break;

    case E_V256HImode:
      if (register_operand (operands[0], E_V256HImode)
          && GET_MODE (x2) == E_V256HImode
          && register_operand (operands[1], E_V256QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4195 (insn, operands);
      break;

    case E_V512HImode:
      if (register_operand (operands[0], E_V512HImode)
          && GET_MODE (x2) == E_V512HImode
          && register_operand (operands[1], E_V512QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4197 (insn, operands);
      break;

    case E_V1024HImode:
      if (register_operand (operands[0], E_V1024HImode)
          && GET_MODE (x2) == E_V1024HImode
          && register_operand (operands[1], E_V1024QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4199 (insn, operands);
      break;

    case E_V2048HImode:
      if (register_operand (operands[0], E_V2048HImode)
          && GET_MODE (x2) == E_V2048HImode
          && register_operand (operands[1], E_V2048QImode)
          && ((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4201 (insn, operands);
      break;

    case E_V1SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4203 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4263 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V2SImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4205 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4265 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V4SImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4207 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4267 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V8SImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4209 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4269 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V16SImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4211 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4271 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V32SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4213 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4273 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V64SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4215 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4275 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V128SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4217 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4277 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V256SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4219 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4279 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V512SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4221 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4281 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1024SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4223 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4283 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1DImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4225 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4285 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4313 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V2DImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4227 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4287 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4315 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V4DImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4229 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4289 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4317 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V8DImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4231 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4291 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4319 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V16DImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4233 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4293 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4321 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V32DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4235 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4295 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4323 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V64DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4237 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4297 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4325 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V128DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4239 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4299 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4327 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V256DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4241 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4301 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4329 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V512DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (((
#line 726 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4243 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4303 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 759 "../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4331 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x3) != SUBREG
      || pattern232 (x2) != 0)
    return NULL;
  if (vector_length_operand (operands[1], E_SImode)
      && ((
#line 1827 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1829 "../../gcc/config/riscv/vector.md"
( 1)))
    return gen_split_2307 (insn, operands);
  if (!vector_length_operand (operands[1], E_DImode)
      || !((
#line 1827 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1829 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2308 (insn, operands);
}

 rtx_insn *
split_117 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern447 (x2))
    {
    case 0:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_488 (insn, operands);

    case 1:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_489 (insn, operands);

    case 2:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_490 (insn, operands);

    case 3:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_491 (insn, operands);

    case 4:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_492 (insn, operands);

    case 5:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_493 (insn, operands);

    case 6:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_494 (insn, operands);

    case 7:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_495 (insn, operands);

    case 8:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_496 (insn, operands);

    case 9:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_497 (insn, operands);

    case 10:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_498 (insn, operands);

    case 11:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_499 (insn, operands);

    case 12:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_500 (insn, operands);

    case 13:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_501 (insn, operands);

    case 14:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_502 (insn, operands);

    case 15:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_503 (insn, operands);

    case 16:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_504 (insn, operands);

    case 17:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_505 (insn, operands);

    case 18:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_506 (insn, operands);

    case 19:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_507 (insn, operands);

    case 20:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_508 (insn, operands);

    case 21:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_509 (insn, operands);

    case 22:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_510 (insn, operands);

    case 23:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_511 (insn, operands);

    case 24:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_512 (insn, operands);

    case 25:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_513 (insn, operands);

    case 26:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_514 (insn, operands);

    case 27:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_515 (insn, operands);

    case 28:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_516 (insn, operands);

    case 29:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_517 (insn, operands);

    case 30:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_518 (insn, operands);

    case 31:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_519 (insn, operands);

    case 32:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_520 (insn, operands);

    case 33:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_521 (insn, operands);

    case 34:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_522 (insn, operands);

    case 35:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_523 (insn, operands);

    case 36:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_524 (insn, operands);

    case 37:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_525 (insn, operands);

    case 38:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_526 (insn, operands);

    case 39:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_527 (insn, operands);

    case 40:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_528 (insn, operands);

    case 41:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_529 (insn, operands);

    case 42:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_530 (insn, operands);

    case 43:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_531 (insn, operands);

    case 44:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_532 (insn, operands);

    case 45:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_533 (insn, operands);

    case 46:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_534 (insn, operands);

    case 47:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_535 (insn, operands);

    case 48:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_536 (insn, operands);

    case 49:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_537 (insn, operands);

    case 50:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_538 (insn, operands);

    case 51:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_539 (insn, operands);

    case 52:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_540 (insn, operands);

    case 53:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_541 (insn, operands);

    case 54:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_542 (insn, operands);

    case 55:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_543 (insn, operands);

    case 56:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_544 (insn, operands);

    case 57:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_545 (insn, operands);

    case 58:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_546 (insn, operands);

    case 59:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_547 (insn, operands);

    case 60:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_548 (insn, operands);

    case 61:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_549 (insn, operands);

    case 62:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_550 (insn, operands);

    case 63:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_551 (insn, operands);

    case 64:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_552 (insn, operands);

    case 65:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_553 (insn, operands);

    case 66:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_554 (insn, operands);

    case 67:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_555 (insn, operands);

    case 68:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_556 (insn, operands);

    case 69:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_557 (insn, operands);

    case 70:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_558 (insn, operands);

    case 71:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_559 (insn, operands);

    case 72:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_560 (insn, operands);

    case 73:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_561 (insn, operands);

    case 74:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_562 (insn, operands);

    case 75:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_563 (insn, operands);

    case 76:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_564 (insn, operands);

    case 77:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_565 (insn, operands);

    case 78:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_566 (insn, operands);

    case 79:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_567 (insn, operands);

    case 80:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_568 (insn, operands);

    case 81:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_569 (insn, operands);

    case 82:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_570 (insn, operands);

    case 83:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_571 (insn, operands);

    case 84:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_572 (insn, operands);

    case 85:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_573 (insn, operands);

    case 86:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_574 (insn, operands);

    case 87:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_575 (insn, operands);

    case 88:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_576 (insn, operands);

    case 89:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_577 (insn, operands);

    case 90:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_578 (insn, operands);

    case 91:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_579 (insn, operands);

    case 92:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_580 (insn, operands);

    case 93:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_581 (insn, operands);

    case 94:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_582 (insn, operands);

    case 95:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_583 (insn, operands);

    case 96:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_584 (insn, operands);

    case 97:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 269 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_585 (insn, operands);

    case 98:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 270 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_586 (insn, operands);

    case 99:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 271 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_587 (insn, operands);

    case 100:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_588 (insn, operands);

    case 101:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_589 (insn, operands);

    case 102:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_590 (insn, operands);

    case 103:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_591 (insn, operands);

    case 104:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_592 (insn, operands);

    case 105:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_593 (insn, operands);

    case 106:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_594 (insn, operands);

    case 107:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_595 (insn, operands);

    case 108:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_596 (insn, operands);

    case 109:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_597 (insn, operands);

    case 110:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_598 (insn, operands);

    case 111:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_599 (insn, operands);

    case 112:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_600 (insn, operands);

    case 113:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_601 (insn, operands);

    case 114:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_602 (insn, operands);

    case 115:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_603 (insn, operands);

    case 116:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_604 (insn, operands);

    case 117:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_605 (insn, operands);

    case 118:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_606 (insn, operands);

    case 119:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1153 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_607 (insn, operands);

    case 120:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_608 (insn, operands);

    case 121:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_609 (insn, operands);

    case 122:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_610 (insn, operands);

    case 123:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_611 (insn, operands);

    case 124:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_612 (insn, operands);

    case 125:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_613 (insn, operands);

    case 126:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_614 (insn, operands);

    case 127:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_615 (insn, operands);

    case 128:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_616 (insn, operands);

    case 129:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_617 (insn, operands);

    case 130:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1164 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_618 (insn, operands);

    case 131:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1165 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_619 (insn, operands);

    case 132:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1166 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_620 (insn, operands);

    case 133:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_621 (insn, operands);

    case 134:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_622 (insn, operands);

    case 135:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_623 (insn, operands);

    case 136:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_624 (insn, operands);

    case 137:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_625 (insn, operands);

    case 138:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_626 (insn, operands);

    case 139:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_627 (insn, operands);

    case 140:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_628 (insn, operands);

    case 141:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_629 (insn, operands);

    case 142:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_630 (insn, operands);

    case 143:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_631 (insn, operands);

    case 144:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_632 (insn, operands);

    case 145:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_633 (insn, operands);

    case 146:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_634 (insn, operands);

    case 147:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_635 (insn, operands);

    case 148:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_636 (insn, operands);

    case 149:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_637 (insn, operands);

    case 150:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_638 (insn, operands);

    case 151:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_639 (insn, operands);

    case 152:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_640 (insn, operands);

    case 153:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_641 (insn, operands);

    case 154:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_642 (insn, operands);

    case 155:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_643 (insn, operands);

    case 156:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_644 (insn, operands);

    case 157:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_645 (insn, operands);

    case 158:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_646 (insn, operands);

    case 159:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_647 (insn, operands);

    case 160:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_648 (insn, operands);

    case 161:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_649 (insn, operands);

    case 162:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_650 (insn, operands);

    case 163:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_651 (insn, operands);

    case 164:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_652 (insn, operands);

    case 165:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_653 (insn, operands);

    case 166:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_654 (insn, operands);

    case 167:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_655 (insn, operands);

    case 168:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_656 (insn, operands);

    case 169:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_657 (insn, operands);

    case 170:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_658 (insn, operands);

    case 171:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_659 (insn, operands);

    case 172:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_660 (insn, operands);

    case 173:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_661 (insn, operands);

    case 174:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_662 (insn, operands);

    case 175:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_663 (insn, operands);

    case 176:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_664 (insn, operands);

    case 177:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_665 (insn, operands);

    case 178:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_666 (insn, operands);

    case 179:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_667 (insn, operands);

    case 180:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_668 (insn, operands);

    case 181:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_669 (insn, operands);

    case 182:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_670 (insn, operands);

    case 183:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_671 (insn, operands);

    case 184:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_672 (insn, operands);

    case 185:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_673 (insn, operands);

    case 186:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_674 (insn, operands);

    case 187:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_675 (insn, operands);

    case 188:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_676 (insn, operands);

    case 189:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_677 (insn, operands);

    case 190:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_678 (insn, operands);

    case 191:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_679 (insn, operands);

    case 192:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_680 (insn, operands);

    case 193:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_681 (insn, operands);

    case 194:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_682 (insn, operands);

    case 195:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_683 (insn, operands);

    case 196:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1233 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_684 (insn, operands);

    case 197:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1234 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_685 (insn, operands);

    case 198:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1235 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_686 (insn, operands);

    case 199:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1236 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_687 (insn, operands);

    case 200:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1237 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_688 (insn, operands);

    case 201:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1238 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_689 (insn, operands);

    case 202:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1239 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_690 (insn, operands);

    case 203:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1240 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_691 (insn, operands);

    case 204:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1241 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_692 (insn, operands);

    case 205:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1242 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_693 (insn, operands);

    case 206:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1243 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_694 (insn, operands);

    case 207:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1244 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_695 (insn, operands);

    case 208:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1245 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_696 (insn, operands);

    case 209:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1246 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_697 (insn, operands);

    case 210:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_698 (insn, operands);

    case 211:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_699 (insn, operands);

    case 212:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_700 (insn, operands);

    case 213:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_701 (insn, operands);

    case 214:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_702 (insn, operands);

    case 215:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_703 (insn, operands);

    case 216:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_704 (insn, operands);

    case 217:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_705 (insn, operands);

    case 218:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_706 (insn, operands);

    case 219:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_707 (insn, operands);

    case 220:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_708 (insn, operands);

    case 221:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_709 (insn, operands);

    case 222:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_710 (insn, operands);

    case 223:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_711 (insn, operands);

    case 224:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_712 (insn, operands);

    case 225:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_713 (insn, operands);

    case 226:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_714 (insn, operands);

    case 227:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_715 (insn, operands);

    case 228:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_716 (insn, operands);

    case 229:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_717 (insn, operands);

    case 230:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_718 (insn, operands);

    case 231:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_719 (insn, operands);

    case 232:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_720 (insn, operands);

    case 233:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_721 (insn, operands);

    case 234:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_722 (insn, operands);

    case 235:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_723 (insn, operands);

    case 236:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_724 (insn, operands);

    case 237:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_725 (insn, operands);

    case 238:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_726 (insn, operands);

    case 239:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_727 (insn, operands);

    case 240:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1280 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_728 (insn, operands);

    case 241:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1281 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_729 (insn, operands);

    case 242:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1282 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_730 (insn, operands);

    case 243:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1283 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_731 (insn, operands);

    case 244:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1284 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_732 (insn, operands);

    case 245:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1285 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_733 (insn, operands);

    case 246:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1286 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_734 (insn, operands);

    case 247:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1287 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_735 (insn, operands);

    case 248:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1288 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_736 (insn, operands);

    case 249:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1289 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_737 (insn, operands);

    case 250:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1290 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_738 (insn, operands);

    case 251:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1291 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_739 (insn, operands);

    case 252:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1292 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_740 (insn, operands);

    case 253:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1293 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_741 (insn, operands);

    case 254:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_742 (insn, operands);

    case 255:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_743 (insn, operands);

    case 256:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_744 (insn, operands);

    case 257:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_745 (insn, operands);

    case 258:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_746 (insn, operands);

    case 259:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_747 (insn, operands);

    case 260:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_748 (insn, operands);

    case 261:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_749 (insn, operands);

    case 262:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_750 (insn, operands);

    case 263:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_751 (insn, operands);

    case 264:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_752 (insn, operands);

    case 265:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_753 (insn, operands);

    case 266:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_754 (insn, operands);

    case 267:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_755 (insn, operands);

    case 268:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_756 (insn, operands);

    case 269:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_757 (insn, operands);

    case 270:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1313 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_758 (insn, operands);

    case 271:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_759 (insn, operands);

    case 272:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_760 (insn, operands);

    case 273:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_761 (insn, operands);

    case 274:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1317 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_762 (insn, operands);

    case 275:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_763 (insn, operands);

    case 276:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1319 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_764 (insn, operands);

    case 277:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_765 (insn, operands);

    case 278:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_766 (insn, operands);

    case 279:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_767 (insn, operands);

    case 280:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_768 (insn, operands);

    case 281:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_769 (insn, operands);

    case 282:
      if (!((
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_770 (insn, operands);

    case 283:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_771 (insn, operands);

    case 284:
      if (!((
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_772 (insn, operands);

    case 285:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_773 (insn, operands);

    case 286:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_774 (insn, operands);

    case 287:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_775 (insn, operands);

    case 288:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_776 (insn, operands);

    case 289:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_777 (insn, operands);

    case 290:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_778 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_132 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (pattern261 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return NULL;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return NULL;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return NULL;
  x8 = XVECEXP (x3, 0, 4);
  operands[7] = x8;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return NULL;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  switch (XINT (x3, 1))
    {
    case 158:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_125 (x1, insn);

    case 159:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_126 (x1, insn);

    case 160:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_127 (x1, insn);

    case 161:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_128 (x1, insn);

    case 162:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_129 (x1, insn);

    case 163:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_130 (x1, insn);

    case 91:
      x10 = XEXP (x2, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x10;
          return split_131 (x1, insn);

        case VEC_DUPLICATE:
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern597 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2451 (insn, operands);

            case E_RVVM4QImode:
              if (pattern597 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2452 (insn, operands);

            case E_RVVM2QImode:
              if (pattern597 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2453 (insn, operands);

            case E_RVVM1QImode:
              if (pattern597 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2454 (insn, operands);

            case E_RVVM8HImode:
              if (pattern597 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2455 (insn, operands);

            case E_RVVM4HImode:
              if (pattern597 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2456 (insn, operands);

            case E_RVVM2HImode:
              if (pattern597 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2457 (insn, operands);

            case E_RVVM1HImode:
              if (pattern597 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2458 (insn, operands);

            case E_RVVM8SImode:
              if (pattern597 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2459 (insn, operands);

            case E_RVVM4SImode:
              if (pattern597 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2460 (insn, operands);

            case E_RVVM2SImode:
              if (pattern597 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2461 (insn, operands);

            case E_RVVM1SImode:
              if (pattern597 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2462 (insn, operands);

            case E_RVVM8DImode:
              if (pattern597 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2463 (insn, operands);

            case E_RVVM4DImode:
              if (pattern597 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2464 (insn, operands);

            case E_RVVM2DImode:
              if (pattern597 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2465 (insn, operands);

            case E_RVVM1DImode:
              if (pattern597 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2466 (insn, operands);

            case E_RVVMF2QImode:
              if (pattern597 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2467 (insn, operands);

            case E_RVVMF4QImode:
              if (pattern597 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2468 (insn, operands);

            case E_RVVMF8QImode:
              if (pattern597 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2469 (insn, operands);

            case E_RVVMF2HImode:
              if (pattern597 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2470 (insn, operands);

            case E_RVVMF4HImode:
              if (pattern597 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2471 (insn, operands);

            case E_RVVMF2SImode:
              if (pattern597 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2472 (insn, operands);

            case E_V1QImode:
              if (pattern597 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return NULL;
              return gen_split_2473 (insn, operands);

            case E_V2QImode:
              if (pattern597 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return NULL;
              return gen_split_2474 (insn, operands);

            case E_V4QImode:
              if (pattern597 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return NULL;
              return gen_split_2475 (insn, operands);

            case E_V8QImode:
              if (pattern597 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return NULL;
              return gen_split_2476 (insn, operands);

            case E_V16QImode:
              if (pattern597 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return NULL;
              return gen_split_2477 (insn, operands);

            case E_V32QImode:
              if (pattern597 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return NULL;
              return gen_split_2478 (insn, operands);

            case E_V64QImode:
              if (pattern597 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2479 (insn, operands);

            case E_V128QImode:
              if (pattern597 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2480 (insn, operands);

            case E_V256QImode:
              if (pattern597 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2481 (insn, operands);

            case E_V512QImode:
              if (pattern597 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2482 (insn, operands);

            case E_V1024QImode:
              if (pattern597 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2483 (insn, operands);

            case E_V2048QImode:
              if (pattern597 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2484 (insn, operands);

            case E_V4096QImode:
              if (pattern597 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2485 (insn, operands);

            case E_V1HImode:
              if (pattern597 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return NULL;
              return gen_split_2486 (insn, operands);

            case E_V2HImode:
              if (pattern597 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return NULL;
              return gen_split_2487 (insn, operands);

            case E_V4HImode:
              if (pattern597 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return NULL;
              return gen_split_2488 (insn, operands);

            case E_V8HImode:
              if (pattern597 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return NULL;
              return gen_split_2489 (insn, operands);

            case E_V16HImode:
              if (pattern597 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return NULL;
              return gen_split_2490 (insn, operands);

            case E_V32HImode:
              if (pattern597 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2491 (insn, operands);

            case E_V64HImode:
              if (pattern597 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2492 (insn, operands);

            case E_V128HImode:
              if (pattern597 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2493 (insn, operands);

            case E_V256HImode:
              if (pattern597 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2494 (insn, operands);

            case E_V512HImode:
              if (pattern597 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2495 (insn, operands);

            case E_V1024HImode:
              if (pattern597 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2496 (insn, operands);

            case E_V2048HImode:
              if (pattern597 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2497 (insn, operands);

            case E_V1SImode:
              if (pattern597 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return NULL;
              return gen_split_2498 (insn, operands);

            case E_V2SImode:
              if (pattern597 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return NULL;
              return gen_split_2499 (insn, operands);

            case E_V4SImode:
              if (pattern597 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return NULL;
              return gen_split_2500 (insn, operands);

            case E_V8SImode:
              if (pattern597 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return NULL;
              return gen_split_2501 (insn, operands);

            case E_V16SImode:
              if (pattern597 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2502 (insn, operands);

            case E_V32SImode:
              if (pattern597 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2503 (insn, operands);

            case E_V64SImode:
              if (pattern597 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2504 (insn, operands);

            case E_V128SImode:
              if (pattern597 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2505 (insn, operands);

            case E_V256SImode:
              if (pattern597 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2506 (insn, operands);

            case E_V512SImode:
              if (pattern597 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2507 (insn, operands);

            case E_V1024SImode:
              if (pattern597 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2508 (insn, operands);

            case E_V1DImode:
              if (pattern597 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2509 (insn, operands);

            case E_V2DImode:
              if (pattern597 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2510 (insn, operands);

            case E_V4DImode:
              if (pattern597 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2511 (insn, operands);

            case E_V8DImode:
              if (pattern597 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2512 (insn, operands);

            case E_V16DImode:
              if (pattern597 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2513 (insn, operands);

            case E_V32DImode:
              if (pattern597 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2514 (insn, operands);

            case E_V64DImode:
              if (pattern597 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2515 (insn, operands);

            case E_V128DImode:
              if (pattern597 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2516 (insn, operands);

            case E_V256DImode:
              if (pattern597 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2517 (insn, operands);

            case E_V512DImode:
              if (pattern597 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2518 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_136 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      return split_134 (x1, insn);

    case MULT:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 0);
          operands[3] = x4;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          return split_135 (x1, insn);

        case FLOAT_EXTEND:
          switch (pattern284 (x2))
            {
            case 0:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9518 (insn, operands);

            case 1:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9519 (insn, operands);

            case 2:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9520 (insn, operands);

            case 3:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9521 (insn, operands);

            case 4:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9522 (insn, operands);

            case 5:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9523 (insn, operands);

            case 6:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9524 (insn, operands);

            case 7:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9525 (insn, operands);

            case 8:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9526 (insn, operands);

            case 9:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9527 (insn, operands);

            case 10:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9528 (insn, operands);

            case 11:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1020 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9529 (insn, operands);

            case 12:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1021 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9530 (insn, operands);

            case 13:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1022 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9531 (insn, operands);

            case 14:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9532 (insn, operands);

            case 15:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9533 (insn, operands);

            case 16:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9534 (insn, operands);

            case 17:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9535 (insn, operands);

            case 18:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9536 (insn, operands);

            case 19:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1028 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9537 (insn, operands);

            case 20:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9538 (insn, operands);

            case 21:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9539 (insn, operands);

            case 22:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9540 (insn, operands);

            case 23:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9541 (insn, operands);

            case 24:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9542 (insn, operands);

            case 25:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9543 (insn, operands);

            case 26:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9544 (insn, operands);

            case 27:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9545 (insn, operands);

            case 28:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9546 (insn, operands);

            case 29:
              if (!((
#line 1052 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1054 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9547 (insn, operands);

            case 30:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9548 (insn, operands);

            case 31:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9549 (insn, operands);

            case 32:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9550 (insn, operands);

            case 33:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9551 (insn, operands);

            case 34:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9552 (insn, operands);

            case 35:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9553 (insn, operands);

            case 36:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9554 (insn, operands);

            case 37:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9555 (insn, operands);

            case 38:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9556 (insn, operands);

            case 39:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9557 (insn, operands);

            case 40:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9558 (insn, operands);

            case 41:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1020 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9559 (insn, operands);

            case 42:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1021 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9560 (insn, operands);

            case 43:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1022 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9561 (insn, operands);

            case 44:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9562 (insn, operands);

            case 45:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9563 (insn, operands);

            case 46:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9564 (insn, operands);

            case 47:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9565 (insn, operands);

            case 48:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9566 (insn, operands);

            case 49:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1028 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9567 (insn, operands);

            case 50:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9568 (insn, operands);

            case 51:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9569 (insn, operands);

            case 52:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9570 (insn, operands);

            case 53:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9571 (insn, operands);

            case 54:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9572 (insn, operands);

            case 55:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9573 (insn, operands);

            case 56:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9574 (insn, operands);

            case 57:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9575 (insn, operands);

            case 58:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9576 (insn, operands);

            case 59:
              if (!((
#line 1076 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1078 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9577 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern234 (x2))
        {
        case 0:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8420 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8422 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8424 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8426 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8428 (insn, operands);

        case 5:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8430 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8432 (insn, operands);

        case 7:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8434 (insn, operands);

        case 8:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8436 (insn, operands);

        case 9:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8438 (insn, operands);

        case 10:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8440 (insn, operands);

        case 11:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8442 (insn, operands);

        case 12:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8444 (insn, operands);

        case 13:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8446 (insn, operands);

        case 14:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8448 (insn, operands);

        case 15:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8450 (insn, operands);

        case 16:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8452 (insn, operands);

        case 17:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8454 (insn, operands);

        case 18:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8456 (insn, operands);

        case 19:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8458 (insn, operands);

        case 20:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8460 (insn, operands);

        case 21:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8462 (insn, operands);

        case 22:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8464 (insn, operands);

        case 23:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8466 (insn, operands);

        case 24:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8468 (insn, operands);

        case 25:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8470 (insn, operands);

        case 26:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8472 (insn, operands);

        case 27:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8474 (insn, operands);

        case 28:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8476 (insn, operands);

        case 29:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8478 (insn, operands);

        case 30:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8480 (insn, operands);

        case 31:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8482 (insn, operands);

        case 32:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8484 (insn, operands);

        case 33:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8486 (insn, operands);

        case 34:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8488 (insn, operands);

        case 35:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8490 (insn, operands);

        case 36:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8492 (insn, operands);

        case 37:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8494 (insn, operands);

        case 38:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8496 (insn, operands);

        case 39:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8498 (insn, operands);

        case 40:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8500 (insn, operands);

        case 41:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8502 (insn, operands);

        case 42:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8504 (insn, operands);

        case 43:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8506 (insn, operands);

        case 44:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8508 (insn, operands);

        case 45:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8510 (insn, operands);

        case 46:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8512 (insn, operands);

        case 47:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8514 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern234 (x2))
        {
        case 0:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8421 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8423 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8425 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8427 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8429 (insn, operands);

        case 5:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8431 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8433 (insn, operands);

        case 7:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8435 (insn, operands);

        case 8:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8437 (insn, operands);

        case 9:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8439 (insn, operands);

        case 10:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8441 (insn, operands);

        case 11:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8443 (insn, operands);

        case 12:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8445 (insn, operands);

        case 13:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8447 (insn, operands);

        case 14:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8449 (insn, operands);

        case 15:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8451 (insn, operands);

        case 16:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8453 (insn, operands);

        case 17:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8455 (insn, operands);

        case 18:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8457 (insn, operands);

        case 19:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8459 (insn, operands);

        case 20:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8461 (insn, operands);

        case 21:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8463 (insn, operands);

        case 22:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8465 (insn, operands);

        case 23:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8467 (insn, operands);

        case 24:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8469 (insn, operands);

        case 25:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8471 (insn, operands);

        case 26:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8473 (insn, operands);

        case 27:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8475 (insn, operands);

        case 28:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8477 (insn, operands);

        case 29:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8479 (insn, operands);

        case 30:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8481 (insn, operands);

        case 31:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8483 (insn, operands);

        case 32:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8485 (insn, operands);

        case 33:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8487 (insn, operands);

        case 34:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8489 (insn, operands);

        case 35:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8491 (insn, operands);

        case 36:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8493 (insn, operands);

        case 37:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8495 (insn, operands);

        case 38:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8497 (insn, operands);

        case 39:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8499 (insn, operands);

        case 40:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8501 (insn, operands);

        case 41:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8503 (insn, operands);

        case 42:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8505 (insn, operands);

        case 43:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8507 (insn, operands);

        case 44:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8509 (insn, operands);

        case 45:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8511 (insn, operands);

        case 46:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8513 (insn, operands);

        case 47:
          if (!((
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8515 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      switch (pattern235 (x2))
        {
        case 0:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8924 (insn, operands);

        case 1:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8925 (insn, operands);

        case 2:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8926 (insn, operands);

        case 3:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8927 (insn, operands);

        case 4:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8928 (insn, operands);

        case 5:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8929 (insn, operands);

        case 6:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8930 (insn, operands);

        case 7:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8931 (insn, operands);

        case 8:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8932 (insn, operands);

        case 9:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8933 (insn, operands);

        case 10:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8934 (insn, operands);

        case 11:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1020 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8935 (insn, operands);

        case 12:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1021 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8936 (insn, operands);

        case 13:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1022 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8937 (insn, operands);

        case 14:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8938 (insn, operands);

        case 15:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8939 (insn, operands);

        case 16:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8940 (insn, operands);

        case 17:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8941 (insn, operands);

        case 18:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8942 (insn, operands);

        case 19:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1028 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8943 (insn, operands);

        case 20:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8944 (insn, operands);

        case 21:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8945 (insn, operands);

        case 22:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8946 (insn, operands);

        case 23:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8947 (insn, operands);

        case 24:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8948 (insn, operands);

        case 25:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8949 (insn, operands);

        case 26:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8950 (insn, operands);

        case 27:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8951 (insn, operands);

        case 28:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8952 (insn, operands);

        case 29:
          if (!((
#line 763 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 765 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8953 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_150 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4537 (insn, operands);

    case 1:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4693 (insn, operands);

    case 2:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4539 (insn, operands);

    case 3:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4695 (insn, operands);

    case 4:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4885 (insn, operands);

    case 5:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4541 (insn, operands);

    case 6:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4697 (insn, operands);

    case 7:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4887 (insn, operands);

    case 8:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4543 (insn, operands);

    case 9:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4699 (insn, operands);

    case 10:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4889 (insn, operands);

    case 11:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4545 (insn, operands);

    case 12:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4701 (insn, operands);

    case 13:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4891 (insn, operands);

    case 14:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4547 (insn, operands);

    case 15:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4703 (insn, operands);

    case 16:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4893 (insn, operands);

    case 17:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4549 (insn, operands);

    case 18:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4705 (insn, operands);

    case 19:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4551 (insn, operands);

    case 20:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4707 (insn, operands);

    case 21:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4895 (insn, operands);

    case 22:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4553 (insn, operands);

    case 23:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4709 (insn, operands);

    case 24:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4897 (insn, operands);

    case 25:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4555 (insn, operands);

    case 26:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4711 (insn, operands);

    case 27:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4899 (insn, operands);

    case 28:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4557 (insn, operands);

    case 29:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4713 (insn, operands);

    case 30:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4901 (insn, operands);

    case 31:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4559 (insn, operands);

    case 32:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4715 (insn, operands);

    case 33:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4561 (insn, operands);

    case 34:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4717 (insn, operands);

    case 35:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4563 (insn, operands);

    case 36:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4719 (insn, operands);

    case 37:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4565 (insn, operands);

    case 38:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4721 (insn, operands);

    case 39:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4567 (insn, operands);

    case 40:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4723 (insn, operands);

    case 41:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4903 (insn, operands);

    case 42:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4569 (insn, operands);

    case 43:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4725 (insn, operands);

    case 44:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4905 (insn, operands);

    case 45:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4571 (insn, operands);

    case 46:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4727 (insn, operands);

    case 47:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4907 (insn, operands);

    case 48:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4573 (insn, operands);

    case 49:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4729 (insn, operands);

    case 50:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4909 (insn, operands);

    case 51:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4575 (insn, operands);

    case 52:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4731 (insn, operands);

    case 53:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4911 (insn, operands);

    case 54:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4577 (insn, operands);

    case 55:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4733 (insn, operands);

    case 56:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4913 (insn, operands);

    case 57:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4579 (insn, operands);

    case 58:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4735 (insn, operands);

    case 59:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4915 (insn, operands);

    case 60:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4581 (insn, operands);

    case 61:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4737 (insn, operands);

    case 62:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4917 (insn, operands);

    case 63:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4583 (insn, operands);

    case 64:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4739 (insn, operands);

    case 65:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4919 (insn, operands);

    case 66:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4585 (insn, operands);

    case 67:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4741 (insn, operands);

    case 68:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4921 (insn, operands);

    case 69:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4587 (insn, operands);

    case 70:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4743 (insn, operands);

    case 71:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4923 (insn, operands);

    case 72:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4589 (insn, operands);

    case 73:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4745 (insn, operands);

    case 74:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4591 (insn, operands);

    case 75:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4747 (insn, operands);

    case 76:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4925 (insn, operands);

    case 77:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4593 (insn, operands);

    case 78:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4749 (insn, operands);

    case 79:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4927 (insn, operands);

    case 80:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4595 (insn, operands);

    case 81:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4751 (insn, operands);

    case 82:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4929 (insn, operands);

    case 83:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4597 (insn, operands);

    case 84:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4753 (insn, operands);

    case 85:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4931 (insn, operands);

    case 86:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4599 (insn, operands);

    case 87:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4755 (insn, operands);

    case 88:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4933 (insn, operands);

    case 89:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4601 (insn, operands);

    case 90:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4757 (insn, operands);

    case 91:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4935 (insn, operands);

    case 92:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4603 (insn, operands);

    case 93:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4759 (insn, operands);

    case 94:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4937 (insn, operands);

    case 95:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4605 (insn, operands);

    case 96:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4761 (insn, operands);

    case 97:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4939 (insn, operands);

    case 98:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4607 (insn, operands);

    case 99:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4763 (insn, operands);

    case 100:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4941 (insn, operands);

    case 101:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4609 (insn, operands);

    case 102:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4765 (insn, operands);

    case 103:
      if (!((
#line 1029 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4943 (insn, operands);

    case 104:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4611 (insn, operands);

    case 105:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4767 (insn, operands);

    case 106:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4613 (insn, operands);

    case 107:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4769 (insn, operands);

    case 108:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4615 (insn, operands);

    case 109:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4771 (insn, operands);

    case 110:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4617 (insn, operands);

    case 111:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4773 (insn, operands);

    case 112:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4619 (insn, operands);

    case 113:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4775 (insn, operands);

    case 114:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4621 (insn, operands);

    case 115:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4777 (insn, operands);

    case 116:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4623 (insn, operands);

    case 117:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4779 (insn, operands);

    case 118:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4625 (insn, operands);

    case 119:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4781 (insn, operands);

    case 120:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4627 (insn, operands);

    case 121:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4783 (insn, operands);

    case 122:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4629 (insn, operands);

    case 123:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4785 (insn, operands);

    case 124:
      if (!((
#line 937 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4631 (insn, operands);

    case 125:
      if (!((
#line 985 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4787 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_156 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2597 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2611 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2625 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2639 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2653 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2667 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2681 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2695 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2709 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2723 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2737 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2751 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2765 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2779 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2793 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2807 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2821 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2835 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2849 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2863 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2877 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2891 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2905 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2919 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2933 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2947 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2961 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2975 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2989 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3003 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3017 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3031 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3045 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3059 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3073 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3087 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3101 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3115 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3129 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3143 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3157 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3171 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3185 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3199 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3213 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3227 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3241 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3255 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3269 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3283 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3297 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3311 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3325 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3339 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3353 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3367 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3381 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3395 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3409 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3423 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3437 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3451 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3465 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3479 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3493 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3507 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3521 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3535 (insn, operands);

    case 68:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5556 (insn, operands);

    case 69:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5560 (insn, operands);

    case 70:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5564 (insn, operands);

    case 71:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5568 (insn, operands);

    case 72:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5572 (insn, operands);

    case 73:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5576 (insn, operands);

    case 74:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5580 (insn, operands);

    case 75:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5584 (insn, operands);

    case 76:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5588 (insn, operands);

    case 77:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5592 (insn, operands);

    case 78:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5596 (insn, operands);

    case 79:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5600 (insn, operands);

    case 80:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5604 (insn, operands);

    case 81:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5608 (insn, operands);

    case 82:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5612 (insn, operands);

    case 83:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5616 (insn, operands);

    case 84:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5620 (insn, operands);

    case 85:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5624 (insn, operands);

    case 86:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5628 (insn, operands);

    case 87:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5632 (insn, operands);

    case 88:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5636 (insn, operands);

    case 89:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5640 (insn, operands);

    case 90:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5644 (insn, operands);

    case 91:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5648 (insn, operands);

    case 92:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5652 (insn, operands);

    case 93:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5656 (insn, operands);

    case 94:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5660 (insn, operands);

    case 95:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5664 (insn, operands);

    case 96:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5668 (insn, operands);

    case 97:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5672 (insn, operands);

    case 98:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5676 (insn, operands);

    case 99:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5680 (insn, operands);

    case 100:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5684 (insn, operands);

    case 101:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5688 (insn, operands);

    case 102:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5692 (insn, operands);

    case 103:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5696 (insn, operands);

    case 104:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5700 (insn, operands);

    case 105:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5704 (insn, operands);

    case 106:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5708 (insn, operands);

    case 107:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5712 (insn, operands);

    case 108:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5716 (insn, operands);

    case 109:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5720 (insn, operands);

    case 110:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5724 (insn, operands);

    case 111:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5728 (insn, operands);

    case 112:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5732 (insn, operands);

    case 113:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5736 (insn, operands);

    case 114:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5740 (insn, operands);

    case 115:
      if (!((
#line 1540 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5744 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_170 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 91)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 5
      || XINT (x4, 1) != 155)
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern324 (x3) != 0)
    return NULL;
  switch (pattern452 (x2))
    {
    case 0:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10065 (insn, operands);

    case 1:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10067 (insn, operands);

    case 2:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10069 (insn, operands);

    case 3:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10071 (insn, operands);

    case 4:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10073 (insn, operands);

    case 5:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10075 (insn, operands);

    case 6:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10077 (insn, operands);

    case 7:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10079 (insn, operands);

    case 8:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10081 (insn, operands);

    case 9:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10083 (insn, operands);

    case 10:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10085 (insn, operands);

    case 11:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10087 (insn, operands);

    case 12:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10089 (insn, operands);

    case 13:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10091 (insn, operands);

    case 14:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10093 (insn, operands);

    case 15:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10095 (insn, operands);

    case 16:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10097 (insn, operands);

    case 17:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10099 (insn, operands);

    case 18:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10101 (insn, operands);

    case 19:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10103 (insn, operands);

    case 20:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10066 (insn, operands);

    case 21:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10068 (insn, operands);

    case 22:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10070 (insn, operands);

    case 23:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10072 (insn, operands);

    case 24:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10074 (insn, operands);

    case 25:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10076 (insn, operands);

    case 26:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10078 (insn, operands);

    case 27:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10080 (insn, operands);

    case 28:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10082 (insn, operands);

    case 29:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10084 (insn, operands);

    case 30:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10086 (insn, operands);

    case 31:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10088 (insn, operands);

    case 32:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10090 (insn, operands);

    case 33:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10092 (insn, operands);

    case 34:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10094 (insn, operands);

    case 35:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10096 (insn, operands);

    case 36:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10098 (insn, operands);

    case 37:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10100 (insn, operands);

    case 38:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10102 (insn, operands);

    case 39:
      if (!((
#line 1457 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))) && 
#line 1461 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10104 (insn, operands);

    default:
      return NULL;
    }
}
