/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !csr_operand (operands[2], i3))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return pattern153 (x1); /* [-1, 47] */

    case ZERO_EXTEND:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern154 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_HImode) != 0)
            return -1;
          return 96;

        case E_RVVM2QImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_HImode) != 0)
            return -1;
          return 97;

        case E_RVVM1QImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_HImode) != 0)
            return -1;
          return 98;

        case E_RVVMF2QImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF4QImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF8QImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_HImode) != 0)
            return -1;
          return 101;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_SImode) != 0)
            return -1;
          return 102;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_SImode) != 0)
            return -1;
          return 103;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_SImode) != 0)
            return -1;
          return 104;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_SImode) != 0)
            return -1;
          return 106;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_DImode) != 0)
            return -1;
          return 107;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_DImode) != 0)
            return -1;
          return 108;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_DImode) != 0)
            return -1;
          return 109;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_DImode) != 0)
            return -1;
          return 110;

        case E_V1QImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1QImode, 
E_HImode) != 0)
            return -1;
          return 111;

        case E_V2QImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2QImode, 
E_HImode) != 0)
            return -1;
          return 112;

        case E_V4QImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4QImode, 
E_HImode) != 0)
            return -1;
          return 113;

        case E_V8QImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8QImode, 
E_HImode) != 0)
            return -1;
          return 114;

        case E_V16QImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 115;

        case E_V32QImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32QImode, 
E_HImode) != 0)
            return -1;
          return 116;

        case E_V64QImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64QImode, 
E_HImode) != 0)
            return -1;
          return 117;

        case E_V128QImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128QImode, 
E_HImode) != 0)
            return -1;
          return 118;

        case E_V256QImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256QImode, 
E_HImode) != 0)
            return -1;
          return 119;

        case E_V512QImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512QImode, 
E_HImode) != 0)
            return -1;
          return 120;

        case E_V1024QImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_HImode) != 0)
            return -1;
          return 121;

        case E_V2048QImode:
          if (pattern154 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_HImode) != 0)
            return -1;
          return 122;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1HImode, 
E_SImode) != 0)
            return -1;
          return 123;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2HImode, 
E_SImode) != 0)
            return -1;
          return 124;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4HImode, 
E_SImode) != 0)
            return -1;
          return 125;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8HImode, 
E_SImode) != 0)
            return -1;
          return 126;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16HImode, 
E_SImode) != 0)
            return -1;
          return 127;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 128;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64HImode, 
E_SImode) != 0)
            return -1;
          return 129;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128HImode, 
E_SImode) != 0)
            return -1;
          return 130;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256HImode, 
E_SImode) != 0)
            return -1;
          return 131;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512HImode, 
E_SImode) != 0)
            return -1;
          return 132;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_SImode) != 0)
            return -1;
          return 133;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1DImode, 
E_V1SImode, 
E_DImode) != 0)
            return -1;
          return 134;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2DImode, 
E_V2SImode, 
E_DImode) != 0)
            return -1;
          return 135;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4DImode, 
E_V4SImode, 
E_DImode) != 0)
            return -1;
          return 136;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8DImode, 
E_V8SImode, 
E_DImode) != 0)
            return -1;
          return 137;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16DImode, 
E_V16SImode, 
E_DImode) != 0)
            return -1;
          return 138;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32DImode, 
E_V32SImode, 
E_DImode) != 0)
            return -1;
          return 139;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64DImode, 
E_V64SImode, 
E_DImode) != 0)
            return -1;
          return 140;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128DImode, 
E_V128SImode, 
E_DImode) != 0)
            return -1;
          return 141;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256DImode, 
E_V256SImode, 
E_DImode) != 0)
            return -1;
          return 142;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512DImode, 
E_V512SImode, 
E_DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern184 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      return 2;

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM8SFmode:
      if (!register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 5;

    case E_RVVM2x2QImode:
      if (!register_operand (operands[3], E_RVVM2x2QImode))
        return -1;
      return 6;

    case E_RVVM2x3QImode:
      if (!register_operand (operands[3], E_RVVM2x3QImode))
        return -1;
      return 7;

    case E_RVVM2x4QImode:
      if (!register_operand (operands[3], E_RVVM2x4QImode))
        return -1;
      return 8;

    case E_RVVM4x2HImode:
      if (!register_operand (operands[3], E_RVVM4x2HImode))
        return -1;
      return 9;

    case E_RVVM4x2BFmode:
      if (!register_operand (operands[3], E_RVVM4x2BFmode))
        return -1;
      return 10;

    case E_RVVM4x2HFmode:
      if (!register_operand (operands[3], E_RVVM4x2HFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern191 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern191 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern191 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern191 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern191 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern191 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern191 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern191 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern191 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern191 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern191 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern191 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern191 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern191 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern191 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern191 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern191 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern191 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern191 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern191 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern191 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern191 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern191 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern191 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern191 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern191 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern191 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern191 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern191 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern191 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern191 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern191 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern191 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern191 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern191 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern191 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern191 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern191 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern191 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern191 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern191 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern191 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern191 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern191 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern191 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern191 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern191 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern191 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern201 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern201 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern201 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern201 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern201 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern201 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern201 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern201 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern201 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern201 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern201 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern201 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern201 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern201 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern201 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern201 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern201 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern201 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern201 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern201 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern201 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern201 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern201 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern201 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern201 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern201 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern201 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern201 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern201 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern201 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern201 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern201 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern201 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern201 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern201 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern201 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern201 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern201 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern201 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern201 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern201 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern201 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern201 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern201 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern201 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern201 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern201 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern201 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern201 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern201 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern201 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern201 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern201 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern201 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern201 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern201 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern201 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern201 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern201 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern201 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern201 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern201 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern201 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern201 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern201 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern201 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern201 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern201 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern201 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern201 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern201 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern201 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern201 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern201 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern201 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern201 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern201 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern201 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern201 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern201 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern201 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern201 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern201 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern201 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern201 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern201 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern201 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern201 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern201 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern201 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern201 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern201 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern201 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern201 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern201 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern201 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern201 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern201 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern201 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern201 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern201 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern201 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern201 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern201 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern201 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern201 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern201 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern201 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern201 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern201 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern201 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern201 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern201 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern201 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern201 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern201 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern201 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern201 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern201 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern201 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern201 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern201 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern202 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern202 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern202 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern202 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern202 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern202 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern202 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern202 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern202 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern202 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern202 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern202 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern202 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern202 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern202 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern202 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern202 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern202 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern202 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern202 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern202 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern202 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern202 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern202 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern202 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern202 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern202 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern202 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern202 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern202 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern202 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern202 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern202 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern202 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern202 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern202 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern202 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern202 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern202 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern202 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern202 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern202 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern202 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern202 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern202 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern202 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern202 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern202 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern203 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern203 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern203 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern203 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern203 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern203 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern203 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern203 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern203 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern203 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern203 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern203 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern203 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern203 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern203 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern203 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern203 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern203 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern203 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern203 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern203 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern203 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern203 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern203 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern203 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern203 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern203 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern203 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern203 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern203 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern203 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern203 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern203 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern203 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern203 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern203 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern203 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern203 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern203 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern203 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern203 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern203 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern203 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern203 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern203 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern203 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern203 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern203 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern205 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern204 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern204 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern204 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern204 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern204 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern204 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern204 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern204 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern204 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern204 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern204 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern204 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern204 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern204 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern204 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern204 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern204 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern204 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern204 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern204 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern204 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern204 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern204 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern204 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern204 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern204 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern204 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern204 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern204 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern204 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern204 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern204 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern204 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern204 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern204 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern204 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern204 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern204 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern204 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern204 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern209 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern204 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern204 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern204 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern204 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern204 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern204 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern204 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern204 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern204 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern204 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern204 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern204 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern204 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern204 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern204 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern204 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern204 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern204 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern204 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern204 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern204 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern204 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern204 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern204 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern204 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern204 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern204 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern204 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern204 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern204 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern204 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern204 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern204 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern204 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern204 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern204 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern204 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern204 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern204 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern204 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern204 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern204 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern204 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern204 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern204 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern204 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern211 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern213 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[1], E_RVVM8QImode))
        return -1;
      return 0;

    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 6;

    case E_V1QImode:
      if (!register_operand (operands[1], E_V1QImode))
        return -1;
      return 7;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 8;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 9;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 10;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 13;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 14;

    case E_V256QImode:
      if (!register_operand (operands[1], E_V256QImode))
        return -1;
      return 15;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 16;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 17;

    case E_V2048QImode:
      if (!register_operand (operands[1], E_V2048QImode))
        return -1;
      return 18;

    case E_V4096QImode:
      if (!register_operand (operands[1], E_V4096QImode))
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern455 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern453 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern453 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern460 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern472 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern471 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern471 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern471 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern471 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern471 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern471 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern471 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern471 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern471 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern471 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern471 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern471 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern471 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern471 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern471 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern471 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern471 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern471 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern471 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern484 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern484 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern484 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern484 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern484 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern484 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern484 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern484 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern484 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern484 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern484 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern484 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern484 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern484 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern484 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern484 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern484 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern484 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern484 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern484 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern484 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern484 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern484 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern484 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern484 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern484 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern484 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern484 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern484 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern484 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern484 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern484 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern484 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern484 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern484 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern484 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern484 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern484 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern484 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern484 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern484 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern484 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern484 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern484 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern484 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern484 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern484 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern484 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern484 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern484 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern484 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern484 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern484 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern484 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern484 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern484 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern484 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern484 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern484 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern484 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern484 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern484 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern484 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern484 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern484 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern484 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern484 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern484 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern500 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern501 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern500 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern500 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern500 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern500 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern500 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern500 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern500 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern500 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern500 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern500 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern500 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern500 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern500 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern500 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern500 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern500 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern500 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern500 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern566 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern574 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern492 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern492 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern492 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern492 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern492 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern492 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern492 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern492 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern492 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern492 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern492 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern492 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern492 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern492 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern492 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern582 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_neg_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern595 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[4], E_RVVM2HFmode)
          || !register_operand (operands[5], E_RVVM2HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[4], E_RVVM4SFmode)
          || !register_operand (operands[5], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVM8DFmode:
      if (!register_operand (operands[4], E_RVVM8DFmode)
          || !register_operand (operands[5], E_RVVM8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern608 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[4], E_RVVMF2HFmode)
          || !register_operand (operands[5], E_RVVMF2HFmode))
        return -1;
      return 0;

    case E_RVVM1SFmode:
      if (!register_operand (operands[4], E_RVVM1SFmode)
          || !register_operand (operands[5], E_RVVM1SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[4], E_RVVM2DFmode)
          || !register_operand (operands[5], E_RVVM2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[4], E_V2HFmode)
          || !register_operand (operands[5], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[4], E_V2SFmode)
          || !register_operand (operands[5], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[4], E_V2DFmode)
          || !register_operand (operands[5], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || !register_operand (operands[5], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || !register_operand (operands[5], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || !register_operand (operands[5], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || !register_operand (operands[5], E_V128HFmode))
        return -1;
      return 0;

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || !register_operand (operands[5], E_V128SFmode))
        return -1;
      return 1;

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || !register_operand (operands[5], E_V128DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern621 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i3))
    return -1;
  x10 = XEXP (x1, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  return 0;
}

int
pattern625 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode)
          || !vector_arith_operand (operands[2], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode)
          || !vector_arith_operand (operands[2], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !vector_arith_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !vector_arith_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !vector_arith_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !vector_arith_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode)
          || !register_operand (operands[2], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode)
          || !register_operand (operands[2], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[2], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern638 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew16_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 0;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern653 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern671 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern677 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern686 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i4
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern694 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], E_DImode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern698 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern698 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern698 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern698 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern698 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern698 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVM8SImode
          || GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM8SImode
          || GET_MODE (x4) != E_RVVM8SImode
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode)
              || !register_operand (operands[4], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 7;

            case E_RVVM8QImode:
              if (!register_operand (operands[4], E_RVVM8QImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVM4SImode
          || GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM4SImode
          || GET_MODE (x4) != E_RVVM4SImode
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode)
              || !register_operand (operands[4], E_RVVM2HImode))
            return -1;
          return 9;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 10;

            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVM2SImode
          || GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM2SImode
          || GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode)
              || !register_operand (operands[4], E_RVVM1HImode))
            return -1;
          return 12;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 13;

            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVM1SImode
          || GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM1SImode
          || GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode)
              || !register_operand (operands[4], E_RVVMF2HImode))
            return -1;
          return 15;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVMF2QImode:
              if (!register_operand (operands[4], E_RVVMF2QImode))
                return -1;
              return 16;

            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern698 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVM8DImode:
      if (pattern698 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 19;

    case E_RVVM4DImode:
      if (pattern698 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 20;

    case E_RVVM2DImode:
      if (pattern698 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1DImode:
      if (pattern698 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_V1HImode:
      if (pattern698 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 23;

    case E_V2HImode:
      if (pattern698 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 24;

    case E_V4HImode:
      if (pattern698 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 25;

    case E_V8HImode:
      if (pattern698 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 26;

    case E_V16HImode:
      if (pattern698 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 27;

    case E_V32HImode:
      if (pattern698 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 28;

    case E_V64HImode:
      if (pattern698 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 29;

    case E_V128HImode:
      if (pattern698 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 30;

    case E_V256HImode:
      if (pattern698 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 31;

    case E_V512HImode:
      if (pattern698 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 32;

    case E_V1024HImode:
      if (pattern698 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 33;

    case E_V2048HImode:
      if (pattern698 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 34;

    case E_V1SImode:
      if (pattern698 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2SImode:
      if (pattern698 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4SImode:
      if (pattern698 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8SImode:
      if (pattern698 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16SImode:
      if (pattern698 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32SImode:
      if (pattern698 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64SImode:
      if (pattern698 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128SImode:
      if (pattern698 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256SImode:
      if (pattern698 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512SImode:
      if (pattern698 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024SImode:
      if (pattern698 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V1DImode:
      if (pattern698 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 46;

    case E_V2DImode:
      if (pattern698 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 47;

    case E_V4DImode:
      if (pattern698 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 48;

    case E_V8DImode:
      if (pattern698 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 49;

    case E_V16DImode:
      if (pattern698 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 50;

    case E_V32DImode:
      if (pattern698 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 51;

    case E_V64DImode:
      if (pattern698 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 52;

    case E_V128DImode:
      if (pattern698 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 53;

    case E_V256DImode:
      if (pattern698 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 54;

    case E_V512DImode:
      if (pattern698 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 55;

    default:
      return -1;
    }
}

int
pattern737 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern740 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  return 0;
}

int
pattern745 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x27, 1);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  return 0;
}

int
pattern752 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -24L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -28L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -48L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -56L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern760 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23)
        return -1;
      return 0;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21)
        return -1;
      return 1;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9
          || REGNO (x32) != 8
          || REGNO (x37) != 1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x42) != 10)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 10
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x46) != RETURN)
        return -1;
      x47 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x47) != USE)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 1
          || GET_MODE (x48) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern773 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x52, 1);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  return 0;
}

int
pattern786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern790 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -44])
    return -1;
  return 0;
}

int
pattern794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  x63 = XEXP (x61, 1);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XVECEXP (x1, 0, 13);
  x67 = XEXP (x66, 0);
  if (GET_MODE (x67) != i1)
    return -1;
  x68 = XEXP (x66, 1);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x68, 0);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  x71 = XVECEXP (x1, 0, 14);
  x72 = XEXP (x71, 0);
  if (GET_MODE (x72) != i1)
    return -1;
  x73 = XVECEXP (x1, 0, 15);
  x74 = XEXP (x73, 0);
  if (GET_MODE (x74) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 856 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 9; /* *addsi3_extended2 */

    case MINUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1037 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 18; /* *subsi3_extended2 */

    case NEG:
      operands[2] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1089 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 22; /* *negsi2_extended2 */

    case MULT:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1254 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 29; /* *mulsi3_extended2 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 1954 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_XTHEADMEMIDX))
            return -1;
          return 127; /* *extendsidi2_internal */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 130; /* *extendqidi2 */
          if (!(
#line 321 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 528; /* *extendqidi2_bitmanip */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 133; /* *extendhidi2 */
          if (!(
#line 321 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 531; /* *extendhidi2_bitmanip */

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern280 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 128; /* *extendqihi2 */
          if (!
#line 321 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 526; /* *extendqihi2_bitmanip */

        case 1:
          if (
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 131; /* *extendhihi2 */
          if (!
#line 321 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 529; /* *extendhihi2_bitmanip */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern280 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 129; /* *extendqisi2 */
          if (!
#line 321 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 527; /* *extendqisi2_bitmanip */

        case 1:
          if (
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 132; /* *extendhisi2 */
          if (!
#line 321 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 530; /* *extendhisi2_bitmanip */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern281 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 65 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 858; /* *extendhihi2_th_ext */
          if (!
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return -1;
          return 914; /* *th_memidx_extendhihi2 */

        case 1:
          if (
#line 76 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 861; /* *extendqihi2_th_ext */
          if (
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 911; /* *th_memidx_extendqihi2 */
          if (!
#line 628 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 922; /* *th_memidx_bb_extendqihi2 */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern281 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 65 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 859; /* *extendhisi2_th_ext */
          if (
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 915; /* *th_memidx_extendhisi2 */
          if (!
#line 612 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 920; /* *th_memidx_bb_extendhisi2 */

        case 1:
          if (
#line 76 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 862; /* *extendqisi2_th_ext */
          if (
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 912; /* *th_memidx_extendqisi2 */
          if (!
#line 628 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 923; /* *th_memidx_bb_extendqisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 65 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 860; /* *extendhidi2_th_ext */
          if ((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 916; /* *th_memidx_extendhidi2 */
          if (!(
#line 612 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 921; /* *th_memidx_bb_extendhidi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 76 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 863; /* *extendqidi2_th_ext */
          if ((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 913; /* *th_memidx_extendqidi2 */
          if (!(
#line 628 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 924; /* *th_memidx_bb_extendqidi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 482 "../../../gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX))
            return -1;
          return 907; /* *th_memidx_extendsidi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 91)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || pattern327 (x3) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27334; /* *pred_extract_first_sextdirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27335; /* *pred_extract_first_sextdirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27336; /* *pred_extract_first_sextdirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27337; /* *pred_extract_first_sextdirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27338; /* *pred_extract_first_sextdirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27339; /* *pred_extract_first_sextdirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 551 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27340; /* *pred_extract_first_sextdirvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 557 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 27352; /* *pred_extract_first_sextdiv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 558 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 27353; /* *pred_extract_first_sextdiv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 559 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 27354; /* *pred_extract_first_sextdiv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 560 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 27355; /* *pred_extract_first_sextdiv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 561 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 27356; /* *pred_extract_first_sextdiv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 562 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 27357; /* *pred_extract_first_sextdiv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 563 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 27358; /* *pred_extract_first_sextdiv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 564 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 27359; /* *pred_extract_first_sextdiv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 27360; /* *pred_extract_first_sextdiv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 566 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 27361; /* *pred_extract_first_sextdiv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 27362; /* *pred_extract_first_sextdiv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 568 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 27363; /* *pred_extract_first_sextdiv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 27364; /* *pred_extract_first_sextdiv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27341; /* *pred_extract_first_sextdirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27342; /* *pred_extract_first_sextdirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27343; /* *pred_extract_first_sextdirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27344; /* *pred_extract_first_sextdirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27345; /* *pred_extract_first_sextdirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 553 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27346; /* *pred_extract_first_sextdirvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 570 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 27365; /* *pred_extract_first_sextdiv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 27366; /* *pred_extract_first_sextdiv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 27367; /* *pred_extract_first_sextdiv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 27368; /* *pred_extract_first_sextdiv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 27369; /* *pred_extract_first_sextdiv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 27370; /* *pred_extract_first_sextdiv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 27371; /* *pred_extract_first_sextdiv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 27372; /* *pred_extract_first_sextdiv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 27373; /* *pred_extract_first_sextdiv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 27374; /* *pred_extract_first_sextdiv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 27375; /* *pred_extract_first_sextdiv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 27376; /* *pred_extract_first_sextdiv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8SImode:
              if (!register_operand (operands[1], E_RVVM8SImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27347; /* *pred_extract_first_sextdirvvm8si */

            case E_RVVM4SImode:
              if (!register_operand (operands[1], E_RVVM4SImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27348; /* *pred_extract_first_sextdirvvm4si */

            case E_RVVM2SImode:
              if (!register_operand (operands[1], E_RVVM2SImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27349; /* *pred_extract_first_sextdirvvm2si */

            case E_RVVM1SImode:
              if (!register_operand (operands[1], E_RVVM1SImode)
                  || !
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 27350; /* *pred_extract_first_sextdirvvm1si */

            case E_RVVMF2SImode:
              if (!register_operand (operands[1], E_RVVMF2SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 555 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27351; /* *pred_extract_first_sextdirvvmf2si */

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 27377; /* *pred_extract_first_sextdiv1si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 27378; /* *pred_extract_first_sextdiv2si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 27379; /* *pred_extract_first_sextdiv4si */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 27380; /* *pred_extract_first_sextdiv8si */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 27381; /* *pred_extract_first_sextdiv16si */

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 27382; /* *pred_extract_first_sextdiv32si */

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 27383; /* *pred_extract_first_sextdiv64si */

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 27384; /* *pred_extract_first_sextdiv128si */

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 27385; /* *pred_extract_first_sextdiv256si */

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 27386; /* *pred_extract_first_sextdiv512si */

            case E_V1024SImode:
              if (!register_operand (operands[1], E_V1024SImode)
                  || !(
#line 72 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 27387; /* *pred_extract_first_sextdiv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27388; /* *pred_extract_first_sextsirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27389; /* *pred_extract_first_sextsirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27390; /* *pred_extract_first_sextsirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27391; /* *pred_extract_first_sextsirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27392; /* *pred_extract_first_sextsirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27393; /* *pred_extract_first_sextsirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 545 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27394; /* *pred_extract_first_sextsirvvmf8qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27395; /* *pred_extract_first_sextsirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27396; /* *pred_extract_first_sextsirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27397; /* *pred_extract_first_sextsirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27398; /* *pred_extract_first_sextsirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 27399; /* *pred_extract_first_sextsirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 85 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 547 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 27400; /* *pred_extract_first_sextsirvvmf4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 1045 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 19; /* negdi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 20; /* *negsi2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 1615 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 84; /* negsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 1615 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 85; /* negdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 1615 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 86; /* neghf2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25972; /* negrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25974; /* negrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25976; /* negrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25978; /* negrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25980; /* negrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25982; /* negrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25984; /* negrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25986; /* negrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25988; /* negrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25990; /* negrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25992; /* negrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25994; /* negrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25996; /* negrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25998; /* negrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26000; /* negrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26002; /* negrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26004; /* negrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26006; /* negrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26008; /* negrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26010; /* negrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26012; /* negrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26014; /* negrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26016; /* negv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26018; /* negv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26020; /* negv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26022; /* negv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26024; /* negv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26026; /* negv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26028; /* negv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26030; /* negv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26032; /* negv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26034; /* negv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26036; /* negv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26038; /* negv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26040; /* negv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26042; /* negv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26044; /* negv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26046; /* negv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26048; /* negv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26050; /* negv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26052; /* negv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26054; /* negv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26056; /* negv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26058; /* negv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26060; /* negv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26062; /* negv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26064; /* negv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26066; /* negv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26068; /* negv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26070; /* negv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 26072; /* negv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26074; /* negv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26076; /* negv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26078; /* negv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26080; /* negv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26082; /* negv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26084; /* negv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26086; /* negv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26088; /* negv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26090; /* negv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26092; /* negv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26094; /* negv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26096; /* negv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26098; /* negv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26100; /* negv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26102; /* negv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26104; /* negv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26106; /* negv512di2 */

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26108; /* negrvvm8hf2 */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26110; /* negrvvm4hf2 */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26112; /* negrvvm2hf2 */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26114; /* negrvvm1hf2 */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26116; /* negrvvmf2hf2 */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26118; /* negrvvmf4hf2 */

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26120; /* negrvvm8sf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26122; /* negrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26124; /* negrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26126; /* negrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26128; /* negrvvmf2sf2 */

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26130; /* negrvvm8df2 */

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26132; /* negrvvm4df2 */

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26134; /* negrvvm2df2 */

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26136; /* negrvvm1df2 */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26138; /* negv1hf2 */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26140; /* negv2hf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26142; /* negv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26144; /* negv8hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26146; /* negv16hf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26148; /* negv32hf2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26150; /* negv64hf2 */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26152; /* negv128hf2 */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26154; /* negv256hf2 */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26156; /* negv512hf2 */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26158; /* negv1024hf2 */

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26160; /* negv2048hf2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26162; /* negv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26164; /* negv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26166; /* negv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26168; /* negv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26170; /* negv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26172; /* negv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26174; /* negv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26176; /* negv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26178; /* negv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26180; /* negv512sf2 */

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26182; /* negv1024sf2 */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26184; /* negv1df2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26186; /* negv2df2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26188; /* negv4df2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26190; /* negv8df2 */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26192; /* negv16df2 */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26194; /* negv32df2 */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26196; /* negv64df2 */

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26198; /* negv128df2 */

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26200; /* negv256df2 */

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26202; /* negv512df2 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern236 (x3))
    {
    case 0:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26868; /* fmaxrvvm8hf3 */

    case 1:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26870; /* fmaxrvvm4hf3 */

    case 2:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26872; /* fmaxrvvm2hf3 */

    case 3:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26874; /* fmaxrvvm1hf3 */

    case 4:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26876; /* fmaxrvvmf2hf3 */

    case 5:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26878; /* fmaxrvvmf4hf3 */

    case 6:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26880; /* fmaxrvvm8sf3 */

    case 7:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26882; /* fmaxrvvm4sf3 */

    case 8:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26884; /* fmaxrvvm2sf3 */

    case 9:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26886; /* fmaxrvvm1sf3 */

    case 10:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26888; /* fmaxrvvmf2sf3 */

    case 11:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26890; /* fmaxrvvm8df3 */

    case 12:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26892; /* fmaxrvvm4df3 */

    case 13:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26894; /* fmaxrvvm2df3 */

    case 14:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26896; /* fmaxrvvm1df3 */

    case 15:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26898; /* fmaxv1hf3 */

    case 16:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26900; /* fmaxv2hf3 */

    case 17:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26902; /* fmaxv4hf3 */

    case 18:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26904; /* fmaxv8hf3 */

    case 19:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26906; /* fmaxv16hf3 */

    case 20:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26908; /* fmaxv32hf3 */

    case 21:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26910; /* fmaxv64hf3 */

    case 22:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26912; /* fmaxv128hf3 */

    case 23:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26914; /* fmaxv256hf3 */

    case 24:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26916; /* fmaxv512hf3 */

    case 25:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26918; /* fmaxv1024hf3 */

    case 26:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26920; /* fmaxv2048hf3 */

    case 27:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26922; /* fmaxv1sf3 */

    case 28:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26924; /* fmaxv2sf3 */

    case 29:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26926; /* fmaxv4sf3 */

    case 30:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26928; /* fmaxv8sf3 */

    case 31:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26930; /* fmaxv16sf3 */

    case 32:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26932; /* fmaxv32sf3 */

    case 33:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26934; /* fmaxv64sf3 */

    case 34:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26936; /* fmaxv128sf3 */

    case 35:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26938; /* fmaxv256sf3 */

    case 36:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26940; /* fmaxv512sf3 */

    case 37:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26942; /* fmaxv1024sf3 */

    case 38:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26944; /* fmaxv1df3 */

    case 39:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26946; /* fmaxv2df3 */

    case 40:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26948; /* fmaxv4df3 */

    case 41:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26950; /* fmaxv8df3 */

    case 42:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26952; /* fmaxv16df3 */

    case 43:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26954; /* fmaxv32df3 */

    case 44:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26956; /* fmaxv64df3 */

    case 45:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26958; /* fmaxv128df3 */

    case 46:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26960; /* fmaxv256df3 */

    case 47:
      if (!(
#line 1577 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26962; /* fmaxv512df3 */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18112; /* pred_redmaxrvvm8qi */

        case 1:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18120; /* pred_redmaxrvvm4qi */

        case 2:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18128; /* pred_redmaxrvvm2qi */

        case 3:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18136; /* pred_redmaxrvvm1qi */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18240; /* pred_redmaxrvvmf2qi */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18248; /* pred_redmaxrvvmf4qi */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18256; /* pred_redmaxrvvmf8qi */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18288; /* pred_redmaxv1qi */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18296; /* pred_redmaxv2qi */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18304; /* pred_redmaxv4qi */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18312; /* pred_redmaxv8qi */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18320; /* pred_redmaxv16qi */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18328; /* pred_redmaxv32qi */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18336; /* pred_redmaxv64qi */

        case 14:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18344; /* pred_redmaxv128qi */

        case 15:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18352; /* pred_redmaxv256qi */

        case 16:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18360; /* pred_redmaxv512qi */

        case 17:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18368; /* pred_redmaxv1024qi */

        case 18:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18376; /* pred_redmaxv2048qi */

        case 19:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18384; /* pred_redmaxv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18144; /* pred_redmaxrvvm8hi */

        case 1:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18152; /* pred_redmaxrvvm4hi */

        case 2:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18160; /* pred_redmaxrvvm2hi */

        case 3:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18168; /* pred_redmaxrvvm1hi */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18264; /* pred_redmaxrvvmf2hi */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18272; /* pred_redmaxrvvmf4hi */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18392; /* pred_redmaxv1hi */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18400; /* pred_redmaxv2hi */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18408; /* pred_redmaxv4hi */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18416; /* pred_redmaxv8hi */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18424; /* pred_redmaxv16hi */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18432; /* pred_redmaxv32hi */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18440; /* pred_redmaxv64hi */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18448; /* pred_redmaxv128hi */

        case 14:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18456; /* pred_redmaxv256hi */

        case 15:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18464; /* pred_redmaxv512hi */

        case 16:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18472; /* pred_redmaxv1024hi */

        case 17:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18480; /* pred_redmaxv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18176; /* pred_redmaxrvvm8si */

        case 1:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18184; /* pred_redmaxrvvm4si */

        case 2:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18192; /* pred_redmaxrvvm2si */

        case 3:
          if (!
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18200; /* pred_redmaxrvvm1si */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18280; /* pred_redmaxrvvmf2si */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18488; /* pred_redmaxv1si */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18496; /* pred_redmaxv2si */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18504; /* pred_redmaxv4si */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18512; /* pred_redmaxv8si */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18520; /* pred_redmaxv16si */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18528; /* pred_redmaxv32si */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18536; /* pred_redmaxv64si */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18544; /* pred_redmaxv128si */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18552; /* pred_redmaxv256si */

        case 14:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18560; /* pred_redmaxv512si */

        case 15:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18568; /* pred_redmaxv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2))
        {
        case 0:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18208; /* pred_redmaxrvvm8di */

        case 1:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18216; /* pred_redmaxrvvm4di */

        case 2:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18224; /* pred_redmaxrvvm2di */

        case 3:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18232; /* pred_redmaxrvvm1di */

        case 4:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18576; /* pred_redmaxv1di */

        case 5:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18584; /* pred_redmaxv2di */

        case 6:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18592; /* pred_redmaxv4di */

        case 7:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18600; /* pred_redmaxv8di */

        case 8:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18608; /* pred_redmaxv16di */

        case 9:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18616; /* pred_redmaxv32di */

        case 10:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18624; /* pred_redmaxv64di */

        case 11:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18632; /* pred_redmaxv128di */

        case 12:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18640; /* pred_redmaxv256di */

        case 13:
          if (!(
#line 7765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18648; /* pred_redmaxv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18762; /* pred_redmaxrvvm8hf */

        case 1:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18764; /* pred_redmaxrvvm4hf */

        case 2:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18766; /* pred_redmaxrvvm2hf */

        case 3:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18768; /* pred_redmaxrvvm1hf */

        case 4:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 18770; /* pred_redmaxrvvmf2hf */

        case 5:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18772; /* pred_redmaxrvvmf4hf */

        case 6:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 18792; /* pred_redmaxv1hf */

        case 7:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 18794; /* pred_redmaxv2hf */

        case 8:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 18796; /* pred_redmaxv4hf */

        case 9:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 18798; /* pred_redmaxv8hf */

        case 10:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 18800; /* pred_redmaxv16hf */

        case 11:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18802; /* pred_redmaxv32hf */

        case 12:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18804; /* pred_redmaxv64hf */

        case 13:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18806; /* pred_redmaxv128hf */

        case 14:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18808; /* pred_redmaxv256hf */

        case 15:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18810; /* pred_redmaxv512hf */

        case 16:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18812; /* pred_redmaxv1024hf */

        case 17:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18814; /* pred_redmaxv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18774; /* pred_redmaxrvvm8sf */

        case 1:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18776; /* pred_redmaxrvvm4sf */

        case 2:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18778; /* pred_redmaxrvvm2sf */

        case 3:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18780; /* pred_redmaxrvvm1sf */

        case 4:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18782; /* pred_redmaxrvvmf2sf */

        case 5:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18816; /* pred_redmaxv1sf */

        case 6:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18818; /* pred_redmaxv2sf */

        case 7:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18820; /* pred_redmaxv4sf */

        case 8:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18822; /* pred_redmaxv8sf */

        case 9:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18824; /* pred_redmaxv16sf */

        case 10:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18826; /* pred_redmaxv32sf */

        case 11:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18828; /* pred_redmaxv64sf */

        case 12:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18830; /* pred_redmaxv128sf */

        case 13:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18832; /* pred_redmaxv256sf */

        case 14:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18834; /* pred_redmaxv512sf */

        case 15:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18836; /* pred_redmaxv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2))
        {
        case 0:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18784; /* pred_redmaxrvvm8df */

        case 1:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18786; /* pred_redmaxrvvm4df */

        case 2:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18788; /* pred_redmaxrvvm2df */

        case 3:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18790; /* pred_redmaxrvvm1df */

        case 4:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18838; /* pred_redmaxv1df */

        case 5:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18840; /* pred_redmaxv2df */

        case 6:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18842; /* pred_redmaxv4df */

        case 7:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18844; /* pred_redmaxv8df */

        case 8:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18846; /* pred_redmaxv16df */

        case 9:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18848; /* pred_redmaxv32df */

        case 10:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18850; /* pred_redmaxv64df */

        case 11:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18852; /* pred_redmaxv128df */

        case 12:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18854; /* pred_redmaxv256df */

        case 13:
          if (!(
#line 7807 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18856; /* pred_redmaxv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[3], E_RVVMF8x2QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20676; /* pred_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[3], E_RVVMF8x3QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20677; /* pred_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[3], E_RVVMF8x4QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20678; /* pred_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[3], E_RVVMF8x5QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20679; /* pred_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[3], E_RVVMF8x6QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20680; /* pred_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[3], E_RVVMF8x7QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20681; /* pred_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[3], E_RVVMF8x8QImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20682; /* pred_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[3], E_RVVMF4x2HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20683; /* pred_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[3], E_RVVMF4x3HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20684; /* pred_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[3], E_RVVMF4x4HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20685; /* pred_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[3], E_RVVMF4x5HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20686; /* pred_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[3], E_RVVMF4x6HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20687; /* pred_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[3], E_RVVMF4x7HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20688; /* pred_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[3], E_RVVMF4x8HImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20689; /* pred_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[3], E_RVVMF2x2SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20690; /* pred_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[3], E_RVVMF2x3SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20691; /* pred_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[3], E_RVVMF2x4SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20692; /* pred_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[3], E_RVVMF2x5SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20693; /* pred_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[3], E_RVVMF2x6SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20694; /* pred_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[3], E_RVVMF2x7SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20695; /* pred_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[3], E_RVVMF2x8SImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20696; /* pred_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[3], E_RVVM1x2DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20697; /* pred_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[3], E_RVVM1x3DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20698; /* pred_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[3], E_RVVM1x4DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20699; /* pred_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[3], E_RVVM1x5DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20700; /* pred_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[3], E_RVVM1x6DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20701; /* pred_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[3], E_RVVM1x7DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20702; /* pred_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[3], E_RVVM1x8DImode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20703; /* pred_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[3], E_RVVMF4x2BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20704; /* pred_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[3], E_RVVMF4x3BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20705; /* pred_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[3], E_RVVMF4x4BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20706; /* pred_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[3], E_RVVMF4x5BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20707; /* pred_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[3], E_RVVMF4x6BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20708; /* pred_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[3], E_RVVMF4x7BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20709; /* pred_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[3], E_RVVMF4x8BFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20710; /* pred_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[3], E_RVVMF4x2HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20711; /* pred_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[3], E_RVVMF4x3HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20712; /* pred_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[3], E_RVVMF4x4HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20713; /* pred_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[3], E_RVVMF4x5HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20714; /* pred_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[3], E_RVVMF4x6HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20715; /* pred_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[3], E_RVVMF4x7HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20716; /* pred_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[3], E_RVVMF4x8HFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20717; /* pred_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[3], E_RVVMF2x2SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20718; /* pred_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[3], E_RVVMF2x3SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20719; /* pred_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[3], E_RVVMF2x4SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20720; /* pred_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[3], E_RVVMF2x5SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20721; /* pred_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[3], E_RVVMF2x6SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20722; /* pred_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[3], E_RVVMF2x7SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20723; /* pred_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[3], E_RVVMF2x8SFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20724; /* pred_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[3], E_RVVM1x2DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20725; /* pred_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[3], E_RVVM1x3DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20726; /* pred_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[3], E_RVVM1x4DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20727; /* pred_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[3], E_RVVM1x5DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20728; /* pred_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[3], E_RVVM1x6DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20729; /* pred_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[3], E_RVVM1x7DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20730; /* pred_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[3], E_RVVM1x8DFmode)
          || !(
#line 8301 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20731; /* pred_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[2], E_RVVMF8x2QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20346; /* pred_unit_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[2], E_RVVMF8x3QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20347; /* pred_unit_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[2], E_RVVMF8x4QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20348; /* pred_unit_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[2], E_RVVMF8x5QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20349; /* pred_unit_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[2], E_RVVMF8x6QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20350; /* pred_unit_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[2], E_RVVMF8x7QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20351; /* pred_unit_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[2], E_RVVMF8x8QImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20352; /* pred_unit_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[2], E_RVVMF4x2HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20353; /* pred_unit_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[2], E_RVVMF4x3HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20354; /* pred_unit_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[2], E_RVVMF4x4HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20355; /* pred_unit_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[2], E_RVVMF4x5HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20356; /* pred_unit_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[2], E_RVVMF4x6HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20357; /* pred_unit_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[2], E_RVVMF4x7HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20358; /* pred_unit_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[2], E_RVVMF4x8HImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20359; /* pred_unit_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[2], E_RVVMF2x2SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20360; /* pred_unit_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[2], E_RVVMF2x3SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20361; /* pred_unit_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[2], E_RVVMF2x4SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20362; /* pred_unit_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[2], E_RVVMF2x5SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20363; /* pred_unit_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[2], E_RVVMF2x6SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20364; /* pred_unit_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[2], E_RVVMF2x7SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20365; /* pred_unit_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[2], E_RVVMF2x8SImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20366; /* pred_unit_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[2], E_RVVM1x2DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20367; /* pred_unit_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[2], E_RVVM1x3DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20368; /* pred_unit_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[2], E_RVVM1x4DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20369; /* pred_unit_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[2], E_RVVM1x5DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20370; /* pred_unit_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[2], E_RVVM1x6DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20371; /* pred_unit_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[2], E_RVVM1x7DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20372; /* pred_unit_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[2], E_RVVM1x8DImode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20373; /* pred_unit_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[2], E_RVVMF4x2BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20374; /* pred_unit_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[2], E_RVVMF4x3BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20375; /* pred_unit_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[2], E_RVVMF4x4BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20376; /* pred_unit_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[2], E_RVVMF4x5BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20377; /* pred_unit_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[2], E_RVVMF4x6BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20378; /* pred_unit_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[2], E_RVVMF4x7BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20379; /* pred_unit_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[2], E_RVVMF4x8BFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20380; /* pred_unit_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[2], E_RVVMF4x2HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20381; /* pred_unit_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[2], E_RVVMF4x3HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20382; /* pred_unit_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[2], E_RVVMF4x4HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20383; /* pred_unit_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[2], E_RVVMF4x5HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20384; /* pred_unit_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[2], E_RVVMF4x6HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20385; /* pred_unit_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[2], E_RVVMF4x7HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20386; /* pred_unit_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[2], E_RVVMF4x8HFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20387; /* pred_unit_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[2], E_RVVMF2x2SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20388; /* pred_unit_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[2], E_RVVMF2x3SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20389; /* pred_unit_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[2], E_RVVMF2x4SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20390; /* pred_unit_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[2], E_RVVMF2x5SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20391; /* pred_unit_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[2], E_RVVMF2x6SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20392; /* pred_unit_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[2], E_RVVMF2x7SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20393; /* pred_unit_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[2], E_RVVMF2x8SFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20394; /* pred_unit_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[2], E_RVVM1x2DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20395; /* pred_unit_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[2], E_RVVM1x3DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20396; /* pred_unit_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[2], E_RVVM1x4DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20397; /* pred_unit_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[2], E_RVVM1x5DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20398; /* pred_unit_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[2], E_RVVM1x6DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20399; /* pred_unit_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[2], E_RVVM1x7DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20400; /* pred_unit_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[2], E_RVVM1x8DFmode)
          || !(
#line 8262 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20401; /* pred_unit_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern188 (x1))
    {
    case 0:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19152; /* pred_slideuprvvm8qi */

    case 1:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19154; /* pred_slideuprvvm4qi */

    case 2:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19156; /* pred_slideuprvvm2qi */

    case 3:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19158; /* pred_slideuprvvm1qi */

    case 4:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19160; /* pred_slideuprvvm8hi */

    case 5:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19162; /* pred_slideuprvvm4hi */

    case 6:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19164; /* pred_slideuprvvm2hi */

    case 7:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19166; /* pred_slideuprvvm1hi */

    case 8:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19168; /* pred_slideuprvvm8si */

    case 9:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19170; /* pred_slideuprvvm4si */

    case 10:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19172; /* pred_slideuprvvm2si */

    case 11:
      if (!
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19174; /* pred_slideuprvvm1si */

    case 12:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19176; /* pred_slideuprvvm8di */

    case 13:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19178; /* pred_slideuprvvm4di */

    case 14:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19180; /* pred_slideuprvvm2di */

    case 15:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19182; /* pred_slideuprvvm1di */

    case 16:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19184; /* pred_slideuprvvmf2qi */

    case 17:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19186; /* pred_slideuprvvmf4qi */

    case 18:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19188; /* pred_slideuprvvmf8qi */

    case 19:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19190; /* pred_slideuprvvmf2hi */

    case 20:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19192; /* pred_slideuprvvmf4hi */

    case 21:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19194; /* pred_slideuprvvmf2si */

    case 22:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19196; /* pred_slideuprvvm8bf */

    case 23:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19198; /* pred_slideuprvvm4bf */

    case 24:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19200; /* pred_slideuprvvm2bf */

    case 25:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19202; /* pred_slideuprvvm1bf */

    case 26:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19204; /* pred_slideuprvvmf2bf */

    case 27:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19206; /* pred_slideuprvvmf4bf */

    case 28:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19208; /* pred_slideuprvvm8hf */

    case 29:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19210; /* pred_slideuprvvm4hf */

    case 30:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19212; /* pred_slideuprvvm2hf */

    case 31:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19214; /* pred_slideuprvvm1hf */

    case 32:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19216; /* pred_slideuprvvmf2hf */

    case 33:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19218; /* pred_slideuprvvmf4hf */

    case 34:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19220; /* pred_slideuprvvm8sf */

    case 35:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19222; /* pred_slideuprvvm4sf */

    case 36:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19224; /* pred_slideuprvvm2sf */

    case 37:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19226; /* pred_slideuprvvm1sf */

    case 38:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19228; /* pred_slideuprvvmf2sf */

    case 39:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19230; /* pred_slideuprvvm8df */

    case 40:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19232; /* pred_slideuprvvm4df */

    case 41:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19234; /* pred_slideuprvvm2df */

    case 42:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19236; /* pred_slideuprvvm1df */

    case 43:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 19238; /* pred_slideupv1qi */

    case 44:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 19240; /* pred_slideupv2qi */

    case 45:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 19242; /* pred_slideupv4qi */

    case 46:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 19244; /* pred_slideupv8qi */

    case 47:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 19246; /* pred_slideupv16qi */

    case 48:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 19248; /* pred_slideupv32qi */

    case 49:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19250; /* pred_slideupv64qi */

    case 50:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19252; /* pred_slideupv128qi */

    case 51:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19254; /* pred_slideupv256qi */

    case 52:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19256; /* pred_slideupv512qi */

    case 53:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19258; /* pred_slideupv1024qi */

    case 54:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19260; /* pred_slideupv2048qi */

    case 55:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19262; /* pred_slideupv4096qi */

    case 56:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 19264; /* pred_slideupv1hi */

    case 57:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 19266; /* pred_slideupv2hi */

    case 58:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 19268; /* pred_slideupv4hi */

    case 59:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 19270; /* pred_slideupv8hi */

    case 60:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 19272; /* pred_slideupv16hi */

    case 61:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19274; /* pred_slideupv32hi */

    case 62:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19276; /* pred_slideupv64hi */

    case 63:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19278; /* pred_slideupv128hi */

    case 64:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19280; /* pred_slideupv256hi */

    case 65:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19282; /* pred_slideupv512hi */

    case 66:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19284; /* pred_slideupv1024hi */

    case 67:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19286; /* pred_slideupv2048hi */

    case 68:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 19288; /* pred_slideupv1si */

    case 69:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 19290; /* pred_slideupv2si */

    case 70:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 19292; /* pred_slideupv4si */

    case 71:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 19294; /* pred_slideupv8si */

    case 72:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19296; /* pred_slideupv16si */

    case 73:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19298; /* pred_slideupv32si */

    case 74:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19300; /* pred_slideupv64si */

    case 75:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19302; /* pred_slideupv128si */

    case 76:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19304; /* pred_slideupv256si */

    case 77:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19306; /* pred_slideupv512si */

    case 78:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19308; /* pred_slideupv1024si */

    case 79:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19310; /* pred_slideupv1di */

    case 80:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19312; /* pred_slideupv2di */

    case 81:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19314; /* pred_slideupv4di */

    case 82:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19316; /* pred_slideupv8di */

    case 83:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19318; /* pred_slideupv16di */

    case 84:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19320; /* pred_slideupv32di */

    case 85:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19322; /* pred_slideupv64di */

    case 86:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19324; /* pred_slideupv128di */

    case 87:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19326; /* pred_slideupv256di */

    case 88:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19328; /* pred_slideupv512di */

    case 89:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19330; /* pred_slideupv1hf */

    case 90:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19332; /* pred_slideupv2hf */

    case 91:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19334; /* pred_slideupv4hf */

    case 92:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19336; /* pred_slideupv8hf */

    case 93:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19338; /* pred_slideupv16hf */

    case 94:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19340; /* pred_slideupv32hf */

    case 95:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19342; /* pred_slideupv64hf */

    case 96:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19344; /* pred_slideupv128hf */

    case 97:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19346; /* pred_slideupv256hf */

    case 98:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19348; /* pred_slideupv512hf */

    case 99:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19350; /* pred_slideupv1024hf */

    case 100:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19352; /* pred_slideupv2048hf */

    case 101:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19354; /* pred_slideupv1sf */

    case 102:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19356; /* pred_slideupv2sf */

    case 103:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19358; /* pred_slideupv4sf */

    case 104:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19360; /* pred_slideupv8sf */

    case 105:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19362; /* pred_slideupv16sf */

    case 106:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19364; /* pred_slideupv32sf */

    case 107:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19366; /* pred_slideupv64sf */

    case 108:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19368; /* pred_slideupv128sf */

    case 109:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19370; /* pred_slideupv256sf */

    case 110:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19372; /* pred_slideupv512sf */

    case 111:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19374; /* pred_slideupv1024sf */

    case 112:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19376; /* pred_slideupv1df */

    case 113:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19378; /* pred_slideupv2df */

    case 114:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 19380; /* pred_slideupv4df */

    case 115:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19382; /* pred_slideupv8df */

    case 116:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19384; /* pred_slideupv16df */

    case 117:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19386; /* pred_slideupv32df */

    case 118:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19388; /* pred_slideupv64df */

    case 119:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19390; /* pred_slideupv128df */

    case 120:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19392; /* pred_slideupv256df */

    case 121:
      if (!(
#line 7980 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19394; /* pred_slideupv512df */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 108; /* *xorsi3 */
          if (
#line 1758 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 113; /* *xorsi3_internal */
        }
      if (single_bit_mask_operand (operands[2], E_SImode)
          && (
#line 789 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 606; /* *binvisi */
      if (!uimm_extra_bit_or_twobits (operands[2], E_SImode)
          || !(
#line 1020 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 629; /* *xorisi_extrabit */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (arith_operand (operands[2], E_DImode)
          && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return 110; /* *xordi3 */
      if (single_bit_mask_operand (operands[2], E_DImode)
          && (
#line 789 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return 608; /* *binvidi */
      if (!uimm_extra_bit_or_twobits (operands[2], E_DImode)
          || !(
#line 1020 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 631; /* *xoridi_extrabit */

    case E_HImode:
      switch (pattern331 (x2))
        {
        case 0:
          return 282; /* *xorhihi3 */

        case 1:
          return 283; /* *xorsihi3 */

        default:
          return -1;
        }

    case E_RVVM8QImode:
      if (pattern228 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23618; /* xorrvvm8qi3 */

    case E_RVVM4QImode:
      if (pattern228 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23632; /* xorrvvm4qi3 */

    case E_RVVM2QImode:
      if (pattern228 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23646; /* xorrvvm2qi3 */

    case E_RVVM1QImode:
      if (pattern228 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23660; /* xorrvvm1qi3 */

    case E_RVVM8HImode:
      if (pattern228 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23674; /* xorrvvm8hi3 */

    case E_RVVM4HImode:
      if (pattern228 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23688; /* xorrvvm4hi3 */

    case E_RVVM2HImode:
      if (pattern228 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23702; /* xorrvvm2hi3 */

    case E_RVVM1HImode:
      if (pattern228 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23716; /* xorrvvm1hi3 */

    case E_RVVM8SImode:
      if (pattern228 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23730; /* xorrvvm8si3 */

    case E_RVVM4SImode:
      if (pattern228 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23744; /* xorrvvm4si3 */

    case E_RVVM2SImode:
      if (pattern228 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23758; /* xorrvvm2si3 */

    case E_RVVM1SImode:
      if (pattern228 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23772; /* xorrvvm1si3 */

    case E_RVVM8DImode:
      if (pattern228 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23786; /* xorrvvm8di3 */

    case E_RVVM4DImode:
      if (pattern228 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23800; /* xorrvvm4di3 */

    case E_RVVM2DImode:
      if (pattern228 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23814; /* xorrvvm2di3 */

    case E_RVVM1DImode:
      if (pattern228 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23828; /* xorrvvm1di3 */

    case E_RVVMF2QImode:
      if (pattern228 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23842; /* xorrvvmf2qi3 */

    case E_RVVMF4QImode:
      if (pattern228 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23856; /* xorrvvmf4qi3 */

    case E_RVVMF8QImode:
      if (pattern228 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23870; /* xorrvvmf8qi3 */

    case E_RVVMF2HImode:
      if (pattern228 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23884; /* xorrvvmf2hi3 */

    case E_RVVMF4HImode:
      if (pattern228 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23898; /* xorrvvmf4hi3 */

    case E_RVVMF2SImode:
      if (pattern228 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23912; /* xorrvvmf2si3 */

    case E_V1QImode:
      if (pattern228 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23926; /* xorv1qi3 */

    case E_V2QImode:
      if (pattern228 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23940; /* xorv2qi3 */

    case E_V4QImode:
      if (pattern228 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23954; /* xorv4qi3 */

    case E_V8QImode:
      if (pattern228 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23968; /* xorv8qi3 */

    case E_V16QImode:
      if (pattern228 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23982; /* xorv16qi3 */

    case E_V32QImode:
      if (pattern228 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 23996; /* xorv32qi3 */

    case E_V64QImode:
      if (pattern228 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24010; /* xorv64qi3 */

    case E_V128QImode:
      if (pattern228 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24024; /* xorv128qi3 */

    case E_V256QImode:
      if (pattern228 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24038; /* xorv256qi3 */

    case E_V512QImode:
      if (pattern228 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24052; /* xorv512qi3 */

    case E_V1024QImode:
      if (pattern228 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24066; /* xorv1024qi3 */

    case E_V2048QImode:
      if (pattern228 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24080; /* xorv2048qi3 */

    case E_V4096QImode:
      if (pattern228 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24094; /* xorv4096qi3 */

    case E_V1HImode:
      if (pattern228 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24108; /* xorv1hi3 */

    case E_V2HImode:
      if (pattern228 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24122; /* xorv2hi3 */

    case E_V4HImode:
      if (pattern228 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24136; /* xorv4hi3 */

    case E_V8HImode:
      if (pattern228 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24150; /* xorv8hi3 */

    case E_V16HImode:
      if (pattern228 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24164; /* xorv16hi3 */

    case E_V32HImode:
      if (pattern228 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24178; /* xorv32hi3 */

    case E_V64HImode:
      if (pattern228 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24192; /* xorv64hi3 */

    case E_V128HImode:
      if (pattern228 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24206; /* xorv128hi3 */

    case E_V256HImode:
      if (pattern228 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24220; /* xorv256hi3 */

    case E_V512HImode:
      if (pattern228 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24234; /* xorv512hi3 */

    case E_V1024HImode:
      if (pattern228 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24248; /* xorv1024hi3 */

    case E_V2048HImode:
      if (pattern228 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24262; /* xorv2048hi3 */

    case E_V1SImode:
      if (pattern228 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24276; /* xorv1si3 */

    case E_V2SImode:
      if (pattern228 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24290; /* xorv2si3 */

    case E_V4SImode:
      if (pattern228 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24304; /* xorv4si3 */

    case E_V8SImode:
      if (pattern228 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24318; /* xorv8si3 */

    case E_V16SImode:
      if (pattern228 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24332; /* xorv16si3 */

    case E_V32SImode:
      if (pattern228 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24346; /* xorv32si3 */

    case E_V64SImode:
      if (pattern228 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24360; /* xorv64si3 */

    case E_V128SImode:
      if (pattern228 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24374; /* xorv128si3 */

    case E_V256SImode:
      if (pattern228 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24388; /* xorv256si3 */

    case E_V512SImode:
      if (pattern228 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24402; /* xorv512si3 */

    case E_V1024SImode:
      if (pattern228 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24416; /* xorv1024si3 */

    case E_V1DImode:
      if (pattern228 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24430; /* xorv1di3 */

    case E_V2DImode:
      if (pattern228 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24444; /* xorv2di3 */

    case E_V4DImode:
      if (pattern228 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24458; /* xorv4di3 */

    case E_V8DImode:
      if (pattern228 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24472; /* xorv8di3 */

    case E_V16DImode:
      if (pattern228 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24486; /* xorv16di3 */

    case E_V32DImode:
      if (pattern228 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24500; /* xorv32di3 */

    case E_V64DImode:
      if (pattern228 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24514; /* xorv64di3 */

    case E_V128DImode:
      if (pattern228 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24528; /* xorv128di3 */

    case E_V256DImode:
      if (pattern228 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24542; /* xorv256di3 */

    case E_V512DImode:
      if (pattern228 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24556; /* xorv512di3 */

    case E_RVVMF64BImode:
      if (pattern0 (x2, 
E_RVVMF64BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 24976; /* xorrvvmf64bi3 */

    case E_RVVMF32BImode:
      if (pattern0 (x2, 
E_RVVMF32BImode) != 0
          || !
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24979; /* xorrvvmf32bi3 */

    case E_RVVMF16BImode:
      if (pattern0 (x2, 
E_RVVMF16BImode) != 0
          || !
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24982; /* xorrvvmf16bi3 */

    case E_RVVMF8BImode:
      if (pattern0 (x2, 
E_RVVMF8BImode) != 0
          || !
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24985; /* xorrvvmf8bi3 */

    case E_RVVMF4BImode:
      if (pattern0 (x2, 
E_RVVMF4BImode) != 0
          || !
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24988; /* xorrvvmf4bi3 */

    case E_RVVMF2BImode:
      if (pattern0 (x2, 
E_RVVMF2BImode) != 0
          || !
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24991; /* xorrvvmf2bi3 */

    case E_RVVM1BImode:
      if (pattern0 (x2, 
E_RVVM1BImode) != 0
          || !
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24994; /* xorrvvm1bi3 */

    case E_V1BImode:
      if (pattern0 (x2, 
E_V1BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 24997; /* xorv1bi3 */

    case E_V2BImode:
      if (pattern0 (x2, 
E_V2BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25000; /* xorv2bi3 */

    case E_V4BImode:
      if (pattern0 (x2, 
E_V4BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25003; /* xorv4bi3 */

    case E_V8BImode:
      if (pattern0 (x2, 
E_V8BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25006; /* xorv8bi3 */

    case E_V16BImode:
      if (pattern0 (x2, 
E_V16BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25009; /* xorv16bi3 */

    case E_V32BImode:
      if (pattern0 (x2, 
E_V32BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25012; /* xorv32bi3 */

    case E_V64BImode:
      if (pattern0 (x2, 
E_V64BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25015; /* xorv64bi3 */

    case E_V128BImode:
      if (pattern0 (x2, 
E_V128BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25018; /* xorv128bi3 */

    case E_V256BImode:
      if (pattern0 (x2, 
E_V256BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25021; /* xorv256bi3 */

    case E_V512BImode:
      if (pattern0 (x2, 
E_V512BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25024; /* xorv512bi3 */

    case E_V1024BImode:
      if (pattern0 (x2, 
E_V1024BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25027; /* xorv1024bi3 */

    case E_V2048BImode:
      if (pattern0 (x2, 
E_V2048BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25030; /* xorv2048bi3 */

    case E_V4096BImode:
      if (pattern0 (x2, 
E_V4096BImode) != 0
          || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25033; /* xorv4096bi3 */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32BImode)
      && reg_or_mem_operand (operands[1], E_V32BImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4334 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3305; /* *movv32bisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4334 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3306; /* *movv32bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32BImode)
      || !register_operand (operands[1], E_V32BImode)
      || !(
#line 1529 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
    return -1;
  return 3484; /* *movv32bi_vls */
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32DFmode)
      && reg_or_mem_operand (operands[1], E_V32DFmode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4328 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3295; /* *movv32dfsi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4328 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3296; /* *movv32dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32DFmode)
      || !register_operand (operands[1], E_V32DFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3395; /* *movv32df_vls */
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64SFmode)
      && reg_or_mem_operand (operands[1], E_V64SFmode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4323 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3285; /* *movv64sfsi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4323 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3286; /* *movv64sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64SFmode)
      || !register_operand (operands[1], E_V64SFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3385; /* *movv64sf_vls */
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256HFmode)
      && reg_or_mem_operand (operands[1], E_V256HFmode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4318 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3275; /* *movv256hfsi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4318 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3276; /* *movv256hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256HFmode)
      || !register_operand (operands[1], E_V256HFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3375; /* *movv256hf_vls */
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128DImode)
      && reg_or_mem_operand (operands[1], E_V128DImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4312 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3263; /* *movv128disi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4312 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3264; /* *movv128didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128DImode)
      || !register_operand (operands[1], E_V128DImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3364; /* *movv128di_vls */
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128SImode)
      && reg_or_mem_operand (operands[1], E_V128SImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4306 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3251; /* *movv128sisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4306 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3252; /* *movv128sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128SImode)
      || !register_operand (operands[1], E_V128SImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3353; /* *movv128si_vls */
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256HImode)
      && reg_or_mem_operand (operands[1], E_V256HImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3239; /* *movv256hisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3240; /* *movv256hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256HImode)
      || !register_operand (operands[1], E_V256HImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3342; /* *movv256hi_vls */
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024QImode)
      && reg_or_mem_operand (operands[1], E_V1024QImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3227; /* *movv1024qisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3228; /* *movv1024qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024QImode)
      || !register_operand (operands[1], E_V1024QImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3331; /* *movv1024qi_vls */
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVM1BImode)
      && register_operand (operands[1], E_RVVM1BImode)
      && 
#line 1293 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2803; /* *movrvvm1bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1BImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1BImode))
    return -1;
  if ((
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2845; /* *movrvvm1bisi_lra */
    }
  if (!(
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2846; /* *movrvvm1bidi_lra */
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF64BImode)
      && register_operand (operands[1], E_RVVMF64BImode)
      && (
#line 1293 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 2797; /* *movrvvmf64bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF64BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF64BImode))
    return -1;
  if ((
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2833; /* *movrvvmf64bisi_lra */
    }
  if (!(
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2834; /* *movrvvmf64bidi_lra */
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4HImode)
      && register_operand (operands[1], E_RVVMF4HImode)
      && (
#line 1256 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 920 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 2779; /* *movrvvmf4hi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4HImode))
    return -1;
  if ((
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 920 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2815; /* *movrvvmf4hisi_lra */
    }
  if (!(
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 920 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2826; /* *movrvvmf4hidi_lra */
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return 3215; /* *movv8bi */
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !(
#line 1529 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return -1;
  return 3482; /* *movv8bi_vls */
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DFmode)
      && reg_or_mem_operand (operands[1], E_V2DFmode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))) && 
#line 4276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3208; /* *movv2df */
  if (!register_operand (operands[0], E_V2DFmode)
      || !register_operand (operands[1], E_V2DFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3391; /* *movv2df_vls */
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3201; /* *movv16hf */
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3371; /* *movv16hf_vls */
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DImode)
      && reg_or_mem_operand (operands[1], E_V4DImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))) && 
#line 4262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 3194; /* *movv4di */
  if (!register_operand (operands[0], E_V4DImode)
      || !register_operand (operands[1], E_V4DImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 3359; /* *movv4di_vls */
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SImode)
      && reg_or_mem_operand (operands[1], E_V1SImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SImode)
       || register_operand (operands[1], V1SImode))) && 
#line 4255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 3187; /* *movv1si */
  if (!register_operand (operands[0], E_V1SImode)
      || !register_operand (operands[1], E_V1SImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 3346; /* *movv1si_vls */
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8QImode)
      && reg_or_mem_operand (operands[1], E_V8QImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))) && 
#line 4248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 3180; /* *movv8qi */
  if (!register_operand (operands[0], E_V8QImode)
      || !register_operand (operands[1], E_V8QImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 3324; /* *movv8qi_vls */
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3171; /* *movrvvm4x2bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3172; /* *movrvvm4x2bf_di */
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3155; /* *movrvvm2x2hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3156; /* *movrvvm2x2hf_di */
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3141; /* *movrvvm2x2hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3142; /* *movrvvm2x2hi_di */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3127; /* *movrvvm1x2qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3128; /* *movrvvm1x2qi_di */
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3113; /* *movrvvm1x6hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3114; /* *movrvvm1x6hf_di */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3099; /* *movrvvm1x6bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3100; /* *movrvvm1x6bf_di */
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3SImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3085; /* *movrvvm2x3si_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3086; /* *movrvvm2x3si_di */
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3073; /* *movrvvm1x4hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3074; /* *movrvvm1x4hi_di */
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3059; /* *movrvvmf2x4qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3060; /* *movrvvmf2x4qi_di */
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3043; /* *movrvvm1x6sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3044; /* *movrvvm1x6sf_di */
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3027; /* *movrvvmf2x5hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3028; /* *movrvvmf2x5hf_di */
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3011; /* *movrvvmf2x4bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3012; /* *movrvvmf2x4bf_di */
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6SImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2995; /* *movrvvm1x6si_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2996; /* *movrvvm1x6si_di */
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2985; /* *movrvvmf2x8hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2986; /* *movrvvmf2x8hi_di */
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2969; /* *movrvvmf4x7qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2970; /* *movrvvmf4x7qi_di */
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6DFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2953; /* *movrvvm1x6df_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2954; /* *movrvvm1x6df_di */
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2937; /* *movrvvmf2x5sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2938; /* *movrvvmf2x5sf_di */
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2921; /* *movrvvmf4x4hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2922; /* *movrvvmf4x4hf_di */
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2905; /* *movrvvmf4x3bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2906; /* *movrvvmf4x3bf_di */
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2DImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2889; /* *movrvvm1x2di_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2890; /* *movrvvm1x2di_di */
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !(
#line 815 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (SImode)
       || operands[2] == CONST1_RTX (SImode))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 609; /* *bsetclr_zero_extract */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !(
#line 815 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (DImode)
       || operands[2] == CONST1_RTX (DImode))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 610; /* *bsetclr_zero_extract */

    default:
      return -1;
    }
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 2);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      operands[3] = x5;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *branch_on_bitsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 384; /* *branch_on_bitdi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      operands[1] = x3;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !(
#line 1143 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 637; /* *branchsi_bext */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x5) != E_DImode
              || !(
#line 1143 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 638; /* *branchdi_bext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (equality_operator (x3, E_VOIDmode))
    {
      res = recog_369 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern359 (x2))
        {
        case 0:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32729; /* *czero.nez.sisi */

        case 1:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32731; /* *czero.nez.sidi */

        case 2:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32733; /* *czero.nez.didi */

        case 3:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32741; /* *czero.eqz.sisi.opt1 */

        case 4:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32743; /* *czero.eqz.sidi.opt1 */

        case 5:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && (((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 32742; /* *czero.eqz.disi.opt1 */

        case 6:
          if (!(
#line 69 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32744; /* *czero.eqz.didi.opt1 */

        case 7:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32735; /* *czero.eqz.sisi */

        case 8:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32737; /* *czero.eqz.sidi */

        case 9:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32739; /* *czero.eqz.didi */

        default:
          return -1;
        }

    case NE:
      switch (pattern359 (x2))
        {
        case 0:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32730; /* *czero.eqz.sisi */

        case 1:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32732; /* *czero.eqz.sidi */

        case 2:
          if (!(
#line 34 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32734; /* *czero.eqz.didi */

        case 3:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32745; /* *czero.nez.sisi.opt2 */

        case 4:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32747; /* *czero.nez.sidi.opt2 */

        case 5:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && (((
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 32746; /* *czero.nez.disi.opt2 */

        case 6:
          if (!(
#line 86 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32748; /* *czero.nez.didi.opt2 */

        case 7:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32736; /* *czero.nez.sisi */

        case 8:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32738; /* *czero.nez.sidi */

        case 9:
          if (!(
#line 51 "../../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32740; /* *czero.nez.didi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      switch (pattern409 ())
        {
        case 0:
          if (!(
#line 3238 "../../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 369; /* *branchsi */

        case 1:
          if (!(
#line 3238 "../../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 370; /* *branchdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (pattern332 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_SImode)
              || !sfb_alu_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_0_operand (operands[2], E_SImode)
                  || !(
#line 31 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32749; /* *movsisicc */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode)
                  || !(
#line 31 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32750; /* *movsidicc */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !register_operand (operands[3], E_DImode)
              || !sfb_alu_operand (operands[4], E_DImode)
              || !(
#line 31 "../../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32751; /* *movdidicc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF64BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF64BImode))
    return -1;
  if ((
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 1216; /* *pred_th_movrvvmf64bi */
  if (!(
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return -1;
  return 3801; /* pred_movrvvmf64bi */
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF32BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF32BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1217; /* *pred_th_movrvvmf32bi */
  if (!
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3802; /* pred_movrvvmf32bi */
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF8BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1219; /* *pred_th_movrvvmf8bi */
  if (!
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3804; /* pred_movrvvmf8bi */
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF2BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF2BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1221; /* *pred_th_movrvvmf2bi */
  if (!
#line 1963 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3806; /* pred_movrvvmf2bi */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3828; /* pred_mergervvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3829; /* pred_mergervvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3830; /* pred_mergervvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3831; /* pred_mergervvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3832; /* pred_mergervvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3833; /* pred_mergervvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3834; /* pred_mergervvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3835; /* pred_mergervvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3836; /* pred_mergervvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3837; /* pred_mergervvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3838; /* pred_mergervvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3839; /* pred_mergervvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3840; /* pred_mergervvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3841; /* pred_mergervvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3842; /* pred_mergervvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3843; /* pred_mergervvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3844; /* pred_mergervvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3845; /* pred_mergervvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3846; /* pred_mergervvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3847; /* pred_mergervvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3848; /* pred_mergervvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3849; /* pred_mergervvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3850; /* pred_mergervvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3851; /* pred_mergervvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3852; /* pred_mergervvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3853; /* pred_mergervvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3854; /* pred_mergervvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3855; /* pred_mergervvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3856; /* pred_mergervvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3857; /* pred_mergervvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3858; /* pred_mergervvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3859; /* pred_mergervvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3860; /* pred_mergervvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3861; /* pred_mergervvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3862; /* pred_mergervvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3863; /* pred_mergervvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3864; /* pred_mergervvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3865; /* pred_mergervvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3866; /* pred_mergervvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3867; /* pred_mergervvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3868; /* pred_mergervvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3869; /* pred_mergervvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3870; /* pred_mergervvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3871; /* pred_mergev1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3872; /* pred_mergev2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3873; /* pred_mergev4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3874; /* pred_mergev8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3875; /* pred_mergev16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3876; /* pred_mergev32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3877; /* pred_mergev64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3878; /* pred_mergev128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3879; /* pred_mergev256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3880; /* pred_mergev512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3881; /* pred_mergev1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3882; /* pred_mergev2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3883; /* pred_mergev4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3884; /* pred_mergev1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3885; /* pred_mergev2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3886; /* pred_mergev4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3887; /* pred_mergev8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3888; /* pred_mergev16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3889; /* pred_mergev32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3890; /* pred_mergev64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3891; /* pred_mergev128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3892; /* pred_mergev256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3893; /* pred_mergev512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3894; /* pred_mergev1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3895; /* pred_mergev2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3896; /* pred_mergev1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3897; /* pred_mergev2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3898; /* pred_mergev4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3899; /* pred_mergev8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3900; /* pred_mergev16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3901; /* pred_mergev32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3902; /* pred_mergev64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3903; /* pred_mergev128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3904; /* pred_mergev256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3905; /* pred_mergev512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3906; /* pred_mergev1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3907; /* pred_mergev1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3908; /* pred_mergev2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3909; /* pred_mergev4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3910; /* pred_mergev8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3911; /* pred_mergev16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3912; /* pred_mergev32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3913; /* pred_mergev64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3914; /* pred_mergev128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3915; /* pred_mergev256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3916; /* pred_mergev512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3917; /* pred_mergev1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3918; /* pred_mergev2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3919; /* pred_mergev4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3920; /* pred_mergev8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3921; /* pred_mergev16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3922; /* pred_mergev32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3923; /* pred_mergev64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3924; /* pred_mergev128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3925; /* pred_mergev256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3926; /* pred_mergev512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3927; /* pred_mergev1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3928; /* pred_mergev2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3929; /* pred_mergev1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3930; /* pred_mergev2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3931; /* pred_mergev4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3932; /* pred_mergev8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3933; /* pred_mergev16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3934; /* pred_mergev32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3935; /* pred_mergev64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3936; /* pred_mergev128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3937; /* pred_mergev256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3938; /* pred_mergev512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3939; /* pred_mergev1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3940; /* pred_mergev1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3941; /* pred_mergev2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3942; /* pred_mergev4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3943; /* pred_mergev8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3944; /* pred_mergev16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3945; /* pred_mergev32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3946; /* pred_mergev64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3947; /* pred_mergev128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3948; /* pred_mergev256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern594 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2010 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3949; /* pred_mergev512df */

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_394 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_393 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_392 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern438 (x2))
        {
        case 0:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14138; /* pred_andrvvmf64bi */

        case 1:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14141; /* pred_andrvvmf32bi */

        case 2:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14144; /* pred_andrvvmf16bi */

        case 3:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14147; /* pred_andrvvmf8bi */

        case 4:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14150; /* pred_andrvvmf4bi */

        case 5:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14153; /* pred_andrvvmf2bi */

        case 6:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14156; /* pred_andrvvm1bi */

        case 7:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14159; /* pred_andv1bi */

        case 8:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14162; /* pred_andv2bi */

        case 9:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14165; /* pred_andv4bi */

        case 10:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14168; /* pred_andv8bi */

        case 11:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14171; /* pred_andv16bi */

        case 12:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14174; /* pred_andv32bi */

        case 13:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14177; /* pred_andv64bi */

        case 14:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14180; /* pred_andv128bi */

        case 15:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14183; /* pred_andv256bi */

        case 16:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14186; /* pred_andv512bi */

        case 17:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14189; /* pred_andv1024bi */

        case 18:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14192; /* pred_andv2048bi */

        case 19:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14195; /* pred_andv4096bi */

        case 20:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14258; /* pred_andnotrvvmf64bi */

        case 21:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14260; /* pred_andnotrvvmf32bi */

        case 22:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14262; /* pred_andnotrvvmf16bi */

        case 23:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14264; /* pred_andnotrvvmf8bi */

        case 24:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14266; /* pred_andnotrvvmf4bi */

        case 25:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14268; /* pred_andnotrvvmf2bi */

        case 26:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14270; /* pred_andnotrvvm1bi */

        case 27:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14272; /* pred_andnotv1bi */

        case 28:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14274; /* pred_andnotv2bi */

        case 29:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14276; /* pred_andnotv4bi */

        case 30:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14278; /* pred_andnotv8bi */

        case 31:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14280; /* pred_andnotv16bi */

        case 32:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14282; /* pred_andnotv32bi */

        case 33:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14284; /* pred_andnotv64bi */

        case 34:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14286; /* pred_andnotv128bi */

        case 35:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14288; /* pred_andnotv256bi */

        case 36:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14290; /* pred_andnotv512bi */

        case 37:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14292; /* pred_andnotv1024bi */

        case 38:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14294; /* pred_andnotv2048bi */

        case 39:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14296; /* pred_andnotv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern438 (x2))
        {
        case 0:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14139; /* pred_iorrvvmf64bi */

        case 1:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14142; /* pred_iorrvvmf32bi */

        case 2:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14145; /* pred_iorrvvmf16bi */

        case 3:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14148; /* pred_iorrvvmf8bi */

        case 4:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14151; /* pred_iorrvvmf4bi */

        case 5:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14154; /* pred_iorrvvmf2bi */

        case 6:
          if (!
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14157; /* pred_iorrvvm1bi */

        case 7:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14160; /* pred_iorv1bi */

        case 8:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14163; /* pred_iorv2bi */

        case 9:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14166; /* pred_iorv4bi */

        case 10:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14169; /* pred_iorv8bi */

        case 11:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14172; /* pred_iorv16bi */

        case 12:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14175; /* pred_iorv32bi */

        case 13:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14178; /* pred_iorv64bi */

        case 14:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14181; /* pred_iorv128bi */

        case 15:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14184; /* pred_iorv256bi */

        case 16:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14187; /* pred_iorv512bi */

        case 17:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14190; /* pred_iorv1024bi */

        case 18:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14193; /* pred_iorv2048bi */

        case 19:
          if (!(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14196; /* pred_iorv4096bi */

        case 20:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14259; /* pred_iornotrvvmf64bi */

        case 21:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14261; /* pred_iornotrvvmf32bi */

        case 22:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14263; /* pred_iornotrvvmf16bi */

        case 23:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14265; /* pred_iornotrvvmf8bi */

        case 24:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14267; /* pred_iornotrvvmf4bi */

        case 25:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14269; /* pred_iornotrvvmf2bi */

        case 26:
          if (!
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14271; /* pred_iornotrvvm1bi */

        case 27:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14273; /* pred_iornotv1bi */

        case 28:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14275; /* pred_iornotv2bi */

        case 29:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14277; /* pred_iornotv4bi */

        case 30:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14279; /* pred_iornotv8bi */

        case 31:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14281; /* pred_iornotv16bi */

        case 32:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14283; /* pred_iornotv32bi */

        case 33:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14285; /* pred_iornotv64bi */

        case 34:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14287; /* pred_iornotv128bi */

        case 35:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14289; /* pred_iornotv256bi */

        case 36:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14291; /* pred_iornotv512bi */

        case 37:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14293; /* pred_iornotv1024bi */

        case 38:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14295; /* pred_iornotv2048bi */

        case 39:
          if (!(
#line 6049 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14297; /* pred_iornotv4096bi */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[5] = x6;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      operands[6] = x7;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern436 (x2, 
E_RVVMF64BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14140; /* pred_xorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern436 (x2, 
E_RVVMF32BImode) != 0
              || !
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14143; /* pred_xorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern436 (x2, 
E_RVVMF16BImode) != 0
              || !
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14146; /* pred_xorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern436 (x2, 
E_RVVMF8BImode) != 0
              || !
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14149; /* pred_xorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern436 (x2, 
E_RVVMF4BImode) != 0
              || !
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14152; /* pred_xorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern436 (x2, 
E_RVVMF2BImode) != 0
              || !
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14155; /* pred_xorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern436 (x2, 
E_RVVM1BImode) != 0
              || !
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14158; /* pred_xorrvvm1bi */

        case E_V1BImode:
          if (pattern436 (x2, 
E_V1BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14161; /* pred_xorv1bi */

        case E_V2BImode:
          if (pattern436 (x2, 
E_V2BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14164; /* pred_xorv2bi */

        case E_V4BImode:
          if (pattern436 (x2, 
E_V4BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14167; /* pred_xorv4bi */

        case E_V8BImode:
          if (pattern436 (x2, 
E_V8BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14170; /* pred_xorv8bi */

        case E_V16BImode:
          if (pattern436 (x2, 
E_V16BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14173; /* pred_xorv16bi */

        case E_V32BImode:
          if (pattern436 (x2, 
E_V32BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14176; /* pred_xorv32bi */

        case E_V64BImode:
          if (pattern436 (x2, 
E_V64BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14179; /* pred_xorv64bi */

        case E_V128BImode:
          if (pattern436 (x2, 
E_V128BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14182; /* pred_xorv128bi */

        case E_V256BImode:
          if (pattern436 (x2, 
E_V256BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14185; /* pred_xorv256bi */

        case E_V512BImode:
          if (pattern436 (x2, 
E_V512BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14188; /* pred_xorv512bi */

        case E_V1024BImode:
          if (pattern436 (x2, 
E_V1024BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14191; /* pred_xorv1024bi */

        case E_V2048BImode:
          if (pattern436 (x2, 
E_V2048BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14194; /* pred_xorv2048bi */

        case E_V4096BImode:
          if (pattern436 (x2, 
E_V4096BImode) != 0
              || !(
#line 6007 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14197; /* pred_xorv4096bi */

        default:
          return -1;
        }

    case NOT:
      return recog_395 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8DFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 4331; /* *pred_broadcastv8df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8DFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4453; /* *pred_broadcastv8df_imm */
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024SFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 4327; /* *pred_broadcastv1024sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024SFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4449; /* *pred_broadcastv1024sf_imm */
}

 int
recog_413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64SFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 4323; /* *pred_broadcastv64sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64SFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4445; /* *pred_broadcastv64sf_imm */
}

 int
recog_417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4SFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4319; /* *pred_broadcastv4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4SFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4441; /* *pred_broadcastv4sf_imm */
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return 4315; /* *pred_broadcastv1024hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4437; /* *pred_broadcastv1024hf_imm */
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64HFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return 4311; /* *pred_broadcastv64hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64HFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4433; /* *pred_broadcastv64hf_imm */
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4307; /* *pred_broadcastv4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4429; /* *pred_broadcastv4hf_imm */
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256DImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 4303; /* *pred_broadcastv256di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256DImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4425; /* *pred_broadcastv256di_imm */
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16DImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 4299; /* *pred_broadcastv16di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16DImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4421; /* *pred_broadcastv16di_imm */
}

 int
recog_442 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024SImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 4294; /* *pred_broadcastv1024si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024SImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4416; /* *pred_broadcastv1024si_imm */
}

 int
recog_447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32SImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 4289; /* *pred_broadcastv32si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32SImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4411; /* *pred_broadcastv32si_imm */
}

 int
recog_454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 4282; /* *pred_broadcastv1024hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4404; /* *pred_broadcastv1024hi_imm */
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8HImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 4275; /* *pred_broadcastv8hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8HImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 4397; /* *pred_broadcastv8hi_imm */
}

 int
recog_469 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256QImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 4267; /* *pred_broadcastv256qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256QImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4389; /* *pred_broadcastv256qi_imm */
}

 int
recog_477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1QImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 4259; /* *pred_broadcastv1qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1QImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 4381; /* *pred_broadcastv1qi_imm */
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM4SFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4251; /* *pred_broadcastrvvm4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4373; /* *pred_broadcastrvvm4sf_imm */
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4460; /* pred_strided_loadrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4461; /* pred_strided_loadrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4462; /* pred_strided_loadrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4463; /* pred_strided_loadrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4464; /* pred_strided_loadrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4465; /* pred_strided_loadrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4466; /* pred_strided_loadrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4467; /* pred_strided_loadrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4468; /* pred_strided_loadrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4469; /* pred_strided_loadrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4470; /* pred_strided_loadrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4471; /* pred_strided_loadrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4472; /* pred_strided_loadrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4473; /* pred_strided_loadrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4474; /* pred_strided_loadrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4475; /* pred_strided_loadrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4476; /* pred_strided_loadrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4477; /* pred_strided_loadrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4478; /* pred_strided_loadrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4479; /* pred_strided_loadrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4480; /* pred_strided_loadrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4481; /* pred_strided_loadrvvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4482; /* pred_strided_loadrvvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4483; /* pred_strided_loadrvvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4484; /* pred_strided_loadrvvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4485; /* pred_strided_loadrvvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4486; /* pred_strided_loadrvvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4487; /* pred_strided_loadrvvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4488; /* pred_strided_loadrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4489; /* pred_strided_loadrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4490; /* pred_strided_loadrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4491; /* pred_strided_loadrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4492; /* pred_strided_loadrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4493; /* pred_strided_loadrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4494; /* pred_strided_loadrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4495; /* pred_strided_loadrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4496; /* pred_strided_loadrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4497; /* pred_strided_loadrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 4498; /* pred_strided_loadrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4499; /* pred_strided_loadrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4500; /* pred_strided_loadrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4501; /* pred_strided_loadrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4502; /* pred_strided_loadrvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4503; /* pred_strided_loadv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4504; /* pred_strided_loadv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4505; /* pred_strided_loadv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4506; /* pred_strided_loadv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4507; /* pred_strided_loadv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4508; /* pred_strided_loadv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4509; /* pred_strided_loadv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4510; /* pred_strided_loadv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4511; /* pred_strided_loadv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4512; /* pred_strided_loadv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4513; /* pred_strided_loadv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4514; /* pred_strided_loadv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern712 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4515; /* pred_strided_loadv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4516; /* pred_strided_loadv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4517; /* pred_strided_loadv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4518; /* pred_strided_loadv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4519; /* pred_strided_loadv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4520; /* pred_strided_loadv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4521; /* pred_strided_loadv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4522; /* pred_strided_loadv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4523; /* pred_strided_loadv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4524; /* pred_strided_loadv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4525; /* pred_strided_loadv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4526; /* pred_strided_loadv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4527; /* pred_strided_loadv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4528; /* pred_strided_loadv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4529; /* pred_strided_loadv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4530; /* pred_strided_loadv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4531; /* pred_strided_loadv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4532; /* pred_strided_loadv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4533; /* pred_strided_loadv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4534; /* pred_strided_loadv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4535; /* pred_strided_loadv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4536; /* pred_strided_loadv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4537; /* pred_strided_loadv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4538; /* pred_strided_loadv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4539; /* pred_strided_loadv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4540; /* pred_strided_loadv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4541; /* pred_strided_loadv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4542; /* pred_strided_loadv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4543; /* pred_strided_loadv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4544; /* pred_strided_loadv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4545; /* pred_strided_loadv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4546; /* pred_strided_loadv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4547; /* pred_strided_loadv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4548; /* pred_strided_loadv512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4549; /* pred_strided_loadv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4550; /* pred_strided_loadv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4551; /* pred_strided_loadv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4552; /* pred_strided_loadv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4553; /* pred_strided_loadv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4554; /* pred_strided_loadv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4555; /* pred_strided_loadv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4556; /* pred_strided_loadv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4557; /* pred_strided_loadv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4558; /* pred_strided_loadv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4559; /* pred_strided_loadv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern713 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4560; /* pred_strided_loadv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4561; /* pred_strided_loadv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4562; /* pred_strided_loadv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4563; /* pred_strided_loadv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4564; /* pred_strided_loadv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4565; /* pred_strided_loadv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4566; /* pred_strided_loadv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4567; /* pred_strided_loadv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4568; /* pred_strided_loadv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4569; /* pred_strided_loadv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4570; /* pred_strided_loadv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern714 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4571; /* pred_strided_loadv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4572; /* pred_strided_loadv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4573; /* pred_strided_loadv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4574; /* pred_strided_loadv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4575; /* pred_strided_loadv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4576; /* pred_strided_loadv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4577; /* pred_strided_loadv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4578; /* pred_strided_loadv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4579; /* pred_strided_loadv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4580; /* pred_strided_loadv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern715 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2387 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4581; /* pred_strided_loadv512df */

    default:
      return -1;
    }
}

 int
recog_586 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern558 (x2))
    {
    case 0:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15017; /* pred_copysignrvvm8hf */

    case 1:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15019; /* pred_copysignrvvm4hf */

    case 2:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15021; /* pred_copysignrvvm2hf */

    case 3:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15023; /* pred_copysignrvvm1hf */

    case 4:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15025; /* pred_copysignrvvmf2hf */

    case 5:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15027; /* pred_copysignrvvmf4hf */

    case 6:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15029; /* pred_copysignrvvm8sf */

    case 7:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15031; /* pred_copysignrvvm4sf */

    case 8:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15033; /* pred_copysignrvvm2sf */

    case 9:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15035; /* pred_copysignrvvm1sf */

    case 10:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15037; /* pred_copysignrvvmf2sf */

    case 11:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15039; /* pred_copysignrvvm8df */

    case 12:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15041; /* pred_copysignrvvm4df */

    case 13:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15043; /* pred_copysignrvvm2df */

    case 14:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15045; /* pred_copysignrvvm1df */

    case 15:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15047; /* pred_copysignv1hf */

    case 16:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15049; /* pred_copysignv2hf */

    case 17:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15051; /* pred_copysignv4hf */

    case 18:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15053; /* pred_copysignv8hf */

    case 19:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15055; /* pred_copysignv16hf */

    case 20:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15057; /* pred_copysignv32hf */

    case 21:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15059; /* pred_copysignv64hf */

    case 22:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15061; /* pred_copysignv128hf */

    case 23:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15063; /* pred_copysignv256hf */

    case 24:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15065; /* pred_copysignv512hf */

    case 25:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15067; /* pred_copysignv1024hf */

    case 26:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15069; /* pred_copysignv2048hf */

    case 27:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15071; /* pred_copysignv1sf */

    case 28:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15073; /* pred_copysignv2sf */

    case 29:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15075; /* pred_copysignv4sf */

    case 30:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15077; /* pred_copysignv8sf */

    case 31:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15079; /* pred_copysignv16sf */

    case 32:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15081; /* pred_copysignv32sf */

    case 33:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15083; /* pred_copysignv64sf */

    case 34:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15085; /* pred_copysignv128sf */

    case 35:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15087; /* pred_copysignv256sf */

    case 36:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15089; /* pred_copysignv512sf */

    case 37:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15091; /* pred_copysignv1024sf */

    case 38:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15093; /* pred_copysignv1df */

    case 39:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15095; /* pred_copysignv2df */

    case 40:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15097; /* pred_copysignv4df */

    case 41:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15099; /* pred_copysignv8df */

    case 42:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15101; /* pred_copysignv16df */

    case 43:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15103; /* pred_copysignv32df */

    case 44:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15105; /* pred_copysignv64df */

    case 45:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15107; /* pred_copysignv128df */

    case 46:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15109; /* pred_copysignv256df */

    case 47:
      if (!(
#line 6372 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15111; /* pred_copysignv512df */

    case 48:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15128; /* pred_copysignrvvm8hf_scalar */

    case 49:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15130; /* pred_copysignrvvm4hf_scalar */

    case 50:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15132; /* pred_copysignrvvm2hf_scalar */

    case 51:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15134; /* pred_copysignrvvm1hf_scalar */

    case 52:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15136; /* pred_copysignrvvmf2hf_scalar */

    case 53:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15138; /* pred_copysignrvvmf4hf_scalar */

    case 54:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15140; /* pred_copysignrvvm8sf_scalar */

    case 55:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15142; /* pred_copysignrvvm4sf_scalar */

    case 56:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15144; /* pred_copysignrvvm2sf_scalar */

    case 57:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15146; /* pred_copysignrvvm1sf_scalar */

    case 58:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15148; /* pred_copysignrvvmf2sf_scalar */

    case 59:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15150; /* pred_copysignrvvm8df_scalar */

    case 60:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15152; /* pred_copysignrvvm4df_scalar */

    case 61:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15154; /* pred_copysignrvvm2df_scalar */

    case 62:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15156; /* pred_copysignrvvm1df_scalar */

    case 63:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15158; /* pred_copysignv1hf_scalar */

    case 64:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15160; /* pred_copysignv2hf_scalar */

    case 65:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15162; /* pred_copysignv4hf_scalar */

    case 66:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15164; /* pred_copysignv8hf_scalar */

    case 67:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15166; /* pred_copysignv16hf_scalar */

    case 68:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15168; /* pred_copysignv32hf_scalar */

    case 69:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15170; /* pred_copysignv64hf_scalar */

    case 70:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15172; /* pred_copysignv128hf_scalar */

    case 71:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15174; /* pred_copysignv256hf_scalar */

    case 72:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15176; /* pred_copysignv512hf_scalar */

    case 73:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15178; /* pred_copysignv1024hf_scalar */

    case 74:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15180; /* pred_copysignv2048hf_scalar */

    case 75:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15182; /* pred_copysignv1sf_scalar */

    case 76:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15184; /* pred_copysignv2sf_scalar */

    case 77:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15186; /* pred_copysignv4sf_scalar */

    case 78:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15188; /* pred_copysignv8sf_scalar */

    case 79:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15190; /* pred_copysignv16sf_scalar */

    case 80:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15192; /* pred_copysignv32sf_scalar */

    case 81:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15194; /* pred_copysignv64sf_scalar */

    case 82:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15196; /* pred_copysignv128sf_scalar */

    case 83:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15198; /* pred_copysignv256sf_scalar */

    case 84:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15200; /* pred_copysignv512sf_scalar */

    case 85:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15202; /* pred_copysignv1024sf_scalar */

    case 86:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15204; /* pred_copysignv1df_scalar */

    case 87:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15206; /* pred_copysignv2df_scalar */

    case 88:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15208; /* pred_copysignv4df_scalar */

    case 89:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15210; /* pred_copysignv8df_scalar */

    case 90:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15212; /* pred_copysignv16df_scalar */

    case 91:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15214; /* pred_copysignv32df_scalar */

    case 92:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15216; /* pred_copysignv64df_scalar */

    case 93:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15218; /* pred_copysignv128df_scalar */

    case 94:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15220; /* pred_copysignv256df_scalar */

    case 95:
      if (!(
#line 6414 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15222; /* pred_copysignv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_625 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024QImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13098; /* *pred_mul_plusv1024qi_undef */
}

 int
recog_630 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4HImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13103; /* *pred_mul_plusv4hi_undef */
}

 int
recog_635 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128HImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13108; /* *pred_mul_plusv128hi_undef */
}

 int
recog_640 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1SImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13113; /* *pred_mul_plusv1si_undef */
}

 int
recog_646 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64SImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13119; /* *pred_mul_plusv64si_undef */
}

 int
recog_652 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2DImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13125; /* *pred_mul_plusv2di_undef */
}

 int
recog_658 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128DImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13131; /* *pred_mul_plusv128di_undef */
}

 int
recog_664 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_657 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13198; /* *pred_maddv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13266; /* *pred_maccv64di */
}

 int
recog_669 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_652 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13193; /* *pred_maddv2di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13261; /* *pred_maccv2di */
}

 int
recog_676 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_645 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V32SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13186; /* *pred_maddv32si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13254; /* *pred_maccv32si */
}

 int
recog_684 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_637 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13178; /* *pred_maddv512hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13246; /* *pred_maccv512hi */
}

 int
recog_690 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_631 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 13172; /* *pred_maddv8hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 13240; /* *pred_maccv8hi */
}

 int
recog_697 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_624 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13165; /* *pred_maddv512qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13233; /* *pred_maccv512qi */
}

 int
recog_704 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13334; /* *pred_maddv64di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13402; /* *pred_maccv64di_scalar */
}

 int
recog_711 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13327; /* *pred_maddv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13395; /* *pred_maccv1024si_scalar */
}

 int
recog_718 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13320; /* *pred_maddv8si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13388; /* *pred_maccv8si_scalar */
}

 int
recog_725 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13313; /* *pred_maddv256hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13381; /* *pred_maccv256hi_scalar */
}

 int
recog_732 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_593 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13134; /* *pred_maddrvvm8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13202; /* *pred_maccrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_594 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13135; /* *pred_maddrvvm4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13203; /* *pred_maccrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_595 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13136; /* *pred_maddrvvm2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13204; /* *pred_maccrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_596 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13137; /* *pred_maddrvvm1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13205; /* *pred_maccrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_597 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13138; /* *pred_maddrvvm8hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13206; /* *pred_maccrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_598 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13139; /* *pred_maddrvvm4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13207; /* *pred_maccrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_599 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13140; /* *pred_maddrvvm2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13208; /* *pred_maccrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_600 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13141; /* *pred_maddrvvm1hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13209; /* *pred_maccrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_601 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13142; /* *pred_maddrvvm8si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13210; /* *pred_maccrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_602 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13143; /* *pred_maddrvvm4si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13211; /* *pred_maccrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_603 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13144; /* *pred_maddrvvm2si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13212; /* *pred_maccrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_604 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13145; /* *pred_maddrvvm1si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13213; /* *pred_maccrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_605 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13146; /* *pred_maddrvvm8di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13214; /* *pred_maccrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_606 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM4DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM4DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13147; /* *pred_maddrvvm4di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13215; /* *pred_maccrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_607 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM2DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13148; /* *pred_maddrvvm2di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13216; /* *pred_maccrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_608 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVM1DImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13149; /* *pred_maddrvvm1di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13217; /* *pred_maccrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_609 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13150; /* *pred_maddrvvmf2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13218; /* *pred_maccrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_610 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13151; /* *pred_maddrvvmf4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13219; /* *pred_maccrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_611 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13152; /* *pred_maddrvvmf8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13220; /* *pred_maccrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_612 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13153; /* *pred_maddrvvmf2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13221; /* *pred_maccrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_613 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13154; /* *pred_maddrvvmf4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13222; /* *pred_maccrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_614 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_RVVMF2SImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13155; /* *pred_maddrvvmf2si */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13223; /* *pred_maccrvvmf2si */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_615 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V1QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 13156; /* *pred_maddv1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 13224; /* *pred_maccv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_616 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V2QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 13157; /* *pred_maddv2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 13225; /* *pred_maccv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_617 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V4QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 13158; /* *pred_maddv4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 13226; /* *pred_maccv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_618 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 13159; /* *pred_maddv8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 13227; /* *pred_maccv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_619 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V16QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 13160; /* *pred_maddv16qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 13228; /* *pred_maccv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      res = recog_620 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      if (!register_operand (operands[3], E_V32QImode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      if (!register_operand (operands[4], E_V32QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 13161; /* *pred_maddv32qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 13229; /* *pred_maccv32qi */

    case E_V64QImode:
      return recog_700 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_699 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_698 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_697 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_696 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_695 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_694 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_693 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_692 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_691 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_690 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_689 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_688 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_687 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_686 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_685 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_684 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_683 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_682 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_681 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_680 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_679 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_678 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_677 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_676 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_675 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_674 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_673 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_672 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_671 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_670 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_669 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_668 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_667 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_666 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_665 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_664 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_663 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_662 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_661 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_745 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V8DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 13495; /* *pred_minus_mulv8di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V8DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 13563; /* *pred_nmsubv8di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13631; /* *pred_nmsacv8di */
}

 int
recog_747 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V2DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13493; /* *pred_minus_mulv2di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13561; /* *pred_nmsubv2di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13629; /* *pred_nmsacv2di */
}

 int
recog_749 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V1024SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13491; /* *pred_minus_mulv1024si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1024SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1024SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13559; /* *pred_nmsubv1024si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13627; /* *pred_nmsacv1024si */
}

 int
recog_752 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V128SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13488; /* *pred_minus_mulv128si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13556; /* *pred_nmsubv128si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13624; /* *pred_nmsacv128si */
}

 int
recog_755 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V16SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13485; /* *pred_minus_mulv16si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13553; /* *pred_nmsubv16si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13621; /* *pred_nmsacv16si */
}

 int
recog_759 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V1SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 13481; /* *pred_minus_mulv1si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 13549; /* *pred_nmsubv1si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13617; /* *pred_nmsacv1si */
}

 int
recog_765 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V64HImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13475; /* *pred_minus_mulv64hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13543; /* *pred_nmsubv64hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13611; /* *pred_nmsacv64hi */
}

 int
recog_771 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V1HImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 13469; /* *pred_minus_mulv1hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 13537; /* *pred_nmsubv1hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 13605; /* *pred_nmsacv1hi */
}

 int
recog_779 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V32QImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 13461; /* *pred_minus_mulv32qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return 13529; /* *pred_nmsubv32qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 13597; /* *pred_nmsacv32qi */
}

 int
recog_786 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_RVVMF4HImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13454; /* *pred_minus_mulrvvmf4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13522; /* *pred_nmsubrvvmf4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13590; /* *pred_nmsacrvvmf4hi */
}

 int
recog_799 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13694; /* *pred_nmsubv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13762; /* *pred_nmsacv512si_scalar */
}

 int
recog_807 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13686; /* *pred_nmsubv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13754; /* *pred_nmsacv2si_scalar */
}

 int
recog_815 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13678; /* *pred_nmsubv32hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13746; /* *pred_nmsacv32hi_scalar */
}

 int
recog_823 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern531 (x2, 
SIGN_EXTEND))
    {
    case 0:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9288; /* pred_dual_widen_subsrvvm8hi */

    case 1:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9294; /* pred_dual_widen_subsrvvm4hi */

    case 2:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9300; /* pred_dual_widen_subsrvvm2hi */

    case 3:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9306; /* pred_dual_widen_subsrvvm1hi */

    case 4:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9312; /* pred_dual_widen_subsrvvmf2hi */

    case 5:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9318; /* pred_dual_widen_subsrvvmf4hi */

    case 6:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9324; /* pred_dual_widen_subsrvvm8si */

    case 7:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9330; /* pred_dual_widen_subsrvvm4si */

    case 8:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9336; /* pred_dual_widen_subsrvvm2si */

    case 9:
      if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9342; /* pred_dual_widen_subsrvvm1si */

    case 10:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9348; /* pred_dual_widen_subsrvvmf2si */

    case 11:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9354; /* pred_dual_widen_subsrvvm8di */

    case 12:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9360; /* pred_dual_widen_subsrvvm4di */

    case 13:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9366; /* pred_dual_widen_subsrvvm2di */

    case 14:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9372; /* pred_dual_widen_subsrvvm1di */

    case 15:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9378; /* pred_dual_widen_subsv1hi */

    case 16:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9384; /* pred_dual_widen_subsv2hi */

    case 17:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9390; /* pred_dual_widen_subsv4hi */

    case 18:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9396; /* pred_dual_widen_subsv8hi */

    case 19:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9402; /* pred_dual_widen_subsv16hi */

    case 20:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9408; /* pred_dual_widen_subsv32hi */

    case 21:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9414; /* pred_dual_widen_subsv64hi */

    case 22:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9420; /* pred_dual_widen_subsv128hi */

    case 23:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9426; /* pred_dual_widen_subsv256hi */

    case 24:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9432; /* pred_dual_widen_subsv512hi */

    case 25:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9438; /* pred_dual_widen_subsv1024hi */

    case 26:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9444; /* pred_dual_widen_subsv2048hi */

    case 27:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9450; /* pred_dual_widen_subsv1si */

    case 28:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9456; /* pred_dual_widen_subsv2si */

    case 29:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9462; /* pred_dual_widen_subsv4si */

    case 30:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9468; /* pred_dual_widen_subsv8si */

    case 31:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9474; /* pred_dual_widen_subsv16si */

    case 32:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9480; /* pred_dual_widen_subsv32si */

    case 33:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9486; /* pred_dual_widen_subsv64si */

    case 34:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9492; /* pred_dual_widen_subsv128si */

    case 35:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9498; /* pred_dual_widen_subsv256si */

    case 36:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9504; /* pred_dual_widen_subsv512si */

    case 37:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9510; /* pred_dual_widen_subsv1024si */

    case 38:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9516; /* pred_dual_widen_subsv1di */

    case 39:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9522; /* pred_dual_widen_subsv2di */

    case 40:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9528; /* pred_dual_widen_subsv4di */

    case 41:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9534; /* pred_dual_widen_subsv8di */

    case 42:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9540; /* pred_dual_widen_subsv16di */

    case 43:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9546; /* pred_dual_widen_subsv32di */

    case 44:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9552; /* pred_dual_widen_subsv64di */

    case 45:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9558; /* pred_dual_widen_subsv128di */

    case 46:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9564; /* pred_dual_widen_subsv256di */

    case 47:
      if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9570; /* pred_dual_widen_subsv512di */

    case 48:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9576; /* pred_dual_widen_subsrvvm8hi_scalar */

    case 49:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9582; /* pred_dual_widen_subsrvvm4hi_scalar */

    case 50:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9588; /* pred_dual_widen_subsrvvm2hi_scalar */

    case 51:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9594; /* pred_dual_widen_subsrvvm1hi_scalar */

    case 52:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9600; /* pred_dual_widen_subsrvvmf2hi_scalar */

    case 53:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9606; /* pred_dual_widen_subsrvvmf4hi_scalar */

    case 54:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9612; /* pred_dual_widen_subsrvvm8si_scalar */

    case 55:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9618; /* pred_dual_widen_subsrvvm4si_scalar */

    case 56:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9624; /* pred_dual_widen_subsrvvm2si_scalar */

    case 57:
      if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9630; /* pred_dual_widen_subsrvvm1si_scalar */

    case 58:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9636; /* pred_dual_widen_subsrvvmf2si_scalar */

    case 59:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9642; /* pred_dual_widen_subsrvvm8di_scalar */

    case 60:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9648; /* pred_dual_widen_subsrvvm4di_scalar */

    case 61:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9654; /* pred_dual_widen_subsrvvm2di_scalar */

    case 62:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9660; /* pred_dual_widen_subsrvvm1di_scalar */

    case 63:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9666; /* pred_dual_widen_subsv1hi_scalar */

    case 64:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9672; /* pred_dual_widen_subsv2hi_scalar */

    case 65:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9678; /* pred_dual_widen_subsv4hi_scalar */

    case 66:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9684; /* pred_dual_widen_subsv8hi_scalar */

    case 67:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9690; /* pred_dual_widen_subsv16hi_scalar */

    case 68:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9696; /* pred_dual_widen_subsv32hi_scalar */

    case 69:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9702; /* pred_dual_widen_subsv64hi_scalar */

    case 70:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9708; /* pred_dual_widen_subsv128hi_scalar */

    case 71:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9714; /* pred_dual_widen_subsv256hi_scalar */

    case 72:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9720; /* pred_dual_widen_subsv512hi_scalar */

    case 73:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9726; /* pred_dual_widen_subsv1024hi_scalar */

    case 74:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9732; /* pred_dual_widen_subsv2048hi_scalar */

    case 75:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9738; /* pred_dual_widen_subsv1si_scalar */

    case 76:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9744; /* pred_dual_widen_subsv2si_scalar */

    case 77:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9750; /* pred_dual_widen_subsv4si_scalar */

    case 78:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9756; /* pred_dual_widen_subsv8si_scalar */

    case 79:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9762; /* pred_dual_widen_subsv16si_scalar */

    case 80:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9768; /* pred_dual_widen_subsv32si_scalar */

    case 81:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9774; /* pred_dual_widen_subsv64si_scalar */

    case 82:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9780; /* pred_dual_widen_subsv128si_scalar */

    case 83:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9786; /* pred_dual_widen_subsv256si_scalar */

    case 84:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9792; /* pred_dual_widen_subsv512si_scalar */

    case 85:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9798; /* pred_dual_widen_subsv1024si_scalar */

    case 86:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9804; /* pred_dual_widen_subsv1di_scalar */

    case 87:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9810; /* pred_dual_widen_subsv2di_scalar */

    case 88:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9816; /* pred_dual_widen_subsv4di_scalar */

    case 89:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9822; /* pred_dual_widen_subsv8di_scalar */

    case 90:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9828; /* pred_dual_widen_subsv16di_scalar */

    case 91:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9834; /* pred_dual_widen_subsv32di_scalar */

    case 92:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9840; /* pred_dual_widen_subsv64di_scalar */

    case 93:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9846; /* pred_dual_widen_subsv128di_scalar */

    case 94:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9852; /* pred_dual_widen_subsv256di_scalar */

    case 95:
      if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9858; /* pred_dual_widen_subsv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_826 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512DImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 6626; /* pred_ashlv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6839; /* pred_ashlv512di_scalar */
}

 int
recog_828 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V128DImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 6592; /* pred_ashlv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6833; /* pred_ashlv128di_scalar */
}

 int
recog_830 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32DImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 6558; /* pred_ashlv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 6827; /* pred_ashlv32di_scalar */
}

 int
recog_833 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V4DImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 6507; /* pred_ashlv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 6818; /* pred_ashlv4di_scalar */
}

 int
recog_836 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V1024SImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 6456; /* pred_ashlv1024si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6809; /* pred_ashlv1024si_scalar */
}

 int
recog_839 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V128SImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 6405; /* pred_ashlv128si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6800; /* pred_ashlv128si_scalar */
}

 int
recog_842 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 6354; /* pred_ashlv16si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6791; /* pred_ashlv16si_scalar */
}

 int
recog_847 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2048HImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 6269; /* pred_ashlv2048hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 6776; /* pred_ashlv2048hi_scalar */
}

 int
recog_852 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern489 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V64HImode)
      && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 6184; /* pred_ashlv64hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 6761; /* pred_ashlv64hi_scalar */
}

 int
recog_857 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern668 (x2, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V128SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 31841; /* pred_vwsllv128di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 31889; /* pred_vwsllv128di_scalar */
}

 int
recog_862 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern668 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V4SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 31836; /* pred_vwsllv4di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 31884; /* pred_vwsllv4di_scalar */
}

 int
recog_867 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8966; /* pred_negrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8968; /* pred_negrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8970; /* pred_negrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8972; /* pred_negrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8974; /* pred_negrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8976; /* pred_negrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8978; /* pred_negrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8980; /* pred_negrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8982; /* pred_negrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8984; /* pred_negrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8986; /* pred_negrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8988; /* pred_negrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8990; /* pred_negrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8992; /* pred_negrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8994; /* pred_negrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8996; /* pred_negrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 8998; /* pred_negrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9000; /* pred_negrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9002; /* pred_negrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9004; /* pred_negrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9006; /* pred_negrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9008; /* pred_negrvvmf2si */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 9010; /* pred_negv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 9012; /* pred_negv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 9014; /* pred_negv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 9016; /* pred_negv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 9018; /* pred_negv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 9020; /* pred_negv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9022; /* pred_negv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9024; /* pred_negv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9026; /* pred_negv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9028; /* pred_negv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9030; /* pred_negv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9032; /* pred_negv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9034; /* pred_negv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9036; /* pred_negv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9038; /* pred_negv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9040; /* pred_negv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9042; /* pred_negv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9044; /* pred_negv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9046; /* pred_negv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9048; /* pred_negv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9050; /* pred_negv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9052; /* pred_negv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9054; /* pred_negv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9056; /* pred_negv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9058; /* pred_negv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9060; /* pred_negv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9062; /* pred_negv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9064; /* pred_negv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9066; /* pred_negv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9068; /* pred_negv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9070; /* pred_negv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9072; /* pred_negv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9074; /* pred_negv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9076; /* pred_negv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9078; /* pred_negv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9080; /* pred_negv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9082; /* pred_negv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9084; /* pred_negv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9086; /* pred_negv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9088; /* pred_negv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9090; /* pred_negv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9092; /* pred_negv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9094; /* pred_negv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9096; /* pred_negv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9098; /* pred_negv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 3905 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9100; /* pred_negv512di */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16247; /* pred_negrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16249; /* pred_negrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16251; /* pred_negrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16253; /* pred_negrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16255; /* pred_negrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16257; /* pred_negrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16259; /* pred_negrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16261; /* pred_negrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16263; /* pred_negrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16265; /* pred_negrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16267; /* pred_negrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16269; /* pred_negrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16271; /* pred_negrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16273; /* pred_negrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16275; /* pred_negrvvm1df */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16277; /* pred_negv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16279; /* pred_negv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16281; /* pred_negv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16283; /* pred_negv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16285; /* pred_negv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16287; /* pred_negv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16289; /* pred_negv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16291; /* pred_negv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16293; /* pred_negv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16295; /* pred_negv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16297; /* pred_negv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16299; /* pred_negv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16301; /* pred_negv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16303; /* pred_negv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16305; /* pred_negv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16307; /* pred_negv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16309; /* pred_negv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16311; /* pred_negv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16313; /* pred_negv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16315; /* pred_negv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16317; /* pred_negv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16319; /* pred_negv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16321; /* pred_negv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16323; /* pred_negv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16325; /* pred_negv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16327; /* pred_negv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16329; /* pred_negv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16331; /* pred_negv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16333; /* pred_negv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16335; /* pred_negv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16337; /* pred_negv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16339; /* pred_negv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern489 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 6929 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16341; /* pred_negv512df */

    default:
      return -1;
    }
}

 int
recog_877 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_822 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern485 (x2))
            {
            case 0:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7598; /* pred_subrvvm8qi_reverse_scalar */

            case 1:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7599; /* pred_subrvvm4qi_reverse_scalar */

            case 2:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7600; /* pred_subrvvm2qi_reverse_scalar */

            case 3:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7601; /* pred_subrvvm1qi_reverse_scalar */

            case 4:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7602; /* pred_subrvvmf2qi_reverse_scalar */

            case 5:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7603; /* pred_subrvvmf4qi_reverse_scalar */

            case 6:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 7604; /* pred_subrvvmf8qi_reverse_scalar */

            case 7:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7605; /* pred_subrvvm8hi_reverse_scalar */

            case 8:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7606; /* pred_subrvvm4hi_reverse_scalar */

            case 9:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7607; /* pred_subrvvm2hi_reverse_scalar */

            case 10:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7608; /* pred_subrvvm1hi_reverse_scalar */

            case 11:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7609; /* pred_subrvvmf2hi_reverse_scalar */

            case 12:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 7610; /* pred_subrvvmf4hi_reverse_scalar */

            case 13:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7611; /* pred_subrvvm8si_reverse_scalar */

            case 14:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7612; /* pred_subrvvm4si_reverse_scalar */

            case 15:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7613; /* pred_subrvvm2si_reverse_scalar */

            case 16:
              if (!
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7614; /* pred_subrvvm1si_reverse_scalar */

            case 17:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 7615; /* pred_subrvvmf2si_reverse_scalar */

            case 18:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7616; /* pred_subv1qi_reverse_scalar */

            case 19:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7617; /* pred_subv2qi_reverse_scalar */

            case 20:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7618; /* pred_subv4qi_reverse_scalar */

            case 21:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7619; /* pred_subv8qi_reverse_scalar */

            case 22:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7620; /* pred_subv16qi_reverse_scalar */

            case 23:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7621; /* pred_subv32qi_reverse_scalar */

            case 24:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7622; /* pred_subv64qi_reverse_scalar */

            case 25:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7623; /* pred_subv128qi_reverse_scalar */

            case 26:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7624; /* pred_subv256qi_reverse_scalar */

            case 27:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7625; /* pred_subv512qi_reverse_scalar */

            case 28:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7626; /* pred_subv1024qi_reverse_scalar */

            case 29:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7627; /* pred_subv2048qi_reverse_scalar */

            case 30:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7628; /* pred_subv4096qi_reverse_scalar */

            case 31:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7629; /* pred_subv1hi_reverse_scalar */

            case 32:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7630; /* pred_subv2hi_reverse_scalar */

            case 33:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7631; /* pred_subv4hi_reverse_scalar */

            case 34:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7632; /* pred_subv8hi_reverse_scalar */

            case 35:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7633; /* pred_subv16hi_reverse_scalar */

            case 36:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7634; /* pred_subv32hi_reverse_scalar */

            case 37:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7635; /* pred_subv64hi_reverse_scalar */

            case 38:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7636; /* pred_subv128hi_reverse_scalar */

            case 39:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7637; /* pred_subv256hi_reverse_scalar */

            case 40:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7638; /* pred_subv512hi_reverse_scalar */

            case 41:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7639; /* pred_subv1024hi_reverse_scalar */

            case 42:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7640; /* pred_subv2048hi_reverse_scalar */

            case 43:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7641; /* pred_subv1si_reverse_scalar */

            case 44:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7642; /* pred_subv2si_reverse_scalar */

            case 45:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7643; /* pred_subv4si_reverse_scalar */

            case 46:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7644; /* pred_subv8si_reverse_scalar */

            case 47:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7645; /* pred_subv16si_reverse_scalar */

            case 48:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7646; /* pred_subv32si_reverse_scalar */

            case 49:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7647; /* pred_subv64si_reverse_scalar */

            case 50:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7648; /* pred_subv128si_reverse_scalar */

            case 51:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7649; /* pred_subv256si_reverse_scalar */

            case 52:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7650; /* pred_subv512si_reverse_scalar */

            case 53:
              if (!(
#line 2822 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7651; /* pred_subv1024si_reverse_scalar */

            case 54:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8044; /* *pred_subrvvm8di_reverse_scalar */

            case 55:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8045; /* *pred_subrvvm4di_reverse_scalar */

            case 56:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8046; /* *pred_subrvvm2di_reverse_scalar */

            case 57:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8047; /* *pred_subrvvm1di_reverse_scalar */

            case 58:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8048; /* *pred_subv1di_reverse_scalar */

            case 59:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8049; /* *pred_subv2di_reverse_scalar */

            case 60:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8050; /* *pred_subv4di_reverse_scalar */

            case 61:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8051; /* *pred_subv8di_reverse_scalar */

            case 62:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8052; /* *pred_subv16di_reverse_scalar */

            case 63:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8053; /* *pred_subv32di_reverse_scalar */

            case 64:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8054; /* *pred_subv64di_reverse_scalar */

            case 65:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8055; /* *pred_subv128di_reverse_scalar */

            case 66:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8056; /* *pred_subv256di_reverse_scalar */

            case 67:
              if (!(
#line 3030 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8057; /* *pred_subv512di_reverse_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern487 (x2))
            {
            case 0:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8058; /* *pred_subrvvm8di_extended_reverse_scalar */

            case 1:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8059; /* *pred_subrvvm4di_extended_reverse_scalar */

            case 2:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8060; /* *pred_subrvvm2di_extended_reverse_scalar */

            case 3:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8061; /* *pred_subrvvm1di_extended_reverse_scalar */

            case 4:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8062; /* *pred_subv1di_extended_reverse_scalar */

            case 5:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8063; /* *pred_subv2di_extended_reverse_scalar */

            case 6:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8064; /* *pred_subv4di_extended_reverse_scalar */

            case 7:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8065; /* *pred_subv8di_extended_reverse_scalar */

            case 8:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8066; /* *pred_subv16di_extended_reverse_scalar */

            case 9:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8067; /* *pred_subv32di_extended_reverse_scalar */

            case 10:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8068; /* *pred_subv64di_extended_reverse_scalar */

            case 11:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8069; /* *pred_subv128di_extended_reverse_scalar */

            case 12:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8070; /* *pred_subv256di_extended_reverse_scalar */

            case 13:
              if (!(
#line 3052 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8071; /* *pred_subv512di_extended_reverse_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_823 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern531 (x2, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9289; /* pred_dual_widen_suburvvm8hi */

        case 1:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9295; /* pred_dual_widen_suburvvm4hi */

        case 2:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9301; /* pred_dual_widen_suburvvm2hi */

        case 3:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9307; /* pred_dual_widen_suburvvm1hi */

        case 4:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9313; /* pred_dual_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9319; /* pred_dual_widen_suburvvmf4hi */

        case 6:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9325; /* pred_dual_widen_suburvvm8si */

        case 7:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9331; /* pred_dual_widen_suburvvm4si */

        case 8:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9337; /* pred_dual_widen_suburvvm2si */

        case 9:
          if (!
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9343; /* pred_dual_widen_suburvvm1si */

        case 10:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9349; /* pred_dual_widen_suburvvmf2si */

        case 11:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9355; /* pred_dual_widen_suburvvm8di */

        case 12:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9361; /* pred_dual_widen_suburvvm4di */

        case 13:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9367; /* pred_dual_widen_suburvvm2di */

        case 14:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9373; /* pred_dual_widen_suburvvm1di */

        case 15:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9379; /* pred_dual_widen_subuv1hi */

        case 16:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9385; /* pred_dual_widen_subuv2hi */

        case 17:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9391; /* pred_dual_widen_subuv4hi */

        case 18:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9397; /* pred_dual_widen_subuv8hi */

        case 19:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9403; /* pred_dual_widen_subuv16hi */

        case 20:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9409; /* pred_dual_widen_subuv32hi */

        case 21:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9415; /* pred_dual_widen_subuv64hi */

        case 22:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9421; /* pred_dual_widen_subuv128hi */

        case 23:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9427; /* pred_dual_widen_subuv256hi */

        case 24:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9433; /* pred_dual_widen_subuv512hi */

        case 25:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9439; /* pred_dual_widen_subuv1024hi */

        case 26:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9445; /* pred_dual_widen_subuv2048hi */

        case 27:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9451; /* pred_dual_widen_subuv1si */

        case 28:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9457; /* pred_dual_widen_subuv2si */

        case 29:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9463; /* pred_dual_widen_subuv4si */

        case 30:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9469; /* pred_dual_widen_subuv8si */

        case 31:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9475; /* pred_dual_widen_subuv16si */

        case 32:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9481; /* pred_dual_widen_subuv32si */

        case 33:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9487; /* pred_dual_widen_subuv64si */

        case 34:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9493; /* pred_dual_widen_subuv128si */

        case 35:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9499; /* pred_dual_widen_subuv256si */

        case 36:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9505; /* pred_dual_widen_subuv512si */

        case 37:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9511; /* pred_dual_widen_subuv1024si */

        case 38:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9517; /* pred_dual_widen_subuv1di */

        case 39:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9523; /* pred_dual_widen_subuv2di */

        case 40:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9529; /* pred_dual_widen_subuv4di */

        case 41:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9535; /* pred_dual_widen_subuv8di */

        case 42:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9541; /* pred_dual_widen_subuv16di */

        case 43:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9547; /* pred_dual_widen_subuv32di */

        case 44:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9553; /* pred_dual_widen_subuv64di */

        case 45:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9559; /* pred_dual_widen_subuv128di */

        case 46:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9565; /* pred_dual_widen_subuv256di */

        case 47:
          if (!(
#line 4001 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9571; /* pred_dual_widen_subuv512di */

        case 48:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9577; /* pred_dual_widen_suburvvm8hi_scalar */

        case 49:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9583; /* pred_dual_widen_suburvvm4hi_scalar */

        case 50:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9589; /* pred_dual_widen_suburvvm2hi_scalar */

        case 51:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9595; /* pred_dual_widen_suburvvm1hi_scalar */

        case 52:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9601; /* pred_dual_widen_suburvvmf2hi_scalar */

        case 53:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9607; /* pred_dual_widen_suburvvmf4hi_scalar */

        case 54:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9613; /* pred_dual_widen_suburvvm8si_scalar */

        case 55:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9619; /* pred_dual_widen_suburvvm4si_scalar */

        case 56:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9625; /* pred_dual_widen_suburvvm2si_scalar */

        case 57:
          if (!
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9631; /* pred_dual_widen_suburvvm1si_scalar */

        case 58:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9637; /* pred_dual_widen_suburvvmf2si_scalar */

        case 59:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9643; /* pred_dual_widen_suburvvm8di_scalar */

        case 60:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9649; /* pred_dual_widen_suburvvm4di_scalar */

        case 61:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9655; /* pred_dual_widen_suburvvm2di_scalar */

        case 62:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9661; /* pred_dual_widen_suburvvm1di_scalar */

        case 63:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9667; /* pred_dual_widen_subuv1hi_scalar */

        case 64:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9673; /* pred_dual_widen_subuv2hi_scalar */

        case 65:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9679; /* pred_dual_widen_subuv4hi_scalar */

        case 66:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9685; /* pred_dual_widen_subuv8hi_scalar */

        case 67:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9691; /* pred_dual_widen_subuv16hi_scalar */

        case 68:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9697; /* pred_dual_widen_subuv32hi_scalar */

        case 69:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9703; /* pred_dual_widen_subuv64hi_scalar */

        case 70:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9709; /* pred_dual_widen_subuv128hi_scalar */

        case 71:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9715; /* pred_dual_widen_subuv256hi_scalar */

        case 72:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9721; /* pred_dual_widen_subuv512hi_scalar */

        case 73:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9727; /* pred_dual_widen_subuv1024hi_scalar */

        case 74:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9733; /* pred_dual_widen_subuv2048hi_scalar */

        case 75:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9739; /* pred_dual_widen_subuv1si_scalar */

        case 76:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9745; /* pred_dual_widen_subuv2si_scalar */

        case 77:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9751; /* pred_dual_widen_subuv4si_scalar */

        case 78:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9757; /* pred_dual_widen_subuv8si_scalar */

        case 79:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9763; /* pred_dual_widen_subuv16si_scalar */

        case 80:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9769; /* pred_dual_widen_subuv32si_scalar */

        case 81:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9775; /* pred_dual_widen_subuv64si_scalar */

        case 82:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9781; /* pred_dual_widen_subuv128si_scalar */

        case 83:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9787; /* pred_dual_widen_subuv256si_scalar */

        case 84:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9793; /* pred_dual_widen_subuv512si_scalar */

        case 85:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9799; /* pred_dual_widen_subuv1024si_scalar */

        case 86:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9805; /* pred_dual_widen_subuv1di_scalar */

        case 87:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9811; /* pred_dual_widen_subuv2di_scalar */

        case 88:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9817; /* pred_dual_widen_subuv4di_scalar */

        case 89:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9823; /* pred_dual_widen_subuv8di_scalar */

        case 90:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9829; /* pred_dual_widen_subuv16di_scalar */

        case 91:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9835; /* pred_dual_widen_subuv32di_scalar */

        case 92:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9841; /* pred_dual_widen_subuv64di_scalar */

        case 93:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9847; /* pred_dual_widen_subuv128di_scalar */

        case 94:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9853; /* pred_dual_widen_subuv256di_scalar */

        case 95:
          if (!(
#line 4024 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9859; /* pred_dual_widen_subuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_889 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern488 (x2))
    {
    case 0:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5485; /* pred_iorrvvm8qi */

    case 1:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5502; /* pred_iorrvvm4qi */

    case 2:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5519; /* pred_iorrvvm2qi */

    case 3:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5536; /* pred_iorrvvm1qi */

    case 4:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5553; /* pred_iorrvvm8hi */

    case 5:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5570; /* pred_iorrvvm4hi */

    case 6:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5587; /* pred_iorrvvm2hi */

    case 7:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5604; /* pred_iorrvvm1hi */

    case 8:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5621; /* pred_iorrvvm8si */

    case 9:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5638; /* pred_iorrvvm4si */

    case 10:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5655; /* pred_iorrvvm2si */

    case 11:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5672; /* pred_iorrvvm1si */

    case 12:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5689; /* pred_iorrvvm8di */

    case 13:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5706; /* pred_iorrvvm4di */

    case 14:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5723; /* pred_iorrvvm2di */

    case 15:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5740; /* pred_iorrvvm1di */

    case 16:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5757; /* pred_iorrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5774; /* pred_iorrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5791; /* pred_iorrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5808; /* pred_iorrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5825; /* pred_iorrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5842; /* pred_iorrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5859; /* pred_iorv1qi */

    case 23:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5876; /* pred_iorv2qi */

    case 24:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5893; /* pred_iorv4qi */

    case 25:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5910; /* pred_iorv8qi */

    case 26:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5927; /* pred_iorv16qi */

    case 27:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5944; /* pred_iorv32qi */

    case 28:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5961; /* pred_iorv64qi */

    case 29:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5978; /* pred_iorv128qi */

    case 30:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 5995; /* pred_iorv256qi */

    case 31:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6012; /* pred_iorv512qi */

    case 32:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6029; /* pred_iorv1024qi */

    case 33:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6046; /* pred_iorv2048qi */

    case 34:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6063; /* pred_iorv4096qi */

    case 35:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6080; /* pred_iorv1hi */

    case 36:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6097; /* pred_iorv2hi */

    case 37:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6114; /* pred_iorv4hi */

    case 38:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6131; /* pred_iorv8hi */

    case 39:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6148; /* pred_iorv16hi */

    case 40:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6165; /* pred_iorv32hi */

    case 41:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6182; /* pred_iorv64hi */

    case 42:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6199; /* pred_iorv128hi */

    case 43:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6216; /* pred_iorv256hi */

    case 44:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6233; /* pred_iorv512hi */

    case 45:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6250; /* pred_iorv1024hi */

    case 46:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6267; /* pred_iorv2048hi */

    case 47:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6284; /* pred_iorv1si */

    case 48:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6301; /* pred_iorv2si */

    case 49:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6318; /* pred_iorv4si */

    case 50:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6335; /* pred_iorv8si */

    case 51:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6352; /* pred_iorv16si */

    case 52:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6369; /* pred_iorv32si */

    case 53:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6386; /* pred_iorv64si */

    case 54:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6403; /* pred_iorv128si */

    case 55:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6420; /* pred_iorv256si */

    case 56:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6437; /* pred_iorv512si */

    case 57:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6454; /* pred_iorv1024si */

    case 58:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6471; /* pred_iorv1di */

    case 59:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6488; /* pred_iorv2di */

    case 60:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6505; /* pred_iorv4di */

    case 61:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6522; /* pred_iorv8di */

    case 62:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6539; /* pred_iorv16di */

    case 63:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6556; /* pred_iorv32di */

    case 64:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6573; /* pred_iorv64di */

    case 65:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6590; /* pred_iorv128di */

    case 66:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6607; /* pred_iorv256di */

    case 67:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6624; /* pred_iorv512di */

    case 68:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6844; /* pred_iorrvvm8qi_scalar */

    case 69:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6853; /* pred_iorrvvm4qi_scalar */

    case 70:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6862; /* pred_iorrvvm2qi_scalar */

    case 71:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6871; /* pred_iorrvvm1qi_scalar */

    case 72:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6880; /* pred_iorrvvmf2qi_scalar */

    case 73:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6889; /* pred_iorrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6898; /* pred_iorrvvmf8qi_scalar */

    case 75:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6907; /* pred_iorrvvm8hi_scalar */

    case 76:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6916; /* pred_iorrvvm4hi_scalar */

    case 77:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6925; /* pred_iorrvvm2hi_scalar */

    case 78:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6934; /* pred_iorrvvm1hi_scalar */

    case 79:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6943; /* pred_iorrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6952; /* pred_iorrvvmf4hi_scalar */

    case 81:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6961; /* pred_iorrvvm8si_scalar */

    case 82:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6970; /* pred_iorrvvm4si_scalar */

    case 83:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6979; /* pred_iorrvvm2si_scalar */

    case 84:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6988; /* pred_iorrvvm1si_scalar */

    case 85:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6997; /* pred_iorrvvmf2si_scalar */

    case 86:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7006; /* pred_iorv1qi_scalar */

    case 87:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7015; /* pred_iorv2qi_scalar */

    case 88:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7024; /* pred_iorv4qi_scalar */

    case 89:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7033; /* pred_iorv8qi_scalar */

    case 90:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7042; /* pred_iorv16qi_scalar */

    case 91:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7051; /* pred_iorv32qi_scalar */

    case 92:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7060; /* pred_iorv64qi_scalar */

    case 93:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7069; /* pred_iorv128qi_scalar */

    case 94:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7078; /* pred_iorv256qi_scalar */

    case 95:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7087; /* pred_iorv512qi_scalar */

    case 96:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7096; /* pred_iorv1024qi_scalar */

    case 97:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7105; /* pred_iorv2048qi_scalar */

    case 98:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7114; /* pred_iorv4096qi_scalar */

    case 99:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7123; /* pred_iorv1hi_scalar */

    case 100:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7132; /* pred_iorv2hi_scalar */

    case 101:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7141; /* pred_iorv4hi_scalar */

    case 102:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7150; /* pred_iorv8hi_scalar */

    case 103:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7159; /* pred_iorv16hi_scalar */

    case 104:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7168; /* pred_iorv32hi_scalar */

    case 105:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7177; /* pred_iorv64hi_scalar */

    case 106:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7186; /* pred_iorv128hi_scalar */

    case 107:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7195; /* pred_iorv256hi_scalar */

    case 108:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7204; /* pred_iorv512hi_scalar */

    case 109:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7213; /* pred_iorv1024hi_scalar */

    case 110:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7222; /* pred_iorv2048hi_scalar */

    case 111:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7231; /* pred_iorv1si_scalar */

    case 112:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7240; /* pred_iorv2si_scalar */

    case 113:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7249; /* pred_iorv4si_scalar */

    case 114:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7258; /* pred_iorv8si_scalar */

    case 115:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7267; /* pred_iorv16si_scalar */

    case 116:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7276; /* pred_iorv32si_scalar */

    case 117:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7285; /* pred_iorv64si_scalar */

    case 118:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7294; /* pred_iorv128si_scalar */

    case 119:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7303; /* pred_iorv256si_scalar */

    case 120:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7312; /* pred_iorv512si_scalar */

    case 121:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7321; /* pred_iorv1024si_scalar */

    case 122:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7654; /* *pred_iorrvvm8di_scalar */

    case 123:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7663; /* *pred_iorrvvm4di_scalar */

    case 124:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7672; /* *pred_iorrvvm2di_scalar */

    case 125:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7681; /* *pred_iorrvvm1di_scalar */

    case 126:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7690; /* *pred_iorv1di_scalar */

    case 127:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7699; /* *pred_iorv2di_scalar */

    case 128:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7708; /* *pred_iorv4di_scalar */

    case 129:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7717; /* *pred_iorv8di_scalar */

    case 130:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7726; /* *pred_iorv16di_scalar */

    case 131:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7735; /* *pred_iorv32di_scalar */

    case 132:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7744; /* *pred_iorv64di_scalar */

    case 133:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7753; /* *pred_iorv128di_scalar */

    case 134:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7762; /* *pred_iorv256di_scalar */

    case 135:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7771; /* *pred_iorv512di_scalar */

    case 136:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7780; /* *pred_iorrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7789; /* *pred_iorrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7798; /* *pred_iorrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7807; /* *pred_iorrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7816; /* *pred_iorv1di_extended_scalar */

    case 141:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7825; /* *pred_iorv2di_extended_scalar */

    case 142:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7834; /* *pred_iorv4di_extended_scalar */

    case 143:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7843; /* *pred_iorv8di_extended_scalar */

    case 144:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7852; /* *pred_iorv16di_extended_scalar */

    case 145:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7861; /* *pred_iorv32di_extended_scalar */

    case 146:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7870; /* *pred_iorv64di_extended_scalar */

    case 147:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7879; /* *pred_iorv128di_extended_scalar */

    case 148:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7888; /* *pred_iorv256di_extended_scalar */

    case 149:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7897; /* *pred_iorv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_901 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern501 (x2))
    {
    case 0:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9102; /* pred_extendrvvm8hi_vf2 */

    case 1:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9104; /* pred_extendrvvm4hi_vf2 */

    case 2:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9106; /* pred_extendrvvm2hi_vf2 */

    case 3:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9108; /* pred_extendrvvm1hi_vf2 */

    case 4:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9110; /* pred_extendrvvmf2hi_vf2 */

    case 5:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9112; /* pred_extendrvvmf4hi_vf2 */

    case 6:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9114; /* pred_extendrvvm8si_vf2 */

    case 7:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9198; /* pred_extendrvvm8si_vf4 */

    case 8:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9116; /* pred_extendrvvm4si_vf2 */

    case 9:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9200; /* pred_extendrvvm4si_vf4 */

    case 10:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9118; /* pred_extendrvvm2si_vf2 */

    case 11:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9202; /* pred_extendrvvm2si_vf4 */

    case 12:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9120; /* pred_extendrvvm1si_vf2 */

    case 13:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9204; /* pred_extendrvvm1si_vf4 */

    case 14:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9122; /* pred_extendrvvmf2si_vf2 */

    case 15:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9206; /* pred_extendrvvmf2si_vf4 */

    case 16:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9124; /* pred_extendrvvm8di_vf2 */

    case 17:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9208; /* pred_extendrvvm8di_vf4 */

    case 18:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9258; /* pred_extendrvvm8di_vf8 */

    case 19:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9126; /* pred_extendrvvm4di_vf2 */

    case 20:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9210; /* pred_extendrvvm4di_vf4 */

    case 21:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9260; /* pred_extendrvvm4di_vf8 */

    case 22:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9128; /* pred_extendrvvm2di_vf2 */

    case 23:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9212; /* pred_extendrvvm2di_vf4 */

    case 24:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9262; /* pred_extendrvvm2di_vf8 */

    case 25:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9130; /* pred_extendrvvm1di_vf2 */

    case 26:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9214; /* pred_extendrvvm1di_vf4 */

    case 27:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9264; /* pred_extendrvvm1di_vf8 */

    case 28:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9132; /* pred_extendv1hi_vf2 */

    case 29:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9134; /* pred_extendv2hi_vf2 */

    case 30:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9136; /* pred_extendv4hi_vf2 */

    case 31:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9138; /* pred_extendv8hi_vf2 */

    case 32:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9140; /* pred_extendv16hi_vf2 */

    case 33:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9142; /* pred_extendv32hi_vf2 */

    case 34:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9144; /* pred_extendv64hi_vf2 */

    case 35:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9146; /* pred_extendv128hi_vf2 */

    case 36:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9148; /* pred_extendv256hi_vf2 */

    case 37:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9150; /* pred_extendv512hi_vf2 */

    case 38:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9152; /* pred_extendv1024hi_vf2 */

    case 39:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9154; /* pred_extendv2048hi_vf2 */

    case 40:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9156; /* pred_extendv1si_vf2 */

    case 41:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9216; /* pred_extendv1si_vf4 */

    case 42:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9158; /* pred_extendv2si_vf2 */

    case 43:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9218; /* pred_extendv2si_vf4 */

    case 44:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9160; /* pred_extendv4si_vf2 */

    case 45:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9220; /* pred_extendv4si_vf4 */

    case 46:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9162; /* pred_extendv8si_vf2 */

    case 47:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9222; /* pred_extendv8si_vf4 */

    case 48:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9164; /* pred_extendv16si_vf2 */

    case 49:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9224; /* pred_extendv16si_vf4 */

    case 50:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9166; /* pred_extendv32si_vf2 */

    case 51:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9226; /* pred_extendv32si_vf4 */

    case 52:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9168; /* pred_extendv64si_vf2 */

    case 53:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9228; /* pred_extendv64si_vf4 */

    case 54:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9170; /* pred_extendv128si_vf2 */

    case 55:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9230; /* pred_extendv128si_vf4 */

    case 56:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9172; /* pred_extendv256si_vf2 */

    case 57:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9232; /* pred_extendv256si_vf4 */

    case 58:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9174; /* pred_extendv512si_vf2 */

    case 59:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9234; /* pred_extendv512si_vf4 */

    case 60:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9176; /* pred_extendv1024si_vf2 */

    case 61:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9236; /* pred_extendv1024si_vf4 */

    case 62:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9178; /* pred_extendv1di_vf2 */

    case 63:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9238; /* pred_extendv1di_vf4 */

    case 64:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9266; /* pred_extendv1di_vf8 */

    case 65:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9180; /* pred_extendv2di_vf2 */

    case 66:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9240; /* pred_extendv2di_vf4 */

    case 67:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9268; /* pred_extendv2di_vf8 */

    case 68:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9182; /* pred_extendv4di_vf2 */

    case 69:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9242; /* pred_extendv4di_vf4 */

    case 70:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9270; /* pred_extendv4di_vf8 */

    case 71:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9184; /* pred_extendv8di_vf2 */

    case 72:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9244; /* pred_extendv8di_vf4 */

    case 73:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9272; /* pred_extendv8di_vf8 */

    case 74:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9186; /* pred_extendv16di_vf2 */

    case 75:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9246; /* pred_extendv16di_vf4 */

    case 76:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9274; /* pred_extendv16di_vf8 */

    case 77:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9188; /* pred_extendv32di_vf2 */

    case 78:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9248; /* pred_extendv32di_vf4 */

    case 79:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9276; /* pred_extendv32di_vf8 */

    case 80:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9190; /* pred_extendv64di_vf2 */

    case 81:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9250; /* pred_extendv64di_vf4 */

    case 82:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9278; /* pred_extendv64di_vf8 */

    case 83:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9192; /* pred_extendv128di_vf2 */

    case 84:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9252; /* pred_extendv128di_vf4 */

    case 85:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9280; /* pred_extendv128di_vf8 */

    case 86:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9194; /* pred_extendv256di_vf2 */

    case 87:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9254; /* pred_extendv256di_vf4 */

    case 88:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9282; /* pred_extendv256di_vf8 */

    case 89:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9196; /* pred_extendv512di_vf2 */

    case 90:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9256; /* pred_extendv512di_vf4 */

    case 91:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9284; /* pred_extendv512di_vf8 */

    default:
      return -1;
    }
}

 int
recog_911 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern470 (x2))
    {
    case 0:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1236; /* *pred_mov_widthbrvvm8qi */

    case 1:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1242; /* *pred_mov_widthbrvvm4qi */

    case 2:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1248; /* *pred_mov_widthbrvvm2qi */

    case 3:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1254; /* *pred_mov_widthbrvvm1qi */

    case 4:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1260; /* *pred_mov_widthbrvvm8hi */

    case 5:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1266; /* *pred_mov_widthbrvvm4hi */

    case 6:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1272; /* *pred_mov_widthbrvvm2hi */

    case 7:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1278; /* *pred_mov_widthbrvvm1hi */

    case 8:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1284; /* *pred_mov_widthbrvvm8si */

    case 9:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1290; /* *pred_mov_widthbrvvm4si */

    case 10:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1296; /* *pred_mov_widthbrvvm2si */

    case 11:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1302; /* *pred_mov_widthbrvvm1si */

    case 12:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1308; /* *pred_mov_widthbrvvm8di */

    case 13:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1314; /* *pred_mov_widthbrvvm4di */

    case 14:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1320; /* *pred_mov_widthbrvvm2di */

    case 15:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1326; /* *pred_mov_widthbrvvm1di */

    case 16:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1332; /* *pred_mov_widthbrvvmf2qi */

    case 17:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1338; /* *pred_mov_widthbrvvmf4qi */

    case 18:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1344; /* *pred_mov_widthbrvvmf8qi */

    case 19:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1350; /* *pred_mov_widthbrvvmf2hi */

    case 20:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1356; /* *pred_mov_widthbrvvmf4hi */

    case 21:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1362; /* *pred_mov_widthbrvvmf2si */

    case 22:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1368; /* *pred_mov_widthbrvvm8bf */

    case 23:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1374; /* *pred_mov_widthbrvvm4bf */

    case 24:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1380; /* *pred_mov_widthbrvvm2bf */

    case 25:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1386; /* *pred_mov_widthbrvvm1bf */

    case 26:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1392; /* *pred_mov_widthbrvvmf2bf */

    case 27:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1398; /* *pred_mov_widthbrvvmf4bf */

    case 28:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1404; /* *pred_mov_widthbrvvm8hf */

    case 29:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1410; /* *pred_mov_widthbrvvm4hf */

    case 30:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1416; /* *pred_mov_widthbrvvm2hf */

    case 31:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1422; /* *pred_mov_widthbrvvm1hf */

    case 32:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1428; /* *pred_mov_widthbrvvmf2hf */

    case 33:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1434; /* *pred_mov_widthbrvvmf4hf */

    case 34:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1440; /* *pred_mov_widthbrvvm8sf */

    case 35:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1446; /* *pred_mov_widthbrvvm4sf */

    case 36:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1452; /* *pred_mov_widthbrvvm2sf */

    case 37:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1458; /* *pred_mov_widthbrvvm1sf */

    case 38:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1464; /* *pred_mov_widthbrvvmf2sf */

    case 39:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1470; /* *pred_mov_widthbrvvm8df */

    case 40:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1476; /* *pred_mov_widthbrvvm4df */

    case 41:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1482; /* *pred_mov_widthbrvvm2df */

    case 42:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1488; /* *pred_mov_widthbrvvm1df */

    case 43:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1494; /* *pred_mov_widthbv1qi */

    case 44:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1500; /* *pred_mov_widthbv2qi */

    case 45:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1506; /* *pred_mov_widthbv4qi */

    case 46:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1512; /* *pred_mov_widthbv8qi */

    case 47:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1518; /* *pred_mov_widthbv16qi */

    case 48:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1524; /* *pred_mov_widthbv32qi */

    case 49:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1530; /* *pred_mov_widthbv64qi */

    case 50:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1536; /* *pred_mov_widthbv128qi */

    case 51:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1542; /* *pred_mov_widthbv256qi */

    case 52:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1548; /* *pred_mov_widthbv512qi */

    case 53:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1554; /* *pred_mov_widthbv1024qi */

    case 54:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1560; /* *pred_mov_widthbv2048qi */

    case 55:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1566; /* *pred_mov_widthbv4096qi */

    case 56:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1572; /* *pred_mov_widthbv1hi */

    case 57:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1578; /* *pred_mov_widthbv2hi */

    case 58:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1584; /* *pred_mov_widthbv4hi */

    case 59:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1590; /* *pred_mov_widthbv8hi */

    case 60:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1596; /* *pred_mov_widthbv16hi */

    case 61:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1602; /* *pred_mov_widthbv32hi */

    case 62:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1608; /* *pred_mov_widthbv64hi */

    case 63:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1614; /* *pred_mov_widthbv128hi */

    case 64:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1620; /* *pred_mov_widthbv256hi */

    case 65:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1626; /* *pred_mov_widthbv512hi */

    case 66:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1632; /* *pred_mov_widthbv1024hi */

    case 67:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1638; /* *pred_mov_widthbv2048hi */

    case 68:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1644; /* *pred_mov_widthbv1si */

    case 69:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1650; /* *pred_mov_widthbv2si */

    case 70:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1656; /* *pred_mov_widthbv4si */

    case 71:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1662; /* *pred_mov_widthbv8si */

    case 72:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1668; /* *pred_mov_widthbv16si */

    case 73:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1674; /* *pred_mov_widthbv32si */

    case 74:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1680; /* *pred_mov_widthbv64si */

    case 75:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1686; /* *pred_mov_widthbv128si */

    case 76:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1692; /* *pred_mov_widthbv256si */

    case 77:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1698; /* *pred_mov_widthbv512si */

    case 78:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1704; /* *pred_mov_widthbv1024si */

    case 79:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1710; /* *pred_mov_widthbv1di */

    case 80:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1716; /* *pred_mov_widthbv2di */

    case 81:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1722; /* *pred_mov_widthbv4di */

    case 82:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1728; /* *pred_mov_widthbv8di */

    case 83:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1734; /* *pred_mov_widthbv16di */

    case 84:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1740; /* *pred_mov_widthbv32di */

    case 85:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1746; /* *pred_mov_widthbv64di */

    case 86:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1752; /* *pred_mov_widthbv128di */

    case 87:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1758; /* *pred_mov_widthbv256di */

    case 88:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1764; /* *pred_mov_widthbv512di */

    case 89:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1770; /* *pred_mov_widthbv1hf */

    case 90:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1776; /* *pred_mov_widthbv2hf */

    case 91:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1782; /* *pred_mov_widthbv4hf */

    case 92:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1788; /* *pred_mov_widthbv8hf */

    case 93:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1794; /* *pred_mov_widthbv16hf */

    case 94:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1800; /* *pred_mov_widthbv32hf */

    case 95:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1806; /* *pred_mov_widthbv64hf */

    case 96:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1812; /* *pred_mov_widthbv128hf */

    case 97:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1818; /* *pred_mov_widthbv256hf */

    case 98:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1824; /* *pred_mov_widthbv512hf */

    case 99:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1830; /* *pred_mov_widthbv1024hf */

    case 100:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1836; /* *pred_mov_widthbv2048hf */

    case 101:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1842; /* *pred_mov_widthbv1sf */

    case 102:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1848; /* *pred_mov_widthbv2sf */

    case 103:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1854; /* *pred_mov_widthbv4sf */

    case 104:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1860; /* *pred_mov_widthbv8sf */

    case 105:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1866; /* *pred_mov_widthbv16sf */

    case 106:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1872; /* *pred_mov_widthbv32sf */

    case 107:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1878; /* *pred_mov_widthbv64sf */

    case 108:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1884; /* *pred_mov_widthbv128sf */

    case 109:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1890; /* *pred_mov_widthbv256sf */

    case 110:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1896; /* *pred_mov_widthbv512sf */

    case 111:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1902; /* *pred_mov_widthbv1024sf */

    case 112:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1908; /* *pred_mov_widthbv1df */

    case 113:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1914; /* *pred_mov_widthbv2df */

    case 114:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1920; /* *pred_mov_widthbv4df */

    case 115:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1926; /* *pred_mov_widthbv8df */

    case 116:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1932; /* *pred_mov_widthbv16df */

    case 117:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1938; /* *pred_mov_widthbv32df */

    case 118:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1944; /* *pred_mov_widthbv64df */

    case 119:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1950; /* *pred_mov_widthbv128df */

    case 120:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1956; /* *pred_mov_widthbv256df */

    case 121:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1962; /* *pred_mov_widthbv512df */

    default:
      return -1;
    }
}

 int
recog_930 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15253; /* *pred_mul_addrvvm4sf_undef */
}

 int
recog_935 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15263; /* *pred_mul_addrvvm4df_undef */
}

 int
recog_940 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15273; /* *pred_mul_addv4hf_undef */
}

 int
recog_945 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15283; /* *pred_mul_addv128hf_undef */
}

 int
recog_950 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15293; /* *pred_mul_addv1sf_undef */
}

 int
recog_955 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15303; /* *pred_mul_addv32sf_undef */
}

 int
recog_960 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15313; /* *pred_mul_addv1024sf_undef */
}

 int
recog_965 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15323; /* *pred_mul_addv16df_undef */
}

 int
recog_970 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15333; /* *pred_mul_addv512df_undef */
}

 int
recog_975 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16748; /* pred_widen_mul_addrvvm8sf_scalar */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 130 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32724; /* pred_widen_bf16_mul_rvvm8sf_scalar */

    default:
      return -1;
    }
}

 int
recog_980 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16688; /* pred_widen_mul_addrvvm8sf */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 101 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32719; /* pred_widen_bf16_mul_rvvm8sf */

    default:
      return -1;
    }
}

 int
recog_985 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_966 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15421; /* *pred_maddv32df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15517; /* *pred_maccv32df */
}

 int
recog_990 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_961 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15411; /* *pred_maddv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15507; /* *pred_maccv1df */
}

 int
recog_995 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_956 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15401; /* *pred_maddv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15497; /* *pred_maccv64sf */
}

 int
recog_1000 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_951 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15391; /* *pred_maddv2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15487; /* *pred_maccv2sf */
}

 int
recog_1005 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_946 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15381; /* *pred_maddv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15477; /* *pred_maccv256hf */
}

 int
recog_1010 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_941 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15371; /* *pred_maddv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15467; /* *pred_maccv8hf */
}

 int
recog_1016 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_935 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15359; /* *pred_maddrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15455; /* *pred_maccrvvm4df */
}

 int
recog_1022 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_929 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15347; /* *pred_maddrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15443; /* *pred_maccrvvm8sf */
}

 int
recog_1028 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_923 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15335; /* *pred_maddrvvm8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15431; /* *pred_maccrvvm8hf */
}

 int
recog_1036 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15733; /* *pred_mul_neg_addrvvm4sf_undef */
}

 int
recog_1044 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15749; /* *pred_mul_neg_addv1hf_undef */
}

 int
recog_1053 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15767; /* *pred_mul_neg_addv512hf_undef */
}

 int
recog_1063 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15787; /* *pred_mul_neg_addv128sf_undef */
}

 int
recog_1073 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15807; /* *pred_mul_neg_addv64df_undef */
}

 int
recog_1083 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1070 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15897; /* *pred_nmsubv8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15993; /* *pred_nmsacv8df */
}

 int
recog_1093 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1060 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15877; /* *pred_nmsubv16sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15973; /* *pred_nmsacv16sf */
}

 int
recog_1103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1050 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15857; /* *pred_nmsubv64hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15953; /* *pred_nmsacv64hf */
}

 int
recog_1113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1040 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15837; /* *pred_nmsubrvvm8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15933; /* *pred_nmsacrvvm8df */
}

 int
recog_1123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1030 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15817; /* *pred_nmsubrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15913; /* *pred_nmsacrvvm4hf */
}

 int
recog_1133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15250; /* *pred_mul_subrvvmf4hf_undef */
}

 int
recog_1140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15264; /* *pred_mul_subrvvm4df_undef */
}

 int
recog_1147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15278; /* *pred_mul_subv16hf_undef */
}

 int
recog_1154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15292; /* *pred_mul_subv2048hf_undef */
}

 int
recog_1161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15306; /* *pred_mul_subv64sf_undef */
}

 int
recog_1168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15320; /* *pred_mul_subv4df_undef */
}

 int
recog_1175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15334; /* *pred_mul_subv512df_undef */
}

 int
recog_1182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1169 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15418; /* *pred_msubv8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15514; /* *pred_msacv8df */
}

 int
recog_1189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1162 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15404; /* *pred_msubv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15500; /* *pred_msacv128sf */
}

 int
recog_1196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1155 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15390; /* *pred_msubv1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15486; /* *pred_msacv1sf */
}

 int
recog_1203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1148 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return 15376; /* *pred_msubv32hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15472; /* *pred_msacv32hf */
}

 int
recog_1210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1141 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15362; /* *pred_msubrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15458; /* *pred_msacrvvm2df */
}

 int
recog_1217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1134 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15348; /* *pred_msubrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15444; /* *pred_msacrvvm8sf */
}

 int
recog_1224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15720; /* *pred_mul_neg_subrvvm8hf_undef */
}

 int
recog_1227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15726; /* *pred_mul_neg_subrvvm1hf_undef */
}

 int
recog_1234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15740; /* *pred_mul_neg_subrvvmf2sf_undef */
}

 int
recog_1241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15754; /* *pred_mul_neg_subv4hf_undef */
}

 int
recog_1248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15768; /* *pred_mul_neg_subv512hf_undef */
}

 int
recog_1255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15782; /* *pred_mul_neg_subv16sf_undef */
}

 int
recog_1262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15796; /* *pred_mul_neg_subv1df_undef */
}

 int
recog_1269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15810; /* *pred_mul_neg_subv128df_undef */
}

 int
recog_1276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1267 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15902; /* *pred_nmaddv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15998; /* *pred_nmaccv32df */
}

 int
recog_1283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1260 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15888; /* *pred_nmaddv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15984; /* *pred_nmaccv512sf */
}

 int
recog_1290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1253 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15874; /* *pred_nmaddv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15970; /* *pred_nmaccv4sf */
}

 int
recog_1297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1246 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15860; /* *pred_nmaddv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15956; /* *pred_nmaccv128hf */
}

 int
recog_1305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1238 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15844; /* *pred_nmaddrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15940; /* *pred_nmaccrvvm1df */
}

 int
recog_1313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1230 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15828; /* *pred_nmaddrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15924; /* *pred_nmaccrvvm8sf */
}

 int
recog_1321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern584 (x2))
    {
    case 0:
      return recog_1319 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1318 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1317 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1316 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1315 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1314 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1313 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1312 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1311 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1310 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1309 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1308 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1307 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1306 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1305 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1304 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1303 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1302 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1301 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1300 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1299 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1298 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1297 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1296 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1295 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1294 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1293 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1292 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1291 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1290 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1289 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1288 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1287 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1286 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1285 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1284 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1283 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1282 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1281 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1280 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1279 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1278 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1277 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1276 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1275 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1274 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1273 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1272 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16008; /* *pred_nmaddrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16104; /* *pred_nmaccrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16010; /* *pred_nmaddrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16106; /* *pred_nmaccrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16012; /* *pred_nmaddrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16108; /* *pred_nmaccrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16014; /* *pred_nmaddrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16110; /* *pred_nmaccrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16016; /* *pred_nmaddrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16112; /* *pred_nmaccrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 16018; /* *pred_nmaddrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16114; /* *pred_nmaccrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16020; /* *pred_nmaddrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16116; /* *pred_nmaccrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16022; /* *pred_nmaddrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16118; /* *pred_nmaccrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16024; /* *pred_nmaddrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16120; /* *pred_nmaccrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16026; /* *pred_nmaddrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16122; /* *pred_nmaccrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 16028; /* *pred_nmaddrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16124; /* *pred_nmaccrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16030; /* *pred_nmaddrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16126; /* *pred_nmaccrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16032; /* *pred_nmaddrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16128; /* *pred_nmaccrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16034; /* *pred_nmaddrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16130; /* *pred_nmaccrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16036; /* *pred_nmaddrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16132; /* *pred_nmaccrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 16038; /* *pred_nmaddv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16134; /* *pred_nmaccv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 16040; /* *pred_nmaddv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16136; /* *pred_nmaccv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 16042; /* *pred_nmaddv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16138; /* *pred_nmaccv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 16044; /* *pred_nmaddv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16140; /* *pred_nmaccv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 16046; /* *pred_nmaddv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16142; /* *pred_nmaccv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 16048; /* *pred_nmaddv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16144; /* *pred_nmaccv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 16050; /* *pred_nmaddv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16146; /* *pred_nmaccv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 16052; /* *pred_nmaddv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16148; /* *pred_nmaccv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 16054; /* *pred_nmaddv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16150; /* *pred_nmaccv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 16056; /* *pred_nmaddv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16152; /* *pred_nmaccv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 16058; /* *pred_nmaddv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16154; /* *pred_nmaccv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 16060; /* *pred_nmaddv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16156; /* *pred_nmaccv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16062; /* *pred_nmaddv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16158; /* *pred_nmaccv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16064; /* *pred_nmaddv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16160; /* *pred_nmaccv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16066; /* *pred_nmaddv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16162; /* *pred_nmaccv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16068; /* *pred_nmaddv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16164; /* *pred_nmaccv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 16070; /* *pred_nmaddv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16166; /* *pred_nmaccv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 16072; /* *pred_nmaddv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16168; /* *pred_nmaccv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 16074; /* *pred_nmaddv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16170; /* *pred_nmaccv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 16076; /* *pred_nmaddv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16172; /* *pred_nmaccv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 16078; /* *pred_nmaddv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16174; /* *pred_nmaccv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 16080; /* *pred_nmaddv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16176; /* *pred_nmaccv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 16082; /* *pred_nmaddv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16178; /* *pred_nmaccv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16084; /* *pred_nmaddv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16180; /* *pred_nmaccv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16086; /* *pred_nmaddv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16182; /* *pred_nmaccv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16088; /* *pred_nmaddv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16184; /* *pred_nmaccv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 16090; /* *pred_nmaddv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16186; /* *pred_nmaccv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 16092; /* *pred_nmaddv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16188; /* *pred_nmaccv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 16094; /* *pred_nmaddv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16190; /* *pred_nmaccv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 16096; /* *pred_nmaddv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16192; /* *pred_nmaccv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 16098; /* *pred_nmaddv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16194; /* *pred_nmaccv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 16100; /* *pred_nmaddv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16196; /* *pred_nmaccv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 16102; /* *pred_nmaddv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6863 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16198; /* *pred_nmaccv512df_scalar */

    case 96:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16809; /* pred_widen_mul_neg_subrvvm8sf */

    case 97:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16811; /* pred_widen_mul_neg_subrvvm4sf */

    case 98:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16813; /* pred_widen_mul_neg_subrvvm2sf */

    case 99:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16815; /* pred_widen_mul_neg_subrvvm1sf */

    case 100:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16817; /* pred_widen_mul_neg_subrvvmf2sf */

    case 101:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16819; /* pred_widen_mul_neg_subrvvm8df */

    case 102:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16821; /* pred_widen_mul_neg_subrvvm4df */

    case 103:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16823; /* pred_widen_mul_neg_subrvvm2df */

    case 104:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16825; /* pred_widen_mul_neg_subrvvm1df */

    case 105:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16827; /* pred_widen_mul_neg_subv1sf */

    case 106:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16829; /* pred_widen_mul_neg_subv2sf */

    case 107:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16831; /* pred_widen_mul_neg_subv4sf */

    case 108:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16833; /* pred_widen_mul_neg_subv8sf */

    case 109:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16835; /* pred_widen_mul_neg_subv16sf */

    case 110:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16837; /* pred_widen_mul_neg_subv32sf */

    case 111:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16839; /* pred_widen_mul_neg_subv64sf */

    case 112:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16841; /* pred_widen_mul_neg_subv128sf */

    case 113:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16843; /* pred_widen_mul_neg_subv256sf */

    case 114:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16845; /* pred_widen_mul_neg_subv512sf */

    case 115:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16847; /* pred_widen_mul_neg_subv1024sf */

    case 116:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16849; /* pred_widen_mul_neg_subv1df */

    case 117:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16851; /* pred_widen_mul_neg_subv2df */

    case 118:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16853; /* pred_widen_mul_neg_subv4df */

    case 119:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16855; /* pred_widen_mul_neg_subv8df */

    case 120:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16857; /* pred_widen_mul_neg_subv16df */

    case 121:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16859; /* pred_widen_mul_neg_subv32df */

    case 122:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16861; /* pred_widen_mul_neg_subv64df */

    case 123:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16863; /* pred_widen_mul_neg_subv128df */

    case 124:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16865; /* pred_widen_mul_neg_subv256df */

    case 125:
      if (!(
#line 7223 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16867; /* pred_widen_mul_neg_subv512df */

    case 126:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16869; /* pred_widen_mul_neg_subrvvm8sf_scalar */

    case 127:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16871; /* pred_widen_mul_neg_subrvvm4sf_scalar */

    case 128:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16873; /* pred_widen_mul_neg_subrvvm2sf_scalar */

    case 129:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16875; /* pred_widen_mul_neg_subrvvm1sf_scalar */

    case 130:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16877; /* pred_widen_mul_neg_subrvvmf2sf_scalar */

    case 131:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16879; /* pred_widen_mul_neg_subrvvm8df_scalar */

    case 132:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16881; /* pred_widen_mul_neg_subrvvm4df_scalar */

    case 133:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16883; /* pred_widen_mul_neg_subrvvm2df_scalar */

    case 134:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16885; /* pred_widen_mul_neg_subrvvm1df_scalar */

    case 135:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16887; /* pred_widen_mul_neg_subv1sf_scalar */

    case 136:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16889; /* pred_widen_mul_neg_subv2sf_scalar */

    case 137:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16891; /* pred_widen_mul_neg_subv4sf_scalar */

    case 138:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16893; /* pred_widen_mul_neg_subv8sf_scalar */

    case 139:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16895; /* pred_widen_mul_neg_subv16sf_scalar */

    case 140:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16897; /* pred_widen_mul_neg_subv32sf_scalar */

    case 141:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16899; /* pred_widen_mul_neg_subv64sf_scalar */

    case 142:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16901; /* pred_widen_mul_neg_subv128sf_scalar */

    case 143:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16903; /* pred_widen_mul_neg_subv256sf_scalar */

    case 144:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16905; /* pred_widen_mul_neg_subv512sf_scalar */

    case 145:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16907; /* pred_widen_mul_neg_subv1024sf_scalar */

    case 146:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16909; /* pred_widen_mul_neg_subv1df_scalar */

    case 147:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16911; /* pred_widen_mul_neg_subv2df_scalar */

    case 148:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16913; /* pred_widen_mul_neg_subv4df_scalar */

    case 149:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16915; /* pred_widen_mul_neg_subv8df_scalar */

    case 150:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16917; /* pred_widen_mul_neg_subv16df_scalar */

    case 151:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16919; /* pred_widen_mul_neg_subv32df_scalar */

    case 152:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16921; /* pred_widen_mul_neg_subv64df_scalar */

    case 153:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16923; /* pred_widen_mul_neg_subv128df_scalar */

    case 154:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16925; /* pred_widen_mul_neg_subv256df_scalar */

    case 155:
      if (!(
#line 7253 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16927; /* pred_widen_mul_neg_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || !vector_neg_arith_operand (operands[4], E_V512QImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12647; /* *pred_ltgev512qi_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || !vector_neg_arith_operand (operands[4], E_V512HImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12660; /* *pred_ltgev512hi_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || !vector_neg_arith_operand (operands[4], E_V512SImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12672; /* *pred_ltgev512si_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || !vector_neg_arith_operand (operands[4], E_V512DImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12683; /* *pred_ltgev512di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1382 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern533 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1367 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || !vector_neg_arith_operand (operands[5], E_V8QImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12709; /* *pred_ltgev8qi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12777; /* *pred_ltgev8qi_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || !vector_neg_arith_operand (operands[5], E_V8HImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12722; /* *pred_ltgev8hi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12790; /* *pred_ltgev8hi_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || !vector_neg_arith_operand (operands[5], E_V8SImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12734; /* *pred_ltgev8si */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12802; /* *pred_ltgev8si_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || !vector_neg_arith_operand (operands[5], E_V8DImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12745; /* *pred_ltgev8di */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12813; /* *pred_ltgev8di_narrow */

    default:
      return -1;
    }
}

 int
recog_1389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || GET_MODE (x9) != E_RVVMF4QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12825; /* *pred_cmprvvmf4qi_scalar_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || GET_MODE (x9) != E_RVVMF2HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12831; /* *pred_cmprvvmf2hi_scalar_merge_tie_mask */

    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || GET_MODE (x9) != E_RVVM1SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12836; /* *pred_cmprvvm1si_scalar_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || GET_MODE (x9) != E_RVVM2DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12984; /* *pred_cmprvvm2di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || GET_MODE (x9) != E_V32QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12843; /* *pred_cmpv32qi_scalar_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || GET_MODE (x9) != E_V32HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12856; /* *pred_cmpv32hi_scalar_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || GET_MODE (x9) != E_V32SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4924 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12868; /* *pred_cmpv32si_scalar_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || GET_MODE (x9) != E_V32DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5034 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12991; /* *pred_cmpv32di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern567 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1400 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12901; /* *pred_cmpv512qi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12955; /* *pred_cmpv512qi_scalar_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12914; /* *pred_cmpv512hi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12968; /* *pred_cmpv512hi_scalar_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12926; /* *pred_cmpv512si_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12980; /* *pred_cmpv512si_scalar_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5059 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 13009; /* *pred_cmpv512di_scalar */
      if (!(
#line 5081 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13023; /* *pred_cmpv512di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1410 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern567 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1393 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12894; /* *pred_cmpv4qi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12948; /* *pred_cmpv4qi_scalar_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12907; /* *pred_cmpv4hi_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12961; /* *pred_cmpv4hi_scalar_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4949 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12919; /* *pred_cmpv4si_scalar */
      if (!(
#line 4971 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12973; /* *pred_cmpv4si_scalar_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5059 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 13002; /* *pred_cmpv4di_scalar */
      if (!(
#line 5081 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13016; /* *pred_cmpv4di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1419 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16981; /* *pred_cmprvvmf4hf_narrow_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || !register_operand (operands[4], E_RVVMF2SFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16986; /* *pred_cmprvvmf2sf_narrow_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || !register_operand (operands[4], E_RVVM1DFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16990; /* *pred_cmprvvm1df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || !register_operand (operands[4], E_V16HFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16995; /* *pred_cmpv16hf_narrow_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || !register_operand (operands[4], E_V16SFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17007; /* *pred_cmpv16sf_narrow_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || !register_operand (operands[4], E_V16DFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17018; /* *pred_cmpv16df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || !register_operand (operands[4], E_V512HFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17000; /* *pred_cmpv512hf_narrow_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || !register_operand (operands[4], E_V512SFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17012; /* *pred_cmpv512sf_narrow_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || !register_operand (operands[4], E_V512DFmode)
          || !(
#line 7319 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17023; /* *pred_cmpv512df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || GET_MODE (x9) != E_RVVMF4HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17077; /* *pred_cmprvvmf4hf_scalar_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || GET_MODE (x9) != E_RVVMF2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17082; /* *pred_cmprvvmf2sf_scalar_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || GET_MODE (x9) != E_RVVM1DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17086; /* *pred_cmprvvm1df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1441 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[3], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17092; /* *pred_cmpv32hf_scalar_merge_tie_mask */

    case E_V32SFmode:
      if (!register_operand (operands[3], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17104; /* *pred_cmpv32sf_scalar_merge_tie_mask */

    case E_V32DFmode:
      if (!register_operand (operands[3], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17115; /* *pred_cmpv32df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern544 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1445 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[4], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HFmode)) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 17144; /* *pred_cmpv512hf_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HFmode)) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17192; /* *pred_cmpv512hf_scalar_narrow */

    case E_V512SFmode:
      if (!register_operand (operands[4], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SFmode)) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 17156; /* *pred_cmpv512sf_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SFmode)) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17204; /* *pred_cmpv512sf_scalar_narrow */

    case E_V512DFmode:
      if (!register_operand (operands[4], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DFmode)) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 17167; /* *pred_cmpv512df_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DFmode)) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17215; /* *pred_cmpv512df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern621 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) == 0
          && (
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17072; /* *pred_cmprvvm8hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern622 (x2, 
E_RVVMF2BImode, 
E_RVVM8HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HFmode)) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17120; /* *pred_cmprvvm8hf_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HFmode)) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17168; /* *pred_cmprvvm8hf_scalar_narrow */

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1431 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[4], E_RVVM4HFmode)
              || GET_MODE (x9) != E_RVVM4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HFmode)) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17121; /* *pred_cmprvvm4hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HFmode)) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17169; /* *pred_cmprvvm4hf_scalar_narrow */

        case E_RVVM8SFmode:
          if (!register_operand (operands[4], E_RVVM8SFmode)
              || GET_MODE (x9) != E_RVVM8SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SFmode)) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17126; /* *pred_cmprvvm8sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SFmode)) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17174; /* *pred_cmprvvm8sf_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1432 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[4], E_RVVM2HFmode)
              || GET_MODE (x9) != E_RVVM2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HFmode)) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17122; /* *pred_cmprvvm2hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HFmode)) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17170; /* *pred_cmprvvm2hf_scalar_narrow */

        case E_RVVM4SFmode:
          if (!register_operand (operands[4], E_RVVM4SFmode)
              || GET_MODE (x9) != E_RVVM4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SFmode)) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17127; /* *pred_cmprvvm4sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SFmode)) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17175; /* *pred_cmprvvm4sf_scalar_narrow */

        case E_RVVM8DFmode:
          if (!register_operand (operands[4], E_RVVM8DFmode)
              || GET_MODE (x9) != E_RVVM8DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DFmode)) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17131; /* *pred_cmprvvm8df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DFmode)) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17179; /* *pred_cmprvvm8df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1433 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[4], E_RVVM1HFmode)
              || GET_MODE (x9) != E_RVVM1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HFmode)) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17123; /* *pred_cmprvvm1hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HFmode)) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17171; /* *pred_cmprvvm1hf_scalar_narrow */

        case E_RVVM2SFmode:
          if (!register_operand (operands[4], E_RVVM2SFmode)
              || GET_MODE (x9) != E_RVVM2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SFmode)) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17128; /* *pred_cmprvvm2sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SFmode)) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17176; /* *pred_cmprvvm2sf_scalar_narrow */

        case E_RVVM4DFmode:
          if (!register_operand (operands[4], E_RVVM4DFmode)
              || GET_MODE (x9) != E_RVVM4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DFmode)) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17132; /* *pred_cmprvvm4df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DFmode)) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17180; /* *pred_cmprvvm4df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1434 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[4], E_RVVMF2HFmode)
              || GET_MODE (x9) != E_RVVMF2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HFmode)) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17124; /* *pred_cmprvvmf2hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HFmode)) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17172; /* *pred_cmprvvmf2hf_scalar_narrow */

        case E_RVVM1SFmode:
          if (!register_operand (operands[4], E_RVVM1SFmode)
              || GET_MODE (x9) != E_RVVM1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SFmode)) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17129; /* *pred_cmprvvm1sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SFmode)) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17177; /* *pred_cmprvvm1sf_scalar_narrow */

        case E_RVVM2DFmode:
          if (!register_operand (operands[4], E_RVVM2DFmode)
              || GET_MODE (x9) != E_RVVM2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DFmode)) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17133; /* *pred_cmprvvm2df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DFmode)) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17181; /* *pred_cmprvvm2df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1435 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[4], E_RVVMF4HFmode)
              || GET_MODE (x9) != E_RVVMF4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HFmode)) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return 17125; /* *pred_cmprvvmf4hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HFmode)) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17173; /* *pred_cmprvvmf4hf_scalar_narrow */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[4], E_RVVMF2SFmode)
              || GET_MODE (x9) != E_RVVMF2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SFmode)) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return 17130; /* *pred_cmprvvmf2sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SFmode)) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 17178; /* *pred_cmprvvmf2sf_scalar_narrow */

        case E_RVVM1DFmode:
          if (!register_operand (operands[4], E_RVVM1DFmode)
              || GET_MODE (x9) != E_RVVM1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DFmode)) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17134; /* *pred_cmprvvm1df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DFmode)) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17182; /* *pred_cmprvvm1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1436 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[4], E_V1HFmode)
              || GET_MODE (x9) != E_V1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HFmode)) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return 17135; /* *pred_cmpv1hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HFmode)) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17183; /* *pred_cmpv1hf_scalar_narrow */

        case E_V1SFmode:
          if (!register_operand (operands[4], E_V1SFmode)
              || GET_MODE (x9) != E_V1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SFmode)) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17147; /* *pred_cmpv1sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SFmode)) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17195; /* *pred_cmpv1sf_scalar_narrow */

        case E_V1DFmode:
          if (!register_operand (operands[4], E_V1DFmode)
              || GET_MODE (x9) != E_V1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DFmode)) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17158; /* *pred_cmpv1df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DFmode)) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17206; /* *pred_cmpv1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1437 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[4], E_V2HFmode)
              || GET_MODE (x9) != E_V2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HFmode)) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return 17136; /* *pred_cmpv2hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HFmode)) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17184; /* *pred_cmpv2hf_scalar_narrow */

        case E_V2SFmode:
          if (!register_operand (operands[4], E_V2SFmode)
              || GET_MODE (x9) != E_V2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SFmode)) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17148; /* *pred_cmpv2sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SFmode)) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17196; /* *pred_cmpv2sf_scalar_narrow */

        case E_V2DFmode:
          if (!register_operand (operands[4], E_V2DFmode)
              || GET_MODE (x9) != E_V2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DFmode)) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17159; /* *pred_cmpv2df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DFmode)) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17207; /* *pred_cmpv2df_scalar_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_V4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V4BImode))
        {
          res = recog_1438 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[4], E_V4HFmode)
              || GET_MODE (x9) != E_V4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HFmode)) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return 17137; /* *pred_cmpv4hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HFmode)) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17185; /* *pred_cmpv4hf_scalar_narrow */

        case E_V4SFmode:
          if (!register_operand (operands[4], E_V4SFmode)
              || GET_MODE (x9) != E_V4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SFmode)) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17149; /* *pred_cmpv4sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SFmode)) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17197; /* *pred_cmpv4sf_scalar_narrow */

        case E_V4DFmode:
          if (!register_operand (operands[4], E_V4DFmode)
              || GET_MODE (x9) != E_V4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DFmode)) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17160; /* *pred_cmpv4df_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DFmode)) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17208; /* *pred_cmpv4df_scalar_narrow */

        default:
          return -1;
        }

    case E_V8BImode:
      return recog_1453 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1452 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1451 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1450 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1448 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1449 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1447 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1446 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[4], E_V1024HFmode)
              || GET_MODE (x9) != E_V1024HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HFmode)) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return 17145; /* *pred_cmpv1024hf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HFmode)) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17193; /* *pred_cmpv1024hf_scalar_narrow */

        case E_V1024SFmode:
          if (!register_operand (operands[4], E_V1024SFmode)
              || GET_MODE (x9) != E_V1024SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SFmode)) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return 17157; /* *pred_cmpv1024sf_scalar */
          if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SFmode)) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17205; /* *pred_cmpv1024sf_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern544 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern621 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) == 0
          && (
#line 7382 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17098; /* *pred_cmpv2048hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern622 (x2, 
E_V2048BImode, 
E_V2048HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7407 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HFmode)) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17146; /* *pred_cmpv2048hf_scalar */
      if (!(
#line 7429 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HFmode)) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17194; /* *pred_cmpv2048hf_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1466 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 1790 "../../../gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))
        return -1;
      return 117; /* truncdfsf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1799 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN))
            return -1;
          return 118; /* truncsfhf2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 1808 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZFHMIN && TARGET_DOUBLE_FLOAT) ||
   (TARGET_ZHINXMIN && TARGET_ZDINX)))
            return -1;
          return 119; /* truncdfhf2 */

        default:
          return -1;
        }

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 1818 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZFBFMIN))
        return -1;
      return 120; /* truncsfbf2 */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25438; /* truncrvvm8sfrvvm4hf2 */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25439; /* truncrvvm4sfrvvm2hf2 */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25440; /* truncrvvm2sfrvvm1hf2 */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25441; /* truncrvvm1sfrvvmf2hf2 */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25442; /* truncrvvmf2sfrvvmf4hf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25443; /* truncrvvm8dfrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25444; /* truncrvvm4dfrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25445; /* truncrvvm2dfrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25446; /* truncrvvm1dfrvvmf2sf2 */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25447; /* truncv1sfv1hf2 */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25448; /* truncv2sfv2hf2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25449; /* truncv4sfv4hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25450; /* truncv8sfv8hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25451; /* truncv16sfv16hf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25452; /* truncv32sfv32hf2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25453; /* truncv64sfv64hf2 */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25454; /* truncv128sfv128hf2 */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25455; /* truncv256sfv256hf2 */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25456; /* truncv512sfv512hf2 */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25457; /* truncv1024sfv1024hf2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25458; /* truncv1dfv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25459; /* truncv2dfv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25460; /* truncv4dfv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25461; /* truncv8dfv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25462; /* truncv16dfv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25463; /* truncv32dfv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25464; /* truncv64dfv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25465; /* truncv128dfv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25466; /* truncv256dfv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 863 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25467; /* truncv512dfv512sf2 */

    default:
      return -1;
    }
}

 int
recog_1469 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern52 (x1))
    {
    case 0:
      if (!
#line 2098 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 147; /* *fixuns_truncsfsi2 */

    case 1:
      if (!(
#line 2098 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 149; /* *fixuns_truncdfsi2 */

    case 2:
      if (!(
#line 2098 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 151; /* *fixuns_trunchfsi2 */

    case 3:
      if (!(
#line 2116 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 159; /* fixuns_truncsfdi2 */

    case 4:
      if (!(
#line 2116 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 161; /* fixuns_truncdfdi2 */

    case 5:
      if (!(
#line 2116 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 163; /* fixuns_trunchfdi2 */

    case 6:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25469; /* fixuns_truncrvvm8hfrvvm8hi2 */

    case 7:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25471; /* fixuns_truncrvvm4hfrvvm4hi2 */

    case 8:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25829; /* fixuns_truncrvvm8sfrvvm4hi2 */

    case 9:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25473; /* fixuns_truncrvvm2hfrvvm2hi2 */

    case 10:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25831; /* fixuns_truncrvvm4sfrvvm2hi2 */

    case 11:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25475; /* fixuns_truncrvvm1hfrvvm1hi2 */

    case 12:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25833; /* fixuns_truncrvvm2sfrvvm1hi2 */

    case 13:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25477; /* fixuns_truncrvvmf2hfrvvmf2hi2 */

    case 14:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25835; /* fixuns_truncrvvm1sfrvvmf2hi2 */

    case 15:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25479; /* fixuns_truncrvvmf4hfrvvmf4hi2 */

    case 16:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25837; /* fixuns_truncrvvmf2sfrvvmf4hi2 */

    case 17:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25481; /* fixuns_truncrvvm8sfrvvm8si2 */

    case 18:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25661; /* fixuns_truncrvvm4hfrvvm8si2 */

    case 19:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25483; /* fixuns_truncrvvm4sfrvvm4si2 */

    case 20:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25663; /* fixuns_truncrvvm2hfrvvm4si2 */

    case 21:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25839; /* fixuns_truncrvvm8dfrvvm4si2 */

    case 22:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25485; /* fixuns_truncrvvm2sfrvvm2si2 */

    case 23:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25665; /* fixuns_truncrvvm1hfrvvm2si2 */

    case 24:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25841; /* fixuns_truncrvvm4dfrvvm2si2 */

    case 25:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25487; /* fixuns_truncrvvm1sfrvvm1si2 */

    case 26:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25667; /* fixuns_truncrvvmf2hfrvvm1si2 */

    case 27:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25843; /* fixuns_truncrvvm2dfrvvm1si2 */

    case 28:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25489; /* fixuns_truncrvvmf2sfrvvmf2si2 */

    case 29:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25669; /* fixuns_truncrvvmf4hfrvvmf2si2 */

    case 30:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25845; /* fixuns_truncrvvm1dfrvvmf2si2 */

    case 31:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25491; /* fixuns_truncrvvm8dfrvvm8di2 */

    case 32:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25671; /* fixuns_truncrvvm4sfrvvm8di2 */

    case 33:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25493; /* fixuns_truncrvvm4dfrvvm4di2 */

    case 34:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25673; /* fixuns_truncrvvm2sfrvvm4di2 */

    case 35:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25495; /* fixuns_truncrvvm2dfrvvm2di2 */

    case 36:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25675; /* fixuns_truncrvvm1sfrvvm2di2 */

    case 37:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25497; /* fixuns_truncrvvm1dfrvvm1di2 */

    case 38:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25677; /* fixuns_truncrvvmf2sfrvvm1di2 */

    case 39:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 25499; /* fixuns_truncv1hfv1hi2 */

    case 40:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25871; /* fixuns_truncv1sfv1hi2 */

    case 41:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 25501; /* fixuns_truncv2hfv2hi2 */

    case 42:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25873; /* fixuns_truncv2sfv2hi2 */

    case 43:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 25503; /* fixuns_truncv4hfv4hi2 */

    case 44:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25875; /* fixuns_truncv4sfv4hi2 */

    case 45:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 25505; /* fixuns_truncv8hfv8hi2 */

    case 46:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25877; /* fixuns_truncv8sfv8hi2 */

    case 47:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 25507; /* fixuns_truncv16hfv16hi2 */

    case 48:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25879; /* fixuns_truncv16sfv16hi2 */

    case 49:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25509; /* fixuns_truncv32hfv32hi2 */

    case 50:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25881; /* fixuns_truncv32sfv32hi2 */

    case 51:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25511; /* fixuns_truncv64hfv64hi2 */

    case 52:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25883; /* fixuns_truncv64sfv64hi2 */

    case 53:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25513; /* fixuns_truncv128hfv128hi2 */

    case 54:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25885; /* fixuns_truncv128sfv128hi2 */

    case 55:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25515; /* fixuns_truncv256hfv256hi2 */

    case 56:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25887; /* fixuns_truncv256sfv256hi2 */

    case 57:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25517; /* fixuns_truncv512hfv512hi2 */

    case 58:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25889; /* fixuns_truncv512sfv512hi2 */

    case 59:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25519; /* fixuns_truncv1024hfv1024hi2 */

    case 60:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25891; /* fixuns_truncv1024sfv1024hi2 */

    case 61:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25521; /* fixuns_truncv2048hfv2048hi2 */

    case 62:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25523; /* fixuns_truncv1sfv1si2 */

    case 63:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 25679; /* fixuns_truncv1hfv1si2 */

    case 64:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25893; /* fixuns_truncv1dfv1si2 */

    case 65:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25525; /* fixuns_truncv2sfv2si2 */

    case 66:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 25681; /* fixuns_truncv2hfv2si2 */

    case 67:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25895; /* fixuns_truncv2dfv2si2 */

    case 68:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25527; /* fixuns_truncv4sfv4si2 */

    case 69:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 25683; /* fixuns_truncv4hfv4si2 */

    case 70:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25897; /* fixuns_truncv4dfv4si2 */

    case 71:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25529; /* fixuns_truncv8sfv8si2 */

    case 72:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 25685; /* fixuns_truncv8hfv8si2 */

    case 73:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25899; /* fixuns_truncv8dfv8si2 */

    case 74:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25531; /* fixuns_truncv16sfv16si2 */

    case 75:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25687; /* fixuns_truncv16hfv16si2 */

    case 76:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25901; /* fixuns_truncv16dfv16si2 */

    case 77:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25533; /* fixuns_truncv32sfv32si2 */

    case 78:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25689; /* fixuns_truncv32hfv32si2 */

    case 79:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25903; /* fixuns_truncv32dfv32si2 */

    case 80:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25535; /* fixuns_truncv64sfv64si2 */

    case 81:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25691; /* fixuns_truncv64hfv64si2 */

    case 82:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25905; /* fixuns_truncv64dfv64si2 */

    case 83:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25537; /* fixuns_truncv128sfv128si2 */

    case 84:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25693; /* fixuns_truncv128hfv128si2 */

    case 85:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25907; /* fixuns_truncv128dfv128si2 */

    case 86:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25539; /* fixuns_truncv256sfv256si2 */

    case 87:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25695; /* fixuns_truncv256hfv256si2 */

    case 88:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25909; /* fixuns_truncv256dfv256si2 */

    case 89:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25541; /* fixuns_truncv512sfv512si2 */

    case 90:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25697; /* fixuns_truncv512hfv512si2 */

    case 91:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25911; /* fixuns_truncv512dfv512si2 */

    case 92:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25543; /* fixuns_truncv1024sfv1024si2 */

    case 93:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25699; /* fixuns_truncv1024hfv1024si2 */

    case 94:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25545; /* fixuns_truncv1dfv1di2 */

    case 95:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25701; /* fixuns_truncv1sfv1di2 */

    case 96:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25547; /* fixuns_truncv2dfv2di2 */

    case 97:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25703; /* fixuns_truncv2sfv2di2 */

    case 98:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 25549; /* fixuns_truncv4dfv4di2 */

    case 99:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 25705; /* fixuns_truncv4sfv4di2 */

    case 100:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25551; /* fixuns_truncv8dfv8di2 */

    case 101:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25707; /* fixuns_truncv8sfv8di2 */

    case 102:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25553; /* fixuns_truncv16dfv16di2 */

    case 103:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25709; /* fixuns_truncv16sfv16di2 */

    case 104:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25555; /* fixuns_truncv32dfv32di2 */

    case 105:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25711; /* fixuns_truncv32sfv32di2 */

    case 106:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25557; /* fixuns_truncv64dfv64di2 */

    case 107:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25713; /* fixuns_truncv64sfv64di2 */

    case 108:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25559; /* fixuns_truncv128dfv128di2 */

    case 109:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25715; /* fixuns_truncv128sfv128di2 */

    case 110:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25561; /* fixuns_truncv256dfv256di2 */

    case 111:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25717; /* fixuns_truncv256sfv256di2 */

    case 112:
      if (!(
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25563; /* fixuns_truncv512dfv512di2 */

    case 113:
      if (!(
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25719; /* fixuns_truncv512sfv512di2 */

    case 114:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25817; /* fixuns_truncrvvm8hfrvvm4qi2 */

    case 115:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25819; /* fixuns_truncrvvm4hfrvvm2qi2 */

    case 116:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25821; /* fixuns_truncrvvm2hfrvvm1qi2 */

    case 117:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25823; /* fixuns_truncrvvm1hfrvvmf2qi2 */

    case 118:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 25825; /* fixuns_truncrvvmf2hfrvvmf4qi2 */

    case 119:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 25827; /* fixuns_truncrvvmf4hfrvvmf8qi2 */

    case 120:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 25847; /* fixuns_truncv1hfv1qi2 */

    case 121:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 25849; /* fixuns_truncv2hfv2qi2 */

    case 122:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 25851; /* fixuns_truncv4hfv4qi2 */

    case 123:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 25853; /* fixuns_truncv8hfv8qi2 */

    case 124:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 25855; /* fixuns_truncv16hfv16qi2 */

    case 125:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25857; /* fixuns_truncv32hfv32qi2 */

    case 126:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25859; /* fixuns_truncv64hfv64qi2 */

    case 127:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25861; /* fixuns_truncv128hfv128qi2 */

    case 128:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25863; /* fixuns_truncv256hfv256qi2 */

    case 129:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25865; /* fixuns_truncv512hfv512qi2 */

    case 130:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25867; /* fixuns_truncv1024hfv1024qi2 */

    case 131:
      if (!(
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25869; /* fixuns_truncv2048hfv2048qi2 */

    default:
      return -1;
    }
}

 int
recog_1479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 555; /* *uminsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 603 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 32873; /* riscv_cv_alu_minu */

    case 1:
      if (!(
#line 546 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 559; /* *umindi3 */

    case 2:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23622; /* uminrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23636; /* uminrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23650; /* uminrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23664; /* uminrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23678; /* uminrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23692; /* uminrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23706; /* uminrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23720; /* uminrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23734; /* uminrvvm8si3 */

    case 11:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23748; /* uminrvvm4si3 */

    case 12:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23762; /* uminrvvm2si3 */

    case 13:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23776; /* uminrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23790; /* uminrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23804; /* uminrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23818; /* uminrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23832; /* uminrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23846; /* uminrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23860; /* uminrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23874; /* uminrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23888; /* uminrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23902; /* uminrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23916; /* uminrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23930; /* uminv1qi3 */

    case 25:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23944; /* uminv2qi3 */

    case 26:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23958; /* uminv4qi3 */

    case 27:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23972; /* uminv8qi3 */

    case 28:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23986; /* uminv16qi3 */

    case 29:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24000; /* uminv32qi3 */

    case 30:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24014; /* uminv64qi3 */

    case 31:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24028; /* uminv128qi3 */

    case 32:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24042; /* uminv256qi3 */

    case 33:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24056; /* uminv512qi3 */

    case 34:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24070; /* uminv1024qi3 */

    case 35:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24084; /* uminv2048qi3 */

    case 36:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24098; /* uminv4096qi3 */

    case 37:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24112; /* uminv1hi3 */

    case 38:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24126; /* uminv2hi3 */

    case 39:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24140; /* uminv4hi3 */

    case 40:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24154; /* uminv8hi3 */

    case 41:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24168; /* uminv16hi3 */

    case 42:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24182; /* uminv32hi3 */

    case 43:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24196; /* uminv64hi3 */

    case 44:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24210; /* uminv128hi3 */

    case 45:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24224; /* uminv256hi3 */

    case 46:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24238; /* uminv512hi3 */

    case 47:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24252; /* uminv1024hi3 */

    case 48:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24266; /* uminv2048hi3 */

    case 49:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24280; /* uminv1si3 */

    case 50:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24294; /* uminv2si3 */

    case 51:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24308; /* uminv4si3 */

    case 52:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24322; /* uminv8si3 */

    case 53:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24336; /* uminv16si3 */

    case 54:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24350; /* uminv32si3 */

    case 55:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24364; /* uminv64si3 */

    case 56:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24378; /* uminv128si3 */

    case 57:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24392; /* uminv256si3 */

    case 58:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24406; /* uminv512si3 */

    case 59:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24420; /* uminv1024si3 */

    case 60:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24434; /* uminv1di3 */

    case 61:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24448; /* uminv2di3 */

    case 62:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24462; /* uminv4di3 */

    case 63:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24476; /* uminv8di3 */

    case 64:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24490; /* uminv16di3 */

    case 65:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24504; /* uminv32di3 */

    case 66:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24518; /* uminv64di3 */

    case 67:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24532; /* uminv128di3 */

    case 68:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24546; /* uminv256di3 */

    case 69:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24560; /* uminv512di3 */

    default:
      return -1;
    }
}

 int
recog_1491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!(
#line 1480 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 51; /* sqrtsf2 */

    case 1:
      if (!(
#line 1480 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 52; /* sqrtdf2 */

    case 2:
      if (!(
#line 1480 "../../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 53; /* sqrthf2 */

    case 3:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26204; /* sqrtrvvm8hf2 */

    case 4:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26205; /* sqrtrvvm4hf2 */

    case 5:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26206; /* sqrtrvvm2hf2 */

    case 6:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26207; /* sqrtrvvm1hf2 */

    case 7:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26208; /* sqrtrvvmf2hf2 */

    case 8:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26209; /* sqrtrvvmf4hf2 */

    case 9:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26210; /* sqrtrvvm8sf2 */

    case 10:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26211; /* sqrtrvvm4sf2 */

    case 11:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26212; /* sqrtrvvm2sf2 */

    case 12:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26213; /* sqrtrvvm1sf2 */

    case 13:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26214; /* sqrtrvvmf2sf2 */

    case 14:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26215; /* sqrtrvvm8df2 */

    case 15:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26216; /* sqrtrvvm4df2 */

    case 16:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26217; /* sqrtrvvm2df2 */

    case 17:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26218; /* sqrtrvvm1df2 */

    case 18:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26219; /* sqrtv1hf2 */

    case 19:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26220; /* sqrtv2hf2 */

    case 20:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26221; /* sqrtv4hf2 */

    case 21:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26222; /* sqrtv8hf2 */

    case 22:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26223; /* sqrtv16hf2 */

    case 23:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26224; /* sqrtv32hf2 */

    case 24:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26225; /* sqrtv64hf2 */

    case 25:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26226; /* sqrtv128hf2 */

    case 26:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26227; /* sqrtv256hf2 */

    case 27:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26228; /* sqrtv512hf2 */

    case 28:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26229; /* sqrtv1024hf2 */

    case 29:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26230; /* sqrtv2048hf2 */

    case 30:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26231; /* sqrtv1sf2 */

    case 31:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26232; /* sqrtv2sf2 */

    case 32:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26233; /* sqrtv4sf2 */

    case 33:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26234; /* sqrtv8sf2 */

    case 34:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26235; /* sqrtv16sf2 */

    case 35:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26236; /* sqrtv32sf2 */

    case 36:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26237; /* sqrtv64sf2 */

    case 37:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26238; /* sqrtv128sf2 */

    case 38:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26239; /* sqrtv256sf2 */

    case 39:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26240; /* sqrtv512sf2 */

    case 40:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26241; /* sqrtv1024sf2 */

    case 41:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26242; /* sqrtv1df2 */

    case 42:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26243; /* sqrtv2df2 */

    case 43:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26244; /* sqrtv4df2 */

    case 44:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26245; /* sqrtv8df2 */

    case 45:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26246; /* sqrtv16df2 */

    case 46:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26247; /* sqrtv32df2 */

    case 47:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26248; /* sqrtv64df2 */

    case 48:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26249; /* sqrtv128df2 */

    case 49:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26250; /* sqrtv256df2 */

    case 50:
      if (!(
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26251; /* sqrtv512df2 */

    default:
      return -1;
    }
}

 int
recog_1504 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_1500 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_1501 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) == SET)
    {
      res = recog_1502 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (x5))
    {
    case USE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8QImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2743; /* *movrvvm8qi_reg_whole_vtype */

        case E_RVVM4QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4QImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2744; /* *movrvvm4qi_reg_whole_vtype */

        case E_RVVM2QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2QImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2745; /* *movrvvm2qi_reg_whole_vtype */

        case E_RVVM1QImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1QImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1QImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2746; /* *movrvvm1qi_reg_whole_vtype */

        case E_RVVM8HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2747; /* *movrvvm8hi_reg_whole_vtype */

        case E_RVVM4HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2748; /* *movrvvm4hi_reg_whole_vtype */

        case E_RVVM2HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2749; /* *movrvvm2hi_reg_whole_vtype */

        case E_RVVM1HImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2750; /* *movrvvm1hi_reg_whole_vtype */

        case E_RVVM8BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8BFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 899 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2751; /* *movrvvm8bf_reg_whole_vtype */

        case E_RVVM4BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4BFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 899 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2752; /* *movrvvm4bf_reg_whole_vtype */

        case E_RVVM2BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2BFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 900 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2753; /* *movrvvm2bf_reg_whole_vtype */

        case E_RVVM1BFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1BFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1BFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 900 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
            return -1;
          return 2754; /* *movrvvm1bf_reg_whole_vtype */

        case E_RVVM8HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 902 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2755; /* *movrvvm8hf_reg_whole_vtype */

        case E_RVVM4HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 902 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2756; /* *movrvvm4hf_reg_whole_vtype */

        case E_RVVM2HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 903 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2757; /* *movrvvm2hf_reg_whole_vtype */

        case E_RVVM1HFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1HFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 903 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
            return -1;
          return 2758; /* *movrvvm1hf_reg_whole_vtype */

        case E_RVVM8SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2759; /* *movrvvm8si_reg_whole_vtype */

        case E_RVVM4SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2760; /* *movrvvm4si_reg_whole_vtype */

        case E_RVVM2SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2761; /* *movrvvm2si_reg_whole_vtype */

        case E_RVVM1SImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SImode)
              || !
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
            return -1;
          return 2762; /* *movrvvm1si_reg_whole_vtype */

        case E_RVVM8SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 907 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2763; /* *movrvvm8sf_reg_whole_vtype */

        case E_RVVM4SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 907 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2764; /* *movrvvm4sf_reg_whole_vtype */

        case E_RVVM2SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 908 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2765; /* *movrvvm2sf_reg_whole_vtype */

        case E_RVVM1SFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1SFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 908 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 2766; /* *movrvvm1sf_reg_whole_vtype */

        case E_RVVM8DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DImode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 910 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2767; /* *movrvvm8di_reg_whole_vtype */

        case E_RVVM4DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DImode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 910 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2768; /* *movrvvm4di_reg_whole_vtype */

        case E_RVVM2DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DImode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 911 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2769; /* *movrvvm2di_reg_whole_vtype */

        case E_RVVM1DImode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DImode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DImode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 911 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2770; /* *movrvvm1di_reg_whole_vtype */

        case E_RVVM8DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM8DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2771; /* *movrvvm8df_reg_whole_vtype */

        case E_RVVM4DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM4DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 913 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2772; /* *movrvvm4df_reg_whole_vtype */

        case E_RVVM2DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM2DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2773; /* *movrvvm2df_reg_whole_vtype */

        case E_RVVM1DFmode:
          if (!reg_or_mem_operand (operands[0], E_RVVM1DFmode)
              || !reg_or_mem_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 1248 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 914 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 2774; /* *movrvvm1df_reg_whole_vtype */

        default:
          return -1;
        }

    case CLOBBER:
      return recog_1503 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 2
          || !register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x5, 0, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[4] = x7;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 81:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          if (GET_MODE (x9) != E_SImode
              || !register_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          operands[5] = x10;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          switch (pattern573 (x9))
            {
            case 0:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 744; /* subword_atomic_fetch_strong_add */

            case 1:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 745; /* subword_atomic_fetch_strong_or */

            case 2:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 746; /* subword_atomic_fetch_strong_xor */

            case 3:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 747; /* subword_atomic_fetch_strong_and */

            case 4:
              if (!
#line 284 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              *pnum_clobbers = 2;
              return 748; /* subword_atomic_fetch_strong_nand */

            default:
              return -1;
            }

        case 84:
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          operands[2] = x9;
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[4], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!scratch_operand (operands[5], E_SImode)
              || !
#line 493 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
            return -1;
          return 763; /* subword_atomic_exchange_strong */

        default:
          return -1;
        }

    case CLOBBER:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      return recog_1512 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1514 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_1513 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG
          || pattern221 (x1, 
9) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 8)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x10) != SET
          || pattern549 (x10, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x11) != SET)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PLUS)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 2)
        return -1;
      x14 = XEXP (x11, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x12, 1);
      operands[0] = x15;
      if (!stack_push_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern732 (x1))
        {
        case 0:
          if (pattern735 (x1, 
E_SImode) != 0
              || !(
#line 1142 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32828; /* gpr_multi_push_up_to_s1_si */

        case 1:
          if (pattern735 (x1, 
E_DImode) != 0
              || !(
#line 1142 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32829; /* gpr_multi_push_up_to_s1_di */

        default:
          return -1;
        }

    case PLUS:
      x16 = XEXP (x3, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 2)
        return -1;
      x17 = XEXP (x2, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET
          || pattern389 (x4) != 0)
        return -1;
      x18 = XEXP (x3, 1);
      operands[0] = x18;
      x5 = XEXP (x4, 1);
      x19 = XEXP (x5, 0);
      x20 = XEXP (x19, 1);
      switch (XWINT (x20, 0))
        {
        case -4L:
          switch (pattern475 (x1, 
E_SImode, 
-12, 
-8))
            {
            case 0:
              if (!(
#line 59 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32756; /* gpr_multi_pop_up_to_s1_si */

            case 1:
              if (!(
#line 363 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32776; /* gpr_multi_popret_up_to_ra_si */

            default:
              return -1;
            }

        case -8L:
          switch (pattern475 (x1, 
E_DImode, 
-24, 
-16))
            {
            case 0:
              if (!(
#line 59 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32757; /* gpr_multi_pop_up_to_s1_di */

            case 1:
              if (!(
#line 363 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32777; /* gpr_multi_popret_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      if (pattern119 (x1, 
CLOBBER, 
22) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != RETURN
          || !
#line 277 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
        return -1;
      return 885; /* th_int_pop */

    case SET:
      if (pattern120 (x1, 
23, 
24, 
25, 
26, 
27) != 0
          || pattern741 (x1, 
18, 
19, 
20, 
21, 
22) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 11);
      if (pattern763 (x4) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 9)
        return -1;
      x6 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 8)
        return -1;
      x12 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 1);
      if (GET_CODE (x13) != MEM)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XEXP (x12, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 1)
        return -1;
      x18 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x18) != SET)
        return -1;
      x19 = XEXP (x18, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x18, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 10)
        return -1;
      x21 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x21) != USE)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 10)
        return -1;
      x23 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x3 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x3) != USE)
        return -1;
      x24 = XEXP (x3, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 1
          || GET_MODE (x24) != E_SImode)
        return -1;
      x25 = XEXP (x2, 1);
      x26 = XEXP (x25, 1);
      operands[0] = x26;
      if (!stack_pop_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern771 (x1))
        {
        case 0:
          if (XWINT (x10, 0) != -48L
              || XWINT (x16, 0) != -52L
              || pattern794 (x1, 
E_SImode) != 0
              || !(
#line 1100 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32822; /* gpr_multi_popretz_up_to_s11_si */

        case 1:
          if (XWINT (x10, 0) != -96L
              || XWINT (x16, 0) != -104L
              || pattern794 (x1, 
E_DImode) != 0
              || !(
#line 1100 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32823; /* gpr_multi_popretz_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern371 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern726 (x1))
        {
        case 0:
          switch (pattern734 (x1, 
E_SImode, 
-28, 
-24, 
-20, 
-16))
            {
            case 0:
              if (!(
#line 157 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32764; /* gpr_multi_pop_up_to_s5_si */

            case 1:
              if (!(
#line 445 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32784; /* gpr_multi_popret_up_to_s3_si */

            case 2:
              if (!(
#line 764 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32804; /* gpr_multi_popretz_up_to_s1_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern734 (x1, 
E_DImode, 
-56, 
-48, 
-40, 
-32))
            {
            case 0:
              if (!(
#line 157 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32765; /* gpr_multi_pop_up_to_s5_di */

            case 1:
              if (!(
#line 445 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32785; /* gpr_multi_popret_up_to_s3_di */

            case 2:
              if (!(
#line 764 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32805; /* gpr_multi_popretz_up_to_s1_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 21)
        return -1;
      x6 = XEXP (x2, 0);
      if (pattern364 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 20)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != MEM)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x1, 0, 2);
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 19)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != MEM)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != PLUS)
        return -1;
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x1, 0, 3);
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 18)
        return -1;
      x21 = XEXP (x19, 0);
      if (GET_CODE (x21) != MEM)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != PLUS)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 2)
        return -1;
      x24 = XEXP (x22, 1);
      if (GET_CODE (x24) != CONST_INT
          || pattern733 (x1, 
9) != 0
          || pattern737 (x1, 
8) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (pattern536 (x25, 
1) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x26) != SET)
        return -1;
      x27 = XEXP (x26, 1);
      if (GET_CODE (x27) != PLUS)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 2)
        return -1;
      x30 = XEXP (x27, 1);
      operands[0] = x30;
      if (!stack_push_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern756 (x1))
        {
        case 0:
          if (pattern761 (x1, 
E_SImode) != 0
              || !(
#line 1240 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32836; /* gpr_multi_push_up_to_s5_si */

        case 1:
          if (pattern761 (x1, 
E_DImode) != 0
              || !(
#line 1240 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32837; /* gpr_multi_push_up_to_s5_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x2) != SET)
    return -1;
  switch (pattern391 (x1, 
23, 
24))
    {
    case 0:
      x3 = XVECEXP (x1, 0, 6);
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 2)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      switch (pattern739 (x1))
        {
        case 0:
          if (XWINT (x7, 0) != -24L)
            return -1;
          switch (pattern751 (x1, 
-28, 
E_SImode, 
-32))
            {
            case 0:
              if (pattern775 (x1, 
9) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern787 (x12) != 0
                  || !(
#line 262 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32770; /* gpr_multi_pop_up_to_s8_si */

            case 1:
              if (!(
#line 538 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32790; /* gpr_multi_popret_up_to_s6_si */

            case 2:
              if (!(
#line 848 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32810; /* gpr_multi_popretz_up_to_s4_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x7, 0) != -48L)
            return -1;
          switch (pattern751 (x1, 
-56, 
E_DImode, 
-64))
            {
            case 0:
              x13 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x13) != SET)
                return -1;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != MEM
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 2
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XEXP (x15, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 9
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x19 = XEXP (x10, 1);
              if (GET_CODE (x19) != MEM
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 2
                  || GET_MODE (x21) != E_DImode)
                return -1;
              x22 = XEXP (x20, 1);
              if (GET_CODE (x22) != CONST_INT
                  || XWINT (x22, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 8
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 10);
              if (pattern788 (x12) != 0
                  || !(
#line 262 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32771; /* gpr_multi_pop_up_to_s8_di */

            case 1:
              if (!(
#line 538 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32791; /* gpr_multi_popret_up_to_s6_di */

            case 2:
              if (!(
#line 848 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32811; /* gpr_multi_popretz_up_to_s4_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern537 (x1, 
18, 
19, 
20, 
21, 
22) != 0
          || pattern749 (x1, 
9) != 0
          || pattern759 (x1, 
1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x12) != SET)
        return -1;
      x23 = XEXP (x12, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 2)
        return -1;
      x25 = XEXP (x12, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x23, 1);
      operands[0] = x26;
      if (!stack_push_up_to_s8_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern766 (x1))
        {
        case 0:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -40L
              || pattern773 (x1, 
E_SImode) != 0
              || !(
#line 1345 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32842; /* gpr_multi_push_up_to_s8_si */

        case 1:
          x10 = XVECEXP (x1, 0, 9);
          x11 = XEXP (x10, 0);
          x27 = XEXP (x11, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != -80L
              || pattern773 (x1, 
E_DImode) != 0
              || !(
#line 1345 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32843; /* gpr_multi_push_up_to_s8_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (pattern755 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XVECEXP (x1, 0, 11);
  if (pattern763 (x9) != 0)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG)
    return -1;
  x13 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x13) != RETURN)
    return -1;
  x14 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x14) != USE)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 1
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  operands[0] = x18;
  switch (pattern771 (x1))
    {
    case 0:
      switch (pattern780 (x1, 
E_SImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern798 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern801 (x20) != 0
              || !(
#line 707 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32798; /* gpr_multi_popret_up_to_s11_si */

        case 1:
          if (!(
#line 1048 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32820; /* gpr_multi_popretz_up_to_s9_si */

        default:
          return -1;
        }

    case 1:
      switch (pattern780 (x1, 
E_DImode))
        {
        case 0:
          x19 = XEXP (x11, 1);
          if (pattern799 (x19) != 0
              || REGNO (x12) != 8)
            return -1;
          x20 = XVECEXP (x1, 0, 13);
          if (pattern802 (x20) != 0
              || !(
#line 707 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32799; /* gpr_multi_popret_up_to_s11_di */

        case 1:
          if (!(
#line 1048 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32821; /* gpr_multi_popretz_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_1527 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_1509 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_1510 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_1511 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_1514 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_1515 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 17:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == UNSPEC_VOLATILE
              && pattern119 (x1, 
USE, 
21) == 0
              && 
#line 253 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
            return 884; /* th_int_push */
          break;

        case 18:
          res = recog_1516 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_1517 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_1518 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 9:
          res = recog_1519 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          res = recog_1520 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 11:
          res = recog_1521 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 12:
          res = recog_1522 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 14:
          res = recog_1523 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 13:
          res = recog_1524 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_1525 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 15:
          res = recog_1526 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[1] = x1;
      if (!gpr_save_operation (operands[1], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      return 458; /* gpr_save */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 293; /* fence */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2839 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZIFENCEI))
                return -1;
              return 294; /* fence_i */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 295; /* riscv_pause */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 446; /* blockage */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 459; /* gpr_restore */

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4056 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 462; /* riscv_fscsr */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!csr_operand (operands[0], E_SImode)
                  || !
#line 4069 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 464; /* riscv_fsflags */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4215 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 477; /* riscv_clean_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4215 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 478; /* riscv_clean_di */

                default:
                  return -1;
                }

            case 16:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4223 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 479; /* riscv_flush_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4223 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 480; /* riscv_flush_di */

                default:
                  return -1;
                }

            case 17:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4231 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 481; /* riscv_inval_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4231 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 482; /* riscv_inval_di */

                default:
                  return -1;
                }

            case 18:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4239 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 483; /* riscv_zero_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4239 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 484; /* riscv_zero_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          switch (XINT (x1, 1))
            {
            case 6:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (!register_operand (operands[0], E_SFmode)
                      || !register_operand (operands[1], E_SFmode)
                      || !
#line 4077 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                    return -1;
                  return 465; /* *riscv_fsnvsnansf2 */

                case E_DFmode:
                  if (!register_operand (operands[0], E_DFmode)
                      || !register_operand (operands[1], E_DFmode)
                      || !(
#line 4077 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 466; /* *riscv_fsnvsnandf2 */

                case E_HFmode:
                  if (!register_operand (operands[0], E_HFmode)
                      || !register_operand (operands[1], E_HFmode)
                      || !(
#line 4077 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 467; /* *riscv_fsnvsnanhf2 */

                default:
                  return -1;
                }

            case 19:
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!address_operand (operands[0], E_SImode)
                      || !imm5_operand (operands[1], E_SImode)
                      || !(
#line 4268 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 486; /* riscv_prefetchi_si */

                case E_DImode:
                  if (!address_operand (operands[0], E_DImode)
                      || !imm5_operand (operands[1], E_DImode)
                      || !(
#line 4268 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 487; /* riscv_prefetchi_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 447; /* simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3834 "../../../gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 449; /* eh_set_lr_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 3841 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 450; /* eh_set_lr_di */

        default:
          return -1;
        }

    case EH_RETURN:
      return 451; /* eh_return_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 456; /* nop */

    case TRAP_IF:
      x5 = XEXP (x1, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 457; /* trap */

    case PREFETCH:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[1] = x6;
      if (!imm5_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x1, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 4248 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP))
        return -1;
      return 485; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern147 (x2))
        {
        case 0:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8133 (insn, operands);

        case 1:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8139 (insn, operands);

        case 2:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8145 (insn, operands);

        case 3:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8151 (insn, operands);

        case 4:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8157 (insn, operands);

        case 5:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8163 (insn, operands);

        case 6:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8169 (insn, operands);

        case 7:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8175 (insn, operands);

        case 8:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8181 (insn, operands);

        case 9:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8187 (insn, operands);

        case 10:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8193 (insn, operands);

        case 11:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8199 (insn, operands);

        case 12:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8205 (insn, operands);

        case 13:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8211 (insn, operands);

        case 14:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8217 (insn, operands);

        case 15:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8223 (insn, operands);

        case 16:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8229 (insn, operands);

        case 17:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8235 (insn, operands);

        case 18:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8241 (insn, operands);

        case 19:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8247 (insn, operands);

        case 20:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8253 (insn, operands);

        case 21:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8259 (insn, operands);

        case 22:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8265 (insn, operands);

        case 23:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8271 (insn, operands);

        case 24:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8277 (insn, operands);

        case 25:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8283 (insn, operands);

        case 26:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8289 (insn, operands);

        case 27:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8295 (insn, operands);

        case 28:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8301 (insn, operands);

        case 29:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8307 (insn, operands);

        case 30:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8313 (insn, operands);

        case 31:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8319 (insn, operands);

        case 32:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8325 (insn, operands);

        case 33:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8331 (insn, operands);

        case 34:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8337 (insn, operands);

        case 35:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8343 (insn, operands);

        case 36:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8349 (insn, operands);

        case 37:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8355 (insn, operands);

        case 38:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8361 (insn, operands);

        case 39:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8367 (insn, operands);

        case 40:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8373 (insn, operands);

        case 41:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8379 (insn, operands);

        case 42:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8385 (insn, operands);

        case 43:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8391 (insn, operands);

        case 44:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8397 (insn, operands);

        case 45:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8403 (insn, operands);

        case 46:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8409 (insn, operands);

        case 47:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8415 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern148 (x2))
        {
        case 0:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8517 (insn, operands);

        case 1:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8519 (insn, operands);

        case 2:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8521 (insn, operands);

        case 3:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8523 (insn, operands);

        case 4:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8525 (insn, operands);

        case 5:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8527 (insn, operands);

        case 6:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8529 (insn, operands);

        case 7:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8531 (insn, operands);

        case 8:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8533 (insn, operands);

        case 9:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8535 (insn, operands);

        case 10:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8537 (insn, operands);

        case 11:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8539 (insn, operands);

        case 12:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8541 (insn, operands);

        case 13:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8543 (insn, operands);

        case 14:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8545 (insn, operands);

        case 15:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8547 (insn, operands);

        case 16:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8549 (insn, operands);

        case 17:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8551 (insn, operands);

        case 18:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8553 (insn, operands);

        case 19:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8555 (insn, operands);

        case 20:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8557 (insn, operands);

        case 21:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8559 (insn, operands);

        case 22:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8561 (insn, operands);

        case 23:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8563 (insn, operands);

        case 24:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8565 (insn, operands);

        case 25:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8567 (insn, operands);

        case 26:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8569 (insn, operands);

        case 27:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8571 (insn, operands);

        case 28:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8573 (insn, operands);

        case 29:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8575 (insn, operands);

        case 30:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8577 (insn, operands);

        case 31:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8579 (insn, operands);

        case 32:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8581 (insn, operands);

        case 33:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8583 (insn, operands);

        case 34:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8585 (insn, operands);

        case 35:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8587 (insn, operands);

        case 36:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8589 (insn, operands);

        case 37:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8591 (insn, operands);

        case 38:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8593 (insn, operands);

        case 39:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8595 (insn, operands);

        case 40:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8597 (insn, operands);

        case 41:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8599 (insn, operands);

        case 42:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8601 (insn, operands);

        case 43:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8603 (insn, operands);

        case 44:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8605 (insn, operands);

        case 45:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8607 (insn, operands);

        case 46:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8609 (insn, operands);

        case 47:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8611 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return gen_split_317 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16DFmode)
       || !register_operand (operands[1], V16DFmode)))))
        return gen_split_1981 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2164 (insn, operands);
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_315 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DFmode)
       || !register_operand (operands[1], V4DFmode)))))
        return gen_split_1979 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2162 (insn, operands);
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SFmode)
      && reg_or_mem_operand (operands[1], E_V16SFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return gen_split_306 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))) && 
#line 4274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SFmode)
       || !register_operand (operands[1], V16SFmode)))))
        return gen_split_1976 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SFmode)
      || !register_operand (operands[1], E_V16SFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2153 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SFmode)
      && reg_or_mem_operand (operands[1], E_V1SFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_302 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SFmode)
       || register_operand (operands[1], V1SFmode))) && 
#line 4270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SFmode)
       || !register_operand (operands[1], V1SFmode)))))
        return gen_split_1972 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SFmode)
      || !register_operand (operands[1], E_V1SFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2149 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HFmode)
      && reg_or_mem_operand (operands[1], E_V2HFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_291 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HFmode)
       || register_operand (operands[1], V2HFmode))) && 
#line 4266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HFmode)
       || !register_operand (operands[1], V2HFmode)))))
        return gen_split_1968 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HFmode)
      || !register_operand (operands[1], E_V2HFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2138 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DImode)
      && reg_or_mem_operand (operands[1], E_V4DImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_282 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))) && 
#line 4262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DImode)
       || !register_operand (operands[1], V4DImode)))))
        return gen_split_1964 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DImode)
      || !register_operand (operands[1], E_V4DImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2129 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return gen_split_271 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4SImode)
       || !register_operand (operands[1], V4SImode)))))
        return gen_split_1959 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2118 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HImode)
      && reg_or_mem_operand (operands[1], E_V2HImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return gen_split_258 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 4251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HImode)
       || !register_operand (operands[1], V2HImode)))))
        return gen_split_1953 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HImode)
      || !register_operand (operands[1], E_V2HImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2105 (insn, operands);
}

 rtx_insn *
split_44 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return gen_split_244 (insn, operands);
      if (((
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1440 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1QImode)
       || !register_operand (operands[1], V1QImode)))))
        return gen_split_1947 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2091 (insn, operands);
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_321 (insn, operands);
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2168 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SFmode)
      && reg_or_mem_operand (operands[1], E_V256SFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_310 (insn, operands);
  if (!register_operand (operands[0], E_V256SFmode)
      || !register_operand (operands[1], E_V256SFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2157 (insn, operands);
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512HFmode)
      && reg_or_mem_operand (operands[1], E_V512HFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_299 (insn, operands);
  if (!register_operand (operands[0], E_V512HFmode)
      || !register_operand (operands[1], E_V512HFmode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2146 (insn, operands);
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DImode)
      && reg_or_mem_operand (operands[1], E_V256DImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_288 (insn, operands);
  if (!register_operand (operands[0], E_V256DImode)
      || !register_operand (operands[1], E_V256DImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2135 (insn, operands);
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SImode)
      && reg_or_mem_operand (operands[1], E_V256SImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return gen_split_277 (insn, operands);
  if (!register_operand (operands[0], E_V256SImode)
      || !register_operand (operands[1], E_V256SImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2124 (insn, operands);
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HImode)
      && reg_or_mem_operand (operands[1], E_V256HImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_265 (insn, operands);
  if (!register_operand (operands[0], E_V256HImode)
      || !register_operand (operands[1], E_V256HImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2112 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512QImode)
      && reg_or_mem_operand (operands[1], E_V512QImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_253 (insn, operands);
  if (!register_operand (operands[0], E_V512QImode)
      || !register_operand (operands[1], E_V512QImode)
      || !((
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1510 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2100 (insn, operands);
}

 rtx_insn *
split_96 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BImode)
      && 
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_241 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BImode)
      || !register_operand (operands[1], E_RVVMF4BImode)
      || !(
#line 1293 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1578 (insn, operands);
}

 rtx_insn *
split_103 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return gen_split_226 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2HFmode)
      || !register_operand (operands[1], E_RVVMF2HFmode)
      || !((
#line 1256 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1258 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1570 (insn, operands);
}

 rtx_insn *
split_109 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_DImode)
      && splittable_const_int_operand (operands[1], E_DImode)
      && ((
#line 2458 "../../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], DImode)
        || high_mask_shift_operand (operands[1], DImode))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2462 "../../../gcc/config/riscv/riscv.md"
( 1)))
    return gen_split_19 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_DImode)
      || !move_operand (operands[1], E_DImode)
      || !
#line 2719 "../../../gcc/config/riscv/riscv.md"
(reload_completed
   && riscv_split_64bit_move_p (operands[0], operands[1])))
    return NULL;
  return gen_split_20 (insn, operands);
}

 rtx_insn *
split_116 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4945 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4947 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4949 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4951 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4953 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4955 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4957 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4959 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4961 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4963 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4965 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4967 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4969 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4971 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4973 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4975 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4977 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4979 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4981 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4983 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4985 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4987 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4989 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4991 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4993 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4995 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4997 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4999 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5001 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5003 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5005 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5007 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5009 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5011 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5013 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5015 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5017 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5019 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5021 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5023 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5025 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5027 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5029 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5031 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5033 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5035 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5037 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5039 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5041 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5043 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5045 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5047 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5049 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5051 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5053 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5055 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5057 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5059 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5061 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5063 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5065 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5067 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5069 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5071 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5073 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5075 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5077 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5079 (insn, operands);

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5081 (insn, operands);

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5083 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5085 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5087 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5089 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5091 (insn, operands);

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5093 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5095 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5097 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5099 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5101 (insn, operands);

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5103 (insn, operands);

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5105 (insn, operands);

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5107 (insn, operands);

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5109 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5111 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5113 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5115 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5117 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5119 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5121 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5123 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5125 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5127 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5129 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5131 (insn, operands);

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5133 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5135 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5137 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5139 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5141 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5143 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5145 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5147 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5149 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5151 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5153 (insn, operands);

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5155 (insn, operands);

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5157 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5159 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5161 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5163 (insn, operands);

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5165 (insn, operands);

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5167 (insn, operands);

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5169 (insn, operands);

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5171 (insn, operands);

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5173 (insn, operands);

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 1109 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1111 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5175 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_125 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_799 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_805 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_811 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_817 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_823 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_829 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_835 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_841 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_847 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_853 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_859 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_865 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_871 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_877 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_883 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_889 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_895 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_901 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_907 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_913 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_919 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_925 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_931 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_937 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_943 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_949 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_955 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_961 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_967 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_973 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_979 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_985 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_991 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_997 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1003 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1009 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1015 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1021 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1027 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1033 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1039 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1045 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1051 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1057 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1063 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1069 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1075 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1081 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1087 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1093 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1099 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1105 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1111 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1117 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1123 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1129 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1135 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1141 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1147 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1153 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1159 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1165 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1171 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1177 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1183 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1189 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1195 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1201 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1207 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1213 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1219 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1225 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1231 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1237 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1243 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1249 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1255 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1261 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1267 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1273 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1279 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1285 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1291 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1297 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1303 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1309 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1315 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1321 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1327 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1333 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1339 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1345 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1351 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1357 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1363 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1369 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1375 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1381 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1387 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1393 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1399 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1405 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1411 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1417 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1423 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1429 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1435 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1441 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1447 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1453 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1459 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1465 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1471 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1477 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1483 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1489 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1495 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1501 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1507 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1513 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1519 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern469 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1525 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_133 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern214 (x2))
    {
    case 0:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4027 (insn, operands);

    case 1:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4028 (insn, operands);

    case 2:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4029 (insn, operands);

    case 3:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4030 (insn, operands);

    case 4:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4031 (insn, operands);

    case 5:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4032 (insn, operands);

    case 6:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4033 (insn, operands);

    case 7:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4034 (insn, operands);

    case 8:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4035 (insn, operands);

    case 9:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4036 (insn, operands);

    case 10:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4037 (insn, operands);

    case 11:
      if (!(
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4038 (insn, operands);

    case 12:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4039 (insn, operands);

    case 13:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4040 (insn, operands);

    case 14:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4041 (insn, operands);

    case 15:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4042 (insn, operands);

    case 16:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4043 (insn, operands);

    case 17:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4044 (insn, operands);

    case 18:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4045 (insn, operands);

    case 19:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4046 (insn, operands);

    case 20:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4047 (insn, operands);

    case 21:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4048 (insn, operands);

    case 22:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4049 (insn, operands);

    case 23:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4050 (insn, operands);

    case 24:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4051 (insn, operands);

    case 25:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4052 (insn, operands);

    case 26:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4053 (insn, operands);

    case 27:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4054 (insn, operands);

    case 28:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4055 (insn, operands);

    case 29:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4056 (insn, operands);

    case 30:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4057 (insn, operands);

    case 31:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4058 (insn, operands);

    case 32:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4059 (insn, operands);

    case 33:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4060 (insn, operands);

    case 34:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4061 (insn, operands);

    case 35:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4062 (insn, operands);

    case 36:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4063 (insn, operands);

    case 37:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4064 (insn, operands);

    case 38:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4065 (insn, operands);

    case 39:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4066 (insn, operands);

    case 40:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4067 (insn, operands);

    case 41:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4068 (insn, operands);

    case 42:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4069 (insn, operands);

    case 43:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4070 (insn, operands);

    case 44:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4071 (insn, operands);

    case 45:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4072 (insn, operands);

    case 46:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4073 (insn, operands);

    case 47:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4074 (insn, operands);

    case 48:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4075 (insn, operands);

    case 49:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4076 (insn, operands);

    case 50:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4077 (insn, operands);

    case 51:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4078 (insn, operands);

    case 52:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4079 (insn, operands);

    case 53:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4080 (insn, operands);

    case 54:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4081 (insn, operands);

    case 55:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4082 (insn, operands);

    case 56:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4083 (insn, operands);

    case 57:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4084 (insn, operands);

    case 58:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4085 (insn, operands);

    case 59:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4086 (insn, operands);

    case 60:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4087 (insn, operands);

    case 61:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4088 (insn, operands);

    case 62:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4089 (insn, operands);

    case 63:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4090 (insn, operands);

    case 64:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4091 (insn, operands);

    case 65:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4092 (insn, operands);

    case 66:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4093 (insn, operands);

    case 67:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4094 (insn, operands);

    case 68:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4095 (insn, operands);

    case 69:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4096 (insn, operands);

    case 70:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4097 (insn, operands);

    case 71:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4098 (insn, operands);

    case 72:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4099 (insn, operands);

    case 73:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4100 (insn, operands);

    case 74:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4101 (insn, operands);

    case 75:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4102 (insn, operands);

    case 76:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4103 (insn, operands);

    case 77:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4104 (insn, operands);

    case 78:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4105 (insn, operands);

    case 79:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4106 (insn, operands);

    case 80:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4107 (insn, operands);

    case 81:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4108 (insn, operands);

    case 82:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4109 (insn, operands);

    case 83:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4110 (insn, operands);

    case 84:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4111 (insn, operands);

    case 85:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4112 (insn, operands);

    case 86:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4113 (insn, operands);

    case 87:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4114 (insn, operands);

    case 88:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4115 (insn, operands);

    case 89:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4116 (insn, operands);

    case 90:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4117 (insn, operands);

    case 91:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4118 (insn, operands);

    case 92:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4119 (insn, operands);

    case 93:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4120 (insn, operands);

    case 94:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4121 (insn, operands);

    case 95:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4122 (insn, operands);

    case 96:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4123 (insn, operands);

    case 97:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4124 (insn, operands);

    case 98:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4125 (insn, operands);

    case 99:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4126 (insn, operands);

    case 100:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4127 (insn, operands);

    case 101:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4128 (insn, operands);

    case 102:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4129 (insn, operands);

    case 103:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4130 (insn, operands);

    case 104:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4131 (insn, operands);

    case 105:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4132 (insn, operands);

    case 106:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4133 (insn, operands);

    case 107:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4134 (insn, operands);

    case 108:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4135 (insn, operands);

    case 109:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4136 (insn, operands);

    case 110:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4137 (insn, operands);

    case 111:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4138 (insn, operands);

    case 112:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4139 (insn, operands);

    case 113:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4140 (insn, operands);

    case 114:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4141 (insn, operands);

    case 115:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4142 (insn, operands);

    case 116:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4143 (insn, operands);

    case 117:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4144 (insn, operands);

    case 118:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4145 (insn, operands);

    case 119:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4146 (insn, operands);

    case 120:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4147 (insn, operands);

    case 121:
      if (!((
#line 591 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 593 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4148 (insn, operands);

    case 122:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6314 (insn, operands);

    case 123:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6315 (insn, operands);

    case 124:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6316 (insn, operands);

    case 125:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6317 (insn, operands);

    case 126:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6318 (insn, operands);

    case 127:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6319 (insn, operands);

    case 128:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6320 (insn, operands);

    case 129:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6321 (insn, operands);

    case 130:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6322 (insn, operands);

    case 131:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6323 (insn, operands);

    case 132:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6324 (insn, operands);

    case 133:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6325 (insn, operands);

    case 134:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6326 (insn, operands);

    case 135:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6327 (insn, operands);

    case 136:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6328 (insn, operands);

    case 137:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6329 (insn, operands);

    case 138:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6330 (insn, operands);

    case 139:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6331 (insn, operands);

    case 140:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6332 (insn, operands);

    case 141:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6333 (insn, operands);

    case 142:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6334 (insn, operands);

    case 143:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6335 (insn, operands);

    case 144:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6336 (insn, operands);

    case 145:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6337 (insn, operands);

    case 146:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6338 (insn, operands);

    case 147:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6339 (insn, operands);

    case 148:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6340 (insn, operands);

    case 149:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6341 (insn, operands);

    case 150:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6342 (insn, operands);

    case 151:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6343 (insn, operands);

    case 152:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6344 (insn, operands);

    case 153:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6345 (insn, operands);

    case 154:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6346 (insn, operands);

    case 155:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6347 (insn, operands);

    case 156:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6348 (insn, operands);

    case 157:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6349 (insn, operands);

    case 158:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6350 (insn, operands);

    case 159:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6351 (insn, operands);

    case 160:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6352 (insn, operands);

    case 161:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6353 (insn, operands);

    case 162:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6354 (insn, operands);

    case 163:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6355 (insn, operands);

    case 164:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6356 (insn, operands);

    case 165:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6357 (insn, operands);

    case 166:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6358 (insn, operands);

    case 167:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6359 (insn, operands);

    case 168:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6360 (insn, operands);

    case 169:
      if (!((
#line 107 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6361 (insn, operands);

    case 170:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6362 (insn, operands);

    case 171:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6363 (insn, operands);

    case 172:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6364 (insn, operands);

    case 173:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6365 (insn, operands);

    case 174:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6366 (insn, operands);

    case 175:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6367 (insn, operands);

    case 176:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6368 (insn, operands);

    case 177:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6369 (insn, operands);

    case 178:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6370 (insn, operands);

    case 179:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6371 (insn, operands);

    case 180:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6372 (insn, operands);

    case 181:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6373 (insn, operands);

    case 182:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6374 (insn, operands);

    case 183:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6375 (insn, operands);

    case 184:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6376 (insn, operands);

    case 185:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6377 (insn, operands);

    case 186:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6378 (insn, operands);

    case 187:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6379 (insn, operands);

    case 188:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6380 (insn, operands);

    case 189:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6381 (insn, operands);

    case 190:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6382 (insn, operands);

    case 191:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6383 (insn, operands);

    case 192:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6384 (insn, operands);

    case 193:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6385 (insn, operands);

    case 194:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6386 (insn, operands);

    case 195:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6387 (insn, operands);

    case 196:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6388 (insn, operands);

    case 197:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6389 (insn, operands);

    case 198:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6390 (insn, operands);

    case 199:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6391 (insn, operands);

    case 200:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6392 (insn, operands);

    case 201:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6393 (insn, operands);

    case 202:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6394 (insn, operands);

    case 203:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6395 (insn, operands);

    case 204:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6396 (insn, operands);

    case 205:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6397 (insn, operands);

    case 206:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6398 (insn, operands);

    case 207:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6399 (insn, operands);

    case 208:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6400 (insn, operands);

    case 209:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6401 (insn, operands);

    case 210:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6402 (insn, operands);

    case 211:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6403 (insn, operands);

    case 212:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6404 (insn, operands);

    case 213:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6405 (insn, operands);

    case 214:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6406 (insn, operands);

    case 215:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6407 (insn, operands);

    case 216:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6408 (insn, operands);

    case 217:
      if (!((
#line 126 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6409 (insn, operands);

    case 218:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6410 (insn, operands);

    case 219:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6412 (insn, operands);

    case 220:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6414 (insn, operands);

    case 221:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6416 (insn, operands);

    case 222:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6418 (insn, operands);

    case 223:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6420 (insn, operands);

    case 224:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6422 (insn, operands);

    case 225:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6506 (insn, operands);

    case 226:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6424 (insn, operands);

    case 227:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6508 (insn, operands);

    case 228:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6426 (insn, operands);

    case 229:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6510 (insn, operands);

    case 230:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6428 (insn, operands);

    case 231:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6512 (insn, operands);

    case 232:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6430 (insn, operands);

    case 233:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6514 (insn, operands);

    case 234:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6432 (insn, operands);

    case 235:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6516 (insn, operands);

    case 236:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6566 (insn, operands);

    case 237:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6434 (insn, operands);

    case 238:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6518 (insn, operands);

    case 239:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6568 (insn, operands);

    case 240:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6436 (insn, operands);

    case 241:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6520 (insn, operands);

    case 242:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6570 (insn, operands);

    case 243:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6438 (insn, operands);

    case 244:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6522 (insn, operands);

    case 245:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6572 (insn, operands);

    case 246:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6440 (insn, operands);

    case 247:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6442 (insn, operands);

    case 248:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6444 (insn, operands);

    case 249:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6446 (insn, operands);

    case 250:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6448 (insn, operands);

    case 251:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6450 (insn, operands);

    case 252:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6452 (insn, operands);

    case 253:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6454 (insn, operands);

    case 254:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6456 (insn, operands);

    case 255:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6458 (insn, operands);

    case 256:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6460 (insn, operands);

    case 257:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6462 (insn, operands);

    case 258:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6464 (insn, operands);

    case 259:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6524 (insn, operands);

    case 260:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6466 (insn, operands);

    case 261:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6526 (insn, operands);

    case 262:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6468 (insn, operands);

    case 263:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6528 (insn, operands);

    case 264:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6470 (insn, operands);

    case 265:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6530 (insn, operands);

    case 266:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6472 (insn, operands);

    case 267:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6532 (insn, operands);

    case 268:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6474 (insn, operands);

    case 269:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6534 (insn, operands);

    case 270:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6476 (insn, operands);

    case 271:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6536 (insn, operands);

    case 272:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6478 (insn, operands);

    case 273:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6538 (insn, operands);

    case 274:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6480 (insn, operands);

    case 275:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6540 (insn, operands);

    case 276:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6482 (insn, operands);

    case 277:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6542 (insn, operands);

    case 278:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6484 (insn, operands);

    case 279:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6544 (insn, operands);

    case 280:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6486 (insn, operands);

    case 281:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6546 (insn, operands);

    case 282:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6574 (insn, operands);

    case 283:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6488 (insn, operands);

    case 284:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6548 (insn, operands);

    case 285:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6576 (insn, operands);

    case 286:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6490 (insn, operands);

    case 287:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6550 (insn, operands);

    case 288:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6578 (insn, operands);

    case 289:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6492 (insn, operands);

    case 290:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6552 (insn, operands);

    case 291:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6580 (insn, operands);

    case 292:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6494 (insn, operands);

    case 293:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6554 (insn, operands);

    case 294:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6582 (insn, operands);

    case 295:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6496 (insn, operands);

    case 296:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6556 (insn, operands);

    case 297:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6584 (insn, operands);

    case 298:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6498 (insn, operands);

    case 299:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6558 (insn, operands);

    case 300:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6586 (insn, operands);

    case 301:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6500 (insn, operands);

    case 302:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6560 (insn, operands);

    case 303:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6588 (insn, operands);

    case 304:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6502 (insn, operands);

    case 305:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6562 (insn, operands);

    case 306:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6590 (insn, operands);

    case 307:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6504 (insn, operands);

    case 308:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6564 (insn, operands);

    case 309:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6592 (insn, operands);

    case 310:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6411 (insn, operands);

    case 311:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6413 (insn, operands);

    case 312:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6415 (insn, operands);

    case 313:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6417 (insn, operands);

    case 314:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6419 (insn, operands);

    case 315:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6421 (insn, operands);

    case 316:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6423 (insn, operands);

    case 317:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6507 (insn, operands);

    case 318:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6425 (insn, operands);

    case 319:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6509 (insn, operands);

    case 320:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6427 (insn, operands);

    case 321:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6511 (insn, operands);

    case 322:
      if (!(
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6429 (insn, operands);

    case 323:
      if (!(
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6513 (insn, operands);

    case 324:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6431 (insn, operands);

    case 325:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6515 (insn, operands);

    case 326:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6433 (insn, operands);

    case 327:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6517 (insn, operands);

    case 328:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6567 (insn, operands);

    case 329:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6435 (insn, operands);

    case 330:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6519 (insn, operands);

    case 331:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6569 (insn, operands);

    case 332:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6437 (insn, operands);

    case 333:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6521 (insn, operands);

    case 334:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6571 (insn, operands);

    case 335:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6439 (insn, operands);

    case 336:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6523 (insn, operands);

    case 337:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6573 (insn, operands);

    case 338:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6441 (insn, operands);

    case 339:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6443 (insn, operands);

    case 340:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6445 (insn, operands);

    case 341:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6447 (insn, operands);

    case 342:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6449 (insn, operands);

    case 343:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6451 (insn, operands);

    case 344:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6453 (insn, operands);

    case 345:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6455 (insn, operands);

    case 346:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6457 (insn, operands);

    case 347:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6459 (insn, operands);

    case 348:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6461 (insn, operands);

    case 349:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6463 (insn, operands);

    case 350:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6465 (insn, operands);

    case 351:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6525 (insn, operands);

    case 352:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6467 (insn, operands);

    case 353:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6527 (insn, operands);

    case 354:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6469 (insn, operands);

    case 355:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6529 (insn, operands);

    case 356:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6471 (insn, operands);

    case 357:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6531 (insn, operands);

    case 358:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6473 (insn, operands);

    case 359:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6533 (insn, operands);

    case 360:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6475 (insn, operands);

    case 361:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6535 (insn, operands);

    case 362:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6477 (insn, operands);

    case 363:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6537 (insn, operands);

    case 364:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6479 (insn, operands);

    case 365:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6539 (insn, operands);

    case 366:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6481 (insn, operands);

    case 367:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6541 (insn, operands);

    case 368:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6483 (insn, operands);

    case 369:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6543 (insn, operands);

    case 370:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6485 (insn, operands);

    case 371:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6545 (insn, operands);

    case 372:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6487 (insn, operands);

    case 373:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6547 (insn, operands);

    case 374:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6575 (insn, operands);

    case 375:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6489 (insn, operands);

    case 376:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6549 (insn, operands);

    case 377:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6577 (insn, operands);

    case 378:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6491 (insn, operands);

    case 379:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6551 (insn, operands);

    case 380:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6579 (insn, operands);

    case 381:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6493 (insn, operands);

    case 382:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6553 (insn, operands);

    case 383:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6581 (insn, operands);

    case 384:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6495 (insn, operands);

    case 385:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6555 (insn, operands);

    case 386:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6583 (insn, operands);

    case 387:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6497 (insn, operands);

    case 388:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6557 (insn, operands);

    case 389:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6585 (insn, operands);

    case 390:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6499 (insn, operands);

    case 391:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6559 (insn, operands);

    case 392:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6587 (insn, operands);

    case 393:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6501 (insn, operands);

    case 394:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6561 (insn, operands);

    case 395:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6589 (insn, operands);

    case 396:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6503 (insn, operands);

    case 397:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6563 (insn, operands);

    case 398:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6591 (insn, operands);

    case 399:
      if (!((
#line 144 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6505 (insn, operands);

    case 400:
      if (!((
#line 164 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6565 (insn, operands);

    case 401:
      if (!((
#line 184 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 186 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6593 (insn, operands);

    case 402:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6778 (insn, operands);

    case 403:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6779 (insn, operands);

    case 404:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6780 (insn, operands);

    case 405:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6781 (insn, operands);

    case 406:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6782 (insn, operands);

    case 407:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6783 (insn, operands);

    case 408:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6784 (insn, operands);

    case 409:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6785 (insn, operands);

    case 410:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6786 (insn, operands);

    case 411:
      if (!(
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6787 (insn, operands);

    case 412:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6788 (insn, operands);

    case 413:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6789 (insn, operands);

    case 414:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6790 (insn, operands);

    case 415:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6791 (insn, operands);

    case 416:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6792 (insn, operands);

    case 417:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6793 (insn, operands);

    case 418:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6794 (insn, operands);

    case 419:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6795 (insn, operands);

    case 420:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6796 (insn, operands);

    case 421:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6797 (insn, operands);

    case 422:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6798 (insn, operands);

    case 423:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6799 (insn, operands);

    case 424:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6800 (insn, operands);

    case 425:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6801 (insn, operands);

    case 426:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6802 (insn, operands);

    case 427:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6803 (insn, operands);

    case 428:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6804 (insn, operands);

    case 429:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6805 (insn, operands);

    case 430:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6806 (insn, operands);

    case 431:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6807 (insn, operands);

    case 432:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6808 (insn, operands);

    case 433:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6809 (insn, operands);

    case 434:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6810 (insn, operands);

    case 435:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6811 (insn, operands);

    case 436:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6812 (insn, operands);

    case 437:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6813 (insn, operands);

    case 438:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6814 (insn, operands);

    case 439:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6815 (insn, operands);

    case 440:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6816 (insn, operands);

    case 441:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6817 (insn, operands);

    case 442:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6818 (insn, operands);

    case 443:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6819 (insn, operands);

    case 444:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6820 (insn, operands);

    case 445:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6821 (insn, operands);

    case 446:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6822 (insn, operands);

    case 447:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6823 (insn, operands);

    case 448:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6824 (insn, operands);

    case 449:
      if (!((
#line 283 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6825 (insn, operands);

    case 450:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7420 (insn, operands);

    case 451:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7424 (insn, operands);

    case 452:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7428 (insn, operands);

    case 453:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7432 (insn, operands);

    case 454:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7436 (insn, operands);

    case 455:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7440 (insn, operands);

    case 456:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7444 (insn, operands);

    case 457:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7448 (insn, operands);

    case 458:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7452 (insn, operands);

    case 459:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7456 (insn, operands);

    case 460:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7460 (insn, operands);

    case 461:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7464 (insn, operands);

    case 462:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7468 (insn, operands);

    case 463:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7472 (insn, operands);

    case 464:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7476 (insn, operands);

    case 465:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7480 (insn, operands);

    case 466:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7484 (insn, operands);

    case 467:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7488 (insn, operands);

    case 468:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7492 (insn, operands);

    case 469:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7496 (insn, operands);

    case 470:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7500 (insn, operands);

    case 471:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7504 (insn, operands);

    case 472:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7508 (insn, operands);

    case 473:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7512 (insn, operands);

    case 474:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7516 (insn, operands);

    case 475:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7520 (insn, operands);

    case 476:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7524 (insn, operands);

    case 477:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7528 (insn, operands);

    case 478:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7532 (insn, operands);

    case 479:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7536 (insn, operands);

    case 480:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7540 (insn, operands);

    case 481:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7544 (insn, operands);

    case 482:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7548 (insn, operands);

    case 483:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7552 (insn, operands);

    case 484:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7556 (insn, operands);

    case 485:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7560 (insn, operands);

    case 486:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7564 (insn, operands);

    case 487:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7568 (insn, operands);

    case 488:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7572 (insn, operands);

    case 489:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7576 (insn, operands);

    case 490:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7580 (insn, operands);

    case 491:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7584 (insn, operands);

    case 492:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7588 (insn, operands);

    case 493:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7592 (insn, operands);

    case 494:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7596 (insn, operands);

    case 495:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7600 (insn, operands);

    case 496:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7604 (insn, operands);

    case 497:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7608 (insn, operands);

    case 498:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7422 (insn, operands);

    case 499:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7426 (insn, operands);

    case 500:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7430 (insn, operands);

    case 501:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7434 (insn, operands);

    case 502:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7438 (insn, operands);

    case 503:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7442 (insn, operands);

    case 504:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7446 (insn, operands);

    case 505:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7450 (insn, operands);

    case 506:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7454 (insn, operands);

    case 507:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7458 (insn, operands);

    case 508:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7462 (insn, operands);

    case 509:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7466 (insn, operands);

    case 510:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7470 (insn, operands);

    case 511:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7474 (insn, operands);

    case 512:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7478 (insn, operands);

    case 513:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7482 (insn, operands);

    case 514:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7486 (insn, operands);

    case 515:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7490 (insn, operands);

    case 516:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7494 (insn, operands);

    case 517:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7498 (insn, operands);

    case 518:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7502 (insn, operands);

    case 519:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7506 (insn, operands);

    case 520:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7510 (insn, operands);

    case 521:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7514 (insn, operands);

    case 522:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7518 (insn, operands);

    case 523:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7522 (insn, operands);

    case 524:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7526 (insn, operands);

    case 525:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7530 (insn, operands);

    case 526:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7534 (insn, operands);

    case 527:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7538 (insn, operands);

    case 528:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7542 (insn, operands);

    case 529:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7546 (insn, operands);

    case 530:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7550 (insn, operands);

    case 531:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7554 (insn, operands);

    case 532:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7558 (insn, operands);

    case 533:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7562 (insn, operands);

    case 534:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7566 (insn, operands);

    case 535:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7570 (insn, operands);

    case 536:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7574 (insn, operands);

    case 537:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7578 (insn, operands);

    case 538:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7582 (insn, operands);

    case 539:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7586 (insn, operands);

    case 540:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7590 (insn, operands);

    case 541:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7594 (insn, operands);

    case 542:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7598 (insn, operands);

    case 543:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7602 (insn, operands);

    case 544:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7606 (insn, operands);

    case 545:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7610 (insn, operands);

    case 546:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7612 (insn, operands);

    case 547:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7614 (insn, operands);

    case 548:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7616 (insn, operands);

    case 549:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7618 (insn, operands);

    case 550:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7620 (insn, operands);

    case 551:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7622 (insn, operands);

    case 552:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7624 (insn, operands);

    case 553:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7626 (insn, operands);

    case 554:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7628 (insn, operands);

    case 555:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7630 (insn, operands);

    case 556:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7632 (insn, operands);

    case 557:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7634 (insn, operands);

    case 558:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7636 (insn, operands);

    case 559:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7638 (insn, operands);

    case 560:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7640 (insn, operands);

    case 561:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7642 (insn, operands);

    case 562:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7644 (insn, operands);

    case 563:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7646 (insn, operands);

    case 564:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7648 (insn, operands);

    case 565:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7650 (insn, operands);

    case 566:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7652 (insn, operands);

    case 567:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7654 (insn, operands);

    case 568:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7656 (insn, operands);

    case 569:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7658 (insn, operands);

    case 570:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7660 (insn, operands);

    case 571:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7662 (insn, operands);

    case 572:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7664 (insn, operands);

    case 573:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7666 (insn, operands);

    case 574:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7668 (insn, operands);

    case 575:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7670 (insn, operands);

    case 576:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7672 (insn, operands);

    case 577:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7674 (insn, operands);

    case 578:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7676 (insn, operands);

    case 579:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7678 (insn, operands);

    case 580:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7680 (insn, operands);

    case 581:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7682 (insn, operands);

    case 582:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7684 (insn, operands);

    case 583:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7686 (insn, operands);

    case 584:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7688 (insn, operands);

    case 585:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7690 (insn, operands);

    case 586:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7692 (insn, operands);

    case 587:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7694 (insn, operands);

    case 588:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7696 (insn, operands);

    case 589:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7698 (insn, operands);

    case 590:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7700 (insn, operands);

    case 591:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7702 (insn, operands);

    case 592:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7704 (insn, operands);

    case 593:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7706 (insn, operands);

    case 594:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7421 (insn, operands);

    case 595:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7425 (insn, operands);

    case 596:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7429 (insn, operands);

    case 597:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7433 (insn, operands);

    case 598:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7437 (insn, operands);

    case 599:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7441 (insn, operands);

    case 600:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7445 (insn, operands);

    case 601:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7449 (insn, operands);

    case 602:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7453 (insn, operands);

    case 603:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7457 (insn, operands);

    case 604:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7461 (insn, operands);

    case 605:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7465 (insn, operands);

    case 606:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7469 (insn, operands);

    case 607:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7473 (insn, operands);

    case 608:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7477 (insn, operands);

    case 609:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7481 (insn, operands);

    case 610:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7485 (insn, operands);

    case 611:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7489 (insn, operands);

    case 612:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7493 (insn, operands);

    case 613:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7497 (insn, operands);

    case 614:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7501 (insn, operands);

    case 615:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7505 (insn, operands);

    case 616:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7509 (insn, operands);

    case 617:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7513 (insn, operands);

    case 618:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7517 (insn, operands);

    case 619:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7521 (insn, operands);

    case 620:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7525 (insn, operands);

    case 621:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7529 (insn, operands);

    case 622:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7533 (insn, operands);

    case 623:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7537 (insn, operands);

    case 624:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7541 (insn, operands);

    case 625:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7545 (insn, operands);

    case 626:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7549 (insn, operands);

    case 627:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7553 (insn, operands);

    case 628:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7557 (insn, operands);

    case 629:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7561 (insn, operands);

    case 630:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7565 (insn, operands);

    case 631:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7569 (insn, operands);

    case 632:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7573 (insn, operands);

    case 633:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7577 (insn, operands);

    case 634:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7581 (insn, operands);

    case 635:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7585 (insn, operands);

    case 636:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7589 (insn, operands);

    case 637:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7593 (insn, operands);

    case 638:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7597 (insn, operands);

    case 639:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7601 (insn, operands);

    case 640:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7605 (insn, operands);

    case 641:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7609 (insn, operands);

    case 642:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7423 (insn, operands);

    case 643:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7427 (insn, operands);

    case 644:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7431 (insn, operands);

    case 645:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7435 (insn, operands);

    case 646:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7439 (insn, operands);

    case 647:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7443 (insn, operands);

    case 648:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7447 (insn, operands);

    case 649:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7451 (insn, operands);

    case 650:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7455 (insn, operands);

    case 651:
      if (!(
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7459 (insn, operands);

    case 652:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7463 (insn, operands);

    case 653:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7467 (insn, operands);

    case 654:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7471 (insn, operands);

    case 655:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7475 (insn, operands);

    case 656:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7479 (insn, operands);

    case 657:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7483 (insn, operands);

    case 658:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7487 (insn, operands);

    case 659:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7491 (insn, operands);

    case 660:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7495 (insn, operands);

    case 661:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7499 (insn, operands);

    case 662:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7503 (insn, operands);

    case 663:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7507 (insn, operands);

    case 664:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7511 (insn, operands);

    case 665:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7515 (insn, operands);

    case 666:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7519 (insn, operands);

    case 667:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7523 (insn, operands);

    case 668:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7527 (insn, operands);

    case 669:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7531 (insn, operands);

    case 670:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7535 (insn, operands);

    case 671:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7539 (insn, operands);

    case 672:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7543 (insn, operands);

    case 673:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7547 (insn, operands);

    case 674:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7551 (insn, operands);

    case 675:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7555 (insn, operands);

    case 676:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7559 (insn, operands);

    case 677:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7563 (insn, operands);

    case 678:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7567 (insn, operands);

    case 679:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7571 (insn, operands);

    case 680:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7575 (insn, operands);

    case 681:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7579 (insn, operands);

    case 682:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7583 (insn, operands);

    case 683:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7587 (insn, operands);

    case 684:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7591 (insn, operands);

    case 685:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7595 (insn, operands);

    case 686:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7599 (insn, operands);

    case 687:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7603 (insn, operands);

    case 688:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7607 (insn, operands);

    case 689:
      if (!((
#line 500 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7611 (insn, operands);

    case 690:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7613 (insn, operands);

    case 691:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7615 (insn, operands);

    case 692:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7617 (insn, operands);

    case 693:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7619 (insn, operands);

    case 694:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7621 (insn, operands);

    case 695:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7623 (insn, operands);

    case 696:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7625 (insn, operands);

    case 697:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7627 (insn, operands);

    case 698:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7629 (insn, operands);

    case 699:
      if (!(
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7631 (insn, operands);

    case 700:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7633 (insn, operands);

    case 701:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7635 (insn, operands);

    case 702:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7637 (insn, operands);

    case 703:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7639 (insn, operands);

    case 704:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7641 (insn, operands);

    case 705:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7643 (insn, operands);

    case 706:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7645 (insn, operands);

    case 707:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7647 (insn, operands);

    case 708:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7649 (insn, operands);

    case 709:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7651 (insn, operands);

    case 710:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7653 (insn, operands);

    case 711:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7655 (insn, operands);

    case 712:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7657 (insn, operands);

    case 713:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7659 (insn, operands);

    case 714:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7661 (insn, operands);

    case 715:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7663 (insn, operands);

    case 716:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7665 (insn, operands);

    case 717:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7667 (insn, operands);

    case 718:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7669 (insn, operands);

    case 719:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7671 (insn, operands);

    case 720:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7673 (insn, operands);

    case 721:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7675 (insn, operands);

    case 722:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7677 (insn, operands);

    case 723:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7679 (insn, operands);

    case 724:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7681 (insn, operands);

    case 725:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7683 (insn, operands);

    case 726:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7685 (insn, operands);

    case 727:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7687 (insn, operands);

    case 728:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7689 (insn, operands);

    case 729:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7691 (insn, operands);

    case 730:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7693 (insn, operands);

    case 731:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7695 (insn, operands);

    case 732:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7697 (insn, operands);

    case 733:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7699 (insn, operands);

    case 734:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7701 (insn, operands);

    case 735:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7703 (insn, operands);

    case 736:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7705 (insn, operands);

    case 737:
      if (!((
#line 522 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7707 (insn, operands);

    case 738:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6826 (insn, operands);

    case 739:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6827 (insn, operands);

    case 740:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6828 (insn, operands);

    case 741:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6829 (insn, operands);

    case 742:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6830 (insn, operands);

    case 743:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6831 (insn, operands);

    case 744:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6832 (insn, operands);

    case 745:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6833 (insn, operands);

    case 746:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6834 (insn, operands);

    case 747:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6835 (insn, operands);

    case 748:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6836 (insn, operands);

    case 749:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6837 (insn, operands);

    case 750:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6838 (insn, operands);

    case 751:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6839 (insn, operands);

    case 752:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6840 (insn, operands);

    case 753:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6841 (insn, operands);

    case 754:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6842 (insn, operands);

    case 755:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6843 (insn, operands);

    case 756:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6844 (insn, operands);

    case 757:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6845 (insn, operands);

    case 758:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6846 (insn, operands);

    case 759:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6847 (insn, operands);

    case 760:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6848 (insn, operands);

    case 761:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6849 (insn, operands);

    case 762:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6850 (insn, operands);

    case 763:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6851 (insn, operands);

    case 764:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6852 (insn, operands);

    case 765:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6853 (insn, operands);

    case 766:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6854 (insn, operands);

    case 767:
      if (!((
#line 303 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 305 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6855 (insn, operands);

    case 768:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6886 (insn, operands);

    case 769:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6887 (insn, operands);

    case 770:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6888 (insn, operands);

    case 771:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6889 (insn, operands);

    case 772:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6890 (insn, operands);

    case 773:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6891 (insn, operands);

    case 774:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6892 (insn, operands);

    case 775:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6893 (insn, operands);

    case 776:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6894 (insn, operands);

    case 777:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6895 (insn, operands);

    case 778:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6896 (insn, operands);

    case 779:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6897 (insn, operands);

    case 780:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6898 (insn, operands);

    case 781:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6899 (insn, operands);

    case 782:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6900 (insn, operands);

    case 783:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6901 (insn, operands);

    case 784:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6902 (insn, operands);

    case 785:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6903 (insn, operands);

    case 786:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6904 (insn, operands);

    case 787:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6905 (insn, operands);

    case 788:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6906 (insn, operands);

    case 789:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6907 (insn, operands);

    case 790:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6908 (insn, operands);

    case 791:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6909 (insn, operands);

    case 792:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6910 (insn, operands);

    case 793:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6911 (insn, operands);

    case 794:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6912 (insn, operands);

    case 795:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6913 (insn, operands);

    case 796:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6914 (insn, operands);

    case 797:
      if (!((
#line 350 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 352 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6915 (insn, operands);

    case 798:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6916 (insn, operands);

    case 799:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6918 (insn, operands);

    case 800:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7276 (insn, operands);

    case 801:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6920 (insn, operands);

    case 802:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7278 (insn, operands);

    case 803:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6922 (insn, operands);

    case 804:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7280 (insn, operands);

    case 805:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6924 (insn, operands);

    case 806:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7282 (insn, operands);

    case 807:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6926 (insn, operands);

    case 808:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7284 (insn, operands);

    case 809:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6928 (insn, operands);

    case 810:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7108 (insn, operands);

    case 811:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6930 (insn, operands);

    case 812:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7110 (insn, operands);

    case 813:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7286 (insn, operands);

    case 814:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6932 (insn, operands);

    case 815:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7112 (insn, operands);

    case 816:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7288 (insn, operands);

    case 817:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6934 (insn, operands);

    case 818:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7114 (insn, operands);

    case 819:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7290 (insn, operands);

    case 820:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6936 (insn, operands);

    case 821:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7116 (insn, operands);

    case 822:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7292 (insn, operands);

    case 823:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6938 (insn, operands);

    case 824:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7118 (insn, operands);

    case 825:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6940 (insn, operands);

    case 826:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7120 (insn, operands);

    case 827:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6942 (insn, operands);

    case 828:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7122 (insn, operands);

    case 829:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6944 (insn, operands);

    case 830:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7124 (insn, operands);

    case 831:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6946 (insn, operands);

    case 832:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7318 (insn, operands);

    case 833:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6948 (insn, operands);

    case 834:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7320 (insn, operands);

    case 835:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6950 (insn, operands);

    case 836:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7322 (insn, operands);

    case 837:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6952 (insn, operands);

    case 838:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7324 (insn, operands);

    case 839:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6954 (insn, operands);

    case 840:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7326 (insn, operands);

    case 841:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6956 (insn, operands);

    case 842:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7328 (insn, operands);

    case 843:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6958 (insn, operands);

    case 844:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7330 (insn, operands);

    case 845:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6960 (insn, operands);

    case 846:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7332 (insn, operands);

    case 847:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6962 (insn, operands);

    case 848:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7334 (insn, operands);

    case 849:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6964 (insn, operands);

    case 850:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7336 (insn, operands);

    case 851:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6966 (insn, operands);

    case 852:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7338 (insn, operands);

    case 853:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6968 (insn, operands);

    case 854:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6970 (insn, operands);

    case 855:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7126 (insn, operands);

    case 856:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7340 (insn, operands);

    case 857:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6972 (insn, operands);

    case 858:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7128 (insn, operands);

    case 859:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7342 (insn, operands);

    case 860:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6974 (insn, operands);

    case 861:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7130 (insn, operands);

    case 862:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7344 (insn, operands);

    case 863:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6976 (insn, operands);

    case 864:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7132 (insn, operands);

    case 865:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7346 (insn, operands);

    case 866:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6978 (insn, operands);

    case 867:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7134 (insn, operands);

    case 868:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7348 (insn, operands);

    case 869:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6980 (insn, operands);

    case 870:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7136 (insn, operands);

    case 871:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7350 (insn, operands);

    case 872:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6982 (insn, operands);

    case 873:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7138 (insn, operands);

    case 874:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7352 (insn, operands);

    case 875:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6984 (insn, operands);

    case 876:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7140 (insn, operands);

    case 877:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7354 (insn, operands);

    case 878:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6986 (insn, operands);

    case 879:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7142 (insn, operands);

    case 880:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7356 (insn, operands);

    case 881:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6988 (insn, operands);

    case 882:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7144 (insn, operands);

    case 883:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7358 (insn, operands);

    case 884:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6990 (insn, operands);

    case 885:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7146 (insn, operands);

    case 886:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6992 (insn, operands);

    case 887:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7148 (insn, operands);

    case 888:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6994 (insn, operands);

    case 889:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7150 (insn, operands);

    case 890:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6996 (insn, operands);

    case 891:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7152 (insn, operands);

    case 892:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6998 (insn, operands);

    case 893:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7154 (insn, operands);

    case 894:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7000 (insn, operands);

    case 895:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7156 (insn, operands);

    case 896:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7002 (insn, operands);

    case 897:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7158 (insn, operands);

    case 898:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7004 (insn, operands);

    case 899:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7160 (insn, operands);

    case 900:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7006 (insn, operands);

    case 901:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7162 (insn, operands);

    case 902:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7008 (insn, operands);

    case 903:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7164 (insn, operands);

    case 904:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7010 (insn, operands);

    case 905:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7166 (insn, operands);

    case 906:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7264 (insn, operands);

    case 907:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7266 (insn, operands);

    case 908:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7268 (insn, operands);

    case 909:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7270 (insn, operands);

    case 910:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7272 (insn, operands);

    case 911:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7274 (insn, operands);

    case 912:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7294 (insn, operands);

    case 913:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7296 (insn, operands);

    case 914:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7298 (insn, operands);

    case 915:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7300 (insn, operands);

    case 916:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7302 (insn, operands);

    case 917:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7304 (insn, operands);

    case 918:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7306 (insn, operands);

    case 919:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7308 (insn, operands);

    case 920:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7310 (insn, operands);

    case 921:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7312 (insn, operands);

    case 922:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7314 (insn, operands);

    case 923:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7316 (insn, operands);

    case 924:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6917 (insn, operands);

    case 925:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6919 (insn, operands);

    case 926:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7277 (insn, operands);

    case 927:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6921 (insn, operands);

    case 928:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7279 (insn, operands);

    case 929:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6923 (insn, operands);

    case 930:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7281 (insn, operands);

    case 931:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6925 (insn, operands);

    case 932:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7283 (insn, operands);

    case 933:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6927 (insn, operands);

    case 934:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7285 (insn, operands);

    case 935:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6929 (insn, operands);

    case 936:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7109 (insn, operands);

    case 937:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6931 (insn, operands);

    case 938:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7111 (insn, operands);

    case 939:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7287 (insn, operands);

    case 940:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6933 (insn, operands);

    case 941:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7113 (insn, operands);

    case 942:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7289 (insn, operands);

    case 943:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6935 (insn, operands);

    case 944:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7115 (insn, operands);

    case 945:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7291 (insn, operands);

    case 946:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6937 (insn, operands);

    case 947:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7117 (insn, operands);

    case 948:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7293 (insn, operands);

    case 949:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6939 (insn, operands);

    case 950:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7119 (insn, operands);

    case 951:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6941 (insn, operands);

    case 952:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7121 (insn, operands);

    case 953:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6943 (insn, operands);

    case 954:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7123 (insn, operands);

    case 955:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6945 (insn, operands);

    case 956:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7125 (insn, operands);

    case 957:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6947 (insn, operands);

    case 958:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7319 (insn, operands);

    case 959:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6949 (insn, operands);

    case 960:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7321 (insn, operands);

    case 961:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6951 (insn, operands);

    case 962:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7323 (insn, operands);

    case 963:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6953 (insn, operands);

    case 964:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7325 (insn, operands);

    case 965:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6955 (insn, operands);

    case 966:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7327 (insn, operands);

    case 967:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6957 (insn, operands);

    case 968:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7329 (insn, operands);

    case 969:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6959 (insn, operands);

    case 970:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7331 (insn, operands);

    case 971:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6961 (insn, operands);

    case 972:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7333 (insn, operands);

    case 973:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6963 (insn, operands);

    case 974:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7335 (insn, operands);

    case 975:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6965 (insn, operands);

    case 976:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7337 (insn, operands);

    case 977:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6967 (insn, operands);

    case 978:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7339 (insn, operands);

    case 979:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6969 (insn, operands);

    case 980:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6971 (insn, operands);

    case 981:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7127 (insn, operands);

    case 982:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7341 (insn, operands);

    case 983:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6973 (insn, operands);

    case 984:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7129 (insn, operands);

    case 985:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7343 (insn, operands);

    case 986:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6975 (insn, operands);

    case 987:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7131 (insn, operands);

    case 988:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7345 (insn, operands);

    case 989:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6977 (insn, operands);

    case 990:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7133 (insn, operands);

    case 991:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7347 (insn, operands);

    case 992:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6979 (insn, operands);

    case 993:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7135 (insn, operands);

    case 994:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7349 (insn, operands);

    case 995:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6981 (insn, operands);

    case 996:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7137 (insn, operands);

    case 997:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7351 (insn, operands);

    case 998:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6983 (insn, operands);

    case 999:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7139 (insn, operands);

    case 1000:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7353 (insn, operands);

    case 1001:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6985 (insn, operands);

    case 1002:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7141 (insn, operands);

    case 1003:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7355 (insn, operands);

    case 1004:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6987 (insn, operands);

    case 1005:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7143 (insn, operands);

    case 1006:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7357 (insn, operands);

    case 1007:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6989 (insn, operands);

    case 1008:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7145 (insn, operands);

    case 1009:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7359 (insn, operands);

    case 1010:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6991 (insn, operands);

    case 1011:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7147 (insn, operands);

    case 1012:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6993 (insn, operands);

    case 1013:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7149 (insn, operands);

    case 1014:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6995 (insn, operands);

    case 1015:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7151 (insn, operands);

    case 1016:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6997 (insn, operands);

    case 1017:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7153 (insn, operands);

    case 1018:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6999 (insn, operands);

    case 1019:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7155 (insn, operands);

    case 1020:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7001 (insn, operands);

    case 1021:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7157 (insn, operands);

    case 1022:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7003 (insn, operands);

    case 1023:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7159 (insn, operands);

    case 1024:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7005 (insn, operands);

    case 1025:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7161 (insn, operands);

    case 1026:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7007 (insn, operands);

    case 1027:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7163 (insn, operands);

    case 1028:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7009 (insn, operands);

    case 1029:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7165 (insn, operands);

    case 1030:
      if (!((
#line 371 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7011 (insn, operands);

    case 1031:
      if (!((
#line 413 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7167 (insn, operands);

    case 1032:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7265 (insn, operands);

    case 1033:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7267 (insn, operands);

    case 1034:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7269 (insn, operands);

    case 1035:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7271 (insn, operands);

    case 1036:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7273 (insn, operands);

    case 1037:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7275 (insn, operands);

    case 1038:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7295 (insn, operands);

    case 1039:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7297 (insn, operands);

    case 1040:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7299 (insn, operands);

    case 1041:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7301 (insn, operands);

    case 1042:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7303 (insn, operands);

    case 1043:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7305 (insn, operands);

    case 1044:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7307 (insn, operands);

    case 1045:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7309 (insn, operands);

    case 1046:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7311 (insn, operands);

    case 1047:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7313 (insn, operands);

    case 1048:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7315 (insn, operands);

    case 1049:
      if (!((
#line 455 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7317 (insn, operands);

    case 1050:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7012 (insn, operands);

    case 1051:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7168 (insn, operands);

    case 1052:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7014 (insn, operands);

    case 1053:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7170 (insn, operands);

    case 1054:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7360 (insn, operands);

    case 1055:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7016 (insn, operands);

    case 1056:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7172 (insn, operands);

    case 1057:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7362 (insn, operands);

    case 1058:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7018 (insn, operands);

    case 1059:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7174 (insn, operands);

    case 1060:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7364 (insn, operands);

    case 1061:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7020 (insn, operands);

    case 1062:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7176 (insn, operands);

    case 1063:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7366 (insn, operands);

    case 1064:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7022 (insn, operands);

    case 1065:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7178 (insn, operands);

    case 1066:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7368 (insn, operands);

    case 1067:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7024 (insn, operands);

    case 1068:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7180 (insn, operands);

    case 1069:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7026 (insn, operands);

    case 1070:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7182 (insn, operands);

    case 1071:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7370 (insn, operands);

    case 1072:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7028 (insn, operands);

    case 1073:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7184 (insn, operands);

    case 1074:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7372 (insn, operands);

    case 1075:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7030 (insn, operands);

    case 1076:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7186 (insn, operands);

    case 1077:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7374 (insn, operands);

    case 1078:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7032 (insn, operands);

    case 1079:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7188 (insn, operands);

    case 1080:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7376 (insn, operands);

    case 1081:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7034 (insn, operands);

    case 1082:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7190 (insn, operands);

    case 1083:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7036 (insn, operands);

    case 1084:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7192 (insn, operands);

    case 1085:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7038 (insn, operands);

    case 1086:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7194 (insn, operands);

    case 1087:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7040 (insn, operands);

    case 1088:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7196 (insn, operands);

    case 1089:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7042 (insn, operands);

    case 1090:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7198 (insn, operands);

    case 1091:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7378 (insn, operands);

    case 1092:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7044 (insn, operands);

    case 1093:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7200 (insn, operands);

    case 1094:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7380 (insn, operands);

    case 1095:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7046 (insn, operands);

    case 1096:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7202 (insn, operands);

    case 1097:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7382 (insn, operands);

    case 1098:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7048 (insn, operands);

    case 1099:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7204 (insn, operands);

    case 1100:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7384 (insn, operands);

    case 1101:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7050 (insn, operands);

    case 1102:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7206 (insn, operands);

    case 1103:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7386 (insn, operands);

    case 1104:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7052 (insn, operands);

    case 1105:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7208 (insn, operands);

    case 1106:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7388 (insn, operands);

    case 1107:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7054 (insn, operands);

    case 1108:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7210 (insn, operands);

    case 1109:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7390 (insn, operands);

    case 1110:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7056 (insn, operands);

    case 1111:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7212 (insn, operands);

    case 1112:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7392 (insn, operands);

    case 1113:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7058 (insn, operands);

    case 1114:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7214 (insn, operands);

    case 1115:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7394 (insn, operands);

    case 1116:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7060 (insn, operands);

    case 1117:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7216 (insn, operands);

    case 1118:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7396 (insn, operands);

    case 1119:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7062 (insn, operands);

    case 1120:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7218 (insn, operands);

    case 1121:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7398 (insn, operands);

    case 1122:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7064 (insn, operands);

    case 1123:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7220 (insn, operands);

    case 1124:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7066 (insn, operands);

    case 1125:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7222 (insn, operands);

    case 1126:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7400 (insn, operands);

    case 1127:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7068 (insn, operands);

    case 1128:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7224 (insn, operands);

    case 1129:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7402 (insn, operands);

    case 1130:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7070 (insn, operands);

    case 1131:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7226 (insn, operands);

    case 1132:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7404 (insn, operands);

    case 1133:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7072 (insn, operands);

    case 1134:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7228 (insn, operands);

    case 1135:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7406 (insn, operands);

    case 1136:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7074 (insn, operands);

    case 1137:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7230 (insn, operands);

    case 1138:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7408 (insn, operands);

    case 1139:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7076 (insn, operands);

    case 1140:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7232 (insn, operands);

    case 1141:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7410 (insn, operands);

    case 1142:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7078 (insn, operands);

    case 1143:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7234 (insn, operands);

    case 1144:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7412 (insn, operands);

    case 1145:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7080 (insn, operands);

    case 1146:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7236 (insn, operands);

    case 1147:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7414 (insn, operands);

    case 1148:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7082 (insn, operands);

    case 1149:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7238 (insn, operands);

    case 1150:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7416 (insn, operands);

    case 1151:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7084 (insn, operands);

    case 1152:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7240 (insn, operands);

    case 1153:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7418 (insn, operands);

    case 1154:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7086 (insn, operands);

    case 1155:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7242 (insn, operands);

    case 1156:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7088 (insn, operands);

    case 1157:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7244 (insn, operands);

    case 1158:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7090 (insn, operands);

    case 1159:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7246 (insn, operands);

    case 1160:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7092 (insn, operands);

    case 1161:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7248 (insn, operands);

    case 1162:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7094 (insn, operands);

    case 1163:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7250 (insn, operands);

    case 1164:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7096 (insn, operands);

    case 1165:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7252 (insn, operands);

    case 1166:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7098 (insn, operands);

    case 1167:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7254 (insn, operands);

    case 1168:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7100 (insn, operands);

    case 1169:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7256 (insn, operands);

    case 1170:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7102 (insn, operands);

    case 1171:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7258 (insn, operands);

    case 1172:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7104 (insn, operands);

    case 1173:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7260 (insn, operands);

    case 1174:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7106 (insn, operands);

    case 1175:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7262 (insn, operands);

    case 1176:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7013 (insn, operands);

    case 1177:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7169 (insn, operands);

    case 1178:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7015 (insn, operands);

    case 1179:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7171 (insn, operands);

    case 1180:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7361 (insn, operands);

    case 1181:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7017 (insn, operands);

    case 1182:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7173 (insn, operands);

    case 1183:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7363 (insn, operands);

    case 1184:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7019 (insn, operands);

    case 1185:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7175 (insn, operands);

    case 1186:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7365 (insn, operands);

    case 1187:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7021 (insn, operands);

    case 1188:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7177 (insn, operands);

    case 1189:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7367 (insn, operands);

    case 1190:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7023 (insn, operands);

    case 1191:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7179 (insn, operands);

    case 1192:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7369 (insn, operands);

    case 1193:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7025 (insn, operands);

    case 1194:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7181 (insn, operands);

    case 1195:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7027 (insn, operands);

    case 1196:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7183 (insn, operands);

    case 1197:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7371 (insn, operands);

    case 1198:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7029 (insn, operands);

    case 1199:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7185 (insn, operands);

    case 1200:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7373 (insn, operands);

    case 1201:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7031 (insn, operands);

    case 1202:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7187 (insn, operands);

    case 1203:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7375 (insn, operands);

    case 1204:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7033 (insn, operands);

    case 1205:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7189 (insn, operands);

    case 1206:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7377 (insn, operands);

    case 1207:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7035 (insn, operands);

    case 1208:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7191 (insn, operands);

    case 1209:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7037 (insn, operands);

    case 1210:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7193 (insn, operands);

    case 1211:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7039 (insn, operands);

    case 1212:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7195 (insn, operands);

    case 1213:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7041 (insn, operands);

    case 1214:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7197 (insn, operands);

    case 1215:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7043 (insn, operands);

    case 1216:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7199 (insn, operands);

    case 1217:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7379 (insn, operands);

    case 1218:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7045 (insn, operands);

    case 1219:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7201 (insn, operands);

    case 1220:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7381 (insn, operands);

    case 1221:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7047 (insn, operands);

    case 1222:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7203 (insn, operands);

    case 1223:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7383 (insn, operands);

    case 1224:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7049 (insn, operands);

    case 1225:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7205 (insn, operands);

    case 1226:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7385 (insn, operands);

    case 1227:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7051 (insn, operands);

    case 1228:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7207 (insn, operands);

    case 1229:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7387 (insn, operands);

    case 1230:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7053 (insn, operands);

    case 1231:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7209 (insn, operands);

    case 1232:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7389 (insn, operands);

    case 1233:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7055 (insn, operands);

    case 1234:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7211 (insn, operands);

    case 1235:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7391 (insn, operands);

    case 1236:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7057 (insn, operands);

    case 1237:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7213 (insn, operands);

    case 1238:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7393 (insn, operands);

    case 1239:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7059 (insn, operands);

    case 1240:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7215 (insn, operands);

    case 1241:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7395 (insn, operands);

    case 1242:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7061 (insn, operands);

    case 1243:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7217 (insn, operands);

    case 1244:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7397 (insn, operands);

    case 1245:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7063 (insn, operands);

    case 1246:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7219 (insn, operands);

    case 1247:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7399 (insn, operands);

    case 1248:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7065 (insn, operands);

    case 1249:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7221 (insn, operands);

    case 1250:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7067 (insn, operands);

    case 1251:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7223 (insn, operands);

    case 1252:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7401 (insn, operands);

    case 1253:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7069 (insn, operands);

    case 1254:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7225 (insn, operands);

    case 1255:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7403 (insn, operands);

    case 1256:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7071 (insn, operands);

    case 1257:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7227 (insn, operands);

    case 1258:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7405 (insn, operands);

    case 1259:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7073 (insn, operands);

    case 1260:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7229 (insn, operands);

    case 1261:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7407 (insn, operands);

    case 1262:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7075 (insn, operands);

    case 1263:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7231 (insn, operands);

    case 1264:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7409 (insn, operands);

    case 1265:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7077 (insn, operands);

    case 1266:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7233 (insn, operands);

    case 1267:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7411 (insn, operands);

    case 1268:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7079 (insn, operands);

    case 1269:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7235 (insn, operands);

    case 1270:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7413 (insn, operands);

    case 1271:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7081 (insn, operands);

    case 1272:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7237 (insn, operands);

    case 1273:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7415 (insn, operands);

    case 1274:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7083 (insn, operands);

    case 1275:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7239 (insn, operands);

    case 1276:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7417 (insn, operands);

    case 1277:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7085 (insn, operands);

    case 1278:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7241 (insn, operands);

    case 1279:
      if (!((
#line 476 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7419 (insn, operands);

    case 1280:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7087 (insn, operands);

    case 1281:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7243 (insn, operands);

    case 1282:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7089 (insn, operands);

    case 1283:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7245 (insn, operands);

    case 1284:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7091 (insn, operands);

    case 1285:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7247 (insn, operands);

    case 1286:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7093 (insn, operands);

    case 1287:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7249 (insn, operands);

    case 1288:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7095 (insn, operands);

    case 1289:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7251 (insn, operands);

    case 1290:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7097 (insn, operands);

    case 1291:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7253 (insn, operands);

    case 1292:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7099 (insn, operands);

    case 1293:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7255 (insn, operands);

    case 1294:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7101 (insn, operands);

    case 1295:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7257 (insn, operands);

    case 1296:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7103 (insn, operands);

    case 1297:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7259 (insn, operands);

    case 1298:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7105 (insn, operands);

    case 1299:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7261 (insn, operands);

    case 1300:
      if (!((
#line 392 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7107 (insn, operands);

    case 1301:
      if (!((
#line 434 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7263 (insn, operands);

    case 1302:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7708 (insn, operands);

    case 1303:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7710 (insn, operands);

    case 1304:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7712 (insn, operands);

    case 1305:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7714 (insn, operands);

    case 1306:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7716 (insn, operands);

    case 1307:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7718 (insn, operands);

    case 1308:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7720 (insn, operands);

    case 1309:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7722 (insn, operands);

    case 1310:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7724 (insn, operands);

    case 1311:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7726 (insn, operands);

    case 1312:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7728 (insn, operands);

    case 1313:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7730 (insn, operands);

    case 1314:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7732 (insn, operands);

    case 1315:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7734 (insn, operands);

    case 1316:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7736 (insn, operands);

    case 1317:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7738 (insn, operands);

    case 1318:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7740 (insn, operands);

    case 1319:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7742 (insn, operands);

    case 1320:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7744 (insn, operands);

    case 1321:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7746 (insn, operands);

    case 1322:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7748 (insn, operands);

    case 1323:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7750 (insn, operands);

    case 1324:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7752 (insn, operands);

    case 1325:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7754 (insn, operands);

    case 1326:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7756 (insn, operands);

    case 1327:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7758 (insn, operands);

    case 1328:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7760 (insn, operands);

    case 1329:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7762 (insn, operands);

    case 1330:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7764 (insn, operands);

    case 1331:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7766 (insn, operands);

    case 1332:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7768 (insn, operands);

    case 1333:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7770 (insn, operands);

    case 1334:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7772 (insn, operands);

    case 1335:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7774 (insn, operands);

    case 1336:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7776 (insn, operands);

    case 1337:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7778 (insn, operands);

    case 1338:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7780 (insn, operands);

    case 1339:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7782 (insn, operands);

    case 1340:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7784 (insn, operands);

    case 1341:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7786 (insn, operands);

    case 1342:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7788 (insn, operands);

    case 1343:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7790 (insn, operands);

    case 1344:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7792 (insn, operands);

    case 1345:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7794 (insn, operands);

    case 1346:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7796 (insn, operands);

    case 1347:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7798 (insn, operands);

    case 1348:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7800 (insn, operands);

    case 1349:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7802 (insn, operands);

    case 1350:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7804 (insn, operands);

    case 1351:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7806 (insn, operands);

    case 1352:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7808 (insn, operands);

    case 1353:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7810 (insn, operands);

    case 1354:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7812 (insn, operands);

    case 1355:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7814 (insn, operands);

    case 1356:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7816 (insn, operands);

    case 1357:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7818 (insn, operands);

    case 1358:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7820 (insn, operands);

    case 1359:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7822 (insn, operands);

    case 1360:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7824 (insn, operands);

    case 1361:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7826 (insn, operands);

    case 1362:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7828 (insn, operands);

    case 1363:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7830 (insn, operands);

    case 1364:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7832 (insn, operands);

    case 1365:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7834 (insn, operands);

    case 1366:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7836 (insn, operands);

    case 1367:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7838 (insn, operands);

    case 1368:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7840 (insn, operands);

    case 1369:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7842 (insn, operands);

    case 1370:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7709 (insn, operands);

    case 1371:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7711 (insn, operands);

    case 1372:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7713 (insn, operands);

    case 1373:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7715 (insn, operands);

    case 1374:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7717 (insn, operands);

    case 1375:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7719 (insn, operands);

    case 1376:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7721 (insn, operands);

    case 1377:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7723 (insn, operands);

    case 1378:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7725 (insn, operands);

    case 1379:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7727 (insn, operands);

    case 1380:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7729 (insn, operands);

    case 1381:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7731 (insn, operands);

    case 1382:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7733 (insn, operands);

    case 1383:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7735 (insn, operands);

    case 1384:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7737 (insn, operands);

    case 1385:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7739 (insn, operands);

    case 1386:
      if (!(
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7741 (insn, operands);

    case 1387:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7743 (insn, operands);

    case 1388:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7745 (insn, operands);

    case 1389:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7747 (insn, operands);

    case 1390:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7749 (insn, operands);

    case 1391:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7751 (insn, operands);

    case 1392:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7753 (insn, operands);

    case 1393:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7755 (insn, operands);

    case 1394:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7757 (insn, operands);

    case 1395:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7759 (insn, operands);

    case 1396:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7761 (insn, operands);

    case 1397:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7763 (insn, operands);

    case 1398:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7765 (insn, operands);

    case 1399:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7767 (insn, operands);

    case 1400:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7769 (insn, operands);

    case 1401:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7771 (insn, operands);

    case 1402:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7773 (insn, operands);

    case 1403:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7775 (insn, operands);

    case 1404:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7777 (insn, operands);

    case 1405:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7779 (insn, operands);

    case 1406:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7781 (insn, operands);

    case 1407:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7783 (insn, operands);

    case 1408:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7785 (insn, operands);

    case 1409:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7787 (insn, operands);

    case 1410:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7789 (insn, operands);

    case 1411:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7791 (insn, operands);

    case 1412:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7793 (insn, operands);

    case 1413:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7795 (insn, operands);

    case 1414:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7797 (insn, operands);

    case 1415:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7799 (insn, operands);

    case 1416:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7801 (insn, operands);

    case 1417:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7803 (insn, operands);

    case 1418:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7805 (insn, operands);

    case 1419:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7807 (insn, operands);

    case 1420:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7809 (insn, operands);

    case 1421:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7811 (insn, operands);

    case 1422:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7813 (insn, operands);

    case 1423:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7815 (insn, operands);

    case 1424:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7817 (insn, operands);

    case 1425:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7819 (insn, operands);

    case 1426:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7821 (insn, operands);

    case 1427:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7823 (insn, operands);

    case 1428:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7825 (insn, operands);

    case 1429:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7827 (insn, operands);

    case 1430:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7829 (insn, operands);

    case 1431:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7831 (insn, operands);

    case 1432:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7833 (insn, operands);

    case 1433:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7835 (insn, operands);

    case 1434:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7837 (insn, operands);

    case 1435:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7839 (insn, operands);

    case 1436:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7841 (insn, operands);

    case 1437:
      if (!((
#line 544 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7843 (insn, operands);

    default:
      return NULL;
    }
}
