/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          return pattern156 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode); /* [-1, 0] */

        case E_RVVM2HImode:
          if (pattern156 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 1;

        case E_RVVM1HImode:
          if (pattern156 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 2;

        case E_RVVMF2HImode:
          if (pattern156 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4HImode:
          if (pattern156 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 4;

        case E_RVVM4SImode:
          if (pattern156 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (pattern156 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 6;

        case E_RVVM1SImode:
          if (pattern156 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 7;

        case E_RVVMF2SImode:
          if (pattern156 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 8;

        case E_V1HImode:
          if (pattern156 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 9;

        case E_V2HImode:
          if (pattern156 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 10;

        case E_V4HImode:
          if (pattern156 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern156 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16HImode:
          if (pattern156 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 13;

        case E_V32HImode:
          if (pattern156 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 14;

        case E_V64HImode:
          if (pattern156 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 15;

        case E_V128HImode:
          if (pattern156 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 16;

        case E_V256HImode:
          if (pattern156 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 17;

        case E_V512HImode:
          if (pattern156 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 18;

        case E_V1024HImode:
          if (pattern156 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 19;

        case E_V1SImode:
          if (pattern156 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 20;

        case E_V2SImode:
          if (pattern156 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 21;

        case E_V4SImode:
          if (pattern156 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 22;

        case E_V8SImode:
          if (pattern156 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 23;

        case E_V16SImode:
          if (pattern156 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 24;

        case E_V32SImode:
          if (pattern156 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 25;

        case E_V64SImode:
          if (pattern156 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 26;

        case E_V128SImode:
          if (pattern156 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 27;

        case E_V256SImode:
          if (pattern156 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 28;

        case E_V512SImode:
          if (pattern156 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 29;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HImode:
          if (pattern157 (x1, 
E_RVVM2QImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 30;

        case E_RVVM2HImode:
          if (pattern157 (x1, 
E_RVVM1QImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 31;

        case E_RVVM1HImode:
          if (pattern157 (x1, 
E_RVVMF2QImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 32;

        case E_RVVMF2HImode:
          if (pattern157 (x1, 
E_RVVMF4QImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 33;

        case E_RVVMF4HImode:
          if (pattern157 (x1, 
E_RVVMF8QImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SImode:
          if (pattern157 (x1, 
E_RVVM2HImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SImode:
          if (pattern157 (x1, 
E_RVVM1HImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SImode:
          if (pattern157 (x1, 
E_RVVMF2HImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (pattern157 (x1, 
E_RVVMF4HImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 38;

        case E_V1HImode:
          if (pattern157 (x1, 
E_V1QImode, 
E_V1SImode, 
E_V1HImode) != 0)
            return -1;
          return 39;

        case E_V2HImode:
          if (pattern157 (x1, 
E_V2QImode, 
E_V2SImode, 
E_V2HImode) != 0)
            return -1;
          return 40;

        case E_V4HImode:
          if (pattern157 (x1, 
E_V4QImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 41;

        case E_V8HImode:
          if (pattern157 (x1, 
E_V8QImode, 
E_V8SImode, 
E_V8HImode) != 0)
            return -1;
          return 42;

        case E_V16HImode:
          if (pattern157 (x1, 
E_V16QImode, 
E_V16SImode, 
E_V16HImode) != 0)
            return -1;
          return 43;

        case E_V32HImode:
          if (pattern157 (x1, 
E_V32QImode, 
E_V32SImode, 
E_V32HImode) != 0)
            return -1;
          return 44;

        case E_V64HImode:
          if (pattern157 (x1, 
E_V64QImode, 
E_V64SImode, 
E_V64HImode) != 0)
            return -1;
          return 45;

        case E_V128HImode:
          if (pattern157 (x1, 
E_V128QImode, 
E_V128SImode, 
E_V128HImode) != 0)
            return -1;
          return 46;

        case E_V256HImode:
          if (pattern157 (x1, 
E_V256QImode, 
E_V256SImode, 
E_V256HImode) != 0)
            return -1;
          return 47;

        case E_V512HImode:
          if (pattern157 (x1, 
E_V512QImode, 
E_V512SImode, 
E_V512HImode) != 0)
            return -1;
          return 48;

        case E_V1024HImode:
          if (pattern157 (x1, 
E_V1024QImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 49;

        case E_V1SImode:
          if (pattern157 (x1, 
E_V1HImode, 
E_V1DImode, 
E_V1SImode) != 0)
            return -1;
          return 50;

        case E_V2SImode:
          if (pattern157 (x1, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 51;

        case E_V4SImode:
          if (pattern157 (x1, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 52;

        case E_V8SImode:
          if (pattern157 (x1, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 53;

        case E_V16SImode:
          if (pattern157 (x1, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 54;

        case E_V32SImode:
          if (pattern157 (x1, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 55;

        case E_V64SImode:
          if (pattern157 (x1, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 56;

        case E_V128SImode:
          if (pattern157 (x1, 
E_V128HImode, 
E_V128DImode, 
E_V128SImode) != 0)
            return -1;
          return 57;

        case E_V256SImode:
          if (pattern157 (x1, 
E_V256HImode, 
E_V256DImode, 
E_V256SImode) != 0)
            return -1;
          return 58;

        case E_V512SImode:
          if (pattern157 (x1, 
E_V512HImode, 
E_V512DImode, 
E_V512SImode) != 0)
            return -1;
          return 59;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!const_int2_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vector_shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !vector_shift_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern204 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HImode
          || !register_operand (operands[3], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HImode
          || !register_operand (operands[3], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HImode
          || !register_operand (operands[3], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HImode
          || !register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HImode
          || !register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SImode
          || !register_operand (operands[3], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[2], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[2], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SImode
          || !register_operand (operands[3], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[2], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SImode
          || !register_operand (operands[3], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[2], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SImode
          || !register_operand (operands[3], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[2], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SImode
          || !register_operand (operands[3], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[2], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DImode
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[2], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[2], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DImode
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[2], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[2], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DImode
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[2], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[2], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DImode
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[2], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[2], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[3], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[3], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[3], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HImode
          || !register_operand (operands[3], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HImode
          || !register_operand (operands[3], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HImode
          || !register_operand (operands[3], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HImode
          || !register_operand (operands[3], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HImode
          || !register_operand (operands[3], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HImode
          || !register_operand (operands[3], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern204 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[3], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[2], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[2], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[3], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[2], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SImode
          || !register_operand (operands[3], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[2], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SImode
          || !register_operand (operands[3], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[2], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SImode
          || !register_operand (operands[3], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[2], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SImode
          || !register_operand (operands[3], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[2], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SImode
          || !register_operand (operands[3], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[2], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SImode
          || !register_operand (operands[3], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[2], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SImode
          || !register_operand (operands[3], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[2], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[2], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[2], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[2], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[2], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[2], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DImode
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[2], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[2], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DImode
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[2], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[2], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DImode
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[2], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[2], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DImode
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[2], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[2], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DImode
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[2], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[2], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DImode
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[2], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[2], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DImode
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[2], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[2], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern204 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern204 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern204 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern204 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern204 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern204 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern204 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern204 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern204 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern204 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern204 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern204 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern204 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern204 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern204 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern204 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern204 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern204 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern322 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern322 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode)
          || GET_MODE (x1) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode))
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode)
          || GET_MODE (x1) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 23;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 24;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 25;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 26;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 27;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 28;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 29;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode))
        return -1;
      return 30;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode))
        return -1;
      return 31;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 32;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode))
        return -1;
      return 33;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode))
        return -1;
      return 34;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 35;

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode)
          || GET_MODE (x1) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode))
        return -1;
      return 36;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 37;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 38;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 39;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 40;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 41;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 42;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 43;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 44;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 45;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 46;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 47;

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || GET_MODE (x1) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 48;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 49;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 50;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 51;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 52;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 53;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 54;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 55;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 56;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 57;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 58;

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 59;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 60;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 61;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 62;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 63;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 64;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 65;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 66;

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 67;

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 68;

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern335 (x6); /* [-1, 3] */
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[1], E_V1SImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 9;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 10;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 11;

    case E_V128SImode:
      if (!register_operand (operands[1], E_V128SImode))
        return -1;
      return 12;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 13;

    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 14;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_RVVMF64BImode:
      x3 = XVECEXP (x2, 0, 0);
      return pattern450 (x3, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    case E_V1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V1BImode) != 0)
        return -1;
      return 7;

    case E_V2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V2BImode) != 0)
        return -1;
      return 8;

    case E_V4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V4BImode) != 0)
        return -1;
      return 9;

    case E_V8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V8BImode) != 0)
        return -1;
      return 10;

    case E_V16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V16BImode) != 0)
        return -1;
      return 11;

    case E_V32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V32BImode) != 0)
        return -1;
      return 12;

    case E_V64BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V64BImode) != 0)
        return -1;
      return 13;

    case E_V128BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V128BImode) != 0)
        return -1;
      return 14;

    case E_V256BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V256BImode) != 0)
        return -1;
      return 15;

    case E_V512BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V512BImode) != 0)
        return -1;
      return 16;

    case E_V1024BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V1024BImode) != 0)
        return -1;
      return 17;

    case E_V2048BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V2048BImode) != 0)
        return -1;
      return 18;

    case E_V4096BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (pattern450 (x3, 
E_V4096BImode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern477 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x1, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x6) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF4BImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 0;

        case E_RVVMF8BImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 1;

        case E_RVVMF16BImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 2;

        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 3;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x6) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF8BImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 5;

        case E_RVVMF16BImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 6;

        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 7;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x6) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF16BImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 9;

        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 10;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x6) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVMF32BImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 12;

        case E_RVVMF64BImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern476 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern490 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern489 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern489 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern489 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern489 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern489 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern489 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern489 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern489 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern489 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern489 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern489 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern489 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern489 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern489 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern489 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern489 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern489 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern489 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern489 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern489 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern489 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern489 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern489 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern489 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern489 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern489 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern489 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern489 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern489 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern489 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern489 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern489 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern489 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern489 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern489 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern489 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern489 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern489 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern489 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern489 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern489 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern489 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern489 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern489 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern489 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern489 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern489 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern489 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern489 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern489 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern489 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern489 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern489 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern489 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern489 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern489 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern489 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern489 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern489 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern489 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern489 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern489 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern489 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern489 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern489 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern489 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern489 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern489 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern503 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern500 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM4HImode
          || !vector_merge_operand (operands[2], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM2HImode
          || !vector_merge_operand (operands[2], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM1HImode
          || !vector_merge_operand (operands[2], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVMF2HImode
          || !vector_merge_operand (operands[2], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF4HImode
          || !vector_merge_operand (operands[2], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1HImode
          || !vector_merge_operand (operands[2], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2HImode
          || !vector_merge_operand (operands[2], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4HImode
          || !vector_merge_operand (operands[2], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8HImode
          || !vector_merge_operand (operands[2], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16HImode
          || !vector_merge_operand (operands[2], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32HImode
          || !vector_merge_operand (operands[2], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64HImode
          || !vector_merge_operand (operands[2], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128HImode
          || !vector_merge_operand (operands[2], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256HImode
          || !vector_merge_operand (operands[2], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512HImode
          || !vector_merge_operand (operands[2], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024HImode
          || !vector_merge_operand (operands[2], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern500 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern500 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern500 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern500 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern500 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern500 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern500 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern500 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern500 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern500 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern500 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern500 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern500 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern500 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern500 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern500 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern500 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern500 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern500 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[4], E_RVVMF4HFmode)
          || !register_operand (operands[5], E_RVVMF4HFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[4], E_RVVMF2SFmode)
          || !register_operand (operands[5], E_RVVMF2SFmode))
        return -1;
      return 1;

    case E_RVVM1DFmode:
      if (!register_operand (operands[4], E_RVVM1DFmode)
          || !register_operand (operands[5], E_RVVM1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[4], E_V4HFmode)
          || !register_operand (operands[5], E_V4HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[4], E_V4SFmode)
          || !register_operand (operands[5], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[4], E_V4DFmode)
          || !register_operand (operands[5], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[4], E_V32HFmode)
          || !register_operand (operands[5], E_V32HFmode))
        return -1;
      return 0;

    case E_V32SFmode:
      if (!register_operand (operands[4], E_V32SFmode)
          || !register_operand (operands[5], E_V32SFmode))
        return -1;
      return 1;

    case E_V32DFmode:
      if (!register_operand (operands[4], E_V32DFmode)
          || !register_operand (operands[5], E_V32DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[4], E_V256HFmode)
          || !register_operand (operands[5], E_V256HFmode))
        return -1;
      return 0;

    case E_V256SFmode:
      if (!register_operand (operands[4], E_V256SFmode)
          || !register_operand (operands[5], E_V256SFmode))
        return -1;
      return 1;

    case E_V256DFmode:
      if (!register_operand (operands[4], E_V256DFmode)
          || !register_operand (operands[5], E_V256DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern622 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!register_operand (operands[5], i3))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern628 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode)
          || !vector_arith_operand (operands[2], E_RVVM1HImode))
        return -1;
      return 0;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode)
          || !vector_arith_operand (operands[2], E_RVVM2SImode))
        return -1;
      return 1;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode)
          || !vector_arith_operand (operands[2], E_RVVM4DImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode)
          || !vector_arith_operand (operands[2], E_RVVMF2QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern632 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode)
          || !register_operand (operands[2], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode)
          || !register_operand (operands[2], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode)
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew8_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern639 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew32_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern656 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 1;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern676 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_RVVM1DImode
      || !register_operand (operands[4], E_RVVM1DImode)
      || !vector_merge_operand (operands[2], E_RVVM1DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      return 4;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 5;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      return 6;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      return 7;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      return 8;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      return 9;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      return 10;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      return 11;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      return 12;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern680 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern683 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_broadcast_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern690 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x1, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern697 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[2], i3)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern708 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern712 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew8_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew64_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern719 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern599 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern599 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern599 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern599 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern599 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern599 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern599 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern599 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern599 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern599 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern599 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern599 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern599 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern599 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern599 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern599 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern599 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern599 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern599 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern599 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern599 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern599 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern550 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern550 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern550 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern550 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern550 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern550 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern550 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern550 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern550 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern550 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern550 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern550 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern550 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern550 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern550 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern550 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern550 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern550 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern550 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern550 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern550 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern550 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern550 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern550 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern550 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern550 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern550 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern550 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern550 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern550 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern550 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern550 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern550 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern550 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern550 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern550 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern550 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern550 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern550 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern550 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern550 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern550 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern550 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern550 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern550 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern550 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern736 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern739 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern744 (rtx x1, int i1, machine_mode i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i2)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i2)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i2)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i2)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i2)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i2)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i2)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i2)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i2)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i2)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i2)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i2)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i2)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i2)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i2)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i2)
    return -1;
  switch (REGNO (x7))
    {
    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21
          || REGNO (x22) != 20
          || REGNO (x27) != 19)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i2)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i2)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i2)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x32) != 18)
        return -1;
      return 0;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i2)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i2)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i2)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
          || REGNO (x32) != 8)
        return -1;
      x37 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x37) != SET)
        return -1;
      x38 = XEXP (x37, 1);
      if (GET_CODE (x38) != MEM
          || GET_MODE (x38) != i2)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != PLUS
          || GET_MODE (x39) != i2)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 2
          || GET_MODE (x40) != i2)
        return -1;
      x41 = XEXP (x39, 1);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x42 = XEXP (x37, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 1
          || GET_MODE (x42) != i2)
        return -1;
      x43 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x43) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 1
          || GET_MODE (x45) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 19:
      if (REGNO (x12) != 18
          || REGNO (x17) != 9
          || REGNO (x22) != 8
          || REGNO (x27) != 1)
        return -1;
      x33 = XEXP (x31, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x32) != 10)
        return -1;
      x37 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x37) != USE)
        return -1;
      x42 = XEXP (x37, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 10
          || GET_MODE (x42) != i2)
        return -1;
      x43 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x43) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 1
          || GET_MODE (x45) != E_SImode
          || !stack_pop_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern764 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x12) != 23
          || REGNO (x17) != 22
          || REGNO (x22) != 21
          || REGNO (x27) != 20
          || REGNO (x32) != 19
          || REGNO (x37) != 18
          || REGNO (x42) != 9)
        return -1;
      return 0;

    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19
          || REGNO (x27) != 18
          || REGNO (x32) != 9
          || REGNO (x37) != 8
          || REGNO (x42) != 1)
        return -1;
      x48 = XEXP (x46, 1);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x47) != 10)
        return -1;
      x49 = XVECEXP (x1, 0, 10);
      if (pattern750 (x49, 
i1, 
10) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -72L)
    return -1;
  return 0;
}

int
pattern778 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != PLUS
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 2
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
    return -1;
  x15 = XEXP (x10, 0);
  if (REGNO (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x16) != SET)
    return -1;
  x17 = XEXP (x16, 1);
  return pattern777 (x17); /* [-1, 0] */
}

int
pattern783 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s7_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 9
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PLUS
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern787 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
    return -1;
  x6 = XEXP (x1, 0);
  return pattern786 (x6, 
E_SImode); /* [-1, 0] */
}

int
pattern792 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -88L)
    return -1;
  return 0;
}

int
pattern795 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s9_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 11);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 13);
  return pattern779 (x5, 
E_SImode, 
1); /* [-1, 0] */
}

int
pattern800 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s11_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern802 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -104L)
    return -1;
  x6 = XEXP (x1, 0);
  return pattern800 (x6, 
E_DImode); /* [-1, 0] */
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 325 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC))
        return -1;
      return 890; /* *th_maddhisi4 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30257; /* *dual_widen_fmasrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30259; /* *dual_widen_fmasrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30261; /* *dual_widen_fmasrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30263; /* *dual_widen_fmasrvvm1hi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30265; /* *dual_widen_fmasrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30267; /* *dual_widen_fmasrvvmf4hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30269; /* *dual_widen_fmasrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30271; /* *dual_widen_fmasrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30273; /* *dual_widen_fmasrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
          || !
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30275; /* *dual_widen_fmasrvvm1si */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30277; /* *dual_widen_fmasrvvmf2si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30279; /* *dual_widen_fmasrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30281; /* *dual_widen_fmasrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30283; /* *dual_widen_fmasrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30285; /* *dual_widen_fmasrvvm1di */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1HImode, 
E_V1QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30287; /* *dual_widen_fmasv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2HImode, 
E_V2QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30289; /* *dual_widen_fmasv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V4HImode, 
E_V4QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30291; /* *dual_widen_fmasv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V8HImode, 
E_V8QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30293; /* *dual_widen_fmasv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V16HImode, 
E_V16QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30295; /* *dual_widen_fmasv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V32HImode, 
E_V32QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30297; /* *dual_widen_fmasv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V64HImode, 
E_V64QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30299; /* *dual_widen_fmasv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V128HImode, 
E_V128QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30301; /* *dual_widen_fmasv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V256HImode, 
E_V256QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30303; /* *dual_widen_fmasv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V512HImode, 
E_V512QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30305; /* *dual_widen_fmasv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30307; /* *dual_widen_fmasv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30309; /* *dual_widen_fmasv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1SImode, 
E_V1HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30311; /* *dual_widen_fmasv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2SImode, 
E_V2HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30313; /* *dual_widen_fmasv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V4SImode, 
E_V4HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30315; /* *dual_widen_fmasv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V8SImode, 
E_V8HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30317; /* *dual_widen_fmasv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V16SImode, 
E_V16HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30319; /* *dual_widen_fmasv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V32SImode, 
E_V32HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30321; /* *dual_widen_fmasv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V64SImode, 
E_V64HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30323; /* *dual_widen_fmasv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V128SImode, 
E_V128HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30325; /* *dual_widen_fmasv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V256SImode, 
E_V256HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30327; /* *dual_widen_fmasv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V512SImode, 
E_V512HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30329; /* *dual_widen_fmasv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30331; /* *dual_widen_fmasv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V1DImode, 
E_V1SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30333; /* *dual_widen_fmasv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V2DImode, 
E_V2SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30335; /* *dual_widen_fmasv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V4DImode, 
E_V4SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30337; /* *dual_widen_fmasv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V8DImode, 
E_V8SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30339; /* *dual_widen_fmasv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V16DImode, 
E_V16SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30341; /* *dual_widen_fmasv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V32DImode, 
E_V32SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30343; /* *dual_widen_fmasv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V64DImode, 
E_V64SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30345; /* *dual_widen_fmasv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V128DImode, 
E_V128SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30347; /* *dual_widen_fmasv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V256DImode, 
E_V256SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30349; /* *dual_widen_fmasv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern326 (x2, 
E_V512DImode, 
E_V512SImode) != 0
          || !(
#line 903 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30351; /* *dual_widen_fmasv512di */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !
#line 901 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 12; /* subsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 901 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 13; /* subdf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 901 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 14; /* subhf3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern352 (x2, 
E_DImode) != 0
          || !
#line 910 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 15; /* subdi3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern352 (x2, 
E_SImode) != 0)
        return -1;
      return 16; /* *subsi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23615; /* subrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23629; /* subrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23643; /* subrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23657; /* subrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23671; /* subrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23685; /* subrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23699; /* subrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23713; /* subrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23727; /* subrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23741; /* subrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23755; /* subrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23769; /* subrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23783; /* subrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23797; /* subrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23811; /* subrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23825; /* subrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23839; /* subrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23853; /* subrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23867; /* subrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23881; /* subrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23895; /* subrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23909; /* subrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23923; /* subv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23937; /* subv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23951; /* subv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23965; /* subv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23979; /* subv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 23993; /* subv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24007; /* subv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24021; /* subv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24035; /* subv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24049; /* subv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24063; /* subv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24077; /* subv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24091; /* subv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24105; /* subv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24119; /* subv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24133; /* subv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24147; /* subv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24161; /* subv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24175; /* subv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24189; /* subv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24203; /* subv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24217; /* subv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24231; /* subv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24245; /* subv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24259; /* subv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24273; /* subv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24287; /* subv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24301; /* subv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24315; /* subv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24329; /* subv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24343; /* subv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24357; /* subv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24371; /* subv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24385; /* subv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24399; /* subv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24413; /* subv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24427; /* subv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24441; /* subv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24455; /* subv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24469; /* subv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24483; /* subv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24497; /* subv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24511; /* subv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24525; /* subv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24539; /* subv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern353 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24553; /* subv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26582; /* subrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26586; /* subrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26590; /* subrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26594; /* subrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26598; /* subrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26602; /* subrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26606; /* subrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26610; /* subrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26614; /* subrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26618; /* subrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26622; /* subrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26626; /* subrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26630; /* subrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26634; /* subrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26638; /* subrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26642; /* subv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26646; /* subv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26650; /* subv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26654; /* subv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26658; /* subv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26662; /* subv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26666; /* subv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26670; /* subv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26674; /* subv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26678; /* subv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26682; /* subv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26686; /* subv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26690; /* subv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26694; /* subv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26698; /* subv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26702; /* subv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26706; /* subv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26710; /* subv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26714; /* subv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26718; /* subv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26722; /* subv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26726; /* subv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26730; /* subv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26734; /* subv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26738; /* subv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26742; /* subv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26746; /* subv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26750; /* subv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26754; /* subv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26758; /* subv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26762; /* subv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26766; /* subv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26770; /* subv512df3 */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern155 (x2))
    {
    case 0:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28931; /* *narrow_ashrextendrvvm8hi */

    case 1:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28935; /* *narrow_ashrextendrvvm4hi */

    case 2:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28939; /* *narrow_ashrextendrvvm2hi */

    case 3:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28943; /* *narrow_ashrextendrvvm1hi */

    case 4:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28947; /* *narrow_ashrextendrvvmf2hi */

    case 5:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28951; /* *narrow_ashrextendrvvmf4hi */

    case 6:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28955; /* *narrow_ashrextendrvvm8si */

    case 7:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28959; /* *narrow_ashrextendrvvm4si */

    case 8:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28963; /* *narrow_ashrextendrvvm2si */

    case 9:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28967; /* *narrow_ashrextendrvvm1si */

    case 10:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28971; /* *narrow_ashrextendrvvmf2si */

    case 11:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28975; /* *narrow_ashrextendrvvm8di */

    case 12:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28979; /* *narrow_ashrextendrvvm4di */

    case 13:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28983; /* *narrow_ashrextendrvvm2di */

    case 14:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28987; /* *narrow_ashrextendrvvm1di */

    case 15:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28991; /* *narrow_ashrextendv1hi */

    case 16:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28995; /* *narrow_ashrextendv2hi */

    case 17:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28999; /* *narrow_ashrextendv4hi */

    case 18:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29003; /* *narrow_ashrextendv8hi */

    case 19:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29007; /* *narrow_ashrextendv16hi */

    case 20:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29011; /* *narrow_ashrextendv32hi */

    case 21:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29015; /* *narrow_ashrextendv64hi */

    case 22:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29019; /* *narrow_ashrextendv128hi */

    case 23:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29023; /* *narrow_ashrextendv256hi */

    case 24:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29027; /* *narrow_ashrextendv512hi */

    case 25:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29031; /* *narrow_ashrextendv1024hi */

    case 26:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29035; /* *narrow_ashrextendv2048hi */

    case 27:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29039; /* *narrow_ashrextendv1si */

    case 28:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29043; /* *narrow_ashrextendv2si */

    case 29:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29047; /* *narrow_ashrextendv4si */

    case 30:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29051; /* *narrow_ashrextendv8si */

    case 31:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29055; /* *narrow_ashrextendv16si */

    case 32:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29059; /* *narrow_ashrextendv32si */

    case 33:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29063; /* *narrow_ashrextendv64si */

    case 34:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29067; /* *narrow_ashrextendv128si */

    case 35:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29071; /* *narrow_ashrextendv256si */

    case 36:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29075; /* *narrow_ashrextendv512si */

    case 37:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29079; /* *narrow_ashrextendv1024si */

    case 38:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29083; /* *narrow_ashrextendv1di */

    case 39:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29087; /* *narrow_ashrextendv2di */

    case 40:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29091; /* *narrow_ashrextendv4di */

    case 41:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29095; /* *narrow_ashrextendv8di */

    case 42:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29099; /* *narrow_ashrextendv16di */

    case 43:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29103; /* *narrow_ashrextendv32di */

    case 44:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29107; /* *narrow_ashrextendv64di */

    case 45:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29111; /* *narrow_ashrextendv128di */

    case 46:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29115; /* *narrow_ashrextendv256di */

    case 47:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29119; /* *narrow_ashrextendv512di */

    case 48:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28933; /* *narrow_ashrzero_extendrvvm8hi */

    case 49:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28937; /* *narrow_ashrzero_extendrvvm4hi */

    case 50:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28941; /* *narrow_ashrzero_extendrvvm2hi */

    case 51:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28945; /* *narrow_ashrzero_extendrvvm1hi */

    case 52:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28949; /* *narrow_ashrzero_extendrvvmf2hi */

    case 53:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28953; /* *narrow_ashrzero_extendrvvmf4hi */

    case 54:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28957; /* *narrow_ashrzero_extendrvvm8si */

    case 55:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28961; /* *narrow_ashrzero_extendrvvm4si */

    case 56:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28965; /* *narrow_ashrzero_extendrvvm2si */

    case 57:
      if (!
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 28969; /* *narrow_ashrzero_extendrvvm1si */

    case 58:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28973; /* *narrow_ashrzero_extendrvvmf2si */

    case 59:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28977; /* *narrow_ashrzero_extendrvvm8di */

    case 60:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28981; /* *narrow_ashrzero_extendrvvm4di */

    case 61:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28985; /* *narrow_ashrzero_extendrvvm2di */

    case 62:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28989; /* *narrow_ashrzero_extendrvvm1di */

    case 63:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28993; /* *narrow_ashrzero_extendv1hi */

    case 64:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28997; /* *narrow_ashrzero_extendv2hi */

    case 65:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29001; /* *narrow_ashrzero_extendv4hi */

    case 66:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29005; /* *narrow_ashrzero_extendv8hi */

    case 67:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29009; /* *narrow_ashrzero_extendv16hi */

    case 68:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29013; /* *narrow_ashrzero_extendv32hi */

    case 69:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29017; /* *narrow_ashrzero_extendv64hi */

    case 70:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29021; /* *narrow_ashrzero_extendv128hi */

    case 71:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29025; /* *narrow_ashrzero_extendv256hi */

    case 72:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29029; /* *narrow_ashrzero_extendv512hi */

    case 73:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29033; /* *narrow_ashrzero_extendv1024hi */

    case 74:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29037; /* *narrow_ashrzero_extendv2048hi */

    case 75:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29041; /* *narrow_ashrzero_extendv1si */

    case 76:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29045; /* *narrow_ashrzero_extendv2si */

    case 77:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29049; /* *narrow_ashrzero_extendv4si */

    case 78:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29053; /* *narrow_ashrzero_extendv8si */

    case 79:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29057; /* *narrow_ashrzero_extendv16si */

    case 80:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29061; /* *narrow_ashrzero_extendv32si */

    case 81:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29065; /* *narrow_ashrzero_extendv64si */

    case 82:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29069; /* *narrow_ashrzero_extendv128si */

    case 83:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29073; /* *narrow_ashrzero_extendv256si */

    case 84:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29077; /* *narrow_ashrzero_extendv512si */

    case 85:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29081; /* *narrow_ashrzero_extendv1024si */

    case 86:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29085; /* *narrow_ashrzero_extendv1di */

    case 87:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29089; /* *narrow_ashrzero_extendv2di */

    case 88:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29093; /* *narrow_ashrzero_extendv4di */

    case 89:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29097; /* *narrow_ashrzero_extendv8di */

    case 90:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29101; /* *narrow_ashrzero_extendv16di */

    case 91:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29105; /* *narrow_ashrzero_extendv32di */

    case 92:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29109; /* *narrow_ashrzero_extendv64di */

    case 93:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29113; /* *narrow_ashrzero_extendv128di */

    case 94:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29117; /* *narrow_ashrzero_extendv256di */

    case 95:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29121; /* *narrow_ashrzero_extendv512di */

    case 96:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29123; /* *narrow_ashrrvvm8hi_scalar */

    case 97:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29125; /* *narrow_ashrrvvm4hi_scalar */

    case 98:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29127; /* *narrow_ashrrvvm2hi_scalar */

    case 99:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29129; /* *narrow_ashrrvvm1hi_scalar */

    case 100:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29131; /* *narrow_ashrrvvmf2hi_scalar */

    case 101:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29133; /* *narrow_ashrrvvmf4hi_scalar */

    case 102:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29135; /* *narrow_ashrrvvm8si_scalar */

    case 103:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29137; /* *narrow_ashrrvvm4si_scalar */

    case 104:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29139; /* *narrow_ashrrvvm2si_scalar */

    case 105:
      if (!
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 29141; /* *narrow_ashrrvvm1si_scalar */

    case 106:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 29143; /* *narrow_ashrrvvmf2si_scalar */

    case 107:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29145; /* *narrow_ashrrvvm8di_scalar */

    case 108:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29147; /* *narrow_ashrrvvm4di_scalar */

    case 109:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29149; /* *narrow_ashrrvvm2di_scalar */

    case 110:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29151; /* *narrow_ashrrvvm1di_scalar */

    case 111:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 29153; /* *narrow_ashrv1hi_scalar */

    case 112:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 29155; /* *narrow_ashrv2hi_scalar */

    case 113:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 29157; /* *narrow_ashrv4hi_scalar */

    case 114:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 29159; /* *narrow_ashrv8hi_scalar */

    case 115:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 29161; /* *narrow_ashrv16hi_scalar */

    case 116:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29163; /* *narrow_ashrv32hi_scalar */

    case 117:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29165; /* *narrow_ashrv64hi_scalar */

    case 118:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29167; /* *narrow_ashrv128hi_scalar */

    case 119:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29169; /* *narrow_ashrv256hi_scalar */

    case 120:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29171; /* *narrow_ashrv512hi_scalar */

    case 121:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29173; /* *narrow_ashrv1024hi_scalar */

    case 122:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29175; /* *narrow_ashrv2048hi_scalar */

    case 123:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 29177; /* *narrow_ashrv1si_scalar */

    case 124:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 29179; /* *narrow_ashrv2si_scalar */

    case 125:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 29181; /* *narrow_ashrv4si_scalar */

    case 126:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 29183; /* *narrow_ashrv8si_scalar */

    case 127:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29185; /* *narrow_ashrv16si_scalar */

    case 128:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29187; /* *narrow_ashrv32si_scalar */

    case 129:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29189; /* *narrow_ashrv64si_scalar */

    case 130:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29191; /* *narrow_ashrv128si_scalar */

    case 131:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29193; /* *narrow_ashrv256si_scalar */

    case 132:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29195; /* *narrow_ashrv512si_scalar */

    case 133:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29197; /* *narrow_ashrv1024si_scalar */

    case 134:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29199; /* *narrow_ashrv1di_scalar */

    case 135:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29201; /* *narrow_ashrv2di_scalar */

    case 136:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 29203; /* *narrow_ashrv4di_scalar */

    case 137:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 29205; /* *narrow_ashrv8di_scalar */

    case 138:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 29207; /* *narrow_ashrv16di_scalar */

    case 139:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 29209; /* *narrow_ashrv32di_scalar */

    case 140:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 29211; /* *narrow_ashrv64di_scalar */

    case 141:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 29213; /* *narrow_ashrv128di_scalar */

    case 142:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 29215; /* *narrow_ashrv256di_scalar */

    case 143:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 29217; /* *narrow_ashrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern162 (x1))
    {
    case 0:
      if (!(
#line 3549 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 394; /* fle_quietsfsi4_zfa */

    case 1:
      if (!(
#line 3549 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 398; /* fle_quietdfsi4_zfa */

    case 2:
      if (!(
#line 3549 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 402; /* fle_quiethfsi4_zfa */

    case 3:
      if (!(
#line 3549 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 396; /* fle_quietsfdi4_zfa */

    case 4:
      if (!(
#line 3549 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 400; /* fle_quietdfdi4_zfa */

    case 5:
      if (!(
#line 3549 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 404; /* fle_quiethfdi4_zfa */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_10_operand (operands[2], E_SImode)
      || !
#line 261 "../../../gcc/config/riscv/crypto.md"
((TARGET_ZKND || TARGET_ZKNE) && TARGET_64BIT))
    return -1;
  return 672; /* riscv_aes64ks1i */
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2489; /* vundefinedrvvm8qi */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2490; /* vundefinedrvvm4qi */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2491; /* vundefinedrvvm2qi */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2492; /* vundefinedrvvm1qi */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2493; /* vundefinedrvvm8hi */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2494; /* vundefinedrvvm4hi */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2495; /* vundefinedrvvm2hi */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2496; /* vundefinedrvvm1hi */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2497; /* vundefinedrvvm8si */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2498; /* vundefinedrvvm4si */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2499; /* vundefinedrvvm2si */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2500; /* vundefinedrvvm1si */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2501; /* vundefinedrvvm8di */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2502; /* vundefinedrvvm4di */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2503; /* vundefinedrvvm2di */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2504; /* vundefinedrvvm1di */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 2505; /* vundefinedrvvmf2qi */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 2506; /* vundefinedrvvmf4qi */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2507; /* vundefinedrvvmf8qi */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 2508; /* vundefinedrvvmf2hi */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2509; /* vundefinedrvvmf4hi */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2510; /* vundefinedrvvmf2si */

    case E_RVVM8BFmode:
      if (!register_operand (operands[0], E_RVVM8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8BFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2511; /* vundefinedrvvm8bf */

    case E_RVVM4BFmode:
      if (!register_operand (operands[0], E_RVVM4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4BFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2512; /* vundefinedrvvm4bf */

    case E_RVVM2BFmode:
      if (!register_operand (operands[0], E_RVVM2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2BFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2513; /* vundefinedrvvm2bf */

    case E_RVVM1BFmode:
      if (!register_operand (operands[0], E_RVVM1BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2514; /* vundefinedrvvm1bf */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[0], E_RVVMF2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2515; /* vundefinedrvvmf2bf */

    case E_RVVMF4BFmode:
      if (!register_operand (operands[0], E_RVVMF4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2516; /* vundefinedrvvmf4bf */

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2517; /* vundefinedrvvm8hf */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2518; /* vundefinedrvvm4hf */

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2519; /* vundefinedrvvm2hf */

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2520; /* vundefinedrvvm1hf */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2521; /* vundefinedrvvmf2hf */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2522; /* vundefinedrvvmf4hf */

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2523; /* vundefinedrvvm8sf */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2524; /* vundefinedrvvm4sf */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2525; /* vundefinedrvvm2sf */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2526; /* vundefinedrvvm1sf */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2527; /* vundefinedrvvmf2sf */

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2528; /* vundefinedrvvm8df */

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2529; /* vundefinedrvvm4df */

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2530; /* vundefinedrvvm2df */

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !(
#line 1013 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2531; /* vundefinedrvvm1df */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !(
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2532; /* vundefinedrvvmf64bi */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2533; /* vundefinedrvvmf32bi */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2534; /* vundefinedrvvmf16bi */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2535; /* vundefinedrvvmf8bi */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2536; /* vundefinedrvvmf4bi */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2537; /* vundefinedrvvmf2bi */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !
#line 1020 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2538; /* vundefinedrvvm1bi */

    case E_RVVMF8x2QImode:
      if (!register_operand (operands[0], E_RVVMF8x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x2QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2539; /* vundefinedrvvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[0], E_RVVMF8x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x3QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2540; /* vundefinedrvvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[0], E_RVVMF8x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x4QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2541; /* vundefinedrvvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[0], E_RVVMF8x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x5QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2542; /* vundefinedrvvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[0], E_RVVMF8x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x6QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2543; /* vundefinedrvvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[0], E_RVVMF8x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x7QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2544; /* vundefinedrvvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[0], E_RVVMF8x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8x8QImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2545; /* vundefinedrvvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[0], E_RVVMF4x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2546; /* vundefinedrvvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[0], E_RVVMF4x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2547; /* vundefinedrvvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[0], E_RVVMF4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2548; /* vundefinedrvvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[0], E_RVVMF4x5HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2549; /* vundefinedrvvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[0], E_RVVMF4x6HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2550; /* vundefinedrvvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[0], E_RVVMF4x7HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2551; /* vundefinedrvvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[0], E_RVVMF4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8HImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2552; /* vundefinedrvvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[0], E_RVVMF2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2553; /* vundefinedrvvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[0], E_RVVMF2x3SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2554; /* vundefinedrvvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[0], E_RVVMF2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2555; /* vundefinedrvvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[0], E_RVVMF2x5SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2556; /* vundefinedrvvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[0], E_RVVMF2x6SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2557; /* vundefinedrvvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[0], E_RVVMF2x7SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2558; /* vundefinedrvvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[0], E_RVVMF2x8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8SImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2559; /* vundefinedrvvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[0], E_RVVM1x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2560; /* vundefinedrvvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[0], E_RVVM1x3DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2561; /* vundefinedrvvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[0], E_RVVM1x4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2562; /* vundefinedrvvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[0], E_RVVM1x5DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2563; /* vundefinedrvvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[0], E_RVVM1x6DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2564; /* vundefinedrvvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[0], E_RVVM1x7DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2565; /* vundefinedrvvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[0], E_RVVM1x8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2566; /* vundefinedrvvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[0], E_RVVMF4x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2567; /* vundefinedrvvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[0], E_RVVMF4x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2568; /* vundefinedrvvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[0], E_RVVMF4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2569; /* vundefinedrvvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[0], E_RVVMF4x5BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2570; /* vundefinedrvvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[0], E_RVVMF4x6BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2571; /* vundefinedrvvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[0], E_RVVMF4x7BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2572; /* vundefinedrvvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[0], E_RVVMF4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2573; /* vundefinedrvvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[0], E_RVVMF4x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2574; /* vundefinedrvvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[0], E_RVVMF4x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2575; /* vundefinedrvvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[0], E_RVVMF4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2576; /* vundefinedrvvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[0], E_RVVMF4x5HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2577; /* vundefinedrvvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[0], E_RVVMF4x6HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2578; /* vundefinedrvvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[0], E_RVVMF4x7HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2579; /* vundefinedrvvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[0], E_RVVMF4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2580; /* vundefinedrvvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[0], E_RVVMF2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2581; /* vundefinedrvvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[0], E_RVVMF2x3SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2582; /* vundefinedrvvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[0], E_RVVMF2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2583; /* vundefinedrvvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[0], E_RVVMF2x5SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2584; /* vundefinedrvvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[0], E_RVVMF2x6SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2585; /* vundefinedrvvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[0], E_RVVMF2x7SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2586; /* vundefinedrvvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[0], E_RVVMF2x8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2587; /* vundefinedrvvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[0], E_RVVM1x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2588; /* vundefinedrvvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[0], E_RVVM1x3DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2589; /* vundefinedrvvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[0], E_RVVM1x4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2590; /* vundefinedrvvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[0], E_RVVM1x5DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2591; /* vundefinedrvvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[0], E_RVVM1x6DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2592; /* vundefinedrvvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[0], E_RVVM1x7DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2593; /* vundefinedrvvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[0], E_RVVM1x8DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2594; /* vundefinedrvvm1x8df */

    case E_RVVMF4x2QImode:
      if (!register_operand (operands[0], E_RVVMF4x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x2QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2595; /* vundefinedrvvmf4x2qi */

    case E_RVVMF4x3QImode:
      if (!register_operand (operands[0], E_RVVMF4x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x3QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2596; /* vundefinedrvvmf4x3qi */

    case E_RVVMF4x4QImode:
      if (!register_operand (operands[0], E_RVVMF4x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x4QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2597; /* vundefinedrvvmf4x4qi */

    case E_RVVMF4x5QImode:
      if (!register_operand (operands[0], E_RVVMF4x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x5QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2598; /* vundefinedrvvmf4x5qi */

    case E_RVVMF4x6QImode:
      if (!register_operand (operands[0], E_RVVMF4x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x6QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2599; /* vundefinedrvvmf4x6qi */

    case E_RVVMF4x7QImode:
      if (!register_operand (operands[0], E_RVVMF4x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x7QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2600; /* vundefinedrvvmf4x7qi */

    case E_RVVMF4x8QImode:
      if (!register_operand (operands[0], E_RVVMF4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4x8QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2601; /* vundefinedrvvmf4x8qi */

    case E_RVVMF2x2HImode:
      if (!register_operand (operands[0], E_RVVMF2x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2602; /* vundefinedrvvmf2x2hi */

    case E_RVVMF2x3HImode:
      if (!register_operand (operands[0], E_RVVMF2x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2603; /* vundefinedrvvmf2x3hi */

    case E_RVVMF2x4HImode:
      if (!register_operand (operands[0], E_RVVMF2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2604; /* vundefinedrvvmf2x4hi */

    case E_RVVMF2x5HImode:
      if (!register_operand (operands[0], E_RVVMF2x5HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2605; /* vundefinedrvvmf2x5hi */

    case E_RVVMF2x6HImode:
      if (!register_operand (operands[0], E_RVVMF2x6HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2606; /* vundefinedrvvmf2x6hi */

    case E_RVVMF2x7HImode:
      if (!register_operand (operands[0], E_RVVMF2x7HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2607; /* vundefinedrvvmf2x7hi */

    case E_RVVMF2x8HImode:
      if (!register_operand (operands[0], E_RVVMF2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2608; /* vundefinedrvvmf2x8hi */

    case E_RVVM1x2SImode:
      if (!register_operand (operands[0], E_RVVM1x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2609; /* vundefinedrvvm1x2si */

    case E_RVVM1x3SImode:
      if (!register_operand (operands[0], E_RVVM1x3SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2610; /* vundefinedrvvm1x3si */

    case E_RVVM1x4SImode:
      if (!register_operand (operands[0], E_RVVM1x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2611; /* vundefinedrvvm1x4si */

    case E_RVVM1x5SImode:
      if (!register_operand (operands[0], E_RVVM1x5SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2612; /* vundefinedrvvm1x5si */

    case E_RVVM1x6SImode:
      if (!register_operand (operands[0], E_RVVM1x6SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2613; /* vundefinedrvvm1x6si */

    case E_RVVM1x7SImode:
      if (!register_operand (operands[0], E_RVVM1x7SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2614; /* vundefinedrvvm1x7si */

    case E_RVVM1x8SImode:
      if (!register_operand (operands[0], E_RVVM1x8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2615; /* vundefinedrvvm1x8si */

    case E_RVVM2x2DImode:
      if (!register_operand (operands[0], E_RVVM2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2616; /* vundefinedrvvm2x2di */

    case E_RVVM2x3DImode:
      if (!register_operand (operands[0], E_RVVM2x3DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2617; /* vundefinedrvvm2x3di */

    case E_RVVM2x4DImode:
      if (!register_operand (operands[0], E_RVVM2x4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2618; /* vundefinedrvvm2x4di */

    case E_RVVMF2x2BFmode:
      if (!register_operand (operands[0], E_RVVMF2x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2619; /* vundefinedrvvmf2x2bf */

    case E_RVVMF2x3BFmode:
      if (!register_operand (operands[0], E_RVVMF2x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2620; /* vundefinedrvvmf2x3bf */

    case E_RVVMF2x4BFmode:
      if (!register_operand (operands[0], E_RVVMF2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2621; /* vundefinedrvvmf2x4bf */

    case E_RVVMF2x5BFmode:
      if (!register_operand (operands[0], E_RVVMF2x5BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2622; /* vundefinedrvvmf2x5bf */

    case E_RVVMF2x6BFmode:
      if (!register_operand (operands[0], E_RVVMF2x6BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2623; /* vundefinedrvvmf2x6bf */

    case E_RVVMF2x7BFmode:
      if (!register_operand (operands[0], E_RVVMF2x7BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2624; /* vundefinedrvvmf2x7bf */

    case E_RVVMF2x8BFmode:
      if (!register_operand (operands[0], E_RVVMF2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2625; /* vundefinedrvvmf2x8bf */

    case E_RVVMF2x2HFmode:
      if (!register_operand (operands[0], E_RVVMF2x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2626; /* vundefinedrvvmf2x2hf */

    case E_RVVMF2x3HFmode:
      if (!register_operand (operands[0], E_RVVMF2x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2627; /* vundefinedrvvmf2x3hf */

    case E_RVVMF2x4HFmode:
      if (!register_operand (operands[0], E_RVVMF2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2628; /* vundefinedrvvmf2x4hf */

    case E_RVVMF2x5HFmode:
      if (!register_operand (operands[0], E_RVVMF2x5HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2629; /* vundefinedrvvmf2x5hf */

    case E_RVVMF2x6HFmode:
      if (!register_operand (operands[0], E_RVVMF2x6HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2630; /* vundefinedrvvmf2x6hf */

    case E_RVVMF2x7HFmode:
      if (!register_operand (operands[0], E_RVVMF2x7HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2631; /* vundefinedrvvmf2x7hf */

    case E_RVVMF2x8HFmode:
      if (!register_operand (operands[0], E_RVVMF2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2632; /* vundefinedrvvmf2x8hf */

    case E_RVVM1x2SFmode:
      if (!register_operand (operands[0], E_RVVM1x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2633; /* vundefinedrvvm1x2sf */

    case E_RVVM1x3SFmode:
      if (!register_operand (operands[0], E_RVVM1x3SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2634; /* vundefinedrvvm1x3sf */

    case E_RVVM1x4SFmode:
      if (!register_operand (operands[0], E_RVVM1x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2635; /* vundefinedrvvm1x4sf */

    case E_RVVM1x5SFmode:
      if (!register_operand (operands[0], E_RVVM1x5SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2636; /* vundefinedrvvm1x5sf */

    case E_RVVM1x6SFmode:
      if (!register_operand (operands[0], E_RVVM1x6SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2637; /* vundefinedrvvm1x6sf */

    case E_RVVM1x7SFmode:
      if (!register_operand (operands[0], E_RVVM1x7SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2638; /* vundefinedrvvm1x7sf */

    case E_RVVM1x8SFmode:
      if (!register_operand (operands[0], E_RVVM1x8SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2639; /* vundefinedrvvm1x8sf */

    case E_RVVM2x2DFmode:
      if (!register_operand (operands[0], E_RVVM2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2640; /* vundefinedrvvm2x2df */

    case E_RVVM2x3DFmode:
      if (!register_operand (operands[0], E_RVVM2x3DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2641; /* vundefinedrvvm2x3df */

    case E_RVVM2x4DFmode:
      if (!register_operand (operands[0], E_RVVM2x4DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2642; /* vundefinedrvvm2x4df */

    case E_RVVMF2x2QImode:
      if (!register_operand (operands[0], E_RVVMF2x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x2QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2643; /* vundefinedrvvmf2x2qi */

    case E_RVVMF2x3QImode:
      if (!register_operand (operands[0], E_RVVMF2x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x3QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2644; /* vundefinedrvvmf2x3qi */

    case E_RVVMF2x4QImode:
      if (!register_operand (operands[0], E_RVVMF2x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x4QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2645; /* vundefinedrvvmf2x4qi */

    case E_RVVMF2x5QImode:
      if (!register_operand (operands[0], E_RVVMF2x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x5QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2646; /* vundefinedrvvmf2x5qi */

    case E_RVVMF2x6QImode:
      if (!register_operand (operands[0], E_RVVMF2x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x6QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2647; /* vundefinedrvvmf2x6qi */

    case E_RVVMF2x7QImode:
      if (!register_operand (operands[0], E_RVVMF2x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x7QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2648; /* vundefinedrvvmf2x7qi */

    case E_RVVMF2x8QImode:
      if (!register_operand (operands[0], E_RVVMF2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2x8QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2649; /* vundefinedrvvmf2x8qi */

    case E_RVVM1x2HImode:
      if (!register_operand (operands[0], E_RVVM1x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2650; /* vundefinedrvvm1x2hi */

    case E_RVVM1x3HImode:
      if (!register_operand (operands[0], E_RVVM1x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2651; /* vundefinedrvvm1x3hi */

    case E_RVVM1x4HImode:
      if (!register_operand (operands[0], E_RVVM1x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2652; /* vundefinedrvvm1x4hi */

    case E_RVVM1x5HImode:
      if (!register_operand (operands[0], E_RVVM1x5HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2653; /* vundefinedrvvm1x5hi */

    case E_RVVM1x6HImode:
      if (!register_operand (operands[0], E_RVVM1x6HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2654; /* vundefinedrvvm1x6hi */

    case E_RVVM1x7HImode:
      if (!register_operand (operands[0], E_RVVM1x7HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2655; /* vundefinedrvvm1x7hi */

    case E_RVVM1x8HImode:
      if (!register_operand (operands[0], E_RVVM1x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2656; /* vundefinedrvvm1x8hi */

    case E_RVVM2x2SImode:
      if (!register_operand (operands[0], E_RVVM2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2657; /* vundefinedrvvm2x2si */

    case E_RVVM2x3SImode:
      if (!register_operand (operands[0], E_RVVM2x3SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2658; /* vundefinedrvvm2x3si */

    case E_RVVM2x4SImode:
      if (!register_operand (operands[0], E_RVVM2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2659; /* vundefinedrvvm2x4si */

    case E_RVVM4x2DImode:
      if (!register_operand (operands[0], E_RVVM4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2DImode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2660; /* vundefinedrvvm4x2di */

    case E_RVVM1x2BFmode:
      if (!register_operand (operands[0], E_RVVM1x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2661; /* vundefinedrvvm1x2bf */

    case E_RVVM1x3BFmode:
      if (!register_operand (operands[0], E_RVVM1x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2662; /* vundefinedrvvm1x3bf */

    case E_RVVM1x4BFmode:
      if (!register_operand (operands[0], E_RVVM1x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2663; /* vundefinedrvvm1x4bf */

    case E_RVVM1x5BFmode:
      if (!register_operand (operands[0], E_RVVM1x5BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2664; /* vundefinedrvvm1x5bf */

    case E_RVVM1x6BFmode:
      if (!register_operand (operands[0], E_RVVM1x6BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2665; /* vundefinedrvvm1x6bf */

    case E_RVVM1x7BFmode:
      if (!register_operand (operands[0], E_RVVM1x7BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2666; /* vundefinedrvvm1x7bf */

    case E_RVVM1x8BFmode:
      if (!register_operand (operands[0], E_RVVM1x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2667; /* vundefinedrvvm1x8bf */

    case E_RVVM1x2HFmode:
      if (!register_operand (operands[0], E_RVVM1x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2668; /* vundefinedrvvm1x2hf */

    case E_RVVM1x3HFmode:
      if (!register_operand (operands[0], E_RVVM1x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2669; /* vundefinedrvvm1x3hf */

    case E_RVVM1x4HFmode:
      if (!register_operand (operands[0], E_RVVM1x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2670; /* vundefinedrvvm1x4hf */

    case E_RVVM1x5HFmode:
      if (!register_operand (operands[0], E_RVVM1x5HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2671; /* vundefinedrvvm1x5hf */

    case E_RVVM1x6HFmode:
      if (!register_operand (operands[0], E_RVVM1x6HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2672; /* vundefinedrvvm1x6hf */

    case E_RVVM1x7HFmode:
      if (!register_operand (operands[0], E_RVVM1x7HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2673; /* vundefinedrvvm1x7hf */

    case E_RVVM1x8HFmode:
      if (!register_operand (operands[0], E_RVVM1x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2674; /* vundefinedrvvm1x8hf */

    case E_RVVM2x2SFmode:
      if (!register_operand (operands[0], E_RVVM2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2675; /* vundefinedrvvm2x2sf */

    case E_RVVM2x3SFmode:
      if (!register_operand (operands[0], E_RVVM2x3SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2676; /* vundefinedrvvm2x3sf */

    case E_RVVM2x4SFmode:
      if (!register_operand (operands[0], E_RVVM2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2677; /* vundefinedrvvm2x4sf */

    case E_RVVM4x2DFmode:
      if (!register_operand (operands[0], E_RVVM4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2DFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 2678; /* vundefinedrvvm4x2df */

    case E_RVVM1x2QImode:
      if (!register_operand (operands[0], E_RVVM1x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x2QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2679; /* vundefinedrvvm1x2qi */

    case E_RVVM1x3QImode:
      if (!register_operand (operands[0], E_RVVM1x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x3QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2680; /* vundefinedrvvm1x3qi */

    case E_RVVM1x4QImode:
      if (!register_operand (operands[0], E_RVVM1x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x4QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2681; /* vundefinedrvvm1x4qi */

    case E_RVVM1x5QImode:
      if (!register_operand (operands[0], E_RVVM1x5QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x5QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2682; /* vundefinedrvvm1x5qi */

    case E_RVVM1x6QImode:
      if (!register_operand (operands[0], E_RVVM1x6QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x6QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2683; /* vundefinedrvvm1x6qi */

    case E_RVVM1x7QImode:
      if (!register_operand (operands[0], E_RVVM1x7QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x7QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2684; /* vundefinedrvvm1x7qi */

    case E_RVVM1x8QImode:
      if (!register_operand (operands[0], E_RVVM1x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1x8QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2685; /* vundefinedrvvm1x8qi */

    case E_RVVM2x2HImode:
      if (!register_operand (operands[0], E_RVVM2x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2686; /* vundefinedrvvm2x2hi */

    case E_RVVM2x3HImode:
      if (!register_operand (operands[0], E_RVVM2x3HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2687; /* vundefinedrvvm2x3hi */

    case E_RVVM2x4HImode:
      if (!register_operand (operands[0], E_RVVM2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2688; /* vundefinedrvvm2x4hi */

    case E_RVVM4x2SImode:
      if (!register_operand (operands[0], E_RVVM4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2SImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2689; /* vundefinedrvvm4x2si */

    case E_RVVM2x2BFmode:
      if (!register_operand (operands[0], E_RVVM2x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2690; /* vundefinedrvvm2x2bf */

    case E_RVVM2x3BFmode:
      if (!register_operand (operands[0], E_RVVM2x3BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2691; /* vundefinedrvvm2x3bf */

    case E_RVVM2x4BFmode:
      if (!register_operand (operands[0], E_RVVM2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2692; /* vundefinedrvvm2x4bf */

    case E_RVVM2x2HFmode:
      if (!register_operand (operands[0], E_RVVM2x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2693; /* vundefinedrvvm2x2hf */

    case E_RVVM2x3HFmode:
      if (!register_operand (operands[0], E_RVVM2x3HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2694; /* vundefinedrvvm2x3hf */

    case E_RVVM2x4HFmode:
      if (!register_operand (operands[0], E_RVVM2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2695; /* vundefinedrvvm2x4hf */

    case E_RVVM4x2SFmode:
      if (!register_operand (operands[0], E_RVVM4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2SFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 2696; /* vundefinedrvvm4x2sf */

    case E_RVVM2x2QImode:
      if (!register_operand (operands[0], E_RVVM2x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x2QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2697; /* vundefinedrvvm2x2qi */

    case E_RVVM2x3QImode:
      if (!register_operand (operands[0], E_RVVM2x3QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x3QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2698; /* vundefinedrvvm2x3qi */

    case E_RVVM2x4QImode:
      if (!register_operand (operands[0], E_RVVM2x4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2x4QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2699; /* vundefinedrvvm2x4qi */

    case E_RVVM4x2HImode:
      if (!register_operand (operands[0], E_RVVM4x2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2HImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2700; /* vundefinedrvvm4x2hi */

    case E_RVVM4x2BFmode:
      if (!register_operand (operands[0], E_RVVM4x2BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2BFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2701; /* vundefinedrvvm4x2bf */

    case E_RVVM4x2HFmode:
      if (!register_operand (operands[0], E_RVVM4x2HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2HFmode
          || !(
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2702; /* vundefinedrvvm4x2hf */

    case E_RVVM4x2QImode:
      if (!register_operand (operands[0], E_RVVM4x2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4x2QImode
          || !
#line 1027 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2703; /* vundefinedrvvm4x2qi */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern190 (x1))
    {
    case 0:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19396; /* pred_slide1uprvvm8qi */

    case 1:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19398; /* pred_slide1uprvvm4qi */

    case 2:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19400; /* pred_slide1uprvvm2qi */

    case 3:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19402; /* pred_slide1uprvvm1qi */

    case 4:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19404; /* pred_slide1uprvvmf2qi */

    case 5:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19406; /* pred_slide1uprvvmf4qi */

    case 6:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 19408; /* pred_slide1uprvvmf8qi */

    case 7:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19410; /* pred_slide1uprvvm8hi */

    case 8:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19412; /* pred_slide1uprvvm4hi */

    case 9:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19414; /* pred_slide1uprvvm2hi */

    case 10:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19416; /* pred_slide1uprvvm1hi */

    case 11:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19418; /* pred_slide1uprvvmf2hi */

    case 12:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 19420; /* pred_slide1uprvvmf4hi */

    case 13:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19422; /* pred_slide1uprvvm8si */

    case 14:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19424; /* pred_slide1uprvvm4si */

    case 15:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19426; /* pred_slide1uprvvm2si */

    case 16:
      if (!
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19428; /* pred_slide1uprvvm1si */

    case 17:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 19430; /* pred_slide1uprvvmf2si */

    case 18:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 19432; /* pred_slide1upv1qi */

    case 19:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 19434; /* pred_slide1upv2qi */

    case 20:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 19436; /* pred_slide1upv4qi */

    case 21:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 19438; /* pred_slide1upv8qi */

    case 22:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 19440; /* pred_slide1upv16qi */

    case 23:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 19442; /* pred_slide1upv32qi */

    case 24:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19444; /* pred_slide1upv64qi */

    case 25:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19446; /* pred_slide1upv128qi */

    case 26:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19448; /* pred_slide1upv256qi */

    case 27:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19450; /* pred_slide1upv512qi */

    case 28:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19452; /* pred_slide1upv1024qi */

    case 29:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19454; /* pred_slide1upv2048qi */

    case 30:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19456; /* pred_slide1upv4096qi */

    case 31:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 19458; /* pred_slide1upv1hi */

    case 32:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 19460; /* pred_slide1upv2hi */

    case 33:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 19462; /* pred_slide1upv4hi */

    case 34:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 19464; /* pred_slide1upv8hi */

    case 35:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 19466; /* pred_slide1upv16hi */

    case 36:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19468; /* pred_slide1upv32hi */

    case 37:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19470; /* pred_slide1upv64hi */

    case 38:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19472; /* pred_slide1upv128hi */

    case 39:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19474; /* pred_slide1upv256hi */

    case 40:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19476; /* pred_slide1upv512hi */

    case 41:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19478; /* pred_slide1upv1024hi */

    case 42:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19480; /* pred_slide1upv2048hi */

    case 43:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 19482; /* pred_slide1upv1si */

    case 44:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 19484; /* pred_slide1upv2si */

    case 45:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 19486; /* pred_slide1upv4si */

    case 46:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 19488; /* pred_slide1upv8si */

    case 47:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19490; /* pred_slide1upv16si */

    case 48:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19492; /* pred_slide1upv32si */

    case 49:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19494; /* pred_slide1upv64si */

    case 50:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19496; /* pred_slide1upv128si */

    case 51:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19498; /* pred_slide1upv256si */

    case 52:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19500; /* pred_slide1upv512si */

    case 53:
      if (!(
#line 8000 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19502; /* pred_slide1upv1024si */

    case 54:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19504; /* *pred_slide1uprvvm8di */

    case 55:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19506; /* *pred_slide1uprvvm4di */

    case 56:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19508; /* *pred_slide1uprvvm2di */

    case 57:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19510; /* *pred_slide1uprvvm1di */

    case 58:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19512; /* *pred_slide1upv1di */

    case 59:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19514; /* *pred_slide1upv2di */

    case 60:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19516; /* *pred_slide1upv4di */

    case 61:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19518; /* *pred_slide1upv8di */

    case 62:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19520; /* *pred_slide1upv16di */

    case 63:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19522; /* *pred_slide1upv32di */

    case 64:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19524; /* *pred_slide1upv64di */

    case 65:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19526; /* *pred_slide1upv128di */

    case 66:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19528; /* *pred_slide1upv256di */

    case 67:
      if (!(
#line 8044 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19530; /* *pred_slide1upv512di */

    case 68:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19532; /* *pred_slide1uprvvm8di_extended */

    case 69:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19534; /* *pred_slide1uprvvm4di_extended */

    case 70:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19536; /* *pred_slide1uprvvm2di_extended */

    case 71:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19538; /* *pred_slide1uprvvm1di_extended */

    case 72:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19540; /* *pred_slide1upv1di_extended */

    case 73:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19542; /* *pred_slide1upv2di_extended */

    case 74:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19544; /* *pred_slide1upv4di_extended */

    case 75:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 19546; /* *pred_slide1upv8di_extended */

    case 76:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 19548; /* *pred_slide1upv16di_extended */

    case 77:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 19550; /* *pred_slide1upv32di_extended */

    case 78:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 19552; /* *pred_slide1upv64di_extended */

    case 79:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 19554; /* *pred_slide1upv128di_extended */

    case 80:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 19556; /* *pred_slide1upv256di_extended */

    case 81:
      if (!(
#line 8064 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 19558; /* *pred_slide1upv512di_extended */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 170:
      switch (pattern178 (x1, 
170))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2310; /* pred_indexed_store_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2316; /* pred_indexed_store_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2334; /* pred_indexed_store_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2322; /* pred_indexed_store_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2340; /* pred_indexed_store_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2358; /* pred_indexed_store_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2328; /* pred_indexed_store_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2346; /* pred_indexed_store_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2364; /* pred_indexed_store_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2382; /* pred_indexed_store_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2352; /* pred_indexed_store_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2370; /* pred_indexed_store_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2388; /* pred_indexed_store_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2376; /* pred_indexed_store_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2394; /* pred_indexed_store_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2400; /* pred_indexed_store_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2406; /* pred_indexed_store_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2412; /* pred_indexed_store_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2418; /* pred_indexed_store_widthbrvvmf2si */

        default:
          return -1;
        }

    case 172:
      switch (pattern178 (x1, 
172))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2311; /* pred_indexed_store_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2317; /* pred_indexed_store_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2335; /* pred_indexed_store_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2323; /* pred_indexed_store_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2341; /* pred_indexed_store_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2359; /* pred_indexed_store_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2329; /* pred_indexed_store_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2347; /* pred_indexed_store_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2365; /* pred_indexed_store_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2383; /* pred_indexed_store_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2353; /* pred_indexed_store_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2371; /* pred_indexed_store_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2389; /* pred_indexed_store_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2377; /* pred_indexed_store_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2395; /* pred_indexed_store_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2401; /* pred_indexed_store_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2407; /* pred_indexed_store_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2413; /* pred_indexed_store_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2419; /* pred_indexed_store_widthhrvvmf2si */

        default:
          return -1;
        }

    case 174:
      switch (pattern178 (x1, 
174))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2312; /* pred_indexed_store_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2318; /* pred_indexed_store_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2336; /* pred_indexed_store_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2324; /* pred_indexed_store_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2342; /* pred_indexed_store_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2360; /* pred_indexed_store_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2330; /* pred_indexed_store_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2348; /* pred_indexed_store_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2366; /* pred_indexed_store_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2384; /* pred_indexed_store_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2354; /* pred_indexed_store_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2372; /* pred_indexed_store_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2390; /* pred_indexed_store_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2378; /* pred_indexed_store_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2396; /* pred_indexed_store_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2402; /* pred_indexed_store_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2408; /* pred_indexed_store_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2414; /* pred_indexed_store_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2420; /* pred_indexed_store_widthwrvvmf2si */

        default:
          return -1;
        }

    case 176:
      switch (pattern178 (x1, 
176))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2313; /* pred_indexed_ustore_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2319; /* pred_indexed_ustore_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2337; /* pred_indexed_ustore_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2325; /* pred_indexed_ustore_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2343; /* pred_indexed_ustore_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2361; /* pred_indexed_ustore_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2331; /* pred_indexed_ustore_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2349; /* pred_indexed_ustore_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2367; /* pred_indexed_ustore_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2385; /* pred_indexed_ustore_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2355; /* pred_indexed_ustore_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2373; /* pred_indexed_ustore_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2391; /* pred_indexed_ustore_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2379; /* pred_indexed_ustore_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2397; /* pred_indexed_ustore_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2403; /* pred_indexed_ustore_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2409; /* pred_indexed_ustore_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2415; /* pred_indexed_ustore_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2421; /* pred_indexed_ustore_widthbrvvmf2si */

        default:
          return -1;
        }

    case 177:
      switch (pattern178 (x1, 
177))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2314; /* pred_indexed_ustore_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2320; /* pred_indexed_ustore_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2338; /* pred_indexed_ustore_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2326; /* pred_indexed_ustore_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2344; /* pred_indexed_ustore_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2362; /* pred_indexed_ustore_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2332; /* pred_indexed_ustore_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2350; /* pred_indexed_ustore_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2368; /* pred_indexed_ustore_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2386; /* pred_indexed_ustore_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2356; /* pred_indexed_ustore_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2374; /* pred_indexed_ustore_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2392; /* pred_indexed_ustore_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2380; /* pred_indexed_ustore_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2398; /* pred_indexed_ustore_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2404; /* pred_indexed_ustore_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2410; /* pred_indexed_ustore_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2416; /* pred_indexed_ustore_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2422; /* pred_indexed_ustore_widthhrvvmf2si */

        default:
          return -1;
        }

    case 178:
      switch (pattern178 (x1, 
178))
        {
        case 0:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2315; /* pred_indexed_ustore_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2321; /* pred_indexed_ustore_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2339; /* pred_indexed_ustore_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2327; /* pred_indexed_ustore_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2345; /* pred_indexed_ustore_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2363; /* pred_indexed_ustore_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2333; /* pred_indexed_ustore_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2351; /* pred_indexed_ustore_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2369; /* pred_indexed_ustore_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2387; /* pred_indexed_ustore_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2357; /* pred_indexed_ustore_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2375; /* pred_indexed_ustore_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2393; /* pred_indexed_ustore_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2381; /* pred_indexed_ustore_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2399; /* pred_indexed_ustore_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2405; /* pred_indexed_ustore_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2411; /* pred_indexed_ustore_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2417; /* pred_indexed_ustore_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2423; /* pred_indexed_ustore_widthwrvvmf2si */

        default:
          return -1;
        }

    case 89:
      if (pattern179 (x1, 
67) != 0
          || !const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 1742 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3629; /* vsetvl_vtype_change_only */

    case 94:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 91)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 66
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 67
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SCRATCH)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[4] = x12;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      return recog_77 (x1, insn, pnum_clobbers);

    case 95:
      return recog_81 (x1, insn, pnum_clobbers);

    case 96:
      return recog_80 (x1, insn, pnum_clobbers);

    case 126:
      return recog_84 (x1, insn, pnum_clobbers);

    case 127:
      return recog_83 (x1, insn, pnum_clobbers);

    case 128:
      return recog_85 (x1, insn, pnum_clobbers);

    case 129:
      return recog_86 (x1, insn, pnum_clobbers);

    case 130:
      return recog_87 (x1, insn, pnum_clobbers);

    case 131:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19561; /* pred_slide1downrvvm8hf */

        case 1:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19563; /* pred_slide1downrvvm4hf */

        case 2:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19565; /* pred_slide1downrvvm2hf */

        case 3:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19567; /* pred_slide1downrvvm1hf */

        case 4:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19569; /* pred_slide1downrvvmf2hf */

        case 5:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19571; /* pred_slide1downrvvmf4hf */

        case 6:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19573; /* pred_slide1downrvvm8sf */

        case 7:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19575; /* pred_slide1downrvvm4sf */

        case 8:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19577; /* pred_slide1downrvvm2sf */

        case 9:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19579; /* pred_slide1downrvvm1sf */

        case 10:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19581; /* pred_slide1downrvvmf2sf */

        case 11:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19583; /* pred_slide1downrvvm8df */

        case 12:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19585; /* pred_slide1downrvvm4df */

        case 13:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19587; /* pred_slide1downrvvm2df */

        case 14:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19589; /* pred_slide1downrvvm1df */

        case 15:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19591; /* pred_slide1downv1hf */

        case 16:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19593; /* pred_slide1downv2hf */

        case 17:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19595; /* pred_slide1downv4hf */

        case 18:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19597; /* pred_slide1downv8hf */

        case 19:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19599; /* pred_slide1downv16hf */

        case 20:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19601; /* pred_slide1downv32hf */

        case 21:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19603; /* pred_slide1downv64hf */

        case 22:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19605; /* pred_slide1downv128hf */

        case 23:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19607; /* pred_slide1downv256hf */

        case 24:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19609; /* pred_slide1downv512hf */

        case 25:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19611; /* pred_slide1downv1024hf */

        case 26:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19613; /* pred_slide1downv2048hf */

        case 27:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19615; /* pred_slide1downv1sf */

        case 28:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19617; /* pred_slide1downv2sf */

        case 29:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19619; /* pred_slide1downv4sf */

        case 30:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19621; /* pred_slide1downv8sf */

        case 31:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19623; /* pred_slide1downv16sf */

        case 32:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19625; /* pred_slide1downv32sf */

        case 33:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19627; /* pred_slide1downv64sf */

        case 34:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19629; /* pred_slide1downv128sf */

        case 35:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19631; /* pred_slide1downv256sf */

        case 36:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19633; /* pred_slide1downv512sf */

        case 37:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19635; /* pred_slide1downv1024sf */

        case 38:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19637; /* pred_slide1downv1df */

        case 39:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19639; /* pred_slide1downv2df */

        case 40:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19641; /* pred_slide1downv4df */

        case 41:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19643; /* pred_slide1downv8df */

        case 42:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19645; /* pred_slide1downv16df */

        case 43:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19647; /* pred_slide1downv32df */

        case 44:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19649; /* pred_slide1downv64df */

        case 45:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19651; /* pred_slide1downv128df */

        case 46:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19653; /* pred_slide1downv256df */

        case 47:
          if (!(
#line 8084 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19655; /* pred_slide1downv512df */

        default:
          return -1;
        }

    case 93:
      return recog_82 (x1, insn, pnum_clobbers);

    case 358:
      if (pattern193 (x1) != 0
          || !
#line 2566 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33031; /* riscv_cv_simd_cplxmul_r_si */

    case 359:
      if (pattern193 (x1) != 0
          || !
#line 2583 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 33032; /* riscv_cv_simd_cplxmul_i_si */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64HFmode)
      && reg_or_mem_operand (operands[1], E_V64HFmode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4316 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3271; /* *movv64hfsi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4316 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3272; /* *movv64hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64HFmode)
      || !register_operand (operands[1], E_V64HFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3373; /* *movv64hf_vls */
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32DImode)
      && reg_or_mem_operand (operands[1], E_V32DImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4310 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3259; /* *movv32disi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4310 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3260; /* *movv32didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32DImode)
      || !register_operand (operands[1], E_V32DImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3362; /* *movv32di_vls */
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048HImode)
      && reg_or_mem_operand (operands[1], E_V2048HImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3245; /* *movv2048hisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv2048hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048HImode)
      || !register_operand (operands[1], E_V2048HImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3345; /* *movv2048hi_vls */
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32HImode)
      && reg_or_mem_operand (operands[1], E_V32HImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3233; /* *movv32hisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv32hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32HImode)
      || !register_operand (operands[1], E_V32HImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3339; /* *movv32hi_vls */
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V128QImode)
      && reg_or_mem_operand (operands[1], E_V128QImode))
    {
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3221; /* *movv128qisi_lra */
        }
      if ((
#line 1477 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3222; /* *movv128qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V128QImode)
      || !register_operand (operands[1], E_V128QImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3328; /* *movv128qi_vls */
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF8BImode)
      && register_operand (operands[1], E_RVVMF8BImode)
      && 
#line 1293 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2800; /* *movrvvmf8bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF8BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF8BImode))
    return -1;
  if ((
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2839; /* *movrvvmf8bisi_lra */
    }
  if (!(
#line 1353 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2840; /* *movrvvmf8bidi_lra */
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2HFmode)
      && register_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 1256 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 2782; /* *movrvvmf2hf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2HFmode))
    return -1;
  if ((
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2818; /* *movrvvmf2hfsi_lra */
    }
  if (!(
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 924 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2829; /* *movrvvmf2hfdi_lra */
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4QImode)
      && register_operand (operands[1], E_RVVMF4QImode)
      && 
#line 1256 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return 2776; /* *movrvvmf4qi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4QImode))
    return -1;
  if ((
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2812; /* *movrvvmf4qisi_lra */
    }
  if (!(
#line 1331 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2823; /* *movrvvmf4qidi_lra */
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1BImode)
      && reg_or_mem_operand (operands[1], E_V1BImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1BImode)
       || register_operand (operands[1], V1BImode))) && 
#line 4281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
    return 3212; /* *movv1bi */
  if (!register_operand (operands[0], E_V1BImode)
      || !register_operand (operands[1], E_V1BImode)
      || !(
#line 1529 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
    return -1;
  return 3479; /* *movv1bi_vls */
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3205; /* *movv8sf */
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3382; /* *movv8sf_vls */
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HFmode)
      && reg_or_mem_operand (operands[1], E_V2HFmode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HFmode)
       || register_operand (operands[1], V2HFmode))) && 
#line 4266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3198; /* *movv2hf */
  if (!register_operand (operands[0], E_V2HFmode)
      || !register_operand (operands[1], E_V2HFmode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3368; /* *movv2hf_vls */
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 3191; /* *movv16si */
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3350; /* *movv16si_vls */
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HImode)
      && reg_or_mem_operand (operands[1], E_V4HImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))) && 
#line 4252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 3184; /* *movv4hi */
  if (!register_operand (operands[0], E_V4HImode)
      || !register_operand (operands[1], E_V4HImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 3336; /* *movv4hi_vls */
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode)
      && (
#line 1433 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 3177; /* *movv1qi */
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !(
#line 1508 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 3321; /* *movv1qi_vls */
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3165; /* *movrvvm2x3qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3166; /* *movrvvm2x3qi_di */
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3151; /* *movrvvm2x3bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3152; /* *movrvvm2x3bf_di */
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3137; /* *movrvvm1x7qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3138; /* *movrvvm1x7qi_di */
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3123; /* *movrvvm2x4sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3124; /* *movrvvm2x4sf_di */
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3109; /* *movrvvm1x4hf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3110; /* *movrvvm1x4hf_di */
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3095; /* *movrvvm1x4bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3096; /* *movrvvm1x4bf_di */
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3081; /* *movrvvm1x8hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3082; /* *movrvvm1x8hi_di */
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3067; /* *movrvvmf2x8qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3068; /* *movrvvmf2x8qi_di */
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3051; /* *movrvvm2x3df_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3052; /* *movrvvm2x3df_di */
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3035; /* *movrvvm1x2sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3036; /* *movrvvm1x2sf_di */
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3019; /* *movrvvmf2x8bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3020; /* *movrvvmf2x8bf_di */
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3003; /* *movrvvm2x3di_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3004; /* *movrvvm2x3di_di */
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2979; /* *movrvvmf2x5hi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2980; /* *movrvvmf2x5hi_di */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2963; /* *movrvvmf4x4qi_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2964; /* *movrvvmf4x4qi_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2947; /* *movrvvm1x3df_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2948; /* *movrvvm1x3df_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2931; /* *movrvvmf2x2sf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2932; /* *movrvvmf2x2sf_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2915; /* *movrvvmf4x8bf_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2916; /* *movrvvmf4x8bf_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2899; /* *movrvvm1x7di_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2900; /* *movrvvm1x7di_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode))
    return -1;
  if ((
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2883; /* *movrvvmf2x6si_si */
    }
  if (!(
#line 1404 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2884; /* *movrvvmf2x6si_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern323 (x2))
    {
    case 0:
      return 297; /* *ashrsi3 */

    case 1:
      if (!
#line 2900 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 300; /* ashrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24567; /* ashrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24771; /* vashrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24570; /* ashrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24774; /* vashrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24573; /* ashrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24777; /* vashrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24576; /* ashrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24780; /* vashrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24579; /* ashrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24783; /* vashrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24582; /* ashrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24786; /* vashrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24585; /* ashrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24789; /* vashrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24588; /* ashrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24792; /* vashrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24591; /* ashrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24795; /* vashrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24594; /* ashrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24798; /* vashrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24597; /* ashrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24801; /* vashrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 24600; /* ashrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24804; /* vashrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24603; /* ashrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24807; /* vashrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24606; /* ashrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24810; /* vashrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24609; /* ashrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24813; /* vashrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 24612; /* ashrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24816; /* vashrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24615; /* ashrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24819; /* vashrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24618; /* ashrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24822; /* vashrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24621; /* ashrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24825; /* vashrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 24624; /* ashrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24828; /* vashrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24627; /* ashrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24831; /* vashrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 24630; /* ashrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24834; /* vashrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 24633; /* ashrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24837; /* vashrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 24636; /* ashrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24840; /* vashrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 24639; /* ashrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24843; /* vashrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 24642; /* ashrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24846; /* vashrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 24645; /* ashrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24849; /* vashrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 24648; /* ashrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24852; /* vashrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 24651; /* ashrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24855; /* vashrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 24654; /* ashrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24858; /* vashrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 24657; /* ashrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24861; /* vashrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 24660; /* ashrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24864; /* vashrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 24663; /* ashrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24867; /* vashrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 24666; /* ashrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24870; /* vashrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 24669; /* ashrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24873; /* vashrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 24672; /* ashrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24876; /* vashrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 24675; /* ashrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24879; /* vashrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 24678; /* ashrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24882; /* vashrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 24681; /* ashrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24885; /* vashrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 24684; /* ashrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24888; /* vashrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 24687; /* ashrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24891; /* vashrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 24690; /* ashrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24894; /* vashrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 24693; /* ashrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24897; /* vashrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 24696; /* ashrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24900; /* vashrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 24699; /* ashrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24903; /* vashrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 24702; /* ashrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24906; /* vashrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 24705; /* ashrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24909; /* vashrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 24708; /* ashrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24912; /* vashrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 24711; /* ashrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24915; /* vashrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 24714; /* ashrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24918; /* vashrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 24717; /* ashrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24921; /* vashrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 24720; /* ashrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24924; /* vashrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 24723; /* ashrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24927; /* vashrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 24726; /* ashrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24930; /* vashrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 24729; /* ashrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24933; /* vashrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 24732; /* ashrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24936; /* vashrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 24735; /* ashrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24939; /* vashrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 24738; /* ashrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24942; /* vashrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 24741; /* ashrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24945; /* vashrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 24744; /* ashrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24948; /* vashrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 24747; /* ashrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24951; /* vashrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 24750; /* ashrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24954; /* vashrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 24753; /* ashrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24957; /* vashrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 24756; /* ashrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24960; /* vashrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 24759; /* ashrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24963; /* vashrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 24762; /* ashrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24966; /* vashrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 24765; /* ashrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24969; /* vashrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 24768; /* ashrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 513 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24972; /* vashrv512di3 */

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32455; /* pred_crypto_vvsm4rvsrvvm8si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32515; /* pred_crypto_vvsm4rvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32575; /* pred_crypto_vvsm4rvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32623; /* pred_crypto_vvsm4rvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32659; /* pred_crypto_vvsm4rvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32683; /* pred_crypto_vvsm4rvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32467; /* pred_crypto_vvsm4rvsrvvm4si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32527; /* pred_crypto_vvsm4rvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32587; /* pred_crypto_vvsm4rvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32635; /* pred_crypto_vvsm4rvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32671; /* pred_crypto_vvsm4rvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32479; /* pred_crypto_vvsm4rvsrvvm2si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32539; /* pred_crypto_vvsm4rvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32599; /* pred_crypto_vvsm4rvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32647; /* pred_crypto_vvsm4rvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32491; /* pred_crypto_vvsm4rvsrvvm1si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32551; /* pred_crypto_vvsm4rvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32611; /* pred_crypto_vvsm4rvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32503; /* pred_crypto_vvsm4rvsrvvmf2si */
      if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32563; /* pred_crypto_vvsm4rvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern477 (x2))
    {
    case 0:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32452; /* pred_crypto_vvaesdmvsrvvm8si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32512; /* pred_crypto_vvaesdmvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32572; /* pred_crypto_vvaesdmvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32620; /* pred_crypto_vvaesdmvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32656; /* pred_crypto_vvaesdmvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4360 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32680; /* pred_crypto_vvaesdmvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32464; /* pred_crypto_vvaesdmvsrvvm4si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32524; /* pred_crypto_vvaesdmvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32584; /* pred_crypto_vvaesdmvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32632; /* pred_crypto_vvaesdmvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4356 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32668; /* pred_crypto_vvaesdmvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32476; /* pred_crypto_vvaesdmvsrvvm2si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32536; /* pred_crypto_vvaesdmvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32596; /* pred_crypto_vvaesdmvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4352 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32644; /* pred_crypto_vvaesdmvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 32488; /* pred_crypto_vvaesdmvsrvvm1si */
      if (!
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 32548; /* pred_crypto_vvaesdmvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4348 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32608; /* pred_crypto_vvaesdmvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32500; /* pred_crypto_vvaesdmvsrvvmf2si */
      if (!(
#line 520 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4344 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32560; /* pred_crypto_vvaesdmvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x7;
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      return recog_381 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      x12 = XEXP (x7, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          return recog_382 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern680 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4018; /* *pred_mergervvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern680 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4019; /* *pred_mergervvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern680 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4020; /* *pred_mergervvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern680 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4021; /* *pred_mergervvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern680 (x2, 
E_V1DImode, 
E_V1BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4022; /* *pred_mergev1di_extended_scalar */

            case E_V2DImode:
              if (pattern680 (x2, 
E_V2DImode, 
E_V2BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4023; /* *pred_mergev2di_extended_scalar */

            case E_V4DImode:
              if (pattern680 (x2, 
E_V4DImode, 
E_V4BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4024; /* *pred_mergev4di_extended_scalar */

            case E_V8DImode:
              if (pattern680 (x2, 
E_V8DImode, 
E_V8BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 4025; /* *pred_mergev8di_extended_scalar */

            case E_V16DImode:
              if (pattern680 (x2, 
E_V16DImode, 
E_V16BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 4026; /* *pred_mergev16di_extended_scalar */

            case E_V32DImode:
              if (pattern680 (x2, 
E_V32DImode, 
E_V32BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 4027; /* *pred_mergev32di_extended_scalar */

            case E_V64DImode:
              if (pattern680 (x2, 
E_V64DImode, 
E_V64BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 4028; /* *pred_mergev64di_extended_scalar */

            case E_V128DImode:
              if (pattern680 (x2, 
E_V128DImode, 
E_V128BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 4029; /* *pred_mergev128di_extended_scalar */

            case E_V256DImode:
              if (pattern680 (x2, 
E_V256DImode, 
E_V256BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 4030; /* *pred_mergev256di_extended_scalar */

            case E_V512DImode:
              if (pattern680 (x2, 
E_V512DImode, 
E_V512BImode) != 0
                  || !(
#line 2103 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 4031; /* *pred_mergev512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern468 (x2))
        {
        case 0:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27681; /* *cond_len_extendrvvm4qirvvm8hi */

        case 1:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27683; /* *cond_len_extendrvvm2qirvvm4hi */

        case 2:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27685; /* *cond_len_extendrvvm1qirvvm2hi */

        case 3:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27687; /* *cond_len_extendrvvmf2qirvvm1hi */

        case 4:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27689; /* *cond_len_extendrvvmf4qirvvmf2hi */

        case 5:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 27691; /* *cond_len_extendrvvmf8qirvvmf4hi */

        case 6:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27693; /* *cond_len_extendrvvm4hirvvm8si */

        case 7:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27777; /* *cond_len_extendrvvm2qirvvm8si */

        case 8:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27695; /* *cond_len_extendrvvm2hirvvm4si */

        case 9:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27779; /* *cond_len_extendrvvm1qirvvm4si */

        case 10:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27697; /* *cond_len_extendrvvm1hirvvm2si */

        case 11:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27781; /* *cond_len_extendrvvmf2qirvvm2si */

        case 12:
          if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27699; /* *cond_len_extendrvvmf2hirvvm1si */

        case 13:
          if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 27783; /* *cond_len_extendrvvmf4qirvvm1si */

        case 14:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 27701; /* *cond_len_extendrvvmf4hirvvmf2si */

        case 15:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 27785; /* *cond_len_extendrvvmf8qirvvmf2si */

        case 16:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27703; /* *cond_len_extendrvvm4sirvvm8di */

        case 17:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27787; /* *cond_len_extendrvvm2hirvvm8di */

        case 18:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27837; /* *cond_len_extendrvvm1qirvvm8di */

        case 19:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27705; /* *cond_len_extendrvvm2sirvvm4di */

        case 20:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27789; /* *cond_len_extendrvvm1hirvvm4di */

        case 21:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27839; /* *cond_len_extendrvvmf2qirvvm4di */

        case 22:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27707; /* *cond_len_extendrvvm1sirvvm2di */

        case 23:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27791; /* *cond_len_extendrvvmf2hirvvm2di */

        case 24:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27841; /* *cond_len_extendrvvmf4qirvvm2di */

        case 25:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27709; /* *cond_len_extendrvvmf2sirvvm1di */

        case 26:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27793; /* *cond_len_extendrvvmf4hirvvm1di */

        case 27:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27843; /* *cond_len_extendrvvmf8qirvvm1di */

        case 28:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 27711; /* *cond_len_extendv1qiv1hi */

        case 29:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 27713; /* *cond_len_extendv2qiv2hi */

        case 30:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 27715; /* *cond_len_extendv4qiv4hi */

        case 31:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 27717; /* *cond_len_extendv8qiv8hi */

        case 32:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 27719; /* *cond_len_extendv16qiv16hi */

        case 33:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27721; /* *cond_len_extendv32qiv32hi */

        case 34:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27723; /* *cond_len_extendv64qiv64hi */

        case 35:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27725; /* *cond_len_extendv128qiv128hi */

        case 36:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27727; /* *cond_len_extendv256qiv256hi */

        case 37:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27729; /* *cond_len_extendv512qiv512hi */

        case 38:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27731; /* *cond_len_extendv1024qiv1024hi */

        case 39:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27733; /* *cond_len_extendv2048qiv2048hi */

        case 40:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 27735; /* *cond_len_extendv1hiv1si */

        case 41:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 27795; /* *cond_len_extendv1qiv1si */

        case 42:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 27737; /* *cond_len_extendv2hiv2si */

        case 43:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 27797; /* *cond_len_extendv2qiv2si */

        case 44:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 27739; /* *cond_len_extendv4hiv4si */

        case 45:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 27799; /* *cond_len_extendv4qiv4si */

        case 46:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 27741; /* *cond_len_extendv8hiv8si */

        case 47:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 27801; /* *cond_len_extendv8qiv8si */

        case 48:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27743; /* *cond_len_extendv16hiv16si */

        case 49:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27803; /* *cond_len_extendv16qiv16si */

        case 50:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27745; /* *cond_len_extendv32hiv32si */

        case 51:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27805; /* *cond_len_extendv32qiv32si */

        case 52:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27747; /* *cond_len_extendv64hiv64si */

        case 53:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27807; /* *cond_len_extendv64qiv64si */

        case 54:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27749; /* *cond_len_extendv128hiv128si */

        case 55:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27809; /* *cond_len_extendv128qiv128si */

        case 56:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27751; /* *cond_len_extendv256hiv256si */

        case 57:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27811; /* *cond_len_extendv256qiv256si */

        case 58:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27753; /* *cond_len_extendv512hiv512si */

        case 59:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27813; /* *cond_len_extendv512qiv512si */

        case 60:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27755; /* *cond_len_extendv1024hiv1024si */

        case 61:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27815; /* *cond_len_extendv1024qiv1024si */

        case 62:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27757; /* *cond_len_extendv1siv1di */

        case 63:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27817; /* *cond_len_extendv1hiv1di */

        case 64:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27845; /* *cond_len_extendv1qiv1di */

        case 65:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27759; /* *cond_len_extendv2siv2di */

        case 66:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27819; /* *cond_len_extendv2hiv2di */

        case 67:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27847; /* *cond_len_extendv2qiv2di */

        case 68:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27761; /* *cond_len_extendv4siv4di */

        case 69:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27821; /* *cond_len_extendv4hiv4di */

        case 70:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 27849; /* *cond_len_extendv4qiv4di */

        case 71:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27763; /* *cond_len_extendv8siv8di */

        case 72:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27823; /* *cond_len_extendv8hiv8di */

        case 73:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27851; /* *cond_len_extendv8qiv8di */

        case 74:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27765; /* *cond_len_extendv16siv16di */

        case 75:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27825; /* *cond_len_extendv16hiv16di */

        case 76:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27853; /* *cond_len_extendv16qiv16di */

        case 77:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27767; /* *cond_len_extendv32siv32di */

        case 78:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27827; /* *cond_len_extendv32hiv32di */

        case 79:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27855; /* *cond_len_extendv32qiv32di */

        case 80:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27769; /* *cond_len_extendv64siv64di */

        case 81:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27829; /* *cond_len_extendv64hiv64di */

        case 82:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27857; /* *cond_len_extendv64qiv64di */

        case 83:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27771; /* *cond_len_extendv128siv128di */

        case 84:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27831; /* *cond_len_extendv128hiv128di */

        case 85:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27859; /* *cond_len_extendv128qiv128di */

        case 86:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27773; /* *cond_len_extendv256siv256di */

        case 87:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27833; /* *cond_len_extendv256hiv256di */

        case 88:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27861; /* *cond_len_extendv256qiv256di */

        case 89:
          if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27775; /* *cond_len_extendv512siv512di */

        case 90:
          if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27835; /* *cond_len_extendv512hiv512di */

        case 91:
          if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27863; /* *cond_len_extendv512qiv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_383 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      operands[4] = x4;
      operands[5] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[6] = x8;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      x10 = XEXP (x6, 2);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern466 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27943; /* *cond_len_extendrvvm4hfrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern466 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27944; /* *cond_len_extendrvvm2hfrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern466 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27945; /* *cond_len_extendrvvm1hfrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern466 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27946; /* *cond_len_extendrvvmf2hfrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern466 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 27947; /* *cond_len_extendrvvmf4hfrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern466 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27948; /* *cond_len_extendrvvm4sfrvvm8df */

        case E_RVVM4DFmode:
          if (pattern466 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27949; /* *cond_len_extendrvvm2sfrvvm4df */

        case E_RVVM2DFmode:
          if (pattern466 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27950; /* *cond_len_extendrvvm1sfrvvm2df */

        case E_RVVM1DFmode:
          if (pattern466 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27951; /* *cond_len_extendrvvmf2sfrvvm1df */

        case E_V1SFmode:
          if (pattern466 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27952; /* *cond_len_extendv1hfv1sf */

        case E_V2SFmode:
          if (pattern466 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 986 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27953; /* *cond_len_extendv2hfv2sf */

        case E_V4SFmode:
          if (pattern466 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 987 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27954; /* *cond_len_extendv4hfv4sf */

        case E_V8SFmode:
          if (pattern466 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 988 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 27955; /* *cond_len_extendv8hfv8sf */

        case E_V16SFmode:
          if (pattern466 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 989 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27956; /* *cond_len_extendv16hfv16sf */

        case E_V32SFmode:
          if (pattern466 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27957; /* *cond_len_extendv32hfv32sf */

        case E_V64SFmode:
          if (pattern466 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27958; /* *cond_len_extendv64hfv64sf */

        case E_V128SFmode:
          if (pattern466 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27959; /* *cond_len_extendv128hfv128sf */

        case E_V256SFmode:
          if (pattern466 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27960; /* *cond_len_extendv256hfv256sf */

        case E_V512SFmode:
          if (pattern466 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27961; /* *cond_len_extendv512hfv512sf */

        case E_V1024SFmode:
          if (pattern466 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 995 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27962; /* *cond_len_extendv1024hfv1024sf */

        case E_V1DFmode:
          if (pattern466 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27963; /* *cond_len_extendv1sfv1df */

        case E_V2DFmode:
          if (pattern466 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27964; /* *cond_len_extendv2sfv2df */

        case E_V4DFmode:
          if (pattern466 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 998 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 27965; /* *cond_len_extendv4sfv4df */

        case E_V8DFmode:
          if (pattern466 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 27966; /* *cond_len_extendv8sfv8df */

        case E_V16DFmode:
          if (pattern466 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 27967; /* *cond_len_extendv16sfv16df */

        case E_V32DFmode:
          if (pattern466 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 27968; /* *cond_len_extendv32sfv32df */

        case E_V64DFmode:
          if (pattern466 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 27969; /* *cond_len_extendv64sfv64df */

        case E_V128DFmode:
          if (pattern466 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 27970; /* *cond_len_extendv128sfv128df */

        case E_V256DFmode:
          if (pattern466 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 27971; /* *cond_len_extendv256sfv256df */

        case E_V512DFmode:
          if (pattern466 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !(
#line 331 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 27972; /* *cond_len_extendv512sfv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048HImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 4283; /* *pred_broadcastv2048hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048HImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4405; /* *pred_broadcastv2048hi_imm */
}

 int
recog_460 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 4276; /* *pred_broadcastv16hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 4398; /* *pred_broadcastv16hi_imm */
}

 int
recog_468 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512QImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 4268; /* *pred_broadcastv512qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512QImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4390; /* *pred_broadcastv512qi_imm */
}

 int
recog_476 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2QImode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 4260; /* *pred_broadcastv2qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2QImode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 4382; /* *pred_broadcastv2qi_imm */
}

 int
recog_484 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
      && vector_const_0_operand (operands[3], E_RVVM2SFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4252; /* *pred_broadcastrvvm2sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2SFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4374; /* *pred_broadcastrvvm2sf_imm */
}

 int
recog_492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern598 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
      && vector_const_0_operand (operands[3], E_RVVM8HFmode)
      && (
#line 2339 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4244; /* *pred_broadcastrvvm8hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8HFmode)
      || !(
#line 2359 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4366; /* *pred_broadcastrvvm8hf_imm */
}

 int
recog_500 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32DImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 19773; /* pred_gatherv32df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 19895; /* pred_gatherv32df_scalar */
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1DImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 19768; /* pred_gatherv1df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 19890; /* pred_gatherv1df_scalar */
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64SImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 19763; /* pred_gatherv64sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 19885; /* pred_gatherv64sf_scalar */
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2SImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 19758; /* pred_gatherv2sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 19880; /* pred_gatherv2sf_scalar */
}

 int
recog_520 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256HImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return 19753; /* pred_gatherv256hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 19875; /* pred_gatherv256hf_scalar */
}

 int
recog_525 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8HImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 19748; /* pred_gatherv8hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 19870; /* pred_gatherv8hf_scalar */
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256DImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 19743; /* pred_gatherv256di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 19865; /* pred_gatherv256di_scalar */
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8DImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 19738; /* pred_gatherv8di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 19860; /* pred_gatherv8di_scalar */
}

 int
recog_540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 19733; /* pred_gatherv512si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 19855; /* pred_gatherv512si_scalar */
}

 int
recog_545 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16SImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 19728; /* pred_gatherv16si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 19850; /* pred_gatherv16si_scalar */
}

 int
recog_550 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048HImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 19723; /* pred_gatherv2048hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 19845; /* pred_gatherv2048hi_scalar */
}

 int
recog_555 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64HImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 19718; /* pred_gatherv64hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 19840; /* pred_gatherv64hi_scalar */
}

 int
recog_560 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2HImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 19713; /* pred_gatherv2hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 19835; /* pred_gatherv2hi_scalar */
}

 int
recog_565 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512QImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 19708; /* pred_gatherv512qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 19830; /* pred_gatherv512qi_scalar */
}

 int
recog_570 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16QImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 19703; /* pred_gatherv16qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 19825; /* pred_gatherv16qi_scalar */
}

 int
recog_575 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern599 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM1DImode)
      && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 19698; /* pred_gatherrvvm1df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 19820; /* pred_gatherrvvm1df_scalar */
}

 int
recog_580 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[3] = x9;
  x10 = XVECEXP (x8, 0, 1);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern599 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19656; /* pred_gatherrvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19778; /* pred_gatherrvvm8qi_scalar */

    case E_RVVM4QImode:
      if (pattern599 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19657; /* pred_gatherrvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19779; /* pred_gatherrvvm4qi_scalar */

    case E_RVVM2QImode:
      if (pattern599 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19658; /* pred_gatherrvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19780; /* pred_gatherrvvm2qi_scalar */

    case E_RVVM1QImode:
      if (pattern599 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19659; /* pred_gatherrvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19781; /* pred_gatherrvvm1qi_scalar */

    case E_RVVM8HImode:
      if (pattern599 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19660; /* pred_gatherrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19782; /* pred_gatherrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern599 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19661; /* pred_gatherrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19783; /* pred_gatherrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern599 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19662; /* pred_gatherrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19784; /* pred_gatherrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern599 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19663; /* pred_gatherrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19785; /* pred_gatherrvvm1hi_scalar */

    case E_RVVM8SImode:
      if (pattern599 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19664; /* pred_gatherrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19786; /* pred_gatherrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern599 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19665; /* pred_gatherrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19787; /* pred_gatherrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern599 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19666; /* pred_gatherrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19788; /* pred_gatherrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern599 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 19667; /* pred_gatherrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 19789; /* pred_gatherrvvm1si_scalar */

    case E_RVVM8DImode:
      if (pattern599 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 19668; /* pred_gatherrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19790; /* pred_gatherrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern599 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 19669; /* pred_gatherrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19791; /* pred_gatherrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern599 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 19670; /* pred_gatherrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19792; /* pred_gatherrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern599 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 19671; /* pred_gatherrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 19793; /* pred_gatherrvvm1di_scalar */

    case E_RVVMF2QImode:
      if (pattern599 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 19672; /* pred_gatherrvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19794; /* pred_gatherrvvmf2qi_scalar */

    case E_RVVMF4QImode:
      if (pattern599 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 19673; /* pred_gatherrvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19795; /* pred_gatherrvvmf4qi_scalar */

    case E_RVVMF8QImode:
      if (pattern599 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 19674; /* pred_gatherrvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19796; /* pred_gatherrvvmf8qi_scalar */

    case E_RVVMF2HImode:
      if (pattern599 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 19675; /* pred_gatherrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 19797; /* pred_gatherrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern599 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 19676; /* pred_gatherrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19798; /* pred_gatherrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      if (pattern599 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 19677; /* pred_gatherrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 19799; /* pred_gatherrvvmf2si_scalar */

    case E_RVVM8BFmode:
      if (pattern599 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 19678; /* pred_gatherrvvm8bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19800; /* pred_gatherrvvm8bf_scalar */

    case E_RVVM4BFmode:
      if (pattern599 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 19679; /* pred_gatherrvvm4bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19801; /* pred_gatherrvvm4bf_scalar */

    case E_RVVM2BFmode:
      if (pattern599 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 19680; /* pred_gatherrvvm2bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19802; /* pred_gatherrvvm2bf_scalar */

    case E_RVVM1BFmode:
      if (pattern599 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 19681; /* pred_gatherrvvm1bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19803; /* pred_gatherrvvm1bf_scalar */

    case E_RVVMF2BFmode:
      if (pattern599 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 19682; /* pred_gatherrvvmf2bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 19804; /* pred_gatherrvvmf2bf_scalar */

    case E_RVVMF4BFmode:
      if (pattern599 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return 19683; /* pred_gatherrvvmf4bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19805; /* pred_gatherrvvmf4bf_scalar */

    case E_RVVM8HFmode:
      if (pattern599 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 19684; /* pred_gatherrvvm8hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19806; /* pred_gatherrvvm8hf_scalar */

    case E_RVVM4HFmode:
      if (pattern599 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 19685; /* pred_gatherrvvm4hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19807; /* pred_gatherrvvm4hf_scalar */

    case E_RVVM2HFmode:
      if (pattern599 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 19686; /* pred_gatherrvvm2hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19808; /* pred_gatherrvvm2hf_scalar */

    case E_RVVM1HFmode:
      if (pattern599 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 19687; /* pred_gatherrvvm1hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19809; /* pred_gatherrvvm1hf_scalar */

    case E_RVVMF2HFmode:
      if (pattern599 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 19688; /* pred_gatherrvvmf2hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 19810; /* pred_gatherrvvmf2hf_scalar */

    case E_RVVMF4HFmode:
      if (pattern599 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return 19689; /* pred_gatherrvvmf4hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19811; /* pred_gatherrvvmf4hf_scalar */

    case E_RVVM8SFmode:
      if (pattern599 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8SImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 19690; /* pred_gatherrvvm8sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19812; /* pred_gatherrvvm8sf_scalar */

    case E_RVVM4SFmode:
      if (pattern599 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4SImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 19691; /* pred_gatherrvvm4sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19813; /* pred_gatherrvvm4sf_scalar */

    case E_RVVM2SFmode:
      if (pattern599 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2SImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 19692; /* pred_gatherrvvm2sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19814; /* pred_gatherrvvm2sf_scalar */

    case E_RVVM1SFmode:
      if (pattern599 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1SImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 19693; /* pred_gatherrvvm1sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 19815; /* pred_gatherrvvm1sf_scalar */

    case E_RVVMF2SFmode:
      if (pattern599 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 8105 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 19694; /* pred_gatherrvvmf2sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8125 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 19816; /* pred_gatherrvvmf2sf_scalar */

    case E_RVVM8DFmode:
      return recog_578 (x1, insn, pnum_clobbers);

    case E_RVVM4DFmode:
      return recog_577 (x1, insn, pnum_clobbers);

    case E_RVVM2DFmode:
      return recog_576 (x1, insn, pnum_clobbers);

    case E_RVVM1DFmode:
      return recog_575 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_574 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_573 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_572 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_571 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_570 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_569 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_568 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_567 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_566 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_565 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_564 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_563 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_562 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_561 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_560 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_559 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_558 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_557 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_556 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_555 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_554 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_553 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_552 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_551 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_550 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_549 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_548 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_547 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_546 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_545 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_544 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_543 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_542 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_541 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_540 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_539 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_538 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_537 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_536 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_535 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_534 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_533 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_532 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_531 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_530 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_529 (x1, insn, pnum_clobbers);

    case E_V1HFmode:
      return recog_528 (x1, insn, pnum_clobbers);

    case E_V2HFmode:
      return recog_527 (x1, insn, pnum_clobbers);

    case E_V4HFmode:
      return recog_526 (x1, insn, pnum_clobbers);

    case E_V8HFmode:
      return recog_525 (x1, insn, pnum_clobbers);

    case E_V16HFmode:
      return recog_524 (x1, insn, pnum_clobbers);

    case E_V32HFmode:
      return recog_523 (x1, insn, pnum_clobbers);

    case E_V64HFmode:
      return recog_522 (x1, insn, pnum_clobbers);

    case E_V128HFmode:
      return recog_521 (x1, insn, pnum_clobbers);

    case E_V256HFmode:
      return recog_520 (x1, insn, pnum_clobbers);

    case E_V512HFmode:
      return recog_519 (x1, insn, pnum_clobbers);

    case E_V1024HFmode:
      return recog_518 (x1, insn, pnum_clobbers);

    case E_V2048HFmode:
      return recog_517 (x1, insn, pnum_clobbers);

    case E_V1SFmode:
      return recog_516 (x1, insn, pnum_clobbers);

    case E_V2SFmode:
      return recog_515 (x1, insn, pnum_clobbers);

    case E_V4SFmode:
      return recog_514 (x1, insn, pnum_clobbers);

    case E_V8SFmode:
      return recog_513 (x1, insn, pnum_clobbers);

    case E_V16SFmode:
      return recog_512 (x1, insn, pnum_clobbers);

    case E_V32SFmode:
      return recog_511 (x1, insn, pnum_clobbers);

    case E_V64SFmode:
      return recog_510 (x1, insn, pnum_clobbers);

    case E_V128SFmode:
      return recog_509 (x1, insn, pnum_clobbers);

    case E_V256SFmode:
      return recog_508 (x1, insn, pnum_clobbers);

    case E_V512SFmode:
      return recog_507 (x1, insn, pnum_clobbers);

    case E_V1024SFmode:
      return recog_506 (x1, insn, pnum_clobbers);

    case E_V1DFmode:
      return recog_505 (x1, insn, pnum_clobbers);

    case E_V2DFmode:
      return recog_504 (x1, insn, pnum_clobbers);

    case E_V4DFmode:
      return recog_503 (x1, insn, pnum_clobbers);

    case E_V8DFmode:
      return recog_502 (x1, insn, pnum_clobbers);

    case E_V16DFmode:
      return recog_501 (x1, insn, pnum_clobbers);

    case E_V32DFmode:
      return recog_500 (x1, insn, pnum_clobbers);

    case E_V64DFmode:
      return recog_499 (x1, insn, pnum_clobbers);

    case E_V128DFmode:
      return recog_498 (x1, insn, pnum_clobbers);

    case E_V256DFmode:
      return recog_497 (x1, insn, pnum_clobbers);

    case E_V512DFmode:
      return recog_496 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_587 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern600 (x2))
    {
    case 0:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31894; /* pred_vrev8rvvm8qi */

    case 1:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31897; /* pred_vrev8rvvm4qi */

    case 2:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31900; /* pred_vrev8rvvm2qi */

    case 3:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31903; /* pred_vrev8rvvm1qi */

    case 4:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31906; /* pred_vrev8rvvm8hi */

    case 5:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31909; /* pred_vrev8rvvm4hi */

    case 6:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31912; /* pred_vrev8rvvm2hi */

    case 7:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31915; /* pred_vrev8rvvm1hi */

    case 8:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31918; /* pred_vrev8rvvm8si */

    case 9:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31921; /* pred_vrev8rvvm4si */

    case 10:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31924; /* pred_vrev8rvvm2si */

    case 11:
      if (!
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 31927; /* pred_vrev8rvvm1si */

    case 12:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31930; /* pred_vrev8rvvm8di */

    case 13:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31933; /* pred_vrev8rvvm4di */

    case 14:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31936; /* pred_vrev8rvvm2di */

    case 15:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31939; /* pred_vrev8rvvm1di */

    case 16:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 31942; /* pred_vrev8rvvmf2qi */

    case 17:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 31945; /* pred_vrev8rvvmf4qi */

    case 18:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 31948; /* pred_vrev8rvvmf8qi */

    case 19:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 31951; /* pred_vrev8rvvmf2hi */

    case 20:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 31954; /* pred_vrev8rvvmf4hi */

    case 21:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 31957; /* pred_vrev8rvvmf2si */

    case 22:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 31960; /* pred_vrev8v1qi */

    case 23:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 31963; /* pred_vrev8v2qi */

    case 24:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 31966; /* pred_vrev8v4qi */

    case 25:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 31969; /* pred_vrev8v8qi */

    case 26:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 31972; /* pred_vrev8v16qi */

    case 27:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 31975; /* pred_vrev8v32qi */

    case 28:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31978; /* pred_vrev8v64qi */

    case 29:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31981; /* pred_vrev8v128qi */

    case 30:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31984; /* pred_vrev8v256qi */

    case 31:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31987; /* pred_vrev8v512qi */

    case 32:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31990; /* pred_vrev8v1024qi */

    case 33:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31993; /* pred_vrev8v2048qi */

    case 34:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31996; /* pred_vrev8v4096qi */

    case 35:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31999; /* pred_vrev8v1hi */

    case 36:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32002; /* pred_vrev8v2hi */

    case 37:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32005; /* pred_vrev8v4hi */

    case 38:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32008; /* pred_vrev8v8hi */

    case 39:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32011; /* pred_vrev8v16hi */

    case 40:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32014; /* pred_vrev8v32hi */

    case 41:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32017; /* pred_vrev8v64hi */

    case 42:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32020; /* pred_vrev8v128hi */

    case 43:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32023; /* pred_vrev8v256hi */

    case 44:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32026; /* pred_vrev8v512hi */

    case 45:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32029; /* pred_vrev8v1024hi */

    case 46:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32032; /* pred_vrev8v2048hi */

    case 47:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32035; /* pred_vrev8v1si */

    case 48:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32038; /* pred_vrev8v2si */

    case 49:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32041; /* pred_vrev8v4si */

    case 50:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32044; /* pred_vrev8v8si */

    case 51:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32047; /* pred_vrev8v16si */

    case 52:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32050; /* pred_vrev8v32si */

    case 53:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32053; /* pred_vrev8v64si */

    case 54:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32056; /* pred_vrev8v128si */

    case 55:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32059; /* pred_vrev8v256si */

    case 56:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32062; /* pred_vrev8v512si */

    case 57:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32065; /* pred_vrev8v1024si */

    case 58:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32068; /* pred_vrev8v1di */

    case 59:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32071; /* pred_vrev8v2di */

    case 60:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32074; /* pred_vrev8v4di */

    case 61:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32077; /* pred_vrev8v8di */

    case 62:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32080; /* pred_vrev8v16di */

    case 63:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32083; /* pred_vrev8v32di */

    case 64:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32086; /* pred_vrev8v64di */

    case 65:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32089; /* pred_vrev8v128di */

    case 66:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32092; /* pred_vrev8v256di */

    case 67:
      if (!(
#line 342 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32095; /* pred_vrev8v512di */

    default:
      return -1;
    }
}

 int
recog_601 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM8SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM8SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM8SImode)
      || !
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13074; /* *pred_mul_plusrvvm8si_undef */
}

 int
recog_603 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2SImode)
      || !
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13076; /* *pred_mul_plusrvvm2si_undef */
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM2DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM2DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM2DImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13080; /* *pred_mul_plusrvvm2di_undef */
}

 int
recog_611 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF8QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF8QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF8QImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13084; /* *pred_mul_plusrvvmf8qi_undef */
}

 int
recog_616 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2QImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 13089; /* *pred_mul_plusv2qi_undef */
}

 int
recog_620 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32QImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 13093; /* *pred_mul_plusv32qi_undef */
}

 int
recog_624 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512QImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13097; /* *pred_mul_plusv512qi_undef */
}

 int
recog_629 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2HImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13102; /* *pred_mul_plusv2hi_undef */
}

 int
recog_634 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64HImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13107; /* *pred_mul_plusv64hi_undef */
}

 int
recog_639 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2048HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2048HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2048HImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13112; /* *pred_mul_plusv2048hi_undef */
}

 int
recog_644 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16SImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13117; /* *pred_mul_plusv16si_undef */
}

 int
recog_650 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024SImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13123; /* *pred_mul_plusv1024si_undef */
}

 int
recog_656 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32DImode)
      || !(
#line 5320 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13129; /* *pred_mul_plusv32di_undef */
}

 int
recog_662 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_659 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13200; /* *pred_maddv256di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13268; /* *pred_maccv256di */
}

 int
recog_668 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_653 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13194; /* *pred_maddv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13262; /* *pred_maccv4di */
}

 int
recog_675 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_646 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13187; /* *pred_maddv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13255; /* *pred_maccv64si */
}

 int
recog_682 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_639 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2048HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13180; /* *pred_maddv2048hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13248; /* *pred_maccv2048hi */
}

 int
recog_689 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_632 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13173; /* *pred_maddv16hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13241; /* *pred_maccv16hi */
}

 int
recog_696 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_625 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5346 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 13166; /* *pred_maddv1024qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5375 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13234; /* *pred_maccv1024qi */
}

 int
recog_703 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13335; /* *pred_maddv128di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13403; /* *pred_maccv128di_scalar */
}

 int
recog_710 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13328; /* *pred_maddv1di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13396; /* *pred_maccv1di_scalar */
}

 int
recog_717 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13321; /* *pred_maddv16si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13389; /* *pred_maccv16si_scalar */
}

 int
recog_724 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern697 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5424 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13314; /* *pred_maddv512hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5454 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13382; /* *pred_maccv512hi_scalar */
}

 int
recog_731 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      switch (pattern699 (x2))
        {
        case 0:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13802; /* pred_widen_mul_plussrvvm8hi */

        case 1:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13804; /* pred_widen_mul_plussrvvm4hi */

        case 2:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13806; /* pred_widen_mul_plussrvvm2hi */

        case 3:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13808; /* pred_widen_mul_plussrvvm1hi */

        case 4:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13810; /* pred_widen_mul_plussrvvmf2hi */

        case 5:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 13812; /* pred_widen_mul_plussrvvmf4hi */

        case 6:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13814; /* pred_widen_mul_plussrvvm8si */

        case 7:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31494; /* pred_matrix_mul_plusrvvm8si_qoq */

        case 8:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31510; /* pred_matrix_mul_plusrvvm8si_dod */

        case 9:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13816; /* pred_widen_mul_plussrvvm4si */

        case 10:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31496; /* pred_matrix_mul_plusrvvm4si_qoq */

        case 11:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31512; /* pred_matrix_mul_plusrvvm4si_dod */

        case 12:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13818; /* pred_widen_mul_plussrvvm2si */

        case 13:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31498; /* pred_matrix_mul_plusrvvm2si_qoq */

        case 14:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31514; /* pred_matrix_mul_plusrvvm2si_dod */

        case 15:
          if (!
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13820; /* pred_widen_mul_plussrvvm1si */

        case 16:
          if (!
#line 41 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31500; /* pred_matrix_mul_plusrvvm1si_qoq */

        case 17:
          if (!
#line 113 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31516; /* pred_matrix_mul_plusrvvm1si_dod */

        case 18:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 13822; /* pred_widen_mul_plussrvvmf2si */

        case 19:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13824; /* pred_widen_mul_plussrvvm8di */

        case 20:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13826; /* pred_widen_mul_plussrvvm4di */

        case 21:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13828; /* pred_widen_mul_plussrvvm2di */

        case 22:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13830; /* pred_widen_mul_plussrvvm1di */

        case 23:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 13832; /* pred_widen_mul_plussv1hi */

        case 24:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 13834; /* pred_widen_mul_plussv2hi */

        case 25:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 13836; /* pred_widen_mul_plussv4hi */

        case 26:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 13838; /* pred_widen_mul_plussv8hi */

        case 27:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 13840; /* pred_widen_mul_plussv16hi */

        case 28:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13842; /* pred_widen_mul_plussv32hi */

        case 29:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13844; /* pred_widen_mul_plussv64hi */

        case 30:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13846; /* pred_widen_mul_plussv128hi */

        case 31:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13848; /* pred_widen_mul_plussv256hi */

        case 32:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13850; /* pred_widen_mul_plussv512hi */

        case 33:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13852; /* pred_widen_mul_plussv1024hi */

        case 34:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13854; /* pred_widen_mul_plussv2048hi */

        case 35:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 13856; /* pred_widen_mul_plussv1si */

        case 36:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 13858; /* pred_widen_mul_plussv2si */

        case 37:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 13860; /* pred_widen_mul_plussv4si */

        case 38:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 13862; /* pred_widen_mul_plussv8si */

        case 39:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13864; /* pred_widen_mul_plussv16si */

        case 40:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13866; /* pred_widen_mul_plussv32si */

        case 41:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13868; /* pred_widen_mul_plussv64si */

        case 42:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13870; /* pred_widen_mul_plussv128si */

        case 43:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13872; /* pred_widen_mul_plussv256si */

        case 44:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13874; /* pred_widen_mul_plussv512si */

        case 45:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13876; /* pred_widen_mul_plussv1024si */

        case 46:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13878; /* pred_widen_mul_plussv1di */

        case 47:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13880; /* pred_widen_mul_plussv2di */

        case 48:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13882; /* pred_widen_mul_plussv4di */

        case 49:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13884; /* pred_widen_mul_plussv8di */

        case 50:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13886; /* pred_widen_mul_plussv16di */

        case 51:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13888; /* pred_widen_mul_plussv32di */

        case 52:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13890; /* pred_widen_mul_plussv64di */

        case 53:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13892; /* pred_widen_mul_plussv128di */

        case 54:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13894; /* pred_widen_mul_plussv256di */

        case 55:
          if (!(
#line 5873 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13896; /* pred_widen_mul_plussv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern699 (x2))
        {
        case 0:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13994; /* pred_widen_mul_plussurvvm8hi */

        case 1:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13995; /* pred_widen_mul_plussurvvm4hi */

        case 2:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13996; /* pred_widen_mul_plussurvvm2hi */

        case 3:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13997; /* pred_widen_mul_plussurvvm1hi */

        case 4:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13998; /* pred_widen_mul_plussurvvmf2hi */

        case 5:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 13999; /* pred_widen_mul_plussurvvmf4hi */

        case 6:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14000; /* pred_widen_mul_plussurvvm8si */

        case 7:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31502; /* pred_matrix_mul_plussurvvm8si_qoq */

        case 8:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31518; /* pred_matrix_mul_plussurvvm8si_dod */

        case 9:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14001; /* pred_widen_mul_plussurvvm4si */

        case 10:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31503; /* pred_matrix_mul_plussurvvm4si_qoq */

        case 11:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31519; /* pred_matrix_mul_plussurvvm4si_dod */

        case 12:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14002; /* pred_widen_mul_plussurvvm2si */

        case 13:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31504; /* pred_matrix_mul_plussurvvm2si_qoq */

        case 14:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31520; /* pred_matrix_mul_plussurvvm2si_dod */

        case 15:
          if (!
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14003; /* pred_widen_mul_plussurvvm1si */

        case 16:
          if (!
#line 65 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 31505; /* pred_matrix_mul_plussurvvm1si_qoq */

        case 17:
          if (!
#line 137 "../../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 31521; /* pred_matrix_mul_plussurvvm1si_dod */

        case 18:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14004; /* pred_widen_mul_plussurvvmf2si */

        case 19:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14005; /* pred_widen_mul_plussurvvm8di */

        case 20:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14006; /* pred_widen_mul_plussurvvm4di */

        case 21:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14007; /* pred_widen_mul_plussurvvm2di */

        case 22:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14008; /* pred_widen_mul_plussurvvm1di */

        case 23:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 14009; /* pred_widen_mul_plussuv1hi */

        case 24:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 14010; /* pred_widen_mul_plussuv2hi */

        case 25:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 14011; /* pred_widen_mul_plussuv4hi */

        case 26:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 14012; /* pred_widen_mul_plussuv8hi */

        case 27:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 14013; /* pred_widen_mul_plussuv16hi */

        case 28:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14014; /* pred_widen_mul_plussuv32hi */

        case 29:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14015; /* pred_widen_mul_plussuv64hi */

        case 30:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14016; /* pred_widen_mul_plussuv128hi */

        case 31:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14017; /* pred_widen_mul_plussuv256hi */

        case 32:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14018; /* pred_widen_mul_plussuv512hi */

        case 33:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14019; /* pred_widen_mul_plussuv1024hi */

        case 34:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14020; /* pred_widen_mul_plussuv2048hi */

        case 35:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 14021; /* pred_widen_mul_plussuv1si */

        case 36:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 14022; /* pred_widen_mul_plussuv2si */

        case 37:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 14023; /* pred_widen_mul_plussuv4si */

        case 38:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 14024; /* pred_widen_mul_plussuv8si */

        case 39:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14025; /* pred_widen_mul_plussuv16si */

        case 40:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14026; /* pred_widen_mul_plussuv32si */

        case 41:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14027; /* pred_widen_mul_plussuv64si */

        case 42:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14028; /* pred_widen_mul_plussuv128si */

        case 43:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14029; /* pred_widen_mul_plussuv256si */

        case 44:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14030; /* pred_widen_mul_plussuv512si */

        case 45:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14031; /* pred_widen_mul_plussuv1024si */

        case 46:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14032; /* pred_widen_mul_plussuv1di */

        case 47:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14033; /* pred_widen_mul_plussuv2di */

        case 48:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14034; /* pred_widen_mul_plussuv4di */

        case 49:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14035; /* pred_widen_mul_plussuv8di */

        case 50:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14036; /* pred_widen_mul_plussuv16di */

        case 51:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14037; /* pred_widen_mul_plussuv32di */

        case 52:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14038; /* pred_widen_mul_plussuv64di */

        case 53:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14039; /* pred_widen_mul_plussuv128di */

        case 54:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14040; /* pred_widen_mul_plussuv256di */

        case 55:
          if (!(
#line 5922 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14041; /* pred_widen_mul_plussuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_739 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V512DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13501; /* *pred_minus_mulv512di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13569; /* *pred_nmsubv512di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13637; /* *pred_nmsacv512di */
}

 int
recog_740 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V256DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13500; /* *pred_minus_mulv256di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13568; /* *pred_nmsubv256di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13636; /* *pred_nmsacv256di */
}

 int
recog_741 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V128DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13499; /* *pred_minus_mulv128di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13567; /* *pred_nmsubv128di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13635; /* *pred_nmsacv128di */
}

 int
recog_742 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V64DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13498; /* *pred_minus_mulv64di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13566; /* *pred_nmsubv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13634; /* *pred_nmsacv64di */
}

 int
recog_743 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V32DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13497; /* *pred_minus_mulv32di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13565; /* *pred_nmsubv32di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13633; /* *pred_nmsacv32di */
}

 int
recog_744 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V16DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13496; /* *pred_minus_mulv16di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13564; /* *pred_nmsubv16di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13632; /* *pred_nmsacv16di */
}

 int
recog_746 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V4DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13494; /* *pred_minus_mulv4di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13562; /* *pred_nmsubv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13630; /* *pred_nmsacv4di */
}

 int
recog_748 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V1DImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13492; /* *pred_minus_mulv1di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13560; /* *pred_nmsubv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13628; /* *pred_nmsacv1di */
}

 int
recog_750 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V512SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13490; /* *pred_minus_mulv512si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13558; /* *pred_nmsubv512si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13626; /* *pred_nmsacv512si */
}

 int
recog_753 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V64SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13487; /* *pred_minus_mulv64si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13555; /* *pred_nmsubv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13623; /* *pred_nmsacv64si */
}

 int
recog_757 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V4SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13483; /* *pred_minus_mulv4si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13551; /* *pred_nmsubv4si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13619; /* *pred_nmsacv4si */
}

 int
recog_763 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V256HImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13477; /* *pred_minus_mulv256hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13545; /* *pred_nmsubv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13613; /* *pred_nmsacv256hi */
}

 int
recog_769 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V4HImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13471; /* *pred_minus_mulv4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13539; /* *pred_nmsubv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13607; /* *pred_nmsacv4hi */
}

 int
recog_777 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_V128QImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13463; /* *pred_minus_mulv128qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13531; /* *pred_nmsubv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13599; /* *pred_nmsacv128qi */
}

 int
recog_785 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern702 (x2, 
E_RVVMF2SImode) == 0
      && (
#line 5602 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13455; /* *pred_minus_mulrvvmf2si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF2SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF2SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5628 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13523; /* *pred_nmsubrvvmf2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5657 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13591; /* *pred_nmsacrvvmf2si */
}

 int
recog_796 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 13697; /* *pred_nmsubv2di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13765; /* *pred_nmsacv2di_scalar */
}

 int
recog_804 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 13689; /* *pred_nmsubv16si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13757; /* *pred_nmsacv16si_scalar */
}

 int
recog_812 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern706 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5708 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13681; /* *pred_nmsubv256hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5738 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13749; /* *pred_nmsacv256hi_scalar */
}

 int
recog_820 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 0);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern687 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5483; /* pred_subrvvm8qi */

    case E_RVVM4QImode:
      if (pattern687 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5500; /* pred_subrvvm4qi */

    case E_RVVM2QImode:
      if (pattern687 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5517; /* pred_subrvvm2qi */

    case E_RVVM1QImode:
      if (pattern687 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5534; /* pred_subrvvm1qi */

    case E_RVVM8HImode:
      if (pattern687 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5551; /* pred_subrvvm8hi */

    case E_RVVM4HImode:
      if (pattern687 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5568; /* pred_subrvvm4hi */

    case E_RVVM2HImode:
      if (pattern687 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5585; /* pred_subrvvm2hi */

    case E_RVVM1HImode:
      if (pattern687 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5602; /* pred_subrvvm1hi */

    case E_RVVM8SImode:
      if (pattern687 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5619; /* pred_subrvvm8si */

    case E_RVVM4SImode:
      if (pattern687 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5636; /* pred_subrvvm4si */

    case E_RVVM2SImode:
      if (pattern687 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5653; /* pred_subrvvm2si */

    case E_RVVM1SImode:
      if (pattern687 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5670; /* pred_subrvvm1si */

    case E_RVVM8DImode:
      if (pattern687 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5687; /* pred_subrvvm8di */

    case E_RVVM4DImode:
      if (pattern687 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5704; /* pred_subrvvm4di */

    case E_RVVM2DImode:
      if (pattern687 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5721; /* pred_subrvvm2di */

    case E_RVVM1DImode:
      if (pattern687 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5738; /* pred_subrvvm1di */

    case E_RVVMF2QImode:
      if (pattern687 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5755; /* pred_subrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern687 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5772; /* pred_subrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern687 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5789; /* pred_subrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern687 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5806; /* pred_subrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern687 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5823; /* pred_subrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern687 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5840; /* pred_subrvvmf2si */

    case E_V1QImode:
      if (pattern687 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5857; /* pred_subv1qi */

    case E_V2QImode:
      if (pattern687 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5874; /* pred_subv2qi */

    case E_V4QImode:
      if (pattern687 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5891; /* pred_subv4qi */

    case E_V8QImode:
      if (pattern687 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5908; /* pred_subv8qi */

    case E_V16QImode:
      if (pattern687 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5925; /* pred_subv16qi */

    case E_V32QImode:
      if (pattern687 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5942; /* pred_subv32qi */

    case E_V64QImode:
      if (pattern687 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5959; /* pred_subv64qi */

    case E_V128QImode:
      if (pattern687 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5976; /* pred_subv128qi */

    case E_V256QImode:
      if (pattern687 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 5993; /* pred_subv256qi */

    case E_V512QImode:
      if (pattern687 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6010; /* pred_subv512qi */

    case E_V1024QImode:
      if (pattern687 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6027; /* pred_subv1024qi */

    case E_V2048QImode:
      if (pattern687 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6044; /* pred_subv2048qi */

    case E_V4096QImode:
      if (pattern687 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6061; /* pred_subv4096qi */

    case E_V1HImode:
      if (pattern687 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6078; /* pred_subv1hi */

    case E_V2HImode:
      if (pattern687 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6095; /* pred_subv2hi */

    case E_V4HImode:
      if (pattern687 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6112; /* pred_subv4hi */

    case E_V8HImode:
      if (pattern687 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6129; /* pred_subv8hi */

    case E_V16HImode:
      if (pattern687 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6146; /* pred_subv16hi */

    case E_V32HImode:
      if (pattern687 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6163; /* pred_subv32hi */

    case E_V64HImode:
      if (pattern687 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6180; /* pred_subv64hi */

    case E_V128HImode:
      if (pattern687 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6197; /* pred_subv128hi */

    case E_V256HImode:
      if (pattern687 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6214; /* pred_subv256hi */

    case E_V512HImode:
      if (pattern687 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6231; /* pred_subv512hi */

    case E_V1024HImode:
      if (pattern687 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6248; /* pred_subv1024hi */

    case E_V2048HImode:
      if (pattern687 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6265; /* pred_subv2048hi */

    case E_V1SImode:
      if (pattern687 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6282; /* pred_subv1si */

    case E_V2SImode:
      if (pattern687 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6299; /* pred_subv2si */

    case E_V4SImode:
      if (pattern687 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6316; /* pred_subv4si */

    case E_V8SImode:
      if (pattern687 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6333; /* pred_subv8si */

    case E_V16SImode:
      if (pattern687 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6350; /* pred_subv16si */

    case E_V32SImode:
      if (pattern687 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6367; /* pred_subv32si */

    case E_V64SImode:
      if (pattern687 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6384; /* pred_subv64si */

    case E_V128SImode:
      if (pattern687 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6401; /* pred_subv128si */

    case E_V256SImode:
      if (pattern687 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6418; /* pred_subv256si */

    case E_V512SImode:
      if (pattern687 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6435; /* pred_subv512si */

    case E_V1024SImode:
      if (pattern687 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6452; /* pred_subv1024si */

    case E_V1DImode:
      if (pattern687 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6469; /* pred_subv1di */

    case E_V2DImode:
      if (pattern687 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6486; /* pred_subv2di */

    case E_V4DImode:
      if (pattern687 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6503; /* pred_subv4di */

    case E_V8DImode:
      if (pattern687 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6520; /* pred_subv8di */

    case E_V16DImode:
      if (pattern687 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6537; /* pred_subv16di */

    case E_V32DImode:
      if (pattern687 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6554; /* pred_subv32di */

    case E_V64DImode:
      if (pattern687 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6571; /* pred_subv64di */

    case E_V128DImode:
      if (pattern687 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6588; /* pred_subv128di */

    case E_V256DImode:
      if (pattern687 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6605; /* pred_subv256di */

    case E_V512DImode:
      if (pattern687 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6622; /* pred_subv512di */

    default:
      return -1;
    }
}

 int
recog_825 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern688 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31536; /* pred_vandnrvvm8qi */

        case E_RVVM4QImode:
          if (pattern688 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31537; /* pred_vandnrvvm4qi */

        case E_RVVM2QImode:
          if (pattern688 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31538; /* pred_vandnrvvm2qi */

        case E_RVVM1QImode:
          if (pattern688 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31539; /* pred_vandnrvvm1qi */

        case E_RVVM8HImode:
          if (pattern688 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31540; /* pred_vandnrvvm8hi */

        case E_RVVM4HImode:
          if (pattern688 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31541; /* pred_vandnrvvm4hi */

        case E_RVVM2HImode:
          if (pattern688 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31542; /* pred_vandnrvvm2hi */

        case E_RVVM1HImode:
          if (pattern688 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31543; /* pred_vandnrvvm1hi */

        case E_RVVM8SImode:
          if (pattern688 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31544; /* pred_vandnrvvm8si */

        case E_RVVM4SImode:
          if (pattern688 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31545; /* pred_vandnrvvm4si */

        case E_RVVM2SImode:
          if (pattern688 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31546; /* pred_vandnrvvm2si */

        case E_RVVM1SImode:
          if (pattern688 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 31547; /* pred_vandnrvvm1si */

        case E_RVVM8DImode:
          if (pattern688 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31548; /* pred_vandnrvvm8di */

        case E_RVVM4DImode:
          if (pattern688 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31549; /* pred_vandnrvvm4di */

        case E_RVVM2DImode:
          if (pattern688 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31550; /* pred_vandnrvvm2di */

        case E_RVVM1DImode:
          if (pattern688 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31551; /* pred_vandnrvvm1di */

        case E_RVVMF2QImode:
          if (pattern688 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 31552; /* pred_vandnrvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern688 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 31553; /* pred_vandnrvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern688 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 31554; /* pred_vandnrvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern688 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 31555; /* pred_vandnrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern688 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 31556; /* pred_vandnrvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern688 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 31557; /* pred_vandnrvvmf2si */

        case E_V1QImode:
          if (pattern688 (x2, 
E_V1QImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 31558; /* pred_vandnv1qi */

        case E_V2QImode:
          if (pattern688 (x2, 
E_V2QImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 31559; /* pred_vandnv2qi */

        case E_V4QImode:
          if (pattern688 (x2, 
E_V4QImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 31560; /* pred_vandnv4qi */

        case E_V8QImode:
          if (pattern688 (x2, 
E_V8QImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 31561; /* pred_vandnv8qi */

        case E_V16QImode:
          if (pattern688 (x2, 
E_V16QImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 31562; /* pred_vandnv16qi */

        case E_V32QImode:
          if (pattern688 (x2, 
E_V32QImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 31563; /* pred_vandnv32qi */

        case E_V64QImode:
          if (pattern688 (x2, 
E_V64QImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31564; /* pred_vandnv64qi */

        case E_V128QImode:
          if (pattern688 (x2, 
E_V128QImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31565; /* pred_vandnv128qi */

        case E_V256QImode:
          if (pattern688 (x2, 
E_V256QImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31566; /* pred_vandnv256qi */

        case E_V512QImode:
          if (pattern688 (x2, 
E_V512QImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31567; /* pred_vandnv512qi */

        case E_V1024QImode:
          if (pattern688 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31568; /* pred_vandnv1024qi */

        case E_V2048QImode:
          if (pattern688 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31569; /* pred_vandnv2048qi */

        case E_V4096QImode:
          if (pattern688 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31570; /* pred_vandnv4096qi */

        case E_V1HImode:
          if (pattern688 (x2, 
E_V1HImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31571; /* pred_vandnv1hi */

        case E_V2HImode:
          if (pattern688 (x2, 
E_V2HImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31572; /* pred_vandnv2hi */

        case E_V4HImode:
          if (pattern688 (x2, 
E_V4HImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31573; /* pred_vandnv4hi */

        case E_V8HImode:
          if (pattern688 (x2, 
E_V8HImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31574; /* pred_vandnv8hi */

        case E_V16HImode:
          if (pattern688 (x2, 
E_V16HImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31575; /* pred_vandnv16hi */

        case E_V32HImode:
          if (pattern688 (x2, 
E_V32HImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31576; /* pred_vandnv32hi */

        case E_V64HImode:
          if (pattern688 (x2, 
E_V64HImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31577; /* pred_vandnv64hi */

        case E_V128HImode:
          if (pattern688 (x2, 
E_V128HImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31578; /* pred_vandnv128hi */

        case E_V256HImode:
          if (pattern688 (x2, 
E_V256HImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31579; /* pred_vandnv256hi */

        case E_V512HImode:
          if (pattern688 (x2, 
E_V512HImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31580; /* pred_vandnv512hi */

        case E_V1024HImode:
          if (pattern688 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31581; /* pred_vandnv1024hi */

        case E_V2048HImode:
          if (pattern688 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31582; /* pred_vandnv2048hi */

        case E_V1SImode:
          if (pattern688 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31583; /* pred_vandnv1si */

        case E_V2SImode:
          if (pattern688 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31584; /* pred_vandnv2si */

        case E_V4SImode:
          if (pattern688 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31585; /* pred_vandnv4si */

        case E_V8SImode:
          if (pattern688 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31586; /* pred_vandnv8si */

        case E_V16SImode:
          if (pattern688 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31587; /* pred_vandnv16si */

        case E_V32SImode:
          if (pattern688 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31588; /* pred_vandnv32si */

        case E_V64SImode:
          if (pattern688 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31589; /* pred_vandnv64si */

        case E_V128SImode:
          if (pattern688 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31590; /* pred_vandnv128si */

        case E_V256SImode:
          if (pattern688 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31591; /* pred_vandnv256si */

        case E_V512SImode:
          if (pattern688 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31592; /* pred_vandnv512si */

        case E_V1024SImode:
          if (pattern688 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31593; /* pred_vandnv1024si */

        case E_V1DImode:
          if (pattern688 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31594; /* pred_vandnv1di */

        case E_V2DImode:
          if (pattern688 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31595; /* pred_vandnv2di */

        case E_V4DImode:
          if (pattern688 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31596; /* pred_vandnv4di */

        case E_V8DImode:
          if (pattern688 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31597; /* pred_vandnv8di */

        case E_V16DImode:
          if (pattern688 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31598; /* pred_vandnv16di */

        case E_V32DImode:
          if (pattern688 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31599; /* pred_vandnv32di */

        case E_V64DImode:
          if (pattern688 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31600; /* pred_vandnv64di */

        case E_V128DImode:
          if (pattern688 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31601; /* pred_vandnv128di */

        case E_V256DImode:
          if (pattern688 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31602; /* pred_vandnv256di */

        case E_V512DImode:
          if (pattern688 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 117 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31603; /* pred_vandnv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_824 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_871 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern490 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM8QImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5489; /* pred_lshrrvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6640; /* pred_lshrrvvm8qi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5506; /* pred_lshrrvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6643; /* pred_lshrrvvm4qi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5523; /* pred_lshrrvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6646; /* pred_lshrrvvm2qi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5540; /* pred_lshrrvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6649; /* pred_lshrrvvm1qi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVM8HImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5557; /* pred_lshrrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6652; /* pred_lshrrvvm8hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5574; /* pred_lshrrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6655; /* pred_lshrrvvm4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5591; /* pred_lshrrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6658; /* pred_lshrrvvm2hi_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5608; /* pred_lshrrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6661; /* pred_lshrrvvm1hi_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM8SImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5625; /* pred_lshrrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6664; /* pred_lshrrvvm8si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5642; /* pred_lshrrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6667; /* pred_lshrrvvm4si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5659; /* pred_lshrrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6670; /* pred_lshrrvvm2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && 
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 5676; /* pred_lshrrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6673; /* pred_lshrrvvm1si_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM8DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5693; /* pred_lshrrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6676; /* pred_lshrrvvm8di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM4DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5710; /* pred_lshrrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6679; /* pred_lshrrvvm4di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVM2DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5727; /* pred_lshrrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6682; /* pred_lshrrvvm2di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_RVVM1DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 5744; /* pred_lshrrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6685; /* pred_lshrrvvm1di_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 5761; /* pred_lshrrvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 6688; /* pred_lshrrvvmf2qi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 5778; /* pred_lshrrvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 6691; /* pred_lshrrvvmf4qi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 5795; /* pred_lshrrvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 6694; /* pred_lshrrvvmf8qi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 5812; /* pred_lshrrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 6697; /* pred_lshrrvvmf2hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 5829; /* pred_lshrrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 6700; /* pred_lshrrvvmf4hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 5846; /* pred_lshrrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 6703; /* pred_lshrrvvmf2si_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 5863; /* pred_lshrv1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 6706; /* pred_lshrv1qi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 5880; /* pred_lshrv2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 6709; /* pred_lshrv2qi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 5897; /* pred_lshrv4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 6712; /* pred_lshrv4qi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 5914; /* pred_lshrv8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 6715; /* pred_lshrv8qi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 5931; /* pred_lshrv16qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 6718; /* pred_lshrv16qi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 5948; /* pred_lshrv32qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 6721; /* pred_lshrv32qi_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 5965; /* pred_lshrv64qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6724; /* pred_lshrv64qi_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 5982; /* pred_lshrv128qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6727; /* pred_lshrv128qi_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 5999; /* pred_lshrv256qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6730; /* pred_lshrv256qi_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 6016; /* pred_lshrv512qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6733; /* pred_lshrv512qi_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 6033; /* pred_lshrv1024qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6736; /* pred_lshrv1024qi_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 6050; /* pred_lshrv2048qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6739; /* pred_lshrv2048qi_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V4096QImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 6067; /* pred_lshrv4096qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6742; /* pred_lshrv4096qi_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 6084; /* pred_lshrv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6745; /* pred_lshrv1hi_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 6101; /* pred_lshrv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6748; /* pred_lshrv2hi_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 6118; /* pred_lshrv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6751; /* pred_lshrv4hi_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 6135; /* pred_lshrv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6754; /* pred_lshrv8hi_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 6152; /* pred_lshrv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6757; /* pred_lshrv16hi_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 6169; /* pred_lshrv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6760; /* pred_lshrv32hi_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 6186; /* pred_lshrv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6763; /* pred_lshrv64hi_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 6203; /* pred_lshrv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6766; /* pred_lshrv128hi_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 6220; /* pred_lshrv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6769; /* pred_lshrv256hi_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 6237; /* pred_lshrv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6772; /* pred_lshrv512hi_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 6254; /* pred_lshrv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6775; /* pred_lshrv1024hi_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V2048HImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 6271; /* pred_lshrv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6778; /* pred_lshrv2048hi_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 6288; /* pred_lshrv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6781; /* pred_lshrv1si_scalar */

    case 48:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 6305; /* pred_lshrv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6784; /* pred_lshrv2si_scalar */

    case 49:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 6322; /* pred_lshrv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6787; /* pred_lshrv4si_scalar */

    case 50:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 6339; /* pred_lshrv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6790; /* pred_lshrv8si_scalar */

    case 51:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 6356; /* pred_lshrv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6793; /* pred_lshrv16si_scalar */

    case 52:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 6373; /* pred_lshrv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6796; /* pred_lshrv32si_scalar */

    case 53:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 6390; /* pred_lshrv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6799; /* pred_lshrv64si_scalar */

    case 54:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 6407; /* pred_lshrv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6802; /* pred_lshrv128si_scalar */

    case 55:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 6424; /* pred_lshrv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6805; /* pred_lshrv256si_scalar */

    case 56:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 6441; /* pred_lshrv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6808; /* pred_lshrv512si_scalar */

    case 57:
      if (vector_shift_operand (operands[4], E_V1024SImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 6458; /* pred_lshrv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6811; /* pred_lshrv1024si_scalar */

    case 58:
      if (vector_shift_operand (operands[4], E_V1DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 6475; /* pred_lshrv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6814; /* pred_lshrv1di_scalar */

    case 59:
      if (vector_shift_operand (operands[4], E_V2DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 6492; /* pred_lshrv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6817; /* pred_lshrv2di_scalar */

    case 60:
      if (vector_shift_operand (operands[4], E_V4DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 6509; /* pred_lshrv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6820; /* pred_lshrv4di_scalar */

    case 61:
      if (vector_shift_operand (operands[4], E_V8DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 6526; /* pred_lshrv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6823; /* pred_lshrv8di_scalar */

    case 62:
      if (vector_shift_operand (operands[4], E_V16DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 6543; /* pred_lshrv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6826; /* pred_lshrv16di_scalar */

    case 63:
      if (vector_shift_operand (operands[4], E_V32DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 6560; /* pred_lshrv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6829; /* pred_lshrv32di_scalar */

    case 64:
      if (vector_shift_operand (operands[4], E_V64DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 6577; /* pred_lshrv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6832; /* pred_lshrv64di_scalar */

    case 65:
      if (vector_shift_operand (operands[4], E_V128DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 6594; /* pred_lshrv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6835; /* pred_lshrv128di_scalar */

    case 66:
      if (vector_shift_operand (operands[4], E_V256DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 6611; /* pred_lshrv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6838; /* pred_lshrv256di_scalar */

    case 67:
      if (vector_shift_operand (operands[4], E_V512DImode)
          && (
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 6628; /* pred_lshrv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 2758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6841; /* pred_lshrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_879 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_737 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern485 (x2))
            {
            case 0:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6842; /* pred_addrvvm8qi_scalar */

            case 1:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6851; /* pred_addrvvm4qi_scalar */

            case 2:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6860; /* pred_addrvvm2qi_scalar */

            case 3:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6869; /* pred_addrvvm1qi_scalar */

            case 4:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6878; /* pred_addrvvmf2qi_scalar */

            case 5:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6887; /* pred_addrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6896; /* pred_addrvvmf8qi_scalar */

            case 7:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6905; /* pred_addrvvm8hi_scalar */

            case 8:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6914; /* pred_addrvvm4hi_scalar */

            case 9:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6923; /* pred_addrvvm2hi_scalar */

            case 10:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6932; /* pred_addrvvm1hi_scalar */

            case 11:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6941; /* pred_addrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6950; /* pred_addrvvmf4hi_scalar */

            case 13:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6959; /* pred_addrvvm8si_scalar */

            case 14:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6968; /* pred_addrvvm4si_scalar */

            case 15:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6977; /* pred_addrvvm2si_scalar */

            case 16:
              if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6986; /* pred_addrvvm1si_scalar */

            case 17:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6995; /* pred_addrvvmf2si_scalar */

            case 18:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7004; /* pred_addv1qi_scalar */

            case 19:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7013; /* pred_addv2qi_scalar */

            case 20:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7022; /* pred_addv4qi_scalar */

            case 21:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7031; /* pred_addv8qi_scalar */

            case 22:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7040; /* pred_addv16qi_scalar */

            case 23:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7049; /* pred_addv32qi_scalar */

            case 24:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7058; /* pred_addv64qi_scalar */

            case 25:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7067; /* pred_addv128qi_scalar */

            case 26:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7076; /* pred_addv256qi_scalar */

            case 27:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7085; /* pred_addv512qi_scalar */

            case 28:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7094; /* pred_addv1024qi_scalar */

            case 29:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7103; /* pred_addv2048qi_scalar */

            case 30:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7112; /* pred_addv4096qi_scalar */

            case 31:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7121; /* pred_addv1hi_scalar */

            case 32:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7130; /* pred_addv2hi_scalar */

            case 33:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7139; /* pred_addv4hi_scalar */

            case 34:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7148; /* pred_addv8hi_scalar */

            case 35:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7157; /* pred_addv16hi_scalar */

            case 36:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7166; /* pred_addv32hi_scalar */

            case 37:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7175; /* pred_addv64hi_scalar */

            case 38:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7184; /* pred_addv128hi_scalar */

            case 39:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7193; /* pred_addv256hi_scalar */

            case 40:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7202; /* pred_addv512hi_scalar */

            case 41:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7211; /* pred_addv1024hi_scalar */

            case 42:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7220; /* pred_addv2048hi_scalar */

            case 43:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7229; /* pred_addv1si_scalar */

            case 44:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7238; /* pred_addv2si_scalar */

            case 45:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7247; /* pred_addv4si_scalar */

            case 46:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7256; /* pred_addv8si_scalar */

            case 47:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7265; /* pred_addv16si_scalar */

            case 48:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7274; /* pred_addv32si_scalar */

            case 49:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7283; /* pred_addv64si_scalar */

            case 50:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7292; /* pred_addv128si_scalar */

            case 51:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7301; /* pred_addv256si_scalar */

            case 52:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7310; /* pred_addv512si_scalar */

            case 53:
              if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7319; /* pred_addv1024si_scalar */

            case 54:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7652; /* *pred_addrvvm8di_scalar */

            case 55:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7661; /* *pred_addrvvm4di_scalar */

            case 56:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7670; /* *pred_addrvvm2di_scalar */

            case 57:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7679; /* *pred_addrvvm1di_scalar */

            case 58:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7688; /* *pred_addv1di_scalar */

            case 59:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7697; /* *pred_addv2di_scalar */

            case 60:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7706; /* *pred_addv4di_scalar */

            case 61:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7715; /* *pred_addv8di_scalar */

            case 62:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7724; /* *pred_addv16di_scalar */

            case 63:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7733; /* *pred_addv32di_scalar */

            case 64:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7742; /* *pred_addv64di_scalar */

            case 65:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7751; /* *pred_addv128di_scalar */

            case 66:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7760; /* *pred_addv256di_scalar */

            case 67:
              if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7769; /* *pred_addv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          return recog_592 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HImode:
              if (pattern686 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10247; /* pred_single_widen_addurvvm8hi_extended_scalar */

            case E_RVVM4HImode:
              if (pattern686 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10249; /* pred_single_widen_addurvvm4hi_extended_scalar */

            case E_RVVM2HImode:
              if (pattern686 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10251; /* pred_single_widen_addurvvm2hi_extended_scalar */

            case E_RVVM1HImode:
              if (pattern686 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10253; /* pred_single_widen_addurvvm1hi_extended_scalar */

            case E_RVVMF2HImode:
              if (pattern686 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10255; /* pred_single_widen_addurvvmf2hi_extended_scalar */

            case E_RVVMF4HImode:
              if (pattern686 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10257; /* pred_single_widen_addurvvmf4hi_extended_scalar */

            case E_RVVM8SImode:
              if (pattern686 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10259; /* pred_single_widen_addurvvm8si_extended_scalar */

            case E_RVVM4SImode:
              if (pattern686 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10261; /* pred_single_widen_addurvvm4si_extended_scalar */

            case E_RVVM2SImode:
              if (pattern686 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10263; /* pred_single_widen_addurvvm2si_extended_scalar */

            case E_RVVM1SImode:
              if (pattern686 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10265; /* pred_single_widen_addurvvm1si_extended_scalar */

            case E_RVVMF2SImode:
              if (pattern686 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10267; /* pred_single_widen_addurvvmf2si_extended_scalar */

            case E_RVVM8DImode:
              if (pattern686 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10269; /* pred_single_widen_addurvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern686 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10271; /* pred_single_widen_addurvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern686 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10273; /* pred_single_widen_addurvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern686 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10275; /* pred_single_widen_addurvvm1di_extended_scalar */

            case E_V1HImode:
              if (pattern686 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 10277; /* pred_single_widen_adduv1hi_extended_scalar */

            case E_V2HImode:
              if (pattern686 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 10279; /* pred_single_widen_adduv2hi_extended_scalar */

            case E_V4HImode:
              if (pattern686 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 10281; /* pred_single_widen_adduv4hi_extended_scalar */

            case E_V8HImode:
              if (pattern686 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 10283; /* pred_single_widen_adduv8hi_extended_scalar */

            case E_V16HImode:
              if (pattern686 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 10285; /* pred_single_widen_adduv16hi_extended_scalar */

            case E_V32HImode:
              if (pattern686 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10287; /* pred_single_widen_adduv32hi_extended_scalar */

            case E_V64HImode:
              if (pattern686 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10289; /* pred_single_widen_adduv64hi_extended_scalar */

            case E_V128HImode:
              if (pattern686 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10291; /* pred_single_widen_adduv128hi_extended_scalar */

            case E_V256HImode:
              if (pattern686 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10293; /* pred_single_widen_adduv256hi_extended_scalar */

            case E_V512HImode:
              if (pattern686 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10295; /* pred_single_widen_adduv512hi_extended_scalar */

            case E_V1024HImode:
              if (pattern686 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10297; /* pred_single_widen_adduv1024hi_extended_scalar */

            case E_V2048HImode:
              if (pattern686 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10299; /* pred_single_widen_adduv2048hi_extended_scalar */

            case E_V1SImode:
              if (pattern686 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 10301; /* pred_single_widen_adduv1si_extended_scalar */

            case E_V2SImode:
              if (pattern686 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 10303; /* pred_single_widen_adduv2si_extended_scalar */

            case E_V4SImode:
              if (pattern686 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 10305; /* pred_single_widen_adduv4si_extended_scalar */

            case E_V8SImode:
              if (pattern686 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 10307; /* pred_single_widen_adduv8si_extended_scalar */

            case E_V16SImode:
              if (pattern686 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10309; /* pred_single_widen_adduv16si_extended_scalar */

            case E_V32SImode:
              if (pattern686 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10311; /* pred_single_widen_adduv32si_extended_scalar */

            case E_V64SImode:
              if (pattern686 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10313; /* pred_single_widen_adduv64si_extended_scalar */

            case E_V128SImode:
              if (pattern686 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10315; /* pred_single_widen_adduv128si_extended_scalar */

            case E_V256SImode:
              if (pattern686 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10317; /* pred_single_widen_adduv256si_extended_scalar */

            case E_V512SImode:
              if (pattern686 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10319; /* pred_single_widen_adduv512si_extended_scalar */

            case E_V1024SImode:
              if (pattern686 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10321; /* pred_single_widen_adduv1024si_extended_scalar */

            case E_V1DImode:
              if (pattern686 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10323; /* pred_single_widen_adduv1di_extended_scalar */

            case E_V2DImode:
              if (pattern686 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10325; /* pred_single_widen_adduv2di_extended_scalar */

            case E_V4DImode:
              if (pattern686 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10327; /* pred_single_widen_adduv4di_extended_scalar */

            case E_V8DImode:
              if (pattern686 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10329; /* pred_single_widen_adduv8di_extended_scalar */

            case E_V16DImode:
              if (pattern686 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10331; /* pred_single_widen_adduv16di_extended_scalar */

            case E_V32DImode:
              if (pattern686 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10333; /* pred_single_widen_adduv32di_extended_scalar */

            case E_V64DImode:
              if (pattern686 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10335; /* pred_single_widen_adduv64di_extended_scalar */

            case E_V128DImode:
              if (pattern686 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10337; /* pred_single_widen_adduv128di_extended_scalar */

            case E_V256DImode:
              if (pattern686 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10339; /* pred_single_widen_adduv256di_extended_scalar */

            case E_V512DImode:
              if (pattern686 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4110 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10341; /* pred_single_widen_adduv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_735 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_734 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_736 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_888 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern495 (x2))
    {
    case 0:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5491; /* pred_umaxrvvm8qi */

    case 1:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5508; /* pred_umaxrvvm4qi */

    case 2:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5525; /* pred_umaxrvvm2qi */

    case 3:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5542; /* pred_umaxrvvm1qi */

    case 4:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5559; /* pred_umaxrvvm8hi */

    case 5:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5576; /* pred_umaxrvvm4hi */

    case 6:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5593; /* pred_umaxrvvm2hi */

    case 7:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5610; /* pred_umaxrvvm1hi */

    case 8:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5627; /* pred_umaxrvvm8si */

    case 9:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5644; /* pred_umaxrvvm4si */

    case 10:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5661; /* pred_umaxrvvm2si */

    case 11:
      if (!
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5678; /* pred_umaxrvvm1si */

    case 12:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5695; /* pred_umaxrvvm8di */

    case 13:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5712; /* pred_umaxrvvm4di */

    case 14:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5729; /* pred_umaxrvvm2di */

    case 15:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5746; /* pred_umaxrvvm1di */

    case 16:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5763; /* pred_umaxrvvmf2qi */

    case 17:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5780; /* pred_umaxrvvmf4qi */

    case 18:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5797; /* pred_umaxrvvmf8qi */

    case 19:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5814; /* pred_umaxrvvmf2hi */

    case 20:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5831; /* pred_umaxrvvmf4hi */

    case 21:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5848; /* pred_umaxrvvmf2si */

    case 22:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5865; /* pred_umaxv1qi */

    case 23:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5882; /* pred_umaxv2qi */

    case 24:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5899; /* pred_umaxv4qi */

    case 25:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5916; /* pred_umaxv8qi */

    case 26:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5933; /* pred_umaxv16qi */

    case 27:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5950; /* pred_umaxv32qi */

    case 28:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5967; /* pred_umaxv64qi */

    case 29:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5984; /* pred_umaxv128qi */

    case 30:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6001; /* pred_umaxv256qi */

    case 31:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6018; /* pred_umaxv512qi */

    case 32:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6035; /* pred_umaxv1024qi */

    case 33:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6052; /* pred_umaxv2048qi */

    case 34:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6069; /* pred_umaxv4096qi */

    case 35:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6086; /* pred_umaxv1hi */

    case 36:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6103; /* pred_umaxv2hi */

    case 37:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6120; /* pred_umaxv4hi */

    case 38:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6137; /* pred_umaxv8hi */

    case 39:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6154; /* pred_umaxv16hi */

    case 40:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6171; /* pred_umaxv32hi */

    case 41:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6188; /* pred_umaxv64hi */

    case 42:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6205; /* pred_umaxv128hi */

    case 43:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6222; /* pred_umaxv256hi */

    case 44:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6239; /* pred_umaxv512hi */

    case 45:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6256; /* pred_umaxv1024hi */

    case 46:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6273; /* pred_umaxv2048hi */

    case 47:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6290; /* pred_umaxv1si */

    case 48:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6307; /* pred_umaxv2si */

    case 49:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6324; /* pred_umaxv4si */

    case 50:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6341; /* pred_umaxv8si */

    case 51:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6358; /* pred_umaxv16si */

    case 52:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6375; /* pred_umaxv32si */

    case 53:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6392; /* pred_umaxv64si */

    case 54:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6409; /* pred_umaxv128si */

    case 55:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6426; /* pred_umaxv256si */

    case 56:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6443; /* pred_umaxv512si */

    case 57:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6460; /* pred_umaxv1024si */

    case 58:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6477; /* pred_umaxv1di */

    case 59:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6494; /* pred_umaxv2di */

    case 60:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6511; /* pred_umaxv4di */

    case 61:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6528; /* pred_umaxv8di */

    case 62:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6545; /* pred_umaxv16di */

    case 63:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6562; /* pred_umaxv32di */

    case 64:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6579; /* pred_umaxv64di */

    case 65:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6596; /* pred_umaxv128di */

    case 66:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6613; /* pred_umaxv256di */

    case 67:
      if (!(
#line 2722 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6630; /* pred_umaxv512di */

    case 68:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6847; /* pred_umaxrvvm8qi_scalar */

    case 69:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6856; /* pred_umaxrvvm4qi_scalar */

    case 70:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6865; /* pred_umaxrvvm2qi_scalar */

    case 71:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6874; /* pred_umaxrvvm1qi_scalar */

    case 72:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6883; /* pred_umaxrvvmf2qi_scalar */

    case 73:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6892; /* pred_umaxrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6901; /* pred_umaxrvvmf8qi_scalar */

    case 75:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6910; /* pred_umaxrvvm8hi_scalar */

    case 76:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6919; /* pred_umaxrvvm4hi_scalar */

    case 77:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6928; /* pred_umaxrvvm2hi_scalar */

    case 78:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6937; /* pred_umaxrvvm1hi_scalar */

    case 79:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6946; /* pred_umaxrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6955; /* pred_umaxrvvmf4hi_scalar */

    case 81:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6964; /* pred_umaxrvvm8si_scalar */

    case 82:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6973; /* pred_umaxrvvm4si_scalar */

    case 83:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6982; /* pred_umaxrvvm2si_scalar */

    case 84:
      if (!
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6991; /* pred_umaxrvvm1si_scalar */

    case 85:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7000; /* pred_umaxrvvmf2si_scalar */

    case 86:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 716 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7009; /* pred_umaxv1qi_scalar */

    case 87:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 717 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7018; /* pred_umaxv2qi_scalar */

    case 88:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 718 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7027; /* pred_umaxv4qi_scalar */

    case 89:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 719 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7036; /* pred_umaxv8qi_scalar */

    case 90:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 720 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7045; /* pred_umaxv16qi_scalar */

    case 91:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 721 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7054; /* pred_umaxv32qi_scalar */

    case 92:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 722 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7063; /* pred_umaxv64qi_scalar */

    case 93:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 723 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7072; /* pred_umaxv128qi_scalar */

    case 94:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7081; /* pred_umaxv256qi_scalar */

    case 95:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 725 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7090; /* pred_umaxv512qi_scalar */

    case 96:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7099; /* pred_umaxv1024qi_scalar */

    case 97:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 727 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7108; /* pred_umaxv2048qi_scalar */

    case 98:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7117; /* pred_umaxv4096qi_scalar */

    case 99:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 729 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7126; /* pred_umaxv1hi_scalar */

    case 100:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7135; /* pred_umaxv2hi_scalar */

    case 101:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7144; /* pred_umaxv4hi_scalar */

    case 102:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7153; /* pred_umaxv8hi_scalar */

    case 103:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7162; /* pred_umaxv16hi_scalar */

    case 104:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7171; /* pred_umaxv32hi_scalar */

    case 105:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7180; /* pred_umaxv64hi_scalar */

    case 106:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7189; /* pred_umaxv128hi_scalar */

    case 107:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7198; /* pred_umaxv256hi_scalar */

    case 108:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7207; /* pred_umaxv512hi_scalar */

    case 109:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7216; /* pred_umaxv1024hi_scalar */

    case 110:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7225; /* pred_umaxv2048hi_scalar */

    case 111:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7234; /* pred_umaxv1si_scalar */

    case 112:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7243; /* pred_umaxv2si_scalar */

    case 113:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7252; /* pred_umaxv4si_scalar */

    case 114:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7261; /* pred_umaxv8si_scalar */

    case 115:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7270; /* pred_umaxv16si_scalar */

    case 116:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7279; /* pred_umaxv32si_scalar */

    case 117:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7288; /* pred_umaxv64si_scalar */

    case 118:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7297; /* pred_umaxv128si_scalar */

    case 119:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7306; /* pred_umaxv256si_scalar */

    case 120:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7315; /* pred_umaxv512si_scalar */

    case 121:
      if (!(
#line 2780 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7324; /* pred_umaxv1024si_scalar */

    case 122:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7657; /* *pred_umaxrvvm8di_scalar */

    case 123:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7666; /* *pred_umaxrvvm4di_scalar */

    case 124:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7675; /* *pred_umaxrvvm2di_scalar */

    case 125:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7684; /* *pred_umaxrvvm1di_scalar */

    case 126:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7693; /* *pred_umaxv1di_scalar */

    case 127:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7702; /* *pred_umaxv2di_scalar */

    case 128:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7711; /* *pred_umaxv4di_scalar */

    case 129:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7720; /* *pred_umaxv8di_scalar */

    case 130:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7729; /* *pred_umaxv16di_scalar */

    case 131:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7738; /* *pred_umaxv32di_scalar */

    case 132:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7747; /* *pred_umaxv64di_scalar */

    case 133:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7756; /* *pred_umaxv128di_scalar */

    case 134:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7765; /* *pred_umaxv256di_scalar */

    case 135:
      if (!(
#line 2878 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7774; /* *pred_umaxv512di_scalar */

    case 136:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7783; /* *pred_umaxrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7792; /* *pred_umaxrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7801; /* *pred_umaxrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7810; /* *pred_umaxrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7819; /* *pred_umaxv1di_extended_scalar */

    case 141:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7828; /* *pred_umaxv2di_extended_scalar */

    case 142:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7837; /* *pred_umaxv4di_extended_scalar */

    case 143:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 766 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7846; /* *pred_umaxv8di_extended_scalar */

    case 144:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 767 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7855; /* *pred_umaxv16di_extended_scalar */

    case 145:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 768 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7864; /* *pred_umaxv32di_extended_scalar */

    case 146:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7873; /* *pred_umaxv64di_extended_scalar */

    case 147:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7882; /* *pred_umaxv128di_extended_scalar */

    case 148:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 771 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7891; /* *pred_umaxv256di_extended_scalar */

    case 149:
      if (!(
#line 2900 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 772 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7900; /* *pred_umaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_900 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern501 (x2))
    {
    case 0:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9103; /* pred_zero_extendrvvm8hi_vf2 */

    case 1:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9105; /* pred_zero_extendrvvm4hi_vf2 */

    case 2:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9107; /* pred_zero_extendrvvm2hi_vf2 */

    case 3:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9109; /* pred_zero_extendrvvm1hi_vf2 */

    case 4:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9111; /* pred_zero_extendrvvmf2hi_vf2 */

    case 5:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9113; /* pred_zero_extendrvvmf4hi_vf2 */

    case 6:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9115; /* pred_zero_extendrvvm8si_vf2 */

    case 7:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9199; /* pred_zero_extendrvvm8si_vf4 */

    case 8:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9117; /* pred_zero_extendrvvm4si_vf2 */

    case 9:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9201; /* pred_zero_extendrvvm4si_vf4 */

    case 10:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9119; /* pred_zero_extendrvvm2si_vf2 */

    case 11:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9203; /* pred_zero_extendrvvm2si_vf4 */

    case 12:
      if (!
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9121; /* pred_zero_extendrvvm1si_vf2 */

    case 13:
      if (!
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9205; /* pred_zero_extendrvvm1si_vf4 */

    case 14:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9123; /* pred_zero_extendrvvmf2si_vf2 */

    case 15:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9207; /* pred_zero_extendrvvmf2si_vf4 */

    case 16:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9125; /* pred_zero_extendrvvm8di_vf2 */

    case 17:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9209; /* pred_zero_extendrvvm8di_vf4 */

    case 18:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9259; /* pred_zero_extendrvvm8di_vf8 */

    case 19:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9127; /* pred_zero_extendrvvm4di_vf2 */

    case 20:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9211; /* pred_zero_extendrvvm4di_vf4 */

    case 21:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9261; /* pred_zero_extendrvvm4di_vf8 */

    case 22:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9129; /* pred_zero_extendrvvm2di_vf2 */

    case 23:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9213; /* pred_zero_extendrvvm2di_vf4 */

    case 24:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9263; /* pred_zero_extendrvvm2di_vf8 */

    case 25:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9131; /* pred_zero_extendrvvm1di_vf2 */

    case 26:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9215; /* pred_zero_extendrvvm1di_vf4 */

    case 27:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9265; /* pred_zero_extendrvvm1di_vf8 */

    case 28:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9133; /* pred_zero_extendv1hi_vf2 */

    case 29:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9135; /* pred_zero_extendv2hi_vf2 */

    case 30:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9137; /* pred_zero_extendv4hi_vf2 */

    case 31:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9139; /* pred_zero_extendv8hi_vf2 */

    case 32:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9141; /* pred_zero_extendv16hi_vf2 */

    case 33:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9143; /* pred_zero_extendv32hi_vf2 */

    case 34:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9145; /* pred_zero_extendv64hi_vf2 */

    case 35:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9147; /* pred_zero_extendv128hi_vf2 */

    case 36:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9149; /* pred_zero_extendv256hi_vf2 */

    case 37:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9151; /* pred_zero_extendv512hi_vf2 */

    case 38:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9153; /* pred_zero_extendv1024hi_vf2 */

    case 39:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9155; /* pred_zero_extendv2048hi_vf2 */

    case 40:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9157; /* pred_zero_extendv1si_vf2 */

    case 41:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9217; /* pred_zero_extendv1si_vf4 */

    case 42:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9159; /* pred_zero_extendv2si_vf2 */

    case 43:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9219; /* pred_zero_extendv2si_vf4 */

    case 44:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9161; /* pred_zero_extendv4si_vf2 */

    case 45:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9221; /* pred_zero_extendv4si_vf4 */

    case 46:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9163; /* pred_zero_extendv8si_vf2 */

    case 47:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9223; /* pred_zero_extendv8si_vf4 */

    case 48:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9165; /* pred_zero_extendv16si_vf2 */

    case 49:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9225; /* pred_zero_extendv16si_vf4 */

    case 50:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9167; /* pred_zero_extendv32si_vf2 */

    case 51:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9227; /* pred_zero_extendv32si_vf4 */

    case 52:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9169; /* pred_zero_extendv64si_vf2 */

    case 53:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9229; /* pred_zero_extendv64si_vf4 */

    case 54:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9171; /* pred_zero_extendv128si_vf2 */

    case 55:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9231; /* pred_zero_extendv128si_vf4 */

    case 56:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9173; /* pred_zero_extendv256si_vf2 */

    case 57:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9233; /* pred_zero_extendv256si_vf4 */

    case 58:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9175; /* pred_zero_extendv512si_vf2 */

    case 59:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9235; /* pred_zero_extendv512si_vf4 */

    case 60:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9177; /* pred_zero_extendv1024si_vf2 */

    case 61:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9237; /* pred_zero_extendv1024si_vf4 */

    case 62:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9179; /* pred_zero_extendv1di_vf2 */

    case 63:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9239; /* pred_zero_extendv1di_vf4 */

    case 64:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9267; /* pred_zero_extendv1di_vf8 */

    case 65:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9181; /* pred_zero_extendv2di_vf2 */

    case 66:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9241; /* pred_zero_extendv2di_vf4 */

    case 67:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9269; /* pred_zero_extendv2di_vf8 */

    case 68:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9183; /* pred_zero_extendv4di_vf2 */

    case 69:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9243; /* pred_zero_extendv4di_vf4 */

    case 70:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9271; /* pred_zero_extendv4di_vf8 */

    case 71:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9185; /* pred_zero_extendv8di_vf2 */

    case 72:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9245; /* pred_zero_extendv8di_vf4 */

    case 73:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9273; /* pred_zero_extendv8di_vf8 */

    case 74:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9187; /* pred_zero_extendv16di_vf2 */

    case 75:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9247; /* pred_zero_extendv16di_vf4 */

    case 76:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9275; /* pred_zero_extendv16di_vf8 */

    case 77:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9189; /* pred_zero_extendv32di_vf2 */

    case 78:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9249; /* pred_zero_extendv32di_vf4 */

    case 79:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9277; /* pred_zero_extendv32di_vf8 */

    case 80:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9191; /* pred_zero_extendv64di_vf2 */

    case 81:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9251; /* pred_zero_extendv64di_vf4 */

    case 82:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9279; /* pred_zero_extendv64di_vf8 */

    case 83:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9193; /* pred_zero_extendv128di_vf2 */

    case 84:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9253; /* pred_zero_extendv128di_vf4 */

    case 85:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9281; /* pred_zero_extendv128di_vf8 */

    case 86:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9195; /* pred_zero_extendv256di_vf2 */

    case 87:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9255; /* pred_zero_extendv256di_vf4 */

    case 88:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9283; /* pred_zero_extendv256di_vf8 */

    case 89:
      if (!(
#line 3938 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9197; /* pred_zero_extendv512di_vf2 */

    case 90:
      if (!(
#line 3958 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9257; /* pred_zero_extendv512di_vf4 */

    case 91:
      if (!(
#line 3978 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9285; /* pred_zero_extendv512di_vf8 */

    default:
      return -1;
    }
}

 int
recog_910 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern470 (x2))
    {
    case 0:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1237; /* *pred_mov_widthburvvm8qi */

    case 1:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1243; /* *pred_mov_widthburvvm4qi */

    case 2:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1249; /* *pred_mov_widthburvvm2qi */

    case 3:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1255; /* *pred_mov_widthburvvm1qi */

    case 4:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1261; /* *pred_mov_widthburvvm8hi */

    case 5:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1267; /* *pred_mov_widthburvvm4hi */

    case 6:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1273; /* *pred_mov_widthburvvm2hi */

    case 7:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1279; /* *pred_mov_widthburvvm1hi */

    case 8:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1285; /* *pred_mov_widthburvvm8si */

    case 9:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1291; /* *pred_mov_widthburvvm4si */

    case 10:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1297; /* *pred_mov_widthburvvm2si */

    case 11:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1303; /* *pred_mov_widthburvvm1si */

    case 12:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1309; /* *pred_mov_widthburvvm8di */

    case 13:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1315; /* *pred_mov_widthburvvm4di */

    case 14:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1321; /* *pred_mov_widthburvvm2di */

    case 15:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1327; /* *pred_mov_widthburvvm1di */

    case 16:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1333; /* *pred_mov_widthburvvmf2qi */

    case 17:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1339; /* *pred_mov_widthburvvmf4qi */

    case 18:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1345; /* *pred_mov_widthburvvmf8qi */

    case 19:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1351; /* *pred_mov_widthburvvmf2hi */

    case 20:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1357; /* *pred_mov_widthburvvmf4hi */

    case 21:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1363; /* *pred_mov_widthburvvmf2si */

    case 22:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1369; /* *pred_mov_widthburvvm8bf */

    case 23:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1375; /* *pred_mov_widthburvvm4bf */

    case 24:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1381; /* *pred_mov_widthburvvm2bf */

    case 25:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1387; /* *pred_mov_widthburvvm1bf */

    case 26:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1393; /* *pred_mov_widthburvvmf2bf */

    case 27:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1399; /* *pred_mov_widthburvvmf4bf */

    case 28:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1405; /* *pred_mov_widthburvvm8hf */

    case 29:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1411; /* *pred_mov_widthburvvm4hf */

    case 30:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1417; /* *pred_mov_widthburvvm2hf */

    case 31:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1423; /* *pred_mov_widthburvvm1hf */

    case 32:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1429; /* *pred_mov_widthburvvmf2hf */

    case 33:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1435; /* *pred_mov_widthburvvmf4hf */

    case 34:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1441; /* *pred_mov_widthburvvm8sf */

    case 35:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1447; /* *pred_mov_widthburvvm4sf */

    case 36:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1453; /* *pred_mov_widthburvvm2sf */

    case 37:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1459; /* *pred_mov_widthburvvm1sf */

    case 38:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1465; /* *pred_mov_widthburvvmf2sf */

    case 39:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1471; /* *pred_mov_widthburvvm8df */

    case 40:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1477; /* *pred_mov_widthburvvm4df */

    case 41:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1483; /* *pred_mov_widthburvvm2df */

    case 42:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1489; /* *pred_mov_widthburvvm1df */

    case 43:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1495; /* *pred_mov_widthbuv1qi */

    case 44:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1501; /* *pred_mov_widthbuv2qi */

    case 45:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1507; /* *pred_mov_widthbuv4qi */

    case 46:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1513; /* *pred_mov_widthbuv8qi */

    case 47:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1519; /* *pred_mov_widthbuv16qi */

    case 48:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1525; /* *pred_mov_widthbuv32qi */

    case 49:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1531; /* *pred_mov_widthbuv64qi */

    case 50:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1537; /* *pred_mov_widthbuv128qi */

    case 51:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1543; /* *pred_mov_widthbuv256qi */

    case 52:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1549; /* *pred_mov_widthbuv512qi */

    case 53:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1555; /* *pred_mov_widthbuv1024qi */

    case 54:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1561; /* *pred_mov_widthbuv2048qi */

    case 55:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1567; /* *pred_mov_widthbuv4096qi */

    case 56:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1573; /* *pred_mov_widthbuv1hi */

    case 57:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1579; /* *pred_mov_widthbuv2hi */

    case 58:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1585; /* *pred_mov_widthbuv4hi */

    case 59:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1591; /* *pred_mov_widthbuv8hi */

    case 60:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1597; /* *pred_mov_widthbuv16hi */

    case 61:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1603; /* *pred_mov_widthbuv32hi */

    case 62:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1609; /* *pred_mov_widthbuv64hi */

    case 63:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1615; /* *pred_mov_widthbuv128hi */

    case 64:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1621; /* *pred_mov_widthbuv256hi */

    case 65:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1627; /* *pred_mov_widthbuv512hi */

    case 66:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1633; /* *pred_mov_widthbuv1024hi */

    case 67:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1639; /* *pred_mov_widthbuv2048hi */

    case 68:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1645; /* *pred_mov_widthbuv1si */

    case 69:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1651; /* *pred_mov_widthbuv2si */

    case 70:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1657; /* *pred_mov_widthbuv4si */

    case 71:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1663; /* *pred_mov_widthbuv8si */

    case 72:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1669; /* *pred_mov_widthbuv16si */

    case 73:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1675; /* *pred_mov_widthbuv32si */

    case 74:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1681; /* *pred_mov_widthbuv64si */

    case 75:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1687; /* *pred_mov_widthbuv128si */

    case 76:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1693; /* *pred_mov_widthbuv256si */

    case 77:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1699; /* *pred_mov_widthbuv512si */

    case 78:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1705; /* *pred_mov_widthbuv1024si */

    case 79:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1711; /* *pred_mov_widthbuv1di */

    case 80:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1717; /* *pred_mov_widthbuv2di */

    case 81:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1723; /* *pred_mov_widthbuv4di */

    case 82:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1729; /* *pred_mov_widthbuv8di */

    case 83:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1735; /* *pred_mov_widthbuv16di */

    case 84:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1741; /* *pred_mov_widthbuv32di */

    case 85:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1747; /* *pred_mov_widthbuv64di */

    case 86:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1753; /* *pred_mov_widthbuv128di */

    case 87:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1759; /* *pred_mov_widthbuv256di */

    case 88:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1765; /* *pred_mov_widthbuv512di */

    case 89:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1771; /* *pred_mov_widthbuv1hf */

    case 90:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1777; /* *pred_mov_widthbuv2hf */

    case 91:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1783; /* *pred_mov_widthbuv4hf */

    case 92:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1789; /* *pred_mov_widthbuv8hf */

    case 93:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1795; /* *pred_mov_widthbuv16hf */

    case 94:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1801; /* *pred_mov_widthbuv32hf */

    case 95:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1807; /* *pred_mov_widthbuv64hf */

    case 96:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1813; /* *pred_mov_widthbuv128hf */

    case 97:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1819; /* *pred_mov_widthbuv256hf */

    case 98:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1825; /* *pred_mov_widthbuv512hf */

    case 99:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1831; /* *pred_mov_widthbuv1024hf */

    case 100:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1837; /* *pred_mov_widthbuv2048hf */

    case 101:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1843; /* *pred_mov_widthbuv1sf */

    case 102:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1849; /* *pred_mov_widthbuv2sf */

    case 103:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1855; /* *pred_mov_widthbuv4sf */

    case 104:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1861; /* *pred_mov_widthbuv8sf */

    case 105:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1867; /* *pred_mov_widthbuv16sf */

    case 106:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1873; /* *pred_mov_widthbuv32sf */

    case 107:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1879; /* *pred_mov_widthbuv64sf */

    case 108:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1885; /* *pred_mov_widthbuv128sf */

    case 109:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1891; /* *pred_mov_widthbuv256sf */

    case 110:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1897; /* *pred_mov_widthbuv512sf */

    case 111:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1903; /* *pred_mov_widthbuv1024sf */

    case 112:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1909; /* *pred_mov_widthbuv1df */

    case 113:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1915; /* *pred_mov_widthbuv2df */

    case 114:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1921; /* *pred_mov_widthbuv4df */

    case 115:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1927; /* *pred_mov_widthbuv8df */

    case 116:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1933; /* *pred_mov_widthbuv16df */

    case 117:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1939; /* *pred_mov_widthbuv32df */

    case 118:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1945; /* *pred_mov_widthbuv64df */

    case 119:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1951; /* *pred_mov_widthbuv128df */

    case 120:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1957; /* *pred_mov_widthbuv256df */

    case 121:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1963; /* *pred_mov_widthbuv512df */

    default:
      return -1;
    }
}

 int
recog_929 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15251; /* *pred_mul_addrvvm8sf_undef */
}

 int
recog_934 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15261; /* *pred_mul_addrvvm8df_undef */
}

 int
recog_939 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15271; /* *pred_mul_addv2hf_undef */
}

 int
recog_944 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15281; /* *pred_mul_addv64hf_undef */
}

 int
recog_949 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15291; /* *pred_mul_addv2048hf_undef */
}

 int
recog_954 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15301; /* *pred_mul_addv16sf_undef */
}

 int
recog_959 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15311; /* *pred_mul_addv512sf_undef */
}

 int
recog_964 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15321; /* *pred_mul_addv8df_undef */
}

 int
recog_969 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15331; /* *pred_mul_addv256df_undef */
}

 int
recog_974 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7194 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16750; /* pred_widen_mul_addrvvm4sf_scalar */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 130 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32725; /* pred_widen_bf16_mul_rvvm4sf_scalar */

    default:
      return -1;
    }
}

 int
recog_979 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern727 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7165 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16690; /* pred_widen_mul_addrvvm4sf */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 101 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32720; /* pred_widen_bf16_mul_rvvm4sf */

    default:
      return -1;
    }
}

 int
recog_984 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_967 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15423; /* *pred_maddv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15519; /* *pred_maccv64df */
}

 int
recog_989 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_962 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15413; /* *pred_maddv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15509; /* *pred_maccv2df */
}

 int
recog_994 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_957 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15403; /* *pred_maddv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15499; /* *pred_maccv128sf */
}

 int
recog_999 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_952 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15393; /* *pred_maddv4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15489; /* *pred_maccv4sf */
}

 int
recog_1004 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_947 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15383; /* *pred_maddv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15479; /* *pred_maccv512hf */
}

 int
recog_1009 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_942 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15373; /* *pred_maddv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15469; /* *pred_maccv16hf */
}

 int
recog_1015 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_936 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15361; /* *pred_maddrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15457; /* *pred_maccrvvm2df */
}

 int
recog_1021 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_930 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15349; /* *pred_maddrvvm4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15445; /* *pred_maccrvvm4sf */
}

 int
recog_1027 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_924 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15337; /* *pred_maddrvvm4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15433; /* *pred_maccrvvm4hf */
}

 int
recog_1035 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15731; /* *pred_mul_neg_addrvvm8sf_undef */
}

 int
recog_1043 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15747; /* *pred_mul_neg_addrvvm1df_undef */
}

 int
recog_1052 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15765; /* *pred_mul_neg_addv256hf_undef */
}

 int
recog_1062 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15785; /* *pred_mul_neg_addv64sf_undef */
}

 int
recog_1072 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15805; /* *pred_mul_neg_addv32df_undef */
}

 int
recog_1082 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1071 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 15899; /* *pred_nmsubv16df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15995; /* *pred_nmsacv16df */
}

 int
recog_1092 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1061 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 15879; /* *pred_nmsubv32sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15975; /* *pred_nmsacv32sf */
}

 int
recog_1102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1051 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15859; /* *pred_nmsubv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15955; /* *pred_nmsacv128hf */
}

 int
recog_1112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1041 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15839; /* *pred_nmsubrvvm4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15935; /* *pred_nmsacrvvm4df */
}

 int
recog_1122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1031 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15819; /* *pred_nmsubrvvm2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15915; /* *pred_nmsacrvvm2hf */
}

 int
recog_1132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15248; /* *pred_mul_subrvvmf2hf_undef */
}

 int
recog_1139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15262; /* *pred_mul_subrvvm8df_undef */
}

 int
recog_1146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15276; /* *pred_mul_subv8hf_undef */
}

 int
recog_1153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024HFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15290; /* *pred_mul_subv1024hf_undef */
}

 int
recog_1160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15304; /* *pred_mul_subv32sf_undef */
}

 int
recog_1167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15318; /* *pred_mul_subv2df_undef */
}

 int
recog_1174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6491 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15332; /* *pred_mul_subv256df_undef */
}

 int
recog_1181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1170 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 15420; /* *pred_msubv16df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15516; /* *pred_msacv16df */
}

 int
recog_1188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1163 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 15406; /* *pred_msubv256sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15502; /* *pred_msacv256sf */
}

 int
recog_1195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1156 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15392; /* *pred_msubv2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15488; /* *pred_msacv2sf */
}

 int
recog_1202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1149 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15378; /* *pred_msubv64hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15474; /* *pred_msacv64hf */
}

 int
recog_1209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1142 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15364; /* *pred_msubrvvm1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15460; /* *pred_msacrvvm1df */
}

 int
recog_1215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1136 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15352; /* *pred_msubrvvm2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15448; /* *pred_msacrvvm2sf */
}

 int
recog_1222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1129 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15338; /* *pred_msubrvvm4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6554 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15434; /* *pred_msacrvvm4hf */
}

 int
recog_1230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15732; /* *pred_mul_neg_subrvvm8sf_undef */
}

 int
recog_1237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15746; /* *pred_mul_neg_subrvvm2df_undef */
}

 int
recog_1244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15760; /* *pred_mul_neg_subv32hf_undef */
}

 int
recog_1251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15774; /* *pred_mul_neg_subv1sf_undef */
}

 int
recog_1258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15788; /* *pred_mul_neg_subv128sf_undef */
}

 int
recog_1265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6704 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15802; /* *pred_mul_neg_subv8df_undef */
}

 int
recog_1272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1271 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return 15910; /* *pred_nmaddv512df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16006; /* *pred_nmaccv512df */
}

 int
recog_1279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1264 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15896; /* *pred_nmaddv4df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15992; /* *pred_nmaccv4df */
}

 int
recog_1286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1257 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15882; /* *pred_nmaddv64sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15978; /* *pred_nmaccv64sf */
}

 int
recog_1293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1250 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15868; /* *pred_nmaddv2048hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15964; /* *pred_nmaccv2048hf */
}

 int
recog_1301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1242 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15852; /* *pred_nmaddv8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15948; /* *pred_nmaccv8hf */
}

 int
recog_1309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1234 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return 15836; /* *pred_nmaddrvvmf2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15932; /* *pred_nmaccrvvmf2sf */
}

 int
recog_1318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1225 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15818; /* *pred_nmaddrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6769 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15914; /* *pred_nmaccrvvm4hf */
}

 int
recog_1326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XVECEXP (x5, 0, 5);
      operands[9] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x3, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          switch (pattern709 (x2))
            {
            case 0:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14483; /* pred_addrvvm8hf */

            case 1:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14487; /* pred_addrvvm4hf */

            case 2:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14491; /* pred_addrvvm2hf */

            case 3:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14495; /* pred_addrvvm1hf */

            case 4:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                return -1;
              return 14499; /* pred_addrvvmf2hf */

            case 5:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14503; /* pred_addrvvmf4hf */

            case 6:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14507; /* pred_addrvvm8sf */

            case 7:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14511; /* pred_addrvvm4sf */

            case 8:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14515; /* pred_addrvvm2sf */

            case 9:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14519; /* pred_addrvvm1sf */

            case 10:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 14523; /* pred_addrvvmf2sf */

            case 11:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14527; /* pred_addrvvm8df */

            case 12:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14531; /* pred_addrvvm4df */

            case 13:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14535; /* pred_addrvvm2df */

            case 14:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14539; /* pred_addrvvm1df */

            case 15:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                return -1;
              return 14543; /* pred_addv1hf */

            case 16:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                return -1;
              return 14547; /* pred_addv2hf */

            case 17:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                return -1;
              return 14551; /* pred_addv4hf */

            case 18:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                return -1;
              return 14555; /* pred_addv8hf */

            case 19:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                return -1;
              return 14559; /* pred_addv16hf */

            case 20:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14563; /* pred_addv32hf */

            case 21:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14567; /* pred_addv64hf */

            case 22:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14571; /* pred_addv128hf */

            case 23:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14575; /* pred_addv256hf */

            case 24:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14579; /* pred_addv512hf */

            case 25:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14583; /* pred_addv1024hf */

            case 26:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14587; /* pred_addv2048hf */

            case 27:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14591; /* pred_addv1sf */

            case 28:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14595; /* pred_addv2sf */

            case 29:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14599; /* pred_addv4sf */

            case 30:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 14603; /* pred_addv8sf */

            case 31:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14607; /* pred_addv16sf */

            case 32:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14611; /* pred_addv32sf */

            case 33:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14615; /* pred_addv64sf */

            case 34:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14619; /* pred_addv128sf */

            case 35:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14623; /* pred_addv256sf */

            case 36:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14627; /* pred_addv512sf */

            case 37:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14631; /* pred_addv1024sf */

            case 38:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14635; /* pred_addv1df */

            case 39:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14639; /* pred_addv2df */

            case 40:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 14643; /* pred_addv4df */

            case 41:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 14647; /* pred_addv8df */

            case 42:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 14651; /* pred_addv16df */

            case 43:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 14655; /* pred_addv32df */

            case 44:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 14659; /* pred_addv64df */

            case 45:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 14663; /* pred_addv128df */

            case 46:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 14667; /* pred_addv256df */

            case 47:
              if (!(
#line 6191 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 14671; /* pred_addv512df */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_DUPLICATE)
            return -1;
          switch (pattern730 (x2))
            {
            case 0:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16628; /* pred_single_widen_addrvvm8sf_scalar */

            case 1:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16630; /* pred_single_widen_addrvvm4sf_scalar */

            case 2:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16632; /* pred_single_widen_addrvvm2sf_scalar */

            case 3:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16634; /* pred_single_widen_addrvvm1sf_scalar */

            case 4:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16636; /* pred_single_widen_addrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16638; /* pred_single_widen_addrvvm8df_scalar */

            case 6:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16640; /* pred_single_widen_addrvvm4df_scalar */

            case 7:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16642; /* pred_single_widen_addrvvm2df_scalar */

            case 8:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16644; /* pred_single_widen_addrvvm1df_scalar */

            case 9:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16646; /* pred_single_widen_addv1sf_scalar */

            case 10:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16648; /* pred_single_widen_addv2sf_scalar */

            case 11:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16650; /* pred_single_widen_addv4sf_scalar */

            case 12:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16652; /* pred_single_widen_addv8sf_scalar */

            case 13:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16654; /* pred_single_widen_addv16sf_scalar */

            case 14:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16656; /* pred_single_widen_addv32sf_scalar */

            case 15:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16658; /* pred_single_widen_addv64sf_scalar */

            case 16:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16660; /* pred_single_widen_addv128sf_scalar */

            case 17:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16662; /* pred_single_widen_addv256sf_scalar */

            case 18:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16664; /* pred_single_widen_addv512sf_scalar */

            case 19:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16666; /* pred_single_widen_addv1024sf_scalar */

            case 20:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16668; /* pred_single_widen_addv1df_scalar */

            case 21:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16670; /* pred_single_widen_addv2df_scalar */

            case 22:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16672; /* pred_single_widen_addv4df_scalar */

            case 23:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16674; /* pred_single_widen_addv8df_scalar */

            case 24:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16676; /* pred_single_widen_addv16df_scalar */

            case 25:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16678; /* pred_single_widen_addv32df_scalar */

            case 26:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16680; /* pred_single_widen_addv64df_scalar */

            case 27:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16682; /* pred_single_widen_addv128df_scalar */

            case 28:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16684; /* pred_single_widen_addv256df_scalar */

            case 29:
              if (!(
#line 7130 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16686; /* pred_single_widen_addv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern577 (x2))
        {
        case 0:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14867; /* pred_addrvvm8hf_scalar */

        case 1:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14869; /* pred_addrvvm4hf_scalar */

        case 2:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14871; /* pred_addrvvm2hf_scalar */

        case 3:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14873; /* pred_addrvvm1hf_scalar */

        case 4:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14875; /* pred_addrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14877; /* pred_addrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14879; /* pred_addrvvm8sf_scalar */

        case 7:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14881; /* pred_addrvvm4sf_scalar */

        case 8:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14883; /* pred_addrvvm2sf_scalar */

        case 9:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14885; /* pred_addrvvm1sf_scalar */

        case 10:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14887; /* pred_addrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14889; /* pred_addrvvm8df_scalar */

        case 12:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14891; /* pred_addrvvm4df_scalar */

        case 13:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14893; /* pred_addrvvm2df_scalar */

        case 14:
          if (!(
#line 6257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14895; /* pred_addrvvm1df_scalar */

        default:
          return -1;
        }

    case MULT:
      return recog_1125 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_1126 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_1127 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || !vector_arith_operand (operands[4], E_RVVM4QImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12413; /* *pred_cmprvvm4qi_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || !vector_arith_operand (operands[4], E_RVVM8HImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12416; /* *pred_cmprvvm8hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || !vector_arith_operand (operands[4], E_RVVM2QImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12414; /* *pred_cmprvvm2qi_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || !vector_arith_operand (operands[4], E_RVVM4HImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12417; /* *pred_cmprvvm4hi_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || !vector_arith_operand (operands[4], E_RVVM8SImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12420; /* *pred_cmprvvm8si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode)
          || !vector_arith_operand (operands[4], E_RVVM1QImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12415; /* *pred_cmprvvm1qi_merge_tie_mask */

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode)
          || !vector_arith_operand (operands[4], E_RVVM2HImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12418; /* *pred_cmprvvm2hi_merge_tie_mask */

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode)
          || !vector_arith_operand (operands[4], E_RVVM4SImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12421; /* *pred_cmprvvm4si_merge_tie_mask */

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode)
          || !vector_arith_operand (operands[4], E_RVVM8DImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12424; /* *pred_cmprvvm8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || !vector_arith_operand (operands[4], E_RVVM1HImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12419; /* *pred_cmprvvm1hi_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || !vector_arith_operand (operands[4], E_RVVM2SImode)
          || !
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12422; /* *pred_cmprvvm2si_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || !vector_arith_operand (operands[4], E_RVVM4DImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12425; /* *pred_cmprvvm4di_merge_tie_mask */

    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || !vector_arith_operand (operands[4], E_RVVMF2QImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12428; /* *pred_cmprvvmf2qi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || !vector_arith_operand (operands[4], E_RVVM1DImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12427; /* *pred_cmprvvm1di_merge_tie_mask */

    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || !vector_arith_operand (operands[4], E_RVVMF8QImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12430; /* *pred_cmprvvmf8qi_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || !vector_arith_operand (operands[4], E_RVVMF4HImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12432; /* *pred_cmprvvmf4hi_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || !vector_arith_operand (operands[4], E_RVVMF2SImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12433; /* *pred_cmprvvmf2si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || !vector_arith_operand (operands[4], E_V32QImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12439; /* *pred_cmpv32qi_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || !vector_arith_operand (operands[4], E_V32HImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12452; /* *pred_cmpv32hi_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || !vector_arith_operand (operands[4], E_V32SImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12464; /* *pred_cmpv32si_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || !vector_arith_operand (operands[4], E_V32DImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12475; /* *pred_cmpv32di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2048QImode:
      if (!register_operand (operands[3], E_V2048QImode)
          || !vector_arith_operand (operands[4], E_V2048QImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12445; /* *pred_cmpv2048qi_merge_tie_mask */

    case E_V2048HImode:
      if (!register_operand (operands[3], E_V2048HImode)
          || !vector_arith_operand (operands[4], E_V2048HImode)
          || !(
#line 4758 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12458; /* *pred_cmpv2048hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V128BImode))
    {
      res = recog_1344 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128QImode:
      if (!register_operand (operands[4], E_V128QImode)
          || !vector_arith_operand (operands[5], E_V128QImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128QImode)) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 12509; /* *pred_cmpv128qi */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128QImode)) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12577; /* *pred_cmpv128qi_narrow */

    case E_V128HImode:
      if (!register_operand (operands[4], E_V128HImode)
          || !vector_arith_operand (operands[5], E_V128HImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128HImode)) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 12522; /* *pred_cmpv128hi */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128HImode)) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12590; /* *pred_cmpv128hi_narrow */

    case E_V128SImode:
      if (!register_operand (operands[4], E_V128SImode)
          || !vector_arith_operand (operands[5], E_V128SImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128SImode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 12534; /* *pred_cmpv128si */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128SImode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12602; /* *pred_cmpv128si_narrow */

    case E_V128DImode:
      if (!register_operand (operands[4], E_V128DImode)
          || !vector_arith_operand (operands[5], E_V128DImode))
        return -1;
      if ((
#line 4782 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 12545; /* *pred_cmpv128di */
      if (!(
#line 4803 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12613; /* *pred_cmpv128di_narrow */

    default:
      return -1;
    }
}

 int
recog_1358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[3], E_RVVM4QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4QImode)
          || !
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12617; /* *pred_ltgervvm4qi_merge_tie_mask */

    case E_RVVM8HImode:
      if (!register_operand (operands[3], E_RVVM8HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM8HImode)
          || !
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12620; /* *pred_ltgervvm8hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[3], E_RVVM1DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1DImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12631; /* *pred_ltgervvm1di_merge_tie_mask */

    case E_RVVMF8QImode:
      if (!register_operand (operands[3], E_RVVMF8QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF8QImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12634; /* *pred_ltgervvmf8qi_merge_tie_mask */

    case E_RVVMF4HImode:
      if (!register_operand (operands[3], E_RVVMF4HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF4HImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12636; /* *pred_ltgervvmf4hi_merge_tie_mask */

    case E_RVVMF2SImode:
      if (!register_operand (operands[3], E_RVVMF2SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2SImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12637; /* *pred_ltgervvmf2si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || !vector_neg_arith_operand (operands[4], E_V32QImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12643; /* *pred_ltgev32qi_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || !vector_neg_arith_operand (operands[4], E_V32HImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12656; /* *pred_ltgev32hi_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || !vector_neg_arith_operand (operands[4], E_V32SImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12668; /* *pred_ltgev32si_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || !vector_neg_arith_operand (operands[4], E_V32DImode)
          || !(
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12679; /* *pred_ltgev32di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern533 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1373 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || !vector_neg_arith_operand (operands[5], E_V512QImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12715; /* *pred_ltgev512qi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12783; /* *pred_ltgev512qi_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || !vector_neg_arith_operand (operands[5], E_V512HImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12728; /* *pred_ltgev512hi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12796; /* *pred_ltgev512hi_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || !vector_neg_arith_operand (operands[5], E_V512SImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12740; /* *pred_ltgev512si */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12808; /* *pred_ltgev512si_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || !vector_neg_arith_operand (operands[5], E_V512DImode))
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 12751; /* *pred_ltgev512di */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12819; /* *pred_ltgev512di_narrow */

    default:
      return -1;
    }
}

 int
recog_1384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern589 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) == 0
          && 
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12616; /* *pred_ltgervvm8qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern590 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
        return -1;
      if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12684; /* *pred_ltgervvm8qi */
      if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12752; /* *pred_ltgervvm8qi_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1358 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4QImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12685; /* *pred_ltgervvm4qi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12753; /* *pred_ltgervvm4qi_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8HImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12688; /* *pred_ltgervvm8hi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12756; /* *pred_ltgervvm8hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1359 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2QImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12686; /* *pred_ltgervvm2qi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12754; /* *pred_ltgervvm2qi_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4HImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12689; /* *pred_ltgervvm4hi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12757; /* *pred_ltgervvm4hi_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8SImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12692; /* *pred_ltgervvm8si */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12760; /* *pred_ltgervvm8si_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1360 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1QImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12687; /* *pred_ltgervvm1qi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12755; /* *pred_ltgervvm1qi_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2HImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12690; /* *pred_ltgervvm2hi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12758; /* *pred_ltgervvm2hi_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4SImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12693; /* *pred_ltgervvm4si */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12761; /* *pred_ltgervvm4si_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM8DImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12696; /* *pred_ltgervvm8di */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12764; /* *pred_ltgervvm8di_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1361 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1HImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12691; /* *pred_ltgervvm1hi */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12759; /* *pred_ltgervvm1hi_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2SImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12694; /* *pred_ltgervvm2si */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12762; /* *pred_ltgervvm2si_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM4DImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12697; /* *pred_ltgervvm4di */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12765; /* *pred_ltgervvm4di_narrow */

        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12700; /* *pred_ltgervvmf2qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12768; /* *pred_ltgervvmf2qi_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1362 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1SImode))
            return -1;
          if (
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12695; /* *pred_ltgervvm1si */
          if (!
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12763; /* *pred_ltgervvm1si_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM2DImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12698; /* *pred_ltgervvm2di */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12766; /* *pred_ltgervvm2di_narrow */

        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF4QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12701; /* *pred_ltgervvmf4qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12769; /* *pred_ltgervvmf4qi_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2HImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12703; /* *pred_ltgervvmf2hi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12771; /* *pred_ltgervvmf2hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || !vector_neg_arith_operand (operands[5], E_RVVM1DImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12699; /* *pred_ltgervvm1di */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12767; /* *pred_ltgervvm1di_narrow */

        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF8QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12702; /* *pred_ltgervvmf8qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12770; /* *pred_ltgervvmf8qi_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF4HImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12704; /* *pred_ltgervvmf4hi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12772; /* *pred_ltgervvmf4hi_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || !vector_neg_arith_operand (operands[5], E_RVVMF2SImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12705; /* *pred_ltgervvmf2si */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12773; /* *pred_ltgervvmf2si_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1364 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1QImode:
          if (!register_operand (operands[4], E_V1QImode)
              || !vector_neg_arith_operand (operands[5], E_V1QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 12706; /* *pred_ltgev1qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 12774; /* *pred_ltgev1qi_narrow */

        case E_V1HImode:
          if (!register_operand (operands[4], E_V1HImode)
              || !vector_neg_arith_operand (operands[5], E_V1HImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 12719; /* *pred_ltgev1hi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 12787; /* *pred_ltgev1hi_narrow */

        case E_V1SImode:
          if (!register_operand (operands[4], E_V1SImode)
              || !vector_neg_arith_operand (operands[5], E_V1SImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 12731; /* *pred_ltgev1si */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 12799; /* *pred_ltgev1si_narrow */

        case E_V1DImode:
          if (!register_operand (operands[4], E_V1DImode)
              || !vector_neg_arith_operand (operands[5], E_V1DImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 12742; /* *pred_ltgev1di */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12810; /* *pred_ltgev1di_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1365 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2QImode:
          if (!register_operand (operands[4], E_V2QImode)
              || !vector_neg_arith_operand (operands[5], E_V2QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 12707; /* *pred_ltgev2qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 12775; /* *pred_ltgev2qi_narrow */

        case E_V2HImode:
          if (!register_operand (operands[4], E_V2HImode)
              || !vector_neg_arith_operand (operands[5], E_V2HImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 12720; /* *pred_ltgev2hi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 12788; /* *pred_ltgev2hi_narrow */

        case E_V2SImode:
          if (!register_operand (operands[4], E_V2SImode)
              || !vector_neg_arith_operand (operands[5], E_V2SImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 12732; /* *pred_ltgev2si */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 12800; /* *pred_ltgev2si_narrow */

        case E_V2DImode:
          if (!register_operand (operands[4], E_V2DImode)
              || !vector_neg_arith_operand (operands[5], E_V2DImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 12743; /* *pred_ltgev2di */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12811; /* *pred_ltgev2di_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      return recog_1383 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1382 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1381 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1380 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1379 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1378 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1377 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1376 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1374 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || !vector_neg_arith_operand (operands[5], E_V1024QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12716; /* *pred_ltgev1024qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12784; /* *pred_ltgev1024qi_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || !vector_neg_arith_operand (operands[5], E_V1024HImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12729; /* *pred_ltgev1024hi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12797; /* *pred_ltgev1024hi_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || !vector_neg_arith_operand (operands[5], E_V1024SImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12741; /* *pred_ltgev1024si */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12809; /* *pred_ltgev1024si_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1375 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || !vector_neg_arith_operand (operands[5], E_V2048QImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12717; /* *pred_ltgev2048qi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12785; /* *pred_ltgev2048qi_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || !vector_neg_arith_operand (operands[5], E_V2048HImode))
            return -1;
          if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12730; /* *pred_ltgev2048hi */
          if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12798; /* *pred_ltgev2048hi_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern533 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern589 (x2, 
E_V4096QImode, 
E_V4096BImode) == 0
          && (
#line 4840 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12650; /* *pred_ltgev4096qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern590 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0)
        return -1;
      if ((
#line 4864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12718; /* *pred_ltgev4096qi */
      if (!(
#line 4885 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12786; /* *pred_ltgev4096qi_narrow */

    default:
      return -1;
    }
}

 int
recog_1462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern107 (x3))
        {
        case 0:
          if (!
#line 274 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return -1;
          return 511; /* *popcountsi2 */

        case 1:
          if (!
#line 302 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
            return -1;
          return 523; /* *popcountdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 5
          || XINT (x4, 1) != 91
          || pattern324 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          if (!vector_length_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern545 (x3, 
E_SImode))
                {
                case 0:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                    return -1;
                  return 14318; /* pred_popcountrvvmf64bisi */

                case 1:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14320; /* pred_popcountrvvmf32bisi */

                case 2:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14322; /* pred_popcountrvvmf16bisi */

                case 3:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14324; /* pred_popcountrvvmf8bisi */

                case 4:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14326; /* pred_popcountrvvmf4bisi */

                case 5:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14328; /* pred_popcountrvvmf2bisi */

                case 6:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14330; /* pred_popcountrvvm1bisi */

                case 7:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14332; /* pred_popcountv1bisi */

                case 8:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14334; /* pred_popcountv2bisi */

                case 9:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14336; /* pred_popcountv4bisi */

                case 10:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14338; /* pred_popcountv8bisi */

                case 11:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14340; /* pred_popcountv16bisi */

                case 12:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14342; /* pred_popcountv32bisi */

                case 13:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14344; /* pred_popcountv64bisi */

                case 14:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14346; /* pred_popcountv128bisi */

                case 15:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14348; /* pred_popcountv256bisi */

                case 16:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14350; /* pred_popcountv512bisi */

                case 17:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14352; /* pred_popcountv1024bisi */

                case 18:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14354; /* pred_popcountv2048bisi */

                case 19:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14356; /* pred_popcountv4096bisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern545 (x3, 
E_DImode))
                {
                case 0:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                    return -1;
                  return 14319; /* pred_popcountrvvmf64bidi */

                case 1:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14321; /* pred_popcountrvvmf32bidi */

                case 2:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14323; /* pred_popcountrvvmf16bidi */

                case 3:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14325; /* pred_popcountrvvmf8bidi */

                case 4:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14327; /* pred_popcountrvvmf4bidi */

                case 5:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14329; /* pred_popcountrvvmf2bidi */

                case 6:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14331; /* pred_popcountrvvm1bidi */

                case 7:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14333; /* pred_popcountv1bidi */

                case 8:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14335; /* pred_popcountv2bidi */

                case 9:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14337; /* pred_popcountv4bidi */

                case 10:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14339; /* pred_popcountv8bidi */

                case 11:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14341; /* pred_popcountv16bidi */

                case 12:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14343; /* pred_popcountv32bidi */

                case 13:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14345; /* pred_popcountv64bidi */

                case 14:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14347; /* pred_popcountv128bidi */

                case 15:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14349; /* pred_popcountv256bidi */

                case 16:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14351; /* pred_popcountv512bidi */

                case 17:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14353; /* pred_popcountv1024bidi */

                case 18:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14355; /* pred_popcountv2048bidi */

                case 19:
                  if (!(
#line 6086 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14357; /* pred_popcountv4096bidi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 5
              || XINT (x5, 1) != 155)
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern452 (x3))
            {
            case 0:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 31152; /* *vcond_mask_len_popcount_rvvmf64bisi */

            case 1:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31154; /* *vcond_mask_len_popcount_rvvmf32bisi */

            case 2:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31156; /* *vcond_mask_len_popcount_rvvmf16bisi */

            case 3:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31158; /* *vcond_mask_len_popcount_rvvmf8bisi */

            case 4:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31160; /* *vcond_mask_len_popcount_rvvmf4bisi */

            case 5:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31162; /* *vcond_mask_len_popcount_rvvmf2bisi */

            case 6:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 31164; /* *vcond_mask_len_popcount_rvvm1bisi */

            case 7:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 31166; /* *vcond_mask_len_popcount_v1bisi */

            case 8:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 31168; /* *vcond_mask_len_popcount_v2bisi */

            case 9:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 31170; /* *vcond_mask_len_popcount_v4bisi */

            case 10:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 31172; /* *vcond_mask_len_popcount_v8bisi */

            case 11:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 31174; /* *vcond_mask_len_popcount_v16bisi */

            case 12:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 31176; /* *vcond_mask_len_popcount_v32bisi */

            case 13:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 31178; /* *vcond_mask_len_popcount_v64bisi */

            case 14:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 31180; /* *vcond_mask_len_popcount_v128bisi */

            case 15:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 31182; /* *vcond_mask_len_popcount_v256bisi */

            case 16:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 31184; /* *vcond_mask_len_popcount_v512bisi */

            case 17:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 31186; /* *vcond_mask_len_popcount_v1024bisi */

            case 18:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 31188; /* *vcond_mask_len_popcount_v2048bisi */

            case 19:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 31190; /* *vcond_mask_len_popcount_v4096bisi */

            case 20:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 31153; /* *vcond_mask_len_popcount_rvvmf64bidi */

            case 21:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31155; /* *vcond_mask_len_popcount_rvvmf32bidi */

            case 22:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31157; /* *vcond_mask_len_popcount_rvvmf16bidi */

            case 23:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31159; /* *vcond_mask_len_popcount_rvvmf8bidi */

            case 24:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31161; /* *vcond_mask_len_popcount_rvvmf4bidi */

            case 25:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31163; /* *vcond_mask_len_popcount_rvvmf2bidi */

            case 26:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 31165; /* *vcond_mask_len_popcount_rvvm1bidi */

            case 27:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 31167; /* *vcond_mask_len_popcount_v1bidi */

            case 28:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 31169; /* *vcond_mask_len_popcount_v2bidi */

            case 29:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 31171; /* *vcond_mask_len_popcount_v4bidi */

            case 30:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 31173; /* *vcond_mask_len_popcount_v8bidi */

            case 31:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 31175; /* *vcond_mask_len_popcount_v16bidi */

            case 32:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 31177; /* *vcond_mask_len_popcount_v32bidi */

            case 33:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 31179; /* *vcond_mask_len_popcount_v64bidi */

            case 34:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 31181; /* *vcond_mask_len_popcount_v128bidi */

            case 35:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 31183; /* *vcond_mask_len_popcount_v256bidi */

            case 36:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 31185; /* *vcond_mask_len_popcount_v512bidi */

            case 37:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 31187; /* *vcond_mask_len_popcount_v1024bidi */

            case 38:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 31189; /* *vcond_mask_len_popcount_v2048bidi */

            case 39:
              if (!(
#line 1457 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 31191; /* *vcond_mask_len_popcount_v4096bidi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32098; /* pred_vpopcountrvvm8qi */

        case 1:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32101; /* pred_vpopcountrvvm4qi */

        case 2:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32104; /* pred_vpopcountrvvm2qi */

        case 3:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32107; /* pred_vpopcountrvvm1qi */

        case 4:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32110; /* pred_vpopcountrvvm8hi */

        case 5:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32113; /* pred_vpopcountrvvm4hi */

        case 6:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32116; /* pred_vpopcountrvvm2hi */

        case 7:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32119; /* pred_vpopcountrvvm1hi */

        case 8:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32122; /* pred_vpopcountrvvm8si */

        case 9:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32125; /* pred_vpopcountrvvm4si */

        case 10:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32128; /* pred_vpopcountrvvm2si */

        case 11:
          if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 32131; /* pred_vpopcountrvvm1si */

        case 12:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32134; /* pred_vpopcountrvvm8di */

        case 13:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32137; /* pred_vpopcountrvvm4di */

        case 14:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32140; /* pred_vpopcountrvvm2di */

        case 15:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32143; /* pred_vpopcountrvvm1di */

        case 16:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32146; /* pred_vpopcountrvvmf2qi */

        case 17:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32149; /* pred_vpopcountrvvmf4qi */

        case 18:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32152; /* pred_vpopcountrvvmf8qi */

        case 19:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 32155; /* pred_vpopcountrvvmf2hi */

        case 20:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32158; /* pred_vpopcountrvvmf4hi */

        case 21:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 32161; /* pred_vpopcountrvvmf2si */

        case 22:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 32164; /* pred_vpopcountv1qi */

        case 23:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 32167; /* pred_vpopcountv2qi */

        case 24:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 32170; /* pred_vpopcountv4qi */

        case 25:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 32173; /* pred_vpopcountv8qi */

        case 26:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 32176; /* pred_vpopcountv16qi */

        case 27:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 32179; /* pred_vpopcountv32qi */

        case 28:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32182; /* pred_vpopcountv64qi */

        case 29:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32185; /* pred_vpopcountv128qi */

        case 30:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32188; /* pred_vpopcountv256qi */

        case 31:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32191; /* pred_vpopcountv512qi */

        case 32:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32194; /* pred_vpopcountv1024qi */

        case 33:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32197; /* pred_vpopcountv2048qi */

        case 34:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32200; /* pred_vpopcountv4096qi */

        case 35:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 32203; /* pred_vpopcountv1hi */

        case 36:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 32206; /* pred_vpopcountv2hi */

        case 37:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 32209; /* pred_vpopcountv4hi */

        case 38:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 32212; /* pred_vpopcountv8hi */

        case 39:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 32215; /* pred_vpopcountv16hi */

        case 40:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32218; /* pred_vpopcountv32hi */

        case 41:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32221; /* pred_vpopcountv64hi */

        case 42:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32224; /* pred_vpopcountv128hi */

        case 43:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32227; /* pred_vpopcountv256hi */

        case 44:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32230; /* pred_vpopcountv512hi */

        case 45:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32233; /* pred_vpopcountv1024hi */

        case 46:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32236; /* pred_vpopcountv2048hi */

        case 47:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 32239; /* pred_vpopcountv1si */

        case 48:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 32242; /* pred_vpopcountv2si */

        case 49:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 32245; /* pred_vpopcountv4si */

        case 50:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 32248; /* pred_vpopcountv8si */

        case 51:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32251; /* pred_vpopcountv16si */

        case 52:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32254; /* pred_vpopcountv32si */

        case 53:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32257; /* pred_vpopcountv64si */

        case 54:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32260; /* pred_vpopcountv128si */

        case 55:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32263; /* pred_vpopcountv256si */

        case 56:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32266; /* pred_vpopcountv512si */

        case 57:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32269; /* pred_vpopcountv1024si */

        case 58:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32272; /* pred_vpopcountv1di */

        case 59:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32275; /* pred_vpopcountv2di */

        case 60:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32278; /* pred_vpopcountv4di */

        case 61:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32281; /* pred_vpopcountv8di */

        case 62:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32284; /* pred_vpopcountv16di */

        case 63:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32287; /* pred_vpopcountv32di */

        case 64:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32290; /* pred_vpopcountv64di */

        case 65:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32293; /* pred_vpopcountv128di */

        case 66:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32296; /* pred_vpopcountv256di */

        case 67:
          if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32299; /* pred_vpopcountv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 546 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 557; /* *umaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 625 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 32875; /* riscv_cv_alu_maxu */

    case 1:
      if (!(
#line 546 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 561; /* *umaxdi3 */

    case 2:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23620; /* umaxrvvm8qi3 */

    case 3:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23634; /* umaxrvvm4qi3 */

    case 4:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23648; /* umaxrvvm2qi3 */

    case 5:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23662; /* umaxrvvm1qi3 */

    case 6:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23676; /* umaxrvvm8hi3 */

    case 7:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23690; /* umaxrvvm4hi3 */

    case 8:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23704; /* umaxrvvm2hi3 */

    case 9:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23718; /* umaxrvvm1hi3 */

    case 10:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23732; /* umaxrvvm8si3 */

    case 11:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23746; /* umaxrvvm4si3 */

    case 12:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23760; /* umaxrvvm2si3 */

    case 13:
      if (!
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 23774; /* umaxrvvm1si3 */

    case 14:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23788; /* umaxrvvm8di3 */

    case 15:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23802; /* umaxrvvm4di3 */

    case 16:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23816; /* umaxrvvm2di3 */

    case 17:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 23830; /* umaxrvvm1di3 */

    case 18:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23844; /* umaxrvvmf2qi3 */

    case 19:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23858; /* umaxrvvmf4qi3 */

    case 20:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23872; /* umaxrvvmf8qi3 */

    case 21:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 23886; /* umaxrvvmf2hi3 */

    case 22:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23900; /* umaxrvvmf4hi3 */

    case 23:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 23914; /* umaxrvvmf2si3 */

    case 24:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 23928; /* umaxv1qi3 */

    case 25:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 23942; /* umaxv2qi3 */

    case 26:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 23956; /* umaxv4qi3 */

    case 27:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 23970; /* umaxv8qi3 */

    case 28:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 23984; /* umaxv16qi3 */

    case 29:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 23998; /* umaxv32qi3 */

    case 30:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24012; /* umaxv64qi3 */

    case 31:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24026; /* umaxv128qi3 */

    case 32:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24040; /* umaxv256qi3 */

    case 33:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24054; /* umaxv512qi3 */

    case 34:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24068; /* umaxv1024qi3 */

    case 35:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24082; /* umaxv2048qi3 */

    case 36:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24096; /* umaxv4096qi3 */

    case 37:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 24110; /* umaxv1hi3 */

    case 38:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 24124; /* umaxv2hi3 */

    case 39:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 24138; /* umaxv4hi3 */

    case 40:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 24152; /* umaxv8hi3 */

    case 41:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 24166; /* umaxv16hi3 */

    case 42:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24180; /* umaxv32hi3 */

    case 43:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24194; /* umaxv64hi3 */

    case 44:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24208; /* umaxv128hi3 */

    case 45:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24222; /* umaxv256hi3 */

    case 46:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24236; /* umaxv512hi3 */

    case 47:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24250; /* umaxv1024hi3 */

    case 48:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24264; /* umaxv2048hi3 */

    case 49:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 24278; /* umaxv1si3 */

    case 50:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 24292; /* umaxv2si3 */

    case 51:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 24306; /* umaxv4si3 */

    case 52:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 24320; /* umaxv8si3 */

    case 53:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24334; /* umaxv16si3 */

    case 54:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24348; /* umaxv32si3 */

    case 55:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24362; /* umaxv64si3 */

    case 56:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24376; /* umaxv128si3 */

    case 57:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24390; /* umaxv256si3 */

    case 58:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24404; /* umaxv512si3 */

    case 59:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24418; /* umaxv1024si3 */

    case 60:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24432; /* umaxv1di3 */

    case 61:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24446; /* umaxv2di3 */

    case 62:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24460; /* umaxv4di3 */

    case 63:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24474; /* umaxv8di3 */

    case 64:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24488; /* umaxv16di3 */

    case 65:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24502; /* umaxv32di3 */

    case 66:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24516; /* umaxv64di3 */

    case 67:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24530; /* umaxv128di3 */

    case 68:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 24544; /* umaxv256di3 */

    case 69:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 24558; /* umaxv512di3 */

    default:
      return -1;
    }
}

 int
recog_1486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern118 (x3))
    {
    case 0:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27013; /* umulrvvm8qi3_highpart */

    case 1:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27015; /* umulrvvm4qi3_highpart */

    case 2:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27017; /* umulrvvm2qi3_highpart */

    case 3:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27019; /* umulrvvm1qi3_highpart */

    case 4:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27021; /* umulrvvmf2qi3_highpart */

    case 5:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27023; /* umulrvvmf4qi3_highpart */

    case 6:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 488 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27025; /* umulrvvmf8qi3_highpart */

    case 7:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27027; /* umulrvvm8hi3_highpart */

    case 8:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27029; /* umulrvvm4hi3_highpart */

    case 9:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27031; /* umulrvvm2hi3_highpart */

    case 10:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27033; /* umulrvvm1hi3_highpart */

    case 11:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27035; /* umulrvvmf2hi3_highpart */

    case 12:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 490 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27037; /* umulrvvmf4hi3_highpart */

    case 13:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27039; /* umulrvvm8si3_highpart */

    case 14:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27041; /* umulrvvm4si3_highpart */

    case 15:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27043; /* umulrvvm2si3_highpart */

    case 16:
      if (!
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27045; /* umulrvvm1si3_highpart */

    case 17:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 492 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27047; /* umulrvvmf2si3_highpart */

    case 18:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27049; /* umulrvvm8di3_highpart */

    case 19:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27051; /* umulrvvm4di3_highpart */

    case 20:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27053; /* umulrvvm2di3_highpart */

    case 21:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 494 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27055; /* umulrvvm1di3_highpart */

    case 22:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 496 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27057; /* umulv1qi3_highpart */

    case 23:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 497 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27059; /* umulv2qi3_highpart */

    case 24:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 498 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27061; /* umulv4qi3_highpart */

    case 25:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 499 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27063; /* umulv8qi3_highpart */

    case 26:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 500 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27065; /* umulv16qi3_highpart */

    case 27:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 501 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27067; /* umulv32qi3_highpart */

    case 28:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27069; /* umulv64qi3_highpart */

    case 29:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 503 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27071; /* umulv128qi3_highpart */

    case 30:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27073; /* umulv256qi3_highpart */

    case 31:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 505 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27075; /* umulv512qi3_highpart */

    case 32:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27077; /* umulv1024qi3_highpart */

    case 33:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 507 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27079; /* umulv2048qi3_highpart */

    case 34:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27081; /* umulv4096qi3_highpart */

    case 35:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 509 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27083; /* umulv1hi3_highpart */

    case 36:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27085; /* umulv2hi3_highpart */

    case 37:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27087; /* umulv4hi3_highpart */

    case 38:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27089; /* umulv8hi3_highpart */

    case 39:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27091; /* umulv16hi3_highpart */

    case 40:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27093; /* umulv32hi3_highpart */

    case 41:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27095; /* umulv64hi3_highpart */

    case 42:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27097; /* umulv128hi3_highpart */

    case 43:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27099; /* umulv256hi3_highpart */

    case 44:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27101; /* umulv512hi3_highpart */

    case 45:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27103; /* umulv1024hi3_highpart */

    case 46:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27105; /* umulv2048hi3_highpart */

    case 47:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27107; /* umulv1si3_highpart */

    case 48:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27109; /* umulv2si3_highpart */

    case 49:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27111; /* umulv4si3_highpart */

    case 50:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27113; /* umulv8si3_highpart */

    case 51:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27115; /* umulv16si3_highpart */

    case 52:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27117; /* umulv32si3_highpart */

    case 53:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27119; /* umulv64si3_highpart */

    case 54:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27121; /* umulv128si3_highpart */

    case 55:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27123; /* umulv256si3_highpart */

    case 56:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27125; /* umulv512si3_highpart */

    case 57:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27127; /* umulv1024si3_highpart */

    case 58:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 27129; /* umulv1di3_highpart */

    case 59:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 27131; /* umulv2di3_highpart */

    case 60:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 27133; /* umulv4di3_highpart */

    case 61:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27135; /* umulv8di3_highpart */

    case 62:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27137; /* umulv16di3_highpart */

    case 63:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27139; /* umulv32di3_highpart */

    case 64:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27141; /* umulv64di3_highpart */

    case 65:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27143; /* umulv128di3_highpart */

    case 66:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27145; /* umulv256di3_highpart */

    case 67:
      if (!(
#line 1684 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27147; /* umulv512di3_highpart */

    default:
      return -1;
    }
}

 int
recog_1502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern411 (
E_SImode) != 0
          || !
#line 424 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, SImode)))
        return -1;
      return 900; /* *th_mempair_store_si2 */

    case E_DImode:
      if (pattern411 (
E_DImode) != 0
          || !(
#line 424 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMPAIR && reload_completed
   && th_mempair_operands_p (operands, false, DImode)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 901; /* *th_mempair_store_di2 */

    default:
      return -1;
    }
}

 int
recog_1505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (REGNO (x3))
    {
    case 69:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (REGNO (x5) != 69
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!reg_or_int_operand (operands[1], E_SImode)
          || !
#line 1099 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2707; /* fsrmsi_backup */

    case 1:
      x6 = XEXP (x2, 0);
      if (pattern364 (x6) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x5 = XEXP (x4, 0);
      if (REGNO (x5) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      operands[0] = x9;
      if (!stack_push_up_to_ra_operand (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      x11 = XEXP (x10, 1);
      switch (XWINT (x11, 0))
        {
        case -4L:
          if (pattern547 (x1, 
E_SImode) != 0
              || !(
#line 1111 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32824; /* gpr_multi_push_up_to_ra_si */

        case -8L:
          if (pattern547 (x1, 
E_DImode) != 0
              || !(
#line 1111 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32825; /* gpr_multi_push_up_to_ra_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
          res = recog_1496 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!fp_native_comparison (x4, E_VOIDmode))
        return -1;
      switch (pattern406 (x3))
        {
        case 0:
          if (!(
#line 3352 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 371; /* *cbranchsf4 */

        case 1:
          if (!(
#line 3352 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 372; /* *cbranchsf4 */

        case 2:
          if (!(
#line 3352 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 373; /* *cbranchdf4 */

        case 3:
          if (!(
#line 3352 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 374; /* *cbranchdf4 */

        case 4:
          if (!(
#line 3352 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            return -1;
          return 375; /* *cbranchhf4 */

        case 5:
          if (!(
#line 3352 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 376; /* *cbranchhf4 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 7
          || XINT (x4, 1) != 91)
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 66
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 67
          || GET_MODE (x11) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XINT (x5, 1) != 135)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x12 = XEXP (x8, 1);
      if (pattern370 (x12, 
136, 
1, 
UNSPEC) != 0)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x13) != IF_THEN_ELSE)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != UNSPEC
          || XVECLEN (x14, 0) != 7
          || XINT (x14, 1) != 91)
        return -1;
      x15 = XVECEXP (x14, 0, 5);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 66
          || GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XVECEXP (x14, 0, 6);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 67
          || GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x13, 1);
      if (GET_CODE (x17) != UNSPEC
          || XINT (x17, 1) != 135)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_SImode)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x18 = XVECEXP (x4, 0, 0);
      operands[1] = x18;
      x19 = XVECEXP (x4, 0, 1);
      operands[4] = x19;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x20 = XVECEXP (x4, 0, 2);
      operands[5] = x20;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x21 = XVECEXP (x4, 0, 3);
      operands[6] = x21;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x22 = XVECEXP (x4, 0, 4);
      operands[7] = x22;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      x23 = XVECEXP (x14, 0, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XVECEXP (x14, 0, 1);
      if (!rtx_equal_p (x24, operands[4]))
        return -1;
      x25 = XVECEXP (x14, 0, 2);
      if (!rtx_equal_p (x25, operands[5]))
        return -1;
      x26 = XVECEXP (x14, 0, 3);
      if (!rtx_equal_p (x26, operands[6]))
        return -1;
      x27 = XVECEXP (x14, 0, 4);
      if (!rtx_equal_p (x27, operands[7]))
        return -1;
      x28 = XEXP (x13, 2);
      if (!rtx_equal_p (x28, operands[2]))
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XVECLEN (x17, 0) != 1)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern747 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20138; /* pred_fault_loadrvvm8qi */

            case E_RVVM4QImode:
              if (pattern747 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20139; /* pred_fault_loadrvvm4qi */

            case E_RVVM2QImode:
              if (pattern747 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20140; /* pred_fault_loadrvvm2qi */

            case E_RVVM1QImode:
              if (pattern747 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20141; /* pred_fault_loadrvvm1qi */

            case E_RVVM8HImode:
              if (pattern747 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20142; /* pred_fault_loadrvvm8hi */

            case E_RVVM4HImode:
              if (pattern747 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20143; /* pred_fault_loadrvvm4hi */

            case E_RVVM2HImode:
              if (pattern747 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20144; /* pred_fault_loadrvvm2hi */

            case E_RVVM1HImode:
              if (pattern747 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20145; /* pred_fault_loadrvvm1hi */

            case E_RVVM8SImode:
              if (pattern747 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20146; /* pred_fault_loadrvvm8si */

            case E_RVVM4SImode:
              if (pattern747 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20147; /* pred_fault_loadrvvm4si */

            case E_RVVM2SImode:
              if (pattern747 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20148; /* pred_fault_loadrvvm2si */

            case E_RVVM1SImode:
              if (pattern747 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
                  || !
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 20149; /* pred_fault_loadrvvm1si */

            case E_RVVM8DImode:
              if (pattern747 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20150; /* pred_fault_loadrvvm8di */

            case E_RVVM4DImode:
              if (pattern747 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20151; /* pred_fault_loadrvvm4di */

            case E_RVVM2DImode:
              if (pattern747 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20152; /* pred_fault_loadrvvm2di */

            case E_RVVM1DImode:
              if (pattern747 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 20153; /* pred_fault_loadrvvm1di */

            case E_RVVMF2QImode:
              if (pattern747 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 20154; /* pred_fault_loadrvvmf2qi */

            case E_RVVMF4QImode:
              if (pattern747 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 20155; /* pred_fault_loadrvvmf4qi */

            case E_RVVMF8QImode:
              if (pattern747 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 20156; /* pred_fault_loadrvvmf8qi */

            case E_RVVMF2HImode:
              if (pattern747 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return -1;
              return 20157; /* pred_fault_loadrvvmf2hi */

            case E_RVVMF4HImode:
              if (pattern747 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 20158; /* pred_fault_loadrvvmf4hi */

            case E_RVVMF2SImode:
              if (pattern747 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 20159; /* pred_fault_loadrvvmf2si */

            case E_RVVM8BFmode:
              if (pattern747 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20160; /* pred_fault_loadrvvm8bf */

            case E_RVVM4BFmode:
              if (pattern747 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20161; /* pred_fault_loadrvvm4bf */

            case E_RVVM2BFmode:
              if (pattern747 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20162; /* pred_fault_loadrvvm2bf */

            case E_RVVM1BFmode:
              if (pattern747 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20163; /* pred_fault_loadrvvm1bf */

            case E_RVVMF2BFmode:
              if (pattern747 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
                return -1;
              return 20164; /* pred_fault_loadrvvmf2bf */

            case E_RVVMF4BFmode:
              if (pattern747 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 20165; /* pred_fault_loadrvvmf4bf */

            case E_RVVM8HFmode:
              if (pattern747 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20166; /* pred_fault_loadrvvm8hf */

            case E_RVVM4HFmode:
              if (pattern747 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20167; /* pred_fault_loadrvvm4hf */

            case E_RVVM2HFmode:
              if (pattern747 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20168; /* pred_fault_loadrvvm2hf */

            case E_RVVM1HFmode:
              if (pattern747 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20169; /* pred_fault_loadrvvm1hf */

            case E_RVVMF2HFmode:
              if (pattern747 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
                return -1;
              return 20170; /* pred_fault_loadrvvmf2hf */

            case E_RVVMF4HFmode:
              if (pattern747 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 20171; /* pred_fault_loadrvvmf4hf */

            case E_RVVM8SFmode:
              if (pattern747 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20172; /* pred_fault_loadrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern747 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20173; /* pred_fault_loadrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern747 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20174; /* pred_fault_loadrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern747 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 20175; /* pred_fault_loadrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern747 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 20176; /* pred_fault_loadrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern747 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20177; /* pred_fault_loadrvvm8df */

            case E_RVVM4DFmode:
              if (pattern747 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20178; /* pred_fault_loadrvvm4df */

            case E_RVVM2DFmode:
              if (pattern747 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20179; /* pred_fault_loadrvvm2df */

            case E_RVVM1DFmode:
              if (pattern747 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 8215 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 20180; /* pred_fault_loadrvvm1df */

            default:
              return -1;
            }

        case 2:
          x31 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x31) != MEM
              || GET_MODE (x31) != E_BLKmode)
            return -1;
          x32 = XEXP (x31, 0);
          if (GET_CODE (x32) != SCRATCH
              || XVECLEN (x17, 0) != 2)
            return -1;
          x33 = XVECEXP (x17, 0, 1);
          if (GET_CODE (x33) != MEM
              || GET_MODE (x33) != E_BLKmode)
            return -1;
          x34 = XEXP (x33, 0);
          if (GET_CODE (x34) != SCRATCH)
            return -1;
          x29 = XVECEXP (x5, 0, 0);
          operands[3] = x29;
          if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
            return -1;
          x30 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x30, operands[3]))
            return -1;
          return recog_1497 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  if (pattern113 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern371 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 4);
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 2)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (pattern726 (x1))
        {
        case 0:
          if (XWINT (x9, 0) != -16L)
            return -1;
          switch (pattern738 (x1, 
E_SImode, 
-32, 
-28, 
-24, 
-20))
            {
            case 0:
              if (!(
#line 189 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32766; /* gpr_multi_pop_up_to_s6_si */

            case 1:
              if (!(
#line 473 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32786; /* gpr_multi_popret_up_to_s4_si */

            case 2:
              if (!(
#line 789 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32806; /* gpr_multi_popretz_up_to_s2_si */

            default:
              return -1;
            }

        case 1:
          if (XWINT (x9, 0) != -32L)
            return -1;
          switch (pattern738 (x1, 
E_DImode, 
-64, 
-56, 
-48, 
-40))
            {
            case 0:
              if (!(
#line 189 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32767; /* gpr_multi_pop_up_to_s6_di */

            case 1:
              if (!(
#line 473 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32787; /* gpr_multi_popret_up_to_s4_di */

            case 2:
              if (!(
#line 789 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32807; /* gpr_multi_popretz_up_to_s2_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 22)
        return -1;
      x12 = XEXP (x3, 0);
      if (GET_CODE (x12) != MEM)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 2)
        return -1;
      x15 = XEXP (x13, 1);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x1, 0, 1);
      if (pattern413 (x16, 
21) != 0)
        return -1;
      x17 = XVECEXP (x1, 0, 2);
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 20)
        return -1;
      x19 = XEXP (x17, 0);
      if (GET_CODE (x19) != MEM)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != PLUS)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x22 = XEXP (x20, 1);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x1, 0, 3);
      if (pattern671 (x23, 
19) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 4);
      if (pattern731 (x5, 
18) != 0
          || pattern737 (x1, 
9) != 0
          || pattern743 (x1, 
8) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern748 (x24, 
1) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x25) != SET)
        return -1;
      x26 = XEXP (x25, 1);
      if (GET_CODE (x26) != PLUS)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 2)
        return -1;
      x28 = XEXP (x25, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 1);
      operands[0] = x29;
      if (!stack_push_up_to_s6_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern756 (x1))
        {
        case 0:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -32L
              || pattern765 (x1, 
E_SImode) != 0
              || !(
#line 1272 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32838; /* gpr_multi_push_up_to_s6_si */

        case 1:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -64L
              || pattern765 (x1, 
E_DImode) != 0
              || !(
#line 1272 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32839; /* gpr_multi_push_up_to_s6_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  if (pattern115 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern427 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 8);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern752 (x1))
        {
        case 0:
          switch (pattern760 (x1, 
E_SImode))
            {
            case 0:
              if (pattern776 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern784 (x1, 
E_SImode) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 10);
              x7 = XEXP (x6, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
                return -1;
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 8
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XVECEXP (x1, 0, 11);
              if (pattern790 (x11) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              if (pattern795 (x12, 
E_SImode) != 0
                  || !(
#line 303 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32772; /* gpr_multi_pop_up_to_s9_si */

            case 1:
              if (pattern776 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern785 (x1, 
E_SImode) != 0
                  || !(
#line 575 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32792; /* gpr_multi_popret_up_to_s7_si */

            case 2:
              if (!(
#line 882 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 32812; /* gpr_multi_popretz_up_to_s5_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern760 (x1, 
E_DImode))
            {
            case 0:
              if (pattern778 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern784 (x1, 
E_DImode) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 10);
              x7 = XEXP (x6, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != CONST_INT
                  || XWINT (x9, 0) != -80L)
                return -1;
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 8
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XVECEXP (x1, 0, 11);
              if (pattern792 (x11) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              if (pattern795 (x12, 
E_DImode) != 0
                  || !(
#line 303 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32773; /* gpr_multi_pop_up_to_s9_di */

            case 1:
              if (pattern778 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern785 (x1, 
E_DImode) != 0
                  || !(
#line 575 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32793; /* gpr_multi_popret_up_to_s7_di */

            case 2:
              if (!(
#line 882 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 32813; /* gpr_multi_popretz_up_to_s5_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern390 (x1, 
24, 
25) != 0
          || pattern537 (x1, 
19, 
20, 
21, 
22, 
23) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 7);
      if (pattern748 (x13, 
18) != 0
          || pattern759 (x1, 
8, 
9) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x6) != SET
          || pattern767 (x6, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x11) != SET)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 2)
        return -1;
      x16 = XEXP (x14, 1);
      operands[0] = x16;
      if (!stack_push_up_to_s9_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern772 (x1))
        {
        case 0:
          if (pattern781 (x1, 
E_SImode) != 0
              || !(
#line 1386 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32844; /* gpr_multi_push_up_to_s9_si */

        case 1:
          if (pattern781 (x1, 
E_DImode) != 0
              || !(
#line 1386 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32845; /* gpr_multi_push_up_to_s9_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1524 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern116 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode)
    return -1;
  switch (pattern752 (x1))
    {
    case 0:
      x7 = XVECEXP (x1, 0, 8);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (XWINT (x10, 0) != -32L)
        return -1;
      switch (pattern764 (x1, 
E_SImode))
        {
        case 0:
          x11 = XEXP (x2, 1);
          if (pattern774 (x11) != 0
              || REGNO (x3) != 8)
            return -1;
          x12 = XVECEXP (x1, 0, 10);
          if (pattern787 (x12) != 0
              || !(
#line 615 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32794; /* gpr_multi_popret_up_to_s8_si */

        case 1:
          if (!(
#line 919 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 32814; /* gpr_multi_popretz_up_to_s6_si */

        default:
          return -1;
        }

    case 1:
      x7 = XVECEXP (x1, 0, 8);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      x10 = XEXP (x9, 1);
      if (XWINT (x10, 0) != -64L)
        return -1;
      switch (pattern764 (x1, 
E_DImode))
        {
        case 0:
          x11 = XEXP (x2, 1);
          if (pattern777 (x11) != 0
              || REGNO (x3) != 8)
            return -1;
          x12 = XVECEXP (x1, 0, 10);
          if (pattern788 (x12) != 0
              || !(
#line 615 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32795; /* gpr_multi_popret_up_to_s8_di */

        case 1:
          if (!(
#line 919 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 32815; /* gpr_multi_popretz_up_to_s6_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_1459 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_1463 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_1461 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_1493 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_1489 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_1477 (x1, insn, pnum_clobbers);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      return recog_29 (x1, insn, pnum_clobbers);

    case UDIV:
      return recog_1484 (x1, insn, pnum_clobbers);

    case MOD:
      return recog_1483 (x1, insn, pnum_clobbers);

    case UMOD:
      return recog_1482 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_1491 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_1495 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_1490 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_1468 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_1472 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_1471 (x1, insn, pnum_clobbers);

    case AND:
      return recog_1485 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_1475 (x1, insn, pnum_clobbers);

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_94 (x1, insn, pnum_clobbers);

        case ASHIFT:
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern226 (x2))
                {
                case 0:
                  if (!(
#line 2978 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 325; /* xor_shift_reversesi */

                case 1:
                  if (!(
#line 2978 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 328; /* xor_shift_reversedi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x6, 0) != 1L)
                return -1;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              switch (pattern287 (x2))
                {
                case 0:
                  if ((
#line 587 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 563; /* *binvsi */
                  break;

                case 1:
                  if ((
#line 587 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 565; /* *binvdi */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x7) != SUBREG)
                return -1;
              switch (pattern330 (x2))
                {
                case 0:
                  if (!(
#line 600 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 567; /* *binvsi_mask */

                case 1:
                  if (!(
#line 600 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 569; /* *binvdi_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern194 (x2, pnum_clobbers))
            {
            case 0:
              if ((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 580; /* *bitmanip.md:673 */
                }
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 584; /* *bitmanip.md:673 */

            case 1:
              if ((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 588; /* *bitmanip.md:699 */
                }
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 592; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern194 (x2, pnum_clobbers))
            {
            case 0:
              if ((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 582; /* *bitmanip.md:673 */
                }
              if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 586; /* *bitmanip.md:673 */

            case 1:
              if ((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 590; /* *bitmanip.md:699 */
                }
              if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 594; /* *bitmanip.md:699 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_1476 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_1466 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_1492 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_1467 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_1488 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_1470 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_1469 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_1465 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_1464 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern321 (x2, 
E_SImode) != 0
              || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return -1;
          return 272; /* *lowsi */

        case E_DImode:
          if (pattern321 (x2, 
E_DImode) != 0
              || !
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return -1;
          return 273; /* *lowdi */

        default:
          return -1;
        }

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern265 (x2))
            {
            case 0:
              return 302; /* *ashlsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 308; /* *ashlsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 305; /* *ashldi3_mask_1 */

            case 3:
              if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 311; /* *ashldi3_mask_1 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_QImode))
            {
              switch (pattern332 (x2))
                {
                case 0:
                  if ((
#line 608 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 570; /* *bsetsi_1 */
                  break;

                case 1:
                  if ((
#line 608 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 571; /* *bsetdi_1 */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_QImode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != AND)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern416 (x2, 
E_SImode) != 0
                  || !const_si_mask_operand (operands[2], E_VOIDmode)
                  || !(
#line 781 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 603; /* *bsetsi_1_mask */

            case E_DImode:
              if (pattern416 (x2, 
E_DImode) != 0
                  || !const_di_mask_operand (operands[2], E_VOIDmode)
                  || !(
#line 781 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 604; /* *bsetdi_1_mask */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          return recog_364 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern104 (x1, 
SIGN_EXTEND))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_365 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern265 (x2))
            {
            case 0:
              return 303; /* *ashrsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 309; /* *ashrsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 306; /* *ashrdi3_mask_1 */

            case 3:
              if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 312; /* *ashrdi3_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 262 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32856; /* riscv_cv_mac_mulsN */

        case 2:
          if (!
#line 281 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32857; /* riscv_cv_mac_mulhhsN */

        case 3:
          if (!
#line 352 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32860; /* riscv_cv_mac_mulsRN */

        case 4:
          if (!
#line 433 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32864; /* riscv_cv_mac_macsN */

        case 5:
          if (!
#line 377 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32861; /* riscv_cv_mac_mulhhsRN */

        case 6:
          if (!
#line 453 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32865; /* riscv_cv_mac_machhsN */

        case 7:
          if (!
#line 530 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32868; /* riscv_cv_mac_macsRN */

        case 8:
          if (!
#line 557 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32869; /* riscv_cv_mac_machhsRN */

        case 9:
          if (!
#line 709 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32882; /* riscv_cv_alu_addN */

        case 10:
          if (!
#line 748 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32884; /* riscv_cv_alu_addRN */

        case 11:
          if (!
#line 826 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32888; /* riscv_cv_alu_subRN */

        case 12:
          if (!
#line 787 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32886; /* riscv_cv_alu_subN */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern104 (x1, 
ZERO_EXTEND))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          res = recog_366 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!subreg_lowpart_operator (x5, E_VOIDmode))
            return -1;
          switch (pattern265 (x2))
            {
            case 0:
              return 304; /* *lshrsi3_mask_1 */

            case 1:
              if (!
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 310; /* *lshrsi3_mask_1 */

            case 2:
              if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 307; /* *lshrdi3_mask_1 */

            case 3:
              if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 313; /* *lshrdi3_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 226 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32854; /* riscv_cv_mac_muluN */

        case 2:
          if (!
#line 245 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32855; /* riscv_cv_mac_mulhhuN */

        case 3:
          if (!
#line 304 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32858; /* riscv_cv_mac_muluRN */

        case 4:
          if (!
#line 395 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32862; /* riscv_cv_mac_macuN */

        case 5:
          if (!
#line 329 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32859; /* riscv_cv_mac_mulhhuRN */

        case 6:
          if (!
#line 415 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32863; /* riscv_cv_mac_machhuN */

        case 7:
          if (!
#line 478 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32866; /* riscv_cv_mac_macuRN */

        case 8:
          if (!
#line 505 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
            return -1;
          return 32867; /* riscv_cv_mac_machhuRN */

        case 9:
          if (!
#line 725 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32883; /* riscv_cv_alu_adduN */

        case 10:
          if (!
#line 771 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32885; /* riscv_cv_alu_adduRN */

        case 11:
          if (!
#line 849 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32889; /* riscv_cv_alu_subuRN */

        case 12:
          if (!
#line 803 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32887; /* riscv_cv_alu_subuN */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (
#line 3015 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && (INTVAL (operands[3]) > 0)
    && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            return 330; /* *lshrsi3_extend_2 */
          if (pnum_clobbers != NULL
              && (
#line 3050 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 335; /* *extractdi3 */
            }
          if (!(
#line 53 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 857; /* *th_extdi4 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 3050 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))))
            {
              *pnum_clobbers = 1;
              return 333; /* *extractsi3 */
            }
          if (!
#line 53 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB))
            return -1;
          return 856; /* *th_extsi4 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          res = recog_367 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (XWINT (x5, 0) == 1L)
        {
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              if (register_operand (operands[2], E_QImode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern402 (x2, 
E_SImode) == 0
                          && (
#line 905 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                        return 618; /* *bextsi */
                      break;

                    case E_DImode:
                      if (pattern402 (x2, 
E_DImode) == 0
                          && (
#line 905 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 619; /* *bextdi */
                      break;

                    default:
                      break;
                    }
                }
              break;

            case REG:
            case SUBREG:
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern388 (x2, 
E_SImode) == 0
                      && (
#line 972 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 624; /* *bextsi */
                  break;

                case E_DImode:
                  if (pattern388 (x2, 
E_DImode) == 0
                      && (
#line 972 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 625; /* *bextdi */
                  break;

                default:
                  break;
                }
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x11;
              if (immediate_operand (operands[2], E_VOIDmode))
                {
                  switch (pattern107 (x2))
                    {
                    case 0:
                      if ((
#line 981 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                        return 626; /* *bexti */
                      break;

                    case 1:
                      if ((
#line 981 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 627; /* *bexti */
                      break;

                    default:
                      break;
                    }
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x11 = XEXP (x2, 2);
          operands[3] = x11;
          if (const_int_operand (operands[3], E_VOIDmode))
            {
              switch (pattern107 (x2))
                {
                case 0:
                  if (
#line 88 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB
   && (UINTVAL (operands[2]) + UINTVAL (operands[3])
       <= GET_MODE_BITSIZE (SImode))))
                    return 864; /* *th_extusi4 */
                  break;

                case 1:
                  if ((
#line 88 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB
   && (UINTVAL (operands[2]) + UINTVAL (operands[3])
       <= GET_MODE_BITSIZE (DImode))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 865; /* *th_extudi4 */
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (pattern107 (x2))
        {
        case 0:
          if (!(
#line 151 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 875; /* *th_tstsi3 */

        case 1:
          if (!(
#line 151 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBS && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 876; /* *th_tstdi3 */

        default:
          return -1;
        }

    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      return recog_1494 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_1460 (x1, insn, pnum_clobbers);

    case NE:
      switch (pattern106 (x1, 
0))
        {
        case 0:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 414; /* *sne_zero_sisi */

        case 1:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 415; /* *sne_zero_disi */

        case 2:
          if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 416; /* *sne_zero_didi */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern215 (x2))
        {
        case 0:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 418; /* *sgtu_sisi */

        case 1:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 420; /* *sgtu_disi */

        case 2:
          if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 422; /* *sgtu_didi */

        default:
          return -1;
        }

    case GEU:
      switch (pattern106 (x1, 
1))
        {
        case 0:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 424; /* *sgeu_sisi */

        case 1:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 426; /* *sgeu_disi */

        case 2:
          if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 428; /* *sgeu_didi */

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern264 (x2))
        {
        case 0:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 430; /* sltu_sisi3 */

        case 1:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 432; /* sltu_disi3 */

        case 2:
          if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 434; /* sltu_didi3 */

        default:
          return -1;
        }

    case LEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern216 (x2))
        {
        case 0:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          return 436; /* *sleu_sisi */

        case 1:
          if (!
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 438; /* *sleu_disi */

        case 2:
          if (!
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 440; /* *sleu_didi */

        case 3:
          if (!
#line 581 "../../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
            return -1;
          return 32871; /* riscv_cv_alu_sletu */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_1474 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_1480 (x1, insn, pnum_clobbers);

    case CTZ:
      return recog_1481 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      return recog_1462 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern107 (x2))
        {
        case 0:
          if (arith_operand (operands[2], E_QImode)
              && 
#line 342 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return 532; /* *rotrsi3 */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 38 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || SImode == SImode)))
            return 854; /* *th_srrisi3 */
          break;

        case 1:
          if (arith_operand (operands[2], E_QImode)
              && 
#line 370 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return 533; /* *rotrdi3 */
          if (const_int_operand (operands[2], E_VOIDmode)
              && (
#line 38 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || DImode == SImode)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 855; /* *th_srridi3 */
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x5, E_VOIDmode))
        return -1;
      switch (pattern265 (x2))
        {
        case 0:
          if (!
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return -1;
          return 539; /* *rotrsi3_mask */

        case 1:
          if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 543; /* *rotrsi3_mask */

        case 2:
          if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 541; /* *rotrdi3_mask */

        case 3:
          if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 545; /* *rotrdi3_mask */

        default:
          return -1;
        }

    case ROTATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (register_operand (operands[2], E_QImode))
        {
          switch (pattern107 (x2))
            {
            case 0:
              if (
#line 386 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
                return 535; /* *rotlsi3 */
              break;

            case 1:
              if (
#line 412 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
                return 536; /* rotldi3 */
              break;

            default:
              break;
            }
        }
      if (!subreg_lowpart_operator (x5, E_VOIDmode))
        return -1;
      switch (pattern265 (x2))
        {
        case 0:
          if (!
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
            return -1;
          return 538; /* *rotlsi3_mask */

        case 1:
          if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 31 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 542; /* *rotlsi3_mask */

        case 2:
          if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 540; /* *rotldi3_mask */

        case 3:
          if (!(
#line 432 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 544; /* *rotldi3_mask */

        default:
          return -1;
        }

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern107 (x2))
        {
        case 0:
          if ((
#line 491 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return 552; /* *bswapsi2 */
          if (!
#line 129 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || SImode == SImode)))
            return -1;
          return 871; /* th_revsi2 */

        case 1:
          if ((
#line 491 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 553; /* *bswapdi2 */
          if (!(
#line 129 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && (TARGET_64BIT || DImode == SImode)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 872; /* th_revdi2 */

        default:
          return -1;
        }

    case UMIN:
      return recog_1479 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_1478 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_1473 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      return recog_1487 (x1, insn, pnum_clobbers);

    case UMUL_HIGHPART:
      return recog_1486 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern280 (x2, 
E_HImode))
        {
        case 0:
          if ((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_8 (insn, operands);
          if ((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_191 (insn, operands);
          break;

        case 1:
          if ((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_11 (insn, operands);
          if ((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_194 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_SImode:
      switch (pattern280 (x2, 
E_SImode))
        {
        case 0:
          if ((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_9 (insn, operands);
          if ((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_192 (insn, operands);
          break;

        case 1:
          if ((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 1975 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_12 (insn, operands);
          if ((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 559 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_195 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_DImode:
      switch (pattern280 (x2, 
E_DImode))
        {
        case 0:
          if (((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1975 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_10 (insn, operands);
          if (((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 559 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_193 (insn, operands);
          break;

        case 1:
          if (((
#line 1971 "../../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1975 "../../../gcc/config/riscv/riscv.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_13 (insn, operands);
          if (((
#line 551 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 559 "../../../gcc/config/riscv/thead.md"
( reload_completed
   && REG_P (operands[1])
   && !paradoxical_subreg_p (operands[0]))))
            return gen_split_196 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM8HImode:
      if (register_operand (operands[0], E_RVVM8HImode)
          && GET_MODE (x2) == E_RVVM8HImode
          && register_operand (operands[1], E_RVVM4QImode)
          && (
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4149 (insn, operands);
      break;

    case E_RVVM4HImode:
      if (register_operand (operands[0], E_RVVM4HImode)
          && GET_MODE (x2) == E_RVVM4HImode
          && register_operand (operands[1], E_RVVM2QImode)
          && (
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4151 (insn, operands);
      break;

    case E_RVVM2HImode:
      if (register_operand (operands[0], E_RVVM2HImode)
          && GET_MODE (x2) == E_RVVM2HImode
          && register_operand (operands[1], E_RVVM1QImode)
          && (
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4153 (insn, operands);
      break;

    case E_RVVM1HImode:
      if (register_operand (operands[0], E_RVVM1HImode)
          && GET_MODE (x2) == E_RVVM1HImode
          && register_operand (operands[1], E_RVVMF2QImode)
          && (
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4155 (insn, operands);
      break;

    case E_RVVMF2HImode:
      if (register_operand (operands[0], E_RVVMF2HImode)
          && GET_MODE (x2) == E_RVVMF2HImode
          && register_operand (operands[1], E_RVVMF4QImode)
          && (
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4157 (insn, operands);
      break;

    case E_RVVMF4HImode:
      if (register_operand (operands[0], E_RVVMF4HImode)
          && GET_MODE (x2) == E_RVVMF4HImode
          && register_operand (operands[1], E_RVVMF8QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4159 (insn, operands);
      break;

    case E_RVVM8SImode:
      switch (pattern291 (x2))
        {
        case 0:
          if ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4161 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4245 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM4SImode:
      switch (pattern292 (x2))
        {
        case 0:
          if ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4163 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4247 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM2SImode:
      switch (pattern293 (x2))
        {
        case 0:
          if ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4165 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4249 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM1SImode:
      switch (pattern294 (x2))
        {
        case 0:
          if ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4167 (insn, operands);
          break;

        case 1:
          if ((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4251 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVMF2SImode:
      switch (pattern295 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4169 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1092 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4253 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM8DImode:
      switch (pattern296 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4171 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4255 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4305 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM4DImode:
      switch (pattern297 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4173 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1094 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4257 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1137 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4307 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM2DImode:
      switch (pattern298 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4175 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4259 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4309 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_RVVM1DImode:
      switch (pattern299 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4177 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4261 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1138 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4311 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1HImode:
      if (register_operand (operands[0], E_V1HImode)
          && GET_MODE (x2) == E_V1HImode
          && register_operand (operands[1], E_V1QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4179 (insn, operands);
      break;

    case E_V2HImode:
      if (register_operand (operands[0], E_V2HImode)
          && GET_MODE (x2) == E_V2HImode
          && register_operand (operands[1], E_V2QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4181 (insn, operands);
      break;

    case E_V4HImode:
      if (register_operand (operands[0], E_V4HImode)
          && GET_MODE (x2) == E_V4HImode
          && register_operand (operands[1], E_V4QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4183 (insn, operands);
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && GET_MODE (x2) == E_V8HImode
          && register_operand (operands[1], E_V8QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4185 (insn, operands);
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && GET_MODE (x2) == E_V16HImode
          && register_operand (operands[1], E_V16QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4187 (insn, operands);
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && GET_MODE (x2) == E_V32HImode
          && register_operand (operands[1], E_V32QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4189 (insn, operands);
      break;

    case E_V64HImode:
      if (register_operand (operands[0], E_V64HImode)
          && GET_MODE (x2) == E_V64HImode
          && register_operand (operands[1], E_V64QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4191 (insn, operands);
      break;

    case E_V128HImode:
      if (register_operand (operands[0], E_V128HImode)
          && GET_MODE (x2) == E_V128HImode
          && register_operand (operands[1], E_V128QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4193 (insn, operands);
      break;

    case E_V256HImode:
      if (register_operand (operands[0], E_V256HImode)
          && GET_MODE (x2) == E_V256HImode
          && register_operand (operands[1], E_V256QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4195 (insn, operands);
      break;

    case E_V512HImode:
      if (register_operand (operands[0], E_V512HImode)
          && GET_MODE (x2) == E_V512HImode
          && register_operand (operands[1], E_V512QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4197 (insn, operands);
      break;

    case E_V1024HImode:
      if (register_operand (operands[0], E_V1024HImode)
          && GET_MODE (x2) == E_V1024HImode
          && register_operand (operands[1], E_V1024QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4199 (insn, operands);
      break;

    case E_V2048HImode:
      if (register_operand (operands[0], E_V2048HImode)
          && GET_MODE (x2) == E_V2048HImode
          && register_operand (operands[1], E_V2048QImode)
          && ((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_4201 (insn, operands);
      break;

    case E_V1SImode:
      switch (pattern300 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4203 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1097 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4263 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V2SImode:
      switch (pattern301 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4205 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1098 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4265 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V4SImode:
      switch (pattern302 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4207 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1099 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4267 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V8SImode:
      switch (pattern303 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4209 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1100 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4269 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V16SImode:
      switch (pattern304 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4211 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1101 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4271 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V32SImode:
      switch (pattern305 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4213 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1102 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4273 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V64SImode:
      switch (pattern306 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4215 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1103 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4275 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V128SImode:
      switch (pattern307 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4217 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1104 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4277 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V256SImode:
      switch (pattern308 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4219 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1105 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4279 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V512SImode:
      switch (pattern309 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4221 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4281 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1024SImode:
      switch (pattern310 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4223 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1107 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4283 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V1DImode:
      switch (pattern311 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4225 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4285 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1140 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4313 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V2DImode:
      switch (pattern312 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4227 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4287 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1141 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4315 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V4DImode:
      switch (pattern313 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4229 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1110 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4289 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1142 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4317 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V8DImode:
      switch (pattern314 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4231 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4291 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1143 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4319 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V16DImode:
      switch (pattern315 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4233 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4293 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1144 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4321 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V32DImode:
      switch (pattern316 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4235 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4295 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1145 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4323 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V64DImode:
      switch (pattern317 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4237 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4297 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1146 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4325 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V128DImode:
      switch (pattern318 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4239 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4299 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1147 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4327 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V256DImode:
      switch (pattern319 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4241 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4301 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1148 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4329 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case E_V512DImode:
      switch (pattern320 (x2))
        {
        case 0:
          if (((
#line 726 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 728 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4243 (insn, operands);
          break;

        case 1:
          if (((
#line 742 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 744 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4303 (insn, operands);
          break;

        case 2:
          if (((
#line 757 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1149 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 759 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return gen_split_4331 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x3) != SUBREG
      || pattern232 (x2) != 0)
    return NULL;
  if (vector_length_operand (operands[1], E_SImode)
      && ((
#line 1827 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1829 "../../../gcc/config/riscv/vector.md"
( 1)))
    return gen_split_2307 (insn, operands);
  if (!vector_length_operand (operands[1], E_DImode)
      || !((
#line 1827 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1829 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2308 (insn, operands);
}

 rtx_insn *
split_117 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern447 (x2))
    {
    case 0:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_488 (insn, operands);

    case 1:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_489 (insn, operands);

    case 2:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_490 (insn, operands);

    case 3:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_491 (insn, operands);

    case 4:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_492 (insn, operands);

    case 5:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_493 (insn, operands);

    case 6:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_494 (insn, operands);

    case 7:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_495 (insn, operands);

    case 8:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_496 (insn, operands);

    case 9:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_497 (insn, operands);

    case 10:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_498 (insn, operands);

    case 11:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_499 (insn, operands);

    case 12:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_500 (insn, operands);

    case 13:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_501 (insn, operands);

    case 14:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_502 (insn, operands);

    case 15:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_503 (insn, operands);

    case 16:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_504 (insn, operands);

    case 17:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_505 (insn, operands);

    case 18:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_506 (insn, operands);

    case 19:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_507 (insn, operands);

    case 20:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_508 (insn, operands);

    case 21:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_509 (insn, operands);

    case 22:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_510 (insn, operands);

    case 23:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_511 (insn, operands);

    case 24:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_512 (insn, operands);

    case 25:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_513 (insn, operands);

    case 26:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_514 (insn, operands);

    case 27:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_515 (insn, operands);

    case 28:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_516 (insn, operands);

    case 29:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_517 (insn, operands);

    case 30:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_518 (insn, operands);

    case 31:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_519 (insn, operands);

    case 32:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_520 (insn, operands);

    case 33:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_521 (insn, operands);

    case 34:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_522 (insn, operands);

    case 35:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_523 (insn, operands);

    case 36:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_524 (insn, operands);

    case 37:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_525 (insn, operands);

    case 38:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_526 (insn, operands);

    case 39:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_527 (insn, operands);

    case 40:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_528 (insn, operands);

    case 41:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_529 (insn, operands);

    case 42:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_530 (insn, operands);

    case 43:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_531 (insn, operands);

    case 44:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_532 (insn, operands);

    case 45:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_533 (insn, operands);

    case 46:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_534 (insn, operands);

    case 47:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_535 (insn, operands);

    case 48:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_536 (insn, operands);

    case 49:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_537 (insn, operands);

    case 50:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_538 (insn, operands);

    case 51:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_539 (insn, operands);

    case 52:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_540 (insn, operands);

    case 53:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_541 (insn, operands);

    case 54:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_542 (insn, operands);

    case 55:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_543 (insn, operands);

    case 56:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_544 (insn, operands);

    case 57:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_545 (insn, operands);

    case 58:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_546 (insn, operands);

    case 59:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_547 (insn, operands);

    case 60:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_548 (insn, operands);

    case 61:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_549 (insn, operands);

    case 62:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_550 (insn, operands);

    case 63:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_551 (insn, operands);

    case 64:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_552 (insn, operands);

    case 65:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_553 (insn, operands);

    case 66:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_554 (insn, operands);

    case 67:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_555 (insn, operands);

    case 68:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_556 (insn, operands);

    case 69:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_557 (insn, operands);

    case 70:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_558 (insn, operands);

    case 71:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_559 (insn, operands);

    case 72:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_560 (insn, operands);

    case 73:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_561 (insn, operands);

    case 74:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_562 (insn, operands);

    case 75:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_563 (insn, operands);

    case 76:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_564 (insn, operands);

    case 77:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_565 (insn, operands);

    case 78:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_566 (insn, operands);

    case 79:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_567 (insn, operands);

    case 80:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_568 (insn, operands);

    case 81:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_569 (insn, operands);

    case 82:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_570 (insn, operands);

    case 83:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_571 (insn, operands);

    case 84:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_572 (insn, operands);

    case 85:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_573 (insn, operands);

    case 86:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_574 (insn, operands);

    case 87:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_575 (insn, operands);

    case 88:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_576 (insn, operands);

    case 89:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_577 (insn, operands);

    case 90:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_578 (insn, operands);

    case 91:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_579 (insn, operands);

    case 92:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_580 (insn, operands);

    case 93:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_581 (insn, operands);

    case 94:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_582 (insn, operands);

    case 95:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_583 (insn, operands);

    case 96:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_584 (insn, operands);

    case 97:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 269 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_585 (insn, operands);

    case 98:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 270 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_586 (insn, operands);

    case 99:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 271 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_587 (insn, operands);

    case 100:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_588 (insn, operands);

    case 101:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_589 (insn, operands);

    case 102:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_590 (insn, operands);

    case 103:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_591 (insn, operands);

    case 104:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_592 (insn, operands);

    case 105:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_593 (insn, operands);

    case 106:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_594 (insn, operands);

    case 107:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_595 (insn, operands);

    case 108:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_596 (insn, operands);

    case 109:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_597 (insn, operands);

    case 110:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_598 (insn, operands);

    case 111:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_599 (insn, operands);

    case 112:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_600 (insn, operands);

    case 113:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_601 (insn, operands);

    case 114:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_602 (insn, operands);

    case 115:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_603 (insn, operands);

    case 116:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_604 (insn, operands);

    case 117:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_605 (insn, operands);

    case 118:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_606 (insn, operands);

    case 119:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1153 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_607 (insn, operands);

    case 120:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_608 (insn, operands);

    case 121:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_609 (insn, operands);

    case 122:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_610 (insn, operands);

    case 123:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_611 (insn, operands);

    case 124:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_612 (insn, operands);

    case 125:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_613 (insn, operands);

    case 126:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_614 (insn, operands);

    case 127:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_615 (insn, operands);

    case 128:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_616 (insn, operands);

    case 129:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_617 (insn, operands);

    case 130:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1164 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_618 (insn, operands);

    case 131:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1165 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_619 (insn, operands);

    case 132:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1166 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_620 (insn, operands);

    case 133:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_621 (insn, operands);

    case 134:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_622 (insn, operands);

    case 135:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_623 (insn, operands);

    case 136:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_624 (insn, operands);

    case 137:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_625 (insn, operands);

    case 138:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_626 (insn, operands);

    case 139:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_627 (insn, operands);

    case 140:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_628 (insn, operands);

    case 141:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_629 (insn, operands);

    case 142:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_630 (insn, operands);

    case 143:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_631 (insn, operands);

    case 144:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_632 (insn, operands);

    case 145:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_633 (insn, operands);

    case 146:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_634 (insn, operands);

    case 147:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_635 (insn, operands);

    case 148:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_636 (insn, operands);

    case 149:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_637 (insn, operands);

    case 150:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_638 (insn, operands);

    case 151:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_639 (insn, operands);

    case 152:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_640 (insn, operands);

    case 153:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_641 (insn, operands);

    case 154:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_642 (insn, operands);

    case 155:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_643 (insn, operands);

    case 156:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_644 (insn, operands);

    case 157:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_645 (insn, operands);

    case 158:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_646 (insn, operands);

    case 159:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_647 (insn, operands);

    case 160:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_648 (insn, operands);

    case 161:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_649 (insn, operands);

    case 162:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_650 (insn, operands);

    case 163:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_651 (insn, operands);

    case 164:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_652 (insn, operands);

    case 165:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_653 (insn, operands);

    case 166:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_654 (insn, operands);

    case 167:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_655 (insn, operands);

    case 168:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_656 (insn, operands);

    case 169:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_657 (insn, operands);

    case 170:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_658 (insn, operands);

    case 171:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_659 (insn, operands);

    case 172:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_660 (insn, operands);

    case 173:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_661 (insn, operands);

    case 174:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_662 (insn, operands);

    case 175:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_663 (insn, operands);

    case 176:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_664 (insn, operands);

    case 177:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_665 (insn, operands);

    case 178:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_666 (insn, operands);

    case 179:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_667 (insn, operands);

    case 180:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_668 (insn, operands);

    case 181:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_669 (insn, operands);

    case 182:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_670 (insn, operands);

    case 183:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_671 (insn, operands);

    case 184:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_672 (insn, operands);

    case 185:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_673 (insn, operands);

    case 186:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_674 (insn, operands);

    case 187:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_675 (insn, operands);

    case 188:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_676 (insn, operands);

    case 189:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_677 (insn, operands);

    case 190:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_678 (insn, operands);

    case 191:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_679 (insn, operands);

    case 192:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_680 (insn, operands);

    case 193:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_681 (insn, operands);

    case 194:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_682 (insn, operands);

    case 195:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_683 (insn, operands);

    case 196:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1233 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_684 (insn, operands);

    case 197:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1234 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_685 (insn, operands);

    case 198:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1235 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_686 (insn, operands);

    case 199:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1236 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_687 (insn, operands);

    case 200:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1237 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_688 (insn, operands);

    case 201:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1238 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_689 (insn, operands);

    case 202:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1239 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_690 (insn, operands);

    case 203:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1240 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_691 (insn, operands);

    case 204:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1241 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_692 (insn, operands);

    case 205:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1242 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_693 (insn, operands);

    case 206:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1243 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_694 (insn, operands);

    case 207:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1244 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_695 (insn, operands);

    case 208:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1245 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_696 (insn, operands);

    case 209:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1246 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_697 (insn, operands);

    case 210:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_698 (insn, operands);

    case 211:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_699 (insn, operands);

    case 212:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_700 (insn, operands);

    case 213:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_701 (insn, operands);

    case 214:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_702 (insn, operands);

    case 215:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_703 (insn, operands);

    case 216:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_704 (insn, operands);

    case 217:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_705 (insn, operands);

    case 218:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_706 (insn, operands);

    case 219:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_707 (insn, operands);

    case 220:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_708 (insn, operands);

    case 221:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_709 (insn, operands);

    case 222:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_710 (insn, operands);

    case 223:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_711 (insn, operands);

    case 224:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_712 (insn, operands);

    case 225:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_713 (insn, operands);

    case 226:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_714 (insn, operands);

    case 227:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_715 (insn, operands);

    case 228:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_716 (insn, operands);

    case 229:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_717 (insn, operands);

    case 230:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_718 (insn, operands);

    case 231:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_719 (insn, operands);

    case 232:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_720 (insn, operands);

    case 233:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_721 (insn, operands);

    case 234:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_722 (insn, operands);

    case 235:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_723 (insn, operands);

    case 236:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_724 (insn, operands);

    case 237:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_725 (insn, operands);

    case 238:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_726 (insn, operands);

    case 239:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_727 (insn, operands);

    case 240:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1280 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_728 (insn, operands);

    case 241:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1281 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_729 (insn, operands);

    case 242:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1282 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_730 (insn, operands);

    case 243:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1283 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_731 (insn, operands);

    case 244:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1284 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_732 (insn, operands);

    case 245:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1285 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_733 (insn, operands);

    case 246:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1286 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_734 (insn, operands);

    case 247:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1287 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_735 (insn, operands);

    case 248:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1288 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_736 (insn, operands);

    case 249:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1289 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_737 (insn, operands);

    case 250:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1290 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_738 (insn, operands);

    case 251:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1291 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_739 (insn, operands);

    case 252:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1292 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_740 (insn, operands);

    case 253:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1293 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_741 (insn, operands);

    case 254:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_742 (insn, operands);

    case 255:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_743 (insn, operands);

    case 256:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_744 (insn, operands);

    case 257:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_745 (insn, operands);

    case 258:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_746 (insn, operands);

    case 259:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_747 (insn, operands);

    case 260:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_748 (insn, operands);

    case 261:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_749 (insn, operands);

    case 262:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_750 (insn, operands);

    case 263:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_751 (insn, operands);

    case 264:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_752 (insn, operands);

    case 265:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_753 (insn, operands);

    case 266:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_754 (insn, operands);

    case 267:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_755 (insn, operands);

    case 268:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_756 (insn, operands);

    case 269:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_757 (insn, operands);

    case 270:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1313 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_758 (insn, operands);

    case 271:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1314 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_759 (insn, operands);

    case 272:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1315 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_760 (insn, operands);

    case 273:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1316 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_761 (insn, operands);

    case 274:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1317 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_762 (insn, operands);

    case 275:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1318 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_763 (insn, operands);

    case 276:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1319 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_764 (insn, operands);

    case 277:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_765 (insn, operands);

    case 278:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_766 (insn, operands);

    case 279:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_767 (insn, operands);

    case 280:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_768 (insn, operands);

    case 281:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_769 (insn, operands);

    case 282:
      if (!((
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_770 (insn, operands);

    case 283:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 121 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_771 (insn, operands);

    case 284:
      if (!((
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_772 (insn, operands);

    case 285:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_773 (insn, operands);

    case 286:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_774 (insn, operands);

    case 287:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_775 (insn, operands);

    case 288:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_776 (insn, operands);

    case 289:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_777 (insn, operands);

    case 290:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 146 "../../../gcc/config/riscv/thead-vector.md"
( REG_P (operands[0]) && REG_P (operands[1])
   && REGNO (operands[0]) == REGNO (operands[1]))))
        return NULL;
      return gen_split_778 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_132 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (pattern261 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return NULL;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return NULL;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return NULL;
  x8 = XVECEXP (x3, 0, 4);
  operands[7] = x8;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return NULL;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  switch (XINT (x3, 1))
    {
    case 158:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_125 (x1, insn);

    case 159:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_126 (x1, insn);

    case 160:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_127 (x1, insn);

    case 161:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_128 (x1, insn);

    case 162:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_129 (x1, insn);

    case 163:
      x10 = XEXP (x2, 1);
      operands[3] = x10;
      return split_130 (x1, insn);

    case 91:
      x10 = XEXP (x2, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x10;
          return split_131 (x1, insn);

        case VEC_DUPLICATE:
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern597 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2451 (insn, operands);

            case E_RVVM4QImode:
              if (pattern597 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2452 (insn, operands);

            case E_RVVM2QImode:
              if (pattern597 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2453 (insn, operands);

            case E_RVVM1QImode:
              if (pattern597 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2454 (insn, operands);

            case E_RVVM8HImode:
              if (pattern597 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2455 (insn, operands);

            case E_RVVM4HImode:
              if (pattern597 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2456 (insn, operands);

            case E_RVVM2HImode:
              if (pattern597 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2457 (insn, operands);

            case E_RVVM1HImode:
              if (pattern597 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2458 (insn, operands);

            case E_RVVM8SImode:
              if (pattern597 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2459 (insn, operands);

            case E_RVVM4SImode:
              if (pattern597 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2460 (insn, operands);

            case E_RVVM2SImode:
              if (pattern597 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2461 (insn, operands);

            case E_RVVM1SImode:
              if (pattern597 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
                  || !
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)))
                return NULL;
              return gen_split_2462 (insn, operands);

            case E_RVVM8DImode:
              if (pattern597 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2463 (insn, operands);

            case E_RVVM4DImode:
              if (pattern597 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2464 (insn, operands);

            case E_RVVM2DImode:
              if (pattern597 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2465 (insn, operands);

            case E_RVVM1DImode:
              if (pattern597 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2466 (insn, operands);

            case E_RVVMF2QImode:
              if (pattern597 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2467 (insn, operands);

            case E_RVVMF4QImode:
              if (pattern597 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2468 (insn, operands);

            case E_RVVMF8QImode:
              if (pattern597 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2469 (insn, operands);

            case E_RVVMF2HImode:
              if (pattern597 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
                return NULL;
              return gen_split_2470 (insn, operands);

            case E_RVVMF4HImode:
              if (pattern597 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2471 (insn, operands);

            case E_RVVMF2SImode:
              if (pattern597 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return NULL;
              return gen_split_2472 (insn, operands);

            case E_V1QImode:
              if (pattern597 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return NULL;
              return gen_split_2473 (insn, operands);

            case E_V2QImode:
              if (pattern597 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return NULL;
              return gen_split_2474 (insn, operands);

            case E_V4QImode:
              if (pattern597 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return NULL;
              return gen_split_2475 (insn, operands);

            case E_V8QImode:
              if (pattern597 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return NULL;
              return gen_split_2476 (insn, operands);

            case E_V16QImode:
              if (pattern597 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return NULL;
              return gen_split_2477 (insn, operands);

            case E_V32QImode:
              if (pattern597 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return NULL;
              return gen_split_2478 (insn, operands);

            case E_V64QImode:
              if (pattern597 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2479 (insn, operands);

            case E_V128QImode:
              if (pattern597 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2480 (insn, operands);

            case E_V256QImode:
              if (pattern597 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2481 (insn, operands);

            case E_V512QImode:
              if (pattern597 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2482 (insn, operands);

            case E_V1024QImode:
              if (pattern597 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2483 (insn, operands);

            case E_V2048QImode:
              if (pattern597 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2484 (insn, operands);

            case E_V4096QImode:
              if (pattern597 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], QImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (QImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2485 (insn, operands);

            case E_V1HImode:
              if (pattern597 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return NULL;
              return gen_split_2486 (insn, operands);

            case E_V2HImode:
              if (pattern597 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return NULL;
              return gen_split_2487 (insn, operands);

            case E_V4HImode:
              if (pattern597 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return NULL;
              return gen_split_2488 (insn, operands);

            case E_V8HImode:
              if (pattern597 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return NULL;
              return gen_split_2489 (insn, operands);

            case E_V16HImode:
              if (pattern597 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return NULL;
              return gen_split_2490 (insn, operands);

            case E_V32HImode:
              if (pattern597 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2491 (insn, operands);

            case E_V64HImode:
              if (pattern597 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2492 (insn, operands);

            case E_V128HImode:
              if (pattern597 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2493 (insn, operands);

            case E_V256HImode:
              if (pattern597 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2494 (insn, operands);

            case E_V512HImode:
              if (pattern597 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2495 (insn, operands);

            case E_V1024HImode:
              if (pattern597 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2496 (insn, operands);

            case E_V2048HImode:
              if (pattern597 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], HImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (HImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2497 (insn, operands);

            case E_V1SImode:
              if (pattern597 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return NULL;
              return gen_split_2498 (insn, operands);

            case E_V2SImode:
              if (pattern597 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return NULL;
              return gen_split_2499 (insn, operands);

            case E_V4SImode:
              if (pattern597 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return NULL;
              return gen_split_2500 (insn, operands);

            case E_V8SImode:
              if (pattern597 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return NULL;
              return gen_split_2501 (insn, operands);

            case E_V16SImode:
              if (pattern597 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2502 (insn, operands);

            case E_V32SImode:
              if (pattern597 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2503 (insn, operands);

            case E_V64SImode:
              if (pattern597 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2504 (insn, operands);

            case E_V128SImode:
              if (pattern597 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2505 (insn, operands);

            case E_V256SImode:
              if (pattern597 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2506 (insn, operands);

            case E_V512SImode:
              if (pattern597 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2507 (insn, operands);

            case E_V1024SImode:
              if (pattern597 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], SImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (SImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2508 (insn, operands);

            case E_V1DImode:
              if (pattern597 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2509 (insn, operands);

            case E_V2DImode:
              if (pattern597 (x2, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2510 (insn, operands);

            case E_V4DImode:
              if (pattern597 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_2511 (insn, operands);

            case E_V8DImode:
              if (pattern597 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return NULL;
              return gen_split_2512 (insn, operands);

            case E_V16DImode:
              if (pattern597 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return NULL;
              return gen_split_2513 (insn, operands);

            case E_V32DImode:
              if (pattern597 (x2, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return NULL;
              return gen_split_2514 (insn, operands);

            case E_V64DImode:
              if (pattern597 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return NULL;
              return gen_split_2515 (insn, operands);

            case E_V128DImode:
              if (pattern597 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return NULL;
              return gen_split_2516 (insn, operands);

            case E_V256DImode:
              if (pattern597 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return NULL;
              return gen_split_2517 (insn, operands);

            case E_V512DImode:
              if (pattern597 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0
                  || !(
#line 2219 "../../../gcc/config/riscv/vector.md"
((register_operand (operands[3], DImode)
  || CONST_POLY_INT_P (operands[3]))
  && GET_MODE_BITSIZE (DImode) > GET_MODE_BITSIZE (Pmode)) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return NULL;
              return gen_split_2518 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_136 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      return split_134 (x1, insn);

    case MULT:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 0);
          operands[3] = x4;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          return split_135 (x1, insn);

        case FLOAT_EXTEND:
          switch (pattern284 (x2))
            {
            case 0:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9518 (insn, operands);

            case 1:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9519 (insn, operands);

            case 2:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9520 (insn, operands);

            case 3:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9521 (insn, operands);

            case 4:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9522 (insn, operands);

            case 5:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9523 (insn, operands);

            case 6:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9524 (insn, operands);

            case 7:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9525 (insn, operands);

            case 8:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9526 (insn, operands);

            case 9:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9527 (insn, operands);

            case 10:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9528 (insn, operands);

            case 11:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9529 (insn, operands);

            case 12:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9530 (insn, operands);

            case 13:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9531 (insn, operands);

            case 14:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9532 (insn, operands);

            case 15:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9533 (insn, operands);

            case 16:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9534 (insn, operands);

            case 17:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9535 (insn, operands);

            case 18:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9536 (insn, operands);

            case 19:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9537 (insn, operands);

            case 20:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9538 (insn, operands);

            case 21:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9539 (insn, operands);

            case 22:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9540 (insn, operands);

            case 23:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9541 (insn, operands);

            case 24:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9542 (insn, operands);

            case 25:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9543 (insn, operands);

            case 26:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9544 (insn, operands);

            case 27:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9545 (insn, operands);

            case 28:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9546 (insn, operands);

            case 29:
              if (!((
#line 1052 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1054 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9547 (insn, operands);

            case 30:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9548 (insn, operands);

            case 31:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9549 (insn, operands);

            case 32:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9550 (insn, operands);

            case 33:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9551 (insn, operands);

            case 34:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9552 (insn, operands);

            case 35:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9553 (insn, operands);

            case 36:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9554 (insn, operands);

            case 37:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9555 (insn, operands);

            case 38:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9556 (insn, operands);

            case 39:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9557 (insn, operands);

            case 40:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9558 (insn, operands);

            case 41:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9559 (insn, operands);

            case 42:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9560 (insn, operands);

            case 43:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9561 (insn, operands);

            case 44:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9562 (insn, operands);

            case 45:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9563 (insn, operands);

            case 46:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9564 (insn, operands);

            case 47:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9565 (insn, operands);

            case 48:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9566 (insn, operands);

            case 49:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9567 (insn, operands);

            case 50:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9568 (insn, operands);

            case 51:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9569 (insn, operands);

            case 52:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9570 (insn, operands);

            case 53:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9571 (insn, operands);

            case 54:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9572 (insn, operands);

            case 55:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9573 (insn, operands);

            case 56:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9574 (insn, operands);

            case 57:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9575 (insn, operands);

            case 58:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9576 (insn, operands);

            case 59:
              if (!((
#line 1076 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1078 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9577 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern234 (x2))
        {
        case 0:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8420 (insn, operands);

        case 1:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8422 (insn, operands);

        case 2:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8424 (insn, operands);

        case 3:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8426 (insn, operands);

        case 4:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8428 (insn, operands);

        case 5:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8430 (insn, operands);

        case 6:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8432 (insn, operands);

        case 7:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8434 (insn, operands);

        case 8:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8436 (insn, operands);

        case 9:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8438 (insn, operands);

        case 10:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8440 (insn, operands);

        case 11:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8442 (insn, operands);

        case 12:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8444 (insn, operands);

        case 13:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8446 (insn, operands);

        case 14:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8448 (insn, operands);

        case 15:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8450 (insn, operands);

        case 16:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8452 (insn, operands);

        case 17:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8454 (insn, operands);

        case 18:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8456 (insn, operands);

        case 19:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8458 (insn, operands);

        case 20:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8460 (insn, operands);

        case 21:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8462 (insn, operands);

        case 22:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8464 (insn, operands);

        case 23:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8466 (insn, operands);

        case 24:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8468 (insn, operands);

        case 25:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8470 (insn, operands);

        case 26:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8472 (insn, operands);

        case 27:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8474 (insn, operands);

        case 28:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8476 (insn, operands);

        case 29:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8478 (insn, operands);

        case 30:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8480 (insn, operands);

        case 31:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8482 (insn, operands);

        case 32:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8484 (insn, operands);

        case 33:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8486 (insn, operands);

        case 34:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8488 (insn, operands);

        case 35:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8490 (insn, operands);

        case 36:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8492 (insn, operands);

        case 37:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8494 (insn, operands);

        case 38:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8496 (insn, operands);

        case 39:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8498 (insn, operands);

        case 40:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8500 (insn, operands);

        case 41:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8502 (insn, operands);

        case 42:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8504 (insn, operands);

        case 43:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8506 (insn, operands);

        case 44:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8508 (insn, operands);

        case 45:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8510 (insn, operands);

        case 46:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8512 (insn, operands);

        case 47:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8514 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern234 (x2))
        {
        case 0:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8421 (insn, operands);

        case 1:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8423 (insn, operands);

        case 2:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8425 (insn, operands);

        case 3:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8427 (insn, operands);

        case 4:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8429 (insn, operands);

        case 5:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8431 (insn, operands);

        case 6:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8433 (insn, operands);

        case 7:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8435 (insn, operands);

        case 8:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8437 (insn, operands);

        case 9:
          if (!(
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8439 (insn, operands);

        case 10:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 934 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8441 (insn, operands);

        case 11:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8443 (insn, operands);

        case 12:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 936 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8445 (insn, operands);

        case 13:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8447 (insn, operands);

        case 14:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 937 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8449 (insn, operands);

        case 15:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 939 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8451 (insn, operands);

        case 16:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 940 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8453 (insn, operands);

        case 17:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 941 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8455 (insn, operands);

        case 18:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8457 (insn, operands);

        case 19:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 943 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8459 (insn, operands);

        case 20:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 944 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8461 (insn, operands);

        case 21:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 945 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8463 (insn, operands);

        case 22:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8465 (insn, operands);

        case 23:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 947 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8467 (insn, operands);

        case 24:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8469 (insn, operands);

        case 25:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 949 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8471 (insn, operands);

        case 26:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8473 (insn, operands);

        case 27:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8475 (insn, operands);

        case 28:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 952 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8477 (insn, operands);

        case 29:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8479 (insn, operands);

        case 30:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8481 (insn, operands);

        case 31:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8483 (insn, operands);

        case 32:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8485 (insn, operands);

        case 33:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8487 (insn, operands);

        case 34:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8489 (insn, operands);

        case 35:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8491 (insn, operands);

        case 36:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8493 (insn, operands);

        case 37:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8495 (insn, operands);

        case 38:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8497 (insn, operands);

        case 39:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8499 (insn, operands);

        case 40:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8501 (insn, operands);

        case 41:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8503 (insn, operands);

        case 42:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8505 (insn, operands);

        case 43:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8507 (insn, operands);

        case 44:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8509 (insn, operands);

        case 45:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8511 (insn, operands);

        case 46:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8513 (insn, operands);

        case 47:
          if (!((
#line 629 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 631 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8515 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      switch (pattern235 (x2))
        {
        case 0:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8924 (insn, operands);

        case 1:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8925 (insn, operands);

        case 2:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8926 (insn, operands);

        case 3:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8927 (insn, operands);

        case 4:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8928 (insn, operands);

        case 5:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8929 (insn, operands);

        case 6:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8930 (insn, operands);

        case 7:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8931 (insn, operands);

        case 8:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8932 (insn, operands);

        case 9:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8933 (insn, operands);

        case 10:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8934 (insn, operands);

        case 11:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1020 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8935 (insn, operands);

        case 12:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1021 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8936 (insn, operands);

        case 13:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1022 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8937 (insn, operands);

        case 14:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8938 (insn, operands);

        case 15:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8939 (insn, operands);

        case 16:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8940 (insn, operands);

        case 17:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8941 (insn, operands);

        case 18:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8942 (insn, operands);

        case 19:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1028 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8943 (insn, operands);

        case 20:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8944 (insn, operands);

        case 21:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8945 (insn, operands);

        case 22:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1031 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8946 (insn, operands);

        case 23:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8947 (insn, operands);

        case 24:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8948 (insn, operands);

        case 25:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8949 (insn, operands);

        case 26:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8950 (insn, operands);

        case 27:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8951 (insn, operands);

        case 28:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8952 (insn, operands);

        case 29:
          if (!((
#line 763 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 765 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8953 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_150 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4537 (insn, operands);

    case 1:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4693 (insn, operands);

    case 2:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4539 (insn, operands);

    case 3:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4695 (insn, operands);

    case 4:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4885 (insn, operands);

    case 5:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4541 (insn, operands);

    case 6:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4697 (insn, operands);

    case 7:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4887 (insn, operands);

    case 8:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4543 (insn, operands);

    case 9:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4699 (insn, operands);

    case 10:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4889 (insn, operands);

    case 11:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4545 (insn, operands);

    case 12:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4701 (insn, operands);

    case 13:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4891 (insn, operands);

    case 14:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4547 (insn, operands);

    case 15:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4703 (insn, operands);

    case 16:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4893 (insn, operands);

    case 17:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4549 (insn, operands);

    case 18:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4705 (insn, operands);

    case 19:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4551 (insn, operands);

    case 20:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4707 (insn, operands);

    case 21:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4895 (insn, operands);

    case 22:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4553 (insn, operands);

    case 23:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4709 (insn, operands);

    case 24:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4897 (insn, operands);

    case 25:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4555 (insn, operands);

    case 26:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4711 (insn, operands);

    case 27:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4899 (insn, operands);

    case 28:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4557 (insn, operands);

    case 29:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4713 (insn, operands);

    case 30:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4901 (insn, operands);

    case 31:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4559 (insn, operands);

    case 32:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4715 (insn, operands);

    case 33:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4561 (insn, operands);

    case 34:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4717 (insn, operands);

    case 35:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4563 (insn, operands);

    case 36:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4719 (insn, operands);

    case 37:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4565 (insn, operands);

    case 38:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4721 (insn, operands);

    case 39:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4567 (insn, operands);

    case 40:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4723 (insn, operands);

    case 41:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4903 (insn, operands);

    case 42:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4569 (insn, operands);

    case 43:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4725 (insn, operands);

    case 44:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4905 (insn, operands);

    case 45:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4571 (insn, operands);

    case 46:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4727 (insn, operands);

    case 47:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4907 (insn, operands);

    case 48:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4573 (insn, operands);

    case 49:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4729 (insn, operands);

    case 50:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1053 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4909 (insn, operands);

    case 51:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4575 (insn, operands);

    case 52:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4731 (insn, operands);

    case 53:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1054 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4911 (insn, operands);

    case 54:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4577 (insn, operands);

    case 55:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4733 (insn, operands);

    case 56:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1055 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4913 (insn, operands);

    case 57:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4579 (insn, operands);

    case 58:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4735 (insn, operands);

    case 59:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4915 (insn, operands);

    case 60:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4581 (insn, operands);

    case 61:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4737 (insn, operands);

    case 62:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4917 (insn, operands);

    case 63:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4583 (insn, operands);

    case 64:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4739 (insn, operands);

    case 65:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1058 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4919 (insn, operands);

    case 66:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4585 (insn, operands);

    case 67:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4741 (insn, operands);

    case 68:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4921 (insn, operands);

    case 69:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4587 (insn, operands);

    case 70:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4743 (insn, operands);

    case 71:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4923 (insn, operands);

    case 72:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4589 (insn, operands);

    case 73:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4745 (insn, operands);

    case 74:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4591 (insn, operands);

    case 75:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4747 (insn, operands);

    case 76:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4925 (insn, operands);

    case 77:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4593 (insn, operands);

    case 78:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4749 (insn, operands);

    case 79:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4927 (insn, operands);

    case 80:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4595 (insn, operands);

    case 81:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4751 (insn, operands);

    case 82:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1063 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4929 (insn, operands);

    case 83:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4597 (insn, operands);

    case 84:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4753 (insn, operands);

    case 85:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4931 (insn, operands);

    case 86:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4599 (insn, operands);

    case 87:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4755 (insn, operands);

    case 88:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4933 (insn, operands);

    case 89:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4601 (insn, operands);

    case 90:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4757 (insn, operands);

    case 91:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4935 (insn, operands);

    case 92:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4603 (insn, operands);

    case 93:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4759 (insn, operands);

    case 94:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4937 (insn, operands);

    case 95:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4605 (insn, operands);

    case 96:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4761 (insn, operands);

    case 97:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4939 (insn, operands);

    case 98:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4607 (insn, operands);

    case 99:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4763 (insn, operands);

    case 100:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4941 (insn, operands);

    case 101:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4609 (insn, operands);

    case 102:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4765 (insn, operands);

    case 103:
      if (!((
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4943 (insn, operands);

    case 104:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4611 (insn, operands);

    case 105:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4767 (insn, operands);

    case 106:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4613 (insn, operands);

    case 107:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4769 (insn, operands);

    case 108:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4615 (insn, operands);

    case 109:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4771 (insn, operands);

    case 110:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4617 (insn, operands);

    case 111:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4773 (insn, operands);

    case 112:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4619 (insn, operands);

    case 113:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4775 (insn, operands);

    case 114:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4621 (insn, operands);

    case 115:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4777 (insn, operands);

    case 116:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4623 (insn, operands);

    case 117:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4779 (insn, operands);

    case 118:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4625 (insn, operands);

    case 119:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4781 (insn, operands);

    case 120:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4627 (insn, operands);

    case 121:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4783 (insn, operands);

    case 122:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4629 (insn, operands);

    case 123:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4785 (insn, operands);

    case 124:
      if (!((
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4631 (insn, operands);

    case 125:
      if (!((
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4787 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_156 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2597 (insn, operands);

    case 1:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2611 (insn, operands);

    case 2:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2625 (insn, operands);

    case 3:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2639 (insn, operands);

    case 4:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2653 (insn, operands);

    case 5:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2667 (insn, operands);

    case 6:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2681 (insn, operands);

    case 7:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2695 (insn, operands);

    case 8:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2709 (insn, operands);

    case 9:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2723 (insn, operands);

    case 10:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2737 (insn, operands);

    case 11:
      if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2751 (insn, operands);

    case 12:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2765 (insn, operands);

    case 13:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 127 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2779 (insn, operands);

    case 14:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2793 (insn, operands);

    case 15:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 128 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2807 (insn, operands);

    case 16:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2821 (insn, operands);

    case 17:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2835 (insn, operands);

    case 18:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 117 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2849 (insn, operands);

    case 19:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2863 (insn, operands);

    case 20:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 118 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2877 (insn, operands);

    case 21:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 119 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2891 (insn, operands);

    case 22:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 174 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2905 (insn, operands);

    case 23:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 175 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2919 (insn, operands);

    case 24:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2933 (insn, operands);

    case 25:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2947 (insn, operands);

    case 26:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2961 (insn, operands);

    case 27:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 179 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2975 (insn, operands);

    case 28:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2989 (insn, operands);

    case 29:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3003 (insn, operands);

    case 30:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 182 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3017 (insn, operands);

    case 31:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3031 (insn, operands);

    case 32:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3045 (insn, operands);

    case 33:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 185 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3059 (insn, operands);

    case 34:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 186 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3073 (insn, operands);

    case 35:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 187 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3087 (insn, operands);

    case 36:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3101 (insn, operands);

    case 37:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3115 (insn, operands);

    case 38:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3129 (insn, operands);

    case 39:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3143 (insn, operands);

    case 40:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3157 (insn, operands);

    case 41:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3171 (insn, operands);

    case 42:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3185 (insn, operands);

    case 43:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3199 (insn, operands);

    case 44:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3213 (insn, operands);

    case 45:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3227 (insn, operands);

    case 46:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3241 (insn, operands);

    case 47:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3255 (insn, operands);

    case 48:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3269 (insn, operands);

    case 49:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3283 (insn, operands);

    case 50:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3297 (insn, operands);

    case 51:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3311 (insn, operands);

    case 52:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3325 (insn, operands);

    case 53:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3339 (insn, operands);

    case 54:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3353 (insn, operands);

    case 55:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3367 (insn, operands);

    case 56:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3381 (insn, operands);

    case 57:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3395 (insn, operands);

    case 58:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3409 (insn, operands);

    case 59:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3423 (insn, operands);

    case 60:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3437 (insn, operands);

    case 61:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3451 (insn, operands);

    case 62:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3465 (insn, operands);

    case 63:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3479 (insn, operands);

    case 64:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3493 (insn, operands);

    case 65:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3507 (insn, operands);

    case 66:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3521 (insn, operands);

    case 67:
      if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3535 (insn, operands);

    case 68:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5556 (insn, operands);

    case 69:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5560 (insn, operands);

    case 70:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5564 (insn, operands);

    case 71:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5568 (insn, operands);

    case 72:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5572 (insn, operands);

    case 73:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5576 (insn, operands);

    case 74:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5580 (insn, operands);

    case 75:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5584 (insn, operands);

    case 76:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5588 (insn, operands);

    case 77:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5592 (insn, operands);

    case 78:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5596 (insn, operands);

    case 79:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5600 (insn, operands);

    case 80:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5604 (insn, operands);

    case 81:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5608 (insn, operands);

    case 82:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5612 (insn, operands);

    case 83:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5616 (insn, operands);

    case 84:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5620 (insn, operands);

    case 85:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5624 (insn, operands);

    case 86:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5628 (insn, operands);

    case 87:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5632 (insn, operands);

    case 88:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5636 (insn, operands);

    case 89:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5640 (insn, operands);

    case 90:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5644 (insn, operands);

    case 91:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5648 (insn, operands);

    case 92:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5652 (insn, operands);

    case 93:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5656 (insn, operands);

    case 94:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5660 (insn, operands);

    case 95:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 234 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5664 (insn, operands);

    case 96:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 235 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5668 (insn, operands);

    case 97:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5672 (insn, operands);

    case 98:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5676 (insn, operands);

    case 99:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5680 (insn, operands);

    case 100:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5684 (insn, operands);

    case 101:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5688 (insn, operands);

    case 102:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5692 (insn, operands);

    case 103:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5696 (insn, operands);

    case 104:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5700 (insn, operands);

    case 105:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5704 (insn, operands);

    case 106:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5708 (insn, operands);

    case 107:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5712 (insn, operands);

    case 108:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5716 (insn, operands);

    case 109:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5720 (insn, operands);

    case 110:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5724 (insn, operands);

    case 111:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5728 (insn, operands);

    case 112:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5732 (insn, operands);

    case 113:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5736 (insn, operands);

    case 114:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5740 (insn, operands);

    case 115:
      if (!((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5744 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_169 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 5:
      x3 = XVECEXP (x2, 0, 2);
      operands[3] = x3;
      switch (XINT (x2, 1))
        {
        case 179:
          if (pattern176 (x2) != 0)
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!vector_length_operand (operands[2], E_VOIDmode))
            return NULL;
          return split_117 (x1, insn);

        case 89:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (pattern386 (x2))
            {
            case 0:
              if (!((
#line 1783 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1785 "../../../gcc/config/riscv/vector.md"
( epilogue_completed)))
                return NULL;
              return gen_split_2305 (insn, operands);

            case 1:
              if (!((
#line 1783 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1785 "../../../gcc/config/riscv/vector.md"
( epilogue_completed)))
                return NULL;
              return gen_split_2306 (insn, operands);

            default:
              return NULL;
            }

        case 142:
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          switch (pattern329 (x2))
            {
            case 0:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6285 (insn, operands);

            case 1:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6286 (insn, operands);

            case 2:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6287 (insn, operands);

            case 3:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6288 (insn, operands);

            case 4:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6289 (insn, operands);

            case 5:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 143 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6290 (insn, operands);

            case 6:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6291 (insn, operands);

            case 7:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6292 (insn, operands);

            case 8:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6293 (insn, operands);

            case 9:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6294 (insn, operands);

            case 10:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6295 (insn, operands);

            case 11:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6296 (insn, operands);

            case 12:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 148 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6297 (insn, operands);

            case 13:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6298 (insn, operands);

            case 14:
              if (!((
#line 2385 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 149 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2387 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6299 (insn, operands);

            case 15:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 671 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9140 (insn, operands);

            case 16:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 672 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9141 (insn, operands);

            case 17:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 673 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9142 (insn, operands);

            case 18:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 674 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9143 (insn, operands);

            case 19:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 675 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9144 (insn, operands);

            case 20:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 681 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9149 (insn, operands);

            case 21:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 682 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9150 (insn, operands);

            case 22:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 683 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9151 (insn, operands);

            case 23:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 684 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9152 (insn, operands);

            case 24:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9153 (insn, operands);

            case 25:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9154 (insn, operands);

            case 26:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9155 (insn, operands);

            case 27:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9156 (insn, operands);

            case 28:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9157 (insn, operands);

            case 29:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9158 (insn, operands);

            case 30:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9159 (insn, operands);

            case 31:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 676 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9145 (insn, operands);

            case 32:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9146 (insn, operands);

            case 33:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 678 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9147 (insn, operands);

            case 34:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 679 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9148 (insn, operands);

            case 35:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9160 (insn, operands);

            case 36:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9161 (insn, operands);

            case 37:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 694 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9162 (insn, operands);

            case 38:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9163 (insn, operands);

            case 39:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9164 (insn, operands);

            case 40:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9165 (insn, operands);

            case 41:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9166 (insn, operands);

            case 42:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9167 (insn, operands);

            case 43:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9168 (insn, operands);

            case 44:
              if (!((
#line 871 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 873 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9169 (insn, operands);

            default:
              return NULL;
            }

        case 155:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (pattern357 (x2))
            {
            case 0:
              if (!((
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6300 (insn, operands);

            case 1:
              if (!(
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6301 (insn, operands);

            case 2:
              if (!(
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6302 (insn, operands);

            case 3:
              if (!(
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6303 (insn, operands);

            case 4:
              if (!(
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6304 (insn, operands);

            case 5:
              if (!(
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6305 (insn, operands);

            case 6:
              if (!(
#line 2839 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 2843 "../../../gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6306 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      return split_121 (x1, insn);

    case 1:
      return split_122 (x1, insn);

    default:
      return NULL;
    }
}
